/* $Id: TCorsikaReader.cc,v 1.1.1.1 2005/08/09 11:21:28 rulrich Exp $   */

#ifndef _INCLUDE_TPARTCLEDATA_
#define _INCLUDE_TPARTCLEDATA_

#include <crs/CorsikaTypes.h>

#include <string>


namespace crs {

  class MParticle;
  class MCerenkov;
  class MMuonProductionInfo;


  typedef enum {
    eParticle,
    eNucleus,
    eCerenkov,
    eMuonProductionInfo,
    eEmpty,
    eUnknown
  } ParticleType;


  class TParticleBlockEntry {

    friend class TParticle;
    friend class TCerenkov;
    friend class TMuonProductionInfo;

  public:
    TParticleBlockEntry (const CREAL *data, bool thinn);
    TParticleBlockEntry (const TParticleBlockEntry& p);
    virtual ~TParticleBlockEntry () {}

    inline int GetParticleID () const {return (int)fData [0]/1000;}
	
    virtual void Dump () const {}

    bool IsParticle () const;
    bool IsNucleus () const;
    bool IsCerenkov () const;
    bool IsMuonProductionInfo () const;
    bool IsEmpty () const;
    ParticleType GetType () const;
	
    virtual std::string GetParticleName () const;
	
  protected:
    const CREAL *fData;
    bool fThinned;
	
  };

};


#endif
