c     -*-fortran-*-
c     
c     Common block to be included into the Fortran-77 source for use of
c     f_rdmc.o
c     
c     Version: $Header: /net/local/cvsroot/siegmund/rdmc/rdmc.inc,v 1.37 2004/04/21 17:29:08 wiebusch Exp $
c     
c     For a detailed description, see rdmc.h, and the documentation.
c     
c     
c     symbolic values for End of file and Illegal format, like in rdmc.h
c     
      integer EOF, ILF, NOT_AV 
      parameter (EOF=-1,ILF=-10, NOT_AV=-1 )
      integer RDMC_PARENT_NOISE
      parameter (RDMC_PARENT_NOISE=-2)
      integer RDMC_PARENT_AFPULS
      parameter (RDMC_PARENT_AFPULS=-3)
c     
c     Array id for a NT-36, for a Quasar PMT and the Muon id
c     
      integer NT_36,QUASAR,MU_PLUS
      parameter (NT_36=5,QUASAR=3,MU_PLUS=5)
c     
c     Big value, e.g. length of a long track
c     Small value, e.g. Minimal pmt threshold, in p.e.
c     
      real BIG,SMALL
      parameter (BIG=1.0e6, SMALL=1.0e-9)
c     
c     max number of channels; has to be equal MAXCHANNELS in rdmc.h
c     max number of hits; has to be equal MAXHITS in f_rdmc.c
c     the maximum number of user words in one user block
c     the maximum token string length
c     the maximum number of tokens per line
c     
      integer nch_max,nhits_max,nuser_max,ntoken_max,ntoken_per_line,
     *     nwf_max
      parameter (nch_max=16384,nhits_max=16384,nuser_max=250)
      parameter (ntoken_max=64,ntoken_per_line=1000, nwf_max=4096)
c     
c     the file formats
c     
      integer  BAIKAL_BIN_F, DUMAND_ASCII_F, UWI_ASCII_F
      integer  AMANDA_ASCII_F, F2000_F,  RDMC_DEFAULT_ASCII_F
      parameter (BAIKAL_BIN_F=0, DUMAND_ASCII_F=1, UWI_ASCII_F=2)
      parameter (AMANDA_ASCII_F=4,F2000_F=4,RDMC_DEFAULT_ASCII_F=4)
      
c     
c     read , write mode 
c     
      integer RDMC_READ_MODE,RDMC_WRITE_MODE
      parameter (RDMC_READ_MODE=0,RDMC_WRITE_MODE=1)
      
c     RDMC magic numbers
      integer RDMC_NA, RDMC_REPEAT_CH, RDMC_TDC_NA
      parameter (RDMC_NA=-1, RDMC_REPEAT_CH=-2, RDMC_TDC_NA=-BIG)
      
c     
c     Header information, corresponds to struct{}array in rdmc.h
c     
      integer id_t, nch_t, nstr_t, str_t, clust_t, type_t, serial_t
      integer run_t
      integer tbegin_t, tend_t
      integer cal_geo_t, cal_adc_t, cal_tdc_t, cal_tot_t, cal_utc_t
      real x_t, y_t, z_t, costh_t, thresh_t, sensit_t
      real long_t,latt_t,depth_t
      integer n_trigger, n_user_blocks, n_fit, n_stat, n_mcinfo
      common /farray/ id_t, nch_t, nstr_t, 
     *     long_t,latt_t,depth_t,run_t,
     *     str_t(nch_max), clust_t(nch_max), 
     *     x_t(nch_max), y_t(nch_max), z_t(nch_max),
     *     costh_t(nch_max), type_t(nch_max), serial_t(nch_max), 
     *     thresh_t(nch_max), sensit_t(nch_max),
     *     n_trigger, n_user_blocks, n_fit, n_stat, n_mcinfo,
     *     tbegin_t, tend_t,
     *     cal_geo_t, cal_adc_t, cal_tdc_t, cal_tot_t, cal_utc_t
      
      
c     
c     Common event data, corresponds to struct{} mevt in rdmc.h
c     
      integer nrun_e, enr_e, nch_e, nstr_e  
      integer nhits_e, nwf_e, ntrack_e, nfit_e, nuser_e
      integer mjd_e, secs_e, nsecs_e, ee_e
      integer nstat_e, ntrig_e, nmcinfo_e , nt_uses_e, nf_uses_e
      integer sort_e            ! this variable is not guaranteed in fortran
      real toffset_e,weight_e
      common /fmevt/ nrun_e, enr_e, mjd_e, secs_e, nsecs_e,
     *     toffset_e , weight_e, ee_e,
     *     nch_e, nstr_e, nhits_e, nwf_e, ntrack_e, nfit_e, nuser_e ,
     *     nstat_e, ntrig_e, nmcinfo_e , nt_uses_e, nf_uses_e,
     *     sort_e 
c     
c     Hit times, amplitudes etc.. this structure has no equivalence in C
c     
      integer ch_h(nhits_max), str_h(nhits_max)
      integer mt_h(nhits_max), ma_h(nhits_max), id_h(nhits_max)
      integer edges_h(nhits_max), edges_flag_h(nhits_max)
      real t_h(nhits_max), amp_h(nhits_max), tot_h(nhits_max)
      real weight_h(nhits_max)
      common /fmhit/ ch_h, str_h, t_h, amp_h, tot_h, 
     *     mt_h, ma_h , id_h, weight_h, 
     *     edges_h, edges_flag_h
      
c     
c     One Reconstructed track corresponds to struct mtrack
c     
      integer id_rec, nmuon_rec,nparent_rec
      real e_rec, x_rec, y_rec, z_rec, t_rec, costh_rec, phi_rec,
     *     px_rec, py_rec, pz_rec, length_rec, ntag_rec ,weight_rec
      common /frectrack/ id_rec, e_rec, x_rec, y_rec, z_rec, t_rec,
     *     costh_rec, phi_rec, px_rec, py_rec, pz_rec, length_rec, 
     *     nmuon_rec,nparent_rec,ntag_rec,weight_rec
c     
c     One block of FRESULT variables, corresponds to mevt_special
c     
      real fresult_e(nuser_max)
      integer fresult_id, fresult_nval
      common /frdmcfresult/ fresult_id, fresult_nval ,fresult_e
c     
c     One block of Waveform variables, corresponds to mevt_WF
c     
      integer wf_id,wf_om,wf_ch,wf_pa,wf_ndigi
      real    wf_Tstart,wf_Tbin,wf_bas,wf_digi(nwf_max)
      common /frdmcwf/ wf_id,wf_om,wf_ch,wf_pa,wf_ndigi,
     *     wf_Tstart,wf_Tbin,wf_bas
      common /frdmcdigi/ wf_digi
c     
c     One Generated track, corresponds to struct mtrack
c     
      integer id_gen, nmuon_gen,nparent_gen,ntag_gen
      real e_gen, x_gen, y_gen, z_gen, t_gen, costh_gen, phi_gen
      real px_gen, py_gen, pz_gen, length_gen, weight_gen
      common /fgentrack/ id_gen, e_gen, x_gen, y_gen, z_gen, t_gen,
     *     costh_gen, phi_gen, px_gen, py_gen, pz_gen, length_gen, 
     *     nmuon_gen, nparent_gen, ntag_gen, weight_gen
c     
c     One block of user-defined variables, corresponds to mevt_special
c     
      real special_e(nuser_max)
      integer special_id, special_nval
      common /frdmcspecial/ special_id, special_nval ,special_e

c     
c     One block of header_def information, corresponds to array_header_def_t
c     
      integer hdef_id,hdef_nwords,hdef_npars
      character*(64) hdef_tag,hdef_words(ntoken_per_line)
      character*(64) hdef_pars(ntoken_per_line)
      common /frdmchdef/ hdef_id,hdef_tag,hdef_nwords,hdef_npars,
     *     hdef_words,hdef_pars

cccccccsome rdmc interface routines
      integer frdmc_track_closest
      integer frdmc_get_leading_muon
      integer frdmc_is_secondary
      integer frdmc_is_point_like
      integer frdmc_is_track_like
      external frdmc_track_closest,frdmc_get_leading_muon
      external frdmc_is_secondary
      external frdmc_is_point_like,frdmc_is_track_like
c     
c     fortran functions:
c     frdmc_mcopen
c     
c     
c     End of the include file
c     

