c-----------------------------------------------------------------------
      subroutine aaset(iop)
c-----------------------------------------------------------------------
c     sets parameters and options, initializes counters ...
c-----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incpar'
      include 'nexus.incsem'
      common/record/maxrec(2),irecty(30,2)
      common/cfacmss/facmss/cr3pomi/r3pomi,r4pomi
      common /ems12/iodiba,bidiba  ! defaut iodiba=0. if iodiba=1, study H-Dibaryon 
     

      if(iop.eq.1)write(ifmt,'(a)')'default settings ...'
      if(iop.eq.1)goto1001
      if(iop.eq.2)goto1002

c  version

      iversn=int(3.972*100) !version number
      iverso=int(3.97*100) !last official version
      
c  application 
      
      iappl=1          !choice for application (0,1,2,3,4)

c  file names and units

      fnnx='path/nexus '      !path nexus name
      fnch='zzz.check '         !check-file name
      fnhi='zzz.histo '         !histo-file name
      fndt='zzz.data '          !data-file name
      fncp='zzz.copy '          !copy-file name
      fnii='zzz.initl '       !initl-file name
      fnid='zzz.inidi '       !inidi-file name
      fnie='zzz.iniev '       !iniev-file name
      fnrj='zzz.inirj '       !inirj-file name
      fncs='zzz.inics '       !inics-file name
      nfnnx=index(fnnx,' ')-1   !length of path nexus name
      nfnch=index(fnch,' ')-1   !length of check-file name
      nfnhi=index(fnhi,' ')-1   !length of histo-file name
      nfndt=index(fndt,' ')-1   !length of data-file name
      nfncp=index(fncp,' ')-1   !length of copy-file name
      nfnii=index(fnii,' ')-1   !length of initl-file name
      nfnid=index(fnid,' ')-1   !length of inidi-file name
      nfnie=index(fnie,' ')-1   !length of iniev-file name
      nfnrj=index(fnrj,' ')-1   !length of inirj-file name
      nfncs=index(fncs,' ')-1   !length of inics-file name

      ifop=5     !optns-file unit
      ifmt=6     !std output unit 
      ifcx=31    !check-file unit (for open)
      ifch=6    !check-file unit (for write) 
      ifhi=35    !histo-file unit
      ifdt=51    !data-file unit
      ifcp=52    !copy-file unit

c  initial seed
  
      seedi=0d0   !.ne.0.: seed for random number generator: at start program
      seedj=0d0   !.ne.0.: seed for random number generator: for first event
     

 1001 continue ! ----> entry iop=1 <-----

      call factoriel


c  some basic things

      nevent=1    !number of events
      nfull=-1	  !number of full events (ico+hydro+f.o.)(if different from -1)
      nfreeze=1    !number of freeze out events per nexus event 
      ninicon=1    ! +-number of events per initial condition
                    ! if positive: keep same b, otherwise generate b each time 
      engy=-1      !energy
      elab=-1      !energy lab
      ecms=-1      !energy centre of mass
      ekin=-1      !energy kinetic
      pnll=-1      !momentum
      egymin=2.5    !minimum energy
      egymax=1.5E+06 !maximum energy
      noebin=1     !number of energy bins
      engmin=0     !minimum energy 
      engmax=0     !maximum energy 
      iologe=-1     !0=linear bins   1=log bins (cms engy)
      iologl=-1     !0=linear bins   1=log bins (Kinetic engy)

c  printout options
      
      if(iop.eq.0)iprmpt=-2   !prompt (>0) or not (<0)
      ish=0      !1,2,3,4 ...: more and more detailed messages
      irandm=0   !prints all random numbers (1)
      irewch=0   !rewinds check file before each event (1)
      if(iop.eq.0)iecho=1    !verify option for input reading
      modsho=1   !message all modsho events
      idensi=0   !must be 1 when subr xjden1 is used 
      ishevt=0   !minimum event number for certain print options
      iwseed=1   !print out seed (1) or not

c  fragmentation and decay parameters

      pud=0.465   !prob. for u or d quark production 
      puds=0.4   !prob. for u or d quark production in diquark string
      pdiqua=.07  !qq-qqbar probability
      ptfknk=0.42 !average p_transverse for kinky-strings
      pbreak=0.65  !break-parameter for kinky-strings
      
c  fragmentation and decay options

      ndecay=0   !ndecay suppresses certain resonance decays
                 !0000001: all resonance decays suppressed
                 !0000010: k_short/long (+-20) decays suppressed
                 !0000100: lambda (+-2130) decays suppressed
                 !0001000: sigma (+-1130,+-2230) decays suppressed
                 !0010000: cascade (+-2330,+-1330) decays suppressed
                 !0100000: omega (+-3331) decays suppressed
                 !1000000: pi0 (110) decays suppressed
                 !also several "1"s may be used with obvious meaning
      maxres=99999 !maximum resonance spin
      aouni=0.   !technical parameter for development

c  lepton-nucleon and e+e- options

      iolept=1     !q2-x ditribution calculated (1) or taken from table (<0)
      ydmin=0      ! range of y 
      ydmax=0
      qdmin=0      ! range of q**2
      qdmax=0
      themin=0     !minimum scattering angle
      themax=0     !maximum scattering angle
      elomin=0     !minimum energy of outgoing lepton
      elepti=0     !incoming lepton energy
      elepto=0     !outgoing lepton energy
      angmue=3.9645/360.*2*3.14159 !mue angle
      icinpu=0
      itflav=0     ! initial flavor for e+e-
      idisco=0     !deep inelastic contributions
                   !0=all, 1=direct-light, 2=direct-charm, 3=resolved
            
c  hadron-hadron options

      idproj=1120 !projectile particle id
      idtarg=1120 !target particle id
      iregge=0    !consider reggeons (1=yes 0=no)
      isopom=1    !consider soft pomerons (1=yes 0=no)
      ishpom=1    !consider semihard pomerons (1=yes 0=no)
      iscreen=1   !consider screening corrections (1=yes 0=no)
        iscreeni=1 !store
      irmdrop=1    !consider droplet for remnants (1=yes 0=no)
      iremres=1    !consider collision of remnants (1=yes 0=no)
      nprmax=10000 !maximum number of pomerons/reggeons
      iemspl=0
      intpol=3     !number of points for interpolation in psfli, psfaz
      ioems=2
      isigma=0    !option for xsection calculation: 
c 0=no, 1=sergej, 2=exact, 3=tabulation
      iomega=2    !option for omega calculation (not used)
      isetcs=2    !option to set cross section parameters: 
c 0=calculation, 1=set mode, 2=tabulation sergej, 3=tabulation simulation
        !hadron excitation classes: 1=?,2=?
      icdp=2     !projectile hadron excitation 
      icdt=2     !target hadron excitation
      icdp1=2    !min projectile hadron excitation 
      icdt1=2    !min target hadron excitation
      icdp2=2    !max projectile hadron excitation 
      icdt2=2    !max target hadron excitation
      icdpl1=2   !projectile hadron excitation 
      icdtl1=2   !target hadron excitation
      icdpl2=2   !projectile hadron excitation 
      icdtl2=2   !target hadron excitation
              !hadron classes: 1=pions,2=nucleons,3=kaons
      iclpro1=1   !projectile hadron class lower limit
      iclpro2=3   !projectile hadron class upper limit
      icltar1=2   !target hadron class lower limit
      icltar2=2   !target hadron class upper limit
      iclegy1=1   !energy class lower limit
      iclegy2=99  !energy class upper limit
      egylow=1   !lower limit of lowest energy bin
      egyfac=1.155  !binning factor
      delh=0.25   !effective overcriticity for the hard pomeron (techn param)
      factgam=1         !enhancement factor for gammas
      
c  hadron-hadron parameters

      qcdlam=.04           !lambda_qcd squared
      q2min=4.            !q**2 cutoff
      q2ini=.25           !resolution scale
      q2fin=.25            !q**2 cutoff for the timelike cascade
      betpom=1.4          !gluon structure function parameter for the so
      glusea=0.15            !sea quarks / (sea quarks + gluons) at x -> 0
      naflav=3          !number of active flavors
      factk=2.         !k-factor value
      alfe=1./137.
      pt2cut=0.         !p_t-cutoff for the born process
      rstras=0.2       !effective ratio of strange sea over u sea
      wgtval=0.          !weight for valq - antiq as soft string ends
      wgtsea=1.          !weight for seaq - antiq as soft string ends
      wgtdiq=0.          !weight for diq - antidiq as soft string ends
      wgtqqq=0.05          !weight for seaq - valqq as soft string end
      exmass=0.02         !excitation mass for remnant
      r3pom=0.01      !triple pomeron coupling
        r3pomi=r3pom  !store
      r4pom=0.001     !4-pomeron coupling
        r4pomi=r4pom  !store
      Eseuil=25.      !Threshold for screening  (=delx (see sha) better)
      Esmax=50000.    !Threshold for total screening (not used (see nexus-par))
      epscr=0.45      !power for screening
      epscrp=1.       !power slope for screening
      alppom=1.08     !alpha pomeron
      slopom=0.13     !alpha' pomeron
!     gamhad(1) defined in psaini
      gamhad(2)=4.55   !gamma proton
!     gamhad(3) defined in psaini
      r2had(1)=1.30     !r2 pion
      r2had(2)=2.20     !r2 proton 
      r2had(3)=1.00     !r2 kaon
      chad(1)=1.4    !c pion
      chad(2)=1.4    !c proton
      chad(3)=1.4    !c kaon
      wdiff(1)=1.   !diffractive probability
      wdiff(2)=7.5  !diffractive probability
      wdiff(3)=0    !diffractive probability
      alplea(1)=0.0   !alpha leading pion
      alplea(2)=1.5   !alpha leading proton
      alplea(3)=0.0   !alpha leading kaon
      alplea(4)=5.    !alpha leading jpsi
      rexndi(1)=0.60  !remnant excitation probability nondiffractive pion
      rexndi(2)=0.60  !remnant excitation probability nondiffractive proton
      rexndi(3)=0.50  !remnant excitation probability nondiffractive kaon
      rexndi(4)=0     !remnant excitation probability nondiffractive jpsi
      rexres=0.5      !remnant excitation probability in nucleus
      alppar=0.1      !alpha participant
      alpdif=1.       !alpha mass diffractive        
      alpndi=2.25     !alpha mass nondiffractive
      alpsea=0.3      !alpha string end x for sea parton
      alpval=0.3      !alpha string end x for valence parton
      alpdiq=0.3      !alpha string end x for sea diquark
      ammsqq=0.28     !minimum mass string quark quark
      ammsqd=1.08    !minimum mass string quark diquark 
      ammsdd=1.88    !minimum mass string diquark diquark
      delrex=.01     !mass to be added to the above masses
      cumpom=0       !cutoff mass for virtual pomerons
      reminv=0.5     !remnant inversion probability   
      ptdiff=0.35    !pt for diffraction
      ptsend=0.3     !string end pt
      ptremn=1.2  !string end pt in remnant
      alpdro(1)=2.   !alpha(1) leading droplet (x**alpha(1)*(1-x)**alpha(2))
      alpdro(2)=.5   !alpha(2) leading droplet
      alpdro(3)=alpndi  !alpha mass leading droplet
      amdrmax=8.     !maximum mass leading droplet
                  
      iodiba=0      ! if iodiba=1, study H-Dibaryon (not used (see ProRef in nexus-ems ????)
      bidiba=0.030   ! epsilon of H-Dibaryon 

c Reggeon parameters  (not used)   
 
      alpreg=0.734   !alpha_reggeon
      sloreg=0.499   !slope_reggeon
      gamreg=16.46   !gamma_reggeon
      r2reg=0.613    !r^2_reggeon
      
c  masses

      amhadr(1)=.14            !pion mass
      amhadr(2)=.939           !nucleon mass
      amhadr(3)=.496           !kaon mass
      amhadr(4)=1.868          !d-meson mass
      amhadr(6)=1.116          !lambda mass
      amhadr(5)=2.27           !lambda_c mass
      amhadr(7)=.548           !eta mass
      amhadr(8)=3.5            !J/psi mass
      qcmass=1.6               !c-quark mass

c  nucleus-nucleus

      iokoll=0      !fix # of collisions (1)
      inueff=1      !consider shadowing corrections (1=yes 0=no)
      laproj=0      !projectile charge number
      maproj=0      !projectile mass number
      latarg=0      !target charge number
      matarg=0      !target mass number
      core=0.34     !hard core distance(2*0.17)
c      ncolmx=100000 !maximum number of collisions
      fctrmx=10     !parameter determining range for density distribution
      bmaxim=10000  !maximum impact parameter 
      bminim=0.     !minimum impact parameter
      phimax=2*3.1415927 !maximum phi
      phimin=0      !minimum phi 
      amws=.54   !diffusive radius for the saxon-wood parame

c rescattering parameters

      iorsce=0      !color exchange turned on(1) or off(0)
      iorsdf=0      !droplet formation turned on(1) or off(0)
      iorshh=0      !other hadron-hadron int. turned on(1) or off(0)
      taurea=0      !reaction time
      epscri=1.0    !critical energy density
      amsiac=.8     !interaction mass
      amprif=0      !print option
      delvol=1      !print option
      deleps=1      !print option
      taumin=1.     !min tau for space-time evolution
      deltau=0.2    !initial delta_tau for space-time evolution
      factau=1.05   !factor for delta_tau for space-time evolution
      numtau=80     !number of tau steps for space-time evolution
      dlzeta=0.5    !delta_zeta for longitudinal droplet binning
      etafac=1.0    !factor determining inner range
      facnuc=0.0    !factor for nuclear size to determine inner range
      hacore=0.8    !hadron compressibility factor
      amimfs=0.200  !energy cutoff for fusion
      amimel=0.050  !energy cutoff for elastic scattering
      cepara=0.03   !parameter for excitation for color exchange 
      dscale=1.    !scale parameter for hadron-hadron
      iceopt=1      !real color exchange (1) or just excitation (0)
      delamf=2      !minimum kinetic energy for color exchange 

c initial conditions for hydro
      
      ispherio=0    !call spherio
      icoop=1       !option strings (1) or partons (2) 
      icospec=0     !consider spectators 
      icoremn=0     !consider hadrons from remnants
      icostrg=0     !consider strings
      icotabm=0     !make table for initial condition stuff
      icotabr=0     !read table for initial condition stuff

      xminico=-10.  ! xrange for initial condition calculation
      xmaxico= 10.       
      yminico=-10.  ! yrange for initial condition calculation
      ymaxico= 10.          
      zminico= -5.  ! eta range for initial condition calculation
      zmaxico=  5.        

c  droplet decay 

      dezzer=1e-4   !abs(dezptl())<dezzer treated as no-droplet
      amuseg=10.0   !segment mass
      yradmx= 0.0   !max. radial boost of droplets
      bag4rt=0.200  !bag constant ^1/4
      taunll=1.0    !decay time (comoving frame)
      vrad=0.3

c  droplet decay initializations

         asuhax(1)=1.134  !two lowest multiplets
         asuhax(2)=1.301  !two lowest multiplets
         asuhax(3)=1.461  !two lowest multiplets
         asuhax(4)=1.673  !two lowest multiplets
         asuhax(5)=0.7700 !two lowest multiplets   rho
         asuhax(6)=0.8920 !two lowest multiplets   K*
         asuhax(7)=1.2320 !two lowest multiplets
         asuhay(1)=0.940  !lowest multiplet
         asuhay(2)=1.200  !lowest multiplet
         asuhay(3)=1.322  !lowest multiplet
         asuhay(4)=1.673  !lowest multiplet
         asuhay(5)=0.1400 !lowest multiplet
         asuhay(6)=0.4977 !lowest multiplet
         asuhay(7)=1.2320 !lowest multiplet

c  droplet specification

      keu=0     !u flavour of droplet
      ked=0     !d flavour of droplet
      kes=0     !s flavour of droplet
      kec=0     !c flavour of droplet
      keb=0     !b flavour of droplet
      ket=0     !t flavour of droplet
      tecm=10   !energy of droplet
      volu=70   !volume of droplet

c  metropolis and grand canonical

      iospec=10 !option for particle species
      iocova=2  !covariant (1) or noncovariant (2) phase space integral
      iopair=2  !single pair (1) or double pair (2) method
      iozero=65 !relative weight of zeros (compared to hadrons)
                ! (-1) nspecs
                ! (-2) nspecs/sqrt(tecm/volu)
      ioflac=1  !test multipl distr without (1) or with (2) flavour conserv
                !  (2 only good for nspecs=3,7)
      iostat=1  !use boltzmann (1) or quantum (0) statistics in hgc-routines
      ioinco=1  !call hnbmin for initial configuration (0)
                !call hgcnbi for initial configuration to generate better
                !initial configuration (1)
                !call hgcnbi for initial configuration to generate optimal
                !initial configuration (2)
      iograc=1  !call hgcaaa in case of ioinco=0 (1)
      epsgc=2.  !required accuracy in hgcaaa 10**(-epsgc)
      iocite=0  !perform counting at metropolis iterations (1) or not (else)
      ioceau=0  !perform counting for exp. autocorrel. time (1) or not (else)
      iociau=0  !perform counting for int. autocorrel. time (1) or not (else)
      ioinct=0  !test grand canonical metropolis sampling (1)
                !to plot results call xhgccc, xhgcfl and xhgcam
      ioinfl=1  !conserve flavor in initial configuration in hgcnbi (1)
                !do not conserve flavor (0)
                !do not conserve flavor and energy (-1)
      iowidn=2  !width of total multiplicity distribution in hgcnbi
                ! sigma_tot -> sigma_tot/iowidn
                ! >0 unnormalized
                ! <0 normalized
      ionlat=2  !determine nlattc ,old method (0)
                !or determine nlattc in hgcnbi as:
                ! (1) max(1.3*<N>,<N>+2*sigma,6)
                ! (2) max(1.5*<N>,<N>+3*sigma,6)
                ! (3) max(2.0*<N>,<N>+4*sigma,6)
      iomom=1   !number of momenta to be changed in hnbodz
      ioobsv=0  !observable for autocorrelation time calculation
                !0: total multiplicity
                !else: particle id for particle species
      iosngl=0  !event # for which counting at metropolis iterations is done
      iorejz=0  !reject pair exchange with only zeros (1) or not (else)
      iompar=4  !parameter for windowing algorithm
      iozinc=0  !if iozevt>0: modifies iozero for testing (in sr hgcnbi)
      iozevt=0  !if >0: modifies iozero for testing (in sr hgcnbi)
      nadd=0    !number of pi0s added to minimum initial configuration
      iterma=-6 !>0: maximum number of iterations 
                !<0: - number of iterations per corr time  
      iterpr=10000 !iter-increment for printout 
      iterpl=1  !iter-increment for plot
      iternc=50 !iterations not counted for analysis
      epsr=1e-4 !required accuracy in sr hnbraw
      keepr=1   !keep most random numbers rnoz in hnbodz (1) 
                !  or update all (0)
 
c  strangelets

      iopenu=1      !option for minimum energy 
                    !1: sum of hadron masses
                    !2: bag model curve with minimum at nonzero strangen
      themas=.51225 !parameter theta in berger/jaffe mass formula

c  jpsi 

      jpsi=0     !jpsi to be produced (1) or not (0)
      jpsifi=0   !jpsi final state interaction (1) or not (0)
      sigj=0.2   !jpsi nucleon cross section [fm**2]
      taumx=20   !max time for jpsi evolution
      nsttau=100 !time steps for jpsi evolution
      ijphis=0   !fill jpsi histograms (1) or not (0)

c  analysis: intermittency, space-time, droplets, formation time

      ymximi=2   !upper limit for rapidity interval for intermittency analysis
      imihis=0   !fill intermittency histograms (1) or not (0)
      isphis=0   !fill space-time histograms (1) or not (0)
      iologb=0   !0=linear bins   1=log bins
      ispall=1   !xspace: all ptls (1) or only interacting ptls (else)
      wtmini=-3  !tmin in xspace
      wtstep=1   !t-step in xspace
      iwcent=0   !only central point (1) or longitudinal distr (else) in xspace
      iclhis=0   !fill droplet histograms (1) or not (0)
      iwtime=0   !fill formation time histogram (1) or not (else)
      wtimet=100 !max time in wtime
      wtimei=0   !max mass in wtime
      wtimea=1000 !max mass in wtime


c  storing 
      maxrec(1)=7
      irecty(1,1)=1
      irecty(2,1)=2
      irecty(3,1)=3
      irecty(4,1)=4
      irecty(5,1)=5
      irecty(6,1)=6
      irecty(7,1)=7
      maxrec(2)=14
      irecty(1,2)=1
      irecty(2,2)=2
      irecty(3,2)=3
      irecty(4,2)=4
      irecty(5,2)=5
      irecty(6,2)=6
      irecty(7,2)=7
      irecty(8,2)=8
      irecty(9,2)=9
      irecty(10,2)=10
      irecty(11,2)=11
      irecty(12,2)=12
      irecty(13,2)=13
      irecty(14,2)=14


c  other
 
      gaumx=8    !range for gauss distribution
      nclean=0   !clean /cptl/ if nclean > 0 (every nclean_th time step)
      istore=0   !0: no storage to data-file
                 !1: NEXUS     standard 
                 !2: OSC1997A standart
                 !3: OSC1999A standart
                 !5: calls routine ustore (modifiable by the user)
      iframe=0   !frame specification production run
      jframe=0   !frame specification analysis
      kframe=0   !frame specification analysis (2nd frame)
                 ! 1:total
                 !11:nucleon-nucleon
                 !12:target
                 !21:gamma-nucleon
                 !22:lab
                 !32:sphericity
                 !33:thrust
      irescl=1   !momentum rescaling (1) or not (0) 
      ifrade=1   !suppression of fragmentation and decay (0)
      ntrymx=10  !try-again parameter
      istmax=0   !store only last generation ptls (0) or all (1)
      ionucl=0   !plot of nucleon distribution (1=proj, 2=targ) or not (0)
      iAGKch=0   !run with perfect theory to check AGK (nothing else)
      irdmpr=0   !random sign for projectile if 1

c  constants

      pi=3.1415927
      pii=1./(2*pi**2)
      hquer=0.197327
      prom=.94
      piom=.14
      ainfin=1e31
 
c air 

      airanxs(1)=14.007            !Nitrogen
      airznxs(1)=7.
      airwnxs(1)=0.7846
      airanxs(2)=15.999            !oxigen
      airznxs(2)=8.
      airwnxs(2)=.2107
      airanxs(3)=39.948           !Argon
      airznxs(3)=18.
      airwnxs(3)=0.0047
      airavanxs=airanxs(1)*airwnxs(1)+airanxs(2)*airwnxs(2)
     &         +airanxs(3)*airwnxs(3)
      airavznxs=airznxs(1)*airwnxs(1)+airznxs(2)*airwnxs(2)
     &         +airznxs(3)*airwnxs(3)
      
c  zero initializations

      ixtau=0    
      iEmsB=0      
      iEmsBg=0      
      iEmsPm=0     
      iEmsPx=0     
      iEmsSe=0     
      iEmsDr=0     
      iEmsRx=0    
      iEmsI2=0     
      iEmsI1=0     
      nemsi=0
      facmss=1. 
      nstmax=0
      do 6 i=1,99
      prob(i)=0
      do 6 j=1,2
      icbac(i,j)=0
6     icfor(i,j)=0
      imsg=0
      jerr=0
      ntevt=0
      nrevt=0
      naevt=0
      nrstr=0
      nrptl=0
      nptlu=0
      do itau=1,mxtau
      volsum(itau)=0
      vo2sum(itau)=0
      nclsum(itau)=0
      do ivol=1,mxvol
      do ieps=1,mxeps
      clust(itau,ivol,ieps)=0
      enddo
      enddo
      enddo
      iutotc=0
      iutote=0
      nopen=0
      knxopen=0
      kchopen=0
      khiopen=0
      kdtopen=0
      klgopen=0
      xpar1=0.
      xpar2=0.
      xpar3=0.
      xpar4=0.
      xpar5=0.
      xpar6=0.
      xpar7=0.
      xpar8=0.
      if(iop.eq.0)khisto=0
      nrclu=0
      nrnody=0
      do n=1,mxnody
      nody(n)=0
      enddo
      nrpri=0
      do n=1,mxpri
      subpri(n)='      '
      ishpri(n)=0
      enddo
      nctcor=0
      ncttim=0
      do n=1,matau
      tauv(n)=0
      enddo
      ncnt=0
      nrnucl=0
      do i=1,mxnucl
      rnucl(i)=0
      rnuclo(i)=0
      enddo
      inicnt=0
      accept=0.
      reject=0.
      do n=1,matau
      tauv(n)=0.
      enddo
      
 1002 continue ! ----> entry iop=2 <----


c  analysis

      xvaria='numptl'
      yvaria='ycmptl'
      normal=11
      xminim=-100
      xmaxim=100
      nrbins=100
      hisfac=1
      do nr=1,mxbins
      do l=1,5
      ar(nr,l)=0
      enddo
      enddo
      nozero=0

      return
      end
     
c-----------------------------------------------------------------------
      subroutine ustore
c-----------------------------------------------------------------------
c     writes the results of a simulation into the file with unit ifdt
c     contains a description of the stored variables.
c     modifiable by the user
c-----------------------------------------------------------------------
      include 'nexus.inc'
 
c  count the number of particles to be stored (--> nptevt)

      nptevt=0
      do i=1,nptl
      if(istptl(i).le.istmax)nptevt=nptevt+1 
      enddo
       
c  store event variables:

      write(ifdt,*)'---------------------------------------'
      write(ifdt,'(2i6,f6.2)')nrevt,nptevt,bimevt!,phievt,kolevt
c     *,pmxevt,egyevt,npjevt,ntgevt
 
c     nrevt.......... event number
c     nptevt ........ number of (stored!) particles per event
c     bimevt ........ absolute value of impact parameter
c     phievt ........ angle of impact parameter
c     kolevt ........ number of collisions
c     pmxevt ........ reference momentum
c     egyevt ........ pp cm energy (hadron) or string energy (lepton)
c     npjevt ........ number of primary projectile participants
c     ntgevt ........ number of primary target participants
c     npnevt ........ number of primary projectile neutron spectators
c     nppevt ........ number of primary projectile proton spectators
c     ntnevt ........ number of primary target neutron spectators
c     ntpevt ........ number of primary target proton spectators
c     jpnevt ........ number of absolute projectile neutron spectators
c     jppevt ........ number of absolute projectile proton spectators
c     jtnevt ........ number of absolute target neutron spectators
c     jtpevt ........ number of absolute target proton spectators
 
      do i=1,nptl

      if(istptl(i).le.istmax)then !store events with istptl < istmax
      
c  store particle variables:
        
        id=idtrafo('nxs','pdg',idptl(i))

      write(ifdt,*)
     *i,id,pptl(1,i),pptl(2,i),pptl(3,i),pptl(4,i),pptl(5,i)
c     *,iorptl(i),jorptl(i),istptl(i)
c     *,xorptl(1,i),xorptl(2,i),xorptl(3,i),xorptl(4,i)
c     *,tivptl(1,i),tivptl(2,i)

c     i ............. particle number
c     idptl(i) ...... particle id
c     pptl(1,i) ..... x-component of particle momentum 
c     pptl(2,i) ..... y-component of particle momentum 
c     pptl(3,i) ..... z-component of particle momentum 
c     pptl(4,i) ..... particle energy 
c     pptl(5,i) ..... particle mass 
c     iorptl(i) ..... particle number of father (if .le. 0 : no father) 
c     jorptl(i) ..... particle number of mother (if .le. 0 : no mother)
c     istptl(i) ..... generation flag: last gen. (0) or not (1)
c     ityptl(i) ..... particle type (string, remnant ...)
c     xorptl(1,i) ... x-component of formation point
c     xorptl(2,i) ... y-component of formation point
c     xorptl(3,i) ... z-component of formation point
c     xorptl(4,i) ... formation time
c     tivptl(1,i) ... formation time (always in the pp-cms!)
c     tivptl(2,i) ... destruction time (always in the pp-cms!)

      endif 
      enddo

      return
      end


c-----------------------------------------------------------------------
      subroutine bstora
c-----------------------------------------------------------------------
c     writes the results of a simulation into the file with unit ifdt
c     contains a description of the stored variables.
c-----------------------------------------------------------------------
      include 'nexus.inc'
      common/record/maxrec(2),irecty(30,2)
      character code*8,version*8,frame*4
      code='NEXUS   '
      write(version,'(f5.2,3x)')iversn/100.
      if(iframe.eq. 1)frame='ttcm'
      if(iframe.eq.11)frame='nncm'
      if(iframe.eq.12)frame='targ'
      if(iframe.eq.21)frame='gncm'
      if(iframe.eq.22)frame='lncm'
      ntest=1
      if (istore.eq.2) then     ! OSC1997A
        write (ifdt,'(a)') 'OSC1997A'
        write (ifdt,'(a)') 'final_id_p_x'
        write(ifdt,100) code,version
     *       ,maproj,laproj,matarg,latarg,frame,engy,ntest
 100    format(2(a8,'  '),'(',i3,',',i3,')+(',i3,',',i3,')',
     *       '  ',a4,'  ',e10.4,'  ',i8)
        maxrec(1)=4
        irecty(1,1)=1           !nevt
        irecty(2,1)=2
        irecty(3,1)=3
        irecty(4,1)=4
        maxrec(2)=11
        irecty(1,2)=1           !nr
        irecty(2,2)=2           !id
        irecty(3,2)=3           !px
        irecty(4,2)=4           !py
        irecty(5,2)=5           !pz
        irecty(6,2)=6           !E
        irecty(7,2)=7           !M
        irecty(8,2)=11          !x
        irecty(9,2)=12          !y
        irecty(10,2)=13         !z
        irecty(11,2)=14         !t
      elseif(istore.eq.3) then
 201    format('# ',a)
        write (ifdt,201) 'OSC1999A'
        if(istmax.eq.0) then
          write (ifdt,201) 'final_id_p_x'
        elseif(istmax.ge.2) then  
          write (ifdt,201) 'full_event_history'
        endif
 202    format('# ',a8,' ',a8)
        write(ifdt,202) code,version !3rd line
 203    format('# (',i3,',',i3,')+(',i3,',',i3,')',
     *       '  ',a4,'  ',e10.4,'  ',i8)
        write(ifdt,203) maproj,laproj,matarg,latarg,frame,engy,ntest
        maxrec(1)=5
        irecty(1,1)=2           !nevt
        irecty(2,1)=0           !zero 
        irecty(3,1)=1           !additional information
        irecty(4,1)=3           !additional information
        irecty(5,1)=4           !additional information
        maxrec(2)=12
        irecty(1,2)=1           !nr
        irecty(2,2)=2           !id
        irecty(3,2)=10          !ist
        irecty(4,2)=3           !px
        irecty(5,2)=4           !py
        irecty(6,2)=5           !pz
        irecty(7,2)=6           !E
        irecty(8,2)=7           !M
        irecty(9,2)=11          !x
        irecty(10,2)=12         !y
        irecty(11,2)=13         !z
        irecty(12,2)=14         !t
                                ! nin nout [optional information]
                                ! ipart id ist px py pz p0 mass x y z t [optional information]

      endif
      
      end

c-----------------------------------------------------------------------
      subroutine bstore
c-----------------------------------------------------------------------
c     writes the results of a simulation into the file with unit ifdt
c     contains a description of the stored variables.
c-----------------------------------------------------------------------

      include 'nexus.inc'
      common/record/maxrec(2),irecty(30,2)
      common/dimensi/k2(100)
      
      nptevt=0
      do n=1,nptl
        iok=1               !idcode simple
        if(istmax.eq.2) then
          nk1=0
          nk2=1
          if(iabs(idptl(n)).ge.9999)  iok=0
          if(istptl(n).lt.0) iok=0
          if(istptl(n).ge.2) iok=0
          if(iorptl(n).lt.0) iok=0
          k2(nk2)=n             !check for interaction of daughters
          do while(nk1.lt.nk2.and.iok.eq.1) !----!
            nk1=nk1+1
            nn=k2(nk1)
            if(nk1.gt.1.and.jorptl(nn).ne.0) iok=0
            if(iok.eq.1.and.ifrptl(1,nn).ne.0.and.ifrptl(2,nn).ne.0)then
              do ii=ifrptl(1,nn),ifrptl(2,nn)
                nk2=nk2+1
                k2(nk2)=ii
              enddo
            endif
          enddo                 !---------------!
        else 
          if(istptl(n).gt.istmax) then 
            iok=0
          endif
        endif
        if (iok.eq.1) nptevt=nptevt+1
      enddo
 11   format (i6,' ',$)
 12   format (e12.6,' ',$)
      do i=1,maxrec(1)
        l=irecty(i,1)
        if(l.eq.0)write(ifdt,21) 0
        if(l.eq.1)write(ifdt,11)nrevt
        if(l.eq.2)write(ifdt,11)nptevt
        if(l.eq.3)write(ifdt,12)bimevt
        if(l.eq.4)write(ifdt,12)phievt
        if(l.eq.5)write(ifdt,11)kolevt
        if(l.eq.6)write(ifdt,12)pmxevt
        if(l.eq.7)write(ifdt,12)egyevt
        if(l.eq.8)write(ifdt,11)npjevt
        if(l.eq.9)write(ifdt,11)ntgevt
        if(l.eq.10)write(ifdt,11)npnevt
        if(l.eq.11)write(ifdt,11)nppevt
        if(l.eq.12)write(ifdt,11)ntnevt
        if(l.eq.13)write(ifdt,11)ntpevt
        if(l.eq.14)write(ifdt,11)jpnevt
        if(l.eq.15)write(ifdt,11)jppevt
        if(l.eq.16)write(ifdt,11)jtnevt
        if(l.eq.17)write(ifdt,11)jtpevt
        if(l.eq.20)write(ifdt,12)amproj
        if(l.eq.21)write(ifdt,12)amtarg
      enddo
      write (ifdt,*)            !RETURN
 21   format (i6,' ',$)
 22   format (e12.6,' ',$)
 23   format (i10,' ',$)
      do n=1,nptl
        iok=1                   !idcode simple
        if(istmax.eq.2) then
          nk1=0
          nk2=1
          if(iabs(idptl(n)).ge.9999)  iok=0
          if(istptl(n).lt.0) iok=0 
          if(istptl(n).ge.2) iok=0 
          if(iorptl(n).lt.0) iok=0 
          k2(nk2)=n             !check for interaction of daughters
          do while(nk1.lt.nk2.and.iok.eq.1) !----!
            nk1=nk1+1
            nn=k2(nk1)
            if(nk1.gt.1.and.jorptl(nn).gt.0) iok=0
            if(iok.eq.1.and.ifrptl(1,nn).ne.0.and.ifrptl(2,nn).ne.0)then
              do ii=ifrptl(1,nn),ifrptl(2,nn)
                nk2=nk2+1
                k2(nk2)=ii
              enddo
            endif
          enddo                 !---------------!
        else 
          if(istptl(n).gt.istmax) then 
            iok=0
          endif
        endif
        if (iok.eq.1) then
          id=idptl(n)
          if(istore.eq.2.or.istore.eq.3) then
            id=idtrafo('nxs','pdg',idptl(n))
          endif
          do i=1,maxrec(2)
            l=irecty(i,2)
            if(l.eq.0)write(ifdt,21) 0
            if(l.eq.1)write(ifdt,21) n
            if(l.eq.2)write(ifdt,23) id
            if(l.eq.3.or.l.eq.17)write(ifdt,22) pptl(1,n)
            if(l.eq.4.or.l.eq.17)write(ifdt,22) pptl(2,n)
            if(l.eq.5.or.l.eq.17)write(ifdt,22) pptl(3,n)
            if(l.eq.6.or.l.eq.17)write(ifdt,22) pptl(4,n)
            if(l.eq.7.or.l.eq.17)write(ifdt,22) pptl(5,n)
            if(l.eq.8)write(ifdt,21) iorptl(n)
            if(l.eq.9)write(ifdt,21) jorptl(n)
            if(l.eq.10)write(ifdt,21) istptl(n)
            if(l.eq.11.or.l.eq.18)write(ifdt,22) xorptl(1,n)
            if(l.eq.12.or.l.eq.18)write(ifdt,22) xorptl(2,n)
            if(l.eq.13.or.l.eq.18)write(ifdt,22) xorptl(3,n)
            if(l.eq.14.or.l.eq.18)write(ifdt,22) xorptl(4,n)
            if(l.eq.19)write(ifdt,22) dezptl(n)
            if(l.eq.20)write(ifdt,22) rinptl(n)
            if(l.eq.21)write(ifdt,21) ifrptl(1,n)
            if(l.eq.22)write(ifdt,21) ifrptl(2,n)
            if(l.eq.23)write(ifdt,21) ityptl(n)
            if(l.eq.15) then
              if(iorptl(n).gt.0)then 
                write(ifdt,23) idptl(iorptl(n))
              else
                write(ifdt,23) 0
              endif
            endif
            if(l.eq.16) then
              if(jorptl(n).gt.0)then 
                write(ifdt,23) idptl(jorptl(n))
              else
                write(ifdt,23) 0
              endif
            endif
          enddo
          write (ifdt,*)        !RETURN
        endif
      enddo
      return 
      end
      

c-----------------------------------------------------------------------
      subroutine bread
c-----------------------------------------------------------------------
c     writes the results of a simulation into the file with unit ifdt
c     contains a description of the stored variables.
c-----------------------------------------------------------------------

      include 'nexus.inc'
      common/record/maxrec(2),irecty(30,2)
      character*255 line
      dimension inptl(mxptl)
      logical info
      
      info=.false.
      do n=1,mxptl
        inptl(n)=0
      enddo
      read(ifdt,'(a255)',end=1)line
 1    k=1
      nptevt=0
      do i=1,maxrec(1)
        l=irecty(i,1)
        if(l.eq.0)read(line(k:),'(i6)')ldummy !0
        if(l.eq.0) k=k+7
        if(l.eq.1)read(line(k:),'(i6)')ldummy !nrevt
        if(l.eq.1) k=k+7
        if(l.eq.2)read(line(k:),'(i6)')nptevt
        if(l.eq.2) k=k+7
        if(l.eq.3)read(line(k:),'(e12.6)')bimevt
        if(l.eq.3) k=k+13
        if(l.eq.4)read(line(k:),'(e12.6)')phievt
        if(l.eq.4) k=k+13
        if(l.eq.5)read(line(k:),'(i6)')kolevt
        if(l.eq.5) k=k+7
        if(l.eq.6)read(line(k:),'(e12.6)')pmxevt
        if(l.eq.6) k=k+13
        if(l.eq.7)read(line(k:),'(e12.6)')egyevt
        if(l.eq.7) k=k+13
        if(l.eq.8)read(line(k:),'(i6)')npjevt
        if(l.eq.8) k=k+7
        if(l.eq.9)read(line(k:),'(i6)')ntgevt
        if(l.eq.9) k=k+7
        if(l.eq.10)read(line(k:),'(i6)')npnevt
        if(l.eq.10) k=k+7
        if(l.eq.11)read(line(k:),'(i6)')nppevt
        if(l.eq.11) k=k+7
        if(l.eq.12)read(line(k:),'(i6)')ntnevt
        if(l.eq.12) k=k+7
        if(l.eq.13)read(line(k:),'(i6)')ntpevt
        if(l.eq.13) k=k+7
        if(l.eq.14)read(line(k:),'(i6)')jpnevt
        if(l.eq.14) k=k+7
        if(l.eq.15)read(line(k:),'(i6)')jppevt
        if(l.eq.15) k=k+7
        if(l.eq.16)read(line(k:),'(i6)')jtnevt
        if(l.eq.16) k=k+7
        if(l.eq.17)read(line(k:),'(i6)')jtpevt
        if(l.eq.17) k=k+7
        if(l.eq.20)read(line(k:),'(e12.6)')amproj
        if(l.eq.20) k=k+13
        if(l.eq.21)read(line(k:),'(e12.6)')amtarg
        if(l.eq.21) k=k+13
      enddo
      if(nptevt.eq.0)then
        print *,'sorry, '
        print *,'there is no particle number in the event record  '
        stop
      endif
      do n=1,nptevt
        read(ifdt,'(a255)',end=2)line
 2      k=1
        do i=1,maxrec(2)
          l=irecty(i,2)
          if(l.eq.0)read(line(k:),'(i6)') ldummy
          if(l.eq.0) k=k+7
          if(l.eq.1)then
            read(line(k:),'(i6)') nidp
            if(nidp.gt.0.and.nidp.le.mxptl)then
              info=.true.
              inptl(nidp)=n
            endif
            k=k+7
          endif
          if(l.eq.2)read(line(k:),'(i10)') idptl(n)
          if(l.eq.2) k=k+11
          if(l.eq.3.or.l.eq.17)read(line(k:),'(e12.6)') pptl(1,n)
          if(l.eq.3) k=k+13
          if(l.eq.4.or.l.eq.17)read(line(k:),'(e12.6)') pptl(2,n)
          if(l.eq.4) k=k+13
          if(l.eq.5.or.l.eq.17)read(line(k:),'(e12.6)') pptl(3,n)
          if(l.eq.5) k=k+13
          if(l.eq.6.or.l.eq.17)read(line(k:),'(e12.6)') pptl(4,n)
          if(l.eq.6) k=k+13
          if(l.eq.7.or.l.eq.17)read(line(k:),'(e12.6)') pptl(5,n)
          if(l.eq.7) k=k+13
          if(l.eq.8)then
            read(line(k:),'(i6)') iorptl(n)
            k=k+7
            if(info.and.iorptl(n).gt.0)iorptl(n)=inptl(iorptl(n))
          endif
          if(l.eq.9)then
            read(line(k:),'(i6)') jorptl(n)
            k=k+7
            if(info.and.jorptl(n).gt.0)jorptl(n)=inptl(jorptl(n))
          endif
          if(l.eq.10)read(line(k:),'(i6)') istptl(n)
          if(l.eq.10) k=k+7
          if(l.eq.11.or.l.eq.18)read(line(k:),'(e12.6)')xorptl(1,n)
          if(l.eq.11) k=k+13
          if(l.eq.12.or.l.eq.18)read(line(k:),'(e12.6)')xorptl(2,n)
          if(l.eq.12) k=k+13
          if(l.eq.13.or.l.eq.18)read(line(k:),'(e12.6)')xorptl(3,n)
          if(l.eq.13) k=k+13
          if(l.eq.14.or.l.eq.18)read(line(k:),'(e12.6)')xorptl(4,n)
          if(l.eq.14) k=k+13
c     if(i.eq.15)read(line(k:),'(i6)') idiptl(n)
          if(l.eq.15) k=k+7
c     if(i.eq.16)read(line(k:),'(i6)') idjptl(n)
          if(l.eq.16) k=k+7
          if(l.eq.19)read(line(k:),'(e12.6)') dezptl(n)
          if(l.eq.19) k=k+13
          if(l.eq.20)read(line(k:),'(e12.6)') rinptl(n)
          if(l.eq.20) k=k+13
c          if(l.eq.21)read(line(k:),'(I6)') ifrptl(1,n)
          if(l.eq.21) k=k+7
c          if(l.eq.22)read(line(k:),'(I6)') ifrptl(2,n)
          if(l.eq.22) k=k+7
          if(l.eq.23)read(line(k:),'(I6)') ityptl(n)
          if(l.eq.23) k=k+7
        enddo
      enddo
      nptl=nptevt
      nevt=1
      end
 
c-----------------------------------------------------------------------
      subroutine afinal
c-----------------------------------------------------------------------
c  does some final calculations, to be called before call aasto.
c  * calculates nptlu, the maximum nptl for all events.
c  * calculates xorptl(j,i), representing formation points.
c    (xorptl(j,i),j=1,4) is the 4-vector representing the space-time of
c    creation of particle i.
c  * in case of mod(iframe,10) .ne. 1, these vectors are transformed
c    (being originally in the "natural frame",
c  * calculates numbers of spectators:
c    npnevt (number of primary proj neutron spectators)
c    nppevt (number of primary proj proton spectators)
c    ntnevt (number of primary targ neutron spectators)
c    ntpevt (number of primary targ proton spectators)
c    jpnevt (number of absolute proj neutron spectators)
c    jppevt (number of absolute proj proton spectators)
c    jtnevt (number of absolute targ neutron spectators)
c    jtpevt (number of absolute targ proton spectators)
c-----------------------------------------------------------------------

      include 'nexus.inc'
      
      double precision pp1,pp2,pp3,pp4,pp5 
      call utpri('afinal',ish,ishini,4)
      
      nptlu=max0(nptl,nptlu)

      if(mod(iframe,10).ne.1)then
      if(iframe.eq.12)then   !targ
      pp1=0d0
      pp2=0d0
      pp3=dsinh(dble(yhaha))
      pp4=dcosh(dble(yhaha))
      pp5=1d0
      else
      stop'transformation not yet defined'
      endif
      endif

      do i=1,nptl
         if(idptl(i).ne.0.and.istptl(i).le.1)then         
         if(    abs(tivptl(1,i)).le.ainfin
     *     .and.abs(xorptl(1,i)).le.ainfin
     *     .and.abs(xorptl(2,i)).le.ainfin
     *     .and.abs(xorptl(3,i)).le.ainfin
     *     .and.abs(xorptl(4,i)).le.ainfin
     *     .and.pptl(5,i).le.ainfin
     *     .and.pptl(4,i).gt.0.)then
      if(ish.ge.4)call alistc('afinal&',i,i)
      t=tivptl(1,i)
      xorptl(1,i)=xorptl(1,i)+pptl(1,i)/pptl(4,i)*(t-xorptl(4,i))
      xorptl(2,i)=xorptl(2,i)+pptl(2,i)/pptl(4,i)*(t-xorptl(4,i))
      xorptl(3,i)=xorptl(3,i)+pptl(3,i)/pptl(4,i)*(t-xorptl(4,i))
      xorptl(4,i)=t
      if(mod(iframe,10).ne.1)then
      if(iframe.eq.12)then
      call utlob4(-1,pp1,pp2,pp3,pp4,pp5
     *,xorptl(1,i),xorptl(2,i),xorptl(3,i),xorptl(4,i))
      call utlob5(-yhaha
     *, pptl(1,i), pptl(2,i), pptl(3,i), pptl(4,i), pptl(5,i))
      else
      stop'transformation not yet defined'
      endif
      endif
         else 
      if(ish.ge.1)then
        if(iorptl(i).gt.0)idior=idptl(iorptl(i))
      write(ifmt,'(a,i6,i10,i10,i3,1x,7(e7.1,1x))')
     *'*** warning (afinal): ',
     *i,idptl(i),idior,ityptl(i),tivptl(1,i), pptl(4,i), pptl(5,i)
     *,xorptl(1,i),xorptl(2,i),xorptl(3,i),xorptl(4,i)
      endif
      tivptl(1,i)=ainfin
      xorptl(1,i)=ainfin
      xorptl(2,i)=ainfin
      xorptl(3,i)=ainfin
      xorptl(4,i)=ainfin
         endif
         endif
      enddo
      
      npnevt=0
      nppevt=0
      ntnevt=0
      ntpevt=0    
      jpnevt=0
      jppevt=0
      jtnevt=0
      jtpevt=0    
      if(ish.ge.6)write(ifch,'(/31a1/a/31a1)')('-',l=1,31)
     *,'primary and absolute spectators',('-',l=1,31)
      if(ish.ge.6)write(ifch,'(/a//a/)')'projectile nucleons:'
     *,'     i    id   ior   ist'        
      do i=1,maproj
      if(ish.ge.6)write(ifch,'(4i6)')i,idptl(i),iorptl(i),istptl(i)
      io=iorptl(i)
      id=idptl(i)
      is=istptl(i)
      if(io.eq.0.and.id.eq.1220)npnevt=npnevt+1
      if(io.eq.0.and.id.eq.1120)nppevt=nppevt+1
      if(io.eq.0.and.is.eq.0.and.id.eq.1220)jpnevt=jpnevt+1
      if(io.eq.0.and.is.eq.0.and.id.eq.1120)jppevt=jppevt+1
      enddo
      if(ish.ge.6)write(ifch,'(/a//a/)')'target nucleons:'
     *,'     i    id   ior   ist'        
      do i=maproj+1,maproj+matarg
      if(ish.ge.6)write(ifch,'(4i6)')i,idptl(i),iorptl(i),istptl(i)
      io=iorptl(i)
      id=idptl(i)
      is=istptl(i)
      if(io.eq.0.and.id.eq.1220)ntnevt=ntnevt+1
      if(io.eq.0.and.id.eq.1120)ntpevt=ntpevt+1 
      if(io.eq.0.and.is.eq.0.and.id.eq.1220)jtnevt=jtnevt+1
      if(io.eq.0.and.is.eq.0.and.id.eq.1120)jtpevt=jtpevt+1 
      enddo
      if(ish.ge.6)then
      write(ifch,'(/a/)')'numbers of participants and spectators:'
      write(ifch,'(a,i4,a,i4)')'primary participants:   projectile:'
     *,npjevt,'   target:',ntgevt
      write(ifch,'(a,i4,a,i4)')'primary spectators:     projectile:'
     *,npnevt+nppevt,'   target:',ntnevt+ntpevt
      write(ifch,'(a,i4,a,i4)')
     *'primary spectator neutrons:   projectile:',npnevt
     *,'   target:',ntnevt
      write(ifch,'(a,i4,a,i4)')
     *'primary spectator protons:    projectile:',nppevt
     *,'   target:',ntpevt
      write(ifch,'(a,i4,a,i4)')'absolute spectators:    projectile:'
     *,jpnevt+jppevt,'   target:',jtnevt+jtpevt
      endif


c$$$      if(ifrade.ne.0.and.iappl.eq.1)then
c$$$       numbar=0
c$$$       do j=1,nptl
c$$$        if(istptl(j).eq.0)then
c$$$         if(idptl(j).gt. 1000.and.idptl(j).lt. 10000)numbar=numbar+1
c$$$         if(idptl(j).lt.-1000.and.idptl(j).gt.-10000)numbar=numbar-1
c$$$        endif 
c$$$       enddo
c$$$       nvio=maproj+matarg-numbar
c$$$       if(nvio.ne.0)then
c$$$        call alist('complete list&',1,nptl)
c$$$        write(6,'(//10x,a,i5//)')'ERROR: baryon number violation:',nvio
c$$$        write(6,'(10x,a//)')
c$$$     *        'a complete list has been printed into the check-file'
c$$$c        stop
c$$$       endif 
c$$$      endif



      if(ish.eq.27)stop'change this????????????' !call hnbcor(2)
      if(imihis.eq.1)call wimi
      if(imihis.eq.1.and.nrevt.eq.nevent)call wimino
      if(isphis.eq.1)call xspace(1)
      if(iclhis.eq.1)call wclu
      if(iclhis.eq.1.and.nrevt.eq.nevent)call wclufi
      if(iwtime.eq.1)call wtime(1)
      if(iwtime.eq.1.and.nrevt.eq.nevent)call wtime(2)
      if(ionucl.gt.0.and.nrevt.eq.nevent)call xconxyz
       
      call utprix('afinal',ish,ishini,4)
      return
      end

c-----------------------------------------------------------------------
      subroutine ainit
c-----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      include 'nexus.incpar'
      common/cquama/quama 
      parameter (nptj=129)
      common /cptj/xptj(nptj),qptj(nptj),wptj(nptj)
      common/geom/rmproj,rmtarg,bmax,bkmx
      double precision tpro,zpro,ttar,ztar,ttaus,detap,detat,seedp
      common/cttaus/tpro,zpro,ttar,ztar,ttaus,detap,detat /ctain/mtain
      double precision rcproj,rctarg
      common/geom1/rcproj,rctarg
      common/geom3/b2kmx
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common/testpom/antot,ansh,ansf,pp4max,pp4ini,andropl,anstrg0
     *,anstrg1,anreso0,anreso1,anghadr,antotre
      external sptj
      
      call utpri('ainit ',ish,ishini,4)

      ntevt=0
      

      if(inicnt.eq.0)write(ifmt,'(a)')'initializations ...'
      if(inicnt.eq.0.and.ish.ge.2)
     &write(ifmt,'(a)')'--------------------------------'
      

      if(seedi.ne.0d0)call ranfst(seedi)
      seedc=seedi
      call aseedi

      if(isphis.eq.1)iframe=11  !nncm
      if(icinpu.ge.1)elepti=engy
      if(iopenu.eq.2)call smassi(themas)
      if(iopenu.eq.2.and.ish.eq.19)stop'change this?????????' !call smassp

      if(iappl.eq.5)then
      yhaha=0
      ypjtl=0
      endif
 
      if(ispherio.ne.0)ifrade=0
      if(ispherio.ne.0)irescl=0
       
      if(noebin.gt.1)then
        engy=-1
        ekin=-1
        if(iologe.eq.1)engy=
     *       engmin*(engmax/engmin)**((real(nrebin)-0.5)/noebin)
        if(iologe.eq.0.or.(iologe.lt.0.and.iologl.lt.0))engy=
     *       engmin+(engmax-engmin)/noebin*(nrebin-0.5)
        if(iologl.eq.1)ekin=
     *       engmin*(engmax/engmin)**((real(nrebin-0.5))/noebin)
        if(iologl.eq.0)ekin=
     *       engmin+(engmax-engmin)/noebin*(real(nrebin)-0.5)
        elab=-1
        ecms=-1
        pnll=-1
        if(jpsi.lt.0)then
  11      z=0.19*sqrt(-2*alog(rangen()))*cos(2*pi*rangen()) 
          engy=abs(z)*engmax
          if(engy.le.egymin)goto11
        endif
      endif

           if(iappl.le.3)then

        if((idproj.ne.1120.and.(laproj.ne.-1.or.maproj.ne.1))
     &    .or.maproj.le.0)
     &  call utstop('Invalid projectile setup !&')

      if(iabs(idtarg).ne.1120.and.iabs(idtarg).ne.1220.and.idtarg.ne.0)
     &  call utstop('Invalid target !&')
        if((((idtarg.eq.-1120.or.iabs(idtarg).eq.1220)
     &    .and.(latarg.ne.-1.or.matarg.ne.1))
     &    .and.(idtarg.ne.1120.or.latarg.lt.0))
     &    .or.matarg.le.0)
     &  call utstop('Invalid target setup !&')


      if(idtarg.eq.0)then
        call getairmol(latarg,matarg)
        if(ish.ge.2)write(ifch,*)'Air Target, select (Z,A) :'
     &                           ,latarg,matarg
      endif

      call idmass(idproj,amproj)
      call idmass(idtarg,amtarg)
      nre=0
      if(engy.ge.0.)nre=nre+1
      if(pnll.ge.0.)nre=nre+1
      if(elab.ge.0.)nre=nre+1
      if(ekin.ge.0.)nre=nre+1
      if(ecms.ge.0.)nre=nre+1
      if(nre.ne.1)stop'invalid energy definition'
         if(engy.gt.0.)then
      pnll=sqrt(max(0., ((engy**2-amproj**2-amtarg**2)/2/amtarg)**2
     &                   -amproj**2) )
      elab=sqrt(pnll**2+amproj**2)
      ekin=elab-amproj
      ecms=engy   
         elseif(ecms.gt.0.)then
      engy=ecms   
      pnll=sqrt(max(0., ((engy**2-amproj**2-amtarg**2)/2/amtarg)**2
     &                   -amproj**2) )
      elab=sqrt(pnll**2+amproj**2)
      ekin=elab-amproj
         elseif(elab.gt.0)then
      pnll=sqrt(max(0.,elab**2-amproj**2))   
      engy=sqrt( 2*elab*amtarg+amtarg**2+amproj**2 )
      ecms=engy   
      ekin=elab-amproj
         elseif(pnll.gt.0)then
      elab=sqrt(pnll**2+amproj**2)
      engy=sqrt( 2*sqrt(pnll**2+amproj**2)*amtarg+amtarg**2+amproj**2 )
      ecms=engy   
      ekin=elab-amproj
         elseif(ekin.gt.0.)then
      elab=ekin+amproj
      pnll=sqrt(max(0.,elab**2-amproj**2))   
      engy=sqrt( 2*elab*amtarg+amtarg**2+amproj**2 )
      ecms=engy   
         endif


      if(pnll.le.0.001)call utstop('ainit: energy too low&')
      if(engy.gt.egymax)call utstop('ainit: energy too high&')
      s=engy**2
      pnullx=utpcm(engy,amproj,amtarg)
      yhaha=alog((sqrt(pnll**2+s)+pnll)/sqrt(s))
      ypjtl=alog((sqrt(pnll**2+amproj**2)+pnll)/amproj)

         elseif(iappl.eq.7)then

      call idmass(idproj,amproj)
         if(elab.gt.0)then
      pnll=sqrt(max(0.,elab**2-amproj**2))   
      engy=amproj
      ecms=engy   
      ekin=elab-amproj
         elseif(pnll.gt.0)then
      elab=sqrt(pnll**2+amproj**2)
      engy=amproj
      ecms=engy   
      ekin=elab-amproj
         elseif(ekin.gt.0.)then
      elab=ekin+amproj
      pnll=sqrt(max(0.,elab**2-amproj**2))   
      engy=amproj
      ecms=engy
         else
      engy=amproj
      ecms=amproj
      elab=0.
      pnll=0.
      ekin=0.
         endif

      pnullx=0.
      ypjtl=alog((sqrt(pnll**2+amproj**2)+pnll)/amproj)
      yhaha=ypjtl


         endif

      detap=(ypjtl-yhaha)*etafac
      detat=-yhaha*etafac
      tpro=dcosh(detap)
      zpro=dsinh(detap)
      ttar=dcosh(detat)
      ztar=dsinh(detat)

      egyevt=engy
      pmxevt=pnll
      
      if(iappl.gt.8)stop'update following statement'
      if(iappl.ge.5.and.iappl.le.8)then
      s=12.**2
      endif

      if(iappl.le.3)then
       if(maproj.gt.1)then
        rpj=1.19*maproj**(1./3.)-1.61*maproj**(-1./3.)
        rmproj=rpj+fctrmx*.54
        rcproj=dble(rpj/cosh(yhaha)*facnuc)
       else
        rmproj=0
        rcproj=dble(0.8/cosh(yhaha)*facnuc)
       endif
       if(matarg.gt.1)then
        rtg=1.19*matarg**(1./3.)-1.61*matarg**(-1./3.)
        rmtarg=rtg+fctrmx*.54
        rctarg=dble(rtg/cosh(yhaha)*facnuc)
       else
        rmtarg=0
        rctarg=dble(0.8/cosh(yhaha)*facnuc)
       endif
      endif

         if(inicnt.eq.0)then
	 
      call ranfgt(seedp)                     !not to change the seed ...

      call hdecin(.false.)
           
      if(jpsi.gt.0.and.(iappl.eq.1.or.iappl.ge.5))then
      c=6
      call utquaf(sptj,nptj,xptj,qptj,wptj,0.,.33*c,.66*c,c)
      endif
  
      if(iappl.ne.2)then
        call hnbspd(iospec)
        ktnbod=0
      endif
      if(iappl.ne.6)call psaini                    

      call ranfst(seedp)                     ! ... after this initialization

      inicnt=1
 
         endif
	       
c$$$      if(idproj.eq.1120)icp=2        !????????????? for what ?
c$$$      if(idproj.eq.-1120)icp=-2
c$$$      if(idproj.eq.120)icp=1
c$$$      if(idproj.eq.-120)icp=-1
c$$$      if(idproj.eq.130)icp=4
c$$$      if(idproj.eq.-130)icp=-4
      
         
      if(irdmpr.ne.0)idproj=idproj*(1-2*int(rangen()+0.5d0))


      if(iappl.le.3)then
        call iclass(idproj,iclpro)
        call iclass(idtarg,icltar)
        call emsini(engy,idproj,idtarg)
        call paramini
        if(ish.ge.4)then
          do i=nbpDf0,nbpDf1
            write(ifmt,'(9(a,f8.4))')
     *      'AlpD:',real(alpD(i,iclegy,iclpro,icltar,icdp,icdt))
     * ,'    AlpDp:',real(alpDp(i,iclegy,iclpro,icltar,icdp,icdt))
     * ,'    AlpDpp:',real(alpDpp(i,iclegy,iclpro,icltar,icdp,icdt))
     * ,'    BetD:',real(betD(i,iclegy,iclpro,icltar,icdp,icdt))
     * ,'    BetDp:',real(betDp(i,iclegy,iclpro,icltar,icdp,icdt))
     * ,'    BetDpp:',real(betDpp(i,iclegy,iclpro,icltar,icdp,icdt))
     * ,'    GamD:',real(gamD(i,iclegy,iclpro,icltar,icdp,icdt))
     * ,'    DelD:',real(delD(i,iclegy,iclpro,icltar,icdp,icdt))
     * ,'    AlpPar:',real(alppar) 
          enddo
          do i=1,nbpDf
            write(ifmt,'(4(a,f8.4))')
     *'      AlpD1:',real(alpD1(i,iclegy,iclpro))
     * ,'    BetD1:',real(betD1(i,iclegy,iclpro))
     * ,'    BetDp1:',real(betDp1(i,iclegy,iclpro))
     * ,'    DelD1:',real(delD1(i,iclegy,iclpro))
          enddo
          do i=1,nbpDf
            write(ifmt,'(3(a,f8.4))')
     *'      AlpD2:',real(alpD2(i,iclegy))
     * ,'    BetD2:',real(betD2(i,iclegy))
     * ,'    DelD2:',real(delD2(i,iclegy))
          enddo
        endif
      endif


      if(iappl.le.3)then
      bkmx=conbmx()
      b2kmx=0.
      if((maproj+matarg).gt.2.and.inueff.ne.0)b2kmx=conb2mx()

      if(ish.ge.3)write(ifmt,*)'bkmx,b2kmx',bkmx,b2kmx

      if(maproj.gt.1.or.matarg.gt.1)then
      bmax=rmproj+rmtarg
      else
      bmax=bkmx
      endif
      endif
      
      if(ixtau.eq.1)call xtauev(0)
      if(iEmsB.eq.1)call xEmsB(0,0,0)
      if(iEmsBg.eq.1)call xEmsBg(0,0,0)
      if(iEmsPm.eq.1)call xEmsPm(0,0,0,0,0)
      if(iEmsPx.eq.1)call xEmsPx(0,0.,0.,0)
      if(iEmsPx.eq.1)call xEmsPxNo(0,0.,0.,0)
      if(iEmsPx.eq.1)call xPhiAB(0)
      if(iEmsSe.eq.1)call xEmsSe(0,0.,0.,0)
      if(iEmsDr.eq.1)call xEmsDr(0,0.,0.,0)
      if(iEmsRx.eq.1)call xEmsRx(0,0,0.,0.)
      

c Cross section calculation (as information)

      if(iappl.le.3)call xsigma

      if(idtarg.eq.0)idtarg=1120           !air = nucleus


      if(seedj.ne.0.)call ranfst(seedj)
      seedc=seedj

      call utprix('ainit ',ish,ishini,4)

      return
      end

c---------------------------------------------------------------------
      subroutine aread
c---------------------------------------------------------------------
c  reads and interprets input commands
c---------------------------------------------------------------------     

      include 'nexus.inc'
      include 'nexus.incpar'
      include 'nexus.incsem'
     
      double precision histoweight
      common/chiswei/histoweight
      common/cyield/yield
      common/csigma/sigma
      double precision val
      character*160 line,linex
      data nappl /0/
      common/record/maxrec(2),irecty(30,2)
      common/cfacmss/facmss /cr3pomi/r3pomi,r4pomi 
      common /ems12/iodiba,bidiba  ! defaut iodiba=0. if iodiba=1, study H-Dibaryon 


      j=-1
      n=0

    1 call utword(line,i,j,1)

           if(line(i:j).eq.'application')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'application?'
      call utword(line,i,j,0)
      if(nopen.ne.-1)then       !only first read
      if(line(i:j).eq.'analysis')  iappl=0
      if(line(i:j).eq.'hadron')    iappl=1
      if(line(i:j).eq.'geometry')  iappl=2
      if(line(i:j).eq.'read')      iappl=3
      if(line(i:j).eq.'droplet')   iappl=4
      if(line(i:j).eq.'kinky')     iappl=5
      if(line(i:j).eq.'ee')        iappl=6
      if(line(i:j).eq.'decay')     iappl=7
      if(line(i:j).eq.'lepton')    iappl=8
      if(line(i:j).eq.'ee')    then ! use ee default parameters 
        naflav=5                ! number of flavors
        ptfknk=0.31             ! pt somewhat lower 
        pbreak=-1               ! use parameterization
      endif
      nappl=nappl+1
      if(iappl.gt.0.and.nappl.gt.1)call aaset(1)
      if(iappl.eq.0.and.nappl.gt.1)call aaset(2)
      if(iappl.eq.0)jframe=iframe
      if(iappl.eq.0)kframe=iframe
      if(iappl.eq.1)iframe=0
      if(iappl.eq.2)iframe=0
      if(iappl.eq.4)iframe=1
      if(iappl.eq.5)iframe=1
      if(iappl.eq.6)iframe=1
      if(iappl.eq.7)iframe=0
      if(iappl.eq.8)iframe=21        !gncm
      endif

           elseif(line(i:j).eq.'call')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'subroutine?'
      call utword(line,i,j,0)
      if(nopen.eq.-1)then       !-----only second run 
      if(line(i:j).eq.'xParGam')call xParGam
      if(line(i:j).eq.'xParGampp')call xParGampp
      if(line(i:j).eq.'xParOmega1xy')call xParOmega1xy
      if(line(i:j).eq.'xParOmega3xyz')call xParOmega3xyz
      if(line(i:j).eq.'xParPro')call xParPro
      if(line(i:j).eq.'xParPomInc')call xParPomInc
      if(line(i:j).eq.'xParPomIncX')call xParPomIncX
      if(line(i:j).eq.'xParPomIncP')call xParPomIncP
      if(line(i:j).eq.'xParPomIncM')call xParPomIncM
      if(line(i:j).eq.'xParPomIncXI')call xParPomIncXI
      if(line(i:j).eq.'xParPomIncPI')call xParPomIncPI
      if(line(i:j).eq.'xParPomIncMI')call xParPomIncMI
      if(line(i:j).eq.'xParPomIncJ')call xParPomIncJ
      if(line(i:j).eq.'xParOmega1')call xParOmega1
      if(line(i:j).eq.'xParOmega3')call xParOmega3
      if(line(i:j).eq.'xParOmega5')call xParOmega5
      if(line(i:j).eq.'xParOmegaN')call xParOmegaN
      if(line(i:j).eq.'xParGauss')call xParGauss
      if(line(i:j).eq.'xParSigma')call xParSigma
      if(line(i:j).eq.'xParSigma2')call xParSigma2
      if(line(i:j).eq.'xScrD')call xScrD
      if(line(i:j).eq.'xExaD')call xExaD
      if(line(i:j).eq.'xExaD2')call xExaD2
      if(line(i:j).eq.'xbExaD')call xbExaD
      if(line(i:j).eq.'xbExaD2')call xbExaD2
      if(line(i:j).eq.'xbnExaD')call xbnExaD
      if(line(i:j).eq.'xbnExaD2')call xbnExaD2
      if(line(i:j).eq.'xParD')call xParD
      if(line(i:j).eq.'xbParD')call xbParD
      if(line(i:j).eq.'xParD2')call xParD2
      if(line(i:j).eq.'xGexaJ')call xGexaJ
      if(line(i:j).eq.'xbnParD')call xbnParD
      if(line(i:j).eq.'xsParD')call xsParD
      if(line(i:j).eq.'xmParD2')call xmParD2
      if(line(i:j).eq.'xyParD')call xyParD
      if(line(i:j).eq.'xyParD2')call xyParD2
      if(line(i:j).eq.'xParPhi1')call xParPhi1
      if(line(i:j).eq.'xParPhi')call xParPhi
      if(line(i:j).eq.'xParH')call xParH
      if(line(i:j).eq.'xParHPhiInt')call xParHPhiInt
      if(line(i:j).eq.'xParZ')call xParZ
      if(line(i:j).eq.'xtauev')call xtauev(2)
      if(line(i:j).eq.'xspace')call xspace(2)
      if(line(i:j).eq.'jet'   )call jet
      if(line(i:j).eq.'gakjto'   )call gakjto
      if(line(i:j).eq.'psaevp')call psaevp
c     if(line(i:j).eq.'pyarea')call pyarea
      if(line(i:j).eq.'xhgcam')call xhgcam(0.,-1)
      if(line(i:j).eq.'xhgcfl')call xhgcfl(0.,0.,0.,-1)
      if(line(i:j).eq.'xhgccc')call xhgccc(-1.)
      if(line(i:j).eq.'xjden1')call xjden1(2,0,0.,0.,0.,0.,0.)       
      if(line(i:j).eq.'xjden2')call xjden2(2,0,0.,0.,0.,0.)       
c     if(line(i:j).eq.'xjdis' )call xjdis(2,0,0)
      if(line(i:j).eq.'xhgcen')call xhgcen
      if(line(i:j).eq.'xhgcmt')call xhgcmt
      if(line(i:j).eq.'xhgcmu')call xhgcmu
      if(line(i:j).eq.'xhgcmx')call xhgcmx
      if(line(i:j).eq.'xhgcpt')call xhgcpt
      if(line(i:j).eq.'xhgcra')call xhgcra
      if(line(i:j).eq.'xhnben')call xhnben
      if(line(i:j).eq.'xhnbit')call xhnbit
      if(line(i:j).eq.'xhnbmu')call xhnbmu
      if(line(i:j).eq.'xhnbmz')call xhnbmz
      if(line(i:j).eq.'xhnbte')call xhnbte(-1)
      if(line(i:j).eq.'xhnbti')call xhnbti(-1)
      if(line(i:j).eq.'xEmsB' )call xEmsB(2,0,0)
      if(line(i:j).eq.'xEmsBg')call xEmsBg(2,0,0)
      if(line(i:j).eq.'xEmsPm')call xEmsPm(2,0,0,0,0)
      if(line(i:j).eq.'xEmsPx')call xEmsPx(2,0.,0.,0)
      if(line(i:j).eq.'xEmsPx')call xEmsPxNo(2,0.,0.,0)
      if(line(i:j).eq.'xEmsPx')call xPhiAB(2)
      if(line(i:j).eq.'xEmsSe')call xEmsSe(2,0.,0.,0)
      if(line(i:j).eq.'xEmsDr')call xEmsDr(2,0.,0.,0)
      if(line(i:j).eq.'xEmsRx')call xEmsRx(2,0,0.,0.)

      else
      if(line(i:j).eq.'xtauev')then
       ixtau=1
      elseif(line(i:j).eq.'xEmsB')then
       iEmsB=1
      elseif(line(i:j).eq.'xEmsBg')then
       iEmsBg=1
      elseif(line(i:j).eq.'xEmsPm')then
       iEmsPm=1
      elseif(line(i:j).eq.'xEmsPx')then
       iEmsPx=1
      elseif(line(i:j).eq.'xEmsSe')then
       iEmsSe=1
      elseif(line(i:j).eq.'xEmsDr')then
       iEmsDr=1
      elseif(line(i:j).eq.'xEmsRx')then
       iEmsRx=1
      elseif(line(i:j).eq.'xEmsI1')then
       iEmsI1=1
       if(iEmsI1+iEmsI2.eq.1)write(ifhi,'(a)')'newpage zone 3 4 1'
      elseif(line(i:j).eq.'xEmsI2')then
       iEmsI2=1
       if(iEmsI1+iEmsI2.eq.1)write(ifhi,'(a)')'newpage zone 3 4 1'
      endif 
      endif

           elseif(line(i:j).eq.'decayall')then
           
      nrnody=0    

           elseif(line(i:j).eq.'echo')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'on or off?'
      call utword(line,i,j,0)
      if(line(i:j).eq.'on')iecho=1
      if(line(i:j).eq.'off')iecho=0
      if(line(i:j).ne.'on'.and.line(i:j).ne.'off')stop'invalid option'

           elseif(line(i:j).eq.'fname')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'file-type file-name?'
      call utword(line,i,j,0)
      linex=line
      ix=i
      jx=j
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'file-name?'
      call utword(line,i,j,0)
      if(linex(ix:jx).eq.'pathnx')fnnx(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'check')fnch(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'histo')fnhi(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'data') fndt(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'copy') fncp(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'initl') fnii(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'initl+') fnii(nfnii+1:nfnii+j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'inidi') fnid(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'inidi+') fnid(nfnid+1:nfnid+j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'iniev') fnie(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'iniev+') fnie(nfnie+1:nfnie+j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'inirj') fnrj(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'inirj+') fnrj(nfnrj+1:nfnrj+j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'inics') fncs(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'inics+') fncs(nfncs+1:nfncs+j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'pathnx')nfnnx=j-i+1
      if(linex(ix:jx).eq.'check')nfnch=j-i+1
      if(linex(ix:jx).eq.'histo')nfnhi=j-i+1
      if(linex(ix:jx).eq.'data') nfndt=j-i+1
      if(linex(ix:jx).eq.'copy') nfncp=j-i+1
      if(linex(ix:jx).eq.'initl') nfnii=j-i+1
      if(linex(ix:jx).eq.'initl+')nfnii=nfnii+j-i+1
      if(linex(ix:jx).eq.'inidi') nfnid=j-i+1
      if(linex(ix:jx).eq.'inidi+')nfnid=nfnid+j-i+1
      if(linex(ix:jx).eq.'iniev') nfnie=j-i+1
      if(linex(ix:jx).eq.'iniev+')nfnie=nfnie+j-i+1
      if(linex(ix:jx).eq.'inirj') nfnrj=j-i+1
      if(linex(ix:jx).eq.'inirj+')nfnrj=nfnrj+j-i+1
      if(linex(ix:jx).eq.'inics') nfncs=j-i+1
      if(linex(ix:jx).eq.'inics+')nfncs=nfncs+j-i+1
      if(linex(ix:jx).eq.'check'.and.fnch(1:nfnch).ne.'none') then
      open(unit=ifcx,file=fnch(1:nfnch),status='unknown')
      kchopen=1
      ifch=ifcx
      elseif(linex(ix:jx).eq.'pathnx'.and.fnnx(1:nfnnx).ne.'none')then
      knxopen=1
      elseif(linex(ix:jx).eq.'histo'.and.fnhi(1:nfnhi).ne.'none')then
      open(unit=ifhi,file=fnhi(1:nfnhi),status='unknown')
      khiopen=1
      elseif(linex(ix:jx).eq.'data'.and.fndt(1:nfndt).ne.'none')then
      open(unit=ifdt,file=fndt(1:nfndt),status='unknown')
      kdtopen=1
      elseif(linex(ix:jx).eq.'copy'.and.fncp(1:nfncp).ne.'none')then
      open(unit=ifcp,file=fncp(1:nfncp),status='unknown')
      kcpopen=1
      endif

           elseif(line(i:j).eq.'frame')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'frame?'
      call utword(line,i,j,0)
        if(nopen.ne.-1)then       ! event definition only, not analysis
        if(line(i:j).eq.'nucleon-nucleon')then
      if(iappl.eq.0)jframe=11
      if(iappl.eq.1)iframe=11
      if(iappl.eq.3)iframe=11
      if(iappl.gt.3.or.iappl.eq.2)stop'invalid option nucleon-nucleon'
        elseif(line(i:j).eq.'target')then
      if(iappl.eq.0)jframe=12
      if(iappl.eq.1)iframe=12
      if(iappl.eq.3)iframe=12
      if(iappl.gt.3.or.iappl.eq.2)stop'invalid option target'
        elseif(line(i:j).eq.'gamma-nucleon')then
      if(iappl.eq.0)jframe=21
      if(iappl/2.eq.4)iframe=21
      if(iappl.eq.3)iframe=21
      if(iappl.ne.0.and.iappl/2.ne.4.and.iappl.ne.3)
     *stop'invalid option gamma-nucleon'
        elseif(line(i:j).eq.'lab')then
      if(iappl.eq.0)jframe=22
      if(iappl/2.eq.4)iframe=22
      if(iappl.eq.3)iframe=22
      if(iappl.ne.0.and.iappl/2.ne.4.and.iappl.ne.3)
     *stop'invalid option lab'
        elseif(line(i:j).eq.'sphericity')then
      if(iappl.eq.0)jframe=32
      if(iappl.ne.0)stop'invalid option sphericity'
        elseif(line(i:j).eq.'thrust')then
      if(iappl.eq.0)jframe=33
      if(iappl.ne.0)stop'invalid option thrust'
        elseif(line(i:j).eq.'breit')then
          if(iappl.ne.0)stop'invalid option breit'
        else
      stop'frame not recognized'
        endif
        endif

           elseif(line(i:j).eq.'frame+')then

      call utword(line,i,j,0)

           elseif(line(i:j).eq.'help')then

      write(ifmt,'(77a1)')('-',l=1,77)
      write(ifmt,'(a)')'possible commands:'
      write(ifmt,'(77a1)')('-',l=1,77)
      write(ifmt,'(a,a/a,a)')
     *'application call decayall echo fname help idcode input nodecay '
     *,'print prompt'
     *,'return run set setm show showa stop string trigger write '
     *,' writearray' 
      write(ifmt,'(77a1)')('-',l=1,77)

           elseif(line(i:j).eq.'binning')then
           
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'log/lin?'
      call utword(line,i,j,0)
      if(line(i:j).eq.'lin')iologb=0     
      if(line(i:j).eq.'log')iologb=1     

           elseif(line(i:j).eq.'beginhisto')then

      if(nopen.ne.-1)then
        call xini
        j=-1                    !start new line 
      endif

           elseif(line(i:j).eq.'endhisto')then

      if(nopen.eq.-1)then
        n=n+1
        call xhis(n)
      endif

           elseif(line(i:j).eq.'histogram')then 

      call utword(line,i,j,0)
      call utword(line,i,j,0)
      call utword(line,i,j,0)
      call utword(line,i,j,0)
      call utword(line,i,j,0)
      call utword(line,i,j,0)

           elseif(line(i:j).eq.'plot')then

      ihisarg=ihisarg+1
      do k=1,80
      hisarg(1,ihisarg)(k:k)=' '
      hisarg(2,ihisarg)(k:k)=' '
      enddo
      if(ihisarg.gt.mxhisarg)stop'too many histograms'
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'which one?'
      call utword(line,i,j,0)
      hisarg(1,ihisarg)(1:j-i+1)=line(i:j)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'which one?'
      call utword(line,i,j,0)
      hisarg(2,ihisarg)(1:j-i+1)=line(i:j)

           elseif(line(i:j).eq.'idcode')then

      call utword(line,i,j,0)

           elseif(line(i:i+10).eq.'histoweight')then

      if(nopen.eq.-1)then
        if(line(i:j).eq.'histoweight')then
          write(ifhi,'(a,d22.14)')'histoweight ',histoweight
        elseif(line(i:j).eq.'histoweightbin')then
          write(ifhi,'(a,d22.14)')'histoweightbin ',histoweight
        endif
      endif

           elseif(line(i:j).eq.'input')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'input file?'
      call utword(line,i,j,0)
      if(nopen.ge.0)then
       nopen=nopen+1
       if(nopen.gt.9)stop'too many nested input commands'
       open(unit=20+nopen,file=line(i:j),status='old')
       if(iprmpt.eq.1)iprmpt=-1
      endif 

           elseif(line(i:j).eq.'nodecay')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'id?'
      call utword(line,i,j,0)
      if(nrnody.ge.mxnody)then
      write(ifmt,'(a)')'too many nodecay commands; command ignored'
      j=160
      i=j+1
      goto1
      endif
      nrnody=nrnody+1 
      read(line(i:j),*)val
      nody(nrnody)=nint(val)

           elseif(line(i:j).eq.'print')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'subroutine?'
      call utword(line,i,j,0)
       if(line(i:j).eq.'*')then
      nrpri=0
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'level?'
      call utword(line,i,j,0)
      read(line(i:j),*)val
      ish=nint(val)
       else
      nrpri=nrpri+1    
      subpri(nrpri)='      '  
      subpri(nrpri)(1:j-i+1)=line(i:j)  
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'level?'
      call utword(line,i,j,0)
      read(line(i:j),*)val
      ishpri(nrpri)=nint(val)
       endif
     
           elseif(line(i:j).eq.'printcheck')then
           
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'screen or file?'
      call utword(line,i,j,0)
      if(line(i:j).eq.'screen')ifch=ifmt
      if(line(i:j).eq.'file')ifch=ifcx
      if(line(i:j).ne.'screen'.and.line(i:j).ne.'file')
     *write(ifmt,'(a)')'invalid option; command ignored'

           elseif(line(i:j).eq.'prompt')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'on or off or auto?'
      call utword(line,i,j,0)
      if(line(i:j).eq.'on')iprmpt=2
      if(line(i:j).eq.'off')iprmpt=-2
      if(line(i:j).eq.'auto'.and.nopen.eq.0)iprmpt=1
      if(line(i:j).eq.'auto'.and.nopen.eq.1)iprmpt=-1
      if(line(i:j).ne.'on'.and.line(i:j).ne.'off'
     *.and.line(i:j).ne.'auto')stop'invalid option'

           elseif(line(i:j).eq.'return')then

      close(20+nopen)
      nopen=nopen-1
      if(nopen.eq.0.and.iprmpt.eq.-1)iprmpt=1

           elseif(line(i:j).eq.'run')then
             
      if(kchopen.eq.0.and.fnch(1:nfnch).ne.'none')then
        open(unit=ifcx,file=fnch(1:nfnch),status='unknown')
        kchopen=1
      endif
      if(khiopen.eq.0.and.fnhi(1:nfnhi).ne.'none')then
        open(unit=ifhi,file=fnhi(1:nfnhi),status='unknown')
        khiopen=1
      endif
      if(kdtopen.eq.0.and.fndt(1:nfndt).ne.'none')then
        open(unit=ifdt,file=fndt(1:nfndt),status='unknown')
        kdtopen=1
      endif
      if(kcpopen.eq.0.and.fncp(1:nfncp).ne.'none')then
        open(unit=ifcp,file=fncp(1:nfncp),status='unknown')
        kcpopen=1
      endif
      return


           elseif(line(i:j).eq.'set')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'p/o-name p/o-value?'
      call utword(line,i,j,0)
      linex=line
      ix=i
      jx=j
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'p/o-value?'
      call utword(line,i,j,0)
      read(line(i:j),*)val
c       general
      if(linex(ix:jx).eq.'iversn')iversn=nint(val)
      if(linex(ix:jx).eq.'iappl' )iappl=nint(val)
      if(linex(ix:jx).eq.'nevent')nevent=nint(val)
      if(linex(ix:jx).eq.'nfull')nfull=nint(val)
      if(linex(ix:jx).eq.'nfreeze')nfreeze=nint(val)
      if(linex(ix:jx).eq.'ninicon')ninicon=nint(val)
      if(linex(ix:jx).eq.'egymin' )egymin=sngl(val)
      if(linex(ix:jx).eq.'egymax' )egymax=sngl(val)
c       constants
      if(linex(ix:jx).eq.'ainfin')ainfin=sngl(val)
c       printout options
      if(linex(ix:jx).eq.'iprmpt')iprmpt=nint(val)
      if(linex(ix:jx).eq.  'ish' )ish=nint(val)
      if(linex(ix:jx).eq.'ishsub')ishsub=nint(val)
      if(linex(ix:jx).eq.'irandm')irandm=nint(val)
      if(linex(ix:jx).eq.'irewch')irewch=nint(val)
      if(linex(ix:jx).eq.'iecho ')iecho =nint(val)
      if(linex(ix:jx).eq.'modsho')modsho=nint(val)
      if(linex(ix:jx).eq.'idensi')idensi=nint(val)
      if(linex(ix:jx).eq.'ishevt')ishevt=nint(val)
      if(linex(ix:jx).eq.'iwseed')iwseed=nint(val)
c       fragmentation and decay
      if(linex(ix:jx).eq.'pud '  )pud   =sngl(val)
      if(linex(ix:jx).eq.'puds ' )puds   =sngl(val)
      if(linex(ix:jx).eq.'pdiqua')pdiqua=sngl(val)
      if(linex(ix:jx).eq.'ioptf ')ioptf =nint(val)
      if(linex(ix:jx).eq.'delrex')delrex=sngl(val)
      if(linex(ix:jx).eq.'ndecay')ndecay=nint(val)
      if(linex(ix:jx).eq.'maxres')maxres=nint(val)
      if(linex(ix:jx).eq.'pbreak')pbreak=sngl(val)
      if(linex(ix:jx).eq.'ptfknk')ptfknk=sngl(val)
      if(linex(ix:jx).eq.'aouni ')aouni=sngl(val)
c       lepton-nucleon and e+e-
      if(linex(ix:jx).eq.'iolept')iolept=nint(val)
      if(linex(ix:jx).eq.'ydmin')ydmin=sngl(val)
      if(linex(ix:jx).eq.'ydmax')ydmax=sngl(val)
      if(linex(ix:jx).eq.'qdmin')qdmin=sngl(val)
      if(linex(ix:jx).eq.'qdmax')qdmax=sngl(val)
      if(linex(ix:jx).eq.'themin')themin=sngl(val)
      if(linex(ix:jx).eq.'themax')themax=sngl(val)
      if(linex(ix:jx).eq.'elomin')elomin=sngl(val)
      if(linex(ix:jx).eq.'engy' )engy=sngl(val)
      if(linex(ix:jx).eq.'elab' )elab=sngl(val)
      if(linex(ix:jx).eq.'ekin' )ekin=sngl(val)
      if(linex(ix:jx).eq.'ecms' )ecms=sngl(val)
      if(linex(ix:jx).eq.'elepti')elepti=sngl(val)
      if(linex(ix:jx).eq.'elepto')elepto=sngl(val)
      if(linex(ix:jx).eq.'angmue')angmue=sngl(val)
      if(linex(ix:jx).eq.'noebin')noebin=nint(val)
      if(linex(ix:jx).eq.'engmin')engmin=sngl(val)
      if(linex(ix:jx).eq.'engmax')engmax=sngl(val)
      if(linex(ix:jx).eq.'iologe')iologe=nint(val)
      if(linex(ix:jx).eq.'iologl')iologl=nint(val)
      if(linex(ix:jx).eq.'itflav')itflav=nint(val)
      if(linex(ix:jx).eq.'idisco')idisco=nint(val)
c       hadron-hadron
      if(linex(ix:jx).eq. 'pnll' )pnll=sngl(val)
      if(linex(ix:jx).eq.'idproj')idproj=nint(val)
      if(linex(ix:jx).eq.'idtarg')idtarg=nint(val)
      if(linex(ix:jx).eq.'ptq   ')ptq   =sngl(val)
      if(linex(ix:jx).eq.'rstras')rstras=sngl(val)
      if(linex(ix:jx).eq.'wgtval')wgtval=sngl(val)
      if(linex(ix:jx).eq.'wgtsea')wgtsea=sngl(val)
      if(linex(ix:jx).eq.'wgtdiq')wgtdiq=sngl(val)
      if(linex(ix:jx).eq.'wgtqqq')wgtqqq=sngl(val)
      if(linex(ix:jx).eq.'wproj ')wproj =sngl(val)
      if(linex(ix:jx).eq.'wtarg ')wtarg =sngl(val)
      if(linex(ix:jx).eq.'wexcit')wexcit=sngl(val)
      if(linex(ix:jx).eq.'cutmsq')cutmsq=sngl(val)
      if(linex(ix:jx).eq.'cutmss')cutmss=sngl(val)
      if(linex(ix:jx).eq.'exmass')exmass=sngl(val)
      if(linex(ix:jx).eq.'iregge')iregge=nint(val)
      if(linex(ix:jx).eq.'isopom')isopom=nint(val)
      if(linex(ix:jx).eq.'ishpom')ishpom=nint(val)
      if(linex(ix:jx).eq.'iscreen')iscreen=nint(val)
      if(linex(ix:jx).eq.'iscreen')iscreeni=nint(val)
      if(linex(ix:jx).eq.'irmdrop')irmdrop=nint(val)
      if(linex(ix:jx).eq.'iremres')iremres=nint(val)
      if(linex(ix:jx).eq.'nprmax')nprmax=nint(val)
      if(linex(ix:jx).eq.'iemspl')iemspl=nint(val)
      if(linex(ix:jx).eq.'intpol')intpol=nint(val)
      if(linex(ix:jx).eq.'isigma')isigma=nint(val)
      if(linex(ix:jx).eq.'iomega')iomega=nint(val)
      if(linex(ix:jx).eq.'isetcs')isetcs=nint(val)
      if(linex(ix:jx).eq.'iemsb' )iemsb= nint(val)
      if(linex(ix:jx).eq.'iemspm')iemspm=nint(val)
      if(linex(ix:jx).eq.'iemspx')iemspx=nint(val)
      if(linex(ix:jx).eq.'iemsse')iemsse=nint(val)
      if(linex(ix:jx).eq.'iemsdr')iemsdr=nint(val)
      if(linex(ix:jx).eq.'iemsrx')iemsrx=nint(val)
      if(linex(ix:jx).eq.'iemsi2')iemsi2=nint(val)
      if(linex(ix:jx).eq.'iemsi1')iemsi1=nint(val)
      if(linex(ix:jx).eq.'ioems' )ioems= nint(val)
c       unified parameters
      if(linex(ix:jx).eq.'icdp'   )icdp=nint(val)
      if(linex(ix:jx).eq.'icdt'   )icdt=nint(val)
      if(linex(ix:jx).eq.'icdp1'  )icdp1=nint(val)
      if(linex(ix:jx).eq.'icdt1'  )icdt1=nint(val)
      if(linex(ix:jx).eq.'icdp2'  )icdp2=nint(val)
      if(linex(ix:jx).eq.'icdt2'  )icdt2=nint(val)
      if(linex(ix:jx).eq.'icdpl1' )icdpl1=nint(val)
      if(linex(ix:jx).eq.'icdtl1' )icdtl1=nint(val)
      if(linex(ix:jx).eq.'icdpl2' )icdpl2=nint(val)
      if(linex(ix:jx).eq.'icdtl2' )icdtl2=nint(val)
      if(linex(ix:jx).eq.'iclpro1')iclpro1=nint(val)
      if(linex(ix:jx).eq.'iclpro2')iclpro2=nint(val)
      if(linex(ix:jx).eq.'icltar1')icltar1=nint(val)
      if(linex(ix:jx).eq.'icltar2')icltar2=nint(val)
      if(linex(ix:jx).eq.'iclegy1')iclegy1=nint(val)
      if(linex(ix:jx).eq.'iclegy2')iclegy2=nint(val)
      if(linex(ix:jx).eq.'egylow')egylow=sngl(val)
      if(linex(ix:jx).eq.'egyfac')egyfac=sngl(val)
      if(linex(ix:jx).eq.'alppom')alppom=sngl(val)
      if(linex(ix:jx).eq.'gamhad(1)')stop'gamhad(1) not allowed'
      if(linex(ix:jx).eq.'gamhad(2)')gamhad(2)=sngl(val)
      if(linex(ix:jx).eq.'gamhad(3)')stop'gamhad(3) not allowed'
      if(linex(ix:jx).eq.'slopom')slopom=sngl(val)
      if(linex(ix:jx).eq.'r2had(1)' )r2had(1)= sngl(val)
      if(linex(ix:jx).eq.'r2had(2)' )r2had(2)= sngl(val)
      if(linex(ix:jx).eq.'r2had(3)' )r2had(3)= sngl(val)
      if(linex(ix:jx).eq.'r2had(4)' )r2had(4)= sngl(val)
      if(linex(ix:jx).eq.'r3pom'    )r3pom= sngl(val)
      if(linex(ix:jx).eq.'r4pom'    )r4pom= sngl(val)
      if(linex(ix:jx).eq.'Eseuil'   )Eseuil= sngl(val)
      if(linex(ix:jx).eq.'Esmax'    )Esmax= sngl(val)
      if(linex(ix:jx).eq.'epscr'    )epscr= sngl(val)
      if(linex(ix:jx).eq.'epscrp'   )epscrp= sngl(val)
      if(linex(ix:jx).eq.'chad(1)'  )chad(1)=  sngl(val)
      if(linex(ix:jx).eq.'chad(2)'  )chad(2)=  sngl(val)
      if(linex(ix:jx).eq.'chad(3)'  )chad(3)=  sngl(val)
      if(linex(ix:jx).eq.'chad(4)'  )chad(4)=  sngl(val)
      if(linex(ix:jx).eq.'wdiff(1)')wdiff(1)=sngl(val)
      if(linex(ix:jx).eq.'wdiff(2)')wdiff(2)=sngl(val)
      if(linex(ix:jx).eq.'wdiff(3)')wdiff(3)=sngl(val)
      if(linex(ix:jx).eq.'wdiff(4)')wdiff(4)=sngl(val)
      if(linex(ix:jx).eq.'rexndi(1)')rexndi(1)=sngl(val)
      if(linex(ix:jx).eq.'rexndi(2)')rexndi(2)=sngl(val)
      if(linex(ix:jx).eq.'rexndi(3)')rexndi(3)=sngl(val)
      if(linex(ix:jx).eq.'rexndi(4)')rexndi(4)=sngl(val)
      if(linex(ix:jx).eq.'rexres')rexres=sngl(val)
      if(linex(ix:jx).eq.'alpreg')alpreg=sngl(val)
      if(linex(ix:jx).eq.'sloreg')sloreg=sngl(val)
      if(linex(ix:jx).eq.'gamreg')gamreg=sngl(val)
      if(linex(ix:jx).eq.'r2reg' )r2reg= sngl(val)
      if(linex(ix:jx).eq.'ptdiff')ptdiff=sngl(val)
      if(linex(ix:jx).eq.'alppar')alppar=sngl(val)
      if(linex(ix:jx).eq.'alpsea')alpsea=sngl(val)
      if(linex(ix:jx).eq.'alpval')alpval=sngl(val)
      if(linex(ix:jx).eq.'alpdiq')alpdiq=sngl(val)
      if(linex(ix:jx).eq.'alplea(1)')alplea(1)=sngl(val)
      if(linex(ix:jx).eq.'alplea(2)')alplea(2)=sngl(val)
      if(linex(ix:jx).eq.'alplea(3)')alplea(3)=sngl(val)
      if(linex(ix:jx).eq.'alplea(4)')alplea(4)=sngl(val)
      if(linex(ix:jx).eq.'alpdif')alpdif=sngl(val)
      if(linex(ix:jx).eq.'alpndi')alpndi=sngl(val)
      if(linex(ix:jx).eq.'ammsqq')ammsqq=sngl(val)
      if(linex(ix:jx).eq.'ammsqd')ammsqd=sngl(val)
      if(linex(ix:jx).eq.'ammsdd')ammsdd=sngl(val)
      if(linex(ix:jx).eq.'cumpom')cumpom=sngl(val)
      if(linex(ix:jx).eq.'reminv')reminv=sngl(val)
      if(linex(ix:jx).eq.'ptsend')ptsend=sngl(val)
      if(linex(ix:jx).eq.'ptremn')ptremn=sngl(val)
      if(linex(ix:jx).eq.'alpdro(1)')alpdro(1)=sngl(val)
      if(linex(ix:jx).eq.'alpdro(2)')alpdro(2)=sngl(val)
      if(linex(ix:jx).eq.'alpdro(3)')alpdro(3)=sngl(val)
      if(linex(ix:jx).eq.'amdrmax')amdrmax=sngl(val)
      if(linex(ix:jx).eq.'iodiba')iodiba=nint(val)   
      if(linex(ix:jx).eq.'bidiba')bidiba=sngl(val)    
      
c       hard pomeron parameters
      if(linex(ix:jx).eq.'q2min' )q2min=sngl(val)
      if(linex(ix:jx).eq.'q2ini' )q2ini=sngl(val)
      if(linex(ix:jx).eq.'q2fin' )q2fin=sngl(val)
      if(linex(ix:jx).eq.'betpom')betpom=sngl(val)
      if(linex(ix:jx).eq.'glusea')glusea=sngl(val)
      if(linex(ix:jx).eq.'factk' )factk=sngl(val)
      if(linex(ix:jx).eq.'naflav')naflav=nint(val)
      if(linex(ix:jx).eq.'pt2cut')pt2cut=sngl(val)
      if(linex(ix:jx).eq.'factgam')factgam=sngl(val)
c       nucleus-nucleus
      if(linex(ix:jx).eq.'iokoll')iokoll=nint(val)
      if(linex(ix:jx).eq.'laproj')laproj=nint(val)
      if(linex(ix:jx).eq.'maproj')maproj=nint(val)
      if(linex(ix:jx).eq.'latarg')latarg=nint(val)
      if(linex(ix:jx).eq.'matarg')matarg=nint(val)
      if(linex(ix:jx).eq.'core'  )core  =sngl(val)
c      if(linex(ix:jx).eq.'ncolmx')ncolmx=nint(val)
      if(linex(ix:jx).eq.'fctrmx')fctrmx=sngl(val)
      if(linex(ix:jx).eq.'bmaxim')bmaxim=sngl(val)
      if(linex(ix:jx).eq.'bminim')bminim=sngl(val)
      if(linex(ix:jx).eq.'phimax')phimax=sngl(val)
      if(linex(ix:jx).eq.'phimin')phimin=sngl(val)
      if(linex(ix:jx).eq.'inueff')inueff=nint(val)
c       rescattering parameters
      if(linex(ix:jx).eq.'iorsce')iorsce=nint(val)
      if(linex(ix:jx).eq.'iorsdf')iorsdf=nint(val)
      if(linex(ix:jx).eq.'iorshh')iorshh=nint(val)
      if(linex(ix:jx).eq.'hacore')hacore=sngl(val)
      if(linex(ix:jx).eq.'amimfs')amimfs=sngl(val)
      if(linex(ix:jx).eq.'amimel')amimel=sngl(val)
      if(linex(ix:jx).eq.'cepara')cepara=sngl(val)
      if(linex(ix:jx).eq.'dscale')dscale=sngl(val)
      if(linex(ix:jx).eq.'iceopt')iceopt=nint(val)
      if(linex(ix:jx).eq.'delamf')delamf=sngl(val)
      if(linex(ix:jx).eq.'taurea')taurea=sngl(val)
      if(linex(ix:jx).eq.'epscri')epscri=sngl(val)
      if(linex(ix:jx).eq.'amsiac')amsiac=sngl(val)
      if(linex(ix:jx).eq.'amprif')amprif=sngl(val)
      if(linex(ix:jx).eq.'delvol')delvol=sngl(val)
      if(linex(ix:jx).eq.'deleps')deleps=sngl(val)
      if(linex(ix:jx).eq.'taumin')taumin=sngl(val)
      if(linex(ix:jx).eq.'deltau')deltau=sngl(val)
      if(linex(ix:jx).eq.'factau')factau=sngl(val)
      if(linex(ix:jx).eq.'numtau')numtau=nint(val)
      if(linex(ix:jx).eq.'dlzeta')dlzeta=sngl(val)
      if(linex(ix:jx).eq.'etafac')etafac=sngl(val)
      if(linex(ix:jx).eq.'facnuc')facnuc=sngl(val)
c       spherio
      if(linex(ix:jx).eq.'ispherio')ispherio=int(val)
      if(linex(ix:jx).eq.'icoop')  icoop=int(val)
      if(linex(ix:jx).eq.'icospec')icospec=int(val)
      if(linex(ix:jx).eq.'icoremn')icoremn=int(val)
      if(linex(ix:jx).eq.'icostrg')icostrg=int(val)
      if(linex(ix:jx).eq.'icotabm')icotabm=int(val)
      if(linex(ix:jx).eq.'icotabr')icotabr=int(val)
      if(linex(ix:jx).eq.'xminico')xminico=sngl(val)
      if(linex(ix:jx).eq.'xmaxico')xmaxico=sngl(val)
      if(linex(ix:jx).eq.'yminico')yminico=sngl(val)
      if(linex(ix:jx).eq.'ymaxico')ymaxico=sngl(val)
      if(linex(ix:jx).eq.'zminico')zminico=sngl(val)
      if(linex(ix:jx).eq.'zmaxico')zmaxico=sngl(val)
c       droplet decay
      if(linex(ix:jx).eq.'dezzer')dezzer=sngl(val)
      if(linex(ix:jx).eq.'amuseg')amuseg=sngl(val)
      if(linex(ix:jx).eq.'yradmx')yradmx=sngl(val)
      if(linex(ix:jx).eq.'bag4rt')bag4rt=sngl(val)
      if(linex(ix:jx).eq.'taunll')taunll=sngl(val)
c       droplet specification
      if(linex(ix:jx).eq. 'keu'  )keu=nint(val)
      if(linex(ix:jx).eq. 'ked'  )ked=nint(val)
      if(linex(ix:jx).eq. 'kes'  )kes=nint(val)
      if(linex(ix:jx).eq. 'kec'  )kec=nint(val)
      if(linex(ix:jx).eq. 'keb'  )keb=nint(val)
      if(linex(ix:jx).eq. 'ket'  )ket=nint(val)
      if(linex(ix:jx).eq. 'tecm' )tecm=sngl(val)
      if(linex(ix:jx).eq. 'volu' )volu=sngl(val)
      if(linex(ix:jx).eq. 'vrad' )vrad=sngl(val)
c       metropolis
      if(linex(ix:jx).eq.'iospec')iospec=nint(val)
      if(linex(ix:jx).eq.'iocova')iocova=nint(val)
      if(linex(ix:jx).eq.'iopair')iopair=nint(val)
      if(linex(ix:jx).eq.'iozero')iozero=nint(val)
      if(linex(ix:jx).eq.'ioflac')ioflac=nint(val)
      if(linex(ix:jx).eq.'iostat')iostat=nint(val)
      if(linex(ix:jx).eq.'ioinco')ioinco=nint(val)
      if(linex(ix:jx).eq.'iograc')iograc=nint(val)
      if(linex(ix:jx).eq.'epsgc' )epsgc=sngl(val)
      if(linex(ix:jx).eq.'iocite')iocite=nint(val)
      if(linex(ix:jx).eq.'ioceau')ioceau=nint(val)
      if(linex(ix:jx).eq.'iociau')iociau=nint(val)
      if(linex(ix:jx).eq.'ioinct')ioinct=nint(val)
      if(linex(ix:jx).eq.'ioinfl')ioinfl=nint(val)
      if(linex(ix:jx).eq.'iowidn')iowidn=nint(val)
      if(linex(ix:jx).eq.'ionlat')ionlat=nint(val)
      if(linex(ix:jx).eq.'iomom')iomom=nint(val)
      if(linex(ix:jx).eq.'ioobsv')ioobsv=nint(val)
      if(linex(ix:jx).eq.'iosngl')iosngl=nint(val)
      if(linex(ix:jx).eq.'iorejz')iorejz=nint(val)
      if(linex(ix:jx).eq.'iompar')iompar=nint(val)
      if(linex(ix:jx).eq.'iozinc')iozinc=nint(val)
      if(linex(ix:jx).eq.'iozevt')iozevt=nint(val)
      if(linex(ix:jx).eq. 'nadd' )nadd=nint(val)
      if(linex(ix:jx).eq.'iterma')iterma=nint(val)
      if(linex(ix:jx).eq.'itermx')stop'STOP: set iterma, not itermx'
      if(linex(ix:jx).eq.'iterpr')iterpr=nint(val)
      if(linex(ix:jx).eq.'iterpl')iterpl=nint(val)
      if(linex(ix:jx).eq.'iternc')iternc=nint(val)
      if(linex(ix:jx).eq.'epsr'  )epsr=sngl(val)
      if(linex(ix:jx).eq.'keepr' )keepr=nint(val)
c       strangelets
      if(linex(ix:jx).eq.'iopenu')iopenu=nint(val)
      if(linex(ix:jx).eq.'themas')themas=sngl(val)
c       jpsi
      if(linex(ix:jx).eq.'jpsi  ')jpsi  =nint(val)
      if(linex(ix:jx).eq.'jpsifi')jpsifi=nint(val)
      if(linex(ix:jx).eq.'sigj  ')sigj  =sngl(val)
      if(linex(ix:jx).eq.'taumx ')taumx =sngl(val)
      if(linex(ix:jx).eq.'nsttau')nsttau=nint(val)
      if(linex(ix:jx).eq.'ijphis')ijphis=nint(val)
c       analysis: intermittency, space-time, droplets, formation time
      if(linex(ix:jx).eq.'ymximi')ymximi=sngl(val)
      if(linex(ix:jx).eq.'imihis')imihis=nint(val)
      if(linex(ix:jx).eq.'isphis')isphis=nint(val)
      if(linex(ix:jx).eq.'iologb')iologb=nint(val)
      if(linex(ix:jx).eq.'ispall')ispall=nint(val)
      if(linex(ix:jx).eq.'wtmini')wtmini=sngl(val)
      if(linex(ix:jx).eq.'wtstep')wtstep=sngl(val)
      if(linex(ix:jx).eq.'iwcent')iwcent=nint(val)
      if(linex(ix:jx).eq.'iclhis')iclhis=nint(val)
      if(linex(ix:jx).eq.'iwtime')iwtime=nint(val)
      if(linex(ix:jx).eq.'wtimet')wtimet=sngl(val)
      if(linex(ix:jx).eq.'wtimei')wtimei=sngl(val)
      if(linex(ix:jx).eq.'wtimea')wtimea=sngl(val)
c       other
      if(linex(ix:jx).eq.'gaumx ')gaumx =sngl(val)
      if(linex(ix:jx).eq.'nclean')nclean=nint(val)
      if(linex(ix:jx).eq.'istore')istore=nint(val)
      if(linex(ix:jx).eq.'iframe')iframe=nint(val)
      if(linex(ix:jx).eq.'jframe')jframe=nint(val)
      if(linex(ix:jx).eq.'labsys')stop'labsys no longer supported'
      if(linex(ix:jx).eq.'irescl')irescl=nint(val)
      if(linex(ix:jx).eq.'ifrade')ifrade=nint(val)
      if(linex(ix:jx).eq.'ntrymx')ntrymx=nint(val)
      if(linex(ix:jx).eq.'istmax')istmax=nint(val)
      if(linex(ix:jx).eq.'iAGKch')iAGKch=nint(val)
      if(linex(ix:jx).eq.'ionucl')ionucl=nint(val)
      if(linex(ix:jx).eq.'seedi')seedi =val
      if(linex(ix:jx).eq.'seedj')seedj =val
      if(linex(ix:jx).eq.'xvaria')xvaria='      '
      if(linex(ix:jx).eq.'xvaria')xvaria(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'yvaria')yvaria='      '
      if(linex(ix:jx).eq.'yvaria')yvaria(1:j-i+1)=line(i:j)
      if(linex(ix:jx).eq.'normal')normal=nint(val)
      if(linex(ix:jx).eq.'xminim')xminim=sngl(val)
      if(linex(ix:jx).eq.'xmaxim')xmaxim=sngl(val)
      if(linex(ix:jx).eq.'nrbins')nrbins=nint(val)
      if(linex(ix:jx).eq.'hisfac')hisfac=sngl(val)
      if(linex(ix:jx).eq.'xshift')xshift=sngl(val)
      if(linex(ix:jx).eq.'etacut')etacut=sngl(val)
      if(linex(ix:jx).eq.'xpar1' )xpar1=sngl(val)
      if(linex(ix:jx).eq.'xpar2' )xpar2=sngl(val)
      if(linex(ix:jx).eq.'xpar3' )xpar3=sngl(val)
      if(linex(ix:jx).eq.'xpar4' )xpar4=sngl(val)
      if(linex(ix:jx).eq.'xpar5' )xpar5=sngl(val)
      if(linex(ix:jx).eq.'xpar6' )xpar6=sngl(val)
      if(linex(ix:jx).eq.'xpar7' )xpar7=sngl(val)
      if(linex(ix:jx).eq.'xpar8' )xpar8=sngl(val)
      if(linex(ix:jx).eq.'irdmpr')irdmpr=nint(val)
c       frame definitions      
      if(linex(ix:jx).eq.'engy'.and.iframe.eq.0)iframe=11
      if(linex(ix:jx).eq.'ecms'.and.iframe.eq.0)iframe=11
      if(linex(ix:jx).eq.'elab'.and.iframe.eq.0)iframe=12
      if(linex(ix:jx).eq.'ekin'.and.iframe.eq.0)iframe=12
      if(linex(ix:jx).eq.'pnll'.and.iframe.eq.0)iframe=12
      if(linex(ix:jx).eq.'noebin'.and.dabs(val-1.d0).gt.1.d-10)iframe=11

      
           elseif(line(i:j).eq.'setm')then       

           if(iappl.eq.1.or.iappl.eq.2)then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'nevent modsho pnll laproj maproj latarg matarg?'
      call utword(line,i,j,0)
      read(line(i:j),*)val
      nevent=nint(val)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'modsho pnll laproj maproj latarg matarg?'
      call utword(line,i,j,0)
      read(line(i:j),*)val
      modsho=nint(val)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'pnll laproj maproj latarg matarg?'
      call utword(line,i,j,0)
      read(line(i:j),*)val
      pnll=sngl(val)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'laproj maproj latarg matarg?'
      call utword(line,i,j,0)
      read(line(i:j),*)val
      laproj=nint(val)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'maproj latarg matarg?'      
      call utword(line,i,j,0)
      read(line(i:j),*)val
      maproj=nint(val)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'latarg matarg?'
      call utword(line,i,j,0)
      read(line(i:j),*)val
      latarg=nint(val)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'matarg?'
      call utword(line,i,j,0)
      read(line(i:j),*)val
      matarg=nint(val)

           elseif(iappl.eq.4)then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'tecm volu iterma iterpr iterpl iternc ish?'
      call utword(line,i,j,0)
      read(line(i:j),*)val
      tecm=sngl(val)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'volu iterma iterpr iterpl iternc ish?'       
      call utword(line,i,j,0)
      read(line(i:j),*)val
      volu=sngl(val)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'iterma iterpr iterpl iternc ish?'       
      call utword(line,i,j,0)
      read(line(i:j),*)val
      iterma=nint(val)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'iterpr iterpl iternc ish?'       
      call utword(line,i,j,0)
      read(line(i:j),*)val
      iterpr=nint(val)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'iterpl iternc ish?'
      call utword(line,i,j,0)
      read(line(i:j),*)val
      iterpl=nint(val)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'iternc ish?'       
      call utword(line,i,j,0)
      read(line(i:j),*)val
      iternc=nint(val)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'ish?'       
      call utword(line,i,j,0)
      read(line(i:j),*)val
      ish=nint(val)

           elseif(iappl.eq.7)then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'nevent modsho pnll idproj?'
      call utword(line,i,j,0)
      read(line(i:j),*)val
      nevent=nint(val)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'modsho pnll idproj?'
      call utword(line,i,j,0)
      read(line(i:j),*)val
      modsho=nint(val)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'pnll proj?'
      call utword(line,i,j,0)
      read(line(i:j),*)val
      pnll=sngl(val)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'idproj?'
      call utword(line,i,j,0)
      read(line(i:j),*)val
      idproj=nint(val)

           elseif(iappl.eq.0)then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'xvaria yvaria normal xminim xmaxim nrbins?'
      call utword(line,i,j,0)
      xvaria=line(i:i+5)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'yvaria normal xminim xmaxim nrbins?'       
      call utword(line,i,j,0)
      yvaria=line(i:i+5)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'normal xminim xmaxim nrbins?'       
      call utword(line,i,j,0)
      read(line(i:j),*)val
      normal=nint(val)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'xminim xmaxim nrbins?'       
      call utword(line,i,j,0)
      read(line(i:j),*)val
      xminim=sngl(val)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'xmaxim nrbins?'
      call utword(line,i,j,0)
      read(line(i:j),*)val
      xmaxim=sngl(val)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'nrbins?' 
      call utword(line,i,j,0)
      read(line(i:j),*)val
      nrbins=nint(val)
      
           else 

      stop'setm not defined for this application'

           endif

           elseif(line(i:j).eq.'show')then

      write(ifmt,'(77a1)')('-',l=1,77)
      write(ifmt,'(a)')
     *' iversn  iappl nevent'
      write(ifmt,'(3i7)')
     *iversn  ,iappl ,nevent
      write(ifmt,'(a,a)')
     *' iprmpt    ish ishsub irandm irewch',
     *' iecho modsho idensi'
      write(ifmt,'(8i7)')
     *iprmpt  ,ish ,ishsub ,irandm, irewch,
     *iecho ,modsho,idensi
      write(ifmt,'(77a1)')('-',l=1,77)

      write(ifmt,'(a,a)')
     *'    pud puds pdiqua ',
     *'  ioptf    ' 
      write(ifmt,'(3f7.3,i7)')
     *    pud , puds, pdiqua ,
     *  ioptf    
      write(ifmt,'(a,a)')
     *' delrex ndecay maxres'
      write(ifmt,'(f7.3,2i7)')
     * delrex ,ndecay ,maxres 
      write(ifmt,'(77a1)')('-',l=1,77)

      write(ifmt,'(a)')
     *'   engy elepti elepto angmue'
      write(ifmt,'(4f7.2)')
     *   engy ,elepti ,elepto ,angmue
      write(ifmt,'(77a1)')('-',l=1,77)

      write(ifmt,'(a,a)')
     *'   pnll idproj idtarg  ptq',
     *'   rstras  wproj'
      write(ifmt,'(f7.1,2i7,3f7.3)')
     *   pnll ,idproj ,idtarg  ,ptq,
     *   rstras  ,wproj
      write(ifmt,'(a,a)')
     *'  wtarg cutmsq cutmss exmass wexcit'
      write(ifmt,'(4f7.3,3f7.3)')
     *  wtarg ,cutmsq ,cutmss , exmass, wexcit
      write(ifmt,'(a)')
     *' ishpom'
      write(ifmt,'(i7)')
     * ishpom
      write(ifmt,'(a,a)')
     *' grigam grirsq gridel grislo gricel',
     *' sigppi'
      write(ifmt,'(6f7.3,i7)')
     * grigam ,grirsq ,gridel ,grislo ,gricel,
     * sigppi
      write(ifmt,'(77a1)')('-',l=1,77)

      write(ifmt,'(a,a)')
     *' laproj maproj latarg matarg   core',
     *' ncolmx fctrmx bmaxim bminim'
c     *' ncolmx fctrmx bmaxim bminim'
      write(ifmt,'(4i7,f7.3,i7,3f7.1)')
     * laproj ,maproj ,latarg ,matarg    ,core,
     * fctrmx ,bmaxim ,bminim
c     * ncolmx ,fctrmx ,bmaxim ,bminim
      write(ifmt,'(a)')' phimax phimin'
      write(ifmt,'(2f7.3)')phimax,phimin
      write(ifmt,'(a,a)')
     *' taurea ',
     *' epscri amsiac amprif delvol'
      write(ifmt,'(7f7.3,i7,2f7.2)')
     * taurea ,
     * epscri ,amsiac ,amprif ,delvol 
      write(ifmt,'(a)')
     *' deleps taumin deltau factau numtau etafac dlzeta'
      write(ifmt,'(4f7.3,i7,2f7.3)')
     * deleps ,taumin ,deltau ,factau ,numtau ,etafac ,dlzeta
      write(ifmt,'(a,a)')
     *' dezzer amuseg bag4rt ',
     *' taunll  '
      write(ifmt,'(3f7.3)')
     * dezzer, amuseg ,bag4rt
     * ,taunll  
      write(ifmt,'(a)')
     *'   tecm   volu    keu    ked    kes    kec    keb    ket'
      write(ifmt,'(2f7.1,6i7)')
     *tecm,volu,keu,ked,kes,kec,keb,ket
      write(ifmt,'(a,a)')
     *' iterma iterpr iterpl iternc iospec iocova iopair iozero ioflac' 
     *,'  iomom'
      write(ifmt,'(10i7)')
     *iterma,iterpr,iterpl,iternc,iospec,iocova,iopair,iozero,ioflac
     *,iomom
      write(ifmt,'(a)')
     *' iograc iocite ioceau iociau   nadd   epsr  keepr'       
      write(ifmt,'(5i7,f7.1,i7)')
     *iograc,iocite,ioceau,iociau,nadd,epsr,keepr
      write(ifmt,'(77a1)')('-',l=1,77)

      write(ifmt,'(a)')
     *' iopenu themas   jpsi jpsifi   sigj  taumx nsttau ijphis'      
      write(ifmt,'(i7,1x,f6.5,2i7,f7.3,f7.1,2i7)')
     * iopenu ,themas ,jpsi ,jpsifi  ,sigj  ,taumx ,nsttau ,ijphis
      write(ifmt,'(77a1)')('-',l=1,77)

      write(ifmt,'(a,a)')
     *' ymximi imihis isphis ispall wtmini wtstep ',
     *'iwcent iclhis'
      write(ifmt,'(f7.1,3i7,2f7.2,3i7)')
     * ymximi ,imihis ,isphis ,ispall ,wtmini ,wtstep ,iwcent ,iclhis
      write(ifmt,'(a)')
     *'iwtime wtimet wtimei wtimea'
      write(ifmt,'(i7,3f7.1)')
     *iwtime,wtimet,wtimei,wtimea
      write(ifmt,'(77a1)')('-',l=1,77)

      write(ifmt,'(a,a)')
     *'  gaumx nclean istore irescl ifrade',
     *' ntrymx istmax              seedi               seedj'
      write(ifmt,'(f7.2,6i7,f20.0,f20.0)')
     * gaumx,nclean,istore,irescl,ifrade,ntrymx,istmax
     *,seedi,seedj
      write(ifmt,'(77a1)')('-',l=1,77)

      write(ifmt,'(a,a)')' xvaria yvaria normal xminim xmaxim',
     *' nrbins hisfac'       
      write(ifmt,'(1x,a6,1x,a6,i7,2f7.1,i7,f7.3)')
     *xvaria,yvaria,normal,xminim,xmaxim,nrbins,hisfac
      write(ifmt,'(77a1)')('-',l=1,77)

           elseif(line(i:j).eq.'showa')then

      if(iappl.eq.1)then
      write(ifmt,'(77a1)')('-',l=1,77)
      write(ifmt,'(a)')
     *' nevent modsho   pnll laproj maproj latarg matarg idproj idtarg'
      write(ifmt,'(2i7,f7.1,6i7)')
     *nevent,modsho,pnll,laproj,maproj,latarg,matarg,idproj,idtarg
      write(ifmt,'(77a1)')('-',l=1,77)
      endif

      if(iappl.eq.4)then
      write(ifmt,'(77a1)')('-',l=1,77)
      write(ifmt,'(a)')
     *'   tecm   volu    keu    ked    kes    kec    keb    ket'
      write(ifmt,'(2f7.1,6i7)')
     *tecm,volu,keu,ked,kes,kec,keb,ket
      write(ifmt,'(a,a)')
     *' iterma iterpr iterpl iternc iospec iocova iopair iozero ioflac' 
     *,'  iomom'
      write(ifmt,'(10i7)')
     *iterma,iterpr,iterpl,iternc,iospec,iocova,iopair,iozero,ioflac
     *,iomom
      write(ifmt,'(77a1)')('-',l=1,77)
      endif

      if(iappl.eq.0)then
      write(ifmt,'(77a1)')('-',l=1,77)
      write(ifmt,'(a,a)')' xvaria yvaria normal xminim xmaxim',
     *' nrbins hisfac'       
      write(ifmt,'(1x,a6,1x,a6,i7,2f7.1,i7,f7.3)')
     *xvaria,yvaria,normal,xminim,xmaxim,nrbins,hisfac
      write(ifmt,'(77a1)')('-',l=1,77)
      endif

           elseif(line(i:j).eq.'stop')then

      close(unit=ifcx)
      close(unit=ifhi)
      close(unit=ifdt)
      stop

           elseif(line(i:j).eq.'EndNexusInput')then

      return

           elseif(line(i:j).eq.'string')then

      nstmax=nstmax+1
      ns=nstmax
      icinpu=0
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'string: prob icbac1 icbac2 icfor1 icfor2?' 
      call utword(line,i,j,0)
      read(line(i:j),*)val
      prob(ns)=sngl(val)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'string: icbac1 icbac2 icfor1 icfor2?' 
      call utword(line,i,j,0)
      read(line(i:j),*)val
      icbac(ns,1)=nint(val)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'string: icbac2 icfor1 icfor2?' 
      call utword(line,i,j,0)
      read(line(i:j),*)val
      icbac(ns,2)=nint(val)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'string: icfor1 icfor2?' 
      call utword(line,i,j,0)
      read(line(i:j),*)val
      icfor(ns,1)=nint(val)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'string: icfor2?' 
      call utword(line,i,j,0)
      read(line(i:j),*)val
      icfor(ns,2)=nint(val)

           elseif(line(i:j).eq.'kinks')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *     write(ifmt,'(a)')'kinks: icbac1 icbac2 icfor1 icfor2?' 
      call utword(line,i,j,0)
      read(line(i:j),*)val
      idptl(nptl+1)=nint(val)      
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *     write(ifmt,'(a)')'kinks: icbac2 icfor1 icfor2?' 
      call utword(line,i,j,0)
      read(line(i:j),*)val
      idback=nint(val)
      nrow=0
      nel=0
 10   call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *     write(6,'(a)')'<kinks-data (px-py-pz)>? (End=endkinks)'  
      call utword(line,i,j,0) 
      if(line(i:j).eq.'endkinks')then
         goto 12
      endif
      nel=nel+1
      nrow=1+(nel-1)/3
      nc=mod(nel-1,3)+1
      read(line(i:j),*)a
      if(nc.eq.1)pptl(1,nptl+nrow)=a
      if(nc.eq.2)pptl(2,nptl+nrow)=a
      if(nc.eq.3)then
        pptl(3,nptl+nrow)=a
        istptl(nptl+nrow)=20
        idptl(nptl+nrow+1)=9
        pptl(4,nptl+nrow)=sqrt(pptl(3,nptl+nrow)**2+pptl(2,nptl+nrow)**2
     $       +pptl(1,nptl+nrow)**2)
      endif
      goto10      
 12   continue
      idptl(nptl+nrow)=idback
      nptl=nptl+nrow

           elseif(line(i:j).eq.'record')then

      call utworn(line,j,ne)
c      if(ne.eq.0.and.iprmpt.gt.0)
c     *     write(ifmt,'(a)')'kinks: icbac1 icbac2 icfor1 icfor2?' 
      call utword(line,i,j,0)
      if(line(i:j).eq.'event')ir=1
      if(line(i:j).eq.'particle')ir=2
      maxrec(ir)=0
 20   call utworn(line,j,ne)
c      if(ne.eq.0.and.iprmpt.gt.0)
c     *     write(6,'(a)')'<kinks-data (px-py-pz)>? (End=endkinks)'  
      call utword(line,i,j,0) 
      if(line(i:j).eq.'endrecord')then
         goto 22
      endif
      maxrec(ir)=maxrec(ir)+1
      irecty(maxrec(ir),ir)=0
      if(ir.eq.1)then
        if(line(i:j).eq.'0') irecty(maxrec(ir),ir)=0
        if(line(i:j).eq.'nevt') irecty(maxrec(ir),ir)=1
        if(line(i:j).eq.'nptl') irecty(maxrec(ir),ir)=2
        if(line(i:j).eq.'b') irecty(maxrec(ir),ir)=3
        if(line(i:j).eq.'phi') irecty(maxrec(ir),ir)=4
        if(line(i:j).eq.'ncol') irecty(maxrec(ir),ir)=5
        if(line(i:j).eq.'pmx') irecty(maxrec(ir),ir)=6
        if(line(i:j).eq.'egy') irecty(maxrec(ir),ir)=7
        if(line(i:j).eq.'npj') irecty(maxrec(ir),ir)=8
        if(line(i:j).eq.'ntg') irecty(maxrec(ir),ir)=9
        if(line(i:j).eq.'npn') irecty(maxrec(ir),ir)=10
        if(line(i:j).eq.'npp') irecty(maxrec(ir),ir)=11
        if(line(i:j).eq.'ntn') irecty(maxrec(ir),ir)=12
        if(line(i:j).eq.'ntp') irecty(maxrec(ir),ir)=13
        if(line(i:j).eq.'jpn') irecty(maxrec(ir),ir)=14
        if(line(i:j).eq.'jpp') irecty(maxrec(ir),ir)=15
        if(line(i:j).eq.'jtn') irecty(maxrec(ir),ir)=16
        if(line(i:j).eq.'jtp') irecty(maxrec(ir),ir)=17
        if(line(i:j).eq.'amproj') irecty(maxrec(ir),ir)=20
        if(line(i:j).eq.'amtarg') irecty(maxrec(ir),ir)=21
      else
        if(line(i:j).eq.'0') irecty(maxrec(ir),ir)=0
        if(line(i:j).eq.'i') irecty(maxrec(ir),ir)=1
        if(line(i:j).eq.'id') irecty(maxrec(ir),ir)=2
        if(line(i:j).eq.'p1') irecty(maxrec(ir),ir)=3
        if(line(i:j).eq.'p2') irecty(maxrec(ir),ir)=4
        if(line(i:j).eq.'p3') irecty(maxrec(ir),ir)=5
        if(line(i:j).eq.'p4') irecty(maxrec(ir),ir)=6
        if(line(i:j).eq.'p5') irecty(maxrec(ir),ir)=7
        if(line(i:j).eq.'fa') irecty(maxrec(ir),ir)=8
        if(line(i:j).eq.'mo') irecty(maxrec(ir),ir)=9
        if(line(i:j).eq.'st') irecty(maxrec(ir),ir)=10
        if(line(i:j).eq.'x1') irecty(maxrec(ir),ir)=11
        if(line(i:j).eq.'x2') irecty(maxrec(ir),ir)=12
        if(line(i:j).eq.'x3') irecty(maxrec(ir),ir)=13
        if(line(i:j).eq.'x4') irecty(maxrec(ir),ir)=14
        if(line(i:j).eq.'idfa') irecty(maxrec(ir),ir)=15
        if(line(i:j).eq.'idmo') irecty(maxrec(ir),ir)=16
        if(line(i:j).eq.'p') irecty(maxrec(ir),ir)=17
        if(line(i:j).eq.'x') irecty(maxrec(ir),ir)=18
        if(line(i:j).eq.'dez') irecty(maxrec(ir),ir)=19
        if(line(i:j).eq.'rin') irecty(maxrec(ir),ir)=20
        if(line(i:j).eq.'c1') irecty(maxrec(ir),ir)=21
        if(line(i:j).eq.'c2') irecty(maxrec(ir),ir)=22
        if(line(i:j).eq.'ty') irecty(maxrec(ir),ir)=23
      endif
      if(irecty(maxrec(ir),ir).eq.0)then
        write(*,*) 'unknown variable ',line(i:j)
        stop
      endif
      goto 20      
 22   continue

           elseif(line(i:j).eq.'switch')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'option on/off?' 
      call utword(line,i,j,0)
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)write(ifmt,'(a)')'on/off?' 
        if(line(i:j).eq.'droplet')then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' )iorsdf=1
      if(line(i:j).eq.'off')iorsdf=0  
        elseif(line(i:j).eq.'cascade')then
      call utword(line,i,j,0)
c      if(line(i:j).eq.'on' )iorsce=1  
      if(line(i:j).eq.'on' )iorshh=1  
c      if(line(i:j).eq.'off')iorsce=0  
      if(line(i:j).eq.'off')iorshh=0  
        elseif(line(i:j).eq.'soft')then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' )isopom=1  
      if(line(i:j).eq.'off')isopom=0
        elseif(line(i:j).eq.'hard')then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' )ishpom=1 
      if(line(i:j).eq.'off')ishpom=0 
        elseif(line(i:j).eq.'triple')then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' )r3pom=r3pomi
      if(line(i:j).eq.'off')r3pom=1.E-5  
      if(line(i:j).eq.'on' )r4pom=r3pomi
      if(line(i:j).eq.'off')r4pom=1.E-5  
        elseif(line(i:j).eq.'spherio')then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' ) ispherio=1 
      if(line(i:j).eq.'off') ispherio=0 
        elseif(line(i:j).eq.'decay')then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' ) ndecay=0 
      if(line(i:j).eq.'off') ndecay=1 
        elseif(line(i:j).eq.'fragdecay')then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' ) ifrade=1 
      if(line(i:j).eq.'off') ifrade=0 
        elseif(line(i:j).eq.'icospec')then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' ) icospec=1 
      if(line(i:j).eq.'off') icospec=0 
        elseif(line(i:j).eq.'icoremn')then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' ) icoremn=1 
      if(line(i:j).eq.'off') icoremn=0 
        elseif(line(i:j).eq.'icostrg')then
      call utword(line,i,j,0)
      if(line(i:j).eq.'on' ) icostrg=1 
      if(line(i:j).eq.'off') icostrg=0 
        endif

           elseif(line(i:j).eq.'make')then

      call utword(line,i,j,0)
      if(line(i:j).eq.'icotable')icotabm=1
       
           elseif(line(i:j).eq.'read')then

      call utword(line,i,j,0)
      if(line(i:j).eq.'icotable')icotabr=1
       
           elseif(line(i:j).eq.'output')then

      call utword(line,i,j,0)
      if(line(i:j).eq.'nexus' )     istore=1
      if(line(i:j).eq.'osc1997a' )  istore=2
      if(line(i:j).eq.'osc1999a' )  istore=3
      if(line(i:j).eq.'ustore' )    istore=5

           elseif(line(i:j).eq.'trigger')then

      call utword(line,i,j,0)
      call utword(line,i,j,0)
      call utword(line,i,j,0)

           elseif(line(i:j).eq.'b')then

      nbarray=nbarray+1
      call utword(line,i,j,0)
      read(line(i:j),*)val
      barray(nbarray)=val       

           elseif(line(i:j).eq.'write')then

      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'text?' 
      call utword(line,i,j,0)
      if(nopen.eq.-1)then       !only write in second read for analysis 
       if(j-6.ge.i)then
      do l=i,j-6
      if(line(l:l+6).eq.'$iversn')
     *write(line(l:l+6),'(i1,a,i2,3x)')
     *int(iversn/100),'.',mod(iversn,100)
      enddo
        endif
        if(j-8.ge.i)then
      do l=i,j-8
      if(line(l:l+8).eq.'$xxxyield')then
      write(line(l:l+8),'(f8.6,1x)')yield
      endif
      if(line(l:l+7).eq.'$xxyield')then
      write(line(l:l+8),'(f7.5,1x)')yield
      endif
      if(line(l:l+6).eq.'$xyield')then
      write(line(l:l+8),'(f6.4,1x)')yield
      endif
      enddo
        endif
        if(j-5.ge.i)then
      do l=i,j-5
      if(line(l:l+5).eq.'$yield')then
      if(yield.lt.1.0)then
      write(line(l:l+5),'(f5.3,1x)')yield
      elseif(yield.lt.100.)then
      write(line(l:l+5),'(f5.2,1x)')yield
      elseif(yield.lt.1000.)then
      write(line(l:l+5),'(f5.1,1x)')yield
      elseif(yield.lt.10000.)then
      write(line(l:l+5),'(f6.1)')yield
      else
      write(line(l:l+5),'(i6)')nint(yield)
      endif
      endif
      enddo
      do l=i,j-5
      if(line(l:l+5).eq.'$sigma')then
      if(sigma.lt.1.0)then
      write(line(l:l+5),'(f5.3,1x)')sigma
      elseif(sigma.lt.100.)then
      write(line(l:l+5),'(f5.2,1x)')sigma
      elseif(sigma.lt.1000.)then
      write(line(l:l+5),'(f5.1,1x)')sigma
      elseif(sigma.lt.10000.)then
      write(line(l:l+5),'(f6.1)')sigma
      else
      write(line(l:l+5),'(i6)')nint(sigma)
      endif
      endif
      enddo
        endif
      write(ifhi,'(a)')line(i:j)
      endif

           elseif(line(i:j).eq.'nozero')then
      
      nozero=1

      elseif(line(i:j).eq.'writearray'
     $     .or.line(i:j).eq.'writehisto')then

      if(nopen.eq.-1)then
      ih=0
      if(line(i:j).eq.'writearray') ih=1
      call utworn(line,j,ne)
      if(ne.eq.0.and.iprmpt.gt.0)
     *write(ifmt,'(a)')'# of columns?' 
      call utword(line,i,j,0)
      ioint=0
      if(line(i:j).eq.'int')then
        ioint=1
        call utword(line,i,j,0)
      endif
      read(line(i:j),*)val
      nco=nint(val)
      if(ih.eq.1)write(ifhi,'(a,i3)')'array',nco
      if(ioint.eq.0)then
        do k=1,nrbins
	 iok=1
	 if(nco.eq.2)then
	   if(nozero.eq.1.and.ar(k,3).eq.0.)iok=0
	   if(iok.eq.1)write(ifhi,'(3e12.4)')ar(k,1),ar(k,3)
	 elseif(nco.eq.3)then
	   if(nozero.eq.1.and.ar(k,3).eq.0..and.ar(k,4).eq.0.)iok=0
	   if(iok.eq.1)write(ifhi,'(3e12.4)')ar(k,1),ar(k,3),ar(k,4)
	 endif
        enddo
      else
        sum=0.
        err2=0.
        do k=1,nrbins
          sum=sum+ar(k,3)*(ar(2,1)-ar(1,1))
          err2=err2+(ar(k,4)*(ar(2,1)-ar(1,1)))**2
          if(nco.eq.2)write(ifhi,'(3e12.4)')ar(k,1),sum
          if(nco.eq.3)write(ifhi,'(3e12.4)')ar(k,1),sum,sqrt(err2)
        enddo
      endif
      if(ih.eq.1)write(ifhi,'(a)')'  endarray'
      else
        call utword(line,i,j,0) !nopen .ge. 0 
      endif
      nozero=0

           else

      write(ifmt,'(a,a,a)')'command "',line(i:j),'" not found'
      j=160

           endif

      i=j+1
      goto 1

      end
 
c-----------------------------------------------------------------------
      subroutine aseed(modus)
c-----------------------------------------------------------------------

      include 'nexus.inc'
      double precision seedf
      call utpri('aseed ',ish,ishini,3)

      call ranfgt(seedf)
      if(iwseed.eq.1)then
        if(nrevt.eq.0)then
          write(ifmt,'(a,d27.16)')'seedf:',seedf
        elseif(mod(nrevt,modsho).eq.0)then
          if(modus.eq.1)
     *   write(ifmt,'(a,i10,10x,a,d27.16)')'nrevt:',nrevt,'seedf:',seedf
          if(modus.eq.2)
     *   write(ifmt,'(a,d27.16)')'seed:',seedf
        endif
      endif
      seedc=seedf

      call utprix('aseed ',ish,ishini,3)
      return
      end

c-----------------------------------------------------------------------
      subroutine aseedi
c-----------------------------------------------------------------------

      include 'nexus.inc'
      double precision seedini
      call utpri('aseedi',ish,ishini,3)

      call ranfgt(seedini)

      if(ish.ge.1)write(ifmt,'(a,d26.15)')'seedi:',seedini

      call utprix('aseedi',ish,ishini,3)
      return
      end

c$$$c-----------------------------------------------------------------------
c$$$        subroutine aseed(modus)        !Flush ????
c$$$c-----------------------------------------------------------------------
c$$$
c$$$      include 'nexus.inc'
c$$$      double precision seedf
c$$$      call utpri('aseed',ish,ishini,4)
c$$$
c$$$      call ranfgt(seedf)
c$$$      if(modus.eq.2)then
c$$$        write(ifmt,'(a,d26.15)')'seed:',seedf
c$$$      elseif(modus.eq.1)then
c$$$        if(mod(nrevt,modsho).eq.0)then
c$$$          write(ifmt,100)'nrevt:',nrevt,'seedf:',seedf
c$$$	  call flush(ifmt)
c$$$        endif
c$$$      endif
c$$$      seedc=seedf
c$$$
c$$$  100 format(a,i10,10x,a,d26.15)
c$$$      call utprix('aseed',ish,ishini,4)
c$$$      return
c$$$      end
c$$$
c-----------------------------------------------------------------------
      subroutine astat
c-----------------------------------------------------------------------

      include 'nexus.inc'
      common/testpom/antot,ansh,ansf,pp4max,pp4ini,andropl,anstrg0
     *,anstrg1,anreso0,anreso1,anghadr,antotre
      common/geom/rmproj,rmtarg,bmax,bkmx
      
      if(ish.ge.1.and.iappl.eq.1.)then
        if(abs(accept+reject).gt.1.e-5)write(ifmt,'(a,f9.5)')
     *'EMS acc.rate:',accept/(accept+reject)
        if(antot.ne.0.)write(ifmt,*)'soft,hard(%)'
     *                           ,ansf/antot*100.
     *                           ,ansh/antot*100.,' of' ,antot
        if(antotre.ne.0.)write(ifmt,*)
     *                  'droplet,string(+d),reson(+d), (had)(%) '
     *                           ,andropl/antotre*100.
     *                           ,anstrg0/antotre*100.
     *                           ,'(',anstrg1/antotre*100.,') '
     *                           ,anreso0/antotre*100.
     *                           ,'(',anreso1/antotre*100.,') '
     *             ,' (',anghadr/antotre*100.,')',' of' ,antotre
       if(pp4ini.gt.0.)write(ifmt,*)'Energy loss',(pp4ini-pp4max)/pp4ini
      endif

         if(ish.ge.1)then
      b1=bminim
      b2=amin1(bmax,bmaxim)
      a=pi*(b2**2-b1**2)
      write(ifmt,*)'cross section:',nevent/float(ntevt)*a*10
         endif

      if(iprmpt.le.0)goto1000
      
      write(ifmt,'(77a1)')('-',i=1,77)
      write(ifmt,'(a)')'statistics'
      write(ifmt,'(77a1)')('-',i=1,77)
      write(ifmt,'(a,i6,a)')'nr of messages:',imsg
     *,'    (written to file '//fnch(1:nfnch)//')'      
      write(ifmt,'(a,i8)')'maximum nptl:',nptlu
      write(ifmt,'(77a1)')('-',i=1,77)
 
1000  continue

      return
      end

c-----------------------------------------------------------------------
      subroutine atitle
c-----------------------------------------------------------------------

      include 'nexus.inc'
      
      write(ifmt,'(77a1/a1,2x,a,f5.2,a,1x,a1/77a1)')
     *('#',l=1,78),'neXus',iversn/100.
     *,' -- K.WERNER,M.HLADIK,S.OSTAPCHENKO,H.DRESCHER,T.PIEROG,FM.LIU'
     *,('#',l=1,78)    
      if(iversn.eq.iverso)return
      write(ifmt,100)
     *'#','WARNING: neXus',iversn/100.
     *               ,' is highly preliminary,'
     *               ,' to be used ONLY for technical','#'
     *,'#','studies, in collaboration with the author.','#'
     *,'#','physics results have no meaning whatsoever.'
     *,('#',l=1,78)  
  100 format(a1,2x,a,f5.2,a,a,1x,a1/a1,11x,a,22x,a1/a1,11x,a,21x,a1
     */77a1)      

      return
      end

c-----------------------------------------------------------------------
      subroutine avehep
c-----------------------------------------------------------------------

      include 'nexus.inc'

      call utpri('avehep',ish,ishini,4) 
 
      
      call utprix('avehep',ish,ishini,4)  
      end


c-----------------------------------------------------------------------
      subroutine anexus(nin)
c-----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incems'      
      double precision eppass,etpass
      common/emnpass/eppass(mamx,4),etpass(mamx,4)
      common/emsptl/nppr(npommx,kollmx),npproj(mamx),nptarg(mamx)
      common/testpom/antot,ansh,ansf,pp4max,pp4ini,andropl,anstrg0
     *,anstrg1,anreso0,anreso1,anghadr,antotre
      logical cont
      call utpri('anexus',ish,ishini,4)  

      if(ish.ge.2)then
      call alist('start event&',0,0)
      write(ifch,*)'event number:',nrevt+1
      endif
      
      if(iappl.eq.4)then
      call bnbody
      if(ish.ge.2)call alist('list before int/decays&',1,nptl)
      nevt=1
      nbdky=nptl
      call bjinta(ier)
      if(ier.eq.1)stop'error in bjinta'
      if(ish.ge.2)call alist('list after int/decays&',1,nptl)
      goto1000
      endif
      
      ntry=0
      cont=.true.
      if(nin.le.1)bimevt=-1
      ntevt0=ntevt
 3    ntevt=ntevt0
 2    if(cont)ntevt=ntevt+1
      iret=0
      ntry=ntry+1
      if(iappl.eq.1.or.iappl.eq.2)naevt=naevt+1
 5    nevt=0
      nptl=0
      
      if(iappl.eq.1.or.iappl.eq.2)then !---hadron---geometry---
      if(ntry.lt.10000.and.engy.ge.egymin)then    !if no inel scattering -> nothing !
        call emsaaa(iret)           !nexus
        if(iret.eq.2)cont=.false.
        if(iret.gt.0)goto2
      else
        ntevt=ntevt0+1
        iret=0
        nevt=1
      endif
      if(iappl.eq.2)nevt=1
      if(iappl.eq.2)goto1000  

      elseif(iappl.eq.3) then 
        call bread
        if(ish.ge.2)call alist('list after reading&',1,nptl)
        goto 1000
      elseif(iappl.eq.5) then !---kinky---
        i=1
        do while (istptl(i).eq.21.or.istptl(i).eq.20)
          nptl=i
          istptl(nptl)=20
          i=i+1
        enddo
        nevt=1

      elseif(iappl.eq.6)then !---ee---

        call timann
        nevt=1
      
      elseif(iappl.eq.7)then !---decay---

        call conwr
        nevt=1
      
      elseif(iappl.eq.8)then !---lepton---

        call psadis(iret)
        if(iret.gt.0)goto5
        nevt=1

      endif

      if(nevt.eq.0)stop'************ should not be ***************'

      if(ish.ge.2)call alist('list before fragmentation&',1,nptl)
c      nptlx=nptl+1

      if(iappl.ne.2.and.iappl.ne.7.and.nevt.eq.1.and.ifrade.ne.0)then
        call gakfra()
        if(ish.ge.2)call alist('list after fragmentation&',1,nptl)
        if(irescl.eq.1)then
          call utresc(iret)
          if(ish.ge.2)call alist('list after rescaling&',1,nptl)
          if(iret.gt.0)goto 2
        endif
c       nptlx=nptl+1
      endif

      if(irescl.eq.1.and.ispherio.eq.1)then
        call utrsph(iret)
        if(iret.gt.0)goto 2
      endif



      if(iappl.ne.2.and.nevt.eq.1)then
        nbdky=nptl
        call bjinta(ier)
        if(ier.eq.1)goto3
        if(ish.ge.1)then
          if(ish.ge.2.and.ifrade.ne.0)
     &    call alist('list after int/decays&',1,nptl)
          if(iappl.eq.1)then
            numbar=0
            pp4=0.
            do j=1,nptl
              if(istptl(j).eq.0)then
             if(idptl(j).gt. 1000.and.idptl(j).lt. 10000)numbar=numbar+1
             if(idptl(j).lt.-1000.and.idptl(j).gt.-10000)numbar=numbar-1
             if((((idptl(j).eq.1120.or.idptl(j).eq.1220)
     *           .and.idproj.gt.1000).or.(iabs(idptl(j)).gt.100
     *           .and.idproj.lt.1000)).and.pptl(4,j)
     *           .gt.pp4.and.pptl(3,j).gt.0.)pp4=pptl(4,j)
              endif 
            enddo
            pp4max=pp4max+pp4
            pp4ini=pp4ini+pptl(4,1)
            nvio=isign(matarg,idtarg)-numbar
            if(iabs(idproj).gt.1000)nvio=nvio+isign(maproj,idproj)
            if(ish.ge.2)write (ifch,*)'- Baryon number conservation : '
     &                  ,nvio,' -'

          endif
        endif
      endif

      
      if((iappl.eq.1.or.iappl.eq.2).and.nevt.eq.0)then
        if(nin.le.1)bimevt=-1
        goto2
      endif

      if(ifrade.ne.0.and.iappl.eq.2.and.
     $     idproj.eq.1120.and.idtarg.eq.1120)then
       numbar=0
       do j=1,nptl
        if(istptl(j).eq.0)then
         if(idptl(j).gt. 1000.and.idptl(j).lt. 10000)numbar=numbar+1
         if(idptl(j).lt.-1000.and.idptl(j).gt.-10000)numbar=numbar-1
        endif 
       enddo
       nvio=maproj+matarg-numbar
       if(nvio.ne.0)then
        call alist('complete list&',1,nptl)
        write(6,'(//10x,a,i3//)')'ERROR: baryon number violation:',nvio
        write(6,'(10x,a//)')
     *        'a complete list has been printed into the check-file'
        stop
       endif 
      endif

     
      ifirst=0
      if(nrevt+1.eq.1)ifirst=1
      if(jpsi.gt.0)then                 
        npjpsi=0
        do i=1,jpsi
          call jpsifo(npjpsi)
          call jpsian(ifirst)
        enddo
        if(ish.ge.1)call jtauan(0,0)
        if(nrevt+1.eq.nevent)call jpsihi 
      endif
      
      if(ixtau.eq.1)call xtauev(1)

      if(jerr.gt.0)call utstop('anexus: jerr > 0&')

1000  continue
      if(iabs(nin).eq.iabs(ninicon))nrevt=nrevt+1
      call utprix('anexus',ish,ishini,4)
      return
      end

c-----------------------------------------------------------------------
      subroutine emsaaa(iret)
c-----------------------------------------------------------------------
c  basic EMS routine to determine Pomeron configuration
c-----------------------------------------------------------------------

      include 'nexus.inc'
      common/col3/ncol,kolpt

      call utpri('emsaaa',ish,ishini,4)
      if(ish.ge.3)call alist('Determine Pomeron Configuration&',0,0)

      iret=0

1     nptl=0
      call conaa(iret)
      if(iret.gt.0)goto 1001   !no interaction
      call conre
      call conwr
      call gtildepar(iret)
      call integom1(iret)   
      call emsaa(iret)
      if(iret.gt.0)goto 1    !redo
      if(ncol.eq.0)goto 1001 !no interaction

1000  call utprix('emsaaa',ish,ishini,4)
      return

1001  iret=1 
      goto 1000 

      end

c---------------------------------------------------------------------- 
      subroutine alist(text,n1,n2)
c---------------------------------------------------------------------- 
      include 'nexus.inc'
      parameter(itext=40)
      character  text*40
      dimension pp(5),erest(5)
      if(n1.gt.n2)return
      imax=itext+1
      do i=itext,1,-1
      if(text(i:i).eq.'&')imax=i
      enddo
      if(imax.gt.1)then
      write(ifch,'(/1x,75a1/1x,a,a,a,70a1)')
     *('#',k=1,75),'#############  ',text(1:imax-1),'  '
     *,('#',k=1,59-imax)
      write(ifch,'(1x,75a1/)')('#',k=1,75)
      endif
      if(n1.eq.0.and.n2.eq.0)return
      if(imax.gt.1)then
      write(ifch,'(1x,a,a,a/1x,118a1)')
     *'  ior  jor       i    ifr1  ifr2         id ist ity',
     *'            px         py         pz         p0       mass',
     *'       rap'
     *,('-',k=1,118)
      endif

      do j=1,5
        pp(j)=0.
      enddo
      nqu=0
      nqd=0
      nqs=0
      nqup=0
      nqdp=0
      nqsp=0
      nqut=0
      nqdt=0
      nqst=0
      do i=n1,n2
        amtptl=pptl(1,i)**2.+pptl(2,i)**2.+pptl(5,i)**2.
        if(amtptl.le.0.d0)then
          if(idptl(i).lt.10000)then
            call idmass(idptl(i),amtptl)
          endif
          amtptl=sqrt(amtptl*amtptl+pptl(1,i)**2.+pptl(2,i)**2.)
        else
          amtptl=sqrt(amtptl)
        endif
        rap=0.
        if(amtptl.gt.0.d0.and.pptl(4,i).gt.0.)
     &  rap=sign(1.,pptl(3,i))*alog((pptl(4,i)+abs(pptl(3,i)))/amtptl)
        write(ifch,125)iorptl(i),jorptl(i),i,ifrptl(1,i),ifrptl(2,i)
     &       ,idptl(i),istptl(i),ityptl(i),(pptl(j,i),j=1,5),rap
c     &,(xorptl(j,i),j=1,4)
        if(mod(istptl(i),10).eq.0.and.n1.eq.1.and.n2.eq.nptl)then 
          do j=1,4
            pp(j)=pp(j)+pptl(j,i)
          enddo
          if(istptl(i).ne.40.and.istptl(i).ne.30)then
            call idqufl(i,idptl(i),ifl1,ifl2,ifl3)
            nqu=nqu+ifl1
            nqd=nqd+ifl2
            nqs=nqs+ifl3
          endif
        endif
      enddo
 125  format (1x,i5,i5,3x,i5,3x,i5,i5,i12,2i4,4x,5(e10.4,1x)
     *     ,f9.2,4x,4(e8.2,1x))
 126  format (51x,5(e10.4,1x))
 128  format (51x,65('-'))
      pp(5)=sqrt(pp(4)**2-pp(3)**2-pp(2)**2-pp(1)**2)
      if(n1.ne.n2)write (ifch,128) 
      if(n1.ne.n2)write (ifch,126) (pp(i),i=1,5) 
      if(n1.eq.1.and.n2.eq.nptl)then
        erest(1)=0.
        erest(2)=0.
        erest(3)=0.
        erest(4)=0.
        erest(5)=0.
        if(ispherio.eq.1.and.idproj.eq.1120.and.idtarg.eq.1120)then
          call idmass(1120,amsp)
          call idmass(1220,amsn)
          do i=1,laproj
              erest(3)=erest(3)+pnullx
              erest(4)=erest(4)+sqrt(pnullx**2+amsp**2)
          enddo
          do i=1,maproj-laproj
              erest(3)=erest(3)+pnullx
              erest(4)=erest(4)+sqrt(pnullx**2+amsn**2)
          enddo
          do i=1,latarg
              erest(3)=erest(3)-pnullx
              erest(4)=erest(4)+sqrt(pnullx**2+amsp**2)
          enddo
          do i=1,matarg-latarg
              erest(3)=erest(3)-pnullx
              erest(4)=erest(4)+sqrt(pnullx**2+amsn**2)
          enddo
       else
          do i=1,iabs(maproj)+iabs(matarg)
            do j=1,4
              erest(j)=erest(j)+pptl(j,i)
            enddo
          enddo
        endif
        erest(5)=sqrt(erest(4)**2-erest(3)**2
     $       -erest(2)**2-erest(1)**2)
        write (ifch,129)  (erest(j),j=1,5)
 129    format (50x,'(',5(e10.4,1x),')')
         if(idproj.eq.1120)then
          nqup=iabs(laproj)*2+(maproj-iabs(laproj))
          nqdp=iabs(laproj)+(maproj-iabs(laproj))*2
        else
          call idqufl(1,idproj,nqup,nqdp,nqsp)
        endif
        if(idtarg.eq.1120)then
          nqut=iabs(latarg)*2+(matarg-iabs(latarg))
          nqdt=iabs(latarg)+(matarg-iabs(latarg))*2
        else
          call idqufl(2,idtarg,nqut,nqdt,nqst)
        endif
        nqu=nqu-nqup-nqut    
        nqd=nqd-nqdp-nqdt    
        nqs=nqs-nqsp-nqst    
       write(ifch,*)'Quark number conservation (u,d,s) :',nqu,nqd,nqs
      endif
      end

c---------------------------------------------------------------------- 
      subroutine alist2(text,n1,n2,n3,n4)
c---------------------------------------------------------------------- 
      include 'nexus.inc'
      parameter(itext=40)
      character  text*40 
      if(n1.gt.n2)return
      imax=itext+1
      do i=itext,1,-1
      if(text(i:i).eq.'&')imax=i
      enddo
      write(ifch,'(1x,a,a,a)')
     *'--------------- ',text(1:imax-1),' ---------------  '
      do i=n1,n2
      write(ifch,125)iorptl(i),jorptl(i),i,ifrptl(1,i),ifrptl(2,i)
     &,idptl(i),istptl(i),ityptl(i),(pptl(j,i),j=1,5)
c     &,(xorptl(j,i),j=1,4)
      enddo
      write(ifch,'(1x,a)')'----->'
      do i=n3,n4
      write(ifch,125)iorptl(i),jorptl(i),i,ifrptl(1,i),ifrptl(2,i)
     &,idptl(i),istptl(i),ityptl(i),(pptl(j,i),j=1,5)
c     &,(xorptl(j,i),j=1,4)
      enddo
 125  format (1x,i4,i4,3x,i4,3x,i4,i4,i12,2i4,4x,5(e8.2,1x))
c     *,4x,4(e8.2,1x))
      end

c---------------------------------------------------------------------- 
      subroutine alistc(text,n1,n2)
c---------------------------------------------------------------------- 
      include 'nexus.inc'
      parameter(itext=40)
      character  text*40 
      if(n1.gt.n2)return
      imax=itext+1
      do i=itext,1,-1
      if(text(i:i).eq.'&')imax=i
      enddo
      if(n1.ne.n2)write(ifch,'(1x,a,a,a)')
     *'--------------- ',text(1:imax-1),' ---------------  '
      do i=n1,n2
      write(ifch,130)iorptl(i),jorptl(i),i,ifrptl(1,i),ifrptl(2,i)
     &,idptl(i),istptl(i),ityptl(i),(pptl(j,i),j=1,5)
     &,(xorptl(j,i),j=1,4),tivptl(1,i),tivptl(2,i)
      enddo
 130  format (1x,i4,i4,3x,i4,3x,i4,i4,i12,2i4,4x,5(e8.2,1x)
     *,4x,6(e8.2,1x))
      end

