c-----------------------------------------------------------------------
      subroutine conaa(iret)
c-----------------------------------------------------------------------
c  determines interaction configuration
c-----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incems'
      include 'nexus.incsem'
      
      common/geom/rmproj,rmtarg,bmax,bkmx
      common/geom3/b2kmx
      common/nucl3/phi,bimp
      common /cncl/xproj(mamx),yproj(mamx),zproj(mamx)
     *            ,xtarg(mamx),ytarg(mamx),ztarg(mamx)
      common/cncl2/diffbpr(mamx,mamx),diffbtg(mamx,mamx)
      common/cncl3/iactpr(mamx),iacttg(mamx)
      common/cfacmss/facmss

      call utpri('conaa ',ish,ishini,4)  

      iret=0

c     initialisations
c     ---------------

      vel=tanh(ypjtl-yhaha)+tanh(yhaha)
 
c     determine phi, bimp, coll, iproj, itarg, x/y/zproj, x/y/ztarg
c     ---------------------------------------------------------------

           if(iokoll.eq.1)then
           
      koll=matarg
      do k=1,koll
        do n=1,4
          coord(n,k)=0.
        enddo
      enddo
      bimp=0
      phi=0
      do k=1,koll
      bij=bkmx*sqrt(rangen())
      bk(k)=bij
      iproj(k)=1
      itarg(k)=k
      enddo
      xproj(1)=0
      yproj(1)=0
      zproj(1)=0
      do k=1,koll
      phi=2.*pi*rangen()
      xtarg(k)=bij*cos(phi)
      ytarg(k)=bij*sin(phi)
      ztarg(k)=0
      enddo
      lproj(1)=koll
      do k=1,koll
      ltarg(k)=1
      kproj(1,k)=k
      ktarg(k,1)=k
      enddo
      
           elseif(maproj.eq.1.and.matarg.eq.1)then
           
      b1=bminim
      b2=amin1(bkmx,bmaxim)
      if(b1.gt.b2)call utstop('conaa: bmin > bmax&')
      bimp=sqrt(b1*b1+(b2*b2-b1*b1)*rangen())
      koll=1
      do k=1,koll
        do n=1,4
          coord(n,k)=0.
        enddo
      enddo
      bk(1)=bimp
      iproj(1)=1
      itarg(1)=1
      phi=2.*pi*rangen()
      xproj(1)=bimp*cos(phi)
      yproj(1)=bimp*sin(phi)
      zproj(1)=0
      xtarg(1)=0
      ytarg(1)=0
      ztarg(1)=0
      lproj(1)=1
      ltarg(1)=1
      kproj(1,1)=1
      ktarg(1,1)=1
      iactpr(1)=int(rangen()+1./chad(iclpro)) !active proj.
      iacttg(1)=int(rangen()+1./chad(icltar)) !active targ.
      if(iactpr(1).eq.0.and.iacttg(1).eq.0)iret=-1

           else
             
      call conxyz('p',mamx,xproj,yproj,zproj,ypjtl-yhaha)
      call conxyz('t',mamx,xtarg,ytarg,ztarg,yhaha)

      bx=0
      by=0
      if(maproj.gt.0)then
      if(bimevt.lt.0)then
        b1=bminim
        b2=amin1(rmproj+rmtarg,bmaxim)
        if(b1.gt.b2)call utstop('conaa: bmin > bmax&')
        bimp=sqrt(b1**2+(b2**2-b1**2)*rangen())
        if(nbarray.gt.0)bimp=barray(mod(nrevt,nbarray)+1)
        if(jpsi.gt.0)then
          bimp=b1+(b2-b1)*(float(mod(nrevt,12))+rangen())/12.
          bimevt=bimp
        endif
        phi=phimin+rangen()*(phimax-phimin)
      else
        phi=phievt
        bimp=bimevt
      endif
      bx=cos(phi)*bimp
      by=sin(phi)*bimp
      endif
      if(jpsi.lt.0)then !modify b
        bx=xtarg(1)
        by=ytarg(1)
      endif
      if(maproj.eq.0)goto1000
      wactv=1./chad(2)              !probability to be "active"
      koll=0
      do i=1,maproj
      lproj(i)=0
      lproj3(i)=0
      iactpr(i)=int(rangen()+wactv) !active proj. nucleons
      enddo
      do j=1,matarg
      ltarg(j)=0
      ltarg3(j)=0
      iacttg(j)=int(rangen()+wactv) !active targ. nucleons
      enddo
      do 12 i=1,maproj
      if(iactpr(i).eq.0)goto 12
      do 11 j=1,matarg
      if(iacttg(j).eq.0)goto 11
      if(jpsi.lt.0.and.ztarg(j).le.ztarg(1))goto11
      bij=sqrt((xproj(i)+bx-xtarg(j))**2+(yproj(i)+by-ytarg(j))**2)
      if(ish.ge.7)write(ifch,*)'i_p:',i,' i_t:',j,' b_ij:',bij
      if(bij.gt.bkmx)goto11                

      koll=koll+1
      if(koll.gt.kollmx)call utstop('conaa: kollmx too small&')
      bk(koll)=bij
      bkx(koll)=xproj(i)+bx-xtarg(j)
      bky(koll)=yproj(i)+by-ytarg(j)
      iproj(koll)=i
      itarg(koll)=j
      lproj(i)=lproj(i)+1
      ltarg(j)=ltarg(j)+1
      kproj(i,lproj(i))=koll
      ktarg(j,ltarg(j))=koll

      if(bij.gt.b2kmx)goto11                
      lproj3(i)=lproj3(i)+1
      ltarg3(j)=ltarg3(j)+1
      kproj3(i,lproj3(i))=koll
      ktarg3(j,ltarg3(j))=koll
      

11    continue
12    continue

      do k=1,koll
        do n=1,4
          coord(n,k)=0.
        enddo
      enddo

      if(((iactpr(1).eq.0.and.maproj.eq.1)
     &.or.(iacttg(1).eq.0.and.matarg.eq.1))
     &.and.iret.eq.0)iret=-1

           endif

      if(ish.ge.3)write(ifch,*)'koll=',koll
      if(koll.eq.0)goto 1001

c     determine diffr. components
c     -------------------------- 
        if(icdp1.eq.icdp2)then
          do i1=1,maproj
            icddp(i1)=icdp1
          enddo
        else
          do i1=1,maproj
            icddp(i1)=int(ccproj(2,iclpro)+rangen())+1
          enddo
        endif
        if(icdt1.eq.icdt2)then
          do i1=1,matarg
            icddt(i1)=icdt2
          enddo
        else
          do i1=1,matarg
            icddt(i1)=int(cctarg(2,icltar)+rangen())+1
          enddo
        endif


c     determine coord
c     --------------- 
      do kl=1,koll
      i=iproj(kl)
      j=itarg(kl)
      dist=ztarg(j)-zproj(i)
      coord(1,kl)=(xproj(i)+xtarg(j))*0.5
      coord(2,kl)=(yproj(i)+ytarg(j))*0.5
      coord(3,kl)=(zproj(i)+ztarg(j))*0.5
      coord(4,kl)=dist/vel
      enddo
      
c     determine diffbpr, diffbtg
c     -------------------------- 
      do i2=1,maproj
      do i1=1,maproj
      diffbpr(i1,i2)=
     *sqrt((xproj(i1)-xproj(i2))*(xproj(i1)-xproj(i2))
     *    +(yproj(i1)-yproj(i2))*(yproj(i1)-yproj(i2)))
      enddo
      enddo
      do i1=1,matarg
      do i2=1,matarg
      diffbtg(i2,i1)=
     *sqrt((xtarg(i1)-xtarg(i2))*(xtarg(i1)-xtarg(i2))
     *    +(ytarg(i1)-ytarg(i2))*(ytarg(i1)-ytarg(i2)))
      enddo
      enddo

       
c     exit
c     ----
1000  continue
      if(ish.ge.5)then
      write(ifch,*)'ia,x/y/zproj:'
      do mm=1,maproj
      write(ifch,*)mm,iactpr(mm),xproj(mm),yproj(mm),zproj(mm)
      enddo
      write(ifch,*)'ia,x/y/ztarg:'
      do mm=1,matarg
      write(ifch,*)mm,iacttg(mm),xtarg(mm),ytarg(mm),ztarg(mm)
      enddo
      write(ifch,*)'iret',iret
      endif
      call utprix('conaa ',ish,ishini,4)
      return

1001  continue !iret=1 causes redo of whole collision
      iret=1
      if(ish.ge.3)then
      write(ifch,*)
      write(ifch,*)'***** subroutine conaa:'
      write(ifch,*)'***** no nucleon pair found --> no interaction'
      write(ifch,*)
      endif
      goto 1000

      end

c-----------------------------------------------------------------------
      function conbmx()
c-----------------------------------------------------------------------
      double precision dcel,om1intbc,p,eps
      common /ems3/dcel,ad
      include 'nexus.inc'
      include 'nexus.incsem'

      conbmx=0.
      b1=0.
      b2=7.
      eps=5.0d-3
      if(om1intbc(b1).lt.eps)return

10    b=b1+.5*(b2-b1)

      p=(1.d0-dexp(-om1intbc(b)))

      if(p.gt.eps)then
       if(p.gt.2.d0*eps)then
        b1=b
       else
        conbmx=b
       return
       endif
      else
       if(p.lt.eps/5.d0)then
        b2=b
       else
        conbmx=b
        return
       endif
      endif

      goto10

      end

c-----------------------------------------------------------------------
      function conb2mx()
c-----------------------------------------------------------------------
      double precision dcel,om3intbc,p,eps
      common /ems3/dcel,ad
      common/geom3/b2kmx
      include 'nexus.inc'
      include 'nexus.incsem'
      b1=0.
      b2=7.
      eps=5.0d-3

10    b=b1+.5*(b2-b1)

      p=(1.d0-dexp(-om3intbc(b,b,b,1)))

c      write(*,*)'conb2mx',p,b,om3intbc(b,b,b,1),b1,b2

      if(p.gt.eps.and.b.gt.0.)then
       if(p.gt.2.d0*eps)then
        b1=b
       else
        conb2mx=b
       return
       endif
      elseif(b.gt.0.)then
       if(p.lt.eps/5.d0)then
        b2=b
       else
        conb2mx=b
        return
       endif
      else
         conb2mx=0.
         return
      endif

      goto10

      end


c-----------------------------------------------------------------------
      subroutine conre
c-----------------------------------------------------------------------
c  initializes remnants 
c-----------------------------------------------------------------------
      include "nexus.incems"
      common/files/ifop,ifmt,ifch,ifcx,ifhi,ifdt,ifcp
      common/prnt1/iprmpt,ish,ishsub,irandm,irewch,iecho,modsho,idensi
      common/nucl1/laproj,maproj,latarg,matarg,core,fctrmx
      common/hadr2/iomodl,idproj,idtarg,wexcit
      common/chadron/amproj,amtarg,ypjtl,yhaha,pnullx
      common/remn/icproj(2,mamx),ictarg(2,mamx)

      call utpri('conre ',ish,ishini,6)

c     proj
c     ----
      la=laproj
      ma=iabs(maproj)
      las=0
      mas=0
      do l=1,ma
      if(la.lt.0)then
      ia=iabs(idproj/10)
      is=idproj/iabs(idproj)
      if(ia.ne.111.and.ia.ne.222.and.ia.ne.333)id=idproj/10*10
      if(ia.eq.111.or. ia.eq.222.or. ia.eq.333)id=idproj/10*10+is
      if(ia.eq.213)id=1230*is
      if(iabs(idproj).lt.20)id=idproj
      else
      id=1220
      if(rangen().le.(la-las)*1./(ma-mas))id=1120
      if(id.eq.1120)las=las+1
      mas=mas+1
      endif
      ic1=idtrai(1,id,1)
      ic2=idtrai(2,id,1)
      icproj(1,l)=ic1
      icproj(2,l)=ic2
      enddo
     
c     targ
c     ----
      la=latarg
      ma=iabs(matarg)
      las=0
      mas=0
      do l=1,ma
      if(la.lt.0)then
      ia=iabs(idtarg/10)
      is=idtarg/iabs(idtarg)
      if(ia.ne.111.and.ia.ne.222.and.ia.ne.333)id=idtarg/10*10
      if(ia.eq.111.or. ia.eq.222.or. ia.eq.333)id=idtarg/10*10+is
      if(ia.eq.213)id=1230*is
      if(iabs(idtarg).lt.20)id=idtarg
      else
      id=1220
      if(rangen().le.(la-las)*1./(ma-mas))id=1120
      if(id.eq.1120)las=las+1
      mas=mas+1
      endif
      ic1=idtrai(1,id,1)
      ic2=idtrai(2,id,1)
      ictarg(1,l)=ic1
      ictarg(2,l)=ic2
      enddo

      call utprix('conre ',ish,ishini,6)
      return
      end    

c-----------------------------------------------------------------------
      subroutine conrl
c-----------------------------------------------------------------------
c  initializes target remnant in case of appl lepton
c-----------------------------------------------------------------------
      include "nexus.incems"
      common/nucl1/laproj,maproj,latarg,matarg,core,fctrmx
      common/hadr2/iomodl,idproj,idtarg,wexcit
      common/remn/icproj(2,mamx),ictarg(2,mamx)

c     targ
c     ----
      la=latarg
      ma=iabs(matarg)
      las=0
      mas=0
      do l=1,ma
      if(la.lt.0)then
      id=idtarg
      else
      id=1220
      if(rangen().le.(la-las)*1./(ma-mas))id=1120
      if(id.eq.1120)las=las+1
      mas=mas+1
      endif
      ic1=idtrai(1,id,1)
      ic2=idtrai(2,id,1)
      ictarg(1,l)=ic1
      ictarg(2,l)=ic2
      enddo
 
      return
      end    
 
c-----------------------------------------------------------------------
      subroutine conwr
c-----------------------------------------------------------------------      
c     writes /cptl/
c-----------------------------------------------------------------------
      include "nexus.inc"
      include "nexus.incems"
      common/nucl3/phi,bimp
      common /cncl/xproj(mamx),yproj(mamx),zproj(mamx)
     *,xtarg(mamx),ytarg(mamx),ztarg(mamx)
      common/remn/icproj(2,mamx),ictarg(2,mamx)
      integer ic(2)

      call utpri('conwr ',ish,ishini,6)   
      
      bx=cos(phi)*bimp
      by=sin(phi)*bimp

c     write /cptl/
c     ------------
      nptl=0

           if(iokoll.eq.1)then   ! precisely matarg collisions

      nptl=nptl+1
      do 3 i=1,4
3     xorptl(i,nptl)=0
      tivptl(1,nptl)=-ainfin  
      tivptl(2,nptl)=0
      istptl(nptl)=1
      iorptl(nptl)=-1
      jorptl(nptl)=0
      do 1 k=1,koll
      nptl=nptl+1
      do 4 i=1,4
4     xorptl(i,nptl)=0
      tivptl(1,nptl)=-ainfin 
      tivptl(2,nptl)=0
      istptl(nptl)=1
      iorptl(nptl)=-1
      jorptl(nptl)=0
1     continue
 
           elseif(iappl.ne.7)then
 
      do 6 i=1,maproj
      nptl=nptl+1
      xorptl(1,nptl)=xproj(i)+bx/2
      xorptl(2,nptl)=yproj(i)+by/2
      xorptl(3,nptl)=zproj(i)
      xorptl(4,nptl)=0
      tivptl(1,nptl)=-ainfin  
c for visualisation uncomment
c-c   tivptl(1,nptl)=-100
      tivptl(2,nptl)= ainfin
      istptl(nptl)=0
      iorptl(nptl)=0
      jorptl(nptl)=0
6     continue
      do 7 i=1,matarg
      nptl=nptl+1
      xorptl(1,nptl)=xtarg(i)-bx/2
      xorptl(2,nptl)=ytarg(i)-by/2
      xorptl(3,nptl)=ztarg(i)
      xorptl(4,nptl)=0
      tivptl(1,nptl)=-ainfin  
c for visualisation uncomment
c-c   tivptl(1,nptl)=-100
      tivptl(2,nptl)= ainfin
      istptl(nptl)=0
      iorptl(nptl)=0
      jorptl(nptl)=0
7     continue

           endif
           
      nptl=0
      if(iappl.le.2)then
      do i=1,maproj 
      nptl=nptl+1
      ic(1)=icproj(1,i)
      ic(2)=icproj(2,i)
      id=idtra(ic,0,0,3)
      call idmass(id,ams)
      idptl(nptl)=id
      pptl(1,nptl)=0.
      pptl(2,nptl)=0.
      pptl(3,nptl)=pnullx
      pptl(4,nptl)=sqrt(pnullx**2+ams**2)
      pptl(5,nptl)=ams
      ifrptl(1,nptl)=0
      ifrptl(2,nptl)=0
      ityptl(nptl)=0
      enddo
      endif
      if(iappl.ne.7)then
      do i=1,matarg 
      nptl=nptl+1
      ic(1)=ictarg(1,i)
      ic(2)=ictarg(2,i)
      id=idtra(ic,0,0,3)
      call idmass(id,ams)
      idptl(nptl)=id
      pptl(1,nptl)=0.
      pptl(2,nptl)=0.
      pptl(3,nptl)=-pnullx
      pptl(4,nptl)=sqrt(pnullx**2+ams**2)
      pptl(5,nptl)=ams
      ifrptl(1,nptl)=0
      ifrptl(2,nptl)=0
      ityptl(nptl)=0
      enddo

      else
      nptl=nptl+1
      id=idproj
      call idmass(id,ams)
      idptl(nptl)=id
      pptl(1,nptl)=0.
      pptl(2,nptl)=0.
      pptl(3,nptl)=pnullx
      pptl(4,nptl)=sqrt(pnullx**2+ams**2)
      pptl(5,nptl)=ams
      ifrptl(1,nptl)=0
      ifrptl(2,nptl)=0
      ityptl(nptl)=0
      iorptl(nptl)=-1
      jorptl(nptl)=0
      istptl(nptl)=0
      do 5 i=1,4
 5      xorptl(i,nptl)=0
      tivptl(1,nptl)=-ainfin 
      tivptl(2,nptl)=0
      endif

c     exit
c     ---- 

      call utprix('conwr ',ish,ishini,6)
      return
      end

c------------------------------------------------------------------------
      subroutine conxyz(ch,n,x,y,z,ynuc)
c-----------------------------------------------------------------------
      include 'nexus.inc'

      real x(n),y(n),z(n)
      character ch*1

      if(ch.eq.'p')then
      massnr=maproj
      elseif(ch.eq.'t')then
      massnr=matarg
      else
      call utstop('conxyz: nucleus neither proj nor targ&')
      endif

      if(massnr.eq.0)return
      if(massnr.gt.n)call utstop('conxyz: massnr.gt.n&')
      if(massnr.eq.1)then
      x(1)=0
      y(1)=0
      z(1)=0
      return
      endif

c Be carreful to change also values for cross sections in nexus-sha (psaini) !

c     amws=0.54                                      !option 1
c     amws=0.523                                     !option 2
c     amws=0.54                                      !option 3(in bas)
      if(massnr.ge.10)then  !wood-saxon density
c       rad=1.19*massnr**0.33333-1.38*massnr**(-0.33333) !option 1
c       rad=0.7*float(massnr)**.446                      !option 2
        rad=1.12*massnr**0.33333-0.86*massnr**(-0.33333) !option 3
        rad=rad/amws
        cr1=1.+3./rad+6./rad**2+6./rad**3
        cr2=3./rad
        cr3=3./rad+6./rad**2
      elseif(massnr.lt.10.and.massnr.ne.1)then !gaussian density
        rad=.9*float(massnr)**.3333
        if(massnr.eq.2)rad=3.16
        rad=rad*sqrt(2.*massnr/(massnr-1.))   !van hove simulation
      endif

         if(massnr.ge.10)then

      do i=1,massnr
   1  zuk=rangen()*cr1-1.
        if(zuk.le.0.)then
      tt=rad*(rangen()**.3333-1.)
        elseif(zuk.le.cr2 )then
      tt=-log(rangen())
        elseif(zuk.lt.cr3 )then
      tt=-log(rangen())-log(rangen())
        else
      tt=-log(rangen())-log(rangen())-log(rangen())
        endif
      if(rangen().gt.1./(1.+exp(-abs(tt))))goto 1
      rim=tt+rad
      zz=rim*(2.*rangen()-1.)
      rim=sqrt(rim*rim-zz*zz)
      z(i)=zz*amws
      call pscs(c,s)
      x(i)=rim*c*amws
      y(i)=rim*s*amws
      enddo

         else

      do l=1,3
      summ=0.
      do i=1,massnr-1
      j=massnr-i
      aks=rad *(rangen()+rangen()+rangen()-1.5)
      k=j+1
      if(l.eq.1)x(k)=summ-aks*sqrt(float(j)/k)
      if(l.eq.2)y(k)=summ-aks*sqrt(float(j)/k)
      if(l.eq.3)z(k)=summ-aks*sqrt(float(j)/k)
      summ=summ+aks/sqrt(float(j*k))
      enddo
      if(l.eq.1)x(1)=summ
      if(l.eq.2)y(1)=summ
      if(l.eq.3)z(1)=summ
      enddo

         endif

      if(ionucl.eq.1.and.ch.eq.'p'.or.ionucl.eq.2.and.ch.eq.'t')then
      rmax=(rad+6)*amws
      drnucl=rmax/mxnucl
      do i=1,massnr
      nrnucl=nrnucl+1
      r=sqrt(x(i)**2+y(i)**2+z(i)**2)
      k=1+int(r/drnucl)
      if(k.le.mxnucl)rnucl(k)=rnucl(k)+1
      enddo
      endif

      do i=1,massnr
      z(i)=z(i)/cosh(ynuc)
      enddo

      return
      end

c-----------------------------------------------------------------------
      subroutine xconxyz
c-----------------------------------------------------------------------
c plots distribution of nucleons in nuclei  
c-----------------------------------------------------------------------
      include 'nexus.inc'
      write(ifhi,'(a)')       'newpage zone 1 1 1 openhisto'
      write(ifhi,'(a)')       'htyp lin xmod lin ymod lin'
      write(ifhi,'(a)')       'text 0 0 "xaxis r (fm)"'
      write(ifhi,'(a)')       'text 0 0 "yaxis rho(r)"'
      write(ifhi,'(a,2e11.3)')'xrange',0.,mxnucl*drnucl
      write(ifhi,'(3a)')'yrange',' 0 ',' auto'
      write(ifhi,'(a)')       'array 2'
      do j=1,mxnucl
      r=(j-0.5)*drnucl
      d=0.5*drnucl
      write(ifhi,'(2e12.4)')  r,rnucl(j)/nrnucl/
     *                     (4./3.*pi*((r+d)**3-(r-d)**3))
      enddo
      write(ifhi,'(a)')       '  endarray'
      write(ifhi,'(a)')       'closehisto plot 0-'
      write(ifhi,'(a)')       'openhisto'
      write(ifhi,'(a)')       'htyp lin xmod lin ymod lin'
      write(ifhi,'(a)')       'text 0 0 "xaxis r (fm)"'
      write(ifhi,'(a)')       'text 0 0 "yaxis rho(r)"'
      write(ifhi,'(a,2e11.3)')'xrange',0.,mxnucl*drnucl
      write(ifhi,'(3a)')'yrange',' 0 ',' auto'
      write(ifhi,'(a)')       'array 2'
      do j=1,mxnucl
      r=(j-0.5)*drnucl
      d=0.5*drnucl
      write(ifhi,'(2e12.4)')  r,rnuclo(j)/nrnucl/
     *                     (4./3.*pi*((r+d)**3-(r-d)**3))
      enddo
      write(ifhi,'(a)')       '  endarray'
      write(ifhi,'(a)')       'closehisto plot 0'
      end

