c 27/02/2003 Nexus 3.97


c----------------------------------------------------------------------
      subroutine paramini
c----------------------------------------------------------------------
c  Set the parameter of the parametrisation of the eikonale.
c  We group the parameters into 4 array with a dimension of nbpDf1(=4)
c  and nbpDf0(=1) to define xDfit (see below).
c
c xDfit=Sum(i,1,nbpDf1)(alpD(i)*xp**betDp(i)*xm**betDpp(i)*s**betD(i)
c			    *xs**(gamD(i)*b2)*exp(-b2/delD(i))
c
c----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incems'
      include 'nexus.incsem'
      include 'nexus.incpar'
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar2/  edmax,epmax
      common /psar7/ delx,alam3p,gam3p
      common /ar3/  x1(7),a1(7)
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)
      double precision PhiExact,y
      call utpri('parini',ish,ishini,3)
      
c Initialisation of the variables

      call Class('paramini  ')

c Variables used for xparg (only graphical application)

      spmin=4.*q2min         !Definition of spmin in psvin (nexus-sha)
      smaxDf=engy**2
      emaxDf=engy
      nptf=10
      xmaxDf=1.d0
      xminDf=1.d0/dble(smaxDf)
      xshmin=min(dble(Eseuil**2./smaxDf),3.d-2)
      if(smaxDf.lt.5.*spmin) xshmin=1.d0
      if(icdp+icdt.eq.4)then
      xfitmin=0.1d0
      if(smaxDf.lt.5.*spmin)                      xfitmin=1.d0
c      if(smaxDf.ge.5.*spmin.and.emaxDf.lt.100.)   xfitmin=0.7d0
c      if(emaxDf.ge.100..and.emaxDf.lt.500.)       xfitmin=0.6d0
c      if(emaxDf.ge.500..and.emaxDf.lt.1000.)      xfitmin=0.4d0
c      if(emaxDf.ge.1000..and.emaxDf.lt.10000.)    xfitmin=0.2d0
c      if(emaxDf.ge.10000.)                        xfitmin=1.d-01
      else
      if(smaxDf.lt.5.*spmin)                      xfitmin=1.d0
      if(smaxDf.ge.5.*spmin.and.emaxDf.lt.100.)   xfitmin=0.8d0
      if(emaxDf.ge.100..and.emaxDf.lt.500.)       xfitmin=0.5d0
      if(emaxDf.ge.500..and.emaxDf.lt.1000.)      xfitmin=0.1d0
      if(emaxDf.ge.1000..and.emaxDf.lt.10000.)    xfitmin=0.005d0
      if(emaxDf.ge.10000.)                        xfitmin=1.d-03
      endif

      ierr=0
      bmaxDf=2.5
      iscreen=iscreeni
      st=engy 
      if(r3pom.le.1.E-5.or.st.le.Eseuil.or.st.le.delx) iscreen=0    
      if(iscreen.eq.0)inueff=0
      if(maproj+matarg.le.2)inueff=0

c Minimum x for remnant in omega and ProReM (nexus-ems)

      ptmean=1.       !mean pt of remnant
      amassm=1.       !mean mass of the particles added in the remnants
      aproj=amproj+amassm
      atarg=amtarg+amassm
      xpremin=min(0.8,sqrt(aproj*aproj+ptmean)/st)
      xmremin=min(0.8,sqrt(atarg*atarg+ptmean)/st)


      if(ish.ge.1)write(ifmt,*)'gamini'
     &            ,gamdp(icdp,iclpro),gamdt(icdt,icltar),iscreeni
     &            ,icdp,icdt,iclpro,icltar,iclegy,engy,iscreen

      shaeffsf(1)=0.d0
      shaeffsh(1)=0.d0
      trieff(1)=0.d0
      difefp(1)=0.d0
      difefm(1)=0.d0
      
        iiiclegy=iclegy
        do iiicdp=icdp1,icdp2
        do iiicdt=icdt1,icdt2

          call pompar(alpsf,betsf,0)            !soft

          call pompar(alpsh,betsh,1)            !sh

          if(isetcs.eq.1)then
            call variance(delsf,gamsf,0) 
            call variance(delsh,gamsh,1)
          else
            nbpsf=1
            if(smaxDf.ge.5.*spmin.and.nbpDf0.eq.0)nbpsf=0
            gamsf=gamD(nbpsf,iiiclegy,iclpro,icltar,iiicdp,iiicdt)
            gamsh=gamD(1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)
            delsf=delD(nbpsf,iiiclegy,iclpro,icltar,iiicdp,iiicdt)
            delsh=delD(1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)
          endif

          if(smaxDf.lt.5.*spmin.and.nbpDf0.eq.0)then   !no hard
            alpsf=alpsf/2.
            alpsh=alpsf
            betsh=betsf
            gamsh=gamsf
            delsh=delsf
          endif

c          call pompar(alp,bet,-1)             !softer-sh (for enhanced)
c          call variance(del,gam,2) 

          bet=betsh
c        alp=(alpsh*smaxDf**(betsh-bet)+alpsf*smaxDf**(betsf-bet))/2.
c     *      /epscrp
          alp=min(alpsh*smaxDf**(betsh-bet)/epscrp,
     *        alpsh*smaxDf**(betsh-bet)+alpsf*smaxDf**(betsf-bet))/2.
          gam=gamsh
          del=delsh

          if(alp.lt.1.e-8)iscreen=0

          if(iAGKch.eq.1)then
            gam=.0
            gamsh=gam
            gamsf=gam
            del=(delsh+delsf)/2.
            delsh=del
            delsf=del
            alp=1000.
            alpsf=alp/2.
            alpsh=alp/2.
            bet=-1.+alppar
            betsf=bet
            betsh=bet
            iscreen=0
            inueff=0
            alplea(iclpro)=1.
            alplea(icltar)=1.
          endif

          alpD1(1,iiiclegy,iclpro)=alp*del/gamhad(iclpro)
          betD1(1,iiiclegy,iclpro)=bet
          betDp1(1,iiiclegy,iclpro)=0.
          delD1(1,iiiclegy,iclpro)=del
          alpD1(1,iiiclegy,icltar)=alp*del/gamhad(icltar)
          betD1(1,iiiclegy,icltar)=bet
          betDp1(1,iiiclegy,icltar)=0.
          delD1(1,iiiclegy,icltar)=del

          alpD2(1,iiiclegy)=alpsf
          betD2(1,iiiclegy)=betsf
          delD2(1,iiiclegy)=delsf

          if(nbpDf.ge.2)then

            alpD2(2,iiiclegy)=alpsh
            betD2(2,iiiclegy)=betsh
            delD2(2,iiiclegy)=delsh

            if(iscreen.eq.1.and.isetcs.eq.1)then

            call pompar2(alp1,bet1,0)
            call variance(del1,tmp,2)  
            alpD1(min(nbpDf,2),iiiclegy,iclpro)=alp1
            betD1(min(nbpDf,2),iiiclegy,iclpro)=bet1
            betDp1(min(nbpDf,2),iiiclegy,iclpro)=0.
            delD1(min(nbpDf,2),iiiclegy,iclpro)=
     &        sigma2(min(xminDf*100.d0,dsqrt(xminDf*xmaxDf)),7,ierr) 
            if(ierr.eq.1)then
              if(ish.ge.1)write(ifmt,*)
     &            'Warning ! In param2, initial sigma2(7) not defined !'
              alpD1(min(nbpDf,2),iclegy,iclpro)=0.
              betD1(min(nbpDf,2),iclegy,iclpro)=0.
              betDp1(min(nbpDf,2),iclegy,iclpro)=0.
              delD1(min(nbpDf,2),iclegy,iclpro)=1. 
            endif
           endif
          endif

          if(nbpDf.ge.3.and.iscreen.eq.1)then
            call pompar2(alp2,bet2,1)
            alpD1(min(nbpDf,3),iiiclegy,iclpro)=alp2
            betD1(min(nbpDf,3),iiiclegy,iclpro)=bet2
            betDp1(min(nbpDf,3),iiiclegy,iclpro)=0.
            delD1(min(nbpDf,3),iiiclegy,iclpro)=sigma2(xmaxDf,8,ierr) 
            if(ierr.eq.1)then
              if(ish.ge.1)write(ifmt,*)
     &            'Warning ! In param2, initial sigma2(8) not defined !'
              alpD1(min(nbpDf,3),iclegy,iclpro)=0.
              betD1(min(nbpDf,3),iclegy,iclpro)=0.
              betDp1(min(nbpDf,3),iclegy,iclpro)=0.
              delD1(min(nbpDf,3),iclegy,iclpro)=1. 
            endif
          endif

          if(nbpDf.ge.4.and.iscreen.eq.1)then
            call pompar2(alp3,bet3,5)
            alpD1(min(nbpDf,4),iiiclegy,iclpro)=alp3
            betD1(min(nbpDf,4),iiiclegy,iclpro)=bet3
            betDp1(min(nbpDf,4),iiiclegy,iclpro)=0.
            delD1(min(nbpDf,4),iiiclegy,iclpro)=sigma2(xmaxDf,9,ierr) 
            if(ierr.eq.1)then
              if(ish.ge.1)write(ifmt,*)
     &            'Warning ! In param2, initial sigma2(9) not defined !'
              alpD1(min(nbpDf,4),iclegy,iclpro)=0.
              betD1(min(nbpDf,4),iclegy,iclpro)=0.
              betDp1(min(nbpDf,4),iclegy,iclpro)=0.
              delD1(min(nbpDf,4),iclegy,iclpro)=1. 
            endif
          endif

          xnu(iiiclegy,iclpro)=0.
          xnup(iiiclegy,iclpro)=0.
          xnum(iiiclegy,iclpro)=0.
          xnu(iiiclegy,icltar)=xnu(iiiclegy,iclpro)
          xnup(iiiclegy,icltar)=xnup(iiiclegy,iclpro)
          xnum(iiiclegy,icltar)=xnum(iiiclegy,iclpro)
          xmu(1)=0.
          xmu(2)=0.
          xmu(3)=alp
          eps=0.
          alpp=0.
          alppp=0.
          cYfus=0.d0
          cYscr=0.d0
          cYdif=0.d0
          cXfus=0.d0
          cXdif=0.d0
          cXscr=0.d0
         

          if(ish.ge.1)then
          write(ifmt,*)"-----------------------------------"
          write(ifmt,*)"parameters :"
          write(ifmt,*)"alp,bet,gam,del sf:",alpsf,betsf,gamsf,delsf
          write(ifmt,*)"alp,bet,gam,del sh:",alpsh,betsh,gamsh,delsh
          write(ifmt,*)"alp,bet,gam,del en:",alp,bet,gam,del
          endif
          

          if(st.gt.Eseuil.and.iscreen.eq.1) then
            betp=bet
            if(betp.le.0.)betp=0.
             eps=epscr
             if(eps.lt.15.)then

             alpp=alp
             alppp=0.
             xmu(1)=alpp
             xmu(2)=alppp

             xnu(iiiclegy,iclpro)=-bet/2.
             xnup(iiiclegy,iclpro)=(eps+alppar-1)/2.
             xnu(iiiclegy,icltar)=xnu(iiiclegy,iclpro)
             xnup(iiiclegy,icltar)=xnup(iiiclegy,iclpro)


             Esmin=Eseuil!80      !below this energy, only first order (Y)
             if(st.gt.Esmin)then
               cYdif=sqrt(Esmin/st)
             else
               cYdif=1.d0
             endif
             cYfus=2.d0*cYdif 
             cYscr=-1.d0-CYfus-CYdif 

c             cXfus=-1.4d0 !-4.d0 !-0.7d0     !-C     C=8(initial sans soft)
c             cXdif=-0.7d0 !-2.d0 !-0.35d0     !-C/2   C=4(->1000 GeV)
c             cXscr=5.2d0 !13.d0 !3.1d0     !3C+1     c=3.4(->2000 GeV)

          if(ish.ge.1)then             
             write(ifmt,*)"eps, alpp, alppp :",eps,alpp,alppp
             write(ifmt,*)"nu, nu+, nu- :",xnu(iiiclegy,iclpro),
     *            xnup(iiiclegy,iclpro),xnum(iiiclegy,iclpro)
             write(ifmt,*)"gam+, gam+' :",0.5*(eps-alppar-1.+bet)
     *                         ,eps+bet-alppar
             write(ifmt,*)"cYscr, cYfus, CYdif :",cYscr,cYfus,CYdif
           endif
          else
            iscreen=0
          endif
          endif
          if(ish.ge.1)write(ifmt,*)"-----------------------------------"


         alpD(nbpDf0,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=alpsf
         alpDp(nbpDf0,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=betsf
         alpDpp(nbpDf0,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=0.
         betD(nbpDf0,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=betsf
         betDp(nbpDf0,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=betsf
         betDpp(nbpDf0,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=betsf
         gamD(nbpDf0,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=gamsf
         delD(nbpDf0,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=delsf

         alpD(1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=alpsh
         alpDp(1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=betsh
         alpDpp(1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=0.
         betD(1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=betsh
         betDp(1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=betsh
         betDpp(1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=betsh
         gamD(1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=gamsh
         delD(1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=delsh

         alpD(2,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=-alpp
         alpDp(2,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=bet+eps/2.
         alpDpp(2,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=eps
         betD(2,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=bet
         betDp(2,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=bet+eps
         betDpp(2,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=bet
         gamD(2,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=gam
         delD(2,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=del 

         alpD(3,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=-alpp
         alpDp(3,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=bet+eps/2.
         alpDpp(3,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=-eps
         betD(3,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=bet
         betDp(3,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=bet
         betDpp(3,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=bet+eps
         gamD(3,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=gam
         delD(3,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=del

c$$$         alpD(4,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=alppp
c$$$         alpDp(4,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=bet+eps
c$$$         alpDpp(4,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=0.
c$$$         betD(4,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=bet
c$$$         betDp(4,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=bet+eps
c$$$         betDpp(4,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=bet+eps
c$$$         gamD(4,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=gam
c$$$         delD(4,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=del

         if(iscreen.eq.0)then
         do iii=2,nbpDf1
         alpD(iii,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=0.
         alpDp(iii,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=0.
         alpDpp(iii,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=0.
         betD(iii,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=0.
         betDp(iii,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=0.
         betDpp(iii,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=0.
         gamD(iii,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=0.
         delD(iii,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=1.
         enddo
         endif  


      enddo
      enddo

      if(isetcs.eq.1)then 
        write(ifmt,*)'Run to set cross section parameter  ---------->'
        call Kfit(-1)
      endif


      if(iAGKch.eq.1)then 
        write(ifmt,*)'Theoric run to check AGK ---------->'
        call Kfit(-1)
      endif

      if(ish.ge.1)then             
        y=PhiExact(1.,1.d0,1.d0,engy**2,0.)
        write(ifmt,*)"-----------------------------------"
        write(ifmt,*)'PhiExact'
        write(ifmt,*)engy,y
        write(ifmt,*)"-----------------------------------"
      endif

c      call Kfit(iclegy)
c          xnu(iclegy,iclpro)=0.
c          xnup(iclegy,iclpro)=0.
c          xnum(iclegy,iclpro)=0.
c          slorNp=0.
c          xmu(1)=1.

c$$$      write(*,*)"par",alp/2.,bet,2.*eps+bet-alppar,hup,del,1+bet/2.,
c$$$     *alpD1(1,iclegy,2),1.+(2.*eps-1.-alppar+bet)/2.,log(st/delx)*2.,
c$$$     *alp/alpD1(1,iclegy,2)**4.
c$$$      y=omXuncut(engy**2.,1.d0,0.d0,0.)


c Pas de dependance en y

c$$$        do iiicdp=icdp1,icdp2
c$$$        do iiicdt=icdt1,icdt2
c$$$        do iiiclegy=iclegy1,iclegy2
c$$$         betDp(nbpDf1-1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=
c$$$     &    alpDp(nbpDf1-1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)
c$$$         betDpp(nbpDf1-1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=
c$$$     &    alpDp(nbpDf1-1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)
c$$$
c$$$         betDp(nbpDf1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=
c$$$     &    alpDp(nbpDf1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)
c$$$         betDpp(nbpDf1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=
c$$$     &    alpDp(nbpDf1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)
c$$$
c$$$          if(delD(nbpDf1-1,iiiclegy,iclpro,icltar,iiicdp,iiicdt).gt.
c$$$     &       delD(2,iiiclegy,iclpro,icltar,iiicdp,iiicdt))then
c$$$         gamD(nbpDf1-1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=
c$$$     &   gamD(1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)
c$$$         gamD(nbpDf1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=
c$$$     &   gamD(1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)
c$$$         delD(nbpDf1-1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=
c$$$     &   delD(1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)
c$$$         delD(nbpDf1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)=
c$$$     &   delD(1,iiiclegy,iclpro,icltar,iiicdp,iiicdt)
c$$$         write(*,*)"Changement in par ..."
c$$$          endif
c$$$         enddo
c$$$         enddo
c$$$         enddo


c Initialisation of the parameters for sigma1ifit


           parDf(5,3)=0.
           parDf(6,3)=1.
       do i=nbpDf0,min(nbpDf1,2)
	   parDf(2*i+1,3)=alpD(i,iclegy,iclpro,icltar,icdp,icdt)
	   parDf(2*i+2,3)=alpDp(i,iclegy,iclpro,icltar,icdp,icdt)
       enddo

c tempo pour test dans Dsofshpar

          parDf(5,3)=-alpD(2,iclegy,iclpro,icltar,icdp,icdt)
          parDf(6,3)=alpDp(2,iclegy,iclpro,icltar,icdp,icdt)
          parDf(7,3)=betD(1,iclegy,iclpro,icltar,icdp,icdt)

       if(nbpDf1.eq.3)then
          parDf(5,3)=alpD(max(3,nbpDf1),iclegy,iclpro,icltar,icdp,icdt)
          parDf(6,3)=alpDp(max(3,nbpDf1),iclegy,iclpro,icltar,icdp,icdt)
       endif
	   parDf(9,3)=gamD(1,iclegy,iclpro,icltar,icdp,icdt)
	   parDf(10,3)=delD(1,iclegy,iclpro,icltar,icdp,icdt)
          
	   parDf(11,3)=gamD(2,iclegy,iclpro,icltar,icdp,icdt)
	   parDf(12,3)=delD(2,iclegy,iclpro,icltar,icdp,icdt)
	
c Initialisation of the parameters for sigma2ifit

       do i=13,22
	   parDf(i,3)=0.
       enddo

       do i=1,nbpDf
	   parDf(12+2*i-1,3)=alpD1(i,iclegy,iclpro)
	   parDf(12+2*i,3)=betD1(i,iclegy,iclpro)
       enddo


	   parDf(20,3)=delD1(1,iclegy,iclpro)
	   parDf(21,3)=1.
	   if(nbpDf.ge.2) parDf(21,3)=delD1(min(2,nbpDf),iclegy,iclpro)
	   parDf(22,3)=1.
           if(nbpDf.ge.3)then
             parDf(7,3)=betDp1(max(3,nbpDf-1),iclegy,iclpro)
             parDf(8,3)=betDp1(nbpDf,iclegy,iclpro)
             parDf(22,3)=delD1(max(3,nbpDf-1),iclegy,iclpro)
           endif

c Initialisation of the parameters for sigma3ifit


	   parDf(27,3)=0.
       do i=1,min(nbpDf,3)
	   parDf(22+2*i-1,3)=alpD2(i,iclegy)
	   parDf(22+2*i,3)=betD2(i,iclegy)
       enddo
	   parDf(29,3)=delD2(1,iclegy)
	   if(nbpDf.ge.2) parDf(30,3)=delD2(min(2,nbpDf),iclegy)

      call utprix('parini',ish,ishini,3)

      return
      end
	
c----------------------------------------------------------------------
      subroutine Class(text)
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incpar'
      character*10 text
      iclegy=1+int( (log(engy)-log(egylow))/log(egyfac) ) !energy class
      if(iclegy.gt.iclegy2)then
         write(*,*)'**************************************************'
         write(*,*)'Warning in ',text		
         write(*,*)'Energy above the range used for the fit of D:'
         write(*,*)egylow*egyfac**(iclegy1-1),egylow*egyfac**iclegy2
         write(*,*)'**************************************************'
         iclegy=iclegy2
      endif
      if(iclegy.lt.iclegy1)then
         write(*,*)'**************************************************'
         write(*,*)'Warning in ',text			
         write(*,*)'Energy below the range used for the fit of D:'
         write(*,*)egylow*egyfac**(iclegy1-1),egylow*egyfac**iclegy2
         write(*,*)'**************************************************'
         iclegy=iclegy1
      endif
      end

c----------------------------------------------------------------------
      subroutine param
c----------------------------------------------------------------------
c  Set the parameter of the parametrisation of the eikonale.
c  We group the parameters into 4 array with a dimension of nbpDf1(=4)
c  to define xDfit (see below).
c
c xDfit=Sum(i,1,nbpDf1)(alpD(i)*xp**betDp(i)*xm**betDpp(i)*s**betD(i)
c			    *xs**(gamD(i)*b2)*exp(-b2/delD(i))
c
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      include 'nexus.incpar'
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)
      common /psar7/ delx,alam3p,gam3p

c Initialisation of the variables

      emaxDf=egyfac**iclegy*egylow
      smaxDf=emaxDf**2

      if(egymax.gt.egyfac**iclegy2*egylow)then 
         write(*,*)'**************************************************'
         write(*,*)'Warning in param'		
         write(*,*)'Max energy above the range used for the fit of D:'
         write(*,*)egylow*egyfac**(iclegy1-1),egylow*egyfac**iclegy2
         write(*,*)'**************************************************'
      endif

      spmin=4.*q2min         !Definition of spmin in psvin (nexus-sha)
      nptf=10
      xmaxDf=1.d0
      xminDf=1.d0/dble(smaxDf)
      xshmin=min(dble(Eseuil**2./smaxDf),3.d-2)
      if(smaxDf.lt.5.*spmin) xshmin=1.d0
      if(icdp+icdt.eq.4)then
      xfitmin=0.1d0
      if(smaxDf.lt.5.*spmin)                      xfitmin=1.d0
c      if(smaxDf.ge.5.*spmin.and.emaxDf.lt.100.)   xfitmin=0.8d0
c      if(emaxDf.ge.100..and.emaxDf.lt.500.)       xfitmin=0.5d0
c      if(emaxDf.ge.500..and.emaxDf.lt.1000.)      xfitmin=0.2d0
c      if(emaxDf.ge.1000.)                         xfitmin=0.01d0
      else
      if(smaxDf.lt.5.*spmin)                      xfitmin=1.d0
      if(smaxDf.ge.5.*spmin.and.emaxDf.lt.100.)   xfitmin=0.8d0
      if(emaxDf.ge.100..and.emaxDf.lt.500.)       xfitmin=0.5d0
      if(emaxDf.ge.500..and.emaxDf.lt.1000.)      xfitmin=0.1d0
      if(emaxDf.ge.1000.)                         xfitmin=0.05d0
      endif

      bmaxDf=2.5


      if(nbpDf0.ne.0.and.nbpDf1.ne.3) stop "* nbpDf0/1 are not good! *"   

      engytmp=engy
      engy=emaxDf

c Initialisation of the parameters

        do i=1,nbpf
          do j=1,4
            parDf(i,j)=1.
          enddo
        enddo

c.......Calculations of the parameters



      st=engy 
      iscreen=iscreeni
      if(r3pom.le.1.E-5.or.st.le.Eseuil) iscreen=0    

      iscr=iscreen


      call pompar(alpsf,betsf,0)          !soft
      call variance(delsf,gamsf,0) 

      call pompar(alpsh,betsh,1)          !sh
      call variance(delsh,gamsh,1) 

      if(smaxDf.lt.5.*spmin.and.nbpDf0.eq.0)then !no hard
        alpsf=alpsf/2.
        alpsh=alpsf
        betsh=betsf
        gamsh=gamsf
        delsh=delsf
      endif

c     call pompar(alp,bet,-1)             !softer-sh (for enhanced)
c     call variance(del,gam,2) 

      bet=betsh
      alp=min(alpsh*smaxDf**(betsh-bet)/epscrp,
     *        alpsh*smaxDf**(betsh-bet)+alpsf*smaxDf**(betsf-bet))/2.
      gam=gamsh
      del=delsh

      if(alp.lt.1.e-8)iscr=0

      xnu(iclegy,iclpro)=0.
      xnup(iclegy,iclpro)=0.
      xnum(iclegy,iclpro)=0.
      xnu(iclegy,icltar)=xnu(iclegy,iclpro)
      xnup(iclegy,icltar)=xnup(iclegy,iclpro)
      xnum(iclegy,icltar)=xnum(iclegy,iclpro)
      xmu(1)=0.
      xmu(2)=0.
      xmu(3)=alp
      alpp=0.
      alppp=0.
      eps=0.
      
      if(st.gt.Eseuil.and.iscr.ne.0) then
        betp=bet
        if(betp.le.0.)betp=0.
        eps=epscr
c        alpp=alp/log(Esmax/Eseuil)/2.*log(smaxDf/Eseuil**2.)
c        alppp=0.!alp/log(Esmax/delx)**2./4.*log(smaxDf/delx**2.)**2.
c        if(smaxDf.ge.Esmax**2.)then
          alpp=alp
          alppp=0.!alp
c        endif
        xmu(1)=alpp
        xmu(2)=alppp
        xnu(iclegy,iclpro)=-bet/2.
        xnup(iclegy,iclpro)=(eps+alppar-1)/2.
        xnu(iclegy,icltar)=xnu(iclegy,iclpro)
        xnup(iclegy,icltar)=xnup(iclegy,iclpro)
      endif

      write(ifmt,*)"-----------------------------------"
      write(ifmt,*)"parameters :"
      write(ifmt,*)"alp,bet,gam,del sf:",alpsf,betsf,gamsf,delsf
      write(ifmt,*)"alp,bet,gam,del sh:",alpsh,betsh,gamsh,delsh
      write(ifmt,*)"alp,bet,gam,del en:",alp,bet,gam,del
      write(ifmt,*)"eps, alpp, alppp :",eps,alpp,alppp
      write(ifmt,*)"nu, nu+, nu- :",xnu(iclegy,iclpro),
     *     xnup(iclegy,iclpro),xnum(iclegy,iclpro)
      write(ifmt,*)"gam+, gam+' :",0.5*(eps-alppar-1.+bet)
     *     ,eps+bet-alppar
      
      alpD(nbpDf0,iclegy,iclpro,icltar,icdp,icdt)=alpsf
      alpDp(nbpDf0,iclegy,iclpro,icltar,icdp,icdt)=betsf
      alpDpp(nbpDf0,iclegy,iclpro,icltar,icdp,icdt)=0.
      betD(nbpDf0,iclegy,iclpro,icltar,icdp,icdt)=betsf
      betDp(nbpDf0,iclegy,iclpro,icltar,icdp,icdt)=betsf
      betDpp(nbpDf0,iclegy,iclpro,icltar,icdp,icdt)=betsf
      gamD(nbpDf0,iclegy,iclpro,icltar,icdp,icdt)=gamsf
      delD(nbpDf0,iclegy,iclpro,icltar,icdp,icdt)=delsf
      
      alpD(1,iclegy,iclpro,icltar,icdp,icdt)=alpsh
      alpDp(1,iclegy,iclpro,icltar,icdp,icdt)=betsh
      alpDpp(1,iclegy,iclpro,icltar,icdp,icdt)=0.
      betD(1,iclegy,iclpro,icltar,icdp,icdt)=betsh
      betDp(1,iclegy,iclpro,icltar,icdp,icdt)=betsh
      betDpp(1,iclegy,iclpro,icltar,icdp,icdt)=betsh
      gamD(1,iclegy,iclpro,icltar,icdp,icdt)=gamsh
      delD(1,iclegy,iclpro,icltar,icdp,icdt)=delsh
      
      alpD(2,iclegy,iclpro,icltar,icdp,icdt)=-alpp
      alpDp(2,iclegy,iclpro,icltar,icdp,icdt)=bet+eps/2.
      alpDpp(2,iclegy,iclpro,icltar,icdp,icdt)=eps
      betD(2,iclegy,iclpro,icltar,icdp,icdt)=bet
      betDp(2,iclegy,iclpro,icltar,icdp,icdt)=bet+eps
      betDpp(2,iclegy,iclpro,icltar,icdp,icdt)=bet
      gamD(2,iclegy,iclpro,icltar,icdp,icdt)=gam
      delD(2,iclegy,iclpro,icltar,icdp,icdt)=del
      
      alpD(3,iclegy,iclpro,icltar,icdp,icdt)=-alpp
      alpDp(3,iclegy,iclpro,icltar,icdp,icdt)=bet+eps/2.
      alpDpp(3,iclegy,iclpro,icltar,icdp,icdt)=-eps
      betD(3,iclegy,iclpro,icltar,icdp,icdt)=bet
      betDp(3,iclegy,iclpro,icltar,icdp,icdt)=bet
      betDpp(3,iclegy,iclpro,icltar,icdp,icdt)=bet+eps
      gamD(3,iclegy,iclpro,icltar,icdp,icdt)=gam
      delD(3,iclegy,iclpro,icltar,icdp,icdt)=del
      
c$$$      alpD(4,iclegy,iclpro,icltar,icdp,icdt)=alppp
c$$$      alpDp(4,iclegy,iclpro,icltar,icdp,icdt)=bet+eps
c$$$      alpDpp(4,iclegy,iclpro,icltar,icdp,icdt)=0.
c$$$      betD(4,iclegy,iclpro,icltar,icdp,icdt)=bet
c$$$      betDp(4,iclegy,iclpro,icltar,icdp,icdt)=bet+eps
c$$$      betDpp(4,iclegy,iclpro,icltar,icdp,icdt)=bet+eps
c$$$      gamD(4,iclegy,iclpro,icltar,icdp,icdt)=gam
c$$$      delD(4,iclegy,iclpro,icltar,icdp,icdt)=del
      
      if(iscr.eq.0)then
        do iii=2,nbpDf1
          alpD(iii,iclegy,iclpro,icltar,icdp,icdt)=0.
          alpDp(iii,iclegy,iclpro,icltar,icdp,icdt)=0.
          alpDpp(iii,iclegy,iclpro,icltar,icdp,icdt)=0.
          betD(iii,iclegy,iclpro,icltar,icdp,icdt)=0.
          betDp(iii,iclegy,iclpro,icltar,icdp,icdt)=0.
          betDpp(iii,iclegy,iclpro,icltar,icdp,icdt)=0.
          gamD(iii,iclegy,iclpro,icltar,icdp,icdt)=0.
          delD(iii,iclegy,iclpro,icltar,icdp,icdt)=1.
        enddo
      endif  
      


      engy=engytmp



      return
      end


c----------------------------------------------------------------------
      subroutine param2
c----------------------------------------------------------------------
c  Find the parameter of the parametrisation of the eikonale from the 
c  function om1p(7), om1p(8), and om1p(9).
c  Parametrisation as a function of x with nbpf=12 different param.
c  We group the parameters into 3 array with a dimension of nbpDf(=2)
c  to define xDfit2 (see below).
c  Some common variables are placed in "nexus.incpar"
c  - number of point to do the fit : nptf ( < maxdata=100)
c  - born to fit the eikonale function of b : bmaxDf
c  - born min of the energy = xminDf*smaxDf = 1 Gev**2 
c  - born max of the energy = xmaxDf*smaxDf = smaxDf (1e8 GeV**2)
c  - nmcxDf = number of attempt for the fit function of x (fitx)
c
c xDfit2=Sum(i,1,nbpDf)(alpD1(i)*xp**betDp1(i)
c			     *xs**betD1(i)*exp(-b**2/delD1(i))
c
c----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incsem'
      include 'nexus.incpar'
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
c      double precision om1p

c Initialisation of the variables

	emaxDf=egyfac**iclegy*egylow
	smaxDf=emaxDf**2

      if(egymax.gt.egyfac**iclegy2*egylow)then 
         write(*,*)'**************************************************'
         write(*,*)'Warning in param2'		
         write(*,*)'Max energy above the range used for the fit of D:'
         write(*,*)egylow*egyfac**(iclegy1-1),egylow*egyfac**iclegy2
         write(*,*)'**************************************************'
      endif

      spmin=4.*q2min        !Definition of spmin in psvin (nexus-sha)

      nptf=10
      xmaxDf=1.d0
      xminDf=1.d0/dble(smaxDf)
      bmaxDf=2.5
      write(ifmt,*)'nbpDf,icdp,icdt,iclegy=',nbpDf,icdp,icdt,iclegy
      			
c range of the initial fit of the sh pomeron when x->1
      xfitmin=0.1d0
      if(smaxDf.lt.5.*spmin)                      xfitmin=1.d0
c      if(smaxDf.ge.5.*spmin.and.emaxDf.lt.100.)   xfitmin=0.8d0
c      if(emaxDf.ge.100..and.emaxDf.lt.500.)       xfitmin=0.5d0
c      if(emaxDf.ge.500..and.emaxDf.lt.1000.)      xfitmin=0.2d0
c      if(emaxDf.ge.1000..and.emaxDf.lt.10000.)    xfitmin=0.05d0
c      if(emaxDf.ge.10000.)                        xfitmin=1.d-02
      
c factor for the parameters parDf
      if(emaxDf.lt.100.)                       fparDf=1.
      if(emaxDf.ge.100..and.emaxDf.lt.1000.)   fparDf=1.
      if(emaxDf.ge.1000..and.emaxDf.lt.10000.) fparDf=1.
      if(emaxDf.ge.10000.)                     fparDf=1.
      if(smaxDf.ge.5.*spmin.and.emaxDf.lt.100.)   xfitmin=0.8d0
      if(emaxDf.ge.100..and.emaxDf.lt.500.)       xfitmin=0.5d0
      if(emaxDf.ge.500..and.emaxDf.lt.1000.)      xfitmin=0.1d0
      if(emaxDf.ge.1000..and.emaxDf.lt.10000.)    xfitmin=0.005d0
      if(emaxDf.ge.10000.)                        xfitmin=1.d-03
            
      engytmp=engy
      engy=emaxDf
      ierr=0


      delD1(1,iclegy,iclpro)=delD(1,iclegy,iclpro,icltar,icdp,icdt)
      alpD1(1,iclegy,iclpro)=(alpD(1,iclegy,iclpro,icltar,icdp,icdt)
     *        -alpD(nbpDf0,iclegy,iclpro,icltar,icdp,icdt)
     *             *smaxDf**(betD(nbpDf0,iclegy,iclpro,icltar,icdp,icdt)
     *                      -betD(1,iclegy,iclpro,icltar,icdp,icdt)))/2.
     *                      *delD1(1,iclegy,iclpro)
     *                      /gamhad(iclpro)
      if(nbpDf0.eq.1) alpD1(1,iclegy,iclpro)=alpD1(1,iclegy,iclpro)/2.
      betD1(1,iclegy,iclpro)=betD(1,iclegy,iclpro,icltar,icdp,icdt)
      betDp1(1,iclegy,iclpro)=0.

      if(nbpDf.ge.2)then
        call pompar2(alp1,bet1,0)
        alpD1(min(nbpDf,2),iclegy,iclpro)=alp1
        betD1(min(nbpDf,2),iclegy,iclpro)=bet1
        betDp1(min(nbpDf,2),iclegy,iclpro)=0.
        delD1(min(nbpDf,2),iclegy,iclpro)=sigma2(xminDf,7,ierr) 
        if(ierr.eq.1)then
          write(ifmt,*)
     &         'Warning ! In param2, initial sigma2(7) not defined !'
          alpD1(min(nbpDf,2),iclegy,iclpro)=0.
          betD1(min(nbpDf,2),iclegy,iclpro)=0.
          betDp1(min(nbpDf,2),iclegy,iclpro)=0.
          delD1(min(nbpDf,2),iclegy,iclpro)=1. 
        endif
c        if(ierr.eq.1)stop'In param, initial sigma2(7) not defined !'
      endif

      if(nbpDf.ge.3)then
        call pompar2(alp2,bet2,1)
        alpD1(min(nbpDf,3),iclegy,iclpro)=alp2
        betD1(min(nbpDf,3),iclegy,iclpro)=bet2
        betDp1(min(nbpDf,3),iclegy,iclpro)=0.
        delD1(min(nbpDf,3),iclegy,iclpro)=sigma2(xmaxDf,8,ierr) 
        if(ierr.eq.1)then
          write(ifmt,*)
     &         'Warning ! In param2, initial sigma2(8) not defined !'
          alpD1(min(nbpDf,3),iclegy,iclpro)=0.
          betD1(min(nbpDf,3),iclegy,iclpro)=0.
          betDp1(min(nbpDf,3),iclegy,iclpro)=0.
          delD1(min(nbpDf,3),iclegy,iclpro)=1. 
        endif
c        if(ierr.eq.1)stop'In param, initial sigma2(8) not defined !'
      endif
      
      if(nbpDf.ge.4)then
        call pompar2(alp3,bet3,5)
        alpD1(min(nbpDf,4),iclegy,iclpro)=alp3
        betD1(min(nbpDf,4),iclegy,iclpro)=bet3
        betDp1(min(nbpDf,4),iclegy,iclpro)=0.
        delD1(min(nbpDf,4),iclegy,iclpro)=sigma2(xmaxDf,9,ierr) 
        if(ierr.eq.1)then
          write(ifmt,*)
     &         'Warning ! In param2, initial sigma2(9) not defined !'
          alpD1(min(nbpDf,4),iclegy,iclpro)=0.
          betD1(min(nbpDf,4),iclegy,iclpro)=0.
          betDp1(min(nbpDf,4),iclegy,iclpro)=0.
          delD1(min(nbpDf,4),iclegy,iclpro)=1. 
        endif
c        if(ierr.eq.1)stop'In param, initial sigma2(9) not defined !'
      endif
      


	
      engy=engytmp
            
      return
      end
	
c----------------------------------------------------------------------
      subroutine param3
c----------------------------------------------------------------------
c  Find the parameter of the parametrisation of the eikonale from the 
c  function om1p(5) and om1p(6).
c  Parametrisation as a function of x with nbpf=6 different param.
c  We group the parameters into 2 array with a dimension of nbpDf(=2)
c  to define xDfit3 (see below) (but forth values=0).
c  Some common variables are placed in "nexus.incpar"
c  - number of point to do the fit : nptf ( < maxdata=100)
c  - born to fit the eikonale function of b : bmaxDf
c  - born min of the energy = xminDf*smaxDf = 1 Gev**2 
c  - born max of the energy = xmaxDf*smaxDf = smaxDf (1e8 GeV**2)
c  - nmcxDf = number of attempt for the fit function of x (fitx)
c
c xDfit3=Sum(i,1,3)(alpD2(i)*xs**betD2(i)*exp(-b**2/delD2(i))
c
c----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incsem'
      include 'nexus.incpar'
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)

c Initialisation of the variables


      emaxDf=egyfac**iclegy*egylow
      smaxDf=emaxDf**2

      if(egymax.gt.egyfac**iclegy2*egylow)then 
         write(*,*)'**************************************************'
         write(*,*)'Warning in param3'		
         write(*,*)'Max energy above the range used for the fit of D:'
         write(*,*)egylow*egyfac**(iclegy1-1),egylow*egyfac**iclegy2
         write(*,*)'**************************************************'
      endif

      spmin=4.*q2min         !Definition of spmin in psvin (nexus-sha)

      nptf=10
      xmaxDf=1.d0
      xminDf=1.d0/dble(smaxDf)
      bmaxDf=2.
      			
c range of the initial fit of the sh pomeron when x->1
      if(smaxDf.lt.5.*spmin)                      xfitmin=1.d0
      if(smaxDf.ge.5.*spmin.and.emaxDf.lt.100.)   xfitmin=0.99d0
      if(emaxDf.ge.100..and.emaxDf.lt.500.)       xfitmin=0.8d0
      if(emaxDf.ge.500..and.emaxDf.lt.1000.)      xfitmin=0.4d0
      if(emaxDf.ge.1000.)                         xfitmin=0.2d0
      
c factor for the parameters parDf

      if(emaxDf.lt.100.)                       fparDf=.01
      if(emaxDf.ge.100..and.emaxDf.lt.1000.)   fparDf=.025
      if(emaxDf.ge.1000..and.emaxDf.lt.10000.) fparDf=.05
      if(emaxDf.ge.10000.)                     fparDf=.1

      
      engytmp=engy
      engy=emaxDf

      if(iclegy.eq.iclegy2)then

c Initialisation of the parameters
      do i=1,nbpDf
         alpD2(i,iclegy)=1.
         betD2(i,iclegy)=1.
         delD2(i,iclegy)=1.
      enddo

      do i=1,nbpf
        do j=1,4
          parDf(i,j)=1.
        enddo
      enddo

c Calculations of the parameters
            

      nmcxDf=150000
      call paramx3               !alpD2 and betD2

      nmcbDf=10000
        
        parDf(27,3)=0. 
        parDf(28,3)=1. 
      do i=1,min(nbpDf,3)
        parDf(2*i+21,3)=alpD2(i,iclegy)
        parDf(2*i+22,3)=betD2(i,iclegy)
      enddo

c      call paramb3               !delD2

      else

c Initialisation of the parameters

        do i=1,nbpDf
          alpD2(i,iclegy)=alpD2(i,iclegy2)
          betD2(i,iclegy)=betD2(i,iclegy2)
          delD2(i,iclegy)=1.
        enddo

        nmcbDf=10000

        do i=29,30
          do j=1,4
            parDf(i,j)=1.
          enddo
        enddo

c Calculations of the parameters
            
        call paramb3         !delD2

      endif

      engy=engytmp
            
      return
      end
	
c----------------------------------------------------------------------

	subroutine paramx

c----------------------------------------------------------------------
c Return the 6 parameters of the fit of the sum of the soft pomeron
c and the semi-hard pomeron : 
c  alpd(1)=parDf(1) and betD(1)=parDf(2) for the effective soft pomeron
c  alpd(2)=parDf(3) and betD(2)=parDf(4) for the effective sh pomeron
c  alpd(3)=parDf(5) and betD(3)=parDf(6) for the transition
c----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incsem'
      include 'nexus.incpar'
     
      double precision Dsoftshpar
     
      external Dsoftshpar

      dimension range(nbpf)

      call givedatax

      numminDf=1  	
      numparDf=min(2*nbpDf1,4)
      if(nbpDf1.eq.3)numparDf=6
      betac=.007
      betae=.001


c Initial value of the parameters ...    
      call pompar(parDf(1,3),parDf(2,3),0)
      call pompar(parDf(3,3),parDf(4,3),1)
	          parDf(5,3)=0.  
	          parDf(6,3)=1.
                  if(nbpDf1.eq.3)then
	          parDf(5,3)=-parDf(1,3)  
	          parDf(6,3)=(parDf(2,3)+parDf(4,3))/2.
                  endif

           range(1)=fparDf*parDf(1,3)                   !alpD(1)
	   range(2)=fparDf*parDf(2,3)			!betD(1)
	   range(3)=fparDf*parDf(3,3)                   !alpD(2)
	   range(4)=fparDf*parDf(4,3)/2.              	!betD(2)
	   range(5)=-parDf(5,3)				!alpD(3)
	   range(6)=parDf(6,3)				!betD(3)

      do i=numminDf,numparDf
        parDf(i,1)=parDf(i,3)-range(i)
        parDf(i,2)=parDf(i,3)+range(i)
      enddo

	
      write(*,*) '%%%%%%%%%%%%%%%%%%% fitx %%%%%%%%%%%%%%%%%%%%%%%'
      call fitx(Dsoftshpar,0.,nmcxDf,chi2,err)
	          

      if(nbpDf1.ne.3)parDf(6,3)=0.

      write(*,*) 'nbpDf1=',nbpDf1
      write(*,*) 'chi2=',chi2
      write(*,*) 'err=',err
      write(*,*) 'alpD(1)=',parDf(1,3),' betD(1)=',parDf(2,3)
      write(*,*) 'alpD(2)=',parDf(3,3),' betD(2)=',parDf(4,3)
      write(*,*) 'alpD(3)=',parDf(5,3),' betD(3)=',parDf(6,3)
	
      do i=1,min(nbpDf1,3)
        alpD(i,iclegy,iclpro,icltar,icdp,icdt)=parDf(2*i-1,3)
        alpDp(i,iclegy,iclpro,icltar,icdp,icdt)=parDf(2*i,3)    
        alpDpp(i,iclegy,iclpro,icltar,icdp,icdt)=0.    
        betD(i,iclegy,iclpro,icltar,icdp,icdt)=parDf(2*i,3)    
        betDp(i,iclegy,iclpro,icltar,icdp,icdt)=parDf(2*i,3)    
        betDpp(i,iclegy,iclpro,icltar,icdp,icdt)=parDf(2*i,3)    
      enddo
	
      return
      end


c----------------------------------------------------------------------
      subroutine givedatax
c----------------------------------------------------------------------
c Important to do tests for Xseuil !
c----------------------------------------------------------------------
      
      include 'nexus.inc'
      include 'nexus.incsem'
      include 'nexus.incpar'
      double precision X,X0,X1,Dsoftshval,Xseuil

      numdataDf=nptf
      
      X0=xminDf           
      X1=xmaxDf
      Xseuil=X1
      Smin=(130.)**2 
      iscr=0 
      if(smaxDf.le.Smin) iscr=0        
      if(iscreen.eq.0.or.iclpro.ne.2.or.icltar.ne.2)then
        if(smaxDf.gt.Smin) Xseuil=3.d-1*X1
      elseif(icdp+icdt.eq.2)then         
        if(smaxDf.gt.Smin) Xseuil=dsqrt(X1*X0)
      elseif(icdp+icdt.eq.3)then         
        if(smaxDf.gt.Smin) Xseuil=1.d1*dsqrt(X1*X0)
      endif

      Xseuil=1.d0                 ! Best for this D (14/12/2001)

c      if(smaxDf.gt.Smin) Xseuil=1.d-1*X1

c Fit of G(X) between X0 and X1
      do i=0,nptf-1
        X=X0
        if (i.ne.0) X=X*(X1/X0)**(dble(i)/dble(nptf-1))
        datafitD(i+1,2)=max(1.e-10,
     &             real(Dsoftshval(real(X)*smaxDf,X,0.d0,0.,iscr)))
        datafitD(i+1,1)=real(X)
        datafitD(i+1,3)=2.
        if (X.gt.Xseuil) datafitD(i+1,3)=1.+1.E+2*(log(real(X))
     &                                   -log(real(Xseuil)))
      enddo

      return
      end
	

c----------------------------------------------------------------------

	subroutine paramx2

c----------------------------------------------------------------------
c Return the 4 parameters of the fit of the sum of the soft pomeron
c and the semi-hard pomeron : 
c  alpd1(1)=parDf(1) and betD1(1)=parDf(2) for the effective soft
c           pomeron
c  alpd1(2)=parDf(3) and betD1(2)=parDf(4) for the effective sh pomeron
c----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incpar'
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
   
     
      double precision Dsoftshpar
     
      external Dsoftshpar

      dimension range(nbpf)

      call givedatax2

      numminDf=1  	
      numparDf=2*nbpDf
      betac=.1
      betae=.01
     
c Initial value of the parameters ...
      if(nbpDf.eq.1)then
      call pompar2(parDf(1,3),parDf(2,3),1)
                   parDf(3,3)=0.
                   parDf(4,3)=1.
                   chi2=0.
                   err=0.
      else
      call pompar2(parDf(1,3),parDf(2,3),0)
      call pompar2(parDf(3,3),parDf(4,3),1)
                   parDf(5,3)=0.
                   parDf(6,3)=1.
                   parDf(7,3)=0.
                   parDf(8,3)=1.
                   parDf(9,3)=0.
                   parDf(10,3)=1.
                   parDf(11,3)=0.
                   parDf(12,3)=1.

 	   range(1)=fparDf*parDf(1,3)			!alpD1(1)
	   range(2)=fparDf*parDf(2,3)			!betD1(1)
	   range(3)=fparDf*parDf(3,3)                   !alpD1(2)
	   range(4)=fparDf*parDf(4,3)      	        !betD1(2)

      do i=numminDf,numparDf
        parDf(i,1)=parDf(i,3)-range(i)
        parDf(i,2)=parDf(i,3)+range(i)
      enddo

	
      call fitx(Dsoftshpar,0.,nmcxDf,chi2,err)

      endif

      write(*,*) '%%%%%%%%%%%%%%%%%%% fitx2 %%%%%%%%%%%%%%%%%%%%%%%'
      write(*,*) 'nbpDf=',nbpDf
      write(*,*) 'chi2=',chi2
      write(*,*) 'err=',err
      write(*,*) 'alpD1(1)=',parDf(1,3),' betD1(1)=',parDf(2,3)
      write(*,*) 'alpD1(2)=',parDf(3,3),' betD1(2)=',parDf(4,3)
	
      do i=1,min(nbpDf,2)
        alpD1(i,iclegy,iclpro)=parDf(2*i-1,3)
        betD1(i,iclegy,iclpro)=parDf(2*i,3)    
        betDp1(i,iclegy,iclpro)=0.    
      enddo

      parDf(13,3)=alpD1(1,iclegy,iclpro)
      parDf(14,3)=betD1(1,iclegy,iclpro)
      if(nbpDf.eq.1)then
      parDf(15,3)=0.
      parDf(16,3)=1.
      else
      parDf(15,3)=alpD1(min(2,nbpDf),iclegy,iclpro)
      parDf(16,3)=betD1(min(2,nbpDf),iclegy,iclpro)
      endif
	
      return
      end

c----------------------------------------------------------------------
      subroutine givedatax2
c----------------------------------------------------------------------
      
      include 'nexus.inc'
      include 'nexus.incpar'
      double precision X,X0,X1,Dsoftshval2,Xseuil

      numdataDf=nptf
      Smin=(1000.)**2         
      X0=xminDf           
      X1=xmaxDf
      Xseuil=X1

      if(smaxDf.ge.Smin) Xseuil=5.d-2*X1

c Fit of G(X) between X0 and X1
      do i=0,nptf-1
        X=X0
        if (i.ne.0) X=X*(X1/X0)**(dble(i)/dble(nptf-1))
        datafitD(i+1,2)=max(1.e-10,
     &                  real(Dsoftshval2(real(X)*smaxDf,X,0.d0,0.,2)))
        datafitD(i+1,1)=real(X)
        datafitD(i+1,3)=1.
        if (X.gt.Xseuil) datafitD(i+1,3)=1.+10.*(log(real(X))
     &                                   -log(real(Xseuil)))
      enddo

      return
      end
	

c----------------------------------------------------------------------

	subroutine paramx3

c----------------------------------------------------------------------
c Return the 6 parameters of the fit of the sum of the soft pomeron
c and the semi-hard pomeron integrated over b 
c  alpd2(1)=parDf(1) and betD2(1)=parDf(2) for the effective soft 
c           pomeron
c  alpd2(2)=parDf(3) and betD2(2)=parDf(4) for the effective sh pomeron
c  alpd2(3)=parDf(5) and betD2(3)=parDf(6) for the transition
c----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incpar'
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
   
     
      double precision Dsoftshpar
     
      external Dsoftshpar

      dimension range(nbpf)

      call givedatax3
      
      numminDf=1  	
      numparDf=min(2*nbpDf,6)
      betac=.7
      betae=.01

c Initial value of the parameters ...    
                   parDf(7,3)=0.
                   parDf(8,3)=1.
                   parDf(9,3)=0.
                   parDf(10,3)=1.
                   parDf(11,3)=0.
                   parDf(12,3)=1.
      if(nbpDf.eq.1)then
        call pompar3(parDf(1,3),parDf(2,3),3)
	           parDf(3,3)=0.  
	           parDf(4,3)=1.
	           parDf(5,3)=0.  
	           parDf(6,3)=1.
                   chi2=0.
                   err=0.
        else
        call pompar3(parDf(1,3),parDf(2,3),2)
        call pompar3(parDf(3,3),parDf(4,3),3)
        if (nbpDf.gt.2)then
	           parDf(5,3)=-parDf(1,3)
	           parDf(6,3)=(parDf(2,3)+parDf(4,3))/2.
                   else
	           parDf(5,3)=0.  
	           parDf(6,3)=1.
                   endif

 	   range(1)=fparDf*parDf(1,3)			!alpD(1)
	   range(2)=fparDf*parDf(2,3)			!betD(1)
	   range(3)=fparDf*parDf(3,3)                   !alpD(2)
	   range(4)=fparDf*parDf(4,3)/2.      	        !betD(2)
	   range(5)=-parDf(5,3)                         !alpD(3)
	   range(6)=parDf(6,3)               	        !betD(3)

      do i=numminDf,numparDf
        parDf(i,1)=parDf(i,3)-range(i)
        parDf(i,2)=parDf(i,3)+range(i)
      enddo

	
      call fitx(Dsoftshpar,0.,nmcxDf,chi2,err)

      endif

      write(*,*) '%%%%%%%%%%%%%%%%%%% fitx3 %%%%%%%%%%%%%%%%%%%%%%%'
      write(*,*) 'nbpDf=',nbpDf
      write(*,*) 'chi2=',chi2
      write(*,*) 'err=',err
      write(*,*) 'alpD2(1)=',parDf(1,3),' betD2(1)=',parDf(2,3)
      write(*,*) 'alpD2(2)=',parDf(3,3),' betD2(2)=',parDf(4,3)
      write(*,*) 'alpD2(3)=',parDf(5,3),' betD2(3)=',parDf(6,3)
      write(*,*) 'alpD2(4)=',parDf(7,3),' betD2(4)=',parDf(8,3)
      
      do i=1,nbpDf
        alpD2(i,iclegy)=parDf(2*i-1,3)
        betD2(i,iclegy)=parDf(2*i,3)    
      enddo
	
      return
      end

c----------------------------------------------------------------------
	subroutine givedatax3
c----------------------------------------------------------------------
      
      include 'nexus.inc'
      include 'nexus.incpar'
      double precision X,X0,X1,Dsoftshval3,Xseuil

      numdataDf=nptf
      Smin=1000.**2         
      X0=xminDf           
      X1=xmaxDf
      Xseuil=X1
      iscr=2
      if(smaxDf.ge.Smin) Xseuil=5.d-2*X1

c Fit of G(X) between X0 and X1
      do i=0,nptf-1
        X=X0
        if (i.ne.0) X=X*(X1/X0)**(dble(i)/dble(nptf-1))
        datafitD(i+1,2)=max(1.e-10,
     &                real(Dsoftshval3(real(X)*smaxDf,X,0.d0,0.,iscr)))
        datafitD(i+1,1)=real(X)
        datafitD(i+1,3)=1.
        if (X.gt.Xseuil) datafitD(i+1,3)=1.+10.*(log(real(X))
     &                                   -log(real(Xseuil)))
      enddo

      return
      end
	
	
c----------------------------------------------------------------------
      subroutine paramb
c----------------------------------------------------------------------
c Find the parameter for the dependance on b of D the eikonale
c  gamD(1)=parDf(7) and delD(1)=parDf(8) for the effective soft pomeron
c  gamD(2)=parDf(9) and delD(2)=parDf(10) for the effective sh pomeron
c  gamD(3)=parDf(9) and delD(3)=parDf(10) for the transition
c----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incsem'
      include 'nexus.incpar'

      dimension range(nbpf)
      external sigma1ifit
      

        parDf(5,3)=0.
        parDf(6,3)=1.
      do i=1,min(nbpDf1,2)
        parDf(2*i-1,3)=alpD(i,iclegy,iclpro,icltar,icdp,icdt)
        parDf(2*i,3)=betD(i,iclegy,iclpro,icltar,icdp,icdt)
      enddo
      if(nbpDf1.eq.3)then
        parDf(5,3)=alpD(max(3,nbpDf1),iclegy,iclpro,icltar,icdp,icdt)
        parDf(6,3)=betD(max(3,nbpDf1),iclegy,iclpro,icltar,icdp,icdt)
      endif

      numminDf=9
      numparDf=12
      betac=70.
      
c Initial Values of the paramters ...
      call variance(parDf(10,3),parDf(9,3),0)  !delDf(1), gamDf(1)
      call variance(parDf(12,3),parDf(11,3),1) !delDf(2), gamDf(2)

      do i=numminDf,numparDf 
        range(i)=parDf(i,3)	
      enddo
		
      do i=numminDf,numparDf
        parDf(i,1)=parDf(i,3)-range(i)   !*0.99
        parDf(i,2)=parDf(i,3)+range(i)
      enddo

      call givedatab
	
      write(*,*) '%%%%%%%%%%%%%%%%%%% fitb %%%%%%%%%%%%%%%%%%%%%%%%'
      call fitb(sigma1ifit,nmcbDf,chi2)

      write(*,*) 'nbpDf1=',nbpDf1
      write(*,*) 'chi2=',chi2
      
      write(*,*) 'gamD(1) ',parDf(9,3),' delD(1) ',parDf(10,3)
      write(*,*) 'gamD(2) ',parDf(11,3),' delD(2) ',parDf(12,3)

      gamD(1,iclegy,iclpro,icltar,icdp,icdt)=parDf(9,3)
      gamD(2,iclegy,iclpro,icltar,icdp,icdt)=parDf(11,3)
      delD(1,iclegy,iclpro,icltar,icdp,icdt)=parDf(10,3)
      delD(2,iclegy,iclpro,icltar,icdp,icdt)=parDf(12,3)
      if(nbpDf1.eq.3)then
        gamD(max(3,nbpDf1),iclegy,iclpro,icltar,icdp,icdt)=parDf(10,3)
        delD(max(3,nbpDf1),iclegy,iclpro,icltar,icdp,icdt)=parDf(12,3)
      endif
      if(nbpDf1.gt.3)then
        gamD(max(3,nbpDf1-1),iclegy,iclpro,icltar,icdp,icdt)=0.
        delD(max(3,nbpDf1-1),iclegy,iclpro,icltar,icdp,icdt)=1.
      endif

      return
      end



c----------------------------------------------------------------------
	subroutine givedatab
c----------------------------------------------------------------------
      
      include 'nexus.inc'
      include 'nexus.incpar'
      double precision X,X0,X1,Xseuil
      

      X0=xminDf           
      X1=xmaxDf
      Xseuil=0.1d0*X1
      Smin=(130.)**2         
      if(iscreen.eq.0.or.iclpro.ne.2.or.icltar.ne.2)then
        if(smaxDf.gt.Smin) Xseuil=3.d-2*X1
      else         
        Xseuil=1.d-1*X1
      endif
      Xseuil=1.d0

c Fit of G(X) between X0 and X1
      do i=0,nptf-1
        X=X0
        if (i.ne.0) X=X*(X1/X0)**(dble(i)/dble(nptf-1))
        datafitD(i+1,2)=sigma1i(X)
        datafitD(i+1,1)=real(X)
        datafitD(i+1,3)=1.
        if (X.gt.Xseuil) datafitD(i+1,3)=1.+1.E+2*(log(real(X))
     &                                   -log(real(Xseuil)))
      enddo

      return
      end

c----------------------------------------------------------------------
      subroutine paramb2
c----------------------------------------------------------------------
c Find the parameter for the dependance on b of G1 
c  delD1(1) for the effective soft part
c  delD1(2) for the effective sh part
c   delD1(3) for the valence part
c  =delD1(4) for the valence part
c----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incpar'
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      double precision xmidDf
      external sigma2ifit
      dimension range(nbpf)

       do i=1,6
         do j=1,4
	   parDf(i,j)=1.
         enddo
       enddo
       ierr=0

       xmidDf=dsqrt(xminDf*xmaxDf)


	   parDf(15,3)=0.
	   parDf(16,3)=1.
       do i=1,min(nbpDf,2)
	   parDf(12+2*i-1,3)=alpD1(i,iclegy,iclpro)
	   parDf(12+2*i,3)=betD1(i,iclegy,iclpro)
       enddo
	   parDf(17,3)=0.    
	   parDf(18,3)=1.    
	   parDf(19,3)=0.  
           parDf(20,3)=1.
           parDf(21,3)=1.
	   parDf(22,3)=1.
	   parDf(7,3)=1.
	   parDf(8,3)=1.
       if(nbpDf.eq.4)then
         do i=3,4
	   parDf(12+2*i-1,3)=alpD1(i,iclegy,iclpro)
	   parDf(12+2*i,3)=betD1(i,iclegy,iclpro)
         enddo
           parDf(7,3)=betDp1(max(3,nbpDf-1),iclegy,iclpro)
	   parDf(8,3)=betDp1(nbpDf,iclegy,iclpro)
           parDf(22,3)=sigma2(xmidDf,789,ierr) !delD1(3)=delD1(4)
       if(ierr.eq.1)call utstop
     & ('In paramb2, initial sigma2(9) not def!&')
       endif

c Values of the parameters ...

      if(nbpDf.eq.1)then
      parDf(20,3)=sigma2(xmidDf,789,ierr)  !delD1(1)
      if(ierr.eq.1)call utstop
     &('In paramb2, initial sigma2(8) not def!&')
      chi2=0.

      else

      parDf(20,3)=sigma2(xminDf,789,ierr)  !delD1(1)
      if(ierr.eq.1)call utstop
     &('In paramb2, initial sigma2(7) not def!&')
      parDf(21,3)=sigma2(xmaxDf,789,ierr)  !delD1(2)
      if(ierr.eq.1)call utstop
     &('In paramb2, initial sigma2(8) not def !&')

	
      numminDf=20
      numparDf=21
      if(nbpDf.eq.4) numparDf=22 
      betac=100.
      
      do i=numminDf,numparDf 
        range(i)=parDf(i,3)	
      enddo
		
      do i=numminDf,numparDf
        parDf(i,1)=parDf(i,3)-0.5*range(i)  !-0.99*range(i)
        parDf(i,2)=parDf(i,3)+0.5*range(i)  !+range(i)
      enddo

      call givedatab2
	
      call fitb(sigma2ifit,nmcbDf,chi2)

      endif

      write(*,*) '%%%%%%%%%%%%%%%%%%% fitb2 %%%%%%%%%%%%%%%%%%%%%%%%'
      write(*,*) 'nbpDf=',nbpDf
      write(*,*) 'chi2=',chi2
      write(*,*)'delD(1) ',parDf(20,3)
      write(*,*)'delD(2) ',parDf(21,3)
      write(*,*)'delD(3)=delD(4) ',parDf(22,3)

      do i=1,min(nbpDf,2)
        delD1(i,iclegy,iclpro)=parDf(20+i-1,3)
      enddo
      if(nbpDf.ge.3)then
        delD1(max(3,nbpDf-1),iclegy,iclpro)=parDf(22,3)
        delD1(nbpDf,iclegy,iclpro)=parDf(22,3)
      endif

      return
      end
c----------------------------------------------------------------------
	subroutine givedatab2
c----------------------------------------------------------------------
      
      include 'nexus.inc'
      include 'nexus.incpar'
      double precision X,X0,X1,Xseuil
      

      X0=xminDf           
      X1=xmaxDf 
      Xseuil=1.d0

c Fit of G(X) between X0 and X1
      do i=0,nptf-1
        X=X0
        if (i.ne.0) X=X*(X1/X0)**(dble(i)/dble(nptf-1))
        datafitD(i+1,2)=sigma2i(X)
        datafitD(i+1,1)=real(X)
        datafitD(i+1,3)=1.
        if(X.lt.Xseuil)
     &    datafitD(i+1,3)=1./(1.+10.*exp(real(X)-1.))
c     &    datafitD(i+1,3)=-1./log(real(X/Xseuil))
      enddo

      return
      end

c----------------------------------------------------------------------
      subroutine paramb3
c----------------------------------------------------------------------
c Find the parameter for the dependance on b of G2
c  alpd2(1)=parDf(23) and betD2(1)=parDf(24) for the effective soft 
c           pomeron
c  alpd2(2)=parDf(25) and betD2(2)=parDf(26) for the effective sh pomeron
c  alpd2(3)=parDf(27) and betD2(3)=parDf(28) for the transition
c  delD2(1)=parDf(29) for the effective soft part
c  delD2(2)=parDf(30) for the effective sh part
c  delD2(3)=parDf(29) for the transition
c----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incpar'
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      external sigma3ifit,G2parb
      dimension range(nbpf)
      double precision Dsoftshval3,G2parb

     
      ierr=0

      
c Values of the parameters ...
      if(nbpDf.eq.1)then
      parDf(29,3)=sigma2(xmaxDf,6,ierr)  !delD2(1)=delD2(3)
      if(ierr.eq.1)call utstop
     &('In paramb3, initial sigma2(6) not def!&')
      parDf(30,3)=1.
      write(*,*)  'ini paramb3',parDf(29,3),parDf(30,3)
      chi2=0.

      else

      parDf(29,4)=sigma2(xminDf,5,ierr)  !delD2(1)=delD2(3)
      if(ierr.eq.1)call utstop
     &('In paramb3, initial sigma2(5) not def!&')
      parDf(30,4)=sigma2(xmaxDf,6,ierr)  !delD2(2)
      if(ierr.eq.1)call utstop
     &('In paramb3, initial sigma2(6) not def!&')
      parDf(29,3)=real(
     &            Dsoftshval3(real(xminDf)*smaxDf,xminDf,0.d0,0.,12)
     &           /Dsoftshval3(real(xminDf)*smaxDf,xminDf,0.d0,0.,5))
      parDf(30,3)=real(
     &            Dsoftshval3(real(xmaxDf)*smaxDf,xmaxDf,0.d0,0.,13)
     &           /Dsoftshval3(real(xmaxDf)*smaxDf,xmaxDf,0.d0,0.,6))

      write(*,*)  'ini paramb3',parDf(29,3),parDf(30,3)


      numminDf=29
      numparDf=30
      betac=.07
      betae=.01

      do i=numminDf,numparDf 
        range(i)=parDf(i,4)	
      enddo
		
      do i=numminDf,numparDf
        parDf(i,1)=parDf(i,4)-0.1*range(i)
        parDf(i,2)=parDf(i,4)+0.5*range(i)
      enddo
        parDf(30,2)=parDf(30,4)+0.1*range(30)

      call givedatab3
	
      call fitx(G2parb,0.,nmcbDf,chi2,err)

      endif

      write(*,*) '%%%%%%%%%%%%%%%%%%% fitb3 %%%%%%%%%%%%%%%%%%%%%%%%'
      write(*,*) 'nbpDf=',nbpDf
      write(*,*) 'chi2=',chi2
      write(*,*) 'delD2(1)=delD2(3) ',parDf(29,3)
      write(*,*) 'delD2(2) ',parDf(30,3)

        delD2(1,iclegy)=parDf(29,3)
      if(nbpDf.ge.2)then
        delD2(min(2,nbpDf),iclegy)=parDf(30,3)
        if(nbpDf.ge.3)then
        delD2(min(3,nbpDf),iclegy)=parDf(29,3)
        elseif(nbpDf.eq.4)then
        delD2(nbpDf,iclegy)=1.
        endif
      endif

      return
      end

c----------------------------------------------------------------------
	subroutine givedatab3
c----------------------------------------------------------------------
      
      include 'nexus.inc'
      include 'nexus.incpar'
      double precision X,X0,X1,Xseuil,Dsoftshval3
      

      X0=xminDf           
      X1=xmaxDf 
      Xseuil=1.d0*X1
      Smin=(50.)**2.         

      if(smaxDf.ge.Smin) Xseuil=min(5.d-2,500.d0/dble(smaxDf))

c Fit of G(X) between X0 and X1
      do i=0,nptf-1
        X=X0
        if (i.ne.0) X=X*(X1/X0)**(dble(i)/dble(nptf-1))
        datafitD(i+1,2)=max(1.e-10,
     &                real(Dsoftshval3(real(X)*smaxDf,X,0.d0,0.,1)))
        datafitD(i+1,1)=real(X)
        datafitD(i+1,3)=2.
        if (X.gt.Xseuil) datafitD(i+1,3)=1.+10.*(log(real(X))
     &                                   -log(real(Xseuil)))
      enddo

      return
      end

c----------------------------------------------------------------------
      subroutine paramasym
c----------------------------------------------------------------------
c Find the parameter for the dependance on xp and xm of D the eikonale
c 2*alpD(4)*Smax**betD(4)=parDf(7) and betD(4)=parDf(8) for sharing
c alpDp(1)=parDf(15) and betDp(1)=parDf(16) for soft and xp
c alpDp(2)=parDf(17) and betDp(2)=parDf(18) for valence and xp
c alpDp(3)=parDf(19) and betDp(3)=parDf(20) for sharing and xp
c alpDp(4)=parDf(21) and betDp(4)=parDf(22) for sharing and xp
c alpDpp(1)=parDf(23) and betDpp(1)=parDf(24) for soft and xm
c alpDpp(2)=parDf(25) and betDpp(2)=parDf(26) for valence and xm
c alpDpp(3)=parDf(27) and betDpp(3)=parDf(28) for sharing and xm
c alpDpp(4)=parDf(29) and betDpp(4)=parDf(30) for sharing and xm
c----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incsem'
      include 'nexus.incpar'
     
     
      external Dasym

      dimension range(nbpf)

c Set Initial Values



      do i=1,30
        do j=1,4
          parDf(i,j)=0.
        enddo
      enddo
      do j=1,4
        parDf(10,j)=1.
        parDf(12,j)=1.
        parDf(13,j)=1.
        parDf(14,j)=1.
      enddo

      do i=1,nbpDf1
        parDf(2*i,3)=1.         !betD
        parDf(14+2*i,3)=1.	!betDp
        parDf(22+2*i,3)=1.	!betDpp
      enddo

      numminDf=1
      numparDf=3

      call pompar(parDf(5,3),parDf(6,3),2)     !lambda & betD(3)
      call pompar(tmp,parDf(24,3),8)           !alpDp
c      call pompar(tmp,parDf(6,3),2)           !lambda & betD(3)
c      call pompar(parDf(5,3),parDf(24,3),7)   !alpDp
c      call pompary(xminDf**0.3d0,parDf(23,3),parDf(1,3),1)   !alpDpp(3)
c      call pompary(xminDf**0.3d0,parDf(25,3),parDf(3,3),2)   !alpDpp(4)
      call pompary(xfitmin,parDf(23,3),parDf(1,3),1)   !alpDpp(3)
      call pompary(xfitmin,parDf(25,3),parDf(3,3),2)   !alpDpp(4)
c      call variance(parDf(13,3),tmp,3)         !delDf(3) 
      parDf(13,3)=delD(2,iclegy,iclpro,icltar,icdp,icdt)

c      parDf(5,3)=parDf(5,3)/smaxDf**parDf(6,3)
     
      parDf(8,3)=parDf(6,3)
      parDf(26,3)=parDf(24,3)
      parDf(2,3)=0.
      if(parDf(25,3).ne.0.)parDf(2,3)=parDf(23,3)/parDf(25,3)
      parDf(14,3)=parDf(13,3)


c$$$      call pompar(parDf(7,3),tmp,7)            !alpD(4)
c$$$      if(parDf(7,3).ne.0.)then
c$$$      numparDf=8
c$$$      parDf(8,3)=parDf(6,3)                    !betD(4)
c$$$      call pompar(tmp,parDf(22,3),5)           !betDp(4)
c$$$      call pompar(tmp,parDf(30,3),6)           !betDpp(4)
c$$$      call variance(parDf(14,3),tmp,4)         !delDf(4) 
c$$$      endif
      

c Find AlpD(4)=AlpDp(4)+AlpDpp(4) (for x=1) and betD(4)
      

      betac=7.
      
c Initial Values of the paramters ...


        range(1)=parDf(1,3)*fparDf	
        range(2)=0. !parDf(2,3)*fparDf
        range(3)=parDf(3,3)*fparDf
      do i=numminDf,numparDf
        parDf(i,1)=parDf(i,3)-range(i)
        parDf(i,2)=parDf(i,3)+range(i)
      enddo

c      call givedataxp(xminDf**0.3d0)
      call givedataxp(xfitmin)
	
      write(*,*) '%%%%%%%%%%%%%%%%%%% fity %%%%%%%%%%%%%%%%%%%%%%%%'
      call fitb(Dasym,nmcxDf,chi2xp)

c$$$      parDf(19,3)=-parDf(5,3)
c$$$      parDf(21,3)=-parDf(7,3)/smaxDf**(parDf(8,3)
c$$$     &                                 -(parDf(22,3)+parDf(30,3))/2.)
      parDf(19,3)=-parDf(2,3)/(1.+parDf(2,3))*parDf(5,3)
      parDf(21,3)=-1./(1.+parDf(2,3))*parDf(5,3)
      parDf(20,3)=parDf(24,3)+parDf(1,3)/2.
      parDf(22,3)=parDf(26,3)+parDf(3,3)/2.
      parDf(28,3)=parDf(24,3)-parDf(1,3)/2.
      parDf(30,3)=parDf(26,3)-parDf(3,3)/2.


      write(*,*) 'nbpDf1=',nbpDf1
      write(*,*) 'chi2=',chi2xp
      write(*,*) 'betD(3), alpD(3), betDp(3), betDpp(3), DelD(3) :' 
      write(*,*) parDf(6,3),parDf(19,3),parDf(20,3),parDf(28,3),
     $           parDf(13,3)
      write(*,*) 'betD(4), alpD(4), betDp(4), betDpp(4), DelD(4) :' 
      write(*,*) parDf(8,3),parDf(21,3),parDf(22,3),parDf(30,3),
     $           parDf(14,3)
      
      if(nbpDf1.eq.4)then
        
          alpDp(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)=parDf(24,3) 
          alpDpp(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)=parDf(1,3) 
          betD(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)=parDf(6,3)     
          gamD(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)=
     *         gamD(2,iclegy,iclpro,icltar,icdp,icdt)
          alpDp(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)=parDf(26,3) 
          alpDpp(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)=parDf(3,3) 
          betD(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)=parDf(8,3)     
          gamD(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)=
     *         gamD(2,iclegy,iclpro,icltar,icdp,icdt)

          alpD(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)=parDf(19,3)
          betDp(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)=parDf(20,3)
          betDpp(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)=parDf(28,3)
          delD(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)=parDf(13,3)

          alpD(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)=parDf(21,3)
          betDp(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)=parDf(22,3)
          betDpp(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)=parDf(30,3)
          delD(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)=parDf(14,3)

          slim=alpD(1,iclegy,iclpro,icltar,icdp,icdt)
     &         *smaxDf**betD(1,iclegy,iclpro,icltar,icdp,icdt)
     &         +alpD(2,iclegy,iclpro,icltar,icdp,icdt)
     &         *smaxDf**betD(2,iclegy,iclpro,icltar,icdp,icdt)

          if(-alpD(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)
     &*smaxDf**betD(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)
     &       -alpD(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)
     &*smaxDf**betD(nbpDf1,iclegy,iclpro,icltar,icdp,icdt).gt.slim)then

            write(*,*)"In Param, slim overhead"

c$$$            alpDp(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)=
c$$$     &           alpDp(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)
c$$$     &           -betD(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)
c$$$            alpDp(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)=
c$$$     &           alpDp(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)
c$$$     &           -betD(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)
c$$$
c$$$            betD(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)=
c$$$     &           betD(2,iclegy,iclpro,icltar,icdp,icdt)
c$$$     &           +betD(1,iclegy,iclpro,icltar,icdp,icdt)/2.
c$$$            betD(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)=
c$$$     &           betD(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)
c$$$
c$$$            alpDp(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)=
c$$$     &           alpDp(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)
c$$$     &           +betD(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)
c$$$            alpDp(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)=
c$$$     &           alpDp(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)
c$$$     &           +betD(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)

            alpD(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)=slim
     &      /(-2.*smaxDf**betD(nbpDf1,iclegy,iclpro,icltar,icdp,icdt))

            alpD(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)=
     &                                -parDf(2,3)/(1.+parDf(2,3))*slim
     &      /(smaxDf**betD(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt))
            alpD(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)=
     &                                -1./(1.+parDf(2,3))*slim
     &      /(smaxDf**betD(nbpDf1,iclegy,iclpro,icltar,icdp,icdt))

            betDp(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)=
     &           alpDp(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)
     &          +alpDpp(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)/2.

            betDpp(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)=
     &           alpDp(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)
     &          -alpDpp(nbpDf1,iclegy,iclpro,icltar,icdp,icdt)/2.

            betDp(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)=
     &           alpDp(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)
     &          +alpDpp(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)/2.

            betDpp(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)=
     &           alpDp(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)
     &          -alpDpp(nbpDf1-1,iclegy,iclpro,icltar,icdp,icdt)/2.

        endif

      endif

      return
      end


c----------------------------------------------------------------------
      subroutine givedataxp(x)
c----------------------------------------------------------------------
      
      include 'nexus.inc'
      include 'nexus.incsem'
      include 'nexus.incpar'
      double precision x,Dsoftshval,ymax,Y,norm!,Xseuil,X0,X1

      numdataDf=nptf
      norm=Dsoftshval(real(x)*smaxDf,x,0.d0,0.,-1)
      ymax=-0.5d0*dlog(x)

c      X0=xminDf           
c      X1=xmaxDf
c      Xseuil=X1
c      Smin=(100.)**2         
c      if(smaxDf.gt.Smin) Xseuil=5.d-2*X1

c Fit of G(X) between X0 and X1
      do i=0,nptf-1
c        if (i.ne.0) X=X*(X1/X0)**(dble(i)/dble(nptf-1))
        Y=-ymax+ymax*(dble(i)/dble(nptf))
        datafitD(i+1,2)=max(1.e-10,
     &  real(dabs(Dsoftshval(real(x)*smaxDf,x,Y,0.,-1)/norm)))
        datafitD(i+1,1)=real(Y)
        datafitD(i+1,3)=4.
c        if (X.gt.Xseuil) datafitD(i+1,3)=2.+1.E+2*(log(real(X))
c     &                                   -log(real(Xseuil)))
      enddo

      return
      end
	

c----------------------------------------------------------------------
      subroutine paramasym2
c----------------------------------------------------------------------
c Find the parameter for the dependance on xp of D the eikonale
c alpD1(1)=parDf(13)   and betD1(1)=parDf(14) for soft
c alpD1(2)=parDf(15)   and betD1(2)=parDf(16) for gg
c alpD1(3)=parDf(17)   and betD1(3)=parDf(18) for qg
c alpD1(4)=parDf(19)   and betD1(4)=parDf(18) for qg
c betDp1(3)=parDf(7) for qg
c betDp1(4)=parDf(8) for qg
c----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incpar'
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
          

c Set Initial Values

      do i=1,2
        parDf(12+2*i-1,3)=alpD1(i,iclegy,iclpro)
        parDf(12+2*i,3)=betD1(i,iclegy,iclpro)
      enddo

      call pompar2(tmp,parDf(18,3),5)               !betD1(3)
 	
            
c Initial Values of the paramters ...

      call pompar2(parDf(17,3),parDf(7,3),3)       !betDp1(3)
      call pompar2(parDf(19,3),parDf(8,3),4)       
                   parDf(17,3)=parDf(17,3)/smaxDf**parDf(18,3)   !alpD1(3)
                   parDf(19,3)=parDf(19,3)/smaxDf**parDf(18,3)   !alpD1(4)
     	
      write(*,*) '%%%%%%%%%%%%%%%%%%% fitxp2 %%%%%%%%%%%%%%%%%%%%%%%%'
      write(*,*) 'nbpDf=',nbpDf
      write(*,*) 'betD1(3), alpD1(3), betDp1(3) :' 
      write(*,*) parDf(18,3),parDf(17,3),parDf(7,3)
      
      write(*,*) 'betD1(4), alpD1(4), betDp1(4) :' 
      write(*,*) parDf(18,3),parDf(19,3),parDf(8,3)

      if(nbpDf.eq.4)then
        alpD1(max(3,nbpDf-1),iclegy,iclpro)=parDf(17,3)
        betD1(max(3,nbpDf-1),iclegy,iclpro)=parDf(18,3)     
        betDp1(max(3,nbpDf-1),iclegy,iclpro)=parDf(7,3)     
        alpD1(nbpDf,iclegy,iclpro)=parDf(19,3)
        betD1(nbpDf,iclegy,iclpro)=parDf(18,3)     
        betDp1(nbpDf,iclegy,iclpro)=parDf(8,3)
      endif     


      return
      end


c----------------------------------------------------------------------
	subroutine givedataxp2
c----------------------------------------------------------------------
      
      include 'nexus.inc'
      include 'nexus.incpar'
      double precision X,X0,X1,Dsoftshval2,Xseuil,y

      numdataDf=nptf
      Smin=100.
      X0=dble(Smin/smaxDf)        
      X1=xmaxDf
      Xseuil=1.d-1

c.....Fit of G(X) between X0 and X1
      do i=0,nptf-1
        X=X0
        if (i.ne.0) X=X*(X1/X0)**(dble(i)/dble(nptf-1))
        y=.5d0*dlog(x)
        datafitD(i+1,2)=max(1.e-10,
     $       real(Dsoftshval2(real(X)*smaxDf,X,y,0.,9)))
        datafitD(i+1,1)=real(X)
        datafitD(i+1,3)=3.
        if(X.gt.Xseuil) datafitD(i+1,3)=0.5
c     &              1./(1.+10.*exp(2.*(real(X)-1.)/(1.-real(Xseuil))))
      enddo

      return
      end
      

c----------------------------------------------------------------------

	subroutine pompar(alpha,beta,iqq)

c----------------------------------------------------------------------
c  Return the power beta and the factor alpha of the fit of the eikonal
c of a pomeron of type iqq : D(X)=alpha*(X)**beta
c----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incsem'
      include 'nexus.incpar'
      common /psar7/  delx,alam3p,gam3p
      double precision X,D1,D0,X0,D,droot,drootscr1,drootscr2,drootscr
      double precision Dsoftshval,xmax,drootscr3
      dimension xlnXs(maxdataDf),xlnD(maxdataDf),sigma(maxdataDf)
            
      do i=1,nptf
        sigma(i)=1.e-2
      enddo

      if(iqq.eq.0) then
      
        iscr=0
        xmax=min(0.1d0,100.d0*xminDf) 
	X0=xminDf
	if(ish.ge.4)write (*,*) 'pompar (0) x0,xmax=',X0,xmax

        do i=0,nptf-1
          X=X0
          if (i.ne.0) X=X*(xmax/X0)**(dble(i)/dble(nptf-1))
          D=max(1.d-10,Dsoftshval(real(X)*smaxDf,X,0.d0,0.,iscr))
          if(D.eq.1.d-10) write(*,*) 
     &    "Warning in pompar ! Dsoftshval(0) could be negative"
          xlnXs(i+1)=real(dlog(X*dble(smaxDf)))
          xlnD(i+1)=real(dlog(D))
        enddo

	
c Fit of D(X) between X0 and xmax

	call fit(xlnXs,xlnD,nptf,sigma,0,a,beta)
	if(beta.gt.10.)beta=10.
	
	alpha=real(Dsoftshval(real(X0)*smaxDf,X0,0.d0,0.,iscr))
     &       *(real(X0)*smaxDf)**(-beta)   


      elseif(iqq.eq.1.and.xfitmin.ne.1.d0) then
      
        iscr=2
        xmax=2.d0/max(2.d0,dlog(dble(smaxDf)/1.d3)) 
     
c Definition of D0=D(X0)

	D1=Dsoftshval(real(xmax)*smaxDf,xmax,0.d0,0.,iscr)

	D0=xfitmin*D1
	
c Calculation of X0 and D(X)

	X0=droot(D0,D1,xmax,iscr)
	if(ish.ge.4)write (ifmt,*) 'pompar (1) x0,xmax=',X0,xmax

        do i=0,nptf-1
          X=X0
          if (i.ne.0) X=X*(xmax/X0)**(dble(i)/dble(nptf-1))
          D=max(1.d-10,Dsoftshval(real(X)*smaxDf,X,0.d0,0.,iscr))
          if(D.eq.1.d-10) write(*,*) 
     &    "Warning in pompar ! Dsoftshval(2) could be negative"
          xlnXs(i+1)=real(dlog(X*dble(smaxDf)))
          xlnD(i+1)=real(dlog(D))
        enddo

	
c Fit of D(X) between X0 and xmax

	call fit(xlnXs,xlnD,nptf,sigma,0,a,beta)
	if(beta.gt.10.)beta=10.
	
	alpha=real(Dsoftshval(real(xmax)*smaxDf,xmax,0.d0,0.,iscr))
     &       *(real(xmax)*smaxDf)**(-beta)   


      elseif (iqq.eq.2) then    ! iqq=2
      
        iscr=-1
        xmax=xmaxDf
      
c Definition of D0=D(X0)
	D1=dabs(Dsoftshval(real(xmax)*smaxDf,1.d0,0.d0,0.,iscr))
        if(D1.gt.1.d-10)then

	D0=xfitmin*D1
	
c Calculation of X0 and D(X)

	X0=drootscr(D0,D1,xmax)

	if(ish.ge.4)write (*,*) 'pompar (2) x0=',X0

        do i=0,nptf-1
          X=X0
          if (i.ne.0) X=X*(xmax/X0)**(dble(i)/dble(nptf-1))
          D=dabs(Dsoftshval(real(X)*smaxDf,1.d0,0.d0,0.,iscr))
          xlnXs(i+1)=real(dlog(X*dble(smaxDf)))
          xlnD(i+1)=real(dlog(max(D,1.d-10)))
        enddo
	
c.......Fit of D(X) between X0 and xmax

	call fit(xlnXs,xlnD,nptf,sigma,0,a,beta)
	if(beta.gt.10.)beta=10.
	
        alpha=real(dabs(Dsoftshval(smaxDf,1.d0,0.d0,0.,iscr)))
     &             /smaxDf**beta
      else
        alpha=0.
        beta=0.
      endif
     

      elseif (iqq.eq.3) then    ! iqq=3

        iscr=-1
        xmax=xmaxDf
      
c Definition of D0=D(X0)
	D1=dabs(Dsoftshval(real(xmax)*smaxDf,xmax,
     *                     0.5d0*dlog(xmax),0.,iscr))
        if(D1.gt.1.d-10)then
	D0=xfitmin*D1
	
c Calculation of X0 and D(X)

	X0=drootscr1(D0,D1,xmax)
c	X0=droot(D0,D1,xmax,iscr)
      
c	X0=.1d0
	if(ish.ge.4)write (*,*) 'pompar (3) x0=',X0

        do i=0,nptf-1
          X=X0
          if (i.ne.0) X=X*(xmax/X0)**(dble(i)/dble(nptf-1))
          D=dabs(Dsoftshval(real(X)*smaxDf,X,0.5d0*dlog(X),0.,iscr))
          xlnXs(i+1)=real(dlog(X))
          xlnD(i+1)=real(dlog(max(D,1.d-10)))
        enddo
	
c.......Fit of D(X) between X0 and xmax

	call fit(xlnXs,xlnD,nptf,sigma,0,a,beta)
	if(beta.gt.10.)beta=10.
	
      alpha=real(dabs(Dsoftshval(smaxDf,1.d0,0.d0,0.,iscr)))
      else
        alpha=0.
        beta=0.
      endif

      elseif (iqq.eq.4) then    ! iqq=4

        iscr=-1
        xmax=xmaxDf
      
c Definition of D0=D(X0)
	D1=dabs(Dsoftshval(real(xmax)*smaxDf,xmax,
     *                     -0.5d0*dlog(xmax),0.,iscr))
        if(D1.gt.1.d-10)then
	D0=xfitmin*D1
	
c Calculation of X0 and D(X)

	X0=drootscr2(D0,D1,xmax)
c	X0=droot(D0,D1,xmax,iscr)
      
c	X0=.1d0
	if(ish.ge.4)write (*,*) 'pompar (4) x0=',X0

        do i=0,nptf-1
          X=X0
          if (i.ne.0) X=X*(xmax/X0)**(dble(i)/dble(nptf-1))
          D=dabs(Dsoftshval(real(X)*smaxDf,X,-0.5d0*dlog(X),0.,iscr))
          xlnXs(i+1)=real(dlog(X))
          xlnD(i+1)=real(dlog(max(D,1.d-10)))
        enddo
	
c.......Fit of D(X) between X0 and xmax

	call fit(xlnXs,xlnD,nptf,sigma,0,a,beta)
	if(beta.gt.10.)beta=10.
	
      alpha=real(dabs(Dsoftshval(smaxDf,1.d0,0.d0,0.,iscr)))
      else
        alpha=0.
        beta=0.
      endif

      elseif (iqq.eq.5) then    ! iqq=5
      
        iscr=-1
	X0=xminDf
        xmax=min(0.1d0,100.d0*xminDf)
      
c Definition of D0=D(X0)
	D1=dabs(Dsoftshval(real(X0)*smaxDf,X0,0.5d0*dlog(X0),0.,iscr))
        if(D1.gt.1.d-10)then

	if(ish.ge.4)write (*,*) 'pompar (5) Xmax=',xmax

        do i=0,nptf-1
          X=X0
          if (i.ne.0) X=X*(xmax/X0)**(dble(i)/dble(nptf-1))
          D=dabs(Dsoftshval(real(X)*smaxDf,X,0.5d0*dlog(X),0.,iscr))
          xlnXs(i+1)=real(dlog(X))
          xlnD(i+1)=real(dlog(max(D,1.d-10)))
        enddo
	
c.......Fit of D(X) between X0 and xmax

	call fit(xlnXs,xlnD,nptf,sigma,0,a,beta)
	if(beta.gt.10.)beta=10.
	
	alpha=real(dabs(Dsoftshval(real(X0)*smaxDf,X0,
     &                             0.5d0*dlog(X0),0.,iscr))
     &              /X0**dble(beta))
      else
        alpha=0.
        beta=0.
      endif
     

      elseif (iqq.eq.6) then    ! iqq=6

        iscr=-1
	X0=xminDf
        xmax=min(0.1d0,100.d0*xminDf)

c Definition of D0=D(X0)
        D1=dabs(Dsoftshval(real(X0)*smaxDf,X0,-0.5d0*dlog(X0),0.,iscr))

        if(D1.gt.1.d-10)then
		
c Calculation of X0 and D(X)

	if(ish.ge.4)write (*,*) 'pompar (6) Xmax=',xmax

        do i=0,nptf-1
          X=X0
          if (i.ne.0) X=X*(xmax/X0)**(dble(i)/dble(nptf-1))
          D=dabs(Dsoftshval(real(X)*smaxDf,X,-0.5d0*dlog(X),0.,iscr))
          xlnXs(i+1)=real(dlog(X))
          xlnD(i+1)=real(dlog(max(D,1.d-10)))
        enddo
	
c.......Fit of D(X) between X0 and xmax

	call fit(xlnXs,xlnD,nptf,sigma,0,a,beta)
	if(beta.gt.10.)beta=10.
	
        alpha=real(dabs(Dsoftshval(real(X0)*smaxDf,X0,
     &                             -0.5d0*dlog(X0),0.,iscr))
     &              /X0**dble(beta))
      else
        alpha=0.
        beta=0.
      endif

      elseif (iqq.eq.7) then    ! iqq=7
      
        iscr=-1
	X0=xminDf
        xmax=dsqrt(X0) !min(0.1d0,100.d0*xminDf)
      
c Definition of D0=D(X0)
	D0=dabs(Dsoftshval(real(x0)*smaxDf,x0,0.d0,0.,iscr))
c	D1=dabs(Dsoftshval(smaxDf,xmaxDf,0.d0,0.,iscr))
c        if(D0.gt.1.d-10.and.D1.gt.5.d0*D0)then
        if(D0.gt.1.d-10)then

	if(ish.ge.4)write (*,*) 'pompar (7) Xmax=',xmax

        do i=0,nptf-1
          X=X0
          if (i.ne.0) X=X*(xmax/X0)**(dble(i)/dble(nptf-1))
          D=dabs(Dsoftshval(real(X)*smaxDf,X,0.d0,0.,iscr))
          xlnXs(i+1)=real(dlog(X))
          xlnD(i+1)=real(dlog(max(D,1.d-10)))
        enddo
	
c.......Fit of D(X) between X0 and xmax

	call fit(xlnXs,xlnD,nptf,sigma,0,a,beta)
	if(beta.gt.10.)beta=10.
	
	alpha=real(dabs(Dsoftshval(real(x0)*smaxDf,x0,0.d0,0.,iscr))
     &                  /X0**dble(beta))
      else
        alpha=0.
        beta=0.
      endif
     
      elseif (iqq.eq.8) then    ! iqq=8
      
        iscr=-1
        xmax=xmaxDf
      
c Definition of D0=D(X0)
	D1=dabs(Dsoftshval(real(xmax)*smaxDf,xmax,0.d0,0.,iscr))
        if(D1.gt.1.d-10)then

	D0=xfitmin*D1
	
c Calculation of X0 and D(X)

	X0=drootscr3(D0,D1,xmax)
c        X0=xminDf**0.3d0
c        X0=.1d0

	if(ish.ge.4)write (*,*) 'pompar (8) x0=',X0

        do i=0,nptf-1
          X=X0
          if (i.ne.0) X=X*(xmax/X0)**(dble(i)/dble(nptf-1))
          D=dabs(Dsoftshval(real(X)*smaxDf,X,0.d0,0.,iscr))
          xlnXs(i+1)=real(dlog(X))
          xlnD(i+1)=real(dlog(max(D,1.d-10)))
        enddo
	
c.......Fit of D(X) between X0 and xmax

	call fit(xlnXs,xlnD,nptf,sigma,0,a,beta)
	if(beta.gt.10.)beta=10.
	
        alpha=real(dabs(Dsoftshval(real(xmax)*smaxDf,xmax,0.d0,0.,iscr))
     &             /xmax**dble(beta))
      else
        alpha=0.
        beta=0.
      endif
     
      else                      !iqq=-1 or iqq=1 and xfitmin=1

c Calculation of X0 and D(X)
        iscr=0    

	X0=min(dble(Eseuil**2./smaxDf),1.d-2) !xminDf
        if(engy.lt.Eseuil)X0=1.d0/dble(smaxDf)
        xmax=max(2.d0/dble(smaxDf),
     &       min(max(0.03d0,dble(smaxDf)/2.d5),0.1d0)) 

      	if(ish.ge.4)write (*,*) 'pompar (-1) x0,xmax=',X0,xmax

        do i=0,nptf-1
          X=X0
          if (i.ne.0) X=X*(xmax/X0)**(dble(i)/dble(nptf-1))
          D=max(1.d-10,Dsoftshval(real(X)*smaxDf,X,0.d0,0.,iscr))
          if(D.eq.1.d-10) write(*,*) 
     &    "Warning in pompar ! Dsoftshval(0) could be negative"
          xlnXs(i+1)=real(dlog(X*dble(smaxDf)))
          xlnD(i+1)=real(dlog(D))
        enddo
	
c Fit of D(X) between X0 and xmax

	call fit(xlnXs,xlnD,nptf,sigma,0,a,beta)
	if(beta.gt.10.)beta=10.

	
        if(engy.lt.Eseuil)then
          alpha=real(Dsoftshval(real(X0)*smaxDf,X0,0.d0,0.,iscr))
     &           *(real(X0)*smaxDf)**(-beta)
        else
          alpha=real(Dsoftshval(real(xmax)*smaxDf,xmax,0.d0,0.,iscr))
     &           *(real(xmax)*smaxDf)**(-beta)            
        endif
      endif

	if(ish.ge.4)write(*,*) '%%%%%%%%%%%%% pompar %%%%%%%%%%%%%%%%%%'
	if(ish.ge.4)write(*,*) 'alpD ini =',alpha,' betD ini=',beta

      return
      end


c----------------------------------------------------------------------

	subroutine pompar2(alpha,beta,iqq)

c----------------------------------------------------------------------
c  Return the power beta and the factor alpha of the fit of the eikonal
c of a pomeron of type iqq : D(X)=alpha*(X)**beta
c----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incpar'
      double precision X,X0,D,xmax,y
      double precision Dsoftshval2,D1,D0,droot2
      dimension xlnXs(maxdataDf),xlnD(maxdataDf),sigma(maxdataDf)
            
      do i=1,nptf
        sigma(i)=1.e-2
      enddo

      if (iqq.eq.0.or.(iqq.eq.1.and.xfitmin.eq.1.d0)) then

c Calculation of X0 and D(X)
        iscr=2
        X0=xminDf
        xmax=min(1.d0,4.d0*xminDf)
	if(ish.ge.4)write (*,*) 'pompar2 (0) x0=',X0

        do i=0,nptf-1
          X=X0
          if (i.ne.0) X=X*(xmax/X0)**(dble(i)/dble(nptf-1))
          D=max(1.d-10,Dsoftshval2(real(X)*smaxDf,1.d0,0.d0,0.,iscr))
          if(D.eq.1.d-10) write(*,*) 
     &    "Warning in pompar2 ! Dsoftshval2(2) could be negative"
          xlnXs(i+1)=real(dlog(X*dble(smaxDf)))
          xlnD(i+1)=real(dlog(D))
        enddo
	
c Fit of D(X) between X0 and xmax

	call fit(xlnXs,xlnD,nptf,sigma,0,a,beta)
	
	alpha=real(Dsoftshval2(real(X0)*smaxDf,1.d0,0.d0,0.,iscr))
     &           *(real(X0)*smaxDf)**(-beta) 
	
	
	elseif (iqq.eq.1.and.xfitmin.ne.1.d0) then
      
        iscr=17
        xmax=xmaxDf
	D1=Dsoftshval2(real(xmax)*smaxDf,xmax,0.d0,0.,iscr)
        if(D1.gt.1.d-10)then

	D0=xfitmin*D1
	
c Calculation of X0 and D(X)

	X0=droot2(D0,D1,xmax,iscr)      
      

	if(ish.ge.4)write (*,*) 'pompar2(1) x0=',X0

      do i=0,nptf-1
        X=X0
        if (i.ne.0) X=X*(xmax/X0)**(dble(i)/dble(nptf-1))
        D=max(1.d-10,Dsoftshval2(real(X)*smaxDf,1.d0,0.d0,0.,iscr))
          if(D.eq.1.d-10) write(*,*) 
     &    "Warning in pompar2 ! Dsoftshval2(2) could be negative"
        xlnXs(i+1)=real(dlog(X*dble(smaxDf)))
        xlnD(i+1)=real(dlog(D))
      enddo

	
c Fit of D(X) between X0 and xmax

      call fit(xlnXs,xlnD,nptf,sigma,0,a,beta)
	
      alpha=real(Dsoftshval2(real(xmax)*smaxDf,1.d0,0.d0,0.,iscr))
     &           *(real(xmax)*smaxDf)**(-beta)   
     
      else
        alpha=0.
        beta=1.
      endif

     
      else                      !iqq=3,4,5 or 6

	spmin=15.               !2.*4.*q2min
	if(iqq.eq.3) then
c          X0=dble(max(1./spmin,1.e-3))  !xminDf
          X0=1.d0/dble(smaxDf)  !xminDf
          xmax=max(10.d0*X0,1.d-5)
c          xmax=0.1d0
          if(xmax.ge.xmaxDf) xmax=xmaxDf
        elseif(iqq.eq.4) then
          X0=dble(max(1./spmin,1.e-3))
          xmax=min(0.8d0,xmaxDf)
c          X0=.7d0
        elseif(iqq.eq.5) then
          xmax=0.1d0  !0.7d0  !xmaxDf
        if(smaxDf.le.1000.**2.)xmax=xfitmin
          X0=xfitmin/10.d0 !min(200.d0*xminDf,0.6d0)   !0.7d0
        endif

	if(ish.ge.4)write (*,*) 'x0=',X0

        do i=0,nptf-1
          X=X0
          if (i.ne.0) X=X*(xmax/X0)**(dble(i)/dble(nptf-1))
          y=0.5d0*dlog(X)
          if(iqq.eq.3.or.iqq.eq.4) D=Dsoftshval2(smaxDf,X,y,0.,18)
          if(iqq.eq.5) D=Dsoftshval2(real(X)*smaxDf,1.d0,0.d0,0.,18)
          xlnXs(i+1)=real(dlog(X))
          xlnD(i+1)=real(dlog(max(D,1.d-10)))
        enddo
	
c Fit of D(X) between X0 and xmax
        
	call fit(xlnXs,xlnD,nptf,sigma,0,a,beta)
        
	if(iqq.eq.3) then
          xmax=X0*10.d0
          y=0.5d0*dlog(xmax)
	    alpha=real(Dsoftshval2(smaxDf,xmax,y,0.,9)
     &                 /xmax**dble(beta))
c            beta=2.*beta
	   elseif(iqq.eq.4) then
             xmax=1.d0
          y=0.5d0*dlog(xmax)

	    alpha=real(Dsoftshval2(smaxDf,xmax,y,0.,9)
     &                 /xmax**dble(beta))
c            beta=2.*beta
	   elseif(iqq.eq.5) then
          y=0.5d0*dlog(xmax)
	    alpha=real(Dsoftshval2(real(xmax)*smaxDf,1.d0,0.d0,0.,18))
     &               /(real(xmax)*smaxDf)**beta

        endif
	
      endif

      if(ish.ge.4)write(*,*) '%%%%%%%%%%%%% pompar2 %%%%%%%%%%%%%%%%%%'
      if(ish.ge.4)write(*,*) 'alpD1 ini =',alpha,' betD1 ini=',beta

      return
      end


c----------------------------------------------------------------------

	subroutine pompar3(alpha,beta,iqq)

c----------------------------------------------------------------------
c  Return the power beta and the factor alpha of the fit of the eikonal
c of a pomeron of type iqq : D(X)=alpha*(X)**beta
c----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incpar'
      double precision X,X0,D,xmax
      double precision Dsoftshval3,droot3,D0,D1
      dimension xlnXs(maxdataDf),xlnD(maxdataDf),sigma(maxdataDf)
            
      do i=1,nptf
        sigma(i)=1.e-2
      enddo

      if (iqq.eq.0.or.(iqq.eq.1.and.xfitmin.eq.1.d0)) then

c Calculation of X0 and D(X)

	X0=xminDf
        xmax=min(1.d0,4.d0*xminDf)
      	if(ish.ge.4)write (*,*) 'x0=',X0

        do i=0,nptf-1
          X=X0
          if (i.ne.0) X=X*(xmax/X0)**(dble(i)/dble(nptf-1))
          D=max(1.d-10,Dsoftshval3(real(X)*smaxDf,X,0.d0,0.,0))
          if(D.eq.1.d-10) write(*,*) 
     &    "Warning in pompar3 ! Dsoftshval3(2) could be negative"
          xlnXs(i+1)=real(dlog(X*dble(smaxDf)))
          xlnD(i+1)=real(dlog(D))
        enddo
	
c Fit of D(X) between X0 and xmax

	call fit(xlnXs,xlnD,nptf,sigma,0,a,beta)
	
	alpha=real(Dsoftshval3(real(X0)*smaxDf,X0,0.d0,0.,0))
     &           *(real(X0)*smaxDf)**(-beta) 
	
      elseif (iqq.eq.2.or.(iqq.eq.3.and.xfitmin.eq.1.d0)) then

c Calculation of X0 and D(X)

	X0=xminDf
        xmax=min(1.d0,4.d0*xminDf)
      	if(ish.ge.4)write (*,*) 'x0=',X0

        do i=0,nptf-1
          X=X0
          if (i.ne.0) X=X*(xmax/X0)**(dble(i)/dble(nptf-1))
          D=max(1.d-10,Dsoftshval3(real(X)*smaxDf,X,0.d0,0.,2))
          if(D.eq.1.d-10) write(*,*) 
     &    "Warning in pompar3 ! Dsoftshval3(2) could be negative"
          xlnXs(i+1)=real(dlog(X*dble(smaxDf)))
          xlnD(i+1)=real(dlog(D))
        enddo
	
c Fit of D(X) between X0 and xmax

	call fit(xlnXs,xlnD,nptf,sigma,0,a,beta)
	
	alpha=real(Dsoftshval3(real(X0)*smaxDf,X0,0.d0,0.,2))
     &           *(real(X0)*smaxDf)**(-beta) 
	
	
	elseif (iqq.eq.1.and.xfitmin.ne.1.d0) then
      
          iscr=6
          xmax=xmaxDf
	
          D1=Dsoftshval3(real(xmax)*smaxDf,xmax,0.d0,0.,iscr)

          D0=xfitmin*D1
	
c Calculation of X0 and D(X)

          X0=droot3(D0,D1,xmax,iscr)
      

          if(ish.ge.4)write (*,*) 'pompar3(1) x0=',X0
      

c$$$          x0=min(1.d3*xminDf,9.D-2)
c$$$          xmax=.5d0
c$$$          write (*,*) 'x0=',X0

          do i=0,nptf-1
            X=X0
            if (i.ne.0) X=X*(xmax/X0)**(dble(i)/dble(nptf-1))
            D=max(1.d-10,Dsoftshval3(real(X)*smaxDf,X,0.d0,0.,iscr))
          if(D.eq.1.d-10) write(*,*) 
     &    "Warning in pompar3 ! Dsoftshval3(13) could be negative"
            xlnXs(i+1)=real(dlog(X*dble(smaxDf)))
            xlnD(i+1)=real(dlog(D))
          enddo

	
c Fit of D(X) between X0 and xmax

          call fit(xlnXs,xlnD,nptf,sigma,0,a,beta)
	
          alpha=real(Dsoftshval3(real(xmax)*smaxDf,xmax,0.d0,0.,iscr))
     &           *(real(xmax)*smaxDf)**(-beta)   

	elseif (iqq.eq.3.and.xfitmin.ne.1.d0) then
      
          iscr=13
          xmax=xmaxDf
      
          D1=Dsoftshval3(real(xmax)*smaxDf,xmax,0.d0,0.,iscr)

          D0=xfitmin*D1
	
c Calculation of X0 and D(X)

          X0=droot3(D0,D1,xmax,iscr)
      

          if(ish.ge.4)write (*,*) 'pompar3(3) x0=',X0
      

c$$$          x0=min(1.d3*xminDf,9.D-2)
c$$$          xmax=.5d0
c$$$          write (*,*) 'x0=',X0

          do i=0,nptf-1
            X=X0
            if (i.ne.0) X=X*(xmax/X0)**(dble(i)/dble(nptf-1))
            D=max(1.d-10,Dsoftshval3(real(X)*smaxDf,X,0.d0,0.,iscr))
          if(D.eq.1.d-10) write(*,*) 
     &    "Warning in pompar3 ! Dsoftshval3(13) could be negative"
            xlnXs(i+1)=real(dlog(X*dble(smaxDf)))
            xlnD(i+1)=real(dlog(D))
          enddo

	
c Fit of D(X) between X0 and xmax

          call fit(xlnXs,xlnD,nptf,sigma,0,a,beta)
	
          alpha=real(Dsoftshval3(real(xmax)*smaxDf,xmax,0.d0,0.,iscr))
     &           *(real(xmax)*smaxDf)**(-beta)   


      endif

      if(ish.ge.4)write(*,*) '%%%%%%%%%%%%% pompar3 %%%%%%%%%%%%%%%%%%'
      if(ish.ge.4)write(*,*) 'alpD2 ini =',alpha,' betD2 ini=',beta

      return
      end

c----------------------------------------------------------------------

      double precision function droot(d0,d1,xmax,iscr)
	
c----------------------------------------------------------------------
c Find x0 which gives f(x0)=D(x0*S)-d0=0
c iqq=0 soft pomeron
c iqq=1 semi-hard pomeron
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      include 'nexus.incpar'
      double precision Dsoftshval,d0,d1,d2,x0,x1,x2,f0,f1,f2,xmax
      parameter (kmax=1000)
	

      k=0
      x0=min(xfitmin,100.d0*xminDf)
      x1=xmax
 5    d2=dabs(Dsoftshval(real(x0)*smaxDf,x0,0.d0,0.,iscr))
      if(d2.lt.1.d-10.and.x0.lt.x1)then
        x0=dsqrt(x0*x1)
c        write(*,*)"droot",x0,x1,d0,d1,d2
        goto 5
        elseif(d2.gt.d0)then
        droot=max(x0,xfitmin)
c        write(*,*)"droot",x0,x1,d0,d1,d2
        return
      endif
      f0=d2-d0
      f1=d1-d0	   
      if(f0*f1.lt.0.d0)then


 10   x2=dsqrt(x0*x1)
      d2=dabs(Dsoftshval(real(x2)*smaxDf,x2,0.d0,0.,iscr))
      f2=d2-d0
      k=k+1
c	write (*,*) '******************* droot **************'
c	write (*,*) x0,x1,x2,f0,f1,f2
	
      if (f0*f2.lt.0.D0) then
        x1=x2
        f1=f2
      else
        x0=x2
        f0=f2
      endif	
      
      if (dabs((x1-x0)/x1).gt.(1.D-5).and.k.le.kmax.and.x1.ne.x0) then
        goto 10
      else
        if (k.gt.kmax) then
          write(ifmt,*)'??? Warning in Droot: Delta=',dabs((x1-x0)/x1)
c.........stop 'Error in Droot, too many steps'
        endif   
        droot=dsqrt(x1*x0)
      endif
	
      else
        droot=dsqrt(x1*x0)
      endif

      return
      end

c----------------------------------------------------------------------

      double precision function droot2(d0,d1,xmax,iscr)
	
c----------------------------------------------------------------------
c Find x0 which gives f(x0)=D(x0*S)-d0=0
c iqq=0 soft pomeron
c iqq=1 semi-hard pomeron
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      include 'nexus.incpar'
      double precision Dsoftshval2,d0,d1,d2,x0,x1,x2,f0,f1,f2,xmax
      parameter (kmax=1000)
	

      k=0
      x0=min(xfitmin,100.d0*xminDf)
      x1=xmax
 5    d2=dabs(Dsoftshval2(real(x0)*smaxDf,1.d0,0.d0,0.,iscr))
      if(d2.lt.1.d-10.and.x0.lt.x1)then
        x0=dsqrt(x0*x1)
c        write(*,*)"droot2",x0,x1,d0,d1,d2
        goto 5
        elseif(d2.gt.d0)then
        droot2=max(x0,xfitmin)
c        write(*,*)"droot2",x0,x1,d0,d1,d2
        return
      endif
      f0=d2-d0
      f1=d1-d0	   
      if(f0*f1.lt.0.d0)then


 10   x2=dsqrt(x0*x1)
      d2=dabs(Dsoftshval2(real(x2)*smaxDf,1.d0,0.d0,0.,iscr))
      f2=d2-d0
      k=k+1
c	write (*,*) '******************* droot **************'
c	write (*,*) x0,x1,x2,f0,f1,f2
	
      if (f0*f2.lt.0.D0) then
        x1=x2
        f1=f2
      else
        x0=x2
        f0=f2
      endif	
      
      if (dabs((x1-x0)/x1).gt.(1.D-5).and.k.le.kmax.and.x1.ne.x0) then
        goto 10
      else
        if (k.gt.kmax) then
        write(ifmt,*)'??? Warning in Droot2: Delta=',dabs((x1-x0)/x1)
c.........stop 'Error in Droot2, too many steps'
        endif   
        droot2=dsqrt(x1*x0)
      endif
	
      else
        droot2=dsqrt(x1*x0)
      endif

      return
      end

c----------------------------------------------------------------------

      double precision function droot3(d0,d1,xmax,iscr)
	
c----------------------------------------------------------------------
c Find x0 which gives f(x0)=D(x0*S)-d0=0
c iqq=0 soft pomeron
c iqq=1 semi-hard pomeron
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      include 'nexus.incpar'
      double precision Dsoftshval3,d0,d1,d2,x0,x1,x2,f0,f1,f2,xmax
      parameter (kmax=1000)
	

      k=0
      x0=xminDf
      x1=xmax
 5    d2=dabs(Dsoftshval3(real(x0)*smaxDf,x0,0.d0,0.,iscr))
      if(d2.lt.1.d-10.and.x0.lt.x1)then
        x0=dsqrt(x0*x1)
c        write(*,*)"droot3",x0,x1,d0,d1,d2
        goto 5
        elseif(d2.gt.d0)then
        droot3=max(x0,xfitmin)
c        write(*,*)"droot3",x0,x1,d0,d1,d2
        return
      endif
      f0=d2-d0
      f1=d1-d0	   
      if(f0*f1.lt.0.d0)then


 10   x2=dsqrt(x0*x1)
      d2=dabs(Dsoftshval3(real(x2)*smaxDf,x2,0.d0,0.,iscr))
      f2=d2-d0
      k=k+1
c	write (*,*) '******************* droot **************'
c	write (*,*) x0,x1,x2,f0,f1,f2
	
      if (f0*f2.lt.0.D0) then
        x1=x2
        f1=f2
      else
        x0=x2
        f0=f2
      endif	
      
      if (dabs((x1-x0)/x1).gt.(1.D-5).and.k.le.kmax.and.x1.ne.x0) then
        goto 10
      else
        if (k.gt.kmax) then
        write(ifmt,*)'??? Warning in Droot3: Delta=',dabs((x1-x0)/x1)
c.........stop 'Error in Droot3, too many steps'
        endif   
        droot3=dsqrt(x1*x0)
      endif
	
      else
        droot3=dsqrt(x1*x0)
      endif

      return
      end

c----------------------------------------------------------------------

      double precision function drootscr(d0,d1,xmax)
	
c----------------------------------------------------------------------
c Find x0 which gives f(x0)=D(x0*S)-d0=0 for s screening contribution
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      include 'nexus.incpar'
      double precision Dsoftshval,d0,d1,d2,x0,x1,x2,f0,f1,f2,xmax
      parameter (kmax=1000)
	

      iscr=-1
      k=0
      x0=xminDf
      x1=xmax
 5    d2=dabs(Dsoftshval(real(x0)*smaxDf,1.d0,0.d0,0.,iscr))
      if(d2.lt.1.d-10.and.x0.lt.x1)then
        x0=dsqrt(x0*x1)
c        write(*,*)"drootscr",x0,x1,d0,d1,d2
        goto 5
        elseif(d2.gt.d0)then
        drootscr=max(x0,xfitmin)
c        write(*,*)"drootscr",x0,x1,d0,d1,d2
        return
      endif
      f0=d2-d0
      f1=d1-d0	   
      if(f0*f1.lt.0.d0)then


 10   x2=dsqrt(x0*x1)
      d2=dabs(Dsoftshval(real(x2)*smaxDf,1.d0,0.d0,0.,iscr))
      f2=d2-d0
      k=k+1
c	write (*,*) '******************* drootscr **************'
c	write (*,*) d0,d1,x0,x1,x2,f0,f1,f2
	
      if (f0*f2.lt.0.D0) then
        x1=x2
        f1=f2
      else
        x0=x2
        f0=f2
      endif	
      
      if (dabs((x1-x0)/x1).gt.(1.D-5).and.k.le.kmax.and.x1.ne.x0) then
        goto 10
      else
        if (k.gt.kmax) then
      write(ifmt,*)'??? Warning in Drootscr: Delta=',dabs((x1-x0)/x1)
c.........stop 'Error in Drootscr, too many steps'
        endif   
        drootscr=dsqrt(x1*x0)
      endif

      else
        drootscr=dsqrt(x1*x0)
      endif

      return
      end

c----------------------------------------------------------------------

      double precision function drootscr1(d0,d1,xmax)
	
c----------------------------------------------------------------------
c Find x0 which gives f(x0)=D(x0*S)-d0=0 for x+ screening contribution
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      include 'nexus.incpar'
      double precision Dsoftshval,d0,d1,d2,x0,x1,x2,f0,f1,f2,xmax
      parameter (kmax=1000)
	

      iscr=-1
      k=0
      x0=xminDf
      x1=xmax
 5    d2=dabs(Dsoftshval(real(x0)*smaxDf,x0,0.5d0*dlog(x0),0.,iscr))
      if(d2.lt.1.d-10.and.x0.lt.x1)then
        x0=dsqrt(x0*x1)
c        write(*,*)"drootscr1",x0,x1,d0,d1,d2
        goto 5
        elseif(d2.gt.d0)then
c        write(*,*)"drootscr1",x0,x1,d0,d1,d2
        drootscr1=max(xfitmin,x0)
        return
      endif

      f0=d2-d0
      f1=d1-d0	   
      if(f0*f1.lt.0.d0)then


 10   x2=dsqrt(x0*x1)
      d2=dabs(Dsoftshval(real(x2)*smaxDf,x2,0.5d0*dlog(x2),0.,iscr))
      f2=d2-d0
      k=k+1
c	write (*,*) '******************* drootscr1 **************'
c	write (*,*) d0,d1,x0,x1,x2,f0,f1,f2
	
      if (f0*f2.lt.0.D0) then
        x1=x2
        f1=f2
      else
        x0=x2
        f0=f2
      endif	
      
      if (dabs((x1-x0)/x1).gt.(1.D-5).and.k.le.kmax.and.x1.ne.x0) then
        goto 10
      else
        if (k.gt.kmax) then
      write(ifmt,*)'??? Warning in Drootscr1: Delta=',dabs((x1-x0)/x1)
c.........stop 'Error in Drootscr1, too many steps'
        endif   
        drootscr1=dsqrt(x1*x0)
      endif

      else
        drootscr1=dsqrt(x1*x0)
      endif

      return
      end

c----------------------------------------------------------------------

      double precision function drootscr2(d0,d1,xmax)
	
c----------------------------------------------------------------------
c Find x0 which gives f(x0)=D(x0*S)-d0=0 for x- screening contribution
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      include 'nexus.incpar'
      double precision Dsoftshval,d0,d1,d2,x0,x1,x2,f0,f1,f2,xmax
      parameter (kmax=1000)
	

      iscr=-1
      k=0
      x0=xminDf
      x1=xmax
 5    d2=dabs(Dsoftshval(real(x0)*smaxDf,x0,-0.5d0*dlog(x0),0.,iscr))
      if(d2.lt.1.d-10.and.x0.lt.x1)then
        x0=dsqrt(x0*x1)
c        write(*,*)"drootscr2",x0,x1,d0,d1,d2
        goto 5
        elseif(d2.gt.d0)then
        drootscr2=max(x0,xfitmin)
c        write(*,*)"drootscr2",x0,x1,d0,d1,d2
        return
      endif
      f0=d2-d0
      f1=d1-d0	   
      if(f0*f1.lt.0.d0)then


 10   x2=dsqrt(x0*x1)
      d2=dabs(Dsoftshval(real(x2)*smaxDf,x2,-0.5d0*dlog(x2),0.,iscr))
      f2=d2-d0
      k=k+1
c	write (*,*) '******************* drootscr2 **************'
c	write (*,*) d0,d1,x0,x1,x2,f0,f1,f2
	
      if (f0*f2.lt.0.D0) then
        x1=x2
        f1=f2
      else
        x0=x2
        f0=f2
      endif	
      
      if (dabs((x1-x0)/x1).gt.(1.D-5).and.k.le.kmax.and.x1.ne.x0) then
        goto 10
      else
        if (k.gt.kmax) then
      write(ifmt,*)'??? Warning in Drootscr2: Delta=',dabs((x1-x0)/x1)
c.........stop 'Error in Drootscr2, too many steps'
        endif   
        drootscr2=dsqrt(x1*x0)
      endif

      else
        drootscr2=dsqrt(x1*x0)
      endif

      return
      end

c----------------------------------------------------------------------

      double precision function drootscr3(d0,d1,xmax)
	
c----------------------------------------------------------------------
c Find x0 which gives f(x0)=D(x0*S)-d0=0 for x- screening contribution
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      include 'nexus.incpar'
      double precision Dsoftshval,d0,d1,d2,x0,x1,x2,f0,f1,f2,xmax
      parameter (kmax=1000)
	

      iscr=-1
      k=0
      x0=xminDf
      x1=xmax
 5    d2=dabs(Dsoftshval(real(x0)*smaxDf,x0,0.d0,0.,iscr))
      if(d2.lt.1.d-10.and.x0.lt.x1)then
        x0=dsqrt(x0*x1)
c        write(*,*)"drootscr3",x0,x1,d0,d1,d2
        goto 5
        elseif(d2.gt.d0)then
        drootscr3=max(x0,xfitmin)
c        write(*,*)"drootscr3",x0,x1,d0,d1,d2
        return
      endif
      f0=d2-d0
      f1=d1-d0	   
      if(f0*f1.lt.0.d0)then


 10   x2=dsqrt(x0*x1)
      d2=dabs(Dsoftshval(real(x2)*smaxDf,x2,0.d0,0.,iscr))
      f2=d2-d0
      k=k+1
c	write (*,*) '******************* drootscr3 **************'
c	write (*,*) d0,d1,x0,x1,x2,f0,f1,f2
	
      if (f0*f2.lt.0.D0) then
        x1=x2
        f1=f2
      else
        x0=x2
        f0=f2
      endif	
      
      if (dabs((x1-x0)/x1).gt.(1.D-5).and.k.le.kmax.and.x1.ne.x0) then
        goto 10
      else
        if (k.gt.kmax) then
      write(ifmt,*)'??? Warning in Drootscr3: Delta=',dabs((x1-x0)/x1)
c.........stop 'Error in Drootscr3, too many steps'
        endif   
        drootscr3=dsqrt(x1*x0)
      endif

      else
        drootscr3=dsqrt(x1*x0)
      endif

      return
      end

c----------------------------------------------------------------------

	subroutine pompary(X,alpha,beta,iqq)

c----------------------------------------------------------------------
c  Return the power beta and the factor alpha of the fit of the eikonal
c of a pomeron of type iqq : D(Y)=alpha*exp(Y)**beta
c----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incpar'
      common /psar7/  delx,alam3p,gam3p
      double precision X,D,Dsoftshval,ymax,ymin,Y,norm
      dimension xlnXs(maxdataDf),xlnD(maxdataDf),sigma(maxdataDf)
            
      do i=1,nptf
        sigma(i)=1.e-2
      enddo
      iscr=-1
      norm=Dsoftshval(real(X)*smaxDf,X,0.d0,0.,iscr)
      ymax=-0.5d0*dlog(X)
      
      if(dabs(norm).gt.1.d-10.and.ymax.ne.0.d0)then

      if (iqq.eq.1) then
      
        ymin=ymax/4.d0
	if(ish.ge.4)write (*,*) 'pompary (1) ymax=',ymax
      
        do i=0,nptf-1
          Y=ymin+ymax*(dble(i)/dble(nptf))
          D=max(1.d-10,Dsoftshval(real(X)*smaxDf,X,Y,0.,iscr)/norm)
          if(D.eq.1.d-10) write(*,*) 
     &    "Warning in pompar ! -Dsoftshval(-1) could be negative"
          xlnXs(i+1)=real(Y)
          xlnD(i+1)=real(dlog(D))
        enddo

	
c Fit of D(X) between X0 and xmax

	call fit(xlnXs,xlnD,nptf,sigma,0,a,beta)
	if(beta.gt.10.)beta=10.
	
	alpha=exp(a)

      elseif (iqq.eq.2) then
      
        ymax=-ymax
        ymin=ymax/4.d0
	if(ish.ge.4)write (*,*) 'pompary (2) ymax=',ymax
      
        do i=0,nptf-1
          Y=ymin+ymax*(dble(i)/dble(nptf))
          D=max(1.d-10,Dsoftshval(real(X)*smaxDf,X,Y,0.,iscr)/norm)
          if(D.eq.1.d-10) write(*,*) 
     &    "Warning in pompar ! -Dsoftshval(-1) could be negative"
          xlnXs(i+1)=real(-Y)
          xlnD(i+1)=real(dlog(D))
        enddo

	
c Fit of D(X) between X0 and xmax

	call fit(xlnXs,xlnD,nptf,sigma,0,a,beta)
	if(beta.gt.10.)beta=10.
	beta=-beta
	alpha=exp(a)

        else

          call utstop('Error in pompary, wrong iqq&')

        endif

        else
          alpha=0
          beta=0
        endif

	if(ish.ge.4)write(*,*) '%%%%%%%%%%%%% pompary %%%%%%%%%%%%%%%'
	if(ish.ge.4)write(*,*) 'alpD ini =',alpha,' betD ini=',beta

      return
      end


c----------------------------------------------------------------------
      subroutine variance(r2,alp,iqq)
c----------------------------------------------------------------------
c fit sigma2 into : 1/sigma2(x)=1/r2-alp*log(x*s)
c  iqq=0 -> soft pomeron
c  iqq=1 -> semi-hard pomeron
c  iqq=2 -> sum
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      include 'nexus.incpar'
      dimension Xs(maxdataDf),vari(maxdataDf),sigma(maxdataDf)
      double precision X,X0
            
      do i=1,nptf
        sigma(i)=1.e-2
      enddo
      ierr=0

      if(iqq.eq.0.or.xshmin.gt.0.95d0)then
        X0=xminDf
      elseif(iqq.eq.2)then
        X0=xshmin
      else
        x0=.1d0/dlog(max(dexp(2.d0),dble(smaxDf)/1.d3)) 
        if(smaxDf.lt.100.*q2min)X0=.95d0
      endif
      if(iqq.ne.3.and.iqq.ne.4)then

        do i=0,nptf-1
          X=X0
          if (i.ne.0) X=X*(xmaxDf/X0)**(dble(i)/dble(nptf-1))
          Xs(i+1)=log(real(X)*smaxDf)
          sig2=sigma2(X,iqq,ierr)
          if(ierr.eq.1) call utstop 
     &   ('In variance, initial(1) sigma2 not def!&')
          vari(i+1)=1./sig2
        enddo
       
c Fit of the variance of D(X,b) between X0 and xmaxDf

        call fit(Xs,vari,nptf,sigma,0,tr2,talp)
        r2=1./tr2
        alp=-talp
      else
        if(iqq.eq.3)r2=sigma2(xmaxDf,3,ierr)
        if(iqq.eq.4)r2=sigma2(xshmin,3,ierr)
        if(ierr.eq.1) call utstop 
     &('In variance, initial(2) sigma2 not def!&')
        alp=0.
      endif
      
      if(ish.ge.4)write(*,*) '%%%%%%%%%% variance ini %%%%%%%%%%%%'
      if(ish.ge.4)write(*,*) 'delD ini=',r2
      if(ish.ge.4)write(*,*) 'gamD ini=',alp


      return
      end



c----------------------------------------------------------------------

	function sigma2(x,iqq,ierr)

c----------------------------------------------------------------------
c Return the variance for a given x of : 
c For G :
c iqq=0 the soft pomeron
c iqq=1 the semi-hard and valence quark pomeron
c iqq=2 the sum
c iqq=3 the triple pomeron
c For G2 :
c iqq=5 the soft part
c iqq=6 the sh part
c iqq=56 G2
c For G1 :
c iqq=7 the soft part
c iqq=8 the sh part
c iqq=9 the valence part
c iqq=789 G1
c----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incpar'
      double precision x,Dsoftshval,sfsh,om1p,eps,omNpuncut,range,sig2
      external varifit
      double precision varifit,Db(maxdataDf),bf(maxdataDf)          
      
      sig2=1.5d0
      bmax=bmaxDf
      bmin=-bmax
      eps=1.d-10
      ierr=0
	
      if(iqq.eq.0)then
        range=sig2
        sfsh=om1p(real(x)*smaxDf,x,0.d0,0.,0)
        if (dabs(sfsh).gt.eps) then
        do i=0,nptf-1
          bf(i+1)=dble(bmin+real(i)*(bmax-bmin)/real(nptf-1))
          Db(i+1)=om1p(real(x)*smaxDf,x,0.d0,real(bf(i+1)),0)/sfsh
        enddo
        else
          ierr=1
        endif
      elseif(iqq.eq.1.and.xshmin.lt..95d0)then
        range=sig2
        sfsh=0.d0 
        do j=1,4
	  sfsh=sfsh+om1p(real(x)*smaxDf,x,0.d0,0.,j)
        enddo
        if (dabs(sfsh).gt.eps) then
        do i=0,nptf-1
          bf(i+1)=dble(bmin+real(i)*(bmax-bmin)/real(nptf-1))
          Db(i+1)=0.d0
          do j=1,4
            Db(i+1)=Db(i+1)+om1p(real(x)*smaxDf,x,0.d0,real(bf(i+1)),j)
          enddo
          Db(i+1)=Db(i+1)/sfsh
        enddo
        else
          ierr=1
        endif
      elseif(iqq.eq.3.and.xshmin.lt..95d0)then
 	  sig2=2.d0*sig2
 	  range=sig2
          sfsh=omNpuncut(real(x)*smaxDf,x,0.d0,0.,0)
        if (dabs(sfsh).gt.eps) then
          do i=0,nptf-1
            bf(i+1)=dble(bmin+real(i)*(bmax-bmin)/real(nptf-1))
            Db(i+1)=omNpuncut(real(x)*smaxDf,x,0.d0,real(bf(i+1)),0)
           Db(i+1)=Db(i+1)/sfsh
          enddo
        else
          ierr=1
        endif
      elseif(iqq.eq.7)then
 	  range=sig2
          sfsh=om1p(real(x)*smaxDf,x,0.d0,0.,7)
        if (dabs(sfsh).gt.eps) then
          do i=0,nptf-1
            bf(i+1)=dble(bmin+real(i)*(bmax-bmin)/real(nptf-1))
            Db(i+1)=om1p(real(x)*smaxDf,x,0.d0,real(bf(i+1)),7)
            Db(i+1)=Db(i+1)/sfsh
          enddo
        else
          ierr=1
        endif
      elseif(iqq.eq.8)then
 	  range=sig2
          sfsh=om1p(real(x)*smaxDf,x,0.d0,0.,8)
          if (dabs(sfsh).gt.eps) then
            do i=0,nptf-1
              bf(i+1)=dble(bmin+real(i)*(bmax-bmin)/real(nptf-1))
              Db(i+1)=om1p(real(x)*smaxDf,x,0.d0,real(bf(i+1)),8)
              Db(i+1)=Db(i+1)/sfsh
            enddo
          else
              ierr=1
          endif
      elseif(iqq.eq.9)then
 	  range=sig2
          sfsh=om1p(real(x)*smaxDf,x,0.d0,0.,9)
          if (dabs(sfsh).gt.eps) then
            do i=0,nptf-1
              bf(i+1)=dble(bmin+real(i)*(bmax-bmin)/real(nptf-1))
              Db(i+1)=om1p(real(x)*smaxDf,x,0.d0,real(bf(i+1)),9)
              Db(i+1)=Db(i+1)/sfsh
            enddo
          else
            ierr=1
          endif
      elseif(iqq.eq.789)then
        sig2=2.d0*sig2
        range=sig2
        sfsh=0.d0 
        do j=7,9
	  sfsh=sfsh+om1p(real(x)*smaxDf,x,0.d0,0.,j)
        enddo
        if (dabs(sfsh).gt.eps) then
        do i=0,nptf-1
          bf(i+1)=dble(bmin+real(i)*(bmax-bmin)/real(nptf-1))
          Db(i+1)=0.d0
          do j=7,9
            Db(i+1)=Db(i+1)+om1p(real(x)*smaxDf,x,0.d0,real(bf(i+1)),j)
          enddo
          Db(i+1)=Db(i+1)/sfsh
        enddo
        else
          ierr=1
        endif
      elseif(iqq.eq.5)then
 	  range=sig2
          sfsh=om1p(real(x)*smaxDf,x,0.d0,0.,5)
          if (dabs(sfsh).gt.eps) then
          do i=0,nptf-1
            bf(i+1)=dble(bmin+real(i)*(bmax-bmin)/real(nptf-1))
            Db(i+1)=om1p(real(x)*smaxDf,x,0.d0,real(bf(i+1)),5)
            Db(i+1)=Db(i+1)/sfsh
          enddo
          else
            ierr=1
          endif
      elseif(iqq.eq.6)then
 	  range=sig2
          sfsh=om1p(real(x)*smaxDf,x,0.d0,0.,6)
          if (dabs(sfsh).gt.eps) then
            do i=0,nptf-1
              bf(i+1)=dble(bmin+real(i)*(bmax-bmin)/real(nptf-1))
              Db(i+1)=om1p(real(x)*smaxDf,x,0.d0,real(bf(i+1)),6)
              Db(i+1)=Db(i+1)/sfsh
            enddo
            else
              ierr=1
          endif
      elseif(iqq.eq.56)then
        sig2=2.d0*sig2
        range=sig2
        sfsh=0.d0 
        do j=5,6
	  sfsh=sfsh+om1p(real(x)*smaxDf,x,0.d0,0.,j)
        enddo
        if (dabs(sfsh).gt.eps) then
        do i=0,nptf-1
          bf(i+1)=dble(bmin+real(i)*(bmax-bmin)/real(nptf-1))
          Db(i+1)=0.d0
          do j=5,6
            Db(i+1)=Db(i+1)+om1p(real(x)*smaxDf,x,0.d0,real(bf(i+1)),j)
          enddo
          Db(i+1)=Db(i+1)/sfsh
        enddo
        else
          ierr=1
        endif
      else
        sig2=2.d0*sig2
        range=sig2
        iscr=0 
        sfsh=Dsoftshval(real(x)*smaxDf,x,0.d0,0.,iscr)
        if (dabs(sfsh).gt.eps) then
        do i=0,nptf-1
          bf(i+1)=dble(bmin+real(i)*(bmax-bmin)/real(nptf-1))
          Db(i+1)=Dsoftshval(real(x)*smaxDf,x,0.d0,real(bf(i+1)),iscr)
     &              /sfsh
        enddo
        else
          ierr=1
        endif
      endif
	
c Fit of D(X,b) between -bmaxDf and bmaxDf

      if(ierr.ne.1)then
        call minfit(varifit,bf,Db,nptf,sig2,range)
        sigma2=real(sig2)
      else
        sigma2=0.
      endif
	
      return
      end




c----------------------------------------------------------------------

      function sigma1i(x)

c----------------------------------------------------------------------
c Return the variance of the sum of the soft pomeron and the semi-hard 
c pomeron for a given x. 
c----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incpar'
      double precision x,Dsoftshval,Dint
      	

      iscr=0
      Dint=Dsoftshval(real(x)*smaxDf,x,0.d0,0.,iscr)

      sigma1i=0.
      if(Dint.ne.0.)
     &sigma1i=real(-1.d0/dlog(Dsoftshval(real(x)*smaxDf,x,0.d0,1.,iscr)
     &		/Dint))


      return
      end

c----------------------------------------------------------------------

      function sigma2i(x)

c----------------------------------------------------------------------
c Return the variance of G1 for a given x. 
c----------------------------------------------------------------------

      include 'nexus.incpar'
      double precision x,Dsoftshval2,Dint
      	
      Dint=Dsoftshval2(real(x)*smaxDf,x,0.d0,0.,1)

      sigma2i=0.
      if(Dint.ne.0.)
     &sigma2i=real(-1.d0/dlog(Dsoftshval2(real(x)*smaxDf,x,0.d0,1.,1)
     &		/Dint))


      return
      end

c----------------------------------------------------------------------

      function sigma3i(x)

c----------------------------------------------------------------------
c Return the variance of G2 for a given x. 
c----------------------------------------------------------------------

      include 'nexus.incpar'
      double precision x,Dsoftshval3,Dint
      	
      Dint=Dsoftshval3(real(x)*smaxDf,x,0.d0,0.,1)

      sigma3i=0.
      if(Dint.ne.0.)
     &sigma3i=real(-1.d0/dlog(Dsoftshval3(real(x)*smaxDf,x,0.d0,1.,1)
     &		/Dint))


      return
      end



c----------------------------------------------------------------------

      function sigma1ifit(x)

c----------------------------------------------------------------------
c Return the variance of the sum of the parametrized soft and semi-hard 
c pomeron for a given x. 
c----------------------------------------------------------------------

      double precision x,Dsoftshpar,Dint
      
      Dint=Dsoftshpar(x,0.)
      sigma1ifit=0.
      if(Dint.ne.1.d-10)
     &sigma1ifit=real(-1.d0/dlog(Dsoftshpar(x,1.)/Dint))

      return
      end

c----------------------------------------------------------------------

      function sigma2ifit(x)

c----------------------------------------------------------------------
c Return the variance of parametrized G1 for a given x. 
c----------------------------------------------------------------------

      double precision x,G1parb
      
      Gint=real(G1parb(x,0.))
      sigma2ifit=0.
      if(Gint.ne.1.d-10)
     &sigma2ifit=-1./log(real(G1parb(x,1.))/Gint)

      return
      end

c----------------------------------------------------------------------

      function sigma3ifit(x)

c----------------------------------------------------------------------
c Return the variance of parametrized G2 for a given x. 
c----------------------------------------------------------------------

      double precision x,G2parb,Gint
      
      Gint=G2parb(x,0.)
      sigma3ifit=0.
      if(Gint.ne.1.d-10)
     &sigma3ifit=real(-1.d0/dlog(G2parb(x,1.)/Gint))
      
      return
      end

c----------------------------------------------------------------------

      SUBROUTINE minfit(func,x,y,ndata,a,range)

c----------------------------------------------------------------------
c Given a set of data points x(1:ndata),y(1:ndata), and the range of
c the parameter "a", fits it on function func by minimizing chi2. 
c In input "a" defines the expected value of "a", and on output it
c corresponds to  the fited value.
c ---------------------------------------------------------------------
      include 'nexus.inc'
      double precision x(ndata),y(ndata),func,a,range,Smin,Som,a1,a2,eps
     *,amin,rr,yp
      parameter (eps=1.d-6)
      external func


      Smin=1.d20
      amin=a
      
     

      a1=a-range
      a2=a+range
      
      do j=1,5000
        rr=dble(rangen())
        a=a1+(a2-a1)*rr
        k=0

 10     if(a.lt.0.d0.and.k.lt.100) then
          rr=dble(rangen())
          a=a1+(a2-a1)*rr
          k=k+1
          goto 10
        endif
        if(k.ge.100) call utstop 
     &('Always negative variance in minfit ...&')

        Som=0.d0
        do k=1,ndata
 	    yp=min(1.d10,func(x(k),a))  !proposal function
  	    Som=Som+(yp-y(k))**2.d0
        enddo
        if(Som.lt.Smin)then
          amin=a
          Smin=Som
        endif
        if(Smin.lt.1.d-3)then
          a1=amin*0.75d0
          a2=amin*1.25d0
        endif
        if(Smin.lt.eps)goto 20
      enddo
      
 20   continue
      a=amin

      return
      end


      
c----------------------------------------------------------------------
      subroutine fitx(func,vini,nmc,chi2,err)
c----------------------------------------------------------------------
c  Determines parameters of the funcion func
c  representing the best fit of the data.
c  At the end of the run, the "best" parameters are stored in parDf(n,3).
c  The function func has to be defined via "function" using the parameters 
c  parDf(n,3), n=1,numparDf .
c  Parameters as well as data are stored on /fitpar/:
c    numparDf: number of parameters  (input)
c    parDf: array containing parameters:
c         parDf(n,1): lower limit    (input)
c         parDf(n,2): upper limit    (input)
c         parDf(n,3): current parameter (internal and output = final result)
c         parDf(n,4): previous parameter (internal)
c    numdataDf: number of data points  (input)
c    datafitD: array containing data:
c         datafitD(i,1): x value       (input)
c         datafitD(i,2): y value       (input)
c         datafitD(i,3): error         (input)
c----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incpar'
      double precision func,x
      external func
	
      write (ifmt,*) 'numparDf,numminDf',numparDf,numminDf

     
c initial configuration (better if one start directly with initial one)

c      do n=numminDf,numparDf
c	      parDf(n,3)=parDf(n,1)+rangen()*(parDf(n,2)-parDf(n,1))
c      enddo

      chi2=0.
      err=0.
      do i=1,numdataDf
        x=dble(datafitD(i,1))
        fx=real(func(x,vini))
        chi2=chi2+(log(fx)-log(datafitD(i,2)))**2/datafitD(i,3)**2
        err=err+(log(fx)-log(datafitD(i,2)))/datafitD(i,3)
      enddo
      err=abs(err)/real(numdataDf)
      
c metropolis iteration

      do i=1,nmc 
        if(mod(i,int(real(nmc)/1000.)).eq.0)then
          betac=betac*1.05
          betae=betae*1.05
        endif
        if(mod(i,int(real(nmc)/20.)).eq.0)write(*,*)i,chi2,err

        do n=numminDf,numparDf
          parDf(n,4)=parDf(n,3)
        enddo
        chi2x=chi2
        errx=err
        
        n=numminDf+int(rangen()*(numparDf-numminDf+1))
        n=max(n,numminDf)
        n=min(n,numparDf)
c	      if(mod(i,int(real(nmc)/20.)).eq.0)write(*,*)n
        
 10     parDf(n,3)=parDf(n,1)+rangen()*(parDf(n,2)-parDf(n,1))
        if ((n.eq.2.or.n.eq.6).and.abs(parDf(n,3)).lt.1.e-3) goto 10
        chi2=0
        err=0
        do j=1,numdataDf
          x=dble(datafitD(j,1))
          fx=real(func(x,vini))
          chi2=chi2+(log(fx)-log(datafitD(j,2)))**2/datafitD(j,3)**2
          err=err+(log(fx)-log(datafitD(j,2)))/datafitD(j,3)
        enddo
        err=abs(err)/real(numdataDf)

        if(chi2.gt.chi2x.and.rangen()
     $             .gt.exp(-min(50.,max(-50.,betac*(chi2-chi2x))))
     &             .or.err.gt.errx.and.rangen()
     $             .gt.exp(-min(50.,max(-50.,betae*(err-errx))))
     &	   						  ) then
          do n=numminDf,numparDf
            parDf(n,3)=parDf(n,4)
          enddo
          chi2=chi2x
          err=errx
        endif

      enddo 

      return
      end
      

c----------------------------------------------------------------------
      subroutine fitb(func,nmc,chi2)
c----------------------------------------------------------------------
c  Determines parameters of the funcion func=sigma?i(x)
c  representing the best fit of the data.
c  At the end of the run, the "best" parameters are stored in parDf(n,3).
c  The function func has to be defined via "function" using the parameters 
c  parDf(n,3), n=numminDf,numparDf .
c  Parameters as well as data are stored on /fitpar/:
c    numparDf: number of parameters  (input)
c    parDf: array containing parameters:
c         parDf(n,1): lower limit    (input)
c         parDf(n,2): upper limit    (input)
c         parDf(n,3): current parameter (internal and output = final result)
c         parDf(n,4): previous parameter (internal)
c    numdataDf: number of data points  (input)
c    data: array containing data:
c         datafitD(i,1): x value       (input)
c         datafitD(i,2): y value       (input)
c         datafitD(i,3): error         (input)
c  If betac is very big, chi2x can't be bigger than chi2 (chi2 always 
c  go down). 
c----------------------------------------------------------------------
	
      include 'nexus.incpar'
      double precision x
      external func

      write (*,*) 'numparDf,numminDF,numdataDf',numparDf,numminDf,
     &             numdataDf

     
c initial configuration (better if one start directly with initial one)

c      do n=numminDf,numparDf
c	      parDf(n,3)=parDf(n,1)+rangen()*(parDf(n,2)-parDf(n,1))
c      enddo

      chi2=0.
      do i=1,numdataDf
        x=dble(datafitD(i,1))
        fx=func(x)
        chi2=chi2+(fx-datafitD(i,2))**2/datafitD(i,3)**2
      enddo
      
c metropolis iteration

      do i=1,nmc
      	if(mod(i,int(real(nmc)/100.)).eq.0)then
          betac=betac*1.05
        endif
        if(mod(i,int(real(nmc)/20.)).eq.0)write(*,*)i,chi2
        
        do n=numminDf,numparDf
          parDf(n,4)=parDf(n,3)
        enddo
        chi2x=chi2

        n=numminDf+int(rangen()*(numparDf-numminDf+1))
        n=max(n,numminDf)
        n=min(n,numparDf)
c	      if(mod(i,int(real(nmc)/20.)).eq.0)write(*,*)n

        parDf(n,3)=parDf(n,1)+rangen()*(parDf(n,2)-parDf(n,1))
        chi2=0.
        do j=1,numdataDf
          x=dble(datafitD(j,1))
          fx=func(x)
          chi2=chi2+(fx-datafitD(j,2))**2/datafitD(j,3)**2
        enddo
        if(chi2.gt.chi2x.and.rangen().gt.
     $  exp(-min(50.,max(-50.,betac*(chi2-chi2x))))) then
          do n=numminDf,numparDf
            parDf(n,3)=parDf(n,4)
          enddo
          chi2=chi2x
        endif

      enddo
 

      return
      end


c----------------------------------------------------------------------

	SUBROUTINE fit(x,y,ndata,sig,mwt,a,b)

c----------------------------------------------------------------------
c Given a set of data points x(1:ndata),y(1:ndata) with individual standard
c deviations sig(1:ndata), fit them to a straight line y = a + bx by
c minimizing chi2 .
c Returned are a,b and their respective probable uncertainties siga and sigb, 
c the chisquare chi2, and the goodness-of-fit probability q (that the fit 
c would have chi2 this large or larger). If mwt=0 on input, then the standard 
c deviations are assumed to be unavailable: q is returned as 1.0 and the 
c normalization of chi2 is to unit standard deviation on all points.
c ---------------------------------------------------------------------

	implicit none
	INTEGER mwt,ndata
	REAL sig(ndata),x(ndata),y(ndata)
	REAL a,b,siga,sigb,chi2 !,q 
	INTEGER i
	REAL sigdat,ss,st2,sx,sxoss,sy,t,wt


	sx=0. 		!Initialize sums to zero.
	sy=0.
	st2=0.
	b=0.
	if(mwt.ne.0) then ! Accumulate sums ...
          ss=0.
          do i=1,ndata          !...with weights
            wt=1./(sig(i)**2)
            ss=ss+wt
            sx=sx+x(i)*wt
            sy=sy+y(i)*wt
          enddo
	else
          do i=1,ndata          !...or without weights.
            sx=sx+x(i)
            sy=sy+y(i)
          enddo
          ss=float(ndata)
	endif
	sxoss=sx/ss
	if(mwt.ne.0) then
          do i=1,ndata
            t=(x(i)-sxoss)/sig(i)
            st2=st2+t*t
            b=b+t*y(i)/sig(i)
          enddo
	else
          do i=1,ndata
            t=x(i)-sxoss
            st2=st2+t*t
            b=b+t*y(i)
          enddo
	endif
	b=b/st2 		!Solve for a, b, oe a , and oe b .
	a=(sy-sx*b)/ss
	siga=sqrt((1.+sx*sx/(ss*st2))/ss)
	sigb=sqrt(1./st2)
	chi2=0. 		!Calculate chi2 .
c	q=1.
	if(mwt.eq.0) then
          do i=1,ndata
            chi2=chi2+(y(i)-a-b*x(i))**2
          enddo

c For unweighted data evaluate typical sig using chi2, and adjust 
c the standard deviations.

          sigdat=sqrt(chi2/(ndata-2)) 
          siga=siga*sigdat
          sigb=sigb*sigdat
	else
          do i=1,ndata
            chi2=chi2+((y(i)-a-b*x(i))/sig(i))**2
          enddo
	endif

        if(chi2.ge.0.2)then
          b=(y(ndata)-y(1))/(x(ndata)-x(1))
          a=y(ndata)-b*x(ndata)
        endif


c	write(*,*) '$$$$$$$$$$ fit : a,b,siga,sigb,chi2,q $$$$$$$$$$$'
c	write(*,*) a,b,siga,sigb,chi2!???????????????


	return
	END



c----------------------------------------------------------------------

      real function gamgpar(x,eps)
	
c----------------------------------------------------------------------

      gamgpar=-eps*x
	
      return
      end

c----------------------------------------------------------------------

      double precision function varifit(x,var)
	
c----------------------------------------------------------------------
      double precision x,var

      varifit=dexp(-min(50.d0,x**2.d0/var))
	
      return
      end



c----------------------------------------------------------------------

      double precision function Dsoftshval(sy,x,y,b,iscr)
	
c----------------------------------------------------------------------
c iscr=0 sum of om1p(i), i from 0 to 4 (without screening)
c iscr=1 sum of om1p(i), i from 0 to 4 + omNpuncut (with screening)
c iscr=2 sum of om1p(i), i from 1 to 4 (semihard + valence quark)
c iscr=-1 omNpuncut (only screening)
c----------------------------------------------------------------------
      double precision x,om1p,y,omNpuncut
      include 'nexus.inc'
      include 'nexus.incsem'

      Dsoftshval=0.d0

      if(iscr.eq.0)then
        do i=0,4
          Dsoftshval=Dsoftshval+om1p(sy,x,y,b,i)
        enddo
      elseif(iscr.eq.1)then
        do i=0,4
          Dsoftshval=Dsoftshval+om1p(sy,x,y,b,i)
        enddo
        Dsoftshval=Dsoftshval+omNpuncut(sy,x,y,b,0)  
     &             /dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))
     &             /dble(chad(iclpro)*chad(icltar))  
      elseif(iscr.eq.-1)then
          Dsoftshval=omNpuncut(sy,x,y,b,0)
     &               /dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
     &               /dble(chad(iclpro)*chad(icltar))  
      elseif(iscr.eq.2)then
        do i=1,4
          Dsoftshval=Dsoftshval+om1p(sy,x,y,b,i)
        enddo
      endif
      
      
      Dsoftshval=2.d0*Dsoftshval
     &     /(x**dble(-alppar)*dble(chad(iclpro)*chad(icltar)))
c     &       *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  

      
      return
      end


c----------------------------------------------------------------------

      double precision function Dsoftshval2(sy,x,y,b,iscr)
	
c----------------------------------------------------------------------
c iscr=10 sum of om1p(i), i from 7 to 8
c iscr=0 or 1 sum of om1p(i), i from 7 to 9
c iscr=2 sum of om1p(i), i from 16 to 18
c iscr=3 sum of om1p(i), i from 19 to 21
c iscr=7 -> soft(proj)
c iscr=8 -> gg(proj)
c iscr=9 -> qg(proj)
c iscr=16 -> soft(proj)(int)
c iscr=17 -> gg(proj)(int)
c iscr=18 -> qg(proj)(int)
c iscr=19 -> (b2*soft(proj))(int)
c iscr=20 -> (b2*gg(proj))(int)
c iscr=21 -> (b2*qg(proj))(int)
c----------------------------------------------------------------------
      double precision x,om1p,y
      include 'nexus.inc'
      include 'nexus.incsem'

      Dsoftshval2=0.d0
      if(iscr.eq.10)then
        do i=17,18
          Dsoftshval2=Dsoftshval2+om1p(sy,x,y,b,i)
        enddo
      elseif(iscr.eq.1.or.iscr.eq.0)then
        do i=7,9
          Dsoftshval2=Dsoftshval2+om1p(sy,x,y,b,i)
        enddo
      elseif(iscr.eq.2)then
        do i=16,18
          Dsoftshval2=Dsoftshval2+om1p(sy,x,y,b,i)
        enddo
      elseif(iscr.eq.3)then
        do i=19,21
          Dsoftshval2=Dsoftshval2+om1p(sy,x,y,b,i)
        enddo
      else
        Dsoftshval2=om1p(sy,x,y,b,iscr)
      endif
      
      Dsoftshval2=Dsoftshval2 
     &      /((dsqrt(x)*dexp(y))**dble(-alppar)*dble(chad(iclpro)))
	

      return
      end

c----------------------------------------------------------------------

      double precision function Dsoftshval3(sy,x,y,b,iscr)
	
c----------------------------------------------------------------------
c G2 function
c iscr=0 or 1 sum of om1p(i), i from 5 to 6
c iscr=2 sum of om1p(i), i from 12 to 13
c iscr=3 sum of om1p(i), i from 14 to 15
c iscr=5 -> soft
c iscr=6 -> gg
c iscr=12 -> soft(int)
c iscr=13 -> gg(int)
c iscr=14 -> (b2*soft)(int)
c iscr=15 -> (b2*gg)(int)
c----------------------------------------------------------------------
      double precision x,om1p,y
      include 'nexus.inc'

      Dsoftshval3=0.d0
      if(iscr.eq.0.or.iscr.eq.1)then
        do i=5,6
          Dsoftshval3=Dsoftshval3+om1p(sy,x,y,b,i)
        enddo
      elseif(iscr.eq.2)then
        do i=12,13
          Dsoftshval3=Dsoftshval3+om1p(sy,x,y,b,i)
        enddo
      elseif(iscr.eq.3)then
        do i=14,15
          Dsoftshval3=Dsoftshval3+om1p(sy,x,y,b,i)
        enddo
      else
        Dsoftshval3=om1p(sy,x,y,b,iscr)
      endif

      Dsoftshval3=Dsoftshval3          !/x**dble(-alppar)
      
      return
      end

c----------------------------------------------------------------------

      double precision function Dsoftshpar(x,b)
	
c----------------------------------------------------------------------
      double precision x
      include 'nexus.incpar'

      b2=b*b
      Dsoftshpar=dble(
     &        parDf(1,3)*real(x)**(parDf(2,3)+parDf(9,3)*b2)
     &       *smaxDf**(parDf(2,3)+parDf(9,3)*b2)
     &       *exp(-min(50.,max(-50.,b2/parDf(10,3))))
     &       +parDf(3,3)*real(x)**(parDf(4,3)+parDf(11,3)*b2)
     &       *smaxDf**(parDf(4,3)+parDf(11,3)*b2)
     &       *exp(-min(50.,max(-50.,b2/parDf(12,3))))
     &       +parDf(5,3)*real(x)**(parDf(6,3)+parDf(11,3)*b2)
     &       *smaxDf**(parDf(6,3)+parDf(11,3)*b2)
     &       *exp(-min(50.,max(-50.,b2/parDf(12,3)))))
      Dsoftshpar=min(max(1.d-10,Dsoftshpar),1.d10) 
	
      return
      end

c----------------------------------------------------------------------

	double precision function Dsoftshasym(x,y)
	
c----------------------------------------------------------------------
	double precision xp,xm,x,y
	include 'nexus.incpar'

	b2=0. !b*b
c	sy=smaxDf*real(x)

	xp=dsqrt(x)*dexp(y)
        if(dabs(xp).ge.1.d-15)then
          xm=x/xp
        else
          xm=1.d0
          write(*,*)'Warning in Dsoftshasym in nexus-par'
        endif

        parDf(19,3)=parDf(2,3)/(1.+parDf(2,3))*parDf(5,3)
        parDf(21,3)=1./(1.+parDf(2,3))*parDf(5,3)
        parDf(20,3)=parDf(24,3)+parDf(1,3)/2.
        parDf(22,3)=parDf(26,3)+parDf(3,3)/2.
        parDf(28,3)=parDf(24,3)-parDf(1,3)/2.
        parDf(30,3)=parDf(26,3)-parDf(3,3)/2.
	
c	parDf(19,3)=parDf(5,3)
c        parDf(21,3)=parDf(7,3)/smaxDf**(parDf(8,3)
c     &                                 -(parDf(22,3)+parDf(30,3))/2.)
c	parDf(21,3)=parDf(7,3)
	
c	alp1=parDf(1,3)*real(xp)**parDf(16,3)*real(xm)**parDf(24,3)
c	alp2=parDf(3,3)*real(xp)**parDf(18,3)*real(xm)**parDf(26,3)
	alp3=parDf(19,3)*real(xp)**parDf(20,3)*real(xm)**parDf(28,3)
	alp4=parDf(21,3)*real(xp)**parDf(22,3)*real(xm)**parDf(30,3)
c	Dsoftshasym=dble(
c     &                 alp1*smaxDf**parDf(2,3)*sy**(parDf(9,3)*b2)
c     &                     *exp(-min(50.,max(-50.,b2/parDf(10,3))))
c     &                +alp2*smaxDf**parDf(4,3)*sy**(parDf(11,3)*b2)
c     &                     *exp(-min(50.,max(-50.,b2/parDf(12,3))))
	Dsoftshasym=dble(
     &                alp3*smaxDf**parDf(6,3)
     &                     *exp(-min(50.,max(-50.,b2/parDf(13,3))))
     &                +alp4*smaxDf**parDf(8,3)
     &                     *exp(-min(50.,max(-50.,b2/parDf(14,3)))))
        Dsoftshasym=min(max(1.d-10,Dsoftshasym),1.d10) 
	
	return
	end

c----------------------------------------------------------------------

	function Dasym(y)
	
c----------------------------------------------------------------------
	double precision y
	include 'nexus.incpar'


        parDf(19,3)=parDf(2,3)/(1.+parDf(2,3))
        parDf(21,3)=1./(1.+parDf(2,3))
		
	alp3=parDf(19,3)
	alp4=parDf(21,3)
	Dasym=alp3*exp(min(50.,max(-50.,parDf(1,3)*real(y))))
     &       +alp4*exp(min(50.,max(-50.,parDf(3,3)*real(y))))
        Dasym=min(max(1.e-10,Dasym),1.e10) 
	
	return
	end


c----------------------------------------------------------------------

      double precision function G1parb(x,b)
	
c----------------------------------------------------------------------
      double precision x
      include 'nexus.inc'
      include 'nexus.incpar'

      sy=smaxDf*real(x)
      b2=b*b 
      G1parb=dble(parDf(13,3)/parDf(20,3)*sy**parDf(14,3)
     &                 *exp(-min(50.,max(-50.,b2/parDf(20,3))))
     &      +parDf(15,3)/parDf(21,3)*sy**parDf(16,3)
     &                 *exp(-min(50.,max(-50.,b2/parDf(21,3))))
     &+parDf(17,3)/parDf(22,3)*sy**parDf(18,3)*sqrt(real(x))**parDf(7,3)
     &                 *exp(-min(50.,max(-50.,b2/parDf(22,3))))
     &+parDf(19,3)/parDf(22,3)*sy**parDf(18,3)*sqrt(real(x))**parDf(8,3)
     &                 *exp(-min(50.,max(-50.,b2/parDf(22,3)))))
      G1parb=min(max(1.d-10,G1parb),1.d10) 
	
      return
      end
c----------------------------------------------------------------------

      double precision function G2parb(x,b)
	
c----------------------------------------------------------------------
      double precision x
      include 'nexus.incpar'

      sy=smaxDf*real(x)
      b2=b*b
      G2parb=dble(parDf(23,3)*sy**parDf(24,3)/parDf(29,3)
     &       *exp(-min(50.,max(-50.,b2/parDf(29,3))))
     &       +parDf(25,3)*sy**parDf(26,3)/parDf(30,3)
     &       *exp(-min(50.,max(-50.,b2/parDf(30,3))))
     &       +parDf(27,3)*sy**parDf(28,3)/parDf(29,3)
     &       *exp(-min(50.,max(-50.,b2/parDf(29,3)))))
      G2parb=min(max(1.d-10,G2parb),1.d10) 
	
      return
      end






	





