c-----------------------------------------------------------------------
      subroutine lepexp(rxbj,rqsq)
c-----------------------------------------------------------------------
c     generates x_bjorken and q**2 according to an experimental
c     distribution ( given in array xq(nxbj,nqsq) ).
c-----------------------------------------------------------------------
      parameter (nxbj=10,nqsq=10)
      parameter (xbjmin=0.,qsqmin=4.)
      parameter (xbjwid=0.025, qsqwid=4.)
      dimension xq(nxbj,nqsq),vxq(nxbj*nqsq)
      equivalence (xq(1,1),vxq(1))
 
      data (vxq(i),i=1,50)/
     &         1304.02,   366.40,    19.84,    10.79,     6.42,
     &            4.54,     4.15,     3.38,     2.03,     1.56,
     &          241.63,  1637.26,   427.36,   164.51,    73.72,
     &           43.07,    20.73,    12.78,     9.34,     5.83,
     &            0.01,   724.66,   563.79,   275.08,   176.13,
     &          106.44,    85.82,    54.52,    37.12,    28.65,
     &            0.01,   202.40,   491.10,   245.13,   157.07,
     &          104.43,    61.05,    49.42,    37.84,    26.79,
     &            0.01,     3.77,   316.38,   226.92,   133.45,
     &           90.30,    63.67,    48.42,    35.73,    28.04/
      data (vxq(i),i=51,100)/
     &            0.01,     0.01,   153.74,   213.09,   114.14,
     &           76.26,    60.02,    43.15,    43.47,    25.60,
     &            0.01,     0.01,    39.31,   185.74,   108.56,
     &           88.40,    47.29,    39.35,    31.80,    22.91,
     &            0.01,     0.01,     0.01,   104.61,   107.01,
     &           66.24,    45.34,    37.45,    33.44,    23.78,
     &            0.01,     0.01,     0.01,    56.58,    99.39,
     &           67.78,    43.28,    35.98,    34.63,    18.31,
     &            0.01,     0.01,     0.01,    13.56,    76.25,
     &           64.30,    42.80,    28.56,    21.19,    20.75 /
 
      data init/0/
      init=init+1
      if(init.eq.1) then
      n=nxbj*nqsq
      sum=0.
      do 1 i=1,n
      sum=sum+vxq(i)
1     continue
      do 2 i=2,n
2     vxq(i)=vxq(i)+vxq(i-1)
      do 3 i=1,n
3     vxq(i)=vxq(i)/sum
      endif
 
      n=nxbj*nqsq
      r=rangen()
      call utloc(vxq,n,r,iloc)
      if(iloc.ge.n) iloc=iloc-1
      i=mod(iloc,nxbj)+1
      if(i.eq.0) i=nxbj
      j=iloc/nxbj + 1
      dxint=vxq(1)
      if(iloc.gt.0) dxint=vxq(iloc+1)-vxq(iloc)
      dxbj=xbjwid*abs(r-vxq(iloc+1))/dxint
      dy=qsqwid*rangen()
      rxbj=xbjmin+xbjwid*float(i-1)+dxbj
      rqsq=qsqmin+qsqwid*float(j-1)+dy
      return
      end

c-----------------------------------------------------------------------
      subroutine fremnu(amin,ca,cb,ca0,cb0,ic1,ic2,ic3,ic4)
c-----------------------------------------------------------------------
      common/hadr2/iomodl,idproj,idtarg,wexcit
      real pnll,ptq
      common/hadr1/pnll,ptq,exmass,cutmss,rstras,wproj,wtarg
      parameter (nflav=6)
      integer ic(2),jc(nflav,2)
      ic(1)=ca
      ic(2)=cb
      call iddeco(ic,jc)
      keu=jc(1,1)-jc(1,2)
      ked=jc(2,1)-jc(2,2)
      kes=jc(3,1)-jc(3,2)
      kec=jc(4,1)-jc(4,2)
      keb=jc(5,1)-jc(5,2)
      ket=jc(6,1)-jc(6,2)
      amin=utamnu(keu,ked,kes,kec,keb,ket,5)  !???4=2mults, 5=1mult
        if(ca-ca0.eq.0..and.cb-cb0.eq.0..and.rangen().gt.wexcit)then
      ic3=0
      ic4=0
      ic1=ca
      ic2=cb
       else
      amin=amin+exmass
      n=0
      do i=1,4
      do j=1,2
      n=n+jc(i,j)
      enddo
      enddo
      k=1+rangen()*n
      do i=1,4
      do j=1,2
      k=k-jc(i,j)
      if(k.le.0)goto 1
      enddo
      enddo
1     if(j.eq.1)then
      ic3=10**(6-i)
      ic4=0
      else
      ic3=0
      ic4=10**(6-i)
      endif
      ic1=int(ca)-ic3
      ic2=int(cb)-ic4
        endif
      return
      end


c-----------------------------------------------------------------------
      function fremnux(ic)
c-----------------------------------------------------------------------
      real pnll,ptq
      common/hadr1/pnll,ptq,exmass,cutmss,rstras,wproj,wtarg
      parameter (nflav=6)
      integer ic(2),jc(nflav,2)
c      ic(1)=210000
c      ic(2)=0
      call iddeco(ic,jc)
      keu=jc(1,1)-jc(1,2)
      ked=jc(2,1)-jc(2,2)
      kes=jc(3,1)-jc(3,2)
      kec=jc(4,1)-jc(4,2)
      keb=jc(5,1)-jc(5,2)
      ket=jc(6,1)-jc(6,2)
      fremnux=utamnu(keu,ked,kes,kec,keb,ket,4) !+exmass  !???4=2mults, 5=1mult
      return
      end

c-----------------------------------------------------------------------
      function fremnux2(ic)
c-----------------------------------------------------------------------
      real pnll,ptq
      common/hadr1/pnll,ptq,exmass,cutmss,rstras,wproj,wtarg
      parameter (nflav=6)
      integer ic(2),jc(nflav,2)
c      ic(1)=210000
c      ic(2)=0
      call iddeco(ic,jc)
      keu=jc(1,1)-jc(1,2)
      ked=jc(2,1)-jc(2,2)
      kes=jc(3,1)-jc(3,2)
      kec=jc(4,1)-jc(4,2)
      keb=jc(5,1)-jc(5,2)
      ket=jc(6,1)-jc(6,2)
      fremnux2=utamnu(keu,ked,kes,kec,keb,ket,5) !+exmass  !???4=2mults, 5=1mult
      return
      end

c-----------------------------------------------------------------------
      subroutine fremnx(ammax,amin,sm,ic3,ic4,iret)
c-----------------------------------------------------------------------
      common/psar9/ alpr
      include 'nexus.inc'
      iret=0
      if(ic3.eq.0.and.ic4.eq.0)then
        if(ammax.lt.amin**2)then
          iret=1
          return
        endif
        sm=amin**2
      else
c       ammax1=min(ammax,(engy/4.)**2)
        ammax1=ammax
        if(ammax1.lt.amin**2)then
          iret=1
          return
        endif
        if(alpr.eq.-1.)then
          sm=amin**2*(ammax1/amin**2)**rangen()
        else
          sm=amin**2*(1.+((ammax1/amin**2)**(1.+alpr)-1.)
     *    *rangen())**(1./(1.+alpr))
        endif
      endif
      return
      end

c-----------------------------------------------------------------------
      subroutine fremny(wp1,wm1,pnx,pny,sm,ic1,ic2,ic3,ic4,coord,ey0)
c-----------------------------------------------------------------------
c  treats remnant from deep inelastic process;
c-----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      dimension coord(6),ic(2),ep(4),ey(3),ey0(3),ep3(4)
      double precision  ept(4),ept1(4)

      call utpri('fremny',ish,ishini,5)
      if(ish.ge.5)write(ifch,*)'writing remnant'
      if(ish.ge.5)write(ifch,*)
     *'wp1,wm1,pnx,pny,sm,ic1,ic2,ic3,ic4,coord,ey0:'
      if(ish.ge.5)write(ifch,*)
     *wp1,wm1,pnx,pny,sm,ic1,ic2,ic3,ic4,coord,ey0

        if(ic3.eq.0.and.ic4.eq.0)then

      ic(1)=ic1
      ic(2)=ic2
      nptl=nptl+1
      ep3(3)=pnx
      ep3(4)=pny
      ep3(2)=(wp1-wm1)/2
      ep3(1)=(wp1+wm1)/2
      call pstrans(ep3,ey0,-1)
      pptl(1,nptl)=ep3(3)
      pptl(2,nptl)=ep3(4)
      pptl(3,nptl)=ep3(2)
      pptl(4,nptl)=ep3(1)
      pptl(5,nptl)=sqrt(sm)
      idptl(nptl)=idtra(ic,0,0,3)
      iorptl(nptl)=1
      istptl(nptl)=0
      jorptl(nptl)=0
      do i=1,4
      xorptl(i,nptl)=coord(i)
      enddo
      tivptl(1,nptl)=coord(5)
      tivptl(2,nptl)=coord(6)
      ityptl(nptl)=40

       if(ish.ge.7)then
      write(ifch,*)'proj: nptl, mass**2,id',nptl,sm,idptl(nptl)
      write(ifch,*)'ept',
     *pptl(1,nptl),pptl(2,nptl),pptl(3,nptl),pptl(4,nptl)
       endif

        else

      ic(1)=ic1
      ic(2)=ic2
      nptl=nptl+1
      idptl(nptl)=idtra(ic,0,0,3)
      istptl(nptl)=20
      iorptl(nptl)=1
      jorptl(nptl)=0
      do i=1,4
      xorptl(i,nptl)=coord(i)
      enddo
      tivptl(1,nptl)=coord(5)
      tivptl(2,nptl)=coord(6)
      ityptl(nptl)=40

      ic(1)=ic3
      ic(2)=ic4
      idptl(nptl+1)=idtra(ic,0,0,3)
      istptl(nptl+1)=20
      iorptl(nptl+1)=1
      jorptl(nptl+1)=0
      do i=1,4
      xorptl(i,nptl+1)=coord(i)
      enddo
      tivptl(1,nptl+1)=coord(5)
      tivptl(2,nptl+1)=coord(6)
      ityptl(nptl+1)=40

      ep3(3)=pnx
      ep3(4)=pny
      ep3(2)=(wp1-wm1)/2
      ep3(1)=(wp1+wm1)/2
      call pstrans(ep3,ey0,-1)   !boost to hadronic c.m.s.
      ept(1)=ep3(3)
      ept(2)=ep3(4)
      ept(3)=ep3(2)
      ept(4)=ep3(1)
      do i=1,4
        ept1(i)=ep3(i)
      enddo

      sww=sqrt(sm)
      call psdeftr(sm,ept1,ey)
      ep(1)=.5*sww
      ep(2)=.5*sww
      ep(3)=0.
      ep(4)=0.
      call pstrans(ep,ey,1)
      pptl(1,nptl)=ep(3)
      pptl(2,nptl)=ep(4)
      pptl(3,nptl)=ep(2)
      pptl(4,nptl)=ep(1)
      do i=1,4
        pptl(i,nptl+1)=ept(i)-pptl(i,nptl)
      enddo
      nptl=nptl+1
        endif

       if(ish.ge.5)write(ifch,*)'fremny: final nptl',nptl
      call utprix('fremny',ish,ishini,5)
      return
      end

c-----------------------------------------------------------------------
      subroutine jet
c-----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'

      energy = xpar1
      method = nint(xpar2)
      y1     = xpar3
      y2     = xpar4
      ptmin  = xpar5
      ptmax  = xpar6
      nbins  = nint(xpar7)
      fac    =xpar8
      
      write(ifhi,'(a)')'array 2'
      sx=energy**2
      delpt=(ptmax-ptmin)/nbins
      do i=1,nbins
      pt=ptmin+(i-0.5)*delpt
         if(method.eq.1)then     ! our stuff
      sig=psjx1(pt**2,sx,y2)
      if(y1.gt.0.)sig=sig-psjx1(pt**2,sx,y1)
         elseif(method.eq.2)then ! grv
      sig=psjvrg1(pt**2,sx,y2)
      if(y1.gt.0.)sig=sig-psjvrg1(pt**2,sx,y1)
         elseif(method.eq.3)then !duke-owens
      sig=psjwo1(pt**2,sx,y2)
      if(y1.gt.0.)sig=sig-psjwo1(pt**2,sx,y1)
         endif
      sig=sig / (y2-y1) * factk * 390 *fac
      write(ifmt,*)'pt:',pt,'     sig:',sig
      write(ifhi,'(2e12.4)')pt,sig
      enddo
      write(ifhi,'(a)')       '  endarray'

      end

c-----------------------------------------------------------------------
      subroutine psaevp
c-----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      qq=xpar1
      jmod=nint(xpar2)
      iologb=1

      do i=1,nrbins
        if(iologb.eq.0)then
          xx=xminim+(xmaxim-xminim)*(i-.5)/nrbins
        else
          xx=xminim*(xmaxim/xminim)**((i-.5)/nrbins)
        endif
        ar(i,1)=xx
        ar(i,2)=0.
        if(jmod.eq.0)then            !evolution+matrix element +3P (ours)
          ww=qq/xx
          ar(i,3)=(psdh(ww,qq,2,0)+psdh(ww,qq,2,1)+
     *    psdsh1(ww,qq,2,dqsh,0)+psdsh1(ww,qq,2,dqsh,1)
     *    )/(4.*pi**2*alfe)*qq
        elseif(jmod.eq.1)then        !evolution+matrix element (ours)
          ww=qq/xx
          ar(i,3)=(psdh(ww,qq,2,0)+psdh(ww,qq,2,1)+
     *    psdsh(ww,qq,2,dqsh,0)+psdsh(ww,qq,2,dqsh,1)
     *    )/(4.*pi**2*alfe)*qq
        elseif(jmod.eq.2)then    !just evolution (grv)
          ar(i,3)=(pspdfg(xx,q2min,qq,2,1)/2.25+
     *    pspdfg(xx,q2min,qq,2,2)/9.+
     *    pspdfg(xx,q2min,qq,2,-1)*2./3.6+
     *    pspdfg(xx,q2min,qq,2,-3)*2./9.)
          if(naflav.eq.4)ar(i,3)=ar(i,3)+pspdfg(xx,q2min,qq,2,-4)
     *    *2./2.25
        elseif(jmod.eq.3)then    !grv
          ar(i,3)=(psdfh4(xx,qq,0.,2,1)+2.*psdfh4(xx,qq,0.,2,-1))/2.25
     *    +(psdfh4(xx,qq,0.,2,2)+2.*psdfh4(xx,qq,0.,2,-2))/9.
     *    +2.*psdfh4(xx,qq,0.,2,-3)/9.  !
        elseif(jmod.eq.4)then         !just evolution (ours)
          ar(i,3)=(pspdf0(xx,qq,1)/2.25+pspdf0(xx,qq,2)/9.+
     *    pspdf0(xx,qq,-1)*6./4.5)                     !uv+dv+6*sea
          if(naflav.eq.4)ar(i,3)=ar(i,3)+pspdf0(xx,qq,-4)*2./2.25
        elseif(jmod.eq.5)then         !grv+res
          ww=qq/xx
          ar(i,3)=(psdgh(ww,qq,0)+psdgh(ww,qq,1)
     *    )/(4.*pi**2*alfe)*qq
        endif
        ar(i,4)=0.
      enddo
      return
      end

c------------------------------------------------------------------------
      subroutine pscs(c,s)
c-----------------------------------------------------------------------
c pscs - cos (c) and sin (s) generation for uniformly distributed angle
c-----------------------------------------------------------------------
1     s1=2.*rangen()-1.
      s2=2.*rangen()-1.
      s3=s1*s1+s2*s2
      if(s3.gt.1.)goto 1
      s3=sqrt(s3)
      c=s1/s3
      s=s2/s3
      return
      end
      
c------------------------------------------------------------------------
      subroutine psdefrot(ep,s0x,c0x,s0,c0)
c-----------------------------------------------------------------------
c psdefrot - determination of the parameters the spacial rotation to the
c system for 4-vector ep
c s0, c0 - sin and cos for the zx-rotation;
c s0x, c0x - sin and cos for the xy-rotation
c-----------------------------------------------------------------------
      dimension ep(4)

c transverse momentum square for the current parton (ep)
      pt2=ep(3)**2+ep(4)**2
      if(pt2.ne.0.)then
        pt=sqrt(pt2)
c system rotation to get pt=0 - euler angles are determined (c0x = cos t
c s0x = sin theta, c0 = cos phi, s0 = sin phi)
        c0x=ep(3)/pt
        s0x=ep(4)/pt
c total momentum for the gluon
        pl=sqrt(pt2+ep(2)**2)
        s0=pt/pl
        c0=ep(2)/pl
      else
        c0x=1.
        s0x=0.
        pl=abs(ep(2))
        s0=0.
        c0=ep(2)/pl
      endif

      ep(2)=pl
      ep(3)=0.
      ep(4)=0.
      return
      end

c------------------------------------------------------------------------
      subroutine psdeftr(s,ep,ey)
c-----------------------------------------------------------------------
c psdeftr - determination of the parameters for the lorentz transform to
c rest frame system for 4-vector ep of mass squared s
c-----------------------------------------------------------------------
      dimension ey(3)
      double precision ep(4)

      do i=1,3
        if(ep(i+1).eq.0.d0)then
          ey(i)=1.
        else
          wp=ep(1)+ep(i+1)
          wm=ep(1)-ep(i+1)
          if(wp.gt.1.e-8.and.wm/wp.lt.1.e-8)then
            ww=s
            do l=1,3
              if(l.ne.i)ww=ww+ep(l+1)**2
            enddo
            wm=ww/wp
          elseif(wm.gt.1.e-8.and.wp/wm.lt.1.e-8)then
            ww=s
            do l=1,3
              if(l.ne.i)ww=ww+ep(l+1)**2
            enddo
            wp=ww/wm
          endif
          ey(i)=sqrt(wm/wp)
          ep(1)=wp*ey(i)
          ep(i+1)=0.
        endif
      enddo
      ep(1)=dsqrt(dble(s))
      return
      end

c------------------------------------------------------------------------
      function psdfh4(x,qqs,qq,icq,iq)
c------------------------------------------------------------------------
c psdfh4 - GRV structure functions
c------------------------------------------------------------------------
      common /psar36/ alvc
      
      if(x.gt..99999)then
        psdfh4=0.
        return
      endif
      if(icq.eq.2)then
        sq=log(log(qqs/.232**2)/log(.23/.232**2))
        if(iq.eq.0)then                                 !gluon
          alg=.524
          betg=1.088
          aag=1.742-.93*sq
          bbg=-.399*sq**2
          ag=7.486-2.185*sq
          bg=16.69-22.74*sq+5.779*sq*sq
          cg=-25.59+29.71*sq-7.296*sq*sq
          dg=2.792+2.215*sq+.422*sq*sq-.104*sq*sq*sq
          eg=.807+2.005*sq
          eeg=3.841+.361*sq
          psdfh4=(1.-x)**dg*(x**aag*(ag+bg*x+cg*x**2)*log(1./x)**bbg
     *    +sq**alg*exp(-eg+sqrt(eeg*sq**betg*log(1./x))))
        elseif(iq.eq.1.or.iq.eq.2)then                  !u_v or d_v
          aau=.59-.024*sq
          bbu=.131+.063*sq
          auu=2.284+.802*sq+.055*sq*sq
          au=-.449-.138*sq-.076*sq*sq
          bu=.213+2.669*sq-.728*sq*sq
          cu=8.854-9.135*sq+1.979*sq*sq
          du=2.997+.753*sq-.076*sq*sq
          uv=auu*x**aau*(1.-x)**du*
     *    (1.+au*x**bbu+bu*x+cu*x**1.5)

          aad=.376
          bbd=.486+.062*sq
          add=.371+.083*sq+.039*sq*sq
          ad=-.509+3.31*sq-1.248*sq*sq
          bd=12.41-10.52*sq+2.267*sq*sq
          ccd=6.373-6.208*sq+1.418*sq*sq
          dd=3.691+.799*sq-.071*sq*sq
          dv=add*x**aad*(1.-x)**dd*
     *    (1.+ad*x**bbd+bd*x+ccd*x**1.5)

          if(iq.eq.1)then                              !u_v
            psdfh4=uv
          elseif(iq.eq.2)then                          !d_v
            psdfh4=dv
          endif
        elseif(iq.eq.-3)then                           !s_sea
          als=.914
          bets=.577
          aas=1.798-.596*sq
          as=-5.548+3.669*sqrt(sq)-.616*sq
          bs=18.92-16.73*sqrt(sq)+5.168*sq
          ds=6.379-.35*sq+.142*sq*sq
          es=3.981+1.638*sq
          ees=6.402
          psdfh4=(1.-x)**ds*sq**als/log(1./x)**aas*(1.+as*sqrt(x)
     *    +bs*x)*exp(-es+sqrt(ees*sq**bets*log(1./x)))
        elseif(iabs(iq).lt.3)then                      !u_sea or d_sea
          aadel=.409-.005*sq
          bbdel=.799+.071*sq
          addel=.082+.014*sq+.008*sq*sq
          adel=-38.07+36.13*sq-.656*sq*sq
          bdel=90.31-74.15*sq+7.645*sq*sq
          ccdel=0.
          ddel=7.486+1.217*sq-.159*sq*sq
          delv=addel*x**aadel*(1.-x)**ddel*
     *    (1.+adel*x**bbdel+bdel*x+ccdel*x**1.5)

          alud=1.451
          betud=.271
          aaud=.41-.232*sq
          bbud=.534-.457*sq
          aud=.89-.14*sq
          bud=-.981
          cud=.32+.683*sq
          dud=4.752+1.164*sq+.286*sq*sq
          eud=4.119+1.713*sq
          eeud=.682+2.978*sq
          udsea=(1.-x)**dud*(x**aaud*(aud+bud*x+cud*x**2)
     *    *log(1./x)**bbud+sq**alud*exp(-eud+sqrt(eeud*sq**betud*
     *    log(1./x))))

          if(iq.eq.-1)then                           !u_sea
            psdfh4=(udsea-delv)/2.
          elseif(iq.eq.-2)then                       !d_sea
            psdfh4=(udsea+delv)/2.
          endif
        else
          psdfh4=0.
        endif
      elseif(icq.eq.1.or.icq.eq.3)then
        sq=log(log(qqs/.204**2)/log(.26/.204**2))
        if(iq.eq.1.or.iq.eq.2)then
          aapi=.517-.02*sq
          api=-.037-.578*sq
          bpi=.241+.251*sq
          dpi=.383+.624*sq
          anorm=1.212+.498*sq+.009*sq**2
          psdfh4=.5*anorm*x**aapi*(1.-x)**dpi*
     *    (1.+api*sqrt(x)+bpi*x)
        elseif(iq.eq.0)then
          alfpi=.504
          betpi=.226
          aapi=2.251-1.339*sqrt(sq)
          api=2.668-1.265*sq+.156*sq**2
          bbpi=0.
          bpi=-1.839+.386*sq
          cpi=-1.014+.92*sq-.101*sq**2
          dpi=-.077+1.466*sq
          epi=1.245+1.833*sq
          eppi=.51+3.844*sq
          psdfh4=(1.-x)**dpi*(x**aapi*(api+bpi*sqrt(x)+cpi*x)*
     *    log(1./x)**bbpi+sq**alfpi*
     *    exp(-epi+sqrt(eppi*sq**betpi*log(1./x))))
        elseif(iq.eq.-3)then
          alfpi=.823
          betpi=.65
          aapi=1.036-.709*sq
          api=-1.245+.713*sq
          bpi=5.58-1.281*sq
          dpi=2.746-.191*sq
          epi=5.101+1.294*sq
          eppi=4.854-.437*sq
          psdfh4=sq**alfpi/log(1./x)**aapi*(1.-x)**dpi*
     *    (1.+api*sqrt(x)+bpi*x)*
     *    exp(-epi+sqrt(eppi*sq**betpi*log(1./x)))
        elseif(iabs(iq).lt.3)then
          alfpi=1.147
          betpi=1.241
          aapi=.309-.134*sqrt(sq)
          api=.219-.054*sq
          bbpi=.893-.264*sqrt(sq)
          bpi=-.593+.24*sq
          cpi=1.1-.452*sq
          dpi=3.526+.491*sq
          epi=4.521+1.583*sq
          eppi=3.102
          psdfh4=(1.-x)**dpi*(x**aapi*(api+bpi*sqrt(x)+cpi*x)*
     *    log(1./x)**bbpi+sq**alfpi*
     *    exp(-epi+sqrt(eppi*sq**betpi*log(1./x))))       
        else
          psdfh4=0.
        endif
      elseif(icq.eq.0)then
        sq=log(log(qqs/.204**2)/log(.26/.204**2))
        if(iq.eq.0)then
          alfpi=.504
          betpi=.226
          aapi=2.251-1.339*sqrt(sq)
          api=2.668-1.265*sq+.156*sq**2
          bbpi=0.
          bpi=-1.839+.386*sq
          cpi=-1.014+.92*sq-.101*sq**2
          dpi=-.077+1.466*sq
          epi=1.245+1.833*sq
          eppi=.51+3.844*sq
          psdfh4=(1.-x)**dpi*(x**aapi*(api+bpi*sqrt(x)+cpi*x)*
     *    log(1./x)**bbpi+sq**alfpi*
     *    exp(-epi+sqrt(eppi*sq**betpi*log(1./x))))
     *    *.543
        else
          alfpi=.823
          betpi=.65
          aapi=1.036-.709*sq
          api=-1.245+.713*sq
          bpi=5.58-1.281*sq
          dpi=2.746-.191*sq
          epi=5.101+1.294*sq
          eppi=4.854-.437*sq
          str=sq**alfpi/log(1./x)**aapi*(1.-x)**dpi*
     *    (1.+api*sqrt(x)+bpi*x)*
     *    exp(-epi+sqrt(eppi*sq**betpi*log(1./x)))
          if(iq.eq.3)then
            psdfh4=str*.543*2.
          else        
            aapi=.517-.02*sq
            api=-.037-.578*sq
            bpi=.241+.251*sq
            dpi=.383+.624*sq
            anorm=1.212+.498*sq+.009*sq**2
            val=.5*anorm*x**aapi*(1.-x)**dpi*
     *      (1.+api*sqrt(x)+bpi*x)

            alfpi=1.147
            betpi=1.241
            aapi=.309-.134*sqrt(sq)
            api=.219-.054*sq
            bbpi=.893-.264*sqrt(sq)
            bpi=-.593+.24*sq
            cpi=1.1-.452*sq
            dpi=3.526+.491*sq
            epi=4.521+1.583*sq
            eppi=3.102
            sea=(1.-x)**dpi*(x**aapi*(api+bpi*sqrt(x)+cpi*x)*
     *      log(1./x)**bbpi+sq**alfpi*
     *      exp(-epi+sqrt(eppi*sq**betpi*log(1./x))))    
            if(iq.eq.1)then
              psdfh4=(.836*(val+2.*sea)-.587*str)
            elseif(iq.eq.2)then
              psdfh4=(.25*(val+2.*sea)+.587*str)
            else
              psdfh4=0.
            endif
          endif
        endif
        psdfh4=psdfh4/(1.+qq/.59)**2

      elseif(icq.eq.4.and.iq.eq.1)then
        psdfh4=x**3*(1.-x)**alvc*(alvc+3.)*(alvc+2.)*(alvc+1.)
      else
        psdfh4=0.
      endif
      return
      end


c------------------------------------------------------------------------
      function psfap(x,j,l)
c-----------------------------------------------------------------------
c psfap - altarelli-parisi function (multiplied by x)
c x - light cone momentum share value,
c j - type of the parent parton (0-g;1,2,etc.-q)
c l - type of the daughter parton (0-g;1,2,etc.-q)
c-----------------------------------------------------------------------
      double precision x
      include 'nexus.incsem'

      if(j.eq.0)then
        if(l.eq.0)then
          psfap=((1.d0-x)/x+x/(1.d0-x)+x*(1.d0-x))*6.d0
        else
          psfap=(x**2+(1.d0-x)**2)*naflav
        endif
      else
        if(l.eq.0)then
          psfap=(1.d0+(1.d0-x)**2)/x/.75d0
        else
          psfap=(x**2+1.d0)/(1.d0-x)/.75d0
        endif
      endif
      return
      end

c------------------------------------------------------------------------
      function psgen(a1,a2)
c-----------------------------------------------------------------------
c psgen - x-values generation according to distribution
c x1^(-a1) x2^(-0.5)
c-----------------------------------------------------------------------
      common/lept1/engy,elepti,elepto,angmue,icinpu

      aa=max(a1,a2)
1     continue
      if(aa.lt.1.)then
        x1=.5*rangen()**(1./(1.-aa))
      elseif(aa.eq.1.)then
        x1=.5/engy**rangen()
      else
        x1=.5*(1.+rangen()*(engy**(aa-1.)-1.))**(1./(1.-aa))
      endif
      if(x1.lt.1.e-7.or.x1.gt..999999)then
        goto 1
      endif
      if(rangen().lt..5)then
        gb=x1**(aa-a1)*.5**aa/(1.-x1)**a2
      else
        x1=1.-x1
        gb=(1.-x1)**(aa-a2)*.5**aa/x1**a1
      endif
      if(rangen().gt.gb)goto 1
      psgen=x1
      return
      end

c------------------------------------------------------------------------
      function psidd(icc)
c-----------------------------------------------------------------------
c psidd - kink type decoder
c-----------------------------------------------------------------------
      if(icc.eq.0)then                    !g
        psidd=9
      elseif(iabs(icc).le.2)then          !u,u~,d,d~
        psidd=icc
      elseif(iabs(icc).eq.4)then          !s,s~
        psidd=icc/4*3
      elseif(iabs(icc).gt.10)then         !c,c~ etc.
        psidd=icc/10
      elseif(icc.eq.3)then                !ud
        psidd=1200
      elseif(icc.eq.-3)then               !u~d~
        psidd=-1200
      elseif(icc.eq.6)then                !uu
        psidd=1100
      elseif(icc.eq.-6)then               !u~u~
        psidd=-1100
      elseif(icc.eq.7)then                !dd
        psidd=2200
      elseif(icc.eq.-7)then               !d~d~
        psidd=-2200
      else
        write (*,*)'psidd?????????',icc
      endif
      return
      end

c------------------------------------------------------------------------
      subroutine psjarr(jfl)
c-----------------------------------------------------------------------
c psjarr - final jets rearrangement according to their colour connection
c jfl - flag for the rejection (in case of jfl=0)
c-----------------------------------------------------------------------
c Input:

      parameter (mjstr=20000)
      common /psar29/ eqj(4,mjstr),iqj(mjstr),ncj(2,mjstr),nj

c eqj(1:4,k) - 4-momentum (qgs) for k-th parton;
c bxj(1:4,k) - coordinates for k-th parton formation point;
c iqj(k) - ID (qgs) for k-th parton;
c ncj(1:2,k) - colour connected partons indexes for k-th parton;
c nj - number of partons
c-----------------------------------------------------------------------
      dimension mark(mjstr)
      double precision  ept(4)
      include 'nexus.inc'
      include 'nexus.incsem'

      if(nj.eq.0)then
        jfl=1
        return
      endif
c      do k=1,nj  !???????????????
c       eqj(1,k)=dsqrt(0d0+eqj(2,k)**2+eqj(3,k)**2+eqj(4,k)**2)
c      enddo
      if(ish.ge.3)then
        write (ifch,*)'psjarr: nj',nj
        do k=1,nj
          if(iqj(k).ne.0)ncj(2,k)=0
          write(ifch,'(a,i4)')' parton',k
          write(ifch,'(i3,2x,4e10.3,2x,2i3)')iqj(k)
     *    ,(eqj(j,k),j=1,4),(ncj(j,k),j=1,2)
        enddo
      endif

      jfl=0
      do i=1,nj
        mark(i)=1
      enddo
      nptl0=nptl
      if(ish.ge.5)write (ifch,*)'nptl,nj',nptl,nj

1     continue
      do ij=1,nj
        if(mark(ij).ne.0.and.iqj(ij).ne.0)goto 2
      enddo
2     continue
      jfirst=1
      if(iabs(iqj(ij)).le.2)then
        am1=amhadr(1)
      elseif(iabs(iqj(ij)).eq.4)then
        am1=amhadr(3)
      elseif(iabs(iqj(ij)).eq.40)then
        am1=qcmass
      else
        am1=amhadr(2)
      endif

      do i=1,4
        ept(i)=0.
      enddo

3     continue
      call pspawr(ij)
      mark(ij)=0

      do i=1,4
        ept(i)=ept(i)+eqj(i,ij)
      enddo

      if(iqj(ij).ne.0)then
        if(jfirst.ne.1)then
          if(iabs(iqj(ij)).le.2)then
            am2=amhadr(1)
          elseif(iabs(iqj(ij)).eq.4)then
            am2=amhadr(3)
          elseif(iabs(iqj(ij)).eq.40)then
            am2=qcmass
          else
            am2=amhadr(2)
          endif
          amj=(am1+am2+stmass)**2
          sm=psnorm(ept)
          if(sm.lt.amj)then
            nptl=nptl0
            return
          endif

          if(nptl-nptl0.lt.nj)then
            goto 1
          else
      if(ish.ge.3)then
        write (ifch,*)'psjarr: nptl',nptl
        do k=nptl0,nptl
          write(ifch,'(a,i4)')' particle',k
          write(ifch,'(i5,2x,5e10.3)')idptl(k),(pptl(j,k),j=1,5)
        enddo
      endif
            jfl=1
            return
          endif
        else
          jfirst=0
          njpar=ij
          ij=ncj(1,ij)
          goto 3
        endif

      else
        if(ncj(1,ij).eq.njpar)then
          njdau=ncj(2,ij)
        else
          njdau=ncj(1,ij)
        endif
        njpar=ij
        ij=njdau
        goto 3
      endif
      end

c------------------------------------------------------------------------
       function pslam(s,a,b)
c-----------------------------------------------------------------------
c kinematical function for two particle decay - maximal pt-value
c a - first particle mass squared,
c b - second particle mass squared,
c s - two particle invariant mass squared
c-----------------------------------------------------------------------
       pslam=.25/s*(s+a-b)**2-a
       return
       end

c------------------------------------------------------------------------
      function psjvrg1(qt,s,y0)
c-----------------------------------------------------------------------
      common /ar3/   x1(7),a1(7)
      common /cnsta/ pi,pii,hquer,prom,piom,ainfin
      include 'nexus.incsem'

      psjvrg1=0.
      if(s.le.4.*qt)return

      xt=2.*sqrt(qt/s)
      ymax=min(y0,log(1./xt+sqrt(1./xt**2-1.)))
      ymin=-ymax

      do i=1,7
      do m=1,2
        y=.5*(ymax+ymin+(ymin-ymax)*(2*m-3)*x1(i))
        xmin=xt**2/2./(2.-xt*exp(-y))
        xmax=1.-xt*exp(y)/2.

        fx=0.
        do i1=1,7
        do m1=1,2
          xx1=xt*exp(y)/2.+xmin*(xmax/xmin)**(.5+x1(i1)*(m1-1.5))
          xx2=xt*exp(-y)*xx1/(2.*xx1-xt*exp(y))
          z=xx1*xx2
          sh=z*s
          t=sh/2.*(1.-sqrt(1.-4.*qt/sh))
          ft=psjvrx(t,qt,xx1,xx2,sh)
          fx=fx+a1(i1)*ft/sh**2
        enddo
        enddo
        fx=fx*log(xmax/xmin)
        psjvrg1=psjvrg1+a1(i)*fx
      enddo
      enddo
      psjvrg1=psjvrg1*(ymax-ymin)*pi**3
     **pssalf(qt/qcdlam)**2*sqrt(qt)
      return
      end

c-----------------------------------------------------------------------
      function psjvrx(t,qt,xx1,xx2,s)
c-----------------------------------------------------------------------
      include 'nexus.incsem'

      g1=psdfh4(xx1,qt,0.,2,0)
      ub1=psdfh4(xx1,qt,0.,2,-1)
      u1=psdfh4(xx1,qt,0.,2,1)+ub1
      db1=psdfh4(xx1,qt,0.,2,-2)
      d1=psdfh4(xx1,qt,0.,2,2)+db1
      sb1=psdfh4(xx1,qt,0.,2,-3)
      s1=sb1
      g2=psdfh4(xx2,qt,0.,2,0)
      ub2=psdfh4(xx2,qt,0.,2,-1)
      u2=psdfh4(xx2,qt,0.,2,1)+ub2
      db2=psdfh4(xx2,qt,0.,2,-2)
      d2=psdfh4(xx2,qt,0.,2,2)+db2
      sb2=psdfh4(xx2,qt,0.,2,-3)
      s2=sb2

      psjvrx=g1*g2*(psbori(s,t,0,0,1)+psbori(s,s-t,0,0,1)
     *+psbori(s,t,0,0,2)+psbori(s,s-t,0,0,2))/2.
     *+(psbori(s,t,0,1,1)+psbori(s,s-t,0,1,1))*
     *(g2*(u1+ub1+d1+db1+s1+sb1)+g1*(u2+ub2+d2+db2+s2+sb2))
     *+(psbori(s,t,1,1,1)+psbori(s,s-t,1,1,1))/2.*
     *(u1*u2+ub1*ub2+d1*d2+db1*db2+s1*s2+sb1*sb2)
     *+(psbori(s,t,1,-1,1)+psbori(s,s-t,1,-1,1)+psbori(s,t,1,-1,2)+
     *psbori(s,s-t,1,-1,2)+psbori(s,t,1,-1,3)+psbori(s,s-t,1,-1,3))*
     *(u1*ub2+ub1*u2+d1*db2+db1*d2+s1*sb2+sb1*s2)
     *+(psbori(s,t,1,2,1)+psbori(s,s-t,1,2,1))*
     *((u1+ub1)*(d2+db2+s2+sb2)+(u2+ub2)*(d1+db1+s1+sb1)+
     *(d1+db1)*(u2+ub2+s2+sb2)+(d2+db2)*(u1+ub1+s1+sb1)+
     *(s1+sb1)*(u2+ub2+d2+db2)+(s2+sb2)*(u1+ub1+d1+db1))
      return
      end

c------------------------------------------------------------------------
      function psjwo1(qt,s,y0)
c-----------------------------------------------------------------------
      common /ar3/   x1(7),a1(7)
      common /cnsta/ pi,pii,hquer,prom,piom,ainfin
      include 'nexus.incsem'

      psjwo1=0.
      if(s.le.4.*qt)return

      xt=2.*sqrt(qt/s)
      ymax=min(y0,log(1./xt+sqrt(1./xt**2-1.)))
      ymin=-ymax

      do i=1,7
      do m=1,2
        y=.5*(ymax+ymin+(ymin-ymax)*(2*m-3)*x1(i))
        xmin=xt**2/2./(2.-xt*exp(-y))
        xmax=1.-xt*exp(y)/2.

        fx=0.
        do i1=1,7
        do m1=1,2
          xx1=xt*exp(y)/2.+xmin*(xmax/xmin)**(.5+x1(i1)*(m1-1.5))
          xx2=xt*exp(-y)*xx1/(2.*xx1-xt*exp(y))
          z=xx1*xx2
          sh=z*s
          t=sh/2.*(1.-sqrt(1.-4.*qt/sh))
          ft=psjwox(t,qt,xx1,xx2,sh)
          fx=fx+a1(i1)*ft/sh**2
        enddo
        enddo
        fx=fx*log(xmax/xmin)
        psjwo1=psjwo1+a1(i)*fx
      enddo
      enddo
      psjwo1=psjwo1*(ymax-ymin)*pi**3
     **pssalf(qt/qcdlam)**2*sqrt(qt)
      return
      end

c-----------------------------------------------------------------------
      function psjwox(t,qt,xx1,xx2,s)
c-----------------------------------------------------------------------
      double precision x,scale,upv1,dnv1,sea1,str1,chm1,gl1,
     *upv2,dnv2,sea2,str2,chm2,gl2
      scale=sqrt(qt)
      x=xx1
      call strdo1(x,scale,upv1,dnv1,sea1,str1,chm1,gl1)
      x=xx2
      call strdo1(x,scale,upv2,dnv2,sea2,str2,chm2,gl2)

      psjwox=gl1*gl2*(psbori(s,t,0,0,1)+psbori(s,s-t,0,0,1)
     *+psbori(s,t,0,0,2)+psbori(s,s-t,0,0,2)+psbori(s,t,0,0,3)
     *+psbori(s,s-t,0,0,3))/2.
     *+(psbori(s,t,0,1,1)+psbori(s,s-t,0,1,1)
     *+psbori(s,t,0,1,2)+psbori(s,s-t,0,1,2)+psbori(s,t,0,1,3)
     *+psbori(s,s-t,0,1,3))*(gl2*(upv1+dnv1+4.*sea1+2.*str1+2.*chm1)+
     *gl1*(upv2+dnv2+4.*sea2+2.*str2+2.*chm2))
     *+(psbori(s,t,1,1,1)+psbori(s,s-t,1,1,1)
     *+psbori(s,t,1,1,2)+psbori(s,s-t,1,1,2)+psbori(s,t,1,1,3)+
     *psbori(s,s-t,1,1,3))/2.*
     *((upv1+sea1)*(upv2+sea2)+(dnv1+sea1)*(dnv2+sea2)+2.*sea1*sea2
     *+2.*str1*str2+2.*chm1*chm2)
     *+(psbori(s,t,1,-1,1)+psbori(s,s-t,1,-1,1)+psbori(s,t,1,-1,2)+
     *psbori(s,s-t,1,-1,2)+psbori(s,t,1,-1,3)+psbori(s,s-t,1,-1,3))*
     *((upv1+sea1)*sea2+sea1*(upv2+sea2)+(dnv1+sea1)*sea2+
     *sea1*(dnv2+sea2)+2.*str1*str2+2.*chm1*chm2)
     *+(psbori(s,t,1,2,1)
     *+psbori(s,s-t,1,2,1)+psbori(s,t,1,2,2)+psbori(s,s-t,1,2,2)
     *+psbori(s,t,1,2,3)+psbori(s,s-t,1,2,3))*
     *(upv1*dnv2+upv2*dnv1+(upv1+dnv1)*(2.*sea2+2.*str2+2.*chm2)+
     *(upv2+dnv2)*(2.*sea1+2.*str1+2.*chm1)+
     *4.*sea1*(2.*sea2+2.*str2+2.*chm2)+2.*str1*(4.*sea2+2.*chm2)+
     *2.*chm1*(4.*sea2+2.*str2))
      return
      end

c------------------------------------------------------------------------
      function psjx1(qt,s,y0)
c-----------------------------------------------------------------------
      common /ar3/   x1(7),a1(7)
      common /cnsta/ pi,pii,hquer,prom,piom,ainfin
      include 'nexus.incsem'

      psjx1=0.
      if(s.le.4.*qt)return

      xt=2.*sqrt(qt/s)
      ymax=min(y0,log(1./xt+sqrt(1./xt**2-1.)))
      ymin=-ymax

      do i=1,7
      do m=1,2
        y=.5*(ymax+ymin+(ymin-ymax)*(2*m-3)*x1(i))
        xmin=xt**2/2./(2.-xt*exp(-y))
        xmax=1.-xt*exp(y)/2.

        fx=0.
        do i1=1,7
        do m1=1,2
          xx1=xt*exp(y)/2.+xmin*(xmax/xmin)**(.5+x1(i1)*(m1-1.5))
          xx2=xt*exp(-y)*xx1/(2.*xx1-xt*exp(y))
          z=xx1*xx2
          sh=z*s
          t=sh/2.*(1.-sqrt(1.-4.*qt/sh))
          ft=psjy(t,qt,xx1,xx2,sh)
          fx=fx+a1(i1)*ft/sh**2
        enddo
        enddo
        fx=fx*log(xmax/xmin)
        psjx1=psjx1+a1(i)*fx
      enddo
      enddo
      psjx1=psjx1*(ymax-ymin)*pi**3
     **pssalf(qt/qcdlam)**2*sqrt(qt)
      return
      end 

c-----------------------------------------------------------------------
      function psjy(t,qt,xx1,xx2,s)
c-----------------------------------------------------------------------
      include 'nexus.incsem'

      g1=pspdf0(xx1,qt,0)
      uv1=0.    !???????pspdf0(xx1,qt,1)
      dv1=0.    !???????pspdf0(xx1,qt,2)
      uv1=pspdf0(xx1,qt,1)
      dv1=pspdf0(xx1,qt,2)
      sea1=pspdf0(xx1,qt,-1)
      g2=pspdf0(xx2,qt,0)
      uv2=0.    !???????pspdf0(xx2,qt,1)
      dv2=0.    !???????pspdf0(xx2,qt,2)
      uv2=pspdf0(xx2,qt,1)
      dv2=pspdf0(xx2,qt,2)
      sea2=pspdf0(xx2,qt,-1)

      psjy=(psbori(s,t,0,0,1)+psbori(s,s-t,0,0,1)
     *+psbori(s,t,0,0,2)+psbori(s,s-t,0,0,2))/2.*g1*g2               !gg
     *+(psbori(s,t,0,1,1)+psbori(s,s-t,0,1,1))                       !gq
     **(g1*(uv2+dv2+2.*naflav*sea2)+g2*(uv1+dv1+2.*naflav*sea1))
     *+(psbori(s,t,1,1,1)+psbori(s,s-t,1,1,1))/2.                    !qq
     **((uv1+sea1)*(uv2+sea2)
     *+(dv1+sea1)*(dv2+sea2)+sea1*sea2*(naflav-1)*2.)+
     *(psbori(s,t,1,-1,1)+psbori(s,s-t,1,-1,1)+psbori(s,t,1,-1,2)+
     *psbori(s,s-t,1,-1,2)+psbori(s,t,1,-1,3)+psbori(s,s-t,1,-1,3))* !qq~
     *((uv1+sea1)*sea2+(uv2+sea2)*sea1
     *+(dv1+sea1)*sea2+(dv2+sea2)*sea1+sea1*sea2*(naflav-2)*2.)
     *+(psbori(s,t,1,2,1)+psbori(s,s-t,1,2,1))*                      !qq'
     *(dv1*uv2+dv2*uv1+(uv2+dv2)*sea1*(naflav-1)*2.
     *+(uv1+dv1)*sea2*(naflav-1)*2.+sea1*sea2*naflav*(naflav-1)*4.)
      return
      end

c------------------------------------------------------------------------
      subroutine pslcsh(wp1,wm1,wp2,wm2,samqt,amqpt)
c-----------------------------------------------------------------------
c pslcsh - sh pomeron lc momentum sharing between two strings
c------------------------------------------------------------------------
      double precision amqt(4),yqm(4),yqm1(4),xlp(4),xlm(4),am23,sx,y2
     *,wp1,wp2,wm1,wm2,s,sq,psutz,yqmax,y,amjp,amjm,y1,s12,s34,x34,amqpt
      dimension samqt(4)
      include 'nexus.inc'

      s=wp1*wm1
      sq=dsqrt(s)
      do i=1,4
        amqt(i)=dble(samqt(i))
        yqm(i)=dlog(sq/amqt(i)*psutz(s,amqt(i)**2,(amqpt-amqt(i))**2))
      enddo
      yqmax=max(yqm(1),yqm(2))

1     y=yqmax*dble(rangen())
      j=int(1.5+rangen())
      if(y.gt.yqm(j))goto 1

      amjp=amqt(j)*dexp(y)
      amjm=amqt(j)*dexp(-y)
      do i=3,4
        am23=amqt(3-j)+amqt(7-i)
        sx=(am23+amjp)*(am23+amjm)
        yqm1(i)=dlog(sq/amqt(i)*psutz(s,amqt(i)**2,sx))
      enddo
      yqmax1=max(yqm1(3),yqm1(4))
      if(dble(rangen()).gt.yqmax1/max(yqm(3),yqm(4)))goto 1

      y1=yqmax1*dble(rangen())
      j1=int(3.5+rangen())
      if(y1.gt.yqm1(j1))goto 1

      amjp1=amqt(j1)*exp(y1)
      amjm1=amqt(j1)*exp(-y1)
      s12=(amqt(3-j)+amjp)*(amqt(3-j)+amjm)
      s34=(amqt(7-j1)+amjp1)*(amqt(7-j1)+amjm1)
      y2=dlog(sq/(amqt(3-j)+amjp)*psutz(s,s12,s34))

      xlp(j)=amqt(j)/sq*dexp(y+y2)
      xlm(j)=amqt(j)/sq*dexp(-y-y2)
      xlp(3-j)=amqt(3-j)/sq*dexp(y2)
      xlm(3-j)=amqt(3-j)/sq*dexp(-y2)
      x34=1.-xlm(1)-xlm(2)
      xlm(7-j1)=x34/(1.+amjp1/amqt(7-j1))
      xlm(j1)=x34-xlm(7-j1)
c      write (*,*)'xlc',xlp(1),xlp(2),xlm(3),xlm(4)
      if(dble(rangen()).gt.(xlp(1)*xlp(2)*xlm(3)*xlm(4))**(-alpqua)*
     *(xlp(j)*(1.d0-xlp(j))*xlm(j1)*(1.d0-xlm(j1))))goto 1

      wp2=xlp(2)*wp1
      wp1=xlp(1)*wp1
      wm2=xlm(4)*wm1
      wm1=xlm(3)*wm1
c      write (*,*)'wp1,wm1,wp2,wm2',wp1,wm1,wp2,wm2
      return
      end

c------------------------------------------------------------------------
      function psnorm(ep)
c-----------------------------------------------------------------------
c 4-vector squared calculation
c-----------------------------------------------------------------------
      double precision sm2,ep(4)
      sm2=ep(1)**2
      do i=1,3
        sm2=sm2-ep(i+1)**2
      enddo
      psnorm=sm2
      return
      end

c------------------------------------------------------------------------
      subroutine pspawr(kj)
c-----------------------------------------------------------------------
c pspawr - writing final parton kj into particle list
c------------------------------------------------------------------------
c Input:

      parameter (mjstr=20000)
      common /psar29/ eqj(4,mjstr),iqj(mjstr),ncj(2,mjstr),nj
      common /psar30/ iorj(mjstr),ityj(mjstr),bxj(6,mjstr)

c eqj(1:4,k) - 4-momentum (qgs) for k-th parton;
c bxj(1:4,k) - coordinates for k-th parton formation point;
c iqj(k) - ID (qgs) for k-th parton;
c ncj(1:2,k) - colour connected partons indexes for k-th parton;
c nj - number of partons
c-----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'

      if(ish.ge.9)write (ifch,*)'nptl,kj (sto)',nptl,kj
      if(nptl.ge.mxptl)then
       write (ifmt,*)'nptl,kj',nptl,kj
       stop'nptl out of bounds'
      endif 
      nptl=nptl+1
      pptl(1,nptl)=eqj(3,kj)
      pptl(2,nptl)=eqj(4,kj)
      pptl(3,nptl)=eqj(2,kj)
      pptl(4,nptl)=eqj(1,kj)
      pptl(5,nptl)=0.
      idptl(nptl)=psidd(iqj(kj))
      iorptl(nptl)=iorj(kj)
      jorptl(nptl)=0
      istptl(nptl)=20
      do i=1,4
        xorptl(i,nptl)=bxj(i,kj)
      enddo
      tivptl(1,nptl)=bxj(5,kj)
      tivptl(2,nptl)=bxj(6,kj)
      ityptl(nptl)=ityj(kj)
      return
      end

c------------------------------------------------------------------------
      subroutine psrotat(ep,s0x,c0x,s0,c0)
c-----------------------------------------------------------------------
c psrotat - spacial rotation to the lab. system for 4-vector ep
c s0, c0 - sin and cos for the zx-rotation;
c s0x, c0x - sin and cos for the xy-rotation
c-----------------------------------------------------------------------
      dimension ep(4),ep1(3)

      ep1(3)=ep(4)
      ep1(2)=ep(2)*s0+ep(3)*c0
      ep1(1)=ep(2)*c0-ep(3)*s0

      ep(2)=ep1(1)
      ep(4)=ep1(2)*s0x+ep1(3)*c0x
      ep(3)=ep1(2)*c0x-ep1(3)*s0x
      return
      end

c------------------------------------------------------------------------
      subroutine psrotat1(ep,s0x,c0x,s0,c0)
c-----------------------------------------------------------------------
c psrotat - spacial rotation to the lab. system for 4-vector ep
c s0, c0 - sin and cos for the zx-rotation;
c s0x, c0x - sin and cos for the xy-rotation
c-----------------------------------------------------------------------
      dimension ep(4),ep1(3)

      ep1(1)=ep(2)
      ep1(3)=-ep(3)*s0x+ep(4)*c0x
      ep1(2)=ep(3)*c0x+ep(4)*s0x

      ep(4)=ep1(3)
      ep(3)=-ep1(1)*s0+ep1(2)*c0
      ep(2)=ep1(1)*c0+ep1(2)*s0
      return
      end

c-----------------------------------------------------------------------
      function pssalf(qq)
c-----------------------------------------------------------------------
c pssalf - effective qcd coupling (alpha_s/2/pi)
c-----------------------------------------------------------------------
      include "nexus.incsem"
      pssalf=2./(11.-naflav/1.5)/log(qq)
      return
      end

c------------------------------------------------------------------------
      subroutine pstrans(ep,ey,jj)
c-----------------------------------------------------------------------
c pstrans - lorentz boosts according to the parameters ey ( determining
c shift along the z,x,y-axis respectively (ey(1),ey(2),ey(3)))
c jj=1 - inverse transformation to the lab. system;
c jj=-1 - direct transformation
c-----------------------------------------------------------------------
      dimension ey(3),ep(4)

      if(jj.eq.1)then
c lorentz transform to lab. system according to 1/ey(i) parameters
        do i=1,3
          if(ey(4-i).ne.1.)then
            wp=(ep(1)+ep(5-i))/ey(4-i)
            wm=(ep(1)-ep(5-i))*ey(4-i)
            ep(1)=.5*(wp+wm)
            ep(5-i)=.5*(wp-wm)
          endif
        enddo  
      else
c lorentz transform to lab. system according to ey(i) parameters
        do i=1,3
          if(ey(i).ne.1.)then
            wp=(ep(1)+ep(i+1))*ey(i)
            wm=(ep(1)-ep(i+1))/ey(i)
            ep(1)=.5*(wp+wm)
            ep(i+1)=.5*(wp-wm)
          endif
        enddo  
      endif
      return
      end

c------------------------------------------------------------------------
      function psuds(q,m)
c-----------------------------------------------------------------------
c psuds - spacelike sudakov formfactor
c q - maximal value of the effective momentum,
c m - type of parton (0 - g, 1,2, etc. - q)
c-----------------------------------------------------------------------
      dimension wi(3)
      common /psar15/ sudx(40,2)
      include 'nexus.incsem'

      j=min(iabs(m),1)+1

      if(q.gt.q2ini)then
        qli=log(q/q2min)*2.+1.
        i=int(qli)
        if(i.lt.1)i=1
        if(i.gt.38)i=38
        wi(2)=qli-i
        wi(3)=wi(2)*(wi(2)-1.)*.5
        wi(1)=1.-wi(2)+wi(3)
        wi(2)=wi(2)-2.*wi(3)
        dps=0.
        do i1=1,3
          dps=dps+sudx(i+i1-1,j)*wi(i1)
        enddo

        qlm=log(q/qcdlam)
        psuds=(qlm*log(qlm/log(q2ini/qcdlam))-log(q/q2ini))

        if(j.eq.1)then
          psuds=(psuds-(11.-naflav/1.5)/12.*log(qlm/log(q2ini/qcdlam))
     *    +dps*(1.-q2ini/q))*12./(11.-naflav/1.5)
        else
          psuds=(psuds-log(qlm/log(q2ini/qcdlam))*.75
     *    +dps*(1.-q2ini/q))*16./3./(11.-naflav/1.5)
        endif
        psuds=exp(-psuds)
      else
        psuds=1.
      endif
      return
      end

c------------------------------------------------------------------------
      function psudx(q,j)
c-----------------------------------------------------------------------
c psudx - part of the bspacelike sudakov formfactor
c q - maximal value of the effective momentum,
c j - type of parton (1 - g, 2 - q)
c-----------------------------------------------------------------------
      common /ar3/    x1(7),a1(7)
      include 'nexus.incsem'

      psudx=0.

      do i=1,7
      do m=1,2
        qt=.5*(q2ini+q-x1(i)*(2.*m-3.)*(q2ini-q))
        if(j.eq.1)then
          zm=1.-qt/q
          dps=((11.-naflav/1.5)/12.-zm**2*(1.-naflav/12.)+
     *    (zm**3/3.-zm**4/4.)*(1.-naflav/3.))*q/qt
        else
          dps=(1.-qt/q/4.)
        endif
        psudx=psudx+a1(i)*dps/log(qt/qcdlam)
      enddo
      enddo
      psudx=psudx*.5
      return
      end

c------------------------------------------------------------------------
      double precision function psutz(s,a,b)
c-----------------------------------------------------------------------
c psutz - kinematical function for two particle decay - light cone momen
c share for the particle of mass squared a,
c b - partner's mass squared,
c s - two particle invariant mass
c-----------------------------------------------------------------------
      double precision a1,b1,s1,x,dx,s,a,b
      a1=dsqrt(a)
      b1=dsqrt(b)
      s1=dsqrt(s)
      x=(1.d0+(a1-b1)*(a1+b1)/s)/2.d0
      dx=(x-a1/s1)*(x+a1/s1)
c      x=.5*(1.+(a-b)/s)
c      dx=(x*x-a/s)
      if(dx.gt.0.d0)then
        x=x+dsqrt(dx)
      else
        x=a1/s1
      endif
      psutz=min(0.999999999d0,x)     
      return
      end

c------------------------------------------------------------------------
      block data ptdata
c-----------------------------------------------------------------------
c constants for numerical integration (gaussian weights)
c-----------------------------------------------------------------------
      common /ar3/ x1(7),a1(7)
      common /ar4/ x4(2),a4(2)
      common /ar5/ x5(2),a5(2)
      common /ar8/ x2(4),a2
      common /ar9/ x9(3),a9(3)

      data x1/.9862838,.9284349,.8272013,.6872929,.5152486,
     *.3191124,.1080549/
      data a1/.03511946,.08015809,.1215186,.1572032,
     *.1855384,.2051985,.2152639/
      data x2/.00960736,.0842652,.222215,.402455/
      data a2/.392699/
      data x4/ 0.339981,0.861136/
      data a4/ 0.652145,0.347855/
      data x5/.585786,3.41421/
      data a5/.853553,.146447/
      data x9/.93247,.661209,.238619/
      data a9/.171324,.360762,.467914/
      end

c------------------------------------------------------------------------
      subroutine strdo1(x,scale,upv,dnv,sea,str,chm,gl)
c------------------------------------------------------------------------
c :::::::::::: duke owens set 1 ::::::::::::::::::::::::::::
c------------------------------------------------------------------------
      implicit double precision(a-h,o-z)
      double precision
     +       f(5),a(6,5),b1(3,6,5)
      data q0,ql1/2.d0,.2d0/
      data b1/3.d0,0.d0,0.d0,.419d0,.004383d0,-.007412d0,
     &3.46d0,.72432d0,-.065998d0,4.4d0,-4.8644d0,1.3274d0,
     &6*0.d0,1.d0,
     &0.d0,0.d0,.763d0,-.23696d0,.025836d0,4.d0,.62664d0,-.019163d0,
     &0.d0,-.42068d0,.032809d0,6*0.d0,1.265d0,-1.1323d0,.29268d0,
     &0.d0,-.37162d0,-.028977d0,8.05d0,1.5877d0,-.15291d0,
     &0.d0,6.3059d0,-.27342d0,0.d0,-10.543d0,-3.1674d0,
     &0.d0,14.698d0,9.798d0,0.d0,.13479d0,-.074693d0,
     &-.0355d0,-.22237d0,-.057685d0,6.3494d0,3.2649d0,-.90945d0,
     &0.d0,-3.0331d0,1.5042d0,0.d0,17.431d0,-11.255d0,
     &0.d0,-17.861d0,15.571d0,1.564d0,-1.7112d0,.63751d0,
     &0.d0,-.94892d0,.32505d0,6.d0,1.4345d0,-1.0485d0,
     &9.d0,-7.1858d0,.25494d0,0.d0,-16.457d0,10.947d0,
     &0.d0,15.261d0,-10.085d0/
      wn=1.d0
      s= log( log( max(q0,scale)/ql1)/ log(q0/ql1))
      do 10 i=1,5
      do 10 j=1,6
   10 a(j,i)=b1(1,j,i)+s*(b1(2,j,i)+s*b1(3,j,i))
      do 40 i=1,5
   40 f(i)=a(1,i)*x**a(2,i)*(wn-x)**a(3,i)*(wn+x*
     &    (a(4,i)+x*(a(5,i)+x*a(6,i))))
      do 50 i=1,2
      aa=wn+a(2,i)+a(3,i)
   50 f(i)=f(i)*utgam1(sngl(aa))/((wn+a(2,i)*a(4,i)/aa)
     &*utgam1(sngl(a(2,i)))*utgam1(sngl(wn+a(3,i))))
      upv=f(1)-f(2)
      dnv=f(2)
      sea=f(3)/6.d0
      str=sea
      chm=f(4)
      gl =f(5)
      return
      end
