c-----------------------------------------------------------------------
      subroutine utresc(iret)
c-----------------------------------------------------------------------
c  if irescl=1 rescaling is done, otherwise the purpose of going through 
c  this routine is to not change the seed in case of no rescaling
c-----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incems'
      double precision p1,esoll
      dimension p1(5),p0(5,mamx+mamx)
      call utpri('utresc',ish,ishini,4)

      errlim=0.0001
      
      iret=0
      nptlpt=iabs(maproj)+iabs(matarg)
      if(nptl.le.nptlpt) goto 9999
      
      esoll=0.d0
      p1(1)=0.d0
      p1(2)=0.d0
      p1(3)=0.d0
      p1(4)=0.d0
      ipmax=4
      imin=nptlpt+1
      if(iappl.eq.1)then
        imin=1
        ipmax=2
      endif
      do i=nptlpt+1,nptl
       if(mod(istptl(i),10).eq.0)then
         do j=1,ipmax
           p1(j)=p1(j)+dble(pptl(j,i))
         enddo
       endif
      enddo
      do i=imin,nptlpt
         do j=1,5
           p0(j,i)=pptl(j,i)
         enddo
         do j=ipmax+1,4
           p1(j)=p1(j)+dble(pptl(j,i))
         enddo
      enddo
      p1(5)=dsqrt((p1(4)+p1(3))*(p1(4)-p1(3))-p1(2)*p1(2)-p1(1)*p1(1))
      esoll=p1(5)
      if(ish.ge.4) write (ifch,'(a,5g13.6)') 'boost-vector',p1

c     trafo
c     -----
      do i=imin,nptl
        if(mod(istptl(i),10).eq.0)then
          call utlob4(1,p1(1),p1(2),p1(3),p1(4),p1(5)
     $         ,pptl(1,i),pptl(2,i),pptl(3,i),pptl(4,i))
        endif
      enddo

      if(ish.ge.5)write(ifch,'(a)')'------------------'

c     mark ghosts
c     -----------
      do  j=nptlpt+1,nptl 
        if(mod(istptl(j),10).eq.0.and.pptl(4,j).gt.0.d0)then
          amass=pptl(5,j)
          call idmass(idptl(j),amass)
          if(abs(pptl(5,j)-amass).gt.0.01*amass)then
            if(ish.gt.6)write(ifch,*)'wrong particle mass',j,idptl(j)
     &                                           ,pptl(5,j),amass
            amass=pptl(5,j)
            call idres(idptl(j),amass,idr,iadj)
            if(idr.ne.0)then
              pptl(5,j)=amass
              idptl(j)=idr
            else
              call idmass(idptl(j),amass)
              pptl(5,j)=amass
            endif
            call idtau(idptl(j),pptl(4,j),pptl(5,j),taugm)
            tivptl(2,j)=tivptl(1,j)+taugm*(-alog(rangen()))
          endif
          if(abs((pptl(4,j)+pptl(3,j))*(pptl(4,j)-pptl(3,j))
     $         -pptl(2,j)**2-pptl(1,j)**2-pptl(5,j)**2).gt.0.3
     $       .and.abs(1.-abs(pptl(3,j))/pptl(4,j)).gt.0.01)then
c            if(ityptl(j)/10.eq.4)ityptl(j)=54
c            if(ityptl(j)/10.eq.3)ityptl(j)=53
            ityptl(j)=50+ityptl(j)/10
            if(ish.ge.5)then 
              write(ifch,'(a,$)')'ghost:'
              call alist("&",j,j)
            endif
          endif 
        elseif(mod(istptl(j),10).eq.0)then
           if(ish.ge.1)then
             write(ifmt,*)'Lost particle (E=0)'
             write(ifch,*)'Lost particle (E=0) :'
             call alistc("utresc&",j,j)
           endif
           istptl(j)=istptl(j)+2
        endif
      enddo

      if(ish.ge.5)write(ifch,'(a)')'------------------'
     
c     treat ghosts
c     ------------
      ifirst=1
      scal=1.
      pfif=0.
      efif=0.
      ntry=0
 132  nfif=0
      psum=0
      esum=0.
      ntry=ntry+1
      do  j=nptlpt+1,nptl 
        if(mod(istptl(j),10).eq.0)then
          if(ityptl(j).ge.51.and.ityptl(j).le.54)then
            nfif=nfif+1
            if(ifirst.eq.1) pfif=pfif+pptl(3,j)
            if(ifirst.eq.1.and.pptl(4,j).gt.0.)efif=efif+pptl(4,j)
            if(irescl.ge.1) then 
              if(ifirst.eq.1)then
                y=(rangen()+rangen()+rangen()+rangen()-2.)/2.*yhaha
                y=sign(abs(y),pptl(3,j))
                pptl(3,j)
     $               =sqrt(pptl(5,j)**2+pptl(1,j)**2
     $               +pptl(2,j)**2)*sinh(y)
                pptl(4,j)
     $               =sqrt(pptl(5,j)**2+pptl(1,j)**2
     $               +pptl(2,j)**2)*cosh(y)
                efif=efif+pptl(4,j)
              else
c                do k=1,3
                do k=3,3
                  pptl(k,j)=pptl(k,j)*scal
                enddo
                pptl(4,j)=sqrt(pptl(1,j)**2+pptl(2,j)**2+pptl(3,j)**2
     *                 +pptl(5,j)**2)
              endif
            endif
            psum=psum+pptl(3,j)
            esum=esum+pptl(4,j)
            if(ish.ge.5)
     $           write (ifch,*) 'nrevt,psum,esum,pfif,efif,nfif,scal'
     $           ,nrevt,psum,esum,pfif,efif,nfif,scal
          endif 
        endif
      enddo
      if ( ish.ge.5 )  write (ifch,*) 'tot',efif,pfif,esum,psum


      if(nfif.gt.1)then
        do  j=nptlpt+1,nptl
          if ( ityptl(j).ge.51 .and. ityptl(j).le.54 )then
            pptl(3,j)=pptl(3,j)-(psum-pfif)/nfif
          endif
        enddo
        scal=efif/esum
        if ( ish.ge.5 )  write (ifch,*) 'scal',scal
        if ( abs(scal-1.) .gt. 0.01 .or. ifirst.eq.1 ) then
          ifirst = 0
          if(ntry.le.1000)then
            goto 132
          else
            iret=1
            if(ish.ge.2)write (ifch,*) 'Problem in utresc : redo event'
            if(ish.ge.1)write (ifmt,*) 'Problem in utresc : redo event'
c            call utstop('utresc&')
            goto 9999
         endif
        endif
      endif

      if(ish.ge.5)write(ifch,'(a)')'------------------'

c Check Ghost list

      do  j=nptlpt+1,nptl         
        if(mod(istptl(j),10).eq.0)then
          if(ityptl(j).le.54.and.ityptl(j).ge.51)then
            if(ish.ge.5)then 
              write(ifch,'(a,$)')'ghost:'
              call alist("&",j,j)
            endif
          endif
        endif
      enddo

      if(ish.ge.5)write(ifch,'(a)')'------------------'

c     rescale momenta in rest frame
c     -----------------------------

      scal=1.
      diff=0.
      do ipass=1,1000
        sum=0.
        sum3=0.
        ndif=0
        do  j=imin,nptl 
          if(mod(istptl(j),10).eq.0)then
            if(j.gt.nptlpt)then
              ndif=ndif+1
              pptl(3,j)=scal*(pptl(3,j)-diff)
              pptl(4,j)=sqrt(pptl(1,j)**2+pptl(2,j)**2+pptl(3,j)**2
     *           +pptl(5,j)**2)
            endif
            sum=sum+pptl(4,j)
            sum3=sum3+pptl(3,j)
          endif
        enddo

        diff=sum3/real(ndif)
        scal=real(esoll)/sum
        if(ish.ge.6)write(ifch,*)'ipass,scal,diff,e,esoll,pz,ndif:'
     $       ,ipass,scal,diff,sum,esoll,sum3,ndif
        if(abs(scal-1.).le.errlim.and.abs(diff).lt.10.*errlim) goto300
      enddo
      if(ish.ge.1)then
        call utmsg('hrescl')
        write(ifch,*)'*****  scal=',scal,diff
        call utmsgf
      endif

      
c     trafo
c     -----
 300  continue
      do i=imin,nptl
        if(mod(istptl(i),10).eq.0)then
          call utlob4(-1,p1(1),p1(2),p1(3),p1(4),p1(5)
     $         ,pptl(1,i),pptl(2,i),pptl(3,i),pptl(4,i))
        endif
        if(i.le.nptlpt)then
          do j=1,5
            pptl(j,i)=p0(j,i)
          enddo
        endif
      enddo
      
 9999 call utprix('utresc',ish,ishini,4)

      end

c-----------------------------------------------------------------------
      subroutine utrsph(iret)
c-----------------------------------------------------------------------
c  if irescl=1 and ispherio=1 rescaling is done for particle used by 
c  spherio as initial condition.
c-----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incems'
      double precision p1,esoll
      dimension p1(5),p0(5,mamx+mamx)
      call utpri('utrsph',ish,ishini,4)

      errlim=0.0001
      
      iret=0
      nptlpt=iabs(maproj)+iabs(matarg)
      if(nptl.le.nptlpt) goto 9999
      
      esoll=0.d0
      p1(1)=0.d0
      p1(2)=0.d0
      p1(3)=0.d0
      p1(4)=0.d0
      do i=nptlpt+1,nptl
        if((istptl(i).le.11
     $   .and.(iorptl(i).ge.1.and.istptl(iorptl(i)).eq.41))
     $   .or.istptl(i).eq.20.or.istptl(i).eq.21)then 
         do j=1,2
           p1(j)=p1(j)+dble(pptl(j,i))
         enddo
       endif
      enddo
      do i=1,nptlpt
         do j=1,5
           p0(j,i)=pptl(j,i)
         enddo
         do j=3,4
           p1(j)=p1(j)+dble(pptl(j,i))
         enddo
      enddo
      p1(5)=dsqrt((p1(4)+p1(3))*(p1(4)-p1(3))-p1(2)**2.d0-p1(1)**2.d0)
      esoll=p1(5)
      if(ish.ge.4) write (ifch,'(a,5g13.6)') 'boost-vector',p1

c     trafo
c     -----
      do i=1,nptl
        if((istptl(i).le.11
     $   .and.(iorptl(i).ge.1.and.istptl(iorptl(i)).eq.41))
     $   .or.istptl(i).eq.20.or.istptl(i).eq.21
     $   .or.(istptl(i).eq.0.and.i.le.nptlpt))then 
          call utlob4(1,p1(1),p1(2),p1(3),p1(4),p1(5)
     $         ,pptl(1,i),pptl(2,i),pptl(3,i),pptl(4,i))
        endif
      enddo

c$$$c     mark ghosts
c$$$c     -----------
c$$$      do  j=nptlpt+1,nptl 
c$$$        if(istptl(j).le.11
c$$$     $   .and.(iorptl(j).ge.1.and.istptl(iorptl(j)).eq.41))then 
c$$$          if(abs((pptl(4,j)+pptl(3,j))*(pptl(4,j)-pptl(3,j))
c$$$     $         -pptl(2,j)**2-pptl(1,j)**2-pptl(5,j)**2).gt.0.3
c$$$     $       .and.abs(1.-abs(pptl(3,j))/pptl(4,j)).gt.0.01)then
c$$$            ityptl(j)=50+ityptl(j)/10
c$$$            if(ish.ge.5)then 
c$$$              write(ifch,'(a,$)')'ghost:'
c$$$              call alist("&",j,j)
c$$$            endif
c$$$          endif 
c$$$        endif
c$$$      enddo
c$$$
c$$$      if(ish.ge.5)write(ifch,'(a)')'------------------'
c$$$      
c$$$c     treat ghosts
c$$$c     ------------
c$$$      ifirst=1
c$$$      scal=1.
c$$$      pfif=0.
c$$$      efif=0.
c$$$      ntry=0
c$$$ 132  nfif=0
c$$$      psum=0
c$$$      esum=0.
c$$$      ntry=ntry+1
c$$$      do  j=nptlpt+1,nptl 
c$$$          if(ityptl(j).ge.51.and.ityptl(j).le.54)then
c$$$            nfif=nfif+1
c$$$            if(ifirst.eq.1) pfif=pfif+pptl(3,j)
c$$$            if(ifirst.eq.1.and.pptl(4,j).gt.0.)efif=efif+pptl(4,j)
c$$$            if(irescl.ge.1) then 
c$$$              if(ifirst.eq.1)then
c$$$                y=(rangen()+rangen()+rangen()+rangen()-2.)/2.*yhaha
c$$$                y=sign(abs(y),pptl(3,j))
c$$$                pptl(3,j)
c$$$     $               =sqrt(pptl(5,j)**2+pptl(1,j)**2
c$$$     $               +pptl(2,j)**2)*sinh(y)
c$$$                pptl(4,j)
c$$$     $               =sqrt(pptl(5,j)**2+pptl(1,j)**2
c$$$     $               +pptl(2,j)**2)*cosh(y)
c$$$                efif=efif+pptl(4,j)
c$$$              else
c$$$c                do k=1,3
c$$$                do k=3,3
c$$$                  pptl(k,j)=pptl(k,j)*scal
c$$$                enddo
c$$$                pptl(4,j)=sqrt(pptl(1,j)**2+pptl(2,j)**2+pptl(3,j)**2
c$$$     *                 +pptl(5,j)**2)
c$$$              endif
c$$$            endif
c$$$            psum=psum+pptl(3,j)
c$$$            esum=esum+pptl(4,j)
c$$$            if(ish.ge.5)
c$$$     $           write (ifch,*) 'nrevt,psum,esum,pfif,efif,nfif,scal'
c$$$     $           ,nrevt,psum,esum,pfif,efif,nfif,scal
c$$$          endif 
c$$$      enddo
c$$$      if ( ish.ge.5 )  write (ifch,*) 'tot',efif,pfif,esum,psum
c$$$
c$$$
c$$$      if(nfif.gt.1)then
c$$$        do  j=nptlpt+1,nptl
c$$$          if ( ityptl(j).ge.51 .and. ityptl(j).le.54 )then
c$$$            pptl(3,j)=pptl(3,j)-(psum-pfif)/nfif
c$$$          endif
c$$$        enddo
c$$$        scal=efif/esum
c$$$        if ( ish.ge.5 )  write (ifch,*) 'scal',scal
c$$$        if ( abs(scal-1.) .gt. 0.01 .or. ifirst.eq.1 ) then
c$$$          ifirst = 0
c$$$          if(ntry.le.1000)then
c$$$            goto 132
c$$$          else
c$$$            iret=1
c$$$            if(ish.ge.2)write (ifch,*) 'Problem in utrsph : redo event'
c$$$            if(ish.ge.1)write (ifmt,*) 'Problem in utrsph : redo event'
c$$$c            call utstop('utrsph&')
c$$$            goto 9999
c$$$         endif
c$$$        endif
c$$$      endif
c$$$
c$$$      if(ish.ge.5)write(ifch,'(a)')'------------------'
c$$$
c$$$
c$$$c Check Ghost list and unmark for Spherio
c$$$
c$$$      do  j=nptlpt+1,nptl         
c$$$          if(ityptl(j).le.54.and.ityptl(j).ge.51)then
c$$$            if(ish.ge.5)then 
c$$$              write(ifch,'(a,$)')'ghost:'
c$$$              call alist("&",j,j)
c$$$            endif
c$$$c            if(ityptl(j).eq.54)ityptl(j)=40
c$$$c            if(ityptl(j).eq.51)ityptl(j)=10           
c$$$            ityptl(j)=mod(ityptl(j),10)*10
c$$$          endif
c$$$      enddo

      if(ish.ge.5)write(ifch,'(a)')'------------------'

c     rescale momenta in rest frame
c     -----------------------------

      scal=1.
      diff=0.
      do ipass=1,1000
        sum=0.
        sum3=0.
        ndif=0
        do  j=1,nptl 
        if((istptl(j).le.11
     $   .and.(iorptl(j).ge.1.and.istptl(iorptl(j)).eq.41))
     $   .or.istptl(j).eq.20.or.istptl(j).eq.21
     $   .or.(istptl(j).eq.0.and.j.le.nptlpt))then 
            if(j.gt.nptlpt)then
              ndif=ndif+1
              pptl(3,j)=scal*(pptl(3,j)-diff)
              pptl(4,j)=sqrt(pptl(1,j)**2+pptl(2,j)**2+pptl(3,j)**2
     *           +pptl(5,j)**2)
            endif
            sum=sum+pptl(4,j)
            sum3=sum3+pptl(3,j)
          endif
        enddo

        diff=sum3/real(ndif)
        scal=real(esoll)/sum
        if(ish.ge.6)write(ifch,*)'ipass,scal,diff,e,esoll,pz,ndif:'
     $       ,ipass,scal,diff,sum,esoll,sum3,ndif
        if(abs(scal-1.).le.errlim.and.abs(diff).lt.10.*errlim) goto300
      enddo
      if(ish.ge.1)then
        call utmsg('hresph')
        write(ifch,*)'*****  scal=',scal,diff
        call utmsgf
      endif

      
c     trafo
c     -----
 300  continue
c      do i=nptlpt+1,nptl
      do i=1,nptl
        if((istptl(i).le.11
     $   .and.(iorptl(i).ge.1.and.istptl(iorptl(i)).eq.41))
     $   .or.istptl(i).eq.20.or.istptl(i).eq.21
     $   .or.(istptl(i).eq.0.and.i.le.nptlpt))then 
          call utlob4(-1,p1(1),p1(2),p1(3),p1(4),p1(5)
     $         ,pptl(1,i),pptl(2,i),pptl(3,i),pptl(4,i))
        endif
        if(i.le.nptlpt)then
          do j=1,5
            pptl(j,i)=p0(j,i)
          enddo
        endif
      enddo
      
 9999 call utprix('utrsph',ish,ishini,4)

      end

c-----------------------------------------------------------------------
      double precision function dddlog(xxx)
c-----------------------------------------------------------------------
      double precision xxx
      dddlog=-1d50
      if(xxx.gt.0d0)dddlog=dlog(xxx)
      end
      
c-----------------------------------------------------------------------
      subroutine randfl(jc,iqa0,iflav,ic,isame)
c-----------------------------------------------------------------------
c     returns random flavour ic(2) (iqa0=1:quark,2:antiquark,11:diquark)
c-----------------------------------------------------------------------
      common/files/ifop,ifmt,ifch,ifcx,ifhi,ifdt,ifcp
      common/prnt1/iprmpt,ish,ishsub,irandm,irewch,iecho,modsho,idensi
      parameter (nflav=6)
      real probab(nflav),probsu(nflav+1)
      integer jc(nflav,2),jc0(nflav,2),ic(2)
      if(ish.ge.6)then
      write(ifch,*)('-',i=1,10)
     *,' entry sr randfl ',('-',i=1,30)
      write(ifch,*)'iqa0:',iqa0
      write(ifch,*)'jc:'
      write(ifch,*)jc
      endif
      iflav=0
      ic(1)=0
      ic(2)=0
      do 10 n=1,nflav
      do 10 i=1,2
10    jc0(n,i)=0
      iqa1=iqa0*10
9999  iqa1=iqa1/10
      if(iqa1.eq.0)goto9998
      iqa=mod(iqa1,10)
      su=0
      do 20 i=1,nflav
      probab(i)=jc(i,iqa)-jc0(i,iqa)
      if(isame.eq.1)probab(i)=probab(i)*(jc(i,3-iqa)-jc0(i,3-iqa))
20    su=su+probab(i)
      if(su.lt..5)then
      iflav=0
      ic(1)=0
      ic(2)=0
      goto9998
      endif
      probsu(1)=0.
      do 30 i=1,nflav
      probsu(i+1)=probsu(i)+probab(i)/su
      if(probsu(i+1)-probsu(i).lt.1e-5)probsu(i+1)=probsu(i)
30    continue
      r=rangen()*probsu(nflav+1)
      do 50 i=1,nflav
      if(probsu(i).le.r.and.r.lt.probsu(i+1))iflav=i
50    continue
      jc0(iflav,iqa)=jc0(iflav,iqa)+1
      if(isame.eq.1)jc0(iflav,3-iqa)=jc0(iflav,3-iqa)+1
      call idenco(jc0,ic,ireten)
      if(ireten.eq.1)call utstop('randfl: idenco ret code = 1&')
      if(ish.ge.6)then
      write(ifch,*)'probab:'
      write(ifch,*)probab
      write(ifch,*)'probsu:'
      write(ifch,*)probsu
      write(ifch,*)'ran#:',r,'   flav:',iflav
      endif
      goto9999
9998  continue
      if(ish.ge.6)write(ifch,*)('-',i=1,30)
     *,' exit sr randfl ',('-',i=1,10)
      return
      end
 
c-----------------------------------------------------------------------
      subroutine ranfgt(seed)
c-----------------------------------------------------------------------
      double precision    seed,     g900gt,   g900st,   dummy
      seed  =  g900gt()
      return
      entry ranfst(seed)
      dummy  =  g900st(seed)
      return
      end
 
c-----------------------------------------------------------------------
      subroutine ranhvy(x,eps)
c-----------------------------------------------------------------------
c     generates x for heavy particle fragmentation according to
c     the peterson form
c          d(x)=1/(x*(1-1/x-eps/(1-x))**2)
c              =d0(x)*d1(x)*d2(x)
c          d0(x)=(1-x)**2/((1-x)**2+eps)**2
c          d1(x)=x
c          d2(x)=(((1-x)**2+eps)/((1-x)**2+eps*x))**2
c     using x=1-y**pow
c     generates flat in x if eps>1.
c-----------------------------------------------------------------------
      data aln4/1.3863/
      if(eps.lt.1.) then
        pow=alog((3.+eps)/eps)/aln4
        ymx=(eps*(3.*pow-1.)/(pow+1.))**(.5/pow)
        zmx=1-ymx**pow
        d0mx=(1-zmx)**2/((1.-zmx)**2+eps)**2*pow*ymx**(pow-1.)
        d2mx=2./(2.-sqrt(eps))
      else
        pow=1.
        zmx=0.
        d0mx=(1.-zmx)**2/((1.-zmx)**2+eps)**2
        d2mx=1.+eps
      endif
c
c          generate z according to (1-z)**2/((1-z)**2+eps*z)**2
1     continue
      y=rangen()
      z=1.-y**pow
c
      d0z=(1.-z)**2/((1.-z)**2+eps)**2*pow*y**(pow-1.)
      if(d0z.lt.rangen()*d0mx) goto1
c
c          check remaining factors
      d1=z
      d2=(((1.-z)**2+eps)/((1.-z)**2+eps*z))**2
      if(d1*d2.lt.rangen()*d2mx) goto1
c
c          good x
      x=z
      return
      end
 
c-----------------------------------------------------------------------
      function ransig()
c-----------------------------------------------------------------------
c     returns randomly +1 or -1
c-----------------------------------------------------------------------
      ransig=1
      if(rangen().gt.0.5)ransig=-1
      return
      end
 
c-----------------------------------------------------------------------
      function ranxq(n,x,q,xmin)
c-----------------------------------------------------------------------
c     returns random number according to x(i) q(i) with x>=xmin
c-----------------------------------------------------------------------
      common/files/ifop,ifmt,ifch,ifcx,ifhi,ifdt,ifcp
      real x(n),q(n)
      imin=1
      if(xmin.eq.0.)goto3
      i1=1
      i2=n
1     i=i1+(i2-i1)/2
      if(x(i).lt.xmin)then
      i1=i
      elseif(x(i).gt.xmin)then
      i2=i
      else
      imin=i
      goto3
      endif
      if(i2-i1.gt.1)goto1
      imin=i2
3     continue
      if(q(imin).gt.q(n)*.9999)then
      ranxq=xmin
      goto4
      endif
      qran=q(imin)+rangen()*(q(n)-q(imin))
      ranxq=utinvt(n,x,q,qran)
4     continue
 
      if(ranxq.lt.xmin)then
      call utmsg('ranxq ')
      write(ifch,*)'*****  ranxq=',ranxq,' <       xmin=',xmin
      write(ifch,*)'q(imin) q q(n):',q(imin),qran,q(n)
      write(ifch,*)'x(imin) x x(n):',x(imin),ranxq,x(n)
      call utmsgf
      ranxq=xmin
      endif
 
      return
      end
 
c  ***** end r-routines
c  ***** beg s-routines      

c-----------------------------------------------------------------------
      function sbet(z,w)
c-----------------------------------------------------------------------
      sbet=utgam1(z)*utgam1(w)/utgam1(z+w)
      return
      end
 
c-----------------------------------------------------------------------
      function smass(a,y,z)
c-----------------------------------------------------------------------
c     returns droplet mass (in gev) (per droplet, not (!) per nucleon)
c     according to berger/jaffe mass formula, prc35(1987)213 eq.2.31,
c     see also c. dover, BNL-46322, intersections-meeting, tucson, 91.
c     a: massnr, y: hypercharge, z: charge,
c-----------------------------------------------------------------------
      common/cmass/thet,epsi,as,ac,dy,dz,ym,cz,zm,sigma,rzero
      ymin=ym*a
      zmin=cz/(dz/a+zm/a**(1./3.))
      smass=epsi*a+as*a**(2./3.)+(ac/a**(1./3.)+dz/a/2.)*(z-zmin)**2
     *+dy/a/2.*(y-ymin)**2
      return
      end
 
c-----------------------------------------------------------------------
      subroutine smassi(theta)
c-----------------------------------------------------------------------
c     initialization for smass.
c     calculates parameters for berger/jaffe mass formula
c     (prc35(1987)213 eq.2.31, see also c. dover, BNL-46322).
c     theta: parameter that determines all parameters in mass formula.
c-----------------------------------------------------------------------
      common/cmass/thet,epsi,as,ac,dy,dz,ym,cz,zm,sigma,rzero
      thet=theta
 
      astr=.150
      pi=3.14159
      alp=1./137.
 
      co=cos(theta)
      si=sin(theta)
      bet=(1+co**3)/2.
      rzero=si/astr/(  2./3./pi*(1+co**3)  )**(1./3.)
      cs=astr/si
      cz=-astr/si*(  (  .5*(1+co**3)  )**(1./3.)-1  )
      sigma=6./8./pi*(astr/si)**3*(co**2/6.-si**2*(1-si)/3.-
     *1./3./pi*(pi/2.-theta-sin(2*theta)+si**3*alog((1+co)/si)))
 
      epsi=astr*((.5*(1+co**3))**(1./3.)+2)/si
      as=4*pi*sigma*rzero**2
      ac=3./5.*alp/rzero
      dz=astr/si*bet**(1./3.)*co**2*
     *(co**4*(1+bet**(2./3.))+(1+bet)**2)/
     *(  (2*co**2+bet**(1./3.))*(co**4*(1+bet**(2./3.))+(1+bet)**2)-
     *(co**4+bet**(1./3.)*(1+bet))*((2*bet**(2./3.)-1)*co**2+1+bet)  )
      dy=astr/6.*(1+co**3)**3/si*
     *(  1+(1+co)/(4*(1+co**3))**(2./3.)  )/
     *(co**6+co+co*(.5*(1+co**3))**(4./3.))
      zm=6*alp/(5*rzero)
      ym=(1-co**3)/(1+co**3)
 
      return
      end
 
c-----------------------------------------------------------------------
      subroutine smassp
c-----------------------------------------------------------------------
c     prints smass.
c-----------------------------------------------------------------------
      common/files/ifop,ifmt,ifch,ifcx,ifhi,ifdt,ifcp
      common/cmass/thet,epsi,as,ac,dy,dz,ym,cz,zm,sigma,rzero
      real eng(14),ymi(14),zmi(14)
      pi=3.14159
      write(ifch,*)'parameters of mass formula:'
      write(ifch,*)'theta=',thet,'   epsi=',epsi
      write(ifch,*)'as=',as,'   ac=',ac
      write(ifch,*)'dy=',dy,'   dz=',dz
      write(ifch,*)'ym=',ym
      write(ifch,*)'cz dz zm=',cz,dz,zm
      write(ifch,*)'sigma**1/3=',sigma**(1./3.),'   rzero=',rzero
      write(ifch,*)'mass:'
      write(ifch,5000)(j,j=1,14)
5000  format(5x,'a:',14i5)
      do 4 j=1,14
      a=j
      ymi(j)=ym*a
4     zmi(j)=cz/(dz/a+zm/a**(1./3.))
      write(ifch,5002)(ymi(j),j=1,14)
5002  format(1x,'ymin: ',14f5.2)
      write(ifch,5003)(zmi(j),j=1,14)
5003  format(1x,'zmin: ',14f5.2)
      do 2 i=1,15
      ns=11-i
      do 3 j=1,14
      a=j
      y=a-ns
      z=0.
3     eng(j)=smass(a,y,z)/a
      write(ifch,5001)ns,(eng(j),j=1,14)
5001  format(1x,'s=',i2,2x,14f5.2)
2     continue
      write(ifch,*)'mass-mass(free):'
      write(ifch,5000)(j,j=1,14)
      do 5 i=1,15
      ns=11-i
      do 6 j=1,14
      a=j
      y=a-ns
      z=0.
      call smassu(a,y,z,ku,kd,ks,kc)
6     eng(j)=(smass(a,y,z)-utamnu(ku,kd,ks,kc,0,0,3))/a
      write(ifch,5001)ns,(eng(j),j=1,14)
5     continue
 
      stop
      end
 
c-----------------------------------------------------------------------
      subroutine smasst(kux,kdx,ksx,kcx,a,y,z)
c-----------------------------------------------------------------------
c     input: kux,kdx,ksx,kcx = net quark numbers (for u,d,s,c quarks).
c     output: massnr a, hypercharge y and charge z.
c-----------------------------------------------------------------------
      sg=1
      if(kux+kdx+ksx+kcx.lt.0.)sg=-1
      ku=sg*kux
      kd=sg*kdx
      ks=sg*ksx
      kc=sg*kcx
      k=ku+kd+ks+kc
      if(mod(k,3).ne.0)stop'noninteger baryon number'
      a=k/3
      y=a-ks
      nz=2*ku-kd-ks+2*kc
      if(mod(nz,3).ne.0)stop'noninteger charge'
      z=nz/3
      return
      end
 
c-----------------------------------------------------------------------
      subroutine smassu(ax,yx,zx,ku,kd,ks,kc)
c-----------------------------------------------------------------------
c     input: massnr ax, hypercharge yx and charge zx.
c     output: ku,kd,ks,kc = net quark numbers (for u,d,s,c quarks).
c-----------------------------------------------------------------------
      sg=1
      if(ax.lt.0.)sg=-1
      a=sg*ax
      y=sg*yx
      z=sg*zx
      ku=nint(a+z)
      kd=nint(a-z+y)
      ks=nint(a-y)
      kc=0
      return
      end
 
c-----------------------------------------------------------------------
      function spoc(a,b,c,d,x)
c-----------------------------------------------------------------------
c     power fctn with cutoff
c-----------------------------------------------------------------------
      spoc=0
      if(a.eq.0..and.b.eq.0.)return
      spoc =a+b*x**c
      spoc0=a+b*d**c
      spoc=amin1(spoc,spoc0)
      spoc=amax1(0.,spoc)
      return
      end

c-----------------------------------------------------------------------
      function utacos(x)
c-----------------------------------------------------------------------
c     returns acos(x) for -1 <= x <= 1 , acos(+-1) else
c-----------------------------------------------------------------------
      common/files/ifop,ifmt,ifch,ifcx,ifhi,ifdt,ifcp
      common/prnt1/iprmpt,ish,ishsub,irandm,irewch,iecho,modsho,idensi
      argum=x
      if(x.lt.-1.)then
      if(ish.ge.1)then
      call utmsg('utacos')
      write(ifch,*)'*****  argum = ',argum,' set -1'
      call utmsgf
      endif
      argum=-1.
      elseif(x.gt.1.)then
      if(ish.ge.1)then
      call utmsg('utacos')
      write(ifch,*)'*****  argum = ',argum,' set 1'
      call utmsgf
      endif
      argum=1.
      endif
      utacos=acos(argum)
      return
      end
 
c----------------------------------------------------------------------
      function utamnu(keux,kedx,kesx,kecx,kebx,ketx,modus)
c----------------------------------------------------------------------
c     returns min mass of droplet with given u,d,s,c content
c     keux: net u quark number
c     kedx: net d quark number
c     kesx: net s quark number
c     kecx: net c quark number
c     kebx: net b quark number
c     ketx: net t quark number
c     modus: 4=two lowest multiplets; 5=lowest multiplet
c----------------------------------------------------------------------
      common/files/ifop,ifmt,ifch,ifcx,ifhi,ifdt,ifcp
      common/hadr1/pnll,ptq,exmass,cutmss,rstras,wproj,wtarg
      common/csjcga/amnull,asuha(7)
      common/drop4/asuhax(7),asuhay(7)
      
      if(modus.lt.4.or.modus.gt.5)stop'UTAMNU: not supported'
c 1    format(' flavours:',6i5 )
c 100  format(' flavours+mass:',6i5,f8.2 )
c      write(ifch,1)keux,kedx,kesx,kecx,kebx,ketx
c      write(ifmt,*)'wrong mass in gethad ',damss

      amnull=0.
 
      do i=1,7
      if(modus.eq.4)asuha(i)=asuhax(i)    !two lowest multiplets
      if(modus.eq.5)asuha(i)=asuhay(i)    !lowest multiplet
      enddo

      ke=iabs(keux+kedx+kesx+kecx+kebx+ketx)
 
      if(keux+kedx+kesx+kecx+kebx+ketx.ge.0)then
      keu=keux
      ked=kedx
      kes=kesx
      kec=kecx
      keb=kebx
      ket=ketx
      else
      keu=-keux
      ked=-kedx
      kes=-kesx
      kec=-kecx
      keb=-kebx
      ket=-ketx
      endif

c      write(ifch,*)keu,ked,kes,kec,keb,ket      

c   removing top mesons  to remove t quarks or antiquarks  
      if(ket.ne.0)then
12    continue
      ii=sign(1,ket)
      ket=ket-ii
      if(ii*keu.le.ii*ked)then
      keu=keu+ii
      else
      ked=ked+ii
      endif
      amnull=amnull+200.    ! ???????
      if(ket.ne.0)goto12
      endif

c   removing bottom mesons  to remove b quarks or antiquarks  
      if(keb.ne.0)then
11    continue
      ii=sign(1,keb)
      keb=keb-ii
      if(ii*keu.le.ii*ked)then
      keu=keu+ii
      else
      ked=ked+ii
      endif
      amnull=amnull+5.28   ! (B-meson)
      if(keb.ne.0)goto11
      endif

c   removing charm mesons  to remove c quarks or antiquarks
      if(kec.ne.0)then
10    continue
      ii=sign(1,kec)
      kec=kec-ii
      if(keu*ii.le.ked*ii)then
      keu=keu+ii
      else
      ked=ked+ii
      endif
      amnull=amnull+1.87  ! (D-meson)
      if(kec.ne.0)goto10
      endif
      
c      write(ifch,100)keu,ked,kes,kec,keb,ket,amnull      

c   removing mesons to remove s antiquarks   
5     continue
      if(kes.lt.0)then
      amnull=amnull+asuha(6)
      if(keu.ge.ked)then
      keu=keu-1
      else
      ked=ked-1
      endif
      kes=kes+1
      goto5
      endif
 
c   removing mesons to remove d antiquarks   
6     continue
      if(ked.lt.0)then
      if(keu.ge.kes)then
      amnull=amnull+asuha(5)
      keu=keu-1
      else
      amnull=amnull+asuha(6)
      kes=kes-1
      endif
      ked=ked+1
      goto6
      endif
 
c   removing mesons to remove u antiquarks   
7     continue
      if(keu.lt.0)then
      if(ked.ge.kes)then
      amnull=amnull+asuha(5)
      ked=ked-1
      else
      amnull=amnull+asuha(6)
      kes=kes-1
      endif
      keu=keu+1
      goto7
      endif
      
c      write(ifch,100)keu,ked,kes,kec,keb,ket,amnull      
 
      if(keu+ked+kes+kec+keb+ket.ne.ke)
     *call utstop('utamnu: sum_kei /= ke&')
      keq=keu+ked
      keqx=keq
      amnux=0
 
c   removing strange baryons   
      i=4
2     i=i-1
3     continue
      if((4-i)*kes.gt.(i-1)*keq)then
      amnux=amnux+asuha(1+i)
      kes=kes-i
      keq=keq-3+i
      if(kes.lt.0)call utstop('utamnu: negative kes&')
      if(keq.lt.0)call utstop('utamnu: negative keq&')
      goto3
      endif
      if(i.gt.1)goto2
      if(keqx.gt.keq)then
      do 8 k=1,keqx-keq
      if(keu.ge.ked)then
      keu=keu-1
      else
      ked=ked-1
      endif
8     continue
      endif
      
      if(keu+ked.ne.keq)call utstop('utamnu: keu+ked /= keq&')
c      write(ifch,100)keu,ked,kes,kec,keb,ket,amnull+amnux      
 
c   removing nonstrange baryons   
9     continue
      if(keu.gt.2*ked)then
      amnux=amnux+asuha(7)
      keu=keu-3
      if(keu.lt.0)call utstop('utamnu: negative keu&')
      goto9
      endif
      if(ked.gt.2*keu)then
      amnux=amnux+asuha(7)
      ked=ked-3
      if(ked.lt.0)call utstop('utamnu: negative ked&')
      goto9
      endif
      keq=keu+ked
      
c      write(ifch,100)keu,ked,kes,kec,keb,ket,amnull+amnux     
 
      if(mod(keq,3).ne.0)call utstop('utamnu: mod(keq,3) /= 0&')
      amnux=amnux+asuha(1)*keq/3
      
c      write(ifch,100)keu,ked,kes,kec,keb,ket,amnull+amnux      
 
      amnull=amnull+amnux
 
      if(amnull.eq.0)amnull=asuha(5)
 
      utamnu=amnull
      return
      end
 
c-----------------------------------------------------------------------
      function utamnx(jcp,jcm)
c-----------------------------------------------------------------------
c returns minimum mass for the decay of jcp---jcm (by calling utamnu).
c-----------------------------------------------------------------------
      parameter (nflav=6)
      integer jcp(nflav,2),jcm(nflav,2)

      do i=1,nflav
      do j=1,2
      if(jcp(i,j).ne.0)goto1
      enddo
      enddo
      keu=jcm(1,1)-jcm(1,2)
      ked=jcm(2,1)-jcm(2,2)
      kes=jcm(3,1)-jcm(3,2)
      kec=jcm(4,1)-jcm(4,2)
      keb=jcm(5,1)-jcm(5,2)
      ket=jcm(6,1)-jcm(6,2)
      utamnx=utamnu(keu,ked,kes,kec,keb,ket,5)
      return
1     continue

      do i=1,nflav
      do j=1,2
      if(jcm(i,j).ne.0)goto2
      enddo
      enddo
      keu=jcp(1,1)-jcp(1,2)
      ked=jcp(2,1)-jcp(2,2)
      kes=jcp(3,1)-jcp(3,2)
      kec=jcp(4,1)-jcp(4,2)
      keb=jcp(5,1)-jcp(5,2)
      ket=jcp(6,1)-jcp(6,2)
      utamnx=utamnu(keu,ked,kes,kec,keb,ket,5)
      return
2     continue

      keu=jcp(1,1)-jcp(1,2)
      ked=jcp(2,1)-jcp(2,2)
      kes=jcp(3,1)-jcp(3,2)
      kec=jcp(4,1)-jcp(4,2)
      keb=jcp(5,1)-jcp(5,2)
      ket=jcp(6,1)-jcp(6,2)
      ke=keu+ked+kes+kec+keb+ket
      if(mod(ke+1,3).eq.0)then
        keu=keu+1
        amms1=utamnu(keu,ked,kes,kec,keb,ket,5)
        keu=keu-1
        ked=ked+1
        amms2=utamnu(keu,ked,kes,kec,keb,ket,5)
      elseif(mod(ke-1,3).eq.0)then
        keu=keu-1
        amms1=utamnu(keu,ked,kes,kec,keb,ket,5)
        keu=keu+1
        ked=ked-1
        amms2=utamnu(keu,ked,kes,kec,keb,ket,5)
      else
        call utstop('utamnx: no singlet possible (1)&')
      endif
      keu=jcm(1,1)-jcm(1,2)
      ked=jcm(2,1)-jcm(2,2)
      kes=jcm(3,1)-jcm(3,2)
      kec=jcm(4,1)-jcm(4,2)
      keb=jcm(5,1)-jcm(5,2)
      ket=jcm(6,1)-jcm(6,2)
      ke=keu+ked+kes+kec+keb+ket
      if(mod(ke+1,3).eq.0)then
        keu=keu+1
        amms3=utamnu(keu,ked,kes,kec,keb,ket,5)
        keu=keu-1
        ked=ked+1
        amms4=utamnu(keu,ked,kes,kec,keb,ket,5)
      elseif(mod(ke-1,3).eq.0)then
        keu=keu-1
        amms3=utamnu(keu,ked,kes,kec,keb,ket,5)
        keu=keu+1
        ked=ked-1
        amms4=utamnu(keu,ked,kes,kec,keb,ket,5)
      else
        call utstop('utamnx: no singlet possible (2)&')
      endif
      utamnx=min(amms1+amms3,amms2+amms4)
c       print *,amms1,amms3,amms2,amms4,jcp,jcm
      return
      end


 
c-----------------------------------------------------------------------
      function utamny(jcp,jcm)
c-----------------------------------------------------------------------
c returns minimum mass of jcp+jcm (by calling utamnu).
c-----------------------------------------------------------------------
      parameter (nflav=6)
      integer jcp(nflav,2),jcm(nflav,2),jc(nflav,2)
      do 7 nf=1,nflav
      jc(nf,1)=jcp(nf,1)+jcm(nf,1)
7     jc(nf,2)=jcp(nf,2)+jcm(nf,2)
      keu=jc(1,1)-jc(1,2)
      ked=jc(2,1)-jc(2,2)
      kes=jc(3,1)-jc(3,2)
      kec=jc(4,1)-jc(4,2)
      keb=jc(5,1)-jc(5,2)
      ket=jc(6,1)-jc(6,2)
      utamny=utamnu(keu,ked,kes,kec,keb,ket,5)
      return
      end

c-----------------------------------------------------------------------
      function utamnz(jc,modus)
c-----------------------------------------------------------------------
c returns minimum mass of jc (by calling utamnu).
c-----------------------------------------------------------------------
      parameter (nflav=6)
      integer jc(nflav,2)
      keu=jc(1,1)-jc(1,2)
      ked=jc(2,1)-jc(2,2)
      kes=jc(3,1)-jc(3,2)
      kec=jc(4,1)-jc(4,2)
      keb=jc(5,1)-jc(5,2)
      ket=jc(6,1)-jc(6,2)
      utamnz=utamnu(keu,ked,kes,kec,keb,ket,modus)
      return
      end
 
c-----------------------------------------------------------------------
      subroutine utar(i1,i2,i3,x0,x1,x2,x3,xx)
c-----------------------------------------------------------------------
c     returns the array xx with xx(1)=x0 <= xx(i) <= xx(i3)=x3
c-----------------------------------------------------------------------
      real xx(i3)
      do 1 i=1,i1-1
  1   xx(i)=x0+(i-1.)/(i1-1.)*(x1-x0)
      do 2 i=i1,i2-1
  2   xx(i)=x1+(i-i1*1.)/(i2-i1*1.)*(x2-x1)
      do 3 i=i2,i3
  3   xx(i)=x2+(i-i2*1.)/(i3-i2*1.)*(x3-x2)
      return
      end

c---------------------------------------------------------------------
      subroutine utaxis(i,j,a1,a2,a3)
c-----------------------------------------------------------------------
c     calculates the axis defined by the ptls i,j in the i,j cm system
c---------------------------------------------------------------------
      include 'nexus.inc'
      double precision pi1,pi2,pi3,pi4,pj1,pj2,pj3,pj4,p1,p2,p3,p4,p5
     *,err,a 
      a1=0
      a2=0
      a3=1
      pi1=dble(pptl(1,i))
      pi2=dble(pptl(2,i)) 
      pi3=dble(pptl(3,i)) 
      pi4=dble(pptl(4,i)) 
      pj1=dble(pptl(1,j)) 
      pj2=dble(pptl(2,j)) 
      pj3=dble(pptl(3,j)) 
      pj4=dble(pptl(4,j)) 
      p1=pi1+pj1
      p2=pi2+pj2
      p3=pi3+pj3
      p4=pi4+pj4
      p5=dsqrt(p4**2-p3**2-p2**2-p1**2)
      call utlob2(1,p1,p2,p3,p4,p5,pi1,pi2,pi3,pi4,50)
      call utlob2(1,p1,p2,p3,p4,p5,pj1,pj2,pj3,pj4,51)
           err=(pi1+pj1)**2+(pi2+pj2)**2+(pi3+pj3)**2 
           if(err.gt.1d-3)then
      call utmsg('utaxis')
      write(ifch,*)'*****  err=',err
      write(ifch,*)'pi:',pi1,pi2,pi3,pi4
      write(ifch,*)'pj:',pj1,pj2,pj3,pj4
      call utmsgf
           endif
      a=dsqrt( (pj1-pi1)**2 + (pj2-pi2)**2 + (pj3-pi3)**2 )
      if(a.eq.0.d0)return
      a1=sngl((pi1-pj1)/a)
      a2=sngl((pi2-pj2)/a)
      a3=sngl((pi3-pj3)/a)
      return
      end
 
c-----------------------------------------------------------------------
      subroutine utchm(arp,arm,ii)
c-----------------------------------------------------------------------
c     checks whether arp**2=0 and arm**2=0.
c-----------------------------------------------------------------------
      common/files/ifop,ifmt,ifch,ifcx,ifhi,ifdt,ifcp
      double precision arp(4),arm(4),difp,difm
      difp=arp(4)**2-arp(1)**2-arp(2)**2-arp(3)**2
      difm=arm(4)**2-arm(1)**2-arm(2)**2-arm(3)**2
      if(dabs(difp).gt.1e-3*arp(4)**2
     *.or.dabs(difm).gt.1e-3*arm(4)**2)then
      call utmsg('utchm ')
      write(ifch,*)'*****  mass non zero  -  ',ii
      write(ifch,*)'jet-mass**2`s:    ',difp,difm
      write(ifch,*)'energy**2`s:      ',arp(4)**2,arm(4)**2
      write(ifch,*)(sngl(arp(i)),i=1,4)
      write(ifch,*)(sngl(arm(i)),i=1,4)
      call utmsgf
      endif
      return
      end
 
c-----------------------------------------------------------------------
      subroutine utclea(nptl0)
c-----------------------------------------------------------------------
c     overwrites istptl=2 particles in /cptl/, reduces so nptl.
c-----------------------------------------------------------------------
      include 'nexus.inc'
      integer newptl(mxptl),oldptl(mxptl),ii(mxptl)
 
      ish0=ish
      if(ishsub/100.eq.18)ish=mod(ishsub,100)
 
      if(ish.ge.3)then
      write(ifch,*)('-',l=1,68)
      write(ifch,*)'sr utclea. initial.'
      write(ifch,*)('-',l=1,68)
      do 34 n=1,nptl
      write(ifch,116)iorptl(n),jorptl(n),n,ifrptl(1,n),ifrptl(2,n)
     *,idptl(n),sqrt(pptl(1,n)**2+pptl(2,n)**2),pptl(3,n),pptl(5,n)
     *,istptl(n)
34    continue
116   format(1x,i4,i4,4x,i4,4x,i4,i4,i12,3x,3(e8.2,1x),i2,i2)
      endif

      ish=ish0
      if(iyptlx.gt.0)call utcley(2)
      ish0=ish
      if(ishsub/100.eq.18)ish=mod(ishsub,100)

      i=0
1     i=i+1
      if(i.gt.nptl)goto1000
      if(istptl(i).eq.2)goto2
      newptl(i)=i
      oldptl(i)=i
      goto1
 
2     i=i-1
      j=i
3     i=i+1
4     j=j+1
      if(j.gt.nptl)goto5
      newptl(j)=0
      if(istptl(j).eq.2)goto4
      newptl(j)=i
      oldptl(i)=j
      call utrepl(i,j)
      goto3
 
5     nptl=i-1
      if(nptl.eq.0)nptl0=0  
      if(nptl.eq.0)goto1000

20    n0=newptl(nptl0)
      if(n0.gt.0)then
      nptl0=n0
      else
      nptl0=nptl0-1
      if(nptl0.gt.0)goto20
      endif

      do 11 k=1,nptl
      io=iorptl(k)
      if(io.le.0)ii(k)=io
      if(io.gt.0)ii(k)=newptl(io)
11    continue
      do 12 k=1,nptl
12    iorptl(k)=ii(k)
 
      do 13 k=1,nptl
      jo=jorptl(k)
      if(jo.le.0)ii(k)=jo
      if(jo.gt.0)ii(k)=newptl(jo)
13    continue
      do 14 k=1,nptl
14    jorptl(k)=ii(k)
 
      do 15 k=1,nptl
      if1=ifrptl(1,k)
      if(if1.le.0)ii(k)=if1
      if(if1.gt.0)ii(k)=newptl(if1)
15    continue
      do 16 k=1,nptl
16    ifrptl(1,k)=ii(k)
 
      do 17 k=1,nptl
      if2=ifrptl(2,k)
      if(if2.le.0)ii(k)=if2
      if(if2.gt.0)ii(k)=newptl(if2)
17    continue
      do 18 k=1,nptl
18    ifrptl(2,k)=ii(k)
 
      do 19 k=1,nptl
      if(ifrptl(1,k).eq.0.and.ifrptl(2,k).gt.0)ifrptl(1,k)=ifrptl(2,k)
      if(ifrptl(2,k).eq.0.and.ifrptl(1,k).gt.0)ifrptl(2,k)=ifrptl(1,k)
19    continue
 
1000  continue
 
      if(ish.ge.3)then
      write(ifch,*)'before exiting subr utclea:'
      do 35 n=1,nptl
      write(ifch,116)iorptl(n),jorptl(n),n,ifrptl(1,n),ifrptl(2,n)
     *,idptl(n),sqrt(pptl(1,n)**2+pptl(2,n)**2),pptl(3,n),pptl(5,n)
     *,istptl(n)
35    continue
      endif
 
      ish=ish0
      return
      end

c-----------------------------------------------------------------------
      subroutine utcley(ist)
c-----------------------------------------------------------------------
c     overwrites istptl=ist particles in /c4ptl/,/c5ptl/;reduces so iyptlx.
c-----------------------------------------------------------------------
      include 'nexus.inc'
      integer irem(myptl)
      double precision tpro,zpro,ttar,ztar,ttaus,detap,detat
      common/cttaus/tpro,zpro,ttar,ztar,ttaus,detap,detat 

      ish0=ish
      if(ishsub/100.eq.22)ish=mod(ishsub,100)
 
      if(ish.ge.3)write(ifch,*)'long droplets at taus=',sngl(ttaus)
      if(ish.ge.3)write(ifch,*)'before cleanup:'
      do 34 i=1,iyptlx
      n=iyiptl(i)
      zfi=xorptl(3,n)+(tivptl(2,n)-xorptl(4,n))*pptl(3,n)/pptl(4,n)
      call jtaus(zfi,tzfi,szfi)
      delt=tzfi-tivptl(2,n)
      irem(i)=0
      if(ist.eq.1.and.istptl(n).eq.1
     *.and.(ifrptl(1,n).eq.0.or.delt.gt.0.1))irem(i)=1
      if(ist.eq.2.and.istptl(n).eq.2)irem(i)=1
      if(ish.ge.3)
     *write(ifch,116)n,i
     *,(weiptl(i,nn),nn=nzeta/2-3,nzeta/2+4),istptl(n),ifrptl(1,n),delt
     *,irem(i)
34    continue
116   format(i6,i5,8f6.1,i3,i6,1x,e8.2,i3)

      iyptlw=iyptlx

      i=0
1     i=i+1
      if(i.gt.iyptlx)goto1000
      ni=iyiptl(i)
      if(irem(i).eq.1)goto2
      goto1
 
2     i=i-1
      j=i
3     i=i+1
      ni=iyiptl(i)
4     j=j+1
      if(j.gt.iyptlx)goto5
      if(irem(j).eq.1)goto4
      nj=iyiptl(j)
      iyptl(ni)=j
      iyptl(nj)=i
      iyiptl(i)=nj
      iyiptl(j)=ni
      do nn=1,nzeta
      weiptl(i,nn)=weiptl(j,nn)
      weiptl(j,nn)=0
      do nf=1,nflav
      iflptl(i,nn,nf)=iflptl(j,nn,nf)      
      iflptl(j,nn,nf)=0
      enddo
      enddo
      goto3
 
5     iyptlx=i-1

1000  continue

      if(iyptlx+1.le.iyptlw)then
      do i=iyptlx+1,iyptlw
      ni=iyiptl(i)
      iyptl(ni)=0
      iyiptl(i)=0
      enddo
      endif

      if(ish.ge.3)write(ifch,*)'after cleanup:'
      if(ish.ge.3)then
      do 35 i=1,iyptlx
      n=iyiptl(i)
      write(ifch,117)n,i
     *,(weiptl(i,nn),nn=nzeta/2-3,nzeta/2+4),istptl(n)
     *,irem(i)
117   format(i6,i5,8f6.1,i3,i3)
35    continue
      endif

      ish=ish0

      return
      end

c---------------------------------------------------------------------
      subroutine utfit(x,y,ndata,sig,mwt,a,b,siga,sigb,chi2,q)
c---------------------------------------------------------------------
c linear fit to data 
c input:
c    ndata: nr of data points
c    x(),y(),sig(): data
c    mwt: unweighted (0) or weighted (else) data points
c output:
c    a,b: parameters of linear fit a+b*x
c---------------------------------------------------------------------   
      INTEGER mwt,ndata
      REAL a,b,chi2,q,siga,sigb,sig(ndata),x(ndata),y(ndata)
CU    USES utgmq 
      INTEGER i
      REAL sigdat,ss,st2,sx,sxoss,sy,t,wt,utgmq
      sx=0.
      sy=0.
      st2=0.
      b=0.
      if(mwt.ne.0) then
        ss=0.
        do 11 i=1,ndata
          wt=1./(sig(i)**2)
          ss=ss+wt
          sx=sx+x(i)*wt
          sy=sy+y(i)*wt
11      continue
      else
        do 12 i=1,ndata
          sx=sx+x(i)
          sy=sy+y(i)
12      continue
        ss=float(ndata)
      endif
      sxoss=sx/ss
      if(mwt.ne.0) then
        do 13 i=1,ndata
          t=(x(i)-sxoss)/sig(i)
          st2=st2+t*t
          b=b+t*y(i)/sig(i)
13      continue
      else
        do 14 i=1,ndata
          t=x(i)-sxoss
          st2=st2+t*t
          b=b+t*y(i)
14      continue
      endif
      b=b/st2
      a=(sy-sx*b)/ss
      siga=sqrt((1.+sx*sx/(ss*st2))/ss)
      sigb=sqrt(1./st2)
      chi2=0.
      if(mwt.eq.0) then
        do 15 i=1,ndata
          chi2=chi2+(y(i)-a-b*x(i))**2
15      continue
        q=1.
        sigdat=sqrt(chi2/(ndata-2))
        siga=siga*sigdat
        sigb=sigb*sigdat
      else
        do 16 i=1,ndata
          chi2=chi2+((y(i)-a-b*x(i))/sig(i))**2
16      continue
        q=utgmq(0.5*(ndata-2),0.5*chi2)
      endif
      return
      END
 
c$$$c-----------------------------------------------------------------------
c$$$      function utgam1(x)
c$$$c-----------------------------------------------------------------------
c$$$c     gamma fctn
c$$$c-----------------------------------------------------------------------
c$$$      common/files/ifop,ifmt,ifch,ifcx,ifhi,ifdt,ifcp 
c$$$      dimension c(13)
c$$$      data c
c$$$     1/ 0.00053 96989 58808, 0.00261 93072 82746, 0.02044 96308 23590,
c$$$     2  0.07309 48364 14370, 0.27964 36915 78538, 0.55338 76923 85769,
c$$$     3  0.99999 99999 99998,-0.00083 27247 08684, 0.00469 86580 79622,
c$$$     4  0.02252 38347 47260,-0.17044 79328 74746,-0.05681 03350 86194,
c$$$     5  1.13060 33572 86556/
c$$$      utgam1=0
c$$$      z=x
c$$$      if(x .gt. 0.0) goto1
c$$$      if(x .eq. aint(x)) goto5
c$$$      z=1.0-z
c$$$    1 f=1.0/z
c$$$      if(z .le. 1.0) goto4
c$$$      f=1.0
c$$$    2 continue
c$$$      if(z .lt. 2.0) goto3
c$$$      z=z-1.0
c$$$      f=f*z
c$$$      goto2
c$$$    3 z=z-1.0
c$$$    4 utgam1=
c$$$     1 f*((((((c(1)*z+c(2))*z+c(3))*z+c(4))*z+c(5))*z+c(6))*z+c(7))/
c$$$     2   ((((((c(8)*z+c(9))*z+c(10))*z+c(11))*z+c(12))*z+c(13))*z+1.0)
c$$$      if(x .gt. 0.0) return
c$$$      utgam1=3.141592653589793/(sin(3.141592653589793*x)*utgam1)
c$$$      return
c$$$    5 write(ifch,10)x
c$$$   10 format(1x,'argument of gamma fctn = ',e20.5)
c$$$      call utstop('utgam1 : negative integer argument&')
c$$$      end
c$$$
c$$$c-----------------------------------------------------------------------
c$$$      double precision function utgam2(x)
c$$$c-----------------------------------------------------------------------
c$$$c  gamma fctn
c$$$c  double precision
c$$$c-----------------------------------------------------------------------
c$$$      common/files/ifop,ifmt,ifch,ifcx,ifhi,ifdt,ifcp 
c$$$      double precision c(13),x,z,f
c$$$      data c
c$$$     1/ 0.00053 96989 58808, 0.00261 93072 82746, 0.02044 96308 23590,
c$$$     2  0.07309 48364 14370, 0.27964 36915 78538, 0.55338 76923 85769,
c$$$     3  0.99999 99999 99998,-0.00083 27247 08684, 0.00469 86580 79622,
c$$$     4  0.02252 38347 47260,-0.17044 79328 74746,-0.05681 03350 86194,
c$$$     5  1.13060 33572 86556/
c$$$      utgam2=0
c$$$      z=x
c$$$      if(x .gt. 0.0d0) goto1
c$$$      if(x .eq. int(x)) goto5
c$$$      z=1.0d0-z
c$$$    1 f=1.0d0/z
c$$$      if(z .le. 1.0d0) goto4
c$$$      f=1.0d0
c$$$    2 continue
c$$$      if(z .lt. 2.0d0) goto3
c$$$      z=z-1.0d0
c$$$      f=f*z
c$$$      goto2
c$$$    3 z=z-1.0d0
c$$$    4 utgam2=
c$$$     1 f*((((((c(1)*z+c(2))*z+c(3))*z+c(4))*z+c(5))*z+c(6))*z+c(7))/
c$$$     2 ((((((c(8)*z+c(9))*z+c(10))*z+c(11))*z+c(12))*z+c(13))*z+1.0d0)       
c$$$      if(x .gt. 0.0d0) return
c$$$      utgam2=3.141592653589793d0/(sin(3.141592653589793d0*x)*utgam2)
c$$$      return
c$$$    5 write(ifch,10)sngl(x)
c$$$   10 format(1x,'argument of gamma fctn = ',e20.5)
c$$$      call utstop('utgam2 : negative integer argument&')
c$$$      end

c-----------------------------------------------------------------------
      double precision function utgam1(x)
c-----------------------------------------------------------------------
c  gamma fctn tabulated
c  single precision
c-----------------------------------------------------------------------
      double precision utgamtab,utgam,al,dl
      common/gamtab/utgamtab(10000)

      if(x.gt.0.01.and.x.lt.99.99)then
        al=100.d0*dble(x)
        k1=int(al)
        k2=k1+1
        dl =al-dble(k1)
        utgam1=real(utgamtab(k2)*dl+utgamtab(k1)*(1.d0-dl))
      elseif(x.eq.0.)then
        utgam1=0.
      else
        utgam1=real(utgam(dble(x)))
      endif

      end

c-----------------------------------------------------------------------
      double precision function utgam2(x)
c-----------------------------------------------------------------------
c  gamma fctn tabulated
c  double precision
c-----------------------------------------------------------------------
      double precision utgamtab,x,al,dl,utgam
      common/gamtab/utgamtab(10000)

      if(x.gt.0.01d0.and.x.le.99.99d0)then
        al=100.d0*x
        k1=int(al)
        k2=k1+1
        dl =al-dble(k1)
        utgam2=utgamtab(k2)*dl+utgamtab(k1)*(1.d0-dl)
      elseif(x.eq.0.d0)then
        utgam2=0.d0
      else
        utgam2=utgam(x)
      endif

      end

c-----------------------------------------------------------------------
      double precision function utgam(x)
c-----------------------------------------------------------------------
c  gamma fctn
c  double precision
c-----------------------------------------------------------------------
      common/files/ifop,ifmt,ifch,ifcx,ifhi,ifdt,ifcp 
      double precision c(13),x,z,f
      data c
     1/ 0.00053 96989 58808, 0.00261 93072 82746, 0.02044 96308 23590,
     2  0.07309 48364 14370, 0.27964 36915 78538, 0.55338 76923 85769,
     3  0.99999 99999 99998,-0.00083 27247 08684, 0.00469 86580 79622,
     4  0.02252 38347 47260,-0.17044 79328 74746,-0.05681 03350 86194,
     5  1.13060 33572 86556/
      utgam=0
      z=x
      if(x .gt. 0.0d0) goto1
      if(x .eq. int(x)) goto5
      z=1.0d0-z
    1 f=1.0d0/z
      if(z .le. 1.0d0) goto4
      f=1.0d0
    2 continue
      if(z .lt. 2.0d0) goto3
      z=z-1.0d0
      f=f*z
      goto2
    3 z=z-1.0d0
    4 utgam=
     1 f*((((((c(1)*z+c(2))*z+c(3))*z+c(4))*z+c(5))*z+c(6))*z+c(7))/
     2 ((((((c(8)*z+c(9))*z+c(10))*z+c(11))*z+c(12))*z+c(13))*z+1.0d0)
      if(x .gt. 0.0d0) return
      utgam=3.141592653589793d0/(sin(3.141592653589793d0*x)*utgam)
      return
    5 write(ifch,10)sngl(x)
   10 format(1x,'argument of gamma fctn = ',e20.5)
      call utstop('utgam : negative integer argument&')
      end

c---------------------------------------------------------------------
      subroutine utgcf(gammcf,a,x,gln)
c---------------------------------------------------------------------
      INTEGER ITMAX
      REAL a,gammcf,gln,x,EPS,FPMIN
      PARAMETER (ITMAX=100,EPS=3.e-7,FPMIN=1.e-30)
CU    USES utgmln
      INTEGER i
      REAL an,b,c,d,del,h,utgmln
      gln=utgmln(a)
      b=x+1.-a
      c=1./FPMIN
      d=1./b
      h=d
      do 11 i=1,ITMAX
        an=-i*(i-a)
        b=b+2.
        d=an*d+b
        if(abs(d).lt.FPMIN)d=FPMIN
        c=b+an/c
        if(abs(c).lt.FPMIN)c=FPMIN
        d=1./d
        del=d*c
        h=h*del
        if(abs(del-1.).lt.EPS)goto 1
11    continue
      pause 'a too large, ITMAX too small in utgcf'
1     gammcf=exp(-x+a*log(x)-gln)*h
      return
      END

c---------------------------------------------------------------------
      function utgmln(xx)
c---------------------------------------------------------------------
      REAL utgmln,xx
      INTEGER j
      DOUBLE PRECISION ser,stp,tmp,x,y,cof(6)
      SAVE cof,stp
      DATA cof,stp/76.18009172947146d0,-86.50532032941677d0,
     *24.01409824083091d0,-1.231739572450155d0,.1208650973866179d-2,
     *-.5395239384953d-5,2.5066282746310005d0/
      x=xx
      y=x
      tmp=x+5.5d0
      tmp=(x+0.5d0)*log(tmp)-tmp
      ser=1.000000000190015d0
      do 11 j=1,6
        y=y+1.d0
        ser=ser+cof(j)/y
11    continue
      utgmln=tmp+log(stp*ser/x)
      return
      END

c---------------------------------------------------------------------
      function utgmq(a,x)
c---------------------------------------------------------------------
      REAL a,utgmq,x
CU    USES utgcf,utgser
      REAL gammcf,gamser,gln
      if(x.lt.0..or.a.le.0.)pause 'bad arguments in utgmq'
      if(x.lt.a+1.)then
        call utgser(gamser,a,x,gln)
        utgmq=1.-gamser
      else
        call utgcf(gammcf,a,x,gln)
        utgmq=gammcf
      endif
      return
      END

c---------------------------------------------------------------------
      subroutine utgser(gamser,a,x,gln)
c---------------------------------------------------------------------
      INTEGER ITMAX
      REAL a,gamser,gln,x,EPS
      PARAMETER (ITMAX=100,EPS=3.e-7)
CU    USES utgmln
      INTEGER n
      REAL ap,del,sum,utgmln
      gln=utgmln(a)
      if(x.le.0.)then
        if(x.lt.0.)pause 'x < 0 in utgser'
        gamser=0.
        return
      endif
      ap=a
      sum=1./a
      del=sum
      do 11 n=1,ITMAX
        ap=ap+1.
        del=del*x/ap
        sum=sum+del
        if(abs(del).lt.abs(sum)*EPS)goto 1
11    continue
      pause 'a too large, ITMAX too small in utgser'
1     gamser=sum*exp(-x+a*log(x)-gln)
      return
      END
 
c-------------------------------------------------------------------------
      subroutine uticpl(ic,ifla,iqaq,iret)
c-------------------------------------------------------------------------      
c  adds a quark (iqaq=1) or antiquark (iqaq=2) of flavour ifla
c  to 2-id ic
c-------------------------------------------------------------------------      
      common/files/ifop,ifmt,ifch,ifcx,ifhi,ifdt,ifcp
      common/prnt1/iprmpt,ish,ishsub,irandm,irewch,iecho,modsho,idensi
      parameter (nflav=6)
      integer jc(nflav,2),ic(2)
      iret=0
      if(ifla.eq.0)return
      call iddeco(ic,jc)
      if(ish.ge.8)write(ifch,'(2i8,12i3)')ic,jc
      jqaq=3-iqaq
      if(jc(ifla,jqaq).gt.0)then
      jc(ifla,jqaq)=jc(ifla,jqaq)-1
      else
      jc(ifla,iqaq)=jc(ifla,iqaq)+1
      endif
      call idcomj(jc)
      call idenco(jc,ic,ireten)
      if(ish.ge.8)write(ifch,'(2i8,12i3)')ic,jc
      if(ireten.eq.1)iret=1
      if(ic(1).eq.0.and.ic(2).eq.0.and.ireten.eq.0)then
      ic(1)=100000
      ic(2)=100000
      endif
      return
      end

c-----------------------------------------------------------------------
      subroutine utindx(n,xar,x,i)
c-----------------------------------------------------------------------
c  input:  dimension n 
c          array xar(n) with xar(i) > xar(i-1) 
c          some number x between xar(1) and xar(n)
c  output: the index i such that x is between xar(i)  and xar(i+1)
c-----------------------------------------------------------------------
      common/files/ifop,ifmt,ifch,ifcx,ifhi,ifdt,ifcp
      common/prnt1/iprmpt,ish,ishsub,irandm,irewch,iecho,modsho,idensi
      real xar(n)
           if(x.lt.xar(1))then
      if(ish.ge.5)then
      call utmsg('utindx')
      write(ifch,*)'*****  x=',x,' < xar(1)=',xar(1)
      call utmsgf
      endif
      i=1
      return
           elseif(x.gt.xar(n))then
      if(ish.ge.5)then
      call utmsg('utindx')
      write(ifch,*)'*****  x=',x,' > xar(n)=',xar(n)
      call utmsgf
      endif
      i=n
      return
           endif
      lu=1
      lo=n
1     lz=(lo+lu)/2
      if((xar(lu).le.x).and.(x.le.xar(lz)))then
      lo=lz
      elseif((xar(lz).lt.x).and.(x.le.xar(lo)))then
      lu=lz
      else
      call utstop('utindx: no interval found&')
      endif
      if((lo-lu).ge.2) goto1
      if(lo.le.lu)call utstop('utinvt: lo.le.lu&')
      i=lu
      return
      end
 
c-----------------------------------------------------------------------
      function utinvt(n,x,q,y)
c-----------------------------------------------------------------------
c     returns x with y=q(x)
c-----------------------------------------------------------------------
      common/files/ifop,ifmt,ifch,ifcx,ifhi,ifdt,ifcp
      common/prnt1/iprmpt,ish,ishsub,irandm,irewch,iecho,modsho,idensi
      real x(n),q(n)
      if(q(n).eq.0.)call utstop('utinvt: q(n)=0&')
           if(y.lt.0.)then
      if(ish.ge.1)then
      call utmsg('utinvt')
      write(ifch,*)'*****  y=',y,' < 0'
      call utmsgf
      endif
      y=0.
           elseif(y.gt.q(n))then
      if(ish.ge.1)then
      call utmsg('utinvt')
      write(ifch,*)'*****  y=',y,' > ',q(n)
      call utmsgf
      endif
      y=q(n)
           endif
      lu=1
      lo=n
1     lz=(lo+lu)/2
      if((q(lu).le.y).and.(y.le.q(lz)))then
      lo=lz
      elseif((q(lz).lt.y).and.(y.le.q(lo)))then
      lu=lz
      else
      write(ifch,*)'q(1),y,q(n):',q(1),y,q(n)
      write(ifch,*)'lu,lz,lo:',lu,lz,lo
      write(ifch,*)'q(lu),q(lz),q(lo):',q(lu),q(lz),q(lo)
      call utstop('utinvt: no interval found&')
      endif
      if((lo-lu).ge.2) goto1
      if(lo.le.lu)call utstop('utinvt: lo.le.lu&')
      utinvt=x(lu)+(y-q(lu))*(x(lo)-x(lu))/(q(lo)-q(lu))
      return
      end
 
c-----------------------------------------------------------------------
      subroutine utlob2(isig,p1,p2,p3,p4,p5,x1,x2,x3,x4,idi)
c-----------------------------------------------------------------------
c  performs a lorentz boost, double prec.
c  isig=+1 is to boost the four vector x1,x2,x3,x4 such as to obtain it
c  in the frame specified by the 5-vector p1...p5 (5-vector=4-vector+mass).
c  isig=-1: the other way round, that means,
c  if the 4-vector x1...x4 is given in some frame characterized by 
c  p1...p5 with respect to to some lab-frame, utlob2 returns the 4-vector 
c  x1...x4  in the lab frame.
c  idi is a call identifyer (integer) to identify the call in case of problem
c-----------------------------------------------------------------------
      common/files/ifop,ifmt,ifch,ifcx,ifhi,ifdt,ifcp
      common/prnt1/iprmpt,ish,ishsub,irandm,irewch,iecho,modsho,idensi
      double precision beta(4),z(4),p1,p2,p3,p4,p5,pp,bp,x1,x2,x3,x4
     *,xx0,x10,x20,x30,x40,x4x
           if(ish.ge.2)then
      if(ish.ge.9)then
      write(ifch,101)x1,x2,x3,x4,(x4-x3)*(x4+x3)-x2*x2-x1*x1
      write(ifch,301)p1,p2,p3,p4,p5,(p4-p3)*(p4+p3)-p2*p2-p1*p1
101   format(' utlob2: x =  ',5e13.5)
301   format('         p =  ',6e13.5)
      endif
      pp=(p4-p3)*(p4+p3)-p2*p2-p1*p1
      if(dabs(pp-p5*p5).gt.1e-3*p4*p4.and.dabs(pp-p5*p5).gt.1e-3)then
      call utmsg('utlob2')
      write(ifch,*)'*****  p**2 .ne. p5**2'
      write(ifch,*)'call identifyer:',idi
      write(ifch,*)'p**2,p5**2: ',pp,p5*p5
      write(ifch,*)'p: ',p1,p2,p3,p4,p5
      call utmsgf
      endif
      x10=x1
      x20=x2
      x30=x3
      x40=x4
           endif
      xx0=(x4-x3)*(x4+x3)-x2*x2-x1*x1
      if(p5.le.0.)then
      call utmsg('utlob2')
      write(ifch,*)'*****  p5 negative.'
      write(ifch,*)'call identifyer:',idi
      write(ifch,*)'p(5): ',p1,p2,p3,p4,p5
      call utmsgf
      call utstop('utlob2: p5 negative.&')
      endif
      z(1)=x1
      z(2)=x2
      z(3)=x3
      z(4)=x4
      beta(1)=-p1/p5
      beta(2)=-p2/p5
      beta(3)=-p3/p5
      beta(4)= p4/p5
      bp=0.
      do 220 k=1,3
220   bp=bp+z(k)*isig*beta(k)
      do 230 k=1,3
230   z(k)=z(k)+isig*beta(k)*z(4)
     *+isig*beta(k)*bp/(beta(4)+1.)
      z(4)=beta(4)*z(4)+bp
      x1=z(1)
      x2=z(2)
      x3=z(3)
      x4=z(4)
      if(ish.ge.9)
     *write(ifch,101)x1,x2,x3,x4,(x4-x3)*(x4+x3)-x2*x2-x1*x1
      x4x=x4
      if(xx0+x1*x1+x2*x2+x3*x3.gt.0.)then
      x4=sign( dsqrt(xx0+x1*x1+x2*x2+x3*x3) , x4x )
      else
      x4=0
      endif
      if(ish.ge.9)then
      write(ifch,101)x1,x2,x3,x4,(x4-x3)*(x4+x3)-x2*x2-x1*x1
      endif
           if(ish.ge.2)then
      if(dabs(x4-x4x).gt.1d-2*dabs(x4).and.dabs(x4-x4x).gt.1d-2)then
      call utmsg('utlob2')
      write(ifch,*)'*****  x**2_ini .ne. x**2_fin.'
      write(ifch,*)'call identifyer:',idi
      write(ifch,*)'x1 x2 x3 x4 x**2 (initial/final/corrected):'
102   format(5e13.5)
      write(ifch,102)x10,x20,x30,x40,(x40-x30)*(x40+x30)-x20*x20-x10*x10
      write(ifch,102)x1,x2,x3,x4x,(x4x-x3)*(x4x+x3)-x2*x2-x1*x1
      write(ifch,102)x1,x2,x3,x4,(x4-x3)*(x4+x3)-x2*x2-x1*x1
      call utmsgf
      endif
           endif
      return
      end

c-----------------------------------------------------------------------
      subroutine utlob3(isig,p1,p2,p3,p4,p5,x1,x2,x3,x4)
c-----------------------------------------------------------------------
c  performs a lorentz boost, double prec.
c  but arguments are single precision
c-----------------------------------------------------------------------
      double precision xx1,xx2,xx3,xx4
      xx1=dble(x1)
      xx2=dble(x2)
      xx3=dble(x3)
      xx4=dble(x4)
      call utlob2(isig
     *,dble(p1),dble(p2),dble(p3),dble(p4),dble(p5)
     *,xx1,xx2,xx3,xx4,52)
      x1=sngl(xx1)
      x2=sngl(xx2)
      x3=sngl(xx3)
      x4=sngl(xx4)
      return
      end

c-----------------------------------------------------------------------
      subroutine utlob5(yboost,x1,x2,x3,x4,x5)
c-----------------------------------------------------------------------
      amt=x5**2+x1**2+x2**2
      if(amt.gt.0.)then
        amt=sqrt(x5**2+x1**2+x2**2)
      else
        amt=max(1e-15,sqrt(abs((x4+x3)*(x4-x3))))
      endif
      y=sign(1.,x3)*alog((x4+abs(x3))/amt)
      y=y-yboost
      x4=amt*cosh(y)
      x3=amt*sinh(y)
      return
      end

c-----------------------------------------------------------------------
      subroutine utlob4(isig,pp1,pp2,pp3,pp4,pp5,x1,x2,x3,x4)
c-----------------------------------------------------------------------
c  performs a lorentz boost, double prec.
c  but arguments are partly single precision
c-----------------------------------------------------------------------
      double precision xx1,xx2,xx3,xx4,pp1,pp2,pp3,pp4,pp5
      xx1=dble(x1)
      xx2=dble(x2)
      xx3=dble(x3)
      xx4=dble(x4)
      call utlob2(isig,pp1,pp2,pp3,pp4,pp5,xx1,xx2,xx3,xx4,53)
      x1=sngl(max(-1.d30,min(1.d30,xx1)))
      x2=sngl(max(-1.d30,min(1.d30,xx2)))
      x3=sngl(max(-1.d30,min(1.d30,xx3)))
      x4=sngl(max(-1.d30,min(1.d30,xx4)))
      return
      end

 
c-----------------------------------------------------------------------
      subroutine utlobo(isig,p1,p2,p3,p4,p5,x1,x2,x3,x4)
c-----------------------------------------------------------------------
c     performs a lorentz boost
c-----------------------------------------------------------------------
      common/files/ifop,ifmt,ifch,ifcx,ifhi,ifdt,ifcp
      real beta(4),z(4)
      if(p5.le.0.)then
      call utmsg('utlobo')
      write(ifch,*)'*****  mass <= 0.'
      write(ifch,*)'p(5): ',p1,p2,p3,p4,p5
      call utmsgf
      call utstop('utlobo: mass <= 0.&')
      endif
      z(1)=x1
      z(2)=x2
      z(3)=x3
      z(4)=x4
      beta(1)=-p1/p5
      beta(2)=-p2/p5
      beta(3)=-p3/p5
      beta(4)= p4/p5
      bp=0.
      do 220 k=1,3
220   bp=bp+z(k)*isig*beta(k)
      do 230 k=1,3
230   z(k)=z(k)+isig*beta(k)*z(4)
     *+isig*beta(k)*bp/(beta(4)+1.)
      z(4)=beta(4)*z(4)+bp
      x1=z(1)
      x2=z(2)
      x3=z(3)
      x4=z(4)
      return
      end
 
c-----------------------------------------------------------------------
      subroutine utloc(ar,n,a,l)
c-----------------------------------------------------------------------
      real ar(n)
      do 1 i=1,n
      l=i-1
      if(a.lt.ar(i))return
1     continue
      l=n
      return
      end
 
c-----------------------------------------------------------------------
      subroutine utlow(cone)
c-----------------------------------------------------------------------
      character*1 cone
      if(cone.eq.'A')cone='a'
      if(cone.eq.'B')cone='b'
      if(cone.eq.'C')cone='c'
      if(cone.eq.'D')cone='d'
      if(cone.eq.'E')cone='e'
      if(cone.eq.'F')cone='f'
      if(cone.eq.'G')cone='g'
      if(cone.eq.'H')cone='h'
      if(cone.eq.'I')cone='i'
      if(cone.eq.'J')cone='j'
      if(cone.eq.'K')cone='k'
      if(cone.eq.'L')cone='l'
      if(cone.eq.'M')cone='m'
      if(cone.eq.'N')cone='n'
      if(cone.eq.'O')cone='o'
      if(cone.eq.'P')cone='p'
      if(cone.eq.'Q')cone='q'
      if(cone.eq.'R')cone='r'
      if(cone.eq.'S')cone='s'
      if(cone.eq.'T')cone='t'
      if(cone.eq.'U')cone='u'
      if(cone.eq.'V')cone='v'
      if(cone.eq.'W')cone='w'
      if(cone.eq.'X')cone='x'
      if(cone.eq.'Y')cone='y'
      if(cone.eq.'Z')cone='z'
      return
      end
 
c-----------------------------------------------------------------------
      subroutine utlow3(cthree)
c-----------------------------------------------------------------------
      character cthree*3
      do 1 i=1,3
1     call utlow(cthree(i:i))
      return
      end
 
c-----------------------------------------------------------------------
      subroutine utlow6(csix)
c-----------------------------------------------------------------------
      character csix*6
      do 1 i=1,6
1     call utlow(csix(i:i))
      return
      end
 
c-----------------------------------------------------------------------
      function utmom(k,n,x,q)
c-----------------------------------------------------------------------
c     calculates kth moment for f(x) with q(i)=int[0,x(i)]f(z)dz
c-----------------------------------------------------------------------
      real x(n),q(n)
      if(n.lt.2)call utstop('utmom : dimension too small&')
      utmom=0
      do 1 i=2,n
1     utmom=utmom+((x(i)+x(i-1))/2)**k*(q(i)-q(i-1))
      utmom=utmom/q(n)
      return
      end
 
c-----------------------------------------------------------------------
      function utpcm(a,b,c)
c-----------------------------------------------------------------------
c     calculates cm momentum for a-->b+c
c-----------------------------------------------------------------------
      val=(a*a-b*b-c*c)*(a*a-b*b-c*c)-(2.*b*c)*(2.*b*c)
      if(val.lt.0..and.val.gt.-1e-4)then
      utpcm=0
      return
      endif
      utpcm=sqrt(val)/(2.*a)
      return
      end

c-----------------------------------------------------------------------
      subroutine utpri(text,idmmy,ishini,ishx)
c-----------------------------------------------------------------------
      include 'nexus.inc'
      character*6 text
c      double precision seedx                               !!!
ctp060202 to avoid warnings with gfortran compilation
      logical ctp060202
      ctp060202=.false.
      if(ctp060202)write(*,*)idmmy
ctp060202 end
      ishini=ish
      if(ishevt.ne.0.and.nrevt+1.ne.ishevt)return
      if(nrpri.gt.0)then
      do nr=1,nrpri
      if(subpri(nr).eq.text)then
      ish=ishpri(nr)
      endif       
      enddo
      endif
      if(ish.ge.ishx)then
        write(ifch,'(1x,43a)')
     *  ('-',i=1,10),' entry ',text,' ',('-',i=1,30)
c       call ranfgt(seedx)                                   !!!
c       if(ish.ge.ishx)write(ifch,*)'seed:',seedx            !!!
      endif
      return
      end
      
c-----------------------------------------------------------------------
      subroutine utprix(text,idmmy,ishini,ishx)
c-----------------------------------------------------------------------
      include 'nexus.inc'
      character*6 text
ctp060202 to avoid warnings with gfortran compilation
      logical ctp060202
      ctp060202=.false.
      if(ctp060202)write(*,*)idmmy
ctp060202 end
      if(ishevt.ne.0.and.nrevt+1.ne.ishevt)return
      if(ish.ge.ishx)write(ifch,'(1x,44a)')
     *('-',i=1,30),' exit ',text,' ',('-',i=1,11)
      ish=ishini
      return
      end

c-----------------------------------------------------------------------
      function utquad(m,x,f,k)
c-----------------------------------------------------------------------
c     performs an integration according to simpson
c-----------------------------------------------------------------------
      real x(m),f(m)
      utquad=0
      do 1 i=1,k-1
  1   utquad=utquad+(f(i)+f(i+1))/2*(x(i+1)-x(i))
      return
      end
 
c-----------------------------------------------------------------------
      subroutine utquaf(fu,n,x,q,wo,x0,x1,x2,x3)
c-----------------------------------------------------------------------
c     returns q(i) = integral [x(1)->x(i)] fu(x) dx
c-----------------------------------------------------------------------
      common/files/ifop,ifmt,ifch,ifcx,ifhi,ifdt,ifcp
      common/prnt1/iprmpt,ish,ishsub,irandm,irewch,iecho,modsho,idensi
      real x(n),q(n),wo(n)
      parameter (m=10)
      real xa(m),fa(m)
      external fu
ctp060202 to avoid warnings with gfortran compilation
      logical ctp060202
      ctp060202=.false.
      if(ctp060202)write(*,*)wo
ctp060202 end
      if(x1.lt.x0.or.x2.lt.x1.or.x3.lt.x2)then
      if(ish.ge.1)then
      call utmsg('utquaf')
      write(ifch,*)'   xi=',x0,x1,x2,x3
      call utmsgf
      endif
      endif
      call utar(n/3,n*2/3,n,x0,x1,x2,x3,x)
      q(1)=0
      do 2 i=2,n
      do 3 k=1,m
      z=x(i-1)+(k-1.)/(m-1.)*(x(i)-x(i-1))
      xa(k)=z
3     fa(k)=fu(z)
      q(i)=q(i-1)+utquad(m,xa,fa,m)
2     continue
      return
      end

c-----------------------------------------------------------------------
      subroutine utrepl(i,j)
c-----------------------------------------------------------------------
c     i is replaced by j in /cptl/
c-----------------------------------------------------------------------
      include 'nexus.inc'
      do 1 k=1,5
1     pptl(k,i)  =pptl(k,j)
      iorptl(i)  =iorptl(j)
      idptl(i)   =idptl(j)
      istptl(i)  =istptl(j)
      do 2 k=1,2
2     tivptl(k,i)=tivptl(k,j)
      do 3 k=1,2
3     ifrptl(k,i)=ifrptl(k,j)
      jorptl(i)  =jorptl(j)
      do 4 k=1,4
4     xorptl(k,i)=xorptl(k,j)
      do 5 k=1,4
5     ibptl(k,i) =ibptl(k,j)
      ityptl(i)  =ityptl(j)
      iaaptl(i)  =iaaptl(j)
      radptl(i)  =radptl(j)
      rinptl(i)  =rinptl(j)
      desptl(i)  =desptl(j)
      dezptl(i)  =dezptl(j)
      iyptl(i)   =iyptl(j)
      iyiptl(iyptl(i))=i
      itsptl(i)  =itsptl(j)
      return
      end
 
c-----------------------------------------------------------------------
      subroutine utresm(icp1,icp2,icm1,icm2,amp,idpr,iadj,ireten)
c-----------------------------------------------------------------------
      parameter (nflav=6)
      integer icm(2),icp(2),jcm(nflav,2),jcp(nflav,2)
      icm(1)=icm1
      icm(2)=icm2
      icp(1)=icp1
      icp(2)=icp2
      CALL IDDECO(ICM,JCM)
      CALL IDDECO(ICP,JCP)
      do 37 nf=1,nflav
      do 37 k=1,2
37    jcP(nf,k)=jcp(nf,k)+jcm(nf,k)
      CALL IDENCO(JCP,ICP,IRETEN)
      IDP=IDTRA(ICP,0,0,3)
      call idres(idp,amp,idpr,iadj)
      return
      end

c-----------------------------------------------------------------------
      subroutine utroa1(phi,a1,a2,a3,x1,x2,x3)
c-----------------------------------------------------------------------
c  rotates x by angle phi around axis a.
c  normalization of a is irrelevant.
c-----------------------------------------------------------------------
      double precision aaa,aa(3),xxx,xx(3),e1(3),e2(3),e3(3),xp,xt,dphi
      dphi=phi
      xx(1)=x1
      xx(2)=x2
      xx(3)=x3
      aa(1)=a1
      aa(2)=a2
      aa(3)=a3
      aaa=0
      xxx=0
      do i=1,3
      aaa=aaa+aa(i)**2
      xxx=xxx+xx(i)**2
      enddo
      if(xxx.eq.0d0)return
      if(aaa.eq.0d0)call utstop('utroa1: zero rotation axis&')
      aaa=dsqrt(aaa)
      xxx=dsqrt(xxx)
c e3 = a / !a!
      do i=1,3
      e3(i)=aa(i)/aaa
      enddo
c x_parallel
      xp=0
      do i=1,3
      xp=xp+xx(i)*e3(i)
      enddo
c x_transverse
      if(xxx**2-xp**2.le.0.)return
      xt=dsqrt(xxx**2-xp**2)
c e1 = vector x_transverse / absolute value x_transverse
      do i=1,3
      e1(i)=(xx(i)-e3(i)*xp)/xt
      enddo
c e2 orthogonal e3,e1
      call utvec2(e3,e1,e2)
c rotate x
      do i=1,3
      xx(i)=xp*e3(i)+xt*dcos(dphi)*e1(i)+xt*dsin(dphi)*e2(i)
      enddo
c back to single precision
      x1=xx(1)
      x2=xx(2)
      x3=xx(3)
      return
      end

c-----------------------------------------------------------------------
      subroutine utroa2(phi,a1,a2,a3,x1,x2,x3)
c-----------------------------------------------------------------------
c  rotates x by angle phi around axis a.
c  normalization of a is irrelevant.
c  double precision phi,a1,a2,a3,x1,x2,x3
c-----------------------------------------------------------------------
      double precision phi,a1,a2,a3,x1,x2,x3
      double precision aaa,aa(3),xxx,xx(3),e1(3),e2(3),e3(3),xp,xt,dphi
      dphi=phi
      xx(1)=x1
      xx(2)=x2
      xx(3)=x3
      aa(1)=a1
      aa(2)=a2
      aa(3)=a3
      aaa=0
      xxx=0
      do i=1,3
      aaa=aaa+aa(i)**2
      xxx=xxx+xx(i)**2
      enddo
      if(xxx.eq.0d0)return
      if(aaa.eq.0d0)call utstop('utroa1: zero rotation axis&')
      aaa=1.0/dsqrt(aaa)
c e3 = a / !a!
      do i=1,3
      e3(i)=aa(i)*aaa
      enddo
c x_parallel
      xp=0
      do i=1,3
      xp=xp+xx(i)*e3(i)
      enddo
c x_transverse
      if(xxx-xp**2.le.0.)return
      xt=dsqrt(xxx-xp**2)
c e1 = vector x_transverse / absolute value x_transverse
      do i=1,3
      e1(i)=(xx(i)-e3(i)*xp)/xt
      enddo
c e2 orthogonal e3,e1
      call utvec2(e3,e1,e2)
c rotate x
      do i=1,3
      xx(i)=xp*e3(i)+xt*dcos(dphi)*e1(i)+xt*dsin(dphi)*e2(i)
      enddo
c back to single precision
      x1=xx(1)
      x2=xx(2)
      x3=xx(3)
      return
      end

c--------------------------------------------------------------------
      function utroot(funcd,x1,x2,xacc)
c--------------------------------------------------------------------
c combination of newton-raphson and bisection method for root finding
c input:
c   funcd: subr returning fctn value and first derivative
c   x1,x2: x-interval
c   xacc:  accuracy
c output: 
c   utroot: root
c--------------------------------------------------------------------
      common/files/ifop,ifmt,ifch,ifcx,ifhi,ifdt,ifcp 
      INTEGER MAXIT
      REAL utroot,x1,x2,xacc
      EXTERNAL funcd
      PARAMETER (MAXIT=100)
      INTEGER j
      REAL df,dx,dxold,f,fh,fl,temp,xh,xl
      call funcd(x1,fl,df)
      call funcd(x2,fh,df)
      if((fl.gt.0..and.fh.gt.0.).or.(fl.lt.0..and.fh.lt.0.))
     *call utstop('utroot: root must be bracketed&')
      if(fl.eq.0.)then
        utroot=x1
        return
      else if(fh.eq.0.)then
        utroot=x2
        return
      else if(fl.lt.0.)then
        xl=x1
        xh=x2
      else
        xh=x1
        xl=x2
      endif
      utroot=.5*(x1+x2)
      dxold=abs(x2-x1)
      dx=dxold
      call funcd(utroot,f,df)
      do 11 j=1,MAXIT
        if(((utroot-xh)*df-f)*((utroot-xl)*df-f).ge.0..or. abs(2.*
     *f).gt.abs(dxold*df) ) then
          dxold=dx
          dx=0.5*(xh-xl)
          utroot=xl+dx
          if(xl.eq.utroot)return
        else
          dxold=dx
          dx=f/df
          temp=utroot
          utroot=utroot-dx
          if(temp.eq.utroot)return
        endif
        if(abs(dx).lt.xacc) return
        call funcd(utroot,f,df)
        if(f.lt.0.) then
          xl=utroot
        else
          xh=utroot
        endif
11    continue
      call utmsg('utroot')
      write(ifch,*)'*****  exceeding maximum iterations'
      write(ifch,*)'dx:',dx
      call utmsgf
      return
      END

c-----------------------------------------------------------------------
      subroutine utrot2(isig,ax,ay,az,x,y,z)
c-----------------------------------------------------------------------
c     performs a rotation, double prec.
c-----------------------------------------------------------------------
      common/files/ifop,ifmt,ifch,ifcx,ifhi,ifdt,ifcp
      double precision ax,ay,az,x,y,z,rx,ry,rz
     *,alp,bet,cosa,sina,cosb,sinb,xs,ys,zs
         if(ax**2.eq.0.and.ay**2.eq.0.and.az**2.eq.0.)then
      write(ifch,*)'ax**2,ay**2,az**2:',ax**2,ay**2,az**2
      write(ifch,*)'ax,ay,az:',ax,ay,az
      call utstop('utrot2: zero vector.&')
         endif
         if(az.ge.0.)then
      rx=ax
      ry=ay
      rz=az
         else
      rx=-ax
      ry=-ay
      rz=-az
         endif
      if(rz**2+ry**2.ne.0.)then
      alp=dabs(dacos(rz/dsqrt(rz**2+ry**2)))*sign(1.,sngl(ry))
      bet=
     *dabs(dacos(dsqrt(rz**2+ry**2)/dsqrt(rz**2+ry**2+rx**2)))*
     *sign(1.,sngl(rx))
      else
      alp=3.1415927d0/2d0
      bet=3.1415927d0/2d0
      endif
      cosa=dcos(alp)
      sina=dsin(alp)
      cosb=dcos(bet)
      sinb=dsin(bet)
           if(isig.gt.0)then
      xs=x*cosb-y*sina*sinb-z*cosa*sinb
      ys=       y*cosa     -z*sina
      zs=x*sinb+y*sina*cosb+z*cosa*cosb
           elseif(isig.lt.0)then
      xs= x*cosb            +z*sinb
      ys=-x*sinb*sina+y*cosa+z*cosb*sina
      zs=-x*sinb*cosa-y*sina+z*cosb*cosa
           endif
      x=xs
      y=ys
      z=zs
      return
      end
 

c-----------------------------------------------------------------------
      subroutine utrot4(isig,ax,ay,az,x,y,z)
c-----------------------------------------------------------------------
c     performs a rotation, double prec.
c     arguments partly single
c-----------------------------------------------------------------------
      double precision ax,ay,az,xx,yy,zz
      xx=dble(x)
      yy=dble(y)
      zz=dble(z)
      call utrot2(isig,ax,ay,az,xx,yy,zz)
      x=sngl(xx)
      y=sngl(yy)
      z=sngl(zz)
      return
      end

c-----------------------------------------------------------------------
      subroutine utrota(isig,ax,ay,az,x,y,z)
c-----------------------------------------------------------------------
c     performs a rotation
c-----------------------------------------------------------------------      
         if(az.ge.0.)then
      rx=ax
      ry=ay
      rz=az
         else
      rx=-ax
      ry=-ay
      rz=-az
         endif
      if(rz.eq.0..and.ry.eq.0.)then
        alp=0.
	stop
      else
        alp=abs(utacos(rz/sqrt(rz**2+ry**2)))*sign(1.,ry)
      endif
      bet=
     *abs(utacos(sqrt(rz**2+ry**2)/sqrt(rz**2+ry**2+rx**2)))*sign(1.,rx)
      cosa=cos(alp)
      sina=sin(alp)
      cosb=cos(bet)
      sinb=sin(bet)
           if(isig.gt.0)then
      xs=x*cosb-y*sina*sinb-z*cosa*sinb
      ys=       y*cosa     -z*sina
      zs=x*sinb+y*sina*cosb+z*cosa*cosb
           elseif(isig.lt.0)then
      xs= x*cosb            +z*sinb
      ys=-x*sinb*sina+y*cosa+z*cosb*sina
      zs=-x*sinb*cosa-y*sina+z*cosb*cosa
           endif
      x=xs
      y=ys
      z=zs
      return
      end
 
c-----------------------------------------------------------------------
      subroutine utstop(text)
c-----------------------------------------------------------------------
c  returns error message and stops execution.
c  text is an optonal text to appear in the error message.
c  text is a character string of length 40; 
c     for shorter text, it has to be terminated by &;
c        example: call utstop('error in subr xyz&')
c-----------------------------------------------------------------------
      common/files/ifop,ifmt,ifch,ifcx,ifhi,ifdt,ifcp
      common/accum/imsg,jerr,ntevt,nrevt,naevt,nrstr,nrptl
      common/prnt1/iprmpt,ish,ishsub,irandm,irewch,iecho,modsho,idensi
      double precision seedi,seedj,seedc
      common/cseed/seedi,seedj,seedc
      parameter(itext=40)
      character  text*40  ,txt*6
      imax=itext+1
      do i=itext,1,-1
      if(text(i:i).eq.'&')imax=i
      enddo
      do 1 j=1,2
      if(j.eq.1)ifi=ifch
      if(j.eq.2)ifi=ifmt
      write(ifi,101)('*',k=1,75),text(1:imax-1)
     *,nrevt+1,seedc,('*',k=1,75)
101   format(
     *1x,75a1
     */1x,'***** stop in ',a
     */1x,'***** current event number: ',i12
     */1x,'***** initial seed for current event:',d25.15
     */1x,75a1)
1     continue
      stop
      entry utmsg(txt)
      imsg=imsg+1
      write(ifch,'(77a1)')('-',j=1,77)
      write(ifch,100)txt,nrevt+1,seedc
100   format(1x,'***** msg from ',a6,'.   es:',i7,2x,d23.17)
      return
      entry utmsgf
      if(ish.eq.1)return
      write(ifch,'(77a1)')('-',j=1,77)
      end
 
c-----------------------------------------------------------------
      subroutine uttrap(func,a,b,s)
c-----------------------------------------------------------------
c trapezoidal method for integration.
c input: fctn func and limits a,b
c output: value s of the integral
c-----------------------------------------------------------------
      common/files/ifop,ifmt,ifch,ifcx,ifhi,ifdt,ifcp 
      common/prnt1/iprmpt,ish,ishsub,irandm,irewch,iecho,modsho,idensi
      common/metr6/epsr,keepr

      INTEGER JMAX
      REAL a,b,func,s,epsr
      EXTERNAL func
      PARAMETER (JMAX=10)
CU    USES uttras
      INTEGER j
      REAL olds
      olds=-1.e30
      do 11 j=1,JMAX
        if(ish.ge.9)write(ifch,*)'sr uttrap:   j:',j
        call uttras(func,a,b,s,j)
        ds=abs(s-olds)
        if (ds.lt.epsr*abs(olds)) return
        olds=s
11    continue
 
c-c   nepsr=nepsr+1
      if(ish.ge.9)then
      call utmsg('uttrap')
      write(ifch,*)
     *'*****  requested accuracy could not be achieved'
      write(ifch,*)'achieved accuracy: ',ds/abs(olds)
      write(ifch,*)'requested accuracy:',epsr
      call utmsgf
      endif

      END

c-----------------------------------------------------------------
      subroutine uttraq(func,a,b,s)
c-----------------------------------------------------------------
c trapezoidal method for integration.
c input: function func and limits a,b
c output: value s of the integral
c-----------------------------------------------------------------

      REAL a,b,func,s
      EXTERNAL func
      PARAMETER (eps=1.e-6)
CU    USES uttras
      INTEGER j
      REAL olds
      olds=-1.e30
      j=1
10      call uttras(func,a,b,s,j)
        ds=abs(s-olds)
        if (ds.le.eps*abs(olds)) return
        olds=s
        if(j.ge.15)return
        j=j+1
      goto10
      END

c-----------------------------------------------------------------
      subroutine uttras(func,a,b,s,n)
c-----------------------------------------------------------------
c performs one iteration of the trapezoidal method for integration
c-----------------------------------------------------------------
      INTEGER n
      REAL a,b,s,func
      EXTERNAL func
      INTEGER it,j
      REAL del,sum,tnm,x
      if (n.eq.1) then
        s=0.5*(b-a)*(func(a)+func(b))
      else
        it=2**(n-2)
        tnm=it
        del=(b-a)/tnm
        x=a+0.5*del
        sum=0.
        do 11 j=1,it
          sum=sum+func(x)
          x=x+del
11      continue
        s=0.5*(s+(b-a)*sum/tnm)
      endif
      return
      END

c-----------------------------------------------------------------------
      subroutine utvec1(a,b,c)
c-----------------------------------------------------------------------
c  returns vector product c = a x b .
c-----------------------------------------------------------------------
      real a(3),b(3),c(3)
      c(1)=a(2)*b(3)-a(3)*b(2)
      c(2)=a(3)*b(1)-a(1)*b(3)
      c(3)=a(1)*b(2)-a(2)*b(1)
      return
      end

c-----------------------------------------------------------------------
      subroutine utvec2(a,b,c)
c-----------------------------------------------------------------------
c  returns vector product c = a x b .
c  a,b,c double precision.
c-----------------------------------------------------------------------
      double precision a(3),b(3),c(3)
      c(1)=a(2)*b(3)-a(3)*b(2)
      c(2)=a(3)*b(1)-a(1)*b(3)
      c(3)=a(1)*b(2)-a(2)*b(1)
      return
      end

c-------------------------------------------------------------------
      subroutine utword(line,i,j,iqu)
c-------------------------------------------------------------------
c  finds the first word of the character string line(j+1:160).
c  the word is line(i:j) (with new i and j).
c  if j<0 or if no word found --> new line read.
c  a text between quotes "..." is considered one word; 
c  stronger: a text between double quotes ""..."" is consid one word
c  stronger: a text between "{ and }" is considered one word
c-------------------------------------------------------------------
c  input: 
c    line: character string (*160)
c    i: integer between 1 and 160
c    iqu: for iqu=1 a "?" is written to output before reading a line,
c         otherwise (iqu/=1) nothing is typed
c  output: 
c    i,j: left and right end of word (word=line(i:j))
c-------------------------------------------------------------------
      include 'nexus.inc'
      parameter(mempty=2)
      character*1 empty(mempty)
      character line*160
      character*2 mrk
      data empty/' ',','/

      if(j.ge.0)then
      i=j
      goto1
      endif

    5 continue
      if(iqu.eq.1.and.iprmpt.gt.0)write(ifmt,'(a)')'?'
      if(nopen.eq.0)ifopx=ifop
      if(nopen.gt.0)ifopx=20+nopen
      if(nopen.lt.0)ifopx=ifcp
      read(ifopx,'(a160)',end=9999)line
      if(nopen.ge.0.and.kcpopen.eq.1)write(ifcp,'(a160)')line
      if(iecho.eq.1)then
       kmax=80
       do k=81,160
       if(line(k:k).ne.' ')kmax=k
       enddo
       write(ifmt,'(a)')line(1:kmax)
      endif
      i=0

    1 i=i+1
      if(i.gt.160.or.line(i:i).eq.'!')goto5
      do ne=1,mempty
      if(line(i:i).eq.empty(ne))goto1
      enddo

      mrk='  '
      if(line(i:i+1).eq.'"{')mrk='}"'
      if(line(i:i+1).eq.'""')mrk='""'
      if(mrk.ne.'  ')goto10
      if(line(i:i).eq.'"')goto8
      j=i-1
    6 j=j+1
      if(j.gt.160)goto7
      if(line(j:j).eq.'!')goto7
      do ne=1,mempty
      if(line(j:j).eq.empty(ne))goto7
      enddo
      goto6

    8 continue
      if(i.ge.79)stop'STOP: syntax error (utword)'
      i=i+1
      j=i
      if(line(j:j).eq.'"')stop'STOP: syntax error (utword)'
    9 j=j+1
      if(j.gt.160)goto7
      if(line(j:j).eq.'"')then
      line(i-1:i-1)=' '
      line(j:j)=' '
      goto7
      endif
      goto9

   10 continue
      if(i.ge.77)stop'STOP: syntax error (utword)'
      i=i+2
      j=i
      if(line(j:j+1).eq.mrk)stop'STOP: syntax error (utword)'
   11 j=j+1
      if(j+1.gt.160)goto7
      if(line(j:j+1).eq.mrk)then
      line(i-2:i-1)='  '
      line(j:j+1)='  '
      goto7
      endif
      goto11

    7 j=j-1
      return

9999  close(ifopx)
      nopen=nopen-1
      if(nopen.eq.0.and.iprmpt.eq.-1)iprmpt=1
      goto5
      end

c--------------------------------------------------------------------
      subroutine utworn(line,j,ne)
c--------------------------------------------------------------------
c  returns number ne of nonempty characters of line(j+1:160)
c--------------------------------------------------------------------
      character line*160
      ne=0
      do l=j+1,160
      if(line(l:l).ne.' ')ne=ne+1
      enddo
      return
      end

c-----------------------------------------------------------------------     
      subroutine getairmol(iz,ia)
c-----------------------------------------------------------------------     
      include 'nexus.inc'
      i=0		  
      r=rangen()	      
      do while(r.gt.0.)  ! choose air-molecule
        i=i+1		      
        r=r-airwnxs(i)	      
      enddo		      
      iz = nint(airznxs(i))         
      ia = nint(airanxs(i))  
      end

c----------------------------------------------------------------------

      subroutine factoriel
	
c----------------------------------------------------------------------
c tabulation of fctrl(n)=n!, facto(n)=1/n! and utgamtab(x) for x=0 to 50
c----------------------------------------------------------------------
      include 'nexus.incems'
      double precision utgamtab,utgam,x
      common/gamtab/utgamtab(10000)


      fctrl(0)=1.D0
      facto(0)=1.D0
      do i=1,5*npommx
        fctrl(i)=fctrl(i-1)*dble(i)
        facto(i)=1.d0/fctrl(i)
      enddo
        
      do k=1,10000
        x=dble(k)/100.d0
        utgamtab(k)=utgam(x)
      enddo
      
      return
      end
      
