c 27/02/2003 Nexus 3.97 

c----------------------------------------------------------------------

      double precision function om1(xh,yp,b)

c----------------------------------------------------------------------
c 2*C*Eikonale
c xh - fraction of the energy squared s for the pomeron;
c b - impact parameter between the pomeron ends;
c yp - rapidity for the pomeron;
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'

      double precision Df,xp,xm,xh,yp

      Df=0.d0
      b2=b*b
      xp=dsqrt(xh)*dexp(yp)
      xm=xh/xp
      sy=engy**2*real(xh)
      imax=nbpDf1
      if(iscreen.eq.0)imax=1
      do i=nbpDf0,imax
        Df=Df+dble(alpD(i,iclegy,iclpro,icltar,icdp,icdt)
     *              *real(xp)**betDp(i,iclegy,iclpro,icltar,icdp,icdt)
     *              *real(xm)**betDpp(i,iclegy,iclpro,icltar,icdp,icdt)
     *              *(engy**2.)**betD(i,iclegy,iclpro,icltar,icdp,icdt)
     *              *sy**(gamD(i,iclegy,iclpro,icltar,icdp,icdt)*b2)
     *              *exp(-b2/delD(i,iclegy,iclpro,icltar,icdp,icdt)))
      enddo
      om1=dble(chad(iclpro)*chad(icltar))
     *         *xh**dble(-alppar)*Df
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
	
      return
      end

c----------------------------------------------------------------------

	double precision function om1x(xh,b)
        
c----------------------------------------------------------------------
c Normalised on x and y omega1 function integrated over y
c xh - fraction of the energy squared s for the pomeron;
c b - impact parameter between the pomeron ends;
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      double precision xh,cint,om1intb,Df

      cint=om1intb(b)	
      om1x=0.d0
      b2=b*b
      sy=engy**2*real(xh)
      imax=nbpDf1
      if(iscreen.eq.0)imax=1
      do i=nbpDf0,imax
        Df=dble(alpD(i,iclegy,iclpro,icltar,icdp,icdt)
     * *real(xh)**alpDp(i,iclegy,iclpro,icltar,icdp,icdt)
     * *sy**(gamD(i,iclegy,iclpro,icltar,icdp,icdt)*b2)
     *            *(engy**2.)**betD(i,iclegy,iclpro,icltar,icdp,icdt)
     *              *exp(-b2/delD(i,iclegy,iclpro,icltar,icdp,icdt)))
        if(abs(alpDpp(i,iclegy,iclpro,icltar,icdp,icdt)).gt.1.e-5)then
          Df=Df/dble(alpDpp(i,iclegy,iclpro,icltar,icdp,icdt))
     *     *(1.d0-xh**dble(alpDpp(i,iclegy,iclpro,icltar,icdp,icdt)))
     *     /dsqrt(xh)**dble(alpDpp(i,iclegy,iclpro,icltar,icdp,icdt))
        else
          Df=-Df*dlog(xh)
        endif
        om1x=om1x+Df
      enddo
      om1x=dble(chad(iclpro)*chad(icltar))/cint
     *         *xh**dble(-alppar)*om1x
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
	      
      return
      end

c----------------------------------------------------------------------

      double precision function om1y(xh,yp,b)
        
c----------------------------------------------------------------------
c Normalised on y omega1 function
c xh - fraction of the energy squared s for the pomeron;
c b - impact parameter between the pomeron ends;
c yp - rapidity for the pomeron;
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      double precision xh,om1,cint,yp,Df 

      cint=0.d0
      b2=b*b
      sy=engy**2*real(xh)
      imax=nbpDf1
      if(iscreen.eq.0)imax=1
      do i=nbpDf0,imax
        Df=dble(alpD(i,iclegy,iclpro,icltar,icdp,icdt)
     * *real(xh)**alpDp(i,iclegy,iclpro,icltar,icdp,icdt)
     * *sy**(gamD(i,iclegy,iclpro,icltar,icdp,icdt)*b2)
     *            *(engy**2.)**betD(i,iclegy,iclpro,icltar,icdp,icdt)
     *              *exp(-b2/delD(i,iclegy,iclpro,icltar,icdp,icdt)))
        if(abs(alpDpp(i,iclegy,iclpro,icltar,icdp,icdt)).gt.1.e-5)then
          Df=Df/dble(alpDpp(i,iclegy,iclpro,icltar,icdp,icdt))
     *   *(1.d0-xh**dble(alpDpp(i,iclegy,iclpro,icltar,icdp,icdt)))
     *   /dsqrt(xh)**dble(alpDpp(i,iclegy,iclpro,icltar,icdp,icdt))
        else
          Df=-Df*dlog(xh)
        endif
        cint=cint+Df
      enddo
      cint=dble(chad(iclpro)*chad(icltar))
     *         *xh**dble(-alppar)*cint
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  

      om1y=om1(xh,yp,b)/cint
	      
      return
      end

c----------------------------------------------------------------------

      double precision function om1xr(b)

c----------------------------------------------------------------------
c Random number generated from the function om1x. We solve the equation
c which give om1xr by Newton-Raphson + secant method.
c b - impact parameter between the pomeron ends;
c----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incsem'
      double precision x,x0,x1,gamomx(nbpDf0:nbpDf1),eps,prec
      double precision xt,fx,fpx,r,f1,f0,cint,deltx,alpp(nbpDf0:nbpDf1)
      double precision delta(nbpDf0:nbpDf1),deltap(nbpDf0:nbpDf1)
     &                ,deltam(nbpDf0:nbpDf1)
      parameter (eps=1.d-20)
 

      om1xr=0.d0
      if(iAGKch.eq.1)return

      s=engy**2
      b2=b*b

      r=dble(rangen())

      imax=nbpDf1
      if(iscreen.eq.0)imax=1
      do i=nbpDf0,imax
        gamomx(i)=dble(chad(iclpro)*chad(icltar)
     &           *gamdp(icdp,iclpro)*gamdt(icdt,icltar)  
     &                *s**(betD(i,iclegy,iclpro,icltar,icdp,icdt)
     &                     +gamD(i,iclegy,iclpro,icltar,icdp,icdt)*b2)
     &                *alpD(i,iclegy,iclpro,icltar,icdp,icdt)
     &               *exp(-b2/delD(i,iclegy,iclpro,icltar,icdp,icdt)))
        deltap(i)=dble(betDp(i,iclegy,iclpro,icltar,icdp,icdt)
     &              +gamD(i,iclegy,iclpro,icltar,icdp,icdt)*b2-alppar)
        deltam(i)=dble(betDpp(i,iclegy,iclpro,icltar,icdp,icdt)
     &              +gamD(i,iclegy,iclpro,icltar,icdp,icdt)*b2-alppar)
        delta(i)=(deltap(i)+deltam(i))/2.d0
        alpp(i)=dble(alpDpp(i,iclegy,iclpro,icltar,icdp,icdt))
         
c Integration possible only if delta(i)>-1

        if(dabs(delta(i)+1.d0).lt.eps)then
          call utstop('Error(1) in nexus-omg in om1xr&')
        endif

      enddo

      cint=0.d0
      do i=nbpDf0,imax
        cint=cint+gamomx(i)/(deltap(i)+1.d0)/(deltam(i)+1.d0)
      enddo
      
         
      x0=2.d0*eps
      x1=1.d0
      f0=0.d0
      f1=0.d0
      do i=nbpDf0,imax
        if(abs(alpDpp(i,iclegy,iclpro,icltar,icdp,icdt)).gt.1.e-5)then
        f0=f0+gamomx(i)/alpp(i)*x0**(delta(i)-alpp(i)/2.d0+1.d0)
     &         *(x0**alpp(i)/(delta(i)+alpp(i)/2.d0+1.d0)
     &           -1.d0/(delta(i)-alpp(i)/2.d0+1.d0))
        f1=f1+gamomx(i)/alpp(i)*x1**(delta(i)-alpp(i)/2.d0+1.d0)
     &       *(x1**alpp(i)/(delta(i)+alpp(i)/2.d0+1.d0)
     &         -1.d0/(delta(i)-alpp(i)/2.d0+1.d0))
        else
        f0=f0+gamomx(i)/(delta(i)+1.d0)*x0**(delta(i)+1.d0)
     &        *(dlog(x0)-1.d0/(delta(i)+1.d0))
        f1=f1+gamomx(i)/(delta(i)+1.d0)*x1**(delta(i)+1.d0)
     &        *(dlog(x1)-1.d0/(delta(i)+1.d0))
        endif
      enddo
      f0=f0/cint+r
      f1=f1/cint+r
      if(f1*f0.gt.eps) call utstop('Error(2) in nexus-omg in om1xr&')
      if(dabs(f0).lt.eps) then
        om1xr=x0
        return
      endif 
      if(dabs(f1).lt.eps) then
        om1xr=x1
        return
      endif 
      x=dsqrt(x1*x0)
      deltx=dabs(x1-x0)  


      ntry=0

 111  continue
      if(ntry.le.1000)then
      fx=0.d0
      fpx=0.d0
      do i=nbpDf0,imax
        if(abs(alpDpp(i,iclegy,iclpro,icltar,icdp,icdt)).gt.1.e-5)then
        fx=fx+gamomx(i)/alpp(i)*x**(delta(i)-alpp(i)/2.d0+1.d0)
     &         *(x**alpp(i)/(delta(i)+alpp(i)/2.d0+1.d0)
     &           -1.d0/(delta(i)-alpp(i)/2.d0+1.d0))
        fpx=fpx+gamomx(i)/alpp(i)*x**(delta(i)-alpp(i)/2.d0)
     &                          *(x**alpp(i)-1.d0)
        else
        fx=fx+gamomx(i)/(delta(i)+1.d0)*x**(delta(i)+1.d0)
     &        *(dlog(x)-1.d0/(delta(i)+1.d0))
        fpx=fpx+gamomx(i)*x**delta(i)*dlog(x)
        endif
      enddo
      fx=fx/cint+r
      fpx=fpx/cint
      xt=x-fx/fpx
      
      if (f0*fx.lt.-eps) then
        f1=fx
        x1=x
      else
        f0=fx
        x0=x
      endif
      if ((xt.lt.x0-eps.or.xt.gt.x1+eps).and.dabs(f1-f0).gt.eps) then
        xt=x1-f1*(x1-x0)/(f1-f0)
      endif

       else

        write(ifmt,*)'Warning in om1xr, to much try !'

      endif


      if(dabs(x-xt).gt.deltx/2.d0) then
        xt=(x1+x0)/2.D0
      endif
      deltx=dabs(x-xt)
      if(dabs(x).gt.eps)then
        prec=deltx/x
      else
        call utstop('Problem in om1xr&')
      endif

      if(prec.gt.1.d-3.and.dabs(f1-f0).gt.eps.and.ntry.le.1000)then
	 x=xt
	 ntry=ntry+1
         goto 111
      endif
      
      om1xr=x

      return
      end	

c----------------------------------------------------------------------

      double precision function om1yr(xh,b)

c----------------------------------------------------------------------
c Random number generated from the function om1y(y). We solve the 
c equation which give om1yr by Newton-Raphson + secant method.
c xh - fraction of the energy squared s for the pomeron;
c b - impact parameter between the pomeron ends;
c----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incsem'

      double precision xh,y0,y1,y,gamomy(nbpDf0:nbpDf1),eps,ymin
     &                ,alpp(nbpDf0:nbpDf1)
      double precision yt,fy,fpy,r,f1,f0,cint,dely,prec
      parameter (eps=1.d-20)

      ymin=0.5d0*dlog(xh)
      s=engy**2
      b2=b*b
      imax=nbpDf1
      
      r=dble(rangen())

      if(iscreen.eq.0)then
        om1yr=(0.5d0-r)*dlog(xh)
      else

      do i=nbpDf0,imax
        gamomy(i)=dble(chad(iclpro)*chad(icltar)
     &           *gamdp(icdp,iclpro)*gamdt(icdt,icltar)  
     &           *s**(betD(i,iclegy,iclpro,icltar,icdp,icdt)
     &           +gamD(i,iclegy,iclpro,icltar,icdp,icdt)*b2)
     &               *alpD(i,iclegy,iclpro,icltar,icdp,icdt)
     &   *real(xh)**(alpDp(i,iclegy,iclpro,icltar,icdp,icdt)
     &    +gamD(i,iclegy,iclpro,icltar,icdp,icdt)*b2-alppar)
     &     *exp(-b2/delD(i,iclegy,iclpro,icltar,icdp,icdt)))
        alpp(i)=dble(alpDpp(i,iclegy,iclpro,icltar,icdp,icdt))
      enddo

      cint=0.d0
      do i=nbpDf0,imax
        if(dabs(alpp(i)).gt.1.d-10)then
          cint=cint-gamomy(i)/alpp(i)*xh**(alpp(i)/2.d0)
     &                               *(1.d0-xh**(-alpp(i)))
        else
          cint=cint-gamomy(i)*dlog(xh)
        endif
      enddo
         
      y0=ymin
      y1=-ymin
      f0=0.d0
      f1=0.d0
      do i=nbpDf0,imax
        if(abs(alpDpp(i,iclegy,iclpro,icltar,icdp,icdt)).gt.1.e-5)then
        f0=f0+gamomy(i)/alpp(i)*(dsqrt(xh)**alpp(i)-dexp(alpp(i)*y0))
        f1=f1+gamomy(i)/alpp(i)*(dsqrt(xh)**alpp(i)-dexp(alpp(i)*y1))
        else
        f0=f0+gamomy(i)*(dlog(xh)/2.d0-y0)
        f1=f1+gamomy(i)*(dlog(xh)/2.d0-y1)
        endif
      enddo
      f0=f0/cint+r
      f1=f1/cint+r
      if(f1*f0.gt.eps)call utstop('Error in nexus-omg in om1yr&')
      if(dabs(f0).lt.eps) then
        om1yr=y0
        return
      endif 
      if(dabs(f1).lt.eps) then
        om1yr=y1
        return
      endif 
      y=(y1+y0)/2.D0
      dely=dabs(y1-y0)  


      ntry=0

 111  continue
      if(ntry.le.1000)then
      fy=0.d0
      fpy=0.d0
      do i=nbpDf0,imax
        if(abs(alpDpp(i,iclegy,iclpro,icltar,icdp,icdt)).gt.1.e-5)then
        fy=fy+gamomy(i)/alpp(i)*(dsqrt(xh)**alpp(i)-dexp(alpp(i)*y))
        fpy=fpy-gamomy(i)*dexp(alpp(i)*y)
        else
        fy=fy+gamomy(i)*(dlog(xh)/2.d0-y)
        fpy=fpy-gamomy(i)
        endif
      enddo
      fy=fy/cint+r
      fpy=fpy/cint
      yt=y-fy/fpy
      
      if (f0*fy.lt.-eps) then
        f1=fy
        y1=y
      else
        f0=fy
        y0=y
      endif
      if ((yt.lt.y0-eps.or.yt.gt.y1+eps).and.dabs(f1-f0).gt.eps) then
        yt=y1-f1*(y1-y0)/(f1-f0)
      endif

      else

        write(ifmt,*)'Warning in om1yr, to much try !'

      endif

      if(dabs(y-yt).gt.dely/2.d0) then
        yt=(y1+y0)/2.D0
      endif
      dely=dabs(y-yt)  
      if(dabs(y).gt.eps)then
        prec=dely/dabs(y)
      else
        prec=dely
      endif

      if (prec.gt.1.d-3.and.dabs(f1-f0).gt.eps.and.ntry.le.1000) then
	 y=yt
	 ntry=ntry+1
         goto 111
      endif
      
      om1yr=y

      endif

      return
      end	

c----------------------------------------------------------------------

      double precision function om1intb(b)

c----------------------------------------------------------------------
c  Set integrated over xp and xm (x and y) omega1 for a given b
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      double precision cint,gamom,deltap,deltam
      double precision eps,ds
      parameter(eps=1.d-20)
      

c Calculation by analytical integration (perfect but it changes if om1 change):
      s=engy*engy
      ds=100.d0*dble(s)
      b2=b*b
      imax=nbpDf1
      if(iscreen.eq.0)imax=1
      cint=0.d0
      do i=nbpDf0,imax
        gamom=dble(chad(iclpro)*chad(icltar)
     &                *s**(betD(i,iclegy,iclpro,icltar,icdp,icdt)
     &                     +gamD(i,iclegy,iclpro,icltar,icdp,icdt)*b2)
     &                *alpD(i,iclegy,iclpro,icltar,icdp,icdt)
     &                *exp(-b2/delD(i,iclegy,iclpro,icltar,icdp,icdt)))
        deltap=dble(betDp(i,iclegy,iclpro,icltar,icdp,icdt)
     &                +gamD(i,iclegy,iclpro,icltar,icdp,icdt)*b2-alppar)
        deltam=dble(betDpp(i,iclegy,iclpro,icltar,icdp,icdt)
     &                +gamD(i,iclegy,iclpro,icltar,icdp,icdt)*b2-alppar)

         
c Integration possible only if delta(i)>-1

        if(deltap+1.d0.gt.eps.or.deltam+1.d0.gt.eps)then
          cint=cint+gamom/(deltap+1.d0)/(deltam+1.d0)
        
        elseif(iAGKch.eq.1)then
c For theory check
          cint=cint+gamom*(dlog(ds)-1.d0)**2.d0
        else
          call utstop('Error in nexus-omg in om1intb&') 
        endif

      enddo

      if(cint.lt.-eps)then
        write(*,*) 'WARNING ! om1intb in nexus-omg is <0 !!!!!'
        write(*,*) 'WARNING ! => om1intb set to 1e-3 !!!!!'
        write(*,*) 'WARNING ! => bmax=3.5 fm !!!!!'
        cint=1.d-3
      endif

      om1intb=cint
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
	
      return 
      end


c----------------------------------------------------------------------

      double precision function om1intbc(b)

c----------------------------------------------------------------------
c  Set integrated over xp and xm (x and y) omega1*F*F for a given b
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      double precision cint,gamom,deltap,deltam
      double precision utgam2,Fp,Fm,eps,ds
      parameter(eps=1.d-20)


c Calculation by analytical integration (perfect but it changes if om1 change):
      s=engy**2
      ds=100.d0*dble(s)
      b2=b*b
      om1intbc=0.d0
      Fp=utgam2(1.d0+dble(alplea(iclpro)))
      Fm=utgam2(1.d0+dble(alplea(icltar)))

      imax=nbpDf1
      if(iscreen.eq.0)imax=1



      do iicdp=icdp1,icdp2
      do iicdt=icdt1,icdt2

      cint=0.d0
        
      do i=nbpDf0,imax
        gamom=dble(chad(iclpro)*chad(icltar)
     &                *s**(betD(i,iclegy,iclpro,icltar,iicdp,iicdt)
     &                     +gamD(i,iclegy,iclpro,icltar,iicdp,iicdt)*b2)
     &                *alpD(i,iclegy,iclpro,icltar,iicdp,iicdt)
     &               *exp(-b2/delD(i,iclegy,iclpro,icltar,iicdp,iicdt)))
        deltap=dble(betDp(i,iclegy,iclpro,icltar,iicdp,iicdt)
     &              +gamD(i,iclegy,iclpro,icltar,iicdp,iicdt)*b2-alppar)
        deltam=dble(betDpp(i,iclegy,iclpro,icltar,iicdp,iicdt)
     &              +gamD(i,iclegy,iclpro,icltar,iicdp,iicdt)*b2-alppar)


c For theory check

      if(iAGKch.eq.1)then
        om1intbc=gamom*(dlog(ds)-1.d0)**2.d0
        return
      endif

      if(deltap+1.d0.lt.eps.or.deltam+1.d0.lt.eps)call utstop
     &  ('Error in nexus-omg-300 in om1intbc&') 


        cint=cint+gamom*utgam2(deltap+1.d0)*utgam2(deltam+1.d0)
     &            /utgam2(2.d0+deltap+dble(alplea(iclpro)))
     &            /utgam2(2.d0+deltam+dble(alplea(icltar)))
      enddo


      om1intbc=om1intbc+cint*Fp*Fm
     *  *dble(gamdp(iicdp,iclpro)*gamdt(iicdt,icltar))  
      enddo
      enddo
      
      if(om1intbc.lt.-1.d-10)then
        write(*,*) 'WARNING ! om1intbc in nexus-omg is <0 !!!!!'
        write(*,*) 'WARNING ! => om1intbc set to 0. !!!!!'
c$$$        write(*,*)chad(iclpro),chad(icltar),gamdp(icdp,iclpro),b
c$$$     *,alpD(1,iclegy,iclpro,icltar,2,2),gamdt(icdt,icltar),iclegy
c$$$     *,deltap,deltam,gamom,Fp,Fm,iclpro,icltar,icdp1,icdp2,icdt1,icdt2 
        om1intbc=0.d0
      endif
	
      return 
      end

c----------------------------------------------------------------------

      double precision function gtilde(xp,xm,k)

c----------------------------------------------------------------------
c function g_tilde
c xp,xm - fraction of the energy ;
c k - collision
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incems'
      common/cgtilde/atilde(ntymi:ntymx,kollmx)
     &,btildep(ntymi:ntymx,kollmx),btildepp(ntymi:ntymx,kollmx)
     &              ,atildg(nbpDf0:nbpDf1,kollmx)
     &,btildgp(nbpDf0:nbpDf1,kollmx),btildgpp(nbpDf0:nbpDf1,kollmx)
      double precision atilde,btildep,btildepp,atildg,btildgp,btildgpp
      double precision xp,xm
      
      gtilde=0.d0
      imax=nbpDf1
      if(iscreen.eq.0)imax=1
      do i=nbpDf0,imax
        gtilde=gtilde+atildg(i,k)*xp**btildgp(i,k)*xm**btildgpp(i,k)
      enddo
      
      gtilde=trieff(k)*gtilde
	
      return
      end

c----------------------------------------------------------------------

      subroutine gtildepar(irea)

c----------------------------------------------------------------------
c calculates parameters for gtilde only if irea=0
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      include 'nexus.incems'
      common /psar7/ delx,alam3p,gam3p
      common/cgtilde/atilde(ntymi:ntymx,kollmx)
     &,btildep(ntymi:ntymx,kollmx),btildepp(ntymi:ntymx,kollmx)
     &              ,atildg(nbpDf0:nbpDf1,kollmx)
     &,btildgp(nbpDf0:nbpDf1,kollmx),btildgpp(nbpDf0:nbpDf1,kollmx)
      double precision atilde,btildep,btildepp,atildg,btildgp,btildgpp
      double precision alp1,alp2,alp3,alp4,del1,del2,del3,del4
      double precision utgam2,dsy,alp,dps,coefgdp,coefgdt,ddelx
      double precision gamtp,gamtm,gamtpp,gamtmp,Mgamtp,Mgamtm
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /kfitd/ xkappafit(nclegy,nclha,nclha,2,2,20),bkbin
      common /coefgam/coefgamtp(kllmxg),coefgamtm(kllmxg)
     &,coefgamtpp(kllmxg),coefgamtmp(kllmxg)
     &,coefMgamtp(kllmxg,0:npmxg,0:npmxg)
     &,coefMgamtm(kllmxg,0:npmxg,0:npmxg)
     &,coefMgambetp(kllmxg,nbpDf0:nbpDf1,0:npmxg,0:npmxg)
     &,coefMgambetpp(kllmxg,nbpDf0:nbpDf1,0:npmxg,0:npmxg)
     &,coefMgambet2p(kllmxg,nbpDf0:nbpDf1,nbpDf0:nbpDf1,0:npmxg,0:npmxg)
     &,coefMgambet2pp(kllmxg,nbpDf0:nbpDf1,nbpDf0:nbpDf1,0:npmxg
     &,0:npmxg)
      double precision coefgamtp,coefgamtm,coefgamtpp,coefgamtmp
     &,coefMgamtp,coefMgamtm,coefMgambetp
     &,coefMgambetpp,coefMgambet2p,coefMgambet2pp
      common /cgtilnu/ cfbetpnp,cfbetppnp,cfbetpnm,cfbetppnm,cfalpro
     &,cfaltar,cfbpap,cfbpam,cfbppap,cfbppam
      double precision cfbetpnp,cfbetppnp,cfbetpnm,cfbetppnm,cfalpro
     &,cfaltar,cfbpap,cfbpam,cfbppap,cfbppam

      if(ish.ge.2.and.kllmxg.lt.koll)write(ifch,*)
     * 'Warning in gtildepar kllmxg<koll'

      cfbetpnp=0.d0
      cfbetppnp=0.d0
      cfbetpnm=0.d0
      cfbetppnm=0.d0
      cfalpro=utgam2(1.d0+dble(alplea(iclpro)))
      cfaltar=utgam2(1.d0+dble(alplea(icltar)))
      cfbpap=1.d0
      cfbppap=1.d0
      cfbpam=1.d0
      cfbppam=1.d0
      sy=engy*engy
      dsy=dble(sy)
      ddelx=dble(delx)


      do k=1,koll
        do i=ntymi,ntymx
          atilde(i,k)=0.d0
          btildep(i,k)=0.d0
          btildepp(i,k)=0.d0
        enddo
        do i=nbpDf0,nbpDf1
          atildg(i,k)=0.d0
          btildgp(i,k)=0.d0
          btildgpp(i,k)=0.d0
        enddo
      enddo
        
      if(irea.eq.0.and.koll.gt.klllim.and.koll.le.kllmxg)then

        npmax=npmxg
        if(sy.le.1.E4.and.npmxg.ge.5)npmax=5
        if(sy.le.1.E6.and.npmxg.ge.10)npmax=10
        if(sy.le.1.E8.and.npmxg.ge.15)npmax=15

        do m2=0,npmax
          do m1=0,npmax-m2
            do k=1,koll
              coefMgamtp(k,m1,m2)=0.d0
              coefMgamtm(k,m1,m2)=0.d0
            enddo
            do i=nbpDf0,nbpDf1
              do k=1,koll
                coefMgambetp(k,i,m1,m2)=0.d0
                coefMgambetpp(k,i,m1,m2)=0.d0
              enddo
            enddo
            do j=nbpDf0,nbpDf1
              do i=nbpDf0,nbpDf1
                do k=1,koll
                  coefMgambet2p(k,i,j,m1,m2)=0.d0
                  coefMgambet2pp(k,i,j,m1,m2)=0.d0
                enddo
              enddo
            enddo
          enddo
        enddo
      endif

      do k=1,koll

	b2=bk(k)*bk(k)
        ip=iproj(k)
        it=itarg(k)
        iicdp=icddp(ip)
        iicdt=icddt(it)
        
        if(xkappafit(iclegy,iclpro,icltar,iicdp,iicdt,1).gt.1.
     *     .and.bk(k).lt.19.*bkbin)then
          ibk=int(bk(k)/bkbin)+1
          egy0=egylow*egyfac**real(iclegy)
          xkappa1=xkappafit(iclegy,iclpro,icltar,iicdp,iicdt,ibk)
     *         +(bk(k)-bkbin*real(ibk-1))/bkbin
     *         *(xkappafit(iclegy,iclpro,icltar,iicdp,iicdt,ibk+1)
     *         -xkappafit(iclegy,iclpro,icltar,iicdp,iicdt,ibk))
          xkappa2=xkappafit(iclegy+1,iclpro,icltar,iicdp,iicdt,ibk)
     *         +(bk(k)-bkbin*real(ibk-1))/bkbin
     *         *(xkappafit(iclegy+1,iclpro,icltar,iicdp,iicdt,ibk+1)
     *         -xkappafit(iclegy+1,iclpro,icltar,iicdp,iicdt,ibk))
          xkappa=xkappa1+(xkappa2-xkappa1)/(egy0*(egyfac-1.))
     *         *(sqrt(sy)-egy0)
        else
          xkappa=1.
        endif

        imax=nbpDf1
        if(iscreen.eq.0)then
          imax=1
          if(koll.gt.klllim.and.koll.le.kllmxg)then
            coefMgamtp(k,0,0)=cfalpro
            coefMgamtm(k,0,0)=cfaltar
            coefgamtp(k)=1.d0
            coefgamtm(k)=1.d0
            coefgamtpp(k)=1.d0
            coefgamtmp(k)=1.d0
          endif
        endif
        do i=nbpDf0,imax
          gamb=gamD(i,iclegy,iclpro,icltar,iicdp,iicdt)*b2
          btildgp(i,k)=dble(betDp(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *                    +gamb-alppar)+1.d0
          btildgpp(i,k)=dble(betDpp(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *                    +gamb-alppar)+1.d0
          coefgdp=utgam2(1.d0+dble(alplea(iclpro))+btildgp(i,k))
          coefgdt=utgam2(1.d0+dble(alplea(icltar))+btildgpp(i,k))
          atildg(i,k)=dble(alpD(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *              *chad(iclpro)*chad(icltar)
     *              *exp(-b2/delD(i,iclegy,iclpro,icltar,iicdp,iicdt))
     *              *sy**(betD(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *                    +gamb))
          if(iAGKch.eq.1)then
          atildg(i,k)=atildg(i,k)*(dlog(dble(100.*sy))-1.d0)**2.d0
          else
          atildg(i,k)=atildg(i,k)*dble(xkappa*xkappa)
     *              *utgam2(btildgp(i,k))*utgam2(btildgpp(i,k))
     *              *cfalpro/coefgdp
     *              *cfaltar/coefgdt
          endif
          if(koll.gt.klllim.and.iscreen.eq.0
     *       .and.koll.le.kllmxg)then
            coefMgambetp(k,i,0,0)=coefgdp
            coefMgambetpp(k,i,0,0)=coefgdt
          endif
        enddo
      enddo
      if(koll.gt.klllim.and.koll.le.kllmxg)then
        do j=nbpDf0,imax
          do i=nbpDf0,imax
            do k=1,koll
              coefMgambet2p(k,i,j,0,0)=
     *   utgam2(1.d0+dble(alplea(iclpro))+btildgp(i,k)+btildgp(j,k))
              coefMgambet2pp(k,i,j,0,0)=
     *   utgam2(1.d0+dble(alplea(icltar))+btildgpp(i,k)+btildgpp(j,k))
            enddo
          enddo
        enddo
      endif

      if(irea.eq.0)then
      do k=1,koll

        b2=bk(k)*bk(k)
        do i=ntymi,1

          gamb=gamD(i,iclegy,iclpro,icltar,iicdp,iicdt)*b2

          atilde(i,k)=dble(alpD(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *              *exp(-b2/delD(i,iclegy,iclpro,icltar,iicdp,iicdt))
     *              *sy**(betD(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *                    +gamb)
     *              *chad(iclpro)*chad(icltar)
     *              *gamdp(iicdp,iclpro)*gamdt(iicdt,icltar))  
          btildep(i,k)=dble(betDp(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *                    +gamb-alppar)
          btildepp(i,k)=dble(betDpp(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *                    +gamb-alppar)

          if(iAGKch.eq.1)then
            btildep(i,k)=-1.d0
            btildepp(i,k)=-1.d0
          endif

        enddo

        if(iscreen.ne.0)then

          gamb=gamD(1,iclegy,iclpro,icltar,iicdp,iicdt)*b2
          alp=dble(exp(-b2/delD(1,iclegy,iclpro,icltar,iicdp,iicdt))
     *            *chad(iclpro)*chad(icltar)
     *            *gamdp(iicdp,iclpro)*gamdt(iicdt,icltar)) 
          betv=xnu(iclegy,iclpro)+gamb/2.
          del1=dble(betD1(1,iclegy,iclpro)+betv)
          alp1=dble(betDp1(1,iclegy,iclpro)-alppar)
     *         +dble(xnup(iclegy,iclpro))
          del2=dble(betD1(1,iclegy,icltar)+betv)
          alp2=dble(betDp1(1,iclegy,icltar)-alppar)
     *         +dble(xnup(iclegy,icltar))
          coefgdp=utgam2(1.d0+alp1+del1)**2.d0
     *         /utgam2(2.d0*(1.d0+alp1+del1))
          coefgdt=utgam2(1.d0+alp2+del2)**2.d0
     *         /utgam2(2.d0*(1.d0+alp2+del2))
          del3=dble(betD1(1,iclegy,icltar)+gamb)
          alp3=dble(betDp1(1,iclegy,icltar)-alppar)
     &         +dble(xnum(iclegy,icltar))
          del4=dble(betD1(1,iclegy,iclpro)+gamb)
          alp4=dble(betDp1(1,iclegy,iclpro)-alppar)
     &         +dble(xnum(iclegy,iclpro))
          dps=dlog(max(1.d0,dsy/ddelx/ddelx))

c Y screening +                                          
          atilde(2,k)=cYscr/coefgdp*dsy**del3*alp*dble(xmu(1))
          btildep(2,k)=alp1+del1
          btildepp(2,k)=alp3+del3
          
c Y screening -
          atilde(3,k)=cYscr/coefgdt*dsy**del4*alp*dble(xmu(1))
          btildep(3,k)=alp4+del4
          btildepp(3,k)=alp2+del2
          
c X screening +&-
          atilde(4,k)=cXscr/coefgdp/coefgdt*dsy**(2.d0*del2)
     &               *alp*dble(xmu(2))
          btildep(4,k)=alp1+del1
          btildepp(4,k)=alp2+del2
          
c Y cut +
          atilde(5,k)=cYfus*dsy**del3*alp*dble(xmu(1))
          btildep(5,k)=1.d0+2.d0*(alp1+del1)
          btildepp(5,k)=alp3+del3
          
c X screening -
          atilde(6,k)=cXfus/coefgdt*dsy**(2.d0*del2)
     &               *alp*dble(xmu(2))
          btildep(6,k)=1.d0+2.d0*(alp1+del1)
          btildepp(6,k)=alp2+del2
          
c Y cut -
          atilde(7,k)=cYfus*dsy**del4*alp*dble(xmu(1))
          btildep(7,k)=alp4+del4
          btildepp(7,k)=1.d0+2.d0*(alp2+del2)

c X screening +
          atilde(8,k)=cXfus/coefgdp*dsy**(2.d0*del2)
     &               *alp*dble(xmu(2))
          btildep(8,k)=alp1+del1
          btildepp(8,k)=1.d0+2.d0*(alp2+del2)
                    
c Y diffr +
          atilde(9,k)=cYdif*dsy**del3*alp*dble(xmu(1))/dps
          btildep(9,k)=-1.d0
          btildepp(9,k)=alp3+del3
          
c X diffr +
          atilde(10,k)=cXdif/coefgdt*dsy**(2.d0*del2)/dps
     &               *alp*dble(xmu(2))
          btildep(10,k)=-1.d0
          btildepp(10,k)=alp2+del2
                    
c Y diffr -
          atilde(11,k)=cYdif*dsy**del4*alp*dble(xmu(1))/dps
          btildep(11,k)=alp4+del4
          btildepp(11,k)=-1.d0

c X diffr +
          atilde(12,k)=cXdif/coefgdp*dsy**(2.d0*del2)/dps
     &               *alp*dble(xmu(2))
          btildep(12,k)=alp1+del1
          btildepp(12,k)=-1.d0
                    
c Y diffr + nucl
          atilde(13,k)=atilde(9,k)
          btildep(13,k)=btildep(9,k)
          btildepp(13,k)=btildepp(9,k)

c Y diffr - nucl
          atilde(14,k)=atilde(11,k)
          btildep(14,k)=btildep(11,k)
          btildepp(14,k)=btildepp(11,k)

c Y sha +- nucl soft

          atilde(17,k)=dble(alpD2(1,iclegy)*sy**betD2(1,iclegy)
     *                    *exp(-b2/delD2(1,iclegy))
     *                    *chad(iclpro)*chad(icltar))
          btildep(17,k)=dble(betD2(1,iclegy)-alppar)
          btildepp(17,k)=dble(betD2(1,iclegy)-alppar)

c Y sha +- nucl semi-hard

          atilde(18,k)=dble(alpD2(2,iclegy)*sy**betD2(2,iclegy)
     *                    *exp(-b2/delD2(2,iclegy))
     *                    *chad(iclpro)*chad(icltar))
          btildep(18,k)=dble(betD2(2,iclegy)-alppar)
          btildepp(18,k)=dble(betD2(2,iclegy)-alppar)


          if(k.eq.1.and.koll.gt.1)then                      ! for om3
            del1=dble(-xnu(iclegy,iclpro))
            del2=dble(-xnu(iclegy,icltar))
            del3=dble(betD1(1,iclegy,icltar))
            del4=dble(betD1(1,iclegy,iclpro))
            cfbetpnp=utgam2(1.d0+alp1+del1)
            cfbetppnm=utgam2(1.d0+alp3+del3)
            cfbetpnm=utgam2(1.d0+alp2+del2)
            cfbetppnp=utgam2(1.d0+alp4+del4)
            cfbpap=utgam2(2.d0+dble(alplea(iclpro))+alp1+del1)
            cfbpam=utgam2(2.d0+dble(alplea(icltar))+alp2+del2)
            cfbppap=utgam2(2.d0+dble(alplea(iclpro))+alp4+del4)
            cfbppam=utgam2(2.d0+dble(alplea(icltar))+alp3+del3)
          endif
        endif
      enddo

      if(koll.gt.klllim.and.iscreen.ne.0.and.koll.le.kllmxg)then ! for PhiExpoMk

        do k=1,koll
          gamb=gamD(1,iclegy,iclpro,icltar,iicdp,iicdt)*bk(k)*bk(k)
          gamtp=1.d0
     &  +dble(xnup(iclegy,iclpro)-xnu(iclegy,iclpro)+gamb/2.-alppar)
          gamtm=1.d0
     &  +dble(xnup(iclegy,icltar)-xnu(iclegy,icltar)+gamb/2.-alppar)
          gamtpp=2.d0*gamtp
          gamtmp=2.d0*gamtm

          coefgamtp(k)=utgam2(gamtp)
          coefgamtm(k)=utgam2(gamtm)
          coefgamtpp(k)=utgam2(gamtpp)
          coefgamtmp(k)=utgam2(gamtmp)

          do m2=0,npmax
            do m1=0,npmax-m2
              Mgamtp=dble(m1)*gamtp+dble(m2)*gamtpp
              Mgamtm=dble(m1)*gamtm+dble(m2)*gamtmp
            coefMgamtp(k,m1,m2)=utgam2(1.d0+dble(alplea(iclpro))+Mgamtp)
            coefMgamtm(k,m1,m2)=utgam2(1.d0+dble(alplea(icltar))+Mgamtm)
              do i=nbpDf0,nbpDf1
                coefMgambetp(k,i,m1,m2)=
     *             utgam2(1.d0+dble(alplea(iclpro))+btildgp(i,k)+Mgamtp)
                coefMgambetpp(k,i,m1,m2)=
     *            utgam2(1.d0+dble(alplea(icltar))+btildgpp(i,k)+Mgamtm)

                do j=nbpDf0,nbpDf1
                  coefMgambet2p(k,j,i,m1,m2)=
     *            utgam2(1.d0+dble(alplea(iclpro))+btildgp(i,k)
     *                                             +btildgp(j,k)+Mgamtp)
                  coefMgambet2pp(k,j,i,m1,m2)=
     *            utgam2(1.d0+dble(alplea(icltar))+btildgpp(i,k)
     *                                            +btildgpp(j,k)+Mgamtm)
                enddo
              enddo
            enddo
          enddo
        enddo
      endif
      endif

      if(ish.ge.8)then
      do k=1,koll
        write(ifch,*)'*******************************************'
        write(ifch,*)'cf',cfbetpnp,cfbetppnp,cfbetpnm,cfbetppnm,cfalpro
     &,cfaltar,cfbpap,cfbpam,cfbppap,cfbppam
        write(ifch,*)'*******************************************'
        do i=ntymi,ntymx
        write(ifch,*)k,i," atilde,btildep,btildepp ",atilde(i,k)
     &                          ,btildep(i,k),btildepp(i,k),' b ',bk(k)
        enddo
      enddo
      endif
      	
      	
      return
      end


c----------------------------------------------------------------------

	subroutine integom1(irea)

c----------------------------------------------------------------------
c  Set integrated over xp and xm omega1 for different b if irea=0
c----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incems'
      include 'nexus.incsem'
      common/cgtilde/atilde(ntymi:ntymx,kollmx)
     &,btildep(ntymi:ntymx,kollmx),btildepp(ntymi:ntymx,kollmx)
     &              ,atildg(nbpDf0:nbpDf1,kollmx)
     &,btildgp(nbpDf0:nbpDf1,kollmx),btildgpp(nbpDf0:nbpDf1,kollmx)
      double precision atilde,btildep,btildepp,atildg,btildgp,btildgpp
      double precision om1intb,om1intbc
      double precision omI,omYp,omYm,omNcutIJb,omNgam
     * ,omGamint13,omGamint14,omGamint17,omGamint18,omNgamint
     * ,omNgamx1,omNgamx3,omNgamx4,omGamint,cint,dps
     * ,omNgamx0,omNgamx5,omNgamx7,omGamintup,omGamintum
     * ,w(0:4),omNgamintb,shaeff,eps
      parameter(eps=1.d-20)
      common/cncl2/diffbpr(mamx,mamx),diffbtg(mamx,mamx)
      common /psar7/  delx,alam3p,gam3p
      common /omNfac/ facOmNp(4,4,4),facOmNm(4,4,4)
      double precision facOmNp,facOmNm

      call utpri('intom1',ish,ishini,5)

      if(irea.eq.0)then

      icdps=icdp
      icdts=icdt
      icdpl1s=icdpl1
      icdtl1s=icdtl1
      koll0=0
      koll1=0

      do i1=1,4
      do i2=1,4
      do i3=1,4
        facOmNp(i3,i2,i1)=1.d0
        facOmNm(i3,i2,i1)=1.d0
      enddo
      enddo
      enddo

      if(koll.gt.1.and.inueff.eq.1)then
        omNgamx0=omNgamint(0)
        omNgamx1=omNgamint(1)
        call WomTyN(w,2)
        if(ish.ge.4)write(ifch,*)'omNgmax +',w
        omNgamx3=omNgam(1)
        omNgamx4=omNgamint(4)
        omNgamx5=omNgamint(5)
        call WomTyN(w,6)
        if(ish.ge.4)write(ifch,*)'omNgmax -',w
        omNgamx7=omNgam(2)
      endif

      do k=1,koll 

        ip=iproj(k)
        it=itarg(k)
        icdp=icddp(ip)
        icdt=icddt(it)

        trieff(k)=1.d0
        shaeffsf(k)=0.d0
        shaeffsh(k)=0.d0
        difefp(k)=0.d0
        difefm(k)=0.d0
        om1int(k)=om1intb(bk(k))
        om1intc(k)=om1intbc(bk(k))
        wallgr(k)=om1int(k)

      
        wnoleg(k)=0.d0
        do iqq=1,ngrmx
          wgrp(k,iqq)=0.d0
        enddo


          wgrp(k,1)=om1int(k)
          
          if(iscreen.ne.0)then              ! only if enhanced diagram

           wallgr(k)=0.d0
           dps=dlog(dble(engy*engy)/dble(delx*delx))

            omGamintup=0.d0
            omGamintum=0.d0
            omGamint13=0.d0
            omGamint14=0.d0
            omGamint17=0.d0
            omGamint18=0.d0
            shaeff=0.d0

            if(koll.gt.1.and.inueff.eq.1)then   
                                       ! nuclear shadowing (if not pp)

              do lp=1,ltarg3(it)
                kt=ktarg3(it,lp)
                if(kt.ne.k)then
                  ipp=iproj(kt)
                  icdpl1=icddp(ipp)
                  bkkt=diffbpr(ip,ipp)
                  omGamintup=omGamintup+omNgamintb(bk(k),bk(kt),bkkt,1)
                  omGamint17=omGamint17
     &                      +omNcutIJb(bk(k),bk(kt),bkkt,2,2,2,3,2,2,1)
                  omGamint18=omGamint18
     &                      +omNcutIJb(bk(k),bk(kt),bkkt,2,2,2,3,3,3,1)
     &                      +omNcutIJb(bk(k),bk(kt),bkkt,3,3,2,3,2,2,1)
c     &                      +omNcutIJb(bk(k),bk(kt),bkkt,3,3,2,3,3,3,1)

                endif
              enddo


              omGamint13=omGamintup*omNgamx1
              shaeff=shaeff+omGamintup*omNgamint(2)
              omGamintup=omGamintup*omNgamx0

              do lt=1,lproj3(ip)
                kp=kproj3(ip,lt)
                if(kp.ne.k)then
                  itt=itarg(kp)
                  icdtl1=icddt(itt)
                  bkkp=diffbtg(it,itt)
                  omGamintum=omGamintum+omNgamintb(bk(k),bk(kp),bkkp,2)
                  omGamint17=omGamint17
     &                      +omNcutIJb(bk(k),bk(kp),bkkp,2,2,2,3,2,2,2)
                  omGamint18=omGamint18
     &                      +omNcutIJb(bk(k),bk(kp),bkkp,2,2,2,3,3,3,2)
     &                      +omNcutIJb(bk(k),bk(kp),bkkp,3,3,2,3,2,2,2)
c     &                      +omNcutIJb(bk(k),bk(kp),bkkp,3,3,2,3,3,3,2)
                endif
              enddo


              omGamint14=omGamintum*omNgamx5
              shaeff=shaeff+omGamintum*omNgamint(6)
              omGamintum=omGamintum*omNgamx4


              if(dabs(omGamint17+omGamint18).gt.eps)
     &        shaeff=shaeff/(omGamint17+omGamint18)


            endif

            omI=omGamint(bk(k),1)
            omYp=omGamint(bk(k),2)
            omYm=omGamint(bk(k),3)
            omGamint17=shaeff*omGamint17 
            omGamint18=shaeff*omGamint18

            wgrp(k,1)=omI+omYp+omYm+omGamint17+omGamint18


            if(dabs(cYfus).gt.0.d0.or.dabs(cXfus).gt.0.d0)then
            wgrp(k,2)=omGamint(bk(k),5)+omGamint(bk(k),6)
            wgrp(k,3)=omGamint(bk(k),7)+omGamint(bk(k),8)
            endif

            if(dabs(cYdif).gt.0.d0.or.dabs(cXdif).gt.0.d0)then
            omYp=omGamint(bk(k),9)
            wgrp(k,4)=omYp+omGamint13

            omYm=omGamint(bk(k),11)
            wgrp(k,5)=omYm+omGamint14

            difefp(k)=omGamint13/omYp
            difefm(k)=omGamint14/omYm
            endif


c Effective weight for nuclear effect

            shaeffsf(k)=omGamint17/omGamint(bk(k),17)
            shaeffsh(k)=omGamint18/omGamint(bk(k),18)

            trieff(k)=1.d0+(omGamintup+omGamintum)/om1intc(k)

            if(ish.ge.5)then
            write(ifch,*)'sha= ',wgrp(k,1)/(wgrp(k,1)+wgrp(k,2)
     &   +wgrp(k,3)+wgrp(k,4)+wgrp(k,5)),trieff(k),bk(k),shaeff
     &   ,shaeffsf(k),shaeffsh(k),difefp(k),difefm(k)
            endif
            
            if(wgrp(k,1).lt.eps.and.inueff.ne.0)then
              if(ish.ge.2)then
              write(ifch,*)'WARNING : nuclear shadowing too big !'
              write(ifch,*)'sha',shaeffsf(k),shaeffsh(k),wgrp(k,1),bk(k)
              endif
              koll0=koll0+1
              shaeff=omGamint18/omGamint17
              shaeffsf(k)=-(wgrp(k,1)-omGamint17-omGamint18)/shaeff
              shaeffsf(k)=shaeffsf(k)/omGamint(bk(k),17)
              shaeffsh(k)=shaeffsf(k)*shaeff
              if(shaeffsf(k).gt.eps.or.shaeffsh(k).gt.eps)
     &                       write(ifmt,*)'shadowing in integom1 ???'
              wgrp(k,1)=0.d0 
       if(ish.ge.2)write(ifch,*)'sha=',shaeffsf(k),shaeffsh(k),wgrp(k,1)
            endif
            if(difefp(k).lt.-eps)then
              if(ish.ge.2)then
              write(ifch,*)'WARNING : nuclear dif+ negativ !'
              write(ifch,*)'difp=',difefp(k),wgrp(k,4)
              endif
              difefp(k)=0.d0
              wgrp(k,4)=0.d0
              write(ifch,*)'difp=',difefp(k),wgrp(k,4)
            endif
            if(difefm(k).lt.-eps)then
              if(ish.ge.2)then
              write(ifch,*)'WARNING : nuclear dif- negativ !'
              write(ifch,*)'difm=',difefm(k),wgrp(k,5)
              endif
              difefm(k)=0.d0
              wgrp(k,5)=0.d0 
              write(ifch,*)'difm=',difefm(k),wgrp(k,5)
            endif
            if(trieff(k).lt.-eps)then
              if(ish.ge.2)then
              write(ifch,*)'WARNING : nuclear uncut negativ !'
              write(ifch,*)'trieff=',trieff(k),om1intc(k)
              endif
              trieff(k)=0.d0
              koll1=koll1+1
              write(ifch,*)'trieff=',trieff(k)
            endif

            atilde(13,k)=difefp(k)*atilde(13,k)
            atilde(14,k)=difefm(k)*atilde(14,k)
            atilde(17,k)=shaeffsf(k)*atilde(17,k)
            atilde(18,k)=shaeffsh(k)*atilde(18,k)


c Integrated omGam for wmatrix

            do iqq=1,5

              if(wgrp(k,iqq).lt.0.d0)then
               write(ifmt,*)'integom1 grp',iqq,' <0 :',wgrp(k,iqq),bk(k)
               call utstop('Negative group in integom1 !&')
              endif

              if(iqq.eq.1)then
                imin=ntymi
                imax=1          !4
              elseif(iqq.eq.2)then
                imin=5
                imax=5          !6
              elseif(iqq.eq.3)then
                imin=7
                imax=7          !8
              elseif(iqq.eq.4)then
                imin=9
                imax=9          !11
              elseif(iqq.eq.5)then
                imin=13         !12
                imax=13         !14
              endif

              cint=0.d0
              do i=imin,imax
                if(iqq.eq.4)then
                  if(i.eq.11)then
                    cint=cint+atilde(13,k)*dps/(btildepp(13,k)+1.d0)
                  else
                    cint=cint+atilde(i,k)*dps/(btildepp(i,k)+1.d0)
                  endif
                elseif(iqq.eq.5)then
                  if(i.eq.13)then
                    cint=cint+atilde(11,k)/(btildep(11,k)+1.d0)*dps
                  else
                    cint=cint+atilde(i,k)/(btildep(i,k)+1.d0)*dps
                  endif
                elseif(iAGKch.ne.1)then
          cint=cint+atilde(i,k)/(btildep(i,k)+1.d0)/(btildepp(i,k)+1.d0)
                else
                  cint=atilde(1,k)*dlog(dble(100.*engy*engy)-1.d0)**2.d0
                endif
              enddo
              om1intg(k,iqq)=cint
              
              wgrp(k,iqq)=om1intg(k,iqq)
           if(ish.ge.5)write(ifch,*)'integom1 grp',iqq,wgrp(k,iqq),bk(k)
 
              if(wgrp(k,iqq).lt.-eps)then
              write(ifmt,*)'integom1 grp',iqq,'<0(2):',wgrp(k,iqq),bk(k)
                call utstop('Negative group in integom1(2) !&')
              endif
              wallgr(k)=wallgr(k)+wgrp(k,iqq)

            enddo

          endif
          

        if((ltarg(it).le.1.and.lproj(ip).le.1).or.inueff.eq.0)then
          wnoleg(k)=1.d0
        else 
          do l=1,ltarg(it)
            kt=ktarg(it,l)
            ipp=iproj(kt)
            icdpl1=icddp(ipp)
            if(kt.eq.k)then
              wlegp(k,ipp)=0.d0
            else
              b12=diffbpr(ip,ipp)
              wlegp(k,ipp)=omNgamx3*omNgamintb(bk(k),bk(kt),b12,1) 
              wnoleg(k)=wnoleg(k)+wlegp(k,ipp)
            endif
          enddo

          wgrp(k,6)=wnoleg(k)
          
          do l=1,lproj(ip)
            kp=kproj(ip,l)
            itt=itarg(kp)
            icdtl1=icddt(itt)
            if(kp.eq.k)then
              wlegt(k,itt)=0.d0
            else
              b12=diffbtg(it,itt)
              wlegt(k,itt)=omNgamx7*omNgamintb(bk(k),bk(kp),b12,2)
              wnoleg(k)=wnoleg(k)+wlegt(k,itt)
            endif
          enddo
          wgrp(k,7)=wnoleg(k)-wgrp(k,6)

          wallgr(k)=wallgr(k)+wnoleg(k)
          
          do l=1,ltarg(it)
            kt=ktarg(it,l)
            ipp=iproj(kt)
            if(wnoleg(k).ne.0.d0)then
              wlegp(k,ipp)=wlegp(k,ipp)/wnoleg(k)
            else
              wlegp(k,ipp)=0.d0
            endif
          enddo
          do l=1,lproj(ip)
            kp=kproj(ip,l)
            itt=itarg(kp)
            if(dabs(wnoleg(k)).gt.eps)then
              wlegt(k,itt)=wlegt(k,itt)/wnoleg(k)
            else
              wlegt(k,itt)=0.d0
            endif
          enddo
          wnoleg(k)=1.d0-wnoleg(k)/wallgr(k)
        endif

        do igr=1,7
          wgrp(k,igr)=wgrp(k,igr)/wallgr(k)
        if(ish.ge.5)write(ifch,*)k,' integom1 : ',wgrp(k,igr),wallgr(k)
        enddo

      enddo

      icdp=icdps
      icdt=icdts
      icdpl1=icdpl1s
      icdtl1=icdtl1s

      if(koll.ge.2.and.ish.ge.2)write(ifmt,*)'integom1 ----->'
     &            ,koll0,koll,real(koll0)/real(koll)
     &            ,koll1,koll,real(koll1)/real(koll)

      endif
      call utprix('intom1',ish,ishini,5)


      return 
      end

c----------------------------------------------------------------------

      double precision function om1xpk(xp,k,iqq)

c----------------------------------------------------------------------
c Normalised on xp and xm Womegak(xp,xm) function
c k - pair indice;
c iqq - groupe of diagram (1=I, 2=Y, 3=iY, 4=Ydif, 5=iYdif)
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incems'
      common /psar7/ delx,alam3p,gam3p
      common/cgtilde/atilde(ntymi:ntymx,kollmx)
     &,btildep(ntymi:ntymx,kollmx),btildepp(ntymi:ntymx,kollmx)
     &              ,atildg(nbpDf0:nbpDf1,kollmx)
     &,btildgp(nbpDf0:nbpDf1,kollmx),btildgpp(nbpDf0:nbpDf1,kollmx)
      double precision atilde,btildep,btildepp,atildg,btildgp,btildgpp
      double precision xp,gamomx(ntymi:ntymx),xis,cint,dps
      double precision deltap(ntymi:ntymx),deltam(ntymi:ntymx),eps
      parameter(eps=1.d-20)

      xis=dble(delx/engy/engy)
      dps=dlog(1.d0/xis/dble(delx))
      om1xpk=0.d0

      if(iscreen.eq.0)then
        imin=ntymi
        imax=1
      elseif(iqq.eq.1)then
        imin=ntymi
        imax=1!4
      elseif(iqq.eq.2)then
        imin=5
        imax=5!6
      elseif(iqq.eq.3)then
        imin=7
        imax=7!8
      elseif(iqq.eq.4)then
        if(xp.le.xis.or.xp.ge.1.d0/dble(delx))return
        imin=9
        imax=9!11
      elseif(iqq.eq.5)then
        imin=13!12
        imax=13!4
      else
        stop"Wrong iqq in om1xpk"
      endif

      do i=imin,imax
        if(iqq.eq.4.and.i.eq.11)then
          gamomx(i)=atilde(13,k)
          deltap(i)=btildep(13,k)
          deltam(i)=btildepp(13,k)
        elseif(iqq.eq.5.and.i.eq.13)then
          gamomx(i)=atilde(11,k)
          deltap(i)=btildep(11,k)
          deltam(i)=btildepp(11,k)
        else
          gamomx(i)=atilde(i,k)
          deltap(i)=btildep(i,k)
          deltam(i)=btildepp(i,k)
        endif
        
      enddo

      if(iAGKch.eq.1)then
        om1xpk=1.d0/xp/(dlog(dble(100.*engy*engy))-1.d0)
        return
      endif

      cint=0.d0
      do i=imin,imax
        if(dabs(deltap(i)+1.d0).gt.eps
     &     .and.dabs(deltam(i)+1.d0).gt.eps)then
          cint=cint+gamomx(i)/(deltap(i)+1.d0)/(deltam(i)+1.d0)
        elseif(dabs(deltap(i)+1.d0).gt.eps)then
          cint=cint+gamomx(i)/(deltap(i)+1.d0)*dlog(1.d0/xis/dble(delx))
        elseif(dabs(deltam(i)+1.d0).gt.eps)then
          cint=cint+gamomx(i)/(deltam(i)+1.d0)*dlog(1.d0/xis/dble(delx))
        else
          call utstop('Not possible in om1xpk&')
        endif
      enddo
      
         
      do i=imin,imax
        if(dabs(deltap(i)+1.d0).gt.eps
     &     .and.dabs(deltam(i)+1.d0).gt.eps)then
          om1xpk=om1xpk+gamomx(i)*xp**deltap(i)/(1.d0+deltam(i))
        elseif(dabs(deltap(i)+1.d0).le.eps)then
          om1xpk=om1xpk+gamomx(i)/(1.d0+deltam(i))/xp
        elseif(dabs(deltam(i)+1.d0).le.eps)then
          om1xpk=om1xpk+gamomx(i)*xp**deltap(i)*dps
        endif

c$$$        write(*,*)cint,i,'omxp',gamomx(i)*xp**deltap(i)/(1.d0+deltam(i))
c$$$     &,xp,gamomx(i),deltap(i),deltam(i)

      enddo

      om1xpk=om1xpk/cint

      return
      end	

c----------------------------------------------------------------------

      double precision function om1xpkAGK(xp,k)

c----------------------------------------------------------------------
c Normalised on xp and xm Womegak(xp,xm) function
c k - pair indice;
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incems'
      common /psar7/ delx,alam3p,gam3p
      common/cgtilde/atilde(ntymi:ntymx,kollmx)
     &,btildep(ntymi:ntymx,kollmx),btildepp(ntymi:ntymx,kollmx)
     &              ,atildg(nbpDf0:nbpDf1,kollmx)
     &,btildgp(nbpDf0:nbpDf1,kollmx),btildgpp(nbpDf0:nbpDf1,kollmx)
      double precision atilde,btildep,btildepp,atildg,btildgp,btildgpp
      double precision xp,gamomx(ntymi:ntymx),cint,dps

      dps=dble(engy*engy*100.)
      om1xpkAGK=0.d0

      imin=ntymi
      imax=1
      
      gamomx(1)=atilde(1,k)

      cint=gamomx(1)*(dlog(dps)+1.d0/dps-1.d0)
      
         
      do i=imin,imax

        om1xpkAGK=gamomx(i)*(1.d0-xp)/xp

      enddo

      om1xpkAGK=om1xpkAGK/cint

      return
      end	


c----------------------------------------------------------------------

      double precision function om1xmk(xp,xm,k,iqq)

c----------------------------------------------------------------------
c Normalised on xm Womegak(xp,xm) function
c k - pair indice;
c iqq - groupe of diagram (1=I, 2=Y, 3=iY, 4=Ydif, 5=iYdif)
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incems'
      common /psar7/ delx,alam3p,gam3p
      common/cgtilde/atilde(ntymi:ntymx,kollmx)
     &,btildep(ntymi:ntymx,kollmx),btildepp(ntymi:ntymx,kollmx)
     &              ,atildg(nbpDf0:nbpDf1,kollmx)
     &,btildgp(nbpDf0:nbpDf1,kollmx),btildgpp(nbpDf0:nbpDf1,kollmx)
      double precision atilde,btildep,btildepp,atildg,btildgp,btildgpp
      double precision xp,xm,gamomx(ntymi:ntymx),xis,cint,dps
      double precision deltam(ntymi:ntymx),eps
      parameter(eps=1.d-20)

      xis=dble(delx/engy/engy)
      dps=dlog(1.d0/xis/dble(delx))

      om1xmk=0.d0

      if(iscreen.eq.0)then
        imin=ntymi
        imax=1
      elseif(iqq.eq.1)then
        imin=ntymi
        imax=1!4
      elseif(iqq.eq.2)then
        imin=5
        imax=5!6
      elseif(iqq.eq.3)then
        imin=7
        imax=7!8
      elseif(iqq.eq.4)then
        if(xp.le.xis.or.xp.ge.1.d0/dble(delx))return
        imin=9
        imax=9!11
      elseif(iqq.eq.5)then
        if(xm.le.xis.or.xm.ge.1.d0/dble(delx))return
        imin=13!12
        imax=13!14
      else
        stop"Wrong iqq in om1xmk"
      endif

      do i=imin,imax
        if(iqq.eq.4.and.i.eq.11)then
          gamomx(i)=atilde(13,k)*xp**btildep(13,k)
          deltam(i)=btildepp(13,k)
        elseif(iqq.eq.5.and.i.eq.13)then
          gamomx(i)=atilde(11,k)*xp**btildep(11,k)
          deltam(i)=btildepp(11,k)
        else
          gamomx(i)=atilde(i,k)*xp**btildep(i,k)
          deltam(i)=btildepp(i,k)
        endif
        
      enddo

      if(iAGKch.eq.1)then
        om1xmk=1.d0/xm/(dlog(dble(100.*engy*engy))-1.d0)
        return
      endif

      cint=0.d0
      do i=imin,imax
        if(dabs(deltam(i)+1.d0).lt.eps)then
          cint=cint+gamomx(i)*dps
        else
          cint=cint+gamomx(i)/(1.d0+deltam(i))
        endif
      enddo
      
         
      do i=imin,imax
        om1xmk=om1xmk+gamomx(i)*xm**deltam(i)
      enddo

      om1xmk=om1xmk/cint

      return
      end	

c----------------------------------------------------------------------

      double precision function om1xprk(k,iqq)

c----------------------------------------------------------------------
c Random number generated from the function om1xpk. We solve the equation
c which give om1xprk by Newton-Raphson + secant method.
c k - pair indice;
c iqq - groupe of diagram (1=I, 2=Y, 3=iY, 4=Ydif, 5=iYdif)
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incems'
      common /psar7/ delx,alam3p,gam3p
      common/cgtilde/atilde(ntymi:ntymx,kollmx)
     &,btildep(ntymi:ntymx,kollmx),btildepp(ntymi:ntymx,kollmx)
     &              ,atildg(nbpDf0:nbpDf1,kollmx)
     &,btildgp(nbpDf0:nbpDf1,kollmx),btildgpp(nbpDf0:nbpDf1,kollmx)
      double precision atilde,btildep,btildepp,atildg,btildgp,btildgpp
      double precision x,x0,x1,gamomx(ntymi:ntymx),eps,xis
      double precision xt,fx,fpx,r,f1,f0,cint,deltx,dps,prec
      double precision deltap(ntymi:ntymx),deltam(ntymi:ntymx)
      parameter (eps=1.d-20)

      xis=dble(delx/engy/engy)
      dps=dlog(1.d0/xis/dble(delx))
      r=dble(rangen())

      om1xprk=0.d0

      x0=2.d0*eps
      x1=1.d0
      if(iAGKch.eq.1)then
        om1xprk=dble(100.*engy*engy)**(r-1.d0)
        return      
      elseif(iscreen.eq.0)then
        imin=ntymi
        imax=1
      elseif(iqq.eq.1)then
        imin=ntymi
        imax=1!4
      elseif(iqq.eq.2)then
        imin=5
        imax=5!6
      elseif(iqq.eq.3)then
        imin=7
        imax=7!8
      elseif(iqq.eq.4)then
        imin=9
        imax=9!11
        x0=xis
        x1=1.d0/dble(delx)
      elseif(iqq.eq.5)then
        imin=13!12
        imax=13!14
      else
        stop"Wrong iqq in om1xprk"
      endif

      do i=imin,imax
        if(iqq.eq.4.and.i.eq.11)then
          gamomx(i)=atilde(13,k)
          deltap(i)=btildep(13,k)
          deltam(i)=btildepp(13,k)
        elseif(iqq.eq.5.and.i.eq.13)then
          gamomx(i)=atilde(11,k)
          deltap(i)=btildep(11,k)
          deltam(i)=btildepp(11,k)
        else
          gamomx(i)=atilde(i,k)
          deltap(i)=btildep(i,k)
          deltam(i)=btildepp(i,k)
        endif        
      enddo



      cint=0.d0
      do i=imin,imax
        if(deltap(i).ne.-1.d0.and.deltam(i).ne.-1.d0)then
          cint=cint+gamomx(i)/(deltap(i)+1.d0)/(deltam(i)+1.d0)
        elseif(deltap(i).ne.-1.d0)then
          cint=cint+gamomx(i)/(deltap(i)+1.d0)*dlog(1.d0/xis/dble(delx))
        elseif(deltam(i).ne.-1.d0)then
          cint=cint+gamomx(i)/(deltam(i)+1.d0)*dlog(1.d0/xis/dble(delx))
        else
          call utstop('Not possible in om1xprk&')
        endif
      enddo

      
         
      f0=0.d0
      f1=0.d0
      do i=imin,imax
        if(deltap(i).ne.-1.d0.and.deltam(i).ne.-1.d0)then
          f0=f0+gamomx(i)*x0**(1.d0+deltap(i))
     &          /(1.d0+deltap(i))/(1.d0+deltam(i))
          f1=f1+gamomx(i)*x1**(1.d0+deltap(i))
     &          /(1.d0+deltap(i))/(1.d0+deltam(i))
        elseif(deltap(i).eq.-1.d0)then
          f0=f0+gamomx(i)*dlog(x0/xis)/(1.d0+deltam(i))
          f1=f1+gamomx(i)*dlog(x1/xis)/(1.d0+deltam(i))
        elseif(deltam(i).eq.-1.d0)then
          f0=f0+gamomx(i)*x0**(1.d0+deltap(i))
     &          /(1.d0+deltap(i))*dps
          f1=f1+gamomx(i)*x1**(1.d0+deltap(i))
     &          /(1.d0+deltap(i))*dps
        endif
      enddo
      f0=-f0/cint+r
      f1=-f1/cint+r
      if(f1*f0.gt.0.d0)call utstop('Error(2) in nexus-omg in om1xprk&')
      if(f0.eq.0.d0) then
        om1xprk=x0
        return
      endif 
      if(f1.eq.0.d0) then
        om1xprk=x1
        return
      endif 
      x=dsqrt(x1*x0)
      deltx=dabs(x1-x0)  


      ntry=0

 111  continue
      if(ntry.le.1000)then
      fx=0.d0
      fpx=0.d0
      do i=imin,imax
        if(deltap(i).ne.-1.d0.and.deltam(i).ne.-1.d0)then
          fx=fx+gamomx(i)*x**(1.d0+deltap(i))
     &          /(1.d0+deltap(i))/(1.d0+deltam(i))
          fpx=fpx+gamomx(i)*x**deltap(i)/(1.d0+deltam(i))
        elseif(deltap(i).eq.-1.d0)then
          fx=fx+gamomx(i)*dlog(x/xis)/(1.d0+deltam(i))
          fpx=fpx+gamomx(i)/(1.d0+deltam(i))/x
        elseif(deltam(i).eq.-1.d0)then
          fx=fx+gamomx(i)*x**(1.d0+deltap(i))
     &          /(1.d0+deltap(i))*dps
          fpx=fpx+gamomx(i)*x**deltap(i)*dps
        endif
      enddo
      fx=-fx/cint+r
      fpx=fpx/cint
      xt=x-fx/fpx
      
      if (f0*fx.lt.0.D0) then
        f1=fx
        x1=x
      else
        f0=fx
        x0=x
      endif
      if ((xt.lt.x0.or.xt.gt.x1).and.dabs(f1-f0).gt.eps) then
        xt=x1-f1*(x1-x0)/(f1-f0)
      endif

       else

        write(ifmt,*)'Warning in om1xprk, to much try !'

      endif


      if(dabs(x-xt).gt.deltx/2.d0) then
        xt=(x1+x0)/2.D0
      endif
      deltx=dabs(x-xt)  
      if(dabs(x).gt.eps)then
        prec=deltx/x
      else
        call utstop('Problem in om1xprk&')
      endif

      if (prec.gt.1.d-3.and.dabs(f1-f0).gt.eps.and.ntry.le.1000) then
	 x=xt
	 ntry=ntry+1
         goto 111
      endif
      
      om1xprk=x

      return
      end	

c----------------------------------------------------------------------

      double precision function om1xprkAGK(k)

c----------------------------------------------------------------------
c Random number generated from the function om1xpkAGK. 
c We solve the equation
c which give om1xprkAGK by Newton-Raphson + secant method.
c k - pair indice;
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incems'
      common /psar7/ delx,alam3p,gam3p
      common/cgtilde/atilde(ntymi:ntymx,kollmx)
     &,btildep(ntymi:ntymx,kollmx),btildepp(ntymi:ntymx,kollmx)
     &              ,atildg(nbpDf0:nbpDf1,kollmx)
     &,btildgp(nbpDf0:nbpDf1,kollmx),btildgpp(nbpDf0:nbpDf1,kollmx)
      double precision atilde,btildep,btildepp,atildg,btildgp,btildgpp
      double precision x,x0,x1,gamomx(ntymi:ntymx),eps
      double precision xt,fx,fpx,r,f1,f0,cint,deltx,dps
      parameter (eps=1.d-20)

      dps=dble(engy*engy*100.)
      r=dble(rangen())
      om1xprkAGK=0.d0


      gamomx(1)=atilde(1,k)



      cint=gamomx(1)*(dlog(dps)+1.d0/dps-1.d0)
      
         
      x0=1.d0/dps
      x1=1.d0
      f0=0.d0
      f1=0.d0
      imin=ntymi
      imax=1
      do i=imin,imax
          f0=gamomx(i)*(dlog(x0)+dlog(dps)-x0+1.d0/dps)
          f1=gamomx(i)*(dlog(x1)+dlog(dps)-x1+1.d0/dps)
      enddo
      f0=f0/cint-r
      f1=f1/cint-r
      if(f1*f0.gt.0.d0)
     &call utstop('Error(2) in nexus-omg in om1xprkAGK&')
      if(f0.eq.0.d0) then
        om1xprkAGK=x0
        return
      endif 
      if(f1.eq.0.d0) then
        om1xprkAGK=x1
        return
      endif 
      x=(x1+x0)/2.D0
      deltx=dabs(x1-x0)  

 111  continue
      fx=0.d0
      fpx=0.d0
      do i=imin,imax
        fx=gamomx(i)*(dlog(x)+dlog(dps)-x+1.d0/dps)
        fpx=gamomx(i)*(1.d0-x)/x
      enddo
      fx=fx/cint-r
      fpx=fpx/cint
      xt=x-fx/fpx
      
      if (f0*fx.lt.0.D0) then
        f1=fx
        x1=x
      else
        f0=fx
        x0=x
      endif
      if (xt.lt.x0.or.xt.gt.x1) then
        xt=x1-f1*(x1-x0)/(f1-f0)
      endif

      if(dabs(x-xt).gt.deltx/2.d0) then
        xt=(x1+x0)/2.D0
      endif
      deltx=dabs(x-xt)  

      if (deltx.gt.eps) then
	 x=xt
	 
         goto 111
      endif
      
      om1xprkAGK=x

      return
      end	

c----------------------------------------------------------------------

      double precision function om1xmrk(xp,k,iqq)

c----------------------------------------------------------------------
c Random number generated from the function om1xmk. We solve the equation
c which give om1xmrk by Newton-Raphson + secant method.
c k - pair indice;
c iqq - groupe of diagram (1=I, 2=Y, 3=iY, 4=Ydif, 5=iYdif)
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incems'
      common /psar7/ delx,alam3p,gam3p
      common/cgtilde/atilde(ntymi:ntymx,kollmx)
     &,btildep(ntymi:ntymx,kollmx),btildepp(ntymi:ntymx,kollmx)
     &              ,atildg(nbpDf0:nbpDf1,kollmx)
     &,btildgp(nbpDf0:nbpDf1,kollmx),btildgpp(nbpDf0:nbpDf1,kollmx)
      double precision atilde,btildep,btildepp,atildg,btildgp,btildgpp
      double precision x,x0,x1,gamomx(ntymi:ntymx),eps,xis,xp
      double precision xt,fx,fpx,r,f1,f0,cint,deltx,dps,prec
      double precision deltam(ntymi:ntymx)
      parameter (eps=1.d-20)

      xis=dble(delx/engy/engy)
      dps=dlog(1.d0/xis/dble(delx))
      r=dble(rangen())
      om1xmrk=0.d0

      if(iAGKch.eq.1)then
        om1xmrk=dble(100.*engy*engy)**(r-1.d0)
        return
      elseif(iscreen.eq.0)then
        imin=ntymi
        imax=1
      elseif(iqq.eq.1)then
        imin=ntymi
        imax=1!4
      elseif(iqq.eq.2)then
        imin=5
        imax=5!6
      elseif(iqq.eq.3)then
        imin=7
        imax=7!8
      elseif(iqq.eq.4)then
        if(xp.lt.xis.or.xp.gt.1.d0/dble(delx))return
        imin=9
        imax=9!11
      elseif(iqq.eq.5)then
        imin=13!12
        imax=13!14
      else
        stop"Wrong iqq in om1xmrk"
      endif

      do i=imin,imax
        if(iqq.eq.4.and.i.eq.11)then
          gamomx(i)=atilde(13,k)*xp**btildep(13,k)
          deltam(i)=btildepp(13,k)
        elseif(iqq.eq.5.and.i.eq.13)then
          gamomx(i)=atilde(11,k)*xp**btildep(11,k)
          deltam(i)=btildepp(11,k)
        else
          gamomx(i)=atilde(i,k)*xp**btildep(i,k)
          deltam(i)=btildepp(i,k)
        endif
        
      enddo

      cint=0.d0
      do i=imin,imax
        if(dabs(deltam(i)+1.d0).lt.eps)then
          cint=cint+gamomx(i)*dps
        else
          cint=cint+gamomx(i)/(1.d0+deltam(i))
        endif
      enddo
      
         
      x0=2.d0*eps
      x1=1.d0
      f0=0.d0
      f1=0.d0
      do i=imin,imax
        if(dabs(deltam(i)+1.d0).gt.eps)then
          f0=f0+gamomx(i)*x0**(1.d0+deltam(i))/(1.d0+deltam(i))
          f1=f1+gamomx(i)*x1**(1.d0+deltam(i))/(1.d0+deltam(i))
        else
          f0=f0+gamomx(i)*dlog(x0/xis)
          f1=f1+gamomx(i)*dlog(x1/xis)
        endif
      enddo
      f0=-f0/cint+r
      f1=-f1/cint+r
      if(f1*f0.gt.-eps)call utstop('Error(2) in nexus-omg in om1xmrk&')
      if(dabs(f0).lt.eps) then
        om1xmrk=x0
        return
      endif 
      if(dabs(f1).lt.eps) then
        om1xmrk=x1
        return
      endif 
      x=dsqrt(x1*x0)
      deltx=dabs(x1-x0)  


      ntry=0

 111  continue
      if(ntry.le.1000)then
      fx=0.d0
      fpx=0.d0
      do i=imin,imax
        if(dabs(deltam(i)+1.d0).gt.eps)then
          fx=fx+gamomx(i)*x**(1.d0+deltam(i))/(1.d0+deltam(i))
          fpx=fpx+gamomx(i)*x**deltam(i)
        else
          fx=fx+gamomx(i)*dlog(x/xis)
          fpx=fpx+gamomx(i)/x
        endif
      enddo
      fx=-fx/cint+r
      fpx=fpx/cint
      xt=x-fx/fpx
      
      if (f0*fx.lt.-eps) then
        f1=fx
        x1=x
      else
        f0=fx
        x0=x
      endif
      if ((xt.lt.x0-eps.or.xt.gt.x1+eps).and.dabs(f1-f0).gt.eps) then
        xt=x1-f1*(x1-x0)/(f1-f0)
      endif

       else

        write(ifmt,*)'Warning in om1xmrk, to much try !'

      endif

      if(dabs(x-xt).gt.deltx/2.d0) then
        xt=(x1+x0)/2.D0
      endif
      deltx=dabs(x-xt)  
      if(dabs(x).gt.eps)then
        prec=deltx/x
      else
        call utstop('Problem in om1xmrk&')
      endif

      if (prec.gt.1.d-3.and.dabs(f1-f0).gt.eps.and.ntry.le.1000) then
	 x=xt
	 ntry=ntry+1
         goto 111
      endif
      
      om1xmrk=x

      return
      end	

c----------------------------------------------------------------------

      double precision function om1xk(xh,k,iqq)

c----------------------------------------------------------------------
c Normalised on x and y Womegak(x,y) function
c k - pair indice;
c iqq - groupe of diagram (1=I, 2=Y, 3=iY, 4=Ydif, 5=iYdif)
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incems'

      common /psar7/ delx,alam3p,gam3p
      common/cgtilde/atilde(ntymi:ntymx,kollmx)
     &,btildep(ntymi:ntymx,kollmx),btildepp(ntymi:ntymx,kollmx)
     &              ,atildg(nbpDf0:nbpDf1,kollmx)
     &,btildgp(nbpDf0:nbpDf1,kollmx),btildgpp(nbpDf0:nbpDf1,kollmx)
      double precision atilde,btildep,btildepp,atildg,btildgp,btildgpp
      double precision xh,gamomx(ntymi:ntymx),cint,alpp(ntymi:ntymx),xis
     &,delta(ntymi:ntymx),deltap(ntymi:ntymx),deltam(ntymi:ntymx),eps
      parameter(eps=1.d-20)


      xis=dble(delx/engy/engy)
      om1xk=0.d0

      if(iscreen.eq.0)then
        imin=ntymi
        imax=1
      elseif(iqq.eq.1)then
        imin=ntymi
        imax=1!4
      elseif(iqq.eq.2)then
        imin=5
        imax=5!6
      elseif(iqq.eq.3)then
        imin=7
        imax=7!8
      elseif(iqq.eq.4)then
        imin=9
        imax=9!11
      elseif(iqq.eq.5)then
        imin=13!12
        imax=13!14
      else
        stop"Wrong iqq in om1xk"
      endif

      do i=imin,imax
        if(iqq.eq.4.and.i.eq.11)then
          gamomx(i)=atilde(13,k)
          deltap(i)=btildep(13,k)
          deltam(i)=btildepp(13,k)
        elseif(iqq.eq.5.and.i.eq.13)then
          gamomx(i)=atilde(11,k)
          deltap(i)=btildep(11,k)
          deltam(i)=btildepp(11,k)
        else
          gamomx(i)=atilde(i,k)
          deltap(i)=btildep(i,k)
          deltam(i)=btildepp(i,k)
        endif
        
        delta(i)=(deltap(i)+deltam(i))/2.d0
        alpp(i)=deltap(i)-deltam(i)
                 
      enddo

      cint=0.d0
      do i=imin,imax
        if(dabs(deltap(i)+1.d0).gt.eps
     &     .and.dabs(deltam(i)+1.d0).gt.eps)then
          cint=cint+gamomx(i)/(deltap(i)+1.d0)/(deltam(i)+1.d0)
        elseif(dabs(deltap(i)+1.d0).gt.eps)then
          cint=cint+gamomx(i)/(deltap(i)+1.d0)*dlog(1.d0/xis/dble(delx))
        elseif(dabs(deltam(i)+1.d0).gt.eps)then
          cint=cint+gamomx(i)/(deltam(i)+1.d0)*dlog(1.d0/xis/dble(delx))
        else
          call utstop('Not possible in om1xk&')
        endif
      enddo

      
      do i=imin,imax
        if(dabs(alpp(i)).gt.eps)then
        om1xk=om1xk+gamomx(i)/alpp(i)*xh**deltam(i)*(1.d0-xh**alpp(i))
        else
        om1xk=om1xk-gamomx(i)*xh**delta(i)*dlog(xh)
        endif
      enddo
      
      om1xk=om1xk/cint

      return
      end	

c----------------------------------------------------------------------

      double precision function om1yk(xh,yp,k,iqq)

c----------------------------------------------------------------------
c Normalised on y Womegak(x,y) function
c xh - fraction of the energy squared s for the pomeron;
c k - pair indice;
c iqq - groupe of diagram (1=I, 2=Y, 3=iY, 4=Ydif, 5=iYdif)
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incems'
      common /psar7/ delx,alam3p,gam3p
      common/cgtilde/atilde(ntymi:ntymx,kollmx)
     &,btildep(ntymi:ntymx,kollmx),btildepp(ntymi:ntymx,kollmx)
     &              ,atildg(nbpDf0:nbpDf1,kollmx)
     &,btildgp(nbpDf0:nbpDf1,kollmx),btildgpp(nbpDf0:nbpDf1,kollmx)
      double precision atilde,btildep,btildepp,atildg,btildgp,btildgpp
      double precision xh,yp,gamomy(ntymi:ntymx),alpp(ntymi:ntymx),cint
      double precision deltap,deltam,eps
      parameter(eps=1.d-20)

      om1yk=0.d0

      if(iscreen.eq.0)then
        imin=ntymi
        imax=1
      elseif(iqq.eq.1)then
        imin=ntymi
        imax=1!4
      elseif(iqq.eq.2)then
        imin=5
        imax=5!6
      elseif(iqq.eq.3)then
        imin=7
        imax=7!8
      elseif(iqq.eq.4)then
        imin=9
        imax=9!11
      elseif(iqq.eq.5)then
        imin=13!12
        imax=13!14
      else
        stop"Wrong iqq in om1yk"
      endif

      do i=imin,imax
        if(iqq.eq.4.and.i.eq.11)then
          gamomy(i)=atilde(13,k)
          deltap=btildep(13,k)
          deltam=btildepp(13,k)
        elseif(iqq.eq.5.and.i.eq.13)then
          gamomy(i)=atilde(11,k)
          deltap=btildep(11,k)
          deltam=btildepp(11,k)
        else
          gamomy(i)=atilde(i,k)
          deltap=btildep(i,k)
          deltam=btildepp(i,k)
        endif
        
        alpp(i)=deltap-deltam
        gamomy(i)=gamomy(i)*xh**((deltap+deltam)/2.d0)

      enddo

      cint=0.d0
      do i=imin,imax
        if(dabs(alpp(i)).gt.eps)then
          cint=cint-gamomy(i)/alpp(i)*xh**(alpp(i)/2.d0)
     &                               *(1.d0-xh**(-alpp(i)))
        else
          cint=cint-gamomy(i)*dlog(xh)
        endif
      enddo
         
      do i=imin,imax
        if(dabs(alpp(i)).gt.eps)then
        om1yk=om1yk+gamomy(i)*dexp(alpp(i)*yp)
        else
        om1yk=om1yk+gamomy(i)
        endif
      enddo

      om1yk=om1yk/cint


      return
      end	

c----------------------------------------------------------------------

      double precision function om1xrk(k,iqq)

c----------------------------------------------------------------------
c Random number generated from the function om1xk. We solve the equation
c which give om1xrk by Newton-Raphson + secant method.
c k - pair indice;
c iqq - groupe of diagram (1=I, 2=Y, 3=iY, 4=Ydif, 5=iYdif)
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incems'
      include 'nexus.incpar'

      common /psar7/ delx,alam3p,gam3p
      common/cgtilde/atilde(ntymi:ntymx,kollmx)
     &,btildep(ntymi:ntymx,kollmx),btildepp(ntymi:ntymx,kollmx)
     &              ,atildg(nbpDf0:nbpDf1,kollmx)
     &,btildgp(nbpDf0:nbpDf1,kollmx),btildgpp(nbpDf0:nbpDf1,kollmx)
      double precision atilde,btildep,btildepp,atildg,btildgp,btildgpp
      double precision x,x0,x1,gamomx(ntymi:ntymx),eps,xis,prec
      double precision xt,fx,fpx,r,f1,f0,cint,deltx,alpp(ntymi:ntymx)
     &,delta(ntymi:ntymx),deltap(ntymi:ntymx),deltam(ntymi:ntymx)
      parameter (eps=1.d-20)


      xis=dble(delx/engy/engy)
      om1xrk=0.d0
      r=dble(rangen())

      if(iscreen.eq.0)then
        imin=ntymi
        imax=1
      elseif(iqq.eq.1)then
        imin=ntymi
        imax=1!4
      elseif(iqq.eq.2)then
        imin=5
        imax=5!6
      elseif(iqq.eq.3)then
        imin=7
        imax=7!8
      elseif(iqq.eq.4)then
        imin=9
        imax=9!11
      elseif(iqq.eq.5)then
        imin=13!12
        imax=13!14
      else
        stop"Wrong iqq in om1xrk"
      endif

      do i=imin,imax
        if(iqq.eq.4.and.i.eq.11)then
          gamomx(i)=atilde(13,k)
          deltap(i)=btildep(13,k)
          deltam(i)=btildepp(13,k)
        elseif(iqq.eq.5.and.i.eq.13)then
          gamomx(i)=atilde(11,k)
          deltap(i)=btildep(11,k)
          deltam(i)=btildepp(11,k)
        else
          gamomx(i)=atilde(i,k)
          deltap(i)=btildep(i,k)
          deltam(i)=btildepp(i,k)
        endif
        
        delta(i)=(deltap(i)+deltam(i))/2.d0
        alpp(i)=deltap(i)-deltam(i)
         
c Integration possible only if delta(i)>-1

        if(dabs(delta(i)+1.d0).lt.eps)then
          call utstop('Error(1) in nexus-omg in om1xrk&')
        endif
        
      enddo

      cint=0.d0
      do i=imin,imax
        if(dabs(deltap(i)+1.d0).gt.eps
     &     .and.dabs(deltam(i)+1.d0).gt.eps)then
          cint=cint+gamomx(i)/(deltap(i)+1.d0)/(deltam(i)+1.d0)
        elseif(dabs(deltap(i)+1.d0).gt.eps)then
          cint=cint+gamomx(i)/(deltap(i)+1.d0)*dlog(1.d0/xis/dble(delx))
        elseif(dabs(deltam(i)+1.d0).gt.eps)then
          cint=cint+gamomx(i)/(deltam(i)+1.d0)*dlog(1.d0/xis/dble(delx))
        else
          call utstop('Not possible in om1xrk&')
        endif
      enddo

      x0=2.d0*eps
      x1=1.d0
      f0=0.d0
      f1=0.d0
      do i=imin,imax
        if(dabs(alpp(i)).gt.eps.and.dabs(deltap(i)+1.d0).gt.eps
     &                         .and.dabs(deltam(i)+1.d0).gt.eps)then
        f0=f0+gamomx(i)/alpp(i)*(x0**(deltam(i)+1.d0)/(deltam(i)+1.d0)
     &                          -x0**(deltap(i)+1.d0)/(deltap(i)+1.d0))
        f1=f1+gamomx(i)/alpp(i)*(x1**(deltam(i)+1.d0)/(deltam(i)+1.d0)
     &                          -x1**(deltap(i)+1.d0)/(deltap(i)+1.d0))
        elseif(dabs(alpp(i)).gt.eps.and.dabs(deltap(i)+1.d0).gt.eps)then
        f0=f0+gamomx(i)/alpp(i)*(dlog(x0/xis)
     &                          -x0**(deltap(i)+1.d0)/(deltap(i)+1.d0))
        f1=f1+gamomx(i)/alpp(i)*(dlog(x1/xis)
     &                          -x1**(deltap(i)+1.d0)/(deltap(i)+1.d0))
        elseif(dabs(alpp(i)).gt.eps.and.dabs(deltam(i)+1.d0).gt.eps)then
        f0=f0-gamomx(i)/alpp(i)*(dlog(x0/xis)
     &                          -x0**(deltam(i)+1.d0)/(deltam(i)+1.d0))
        f1=f1-gamomx(i)/alpp(i)*(dlog(x1/xis)
     &                          -x1**(deltam(i)+1.d0)/(deltam(i)+1.d0))
        else
        f0=f0-gamomx(i)/(delta(i)+1.d0)*x0**(delta(i)+1.d0)
     &        *(dlog(x0)-1.d0/(delta(i)+1.d0))
        f1=f1-gamomx(i)/(delta(i)+1.d0)*x1**(delta(i)+1.d0)
     &        *(dlog(x1)-1.d0/(delta(i)+1.d0))
        endif
      enddo
      f0=-f0/cint+r
      f1=-f1/cint+r
      if(f1*f0.gt.eps)then
        call utmsg('om1xrk')
        write(ifch,*)'Poblem with x0, no root ! --> om1xrk=xminDf'
        write(ifmt,*)'Poblem with x0, no root ! --> om1xrk=xminDf'
        call utmsgf
        om1xrk=x0
        return        
      endif
      if(dabs(f0).lt.eps) then
        om1xrk=x0
        return
      endif 
      if(dabs(f1).lt.eps) then
        om1xrk=x1
        return
      endif 
c      x=(x1+x0)/2.D0
      x=dsqrt(x1*x0)
      deltx=dabs(x1-x0)  

      ntry=0
      fx=0.d0
      fpx=0.d0
      xt=x
 111  continue

      if(ntry.le.1000)then
      fx=0.d0
      fpx=0.d0
      do i=imin,imax
        if(dabs(alpp(i)).gt.eps.and.dabs(deltap(i)+1.d0).gt.eps
     &                         .and.dabs(deltam(i)+1.d0).gt.eps)then
        fx=fx+gamomx(i)/alpp(i)*(x**(deltam(i)+1.d0)/(deltam(i)+1.d0)
     &                          -x**(deltap(i)+1.d0)/(deltap(i)+1.d0))
        fpx=fpx+gamomx(i)/alpp(i)*x**deltam(i)*(1.d0-x**alpp(i))
        elseif(dabs(alpp(i)).gt.eps.and.dabs(deltap(i)+1.d0).gt.eps)then
        fx=fx+gamomx(i)/alpp(i)*(dlog(x/xis)
     &                          -x**(deltap(i)+1.d0)/(deltap(i)+1.d0))
        fpx=fpx+gamomx(i)/alpp(i)*x**deltam(i)*(1.d0-x**alpp(i))
        elseif(dabs(alpp(i)).gt.eps.and.dabs(deltam(i)+1.d0).gt.eps)then
        fx=fx-gamomx(i)/alpp(i)*(dlog(x/xis)
     &                          -x**(deltam(i)+1.d0)/(deltam(i)+1.d0))
        fpx=fpx+gamomx(i)/alpp(i)*x**deltam(i)*(1.d0-x**alpp(i))
        else
        fx=fx-gamomx(i)/(delta(i)+1.d0)*x**(delta(i)+1.d0)
     &        *(dlog(x)-1.d0/(delta(i)+1.d0))
        fpx=fpx-gamomx(i)*x**delta(i)*dlog(x)
        endif
      enddo
      fx=-fx/cint+r
      fpx=fpx/cint
      xt=x-fx/fpx
      
      if (f0*fx.lt.-eps) then
        f1=fx
        x1=x
      else
        f0=fx
        x0=x
      endif
      if ((xt.lt.x0-eps.or.xt.gt.x1+eps).and.dabs(f1-f0).gt.eps) then
        xt=x1-f1*(x1-x0)/(f1-f0)
      endif

      else

        write(ifmt,*)'Warning in om1xrk, to much try !'

      endif

      if(dabs(x-xt).gt.deltx/2.d0) then
        xt=dsqrt(x1*x0)
      endif
      deltx=dabs(x-xt)
      if(dabs(x).gt.eps)then
        prec=deltx/x
      else
        call utstop('Problem in om1xrk&')
      endif

      if (prec.gt.1.d-3.and.dabs(f1-f0).gt.eps.and.ntry.le.1000)then
	 x=xt
	 ntry=ntry+1
         goto 111
      endif
      
      om1xrk=x

      return
      end	

c----------------------------------------------------------------------

      double precision function om1yrk(xh,k,iqq)

c----------------------------------------------------------------------
c Random number generated from the function om1yk(xh). We solve the 
c equation which give om1yrk by Newton-Raphson + secant method.
c xh - fraction of the energy squared s for the pomeron;
c k - pair indice;
c iqq - groupe of diagram (1=I, 2=Y, 3=iY, 4=Ydif, 5=iYdif)
c----------------------------------------------------------------------

      include 'nexus.inc'
      include 'nexus.incems'

      common /psar7/ delx,alam3p,gam3p
      common/cgtilde/atilde(ntymi:ntymx,kollmx)
     &,btildep(ntymi:ntymx,kollmx),btildepp(ntymi:ntymx,kollmx)
     &              ,atildg(nbpDf0:nbpDf1,kollmx)
     &,btildgp(nbpDf0:nbpDf1,kollmx),btildgpp(nbpDf0:nbpDf1,kollmx)
      double precision atilde,btildep,btildepp,atildg,btildgp,btildgpp
      double precision xh,y0,y1,y,gamomy(ntymi:ntymx),eps,ymin,prec,yt
     &,alpp(ntymi:ntymx),fy,fpy,r,f1,f0,cint,dely,deltap,deltam
      parameter (eps=1.d-20)

      ymin=0.5d0*dlog(xh)
      r=dble(rangen())

      om1yrk=0.d0

      if(iscreen.eq.0)then
        om1yrk=(0.5d0-r)*dlog(xh)
        return
      elseif(iqq.eq.1)then
        imin=ntymi
        imax=1!4
      elseif(iqq.eq.2)then
        imin=5
        imax=5!6
      elseif(iqq.eq.3)then
        imin=7
        imax=7!8
      elseif(iqq.eq.4)then
        imin=9
        imax=9!11
      elseif(iqq.eq.5)then
        imin=13!12
        imax=13!14
      else
        stop"Wrong iqq in om1yrk"
      endif

      do i=imin,imax
        if(iqq.eq.4.and.i.eq.11)then
          gamomy(i)=atilde(13,k)
          deltap=btildep(13,k)
          deltam=btildepp(13,k)
        elseif(iqq.eq.5.and.i.eq.13)then
          gamomy(i)=atilde(11,k)
          deltap=btildep(11,k)
          deltam=btildepp(11,k)
        else
          gamomy(i)=atilde(i,k)
          deltap=btildep(i,k)
          deltam=btildepp(i,k)
        endif
        
        alpp(i)=deltap-deltam
        gamomy(i)=gamomy(i)*xh**((deltap+deltam)/2.d0)

      enddo

      cint=0.d0
      do i=imin,imax
        if(dabs(alpp(i)).gt.eps)then
          cint=cint-gamomy(i)/alpp(i)*xh**(alpp(i)/2.d0)
     &                               *(1.d0-xh**(-alpp(i)))
        else
          cint=cint-gamomy(i)*dlog(xh)
        endif
      enddo
         
      y0=ymin
      y1=-ymin
      f0=0.d0
      f1=0.d0
      do i=imin,imax
        if(dabs(alpp(i)).gt.eps)then
        f0=f0+gamomy(i)/alpp(i)*(dsqrt(xh)**alpp(i)-dexp(alpp(i)*y0))
        f1=f1+gamomy(i)/alpp(i)*(dsqrt(xh)**alpp(i)-dexp(alpp(i)*y1))
        else
        f0=f0+gamomy(i)*(dlog(xh)/2.d0-y0)
        f1=f1+gamomy(i)*(dlog(xh)/2.d0-y1)
        endif
      enddo
      f0=f0/cint+r
      f1=f1/cint+r
      if(f1*f0.gt.eps)call utstop('Error in nexus-omg in om1yrk&')
      if(dabs(f0).lt.eps) then
        om1yrk=y0
        return
      endif 
      if(dabs(f1).lt.eps) then
        om1yrk=y1
        return
      endif 
      y=(y1+y0)/2.D0
      dely=dabs(y1-y0)  


      ntry=0

 111  continue
      if(ntry.le.1000)then
      fy=0.d0
      fpy=0.d0
      do i=imin,imax
        if(dabs(alpp(i)).gt.eps)then
        fy=fy+gamomy(i)/alpp(i)*(dsqrt(xh)**alpp(i)-dexp(alpp(i)*y))
        fpy=fpy-gamomy(i)*dexp(alpp(i)*y)
        else
        fy=fy+gamomy(i)*(dlog(xh)/2.d0-y)
        fpy=fpy-gamomy(i)
        endif
      enddo
      fy=fy/cint+r
      fpy=fpy/cint
      yt=y-fy/fpy
      
      if (f0*fy.lt.-eps) then
        f1=fy
        y1=y
      else
        f0=fy
        y0=y
      endif
      if ((yt.lt.y0-eps.or.yt.gt.y1+eps).and.dabs(f1-f0).gt.eps) then
        yt=y1-f1*(y1-y0)/(f1-f0)
      endif

      else

        write(ifmt,*)'Warning in om1yrk, to much try !'

      endif

      if(dabs(y-yt).gt.dely/2.d0) then
        yt=(y1+y0)/2.D0
      endif
      dely=dabs(y-yt)  
      if(dabs(y).gt.eps)then
        prec=dely/dabs(y)
      else
        prec=dely
      endif

      if (prec.gt.1.d-3.and.dabs(f1-f0).gt.eps.and.ntry.le.1000) then
	 y=yt
	 ntry=ntry+1
         goto 111
      endif
      
      om1yrk=y


      return
      end	

c----------------------------------------------------------------------

      subroutine om1xyrk(k,xh,yp,iqq)

c----------------------------------------------------------------------
c  Proposal function for Womegak
c----------------------------------------------------------------------
      double precision xh,yp,om1xrk,om1yrk,om1xprk,om1xmrk,xp,xm,eps
      parameter(eps=1.d-20)

      xh=om1xrk(k,iqq)
      yp=om1yrk(xh,k,iqq)
      if(iqq.eq.4)then
        xp=om1xprk(k,iqq)
        xm=om1xmrk(xp,k,iqq)
        xh=xp*xm
        yp=0.d0
        if(xm.gt.eps.and.xp.gt.eps)yp=0.5D0*dlog(xp/xm)
      elseif(iqq.eq.5)then
        xm=om1xprk(k,4)
        xp=om1xmrk(xm,k,4)
        xh=xp*xm
        yp=0.d0
        if(xm.gt.eps.and.xp.gt.eps)yp=0.5D0*dlog(xp/xm)
      endif

      
      return
      end



c$$$c----------------------------------------------------------------------
c$$$
c$$$      subroutine om1xyrk(k,xh,yp,iqq)
c$$$
c$$$c----------------------------------------------------------------------
c$$$c  Proposal function for Womegak
c$$$c----------------------------------------------------------------------
c$$$      include "nexus.inc"
c$$$      include "nexus.incems"
c$$$      common/cgtilde/atilde(ntymi:ntymx,kollmx)
c$$$     &,btildep(ntymi:ntymx,kollmx),btildepp(ntymi:ntymx,kollmx)
c$$$     &              ,atildg(nbpDf0:nbpDf1,kollmx)
c$$$     &,btildgpp(nbpDf0:nbpDf1,kollmx),btildgp(nbpDf0:nbpDf1,kollmx)
c$$$      double precision atilde,btildep,btildepp,atildg,btildgp,btildgpp
c$$$      double precision xh,yp,om1xrk,om1yrk,Womegak,Womtilde
c$$$     &,gamom,deltap,deltam,delta,alpp
c$$$
c$$$      n=0
c$$$
c$$$ 10   continue
c$$$      if(n.gt.1000)then
c$$$        write(ifmt,*)"Too many statement in om1xyrk, put xh=0 for ",iqq
c$$$        xh=0.d0
c$$$        yp=0.d0
c$$$        return
c$$$      endif
c$$$      n=n+1
c$$$      xh=om1xrk(k,iqq)
c$$$      yp=om1yrk(xh,k,iqq)
c$$$      if(iqq.ge.4)then
c$$$        Womtilde=0.d0
c$$$        if(iscreen.eq.0)then
c$$$          imin=ntymi
c$$$          imax=1
c$$$        elseif(iqq.eq.4)then
c$$$          imin=9
c$$$          imax=11
c$$$        elseif(iqq.eq.5)then
c$$$          imin=12
c$$$          imax=14
c$$$        else
c$$$          stop"Wrong iqq in om1xyrk"
c$$$        endif
c$$$
c$$$        do i=imin,imax
c$$$          if(iqq.eq.4.and.i.eq.11)then
c$$$            gamom=atilde(13,k)
c$$$            deltap=btildep(13,k)
c$$$            deltam=btildepp(13,k)
c$$$          elseif(iqq.eq.5.and.i.eq.13)then
c$$$            gamom=atilde(11,k)
c$$$            deltap=btildep(11,k)
c$$$            deltam=btildepp(11,k)
c$$$          else
c$$$            gamom=atilde(i,k)
c$$$            deltap=btildep(i,k)
c$$$            deltam=btildepp(i,k)
c$$$          endif
c$$$          
c$$$          delta=(deltap+deltam)/2.d0
c$$$          alpp=deltap-deltam
c$$$          Womtilde=Womtilde+gamom*xh**delta*dexp(alpp*yp)
c$$$
c$$$
c$$$        enddo
c$$$        if(dble(rangen()).ge.Womegak(xh,yp,k,iqq)/Womtilde)goto 10
c$$$      endif
c$$$      
c$$$
c$$$      
c$$$      return
c$$$      end

c----------------------------------------------------------------------

      double precision function om2(xp,xm,b)

c----------------------------------------------------------------------
c Sum on the uncut pomerons
c xp,xm - fraction of the energy ;
c b - impact parameter between the pomeron ends;
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'

      double precision al,BeTip,BeTipp,gam,Gt
      double precision AlTi,Di,utgam2,xp,xm
      common /kfitd/ xkappafit(nclegy,nclha,nclha,2,2,20),bkbin

      Gt=0.d0
      b2=b*b
      s=engy**2
      
      do iicdp=icdp1,icdp2
      do iicdt=icdt1,icdt2
      if(isetcs.ne.1.and.iclegy.lt.iclegy2.and.b.lt.19.*bkbin)then
        ibk=int(b/bkbin)+1
        egy0=egylow*egyfac**real(iclegy)
        xkappa1=xkappafit(iclegy,iclpro,icltar,iicdp,iicdt,ibk)
     *         +(b-bkbin*real(ibk-1))/bkbin
     *           *(xkappafit(iclegy,iclpro,icltar,iicdp,iicdt,ibk+1)
     *            -xkappafit(iclegy,iclpro,icltar,iicdp,iicdt,ibk))
        xkappa2=xkappafit(iclegy+1,iclpro,icltar,iicdp,iicdt,ibk)
     *         +(b-bkbin*real(ibk-1))/bkbin
     *           *(xkappafit(iclegy+1,iclpro,icltar,iicdp,iicdt,ibk+1)
     *            -xkappafit(iclegy+1,iclpro,icltar,iicdp,iicdt,ibk))
        xkappa=xkappa1+(xkappa2-xkappa1)/(egy0*(egyfac-1.))
     *          *(sqrt(s)-egy0)
      else
        xkappa=1.
      endif
      do i=nbpDf0,nbpDf1
        gam=dble(gamD(i,iclegy,iclpro,icltar,iicdp,iicdt)*b2)
        BeTip=gam+dble(betDp(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *       -alppar)+1.d0
        BeTipp=gam+dble(betDpp(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *       -alppar)+1.d0
        gam=dble(betD(i,iclegy,iclpro,icltar,iicdp,iicdt))+gam
        al=dble(alpD(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *           *exp(-b2/delD(i,iclegy,iclpro,icltar,iicdp,iicdt)))
     *           *dble(s)**gam
	Di=utgam2(BeTip)*utgam2(BeTipp)
     *     *dble(xkappa)**2.d0
     *     *utgam2(1.d0+dble(alplea(iclpro)))
     *     *utgam2(1.d0+dble(alplea(icltar)))
     *     /utgam2(1.d0+dble(alplea(iclpro))+BeTip)
     *     /utgam2(1.d0+dble(alplea(icltar))+BeTipp)
	   AlTi=al*Di
	   Gt=Gt+AlTi*xp**BeTip*xm**BeTipp
     *  *dble(gamdp(iicdp,iclpro)*gamdt(iicdt,icltar))  
	enddo
	enddo
	enddo
	om2=dble(chad(iclpro)*chad(icltar))*Gt
	
	return
	end

c----------------------------------------------------------------------

      double precision function om3uncut(x1,x2,x3,sy,bh,bl,bhl,jj)

c----------------------------------------------------------------------
c Triple cut Eikonale (for A-A nuclear effect)
c x1 - fraction of the energy squared s for the first (+ or -) leg;
c x2 - fraction of the energy squared s for the second (+ or -) leg;
c x3 - fraction of the energy squared s for the third (- or +) leg;
c bh - impact parameter between the pomeron 1 and 2 ends;
c bl - impact parameter between the pomeron 3 end and the leg end;
c bhl - difference (vector) of impact parameter between the pomeron end and the leg end;
c jj - 1->Y diagram, 2->inversed Y diagram 
c----------------------------------------------------------------------
      double precision x1,x2,x3,dsy,ddelx,bet1,bet2,bet3,
     & alp,bet,del1,del2,del3,del,b1,b2,b12,G3p
      include 'nexus.inc'
      include 'nexus.incsem'
      common /psar7/ delx,alam3p,gam3p
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)
      common /cgtilnu/ cfbetpnp,cfbetppnp,cfbetpnm,cfbetppnm,cfalpro
     &,cfaltar,cfbpap,cfbpam,cfbppap,cfbppam
      double precision cfbetpnp,cfbetppnp,cfbetpnm,cfbetppnm,cfalpro
     &,cfaltar,cfbpap,cfbpam,cfbppap,cfbppam

      om3uncut=0.d0
      b1=dble(bh*bh)
      b2=dble(bl*bl)
      b12=dble(bhl*bhl)
      dsy=dble(sy)
      ddelx=dble(delx)
      if(dsy.le.ddelx**2.d0.or.dsy.le.Eseuil**2..or.inueff.eq.0)return

      if(jj.eq.1)then
       bet=dble(betD(2,iclegy,iclpro,icltar,icdp,icdt))
       del1=dble(delD(2,iclegy,iclpro,icltar,icdp,icdt))/3.d0
       del2=dble(delD(2,iclegy,iclpro,icltar,icdpl1,icdt))/3.d0
       del3=dble(delD(2,iclegy,iclpro,icltar,icdp,icdt))/3.d0
       del=del1*del2+del1*del3+del2*del3
       alp=dble(alpD(2,iclegy,iclpro,icltar,icdp,icdt))
     &    *(cfbetpnp*cfalpro/cfbpap)**2.d0
     &    *cfbetppnm*cfaltar/cfbppam
       bet1=1.d0+dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnup(iclegy,iclpro)-xnu(iclegy,iclpro))
       bet2=1.d0+dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnup(iclegy,iclpro)-xnu(iclegy,iclpro))
       bet3=1.d0+dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnum(iclegy,icltar)+betD1(1,iclegy,icltar))
      else
       bet=dble(betD(3,iclegy,iclpro,icltar,icdp,icdt))
       del1=dble(delD(3,iclegy,iclpro,icltar,icdp,icdt))/3.d0
       del2=dble(delD(3,iclegy,iclpro,icltar,icdp,icdtl1))/3.d0
       del3=dble(delD(3,iclegy,iclpro,icltar,icdp,icdt))/3.d0
       del=del1*del2+del1*del3+del2*del3
       alp=dble(alpD(3,iclegy,iclpro,icltar,icdp,icdt))
     &    *(cfbetpnm*cfaltar/cfbpam)**2.d0
     &    *cfbetppnp*cfalpro/cfbppap
       bet1=1.d0+dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnup(iclegy,icltar)-xnu(iclegy,icltar))
       bet2=1.d0+dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnup(iclegy,icltar)-xnu(iclegy,icltar))
       bet3=1.d0+dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnum(iclegy,iclpro)+betD1(1,iclegy,iclpro))
      endif

      G3p=alp*dsy**bet*x1**bet1*x2**bet2*x3**bet3
     *   *dexp(-del2*b1/del-del1*b2/del-del3*b12/del)


      om3uncut=2.d0*G3p                                    
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))
     *  *dble(chad(iclpro)*chad(icltar))
      if(jj.eq.1)then
        om3uncut=om3uncut*dble(gamdp(icdpl1,iclpro))
      else
        om3uncut=om3uncut*dble(gamdt(icdtl1,icltar))
      endif  
	
      om3uncut=om3uncut/2.d0            !not to double counting

      return
      end

c----------------------------------------------------------------------

      double precision function om3(xh,yp,zl,bh,bl,bhl,jj)

c----------------------------------------------------------------------
c Triple cut Eikonale (for A-A shadowing effect)
c xh - fraction of the energy squared s for the pomeron;
c zl - fraction of the energy squared s for the third leg;
c bh - impact parameter between the pomeron ends;
c bl - impact parameter between the pomeron end and the leg end;
c bhl - difference (vector) of impact parameter between the pomeron end and the leg end;
c yp - rapidity for the pomeron;
c jj - 1->Y diagram, 2->inversed Y diagram 
c----------------------------------------------------------------------
      double precision xh,yp,zl,x1,x2,x3,dsy,ddelx,bet1,bet2,bet3,
     & alp,bet,del1,del2,del3,del,b1,b2,b12,G3p
      include 'nexus.inc'
      include 'nexus.incsem'
      common /psar7/ delx,alam3p,gam3p
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)

      om3=0.d0
      if(cYfus.eq.0.d0)return
      b1=dble(bh*bh)
      b2=dble(bl*bl)
      b12=dble(bhl*bhl)
      dsy=dble(engy*engy)
      ddelx=dble(delx)
      if(dsy.le.ddelx**2.d0.or.dsy.le.Eseuil**2..or.inueff.eq.0)return
      if(jj.eq.1)then
       bet=dble(betD(2,iclegy,iclpro,icltar,icdp,icdt))
       del1=dble(delD(2,iclegy,iclpro,icltar,icdp,icdt))/3.d0
       del2=dble(delD(2,iclegy,iclpro,icltar,icdpl1,icdt))/3.d0
       del3=dble(delD(2,iclegy,iclpro,icltar,icdp,icdt))/3.d0
       del=del1*del2+del1*del3+del2*del3
       alp=dble(alpD(2,iclegy,iclpro,icltar,icdp,icdt))
       bet1=dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnup(iclegy,iclpro)-xnu(iclegy,iclpro))
       bet2=dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnup(iclegy,iclpro)-xnu(iclegy,iclpro))
       bet3=dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnum(iclegy,icltar)+betD1(1,iclegy,icltar))
       x1=dsqrt(xh)*dexp(yp)
       x3=dsqrt(xh)*dexp(-yp)
      else
       bet=dble(betD(3,iclegy,iclpro,icltar,icdp,icdt))
       del1=dble(delD(3,iclegy,iclpro,icltar,icdp,icdt))/3.d0
       del2=dble(delD(3,iclegy,iclpro,icltar,icdp,icdtl1))/3.d0
       del3=dble(delD(3,iclegy,iclpro,icltar,icdp,icdt))/3.d0
       del=del1*del2+del1*del3+del2*del3
       alp=dble(alpD(3,iclegy,iclpro,icltar,icdp,icdt))
       bet1=dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnup(iclegy,icltar)-xnu(iclegy,icltar))
       bet2=dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnup(iclegy,icltar)-xnu(iclegy,icltar))
       bet3=dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnum(iclegy,iclpro)+betD1(1,iclegy,iclpro))
       x3=dsqrt(xh)*dexp(yp)
       x1=dsqrt(xh)*dexp(-yp)
      endif
       x2=zl

      G3p=alp*dsy**bet*x1**bet1*x2**bet2*x3**bet3
     *   *dexp(-del2*b1/del-del1*b2/del-del3*b12/del)


      om3=-2.d0*cYfus*G3p                                    
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
     *  *dble(chad(iclpro)*chad(icltar))
      if(jj.eq.1)then
        om3=om3*dble(gamdp(icdpl1,iclpro))
      else
        om3=om3*dble(gamdt(icdtl1,icltar))
      endif  
	
      om3=om3/2.d0            !not to double counting

      return
      end

c----------------------------------------------------------------------

	double precision function om3x(xh,jj)
        
c----------------------------------------------------------------------
c Normalised on x,y, and z omega3 function integrated over y and z
c xh - fraction of the energy squared s for the pomeron;
c bh - impact parameter between the pomeron ends;
c bl - impact parameter between the leg and the pomeron ends;
c bhl - difference (vector) of impact parameter between the pomeron end and the leg end;
c yp - rapidity for the pomeron;
c jj - 1->Y diagram, 2->inversed Y diagram 
c----------------------------------------------------------------------
      double precision xh,dsy,ddelx,bet1,bet3,alpp,alp,eps
      parameter(eps=1.d-20)
      include 'nexus.inc'
      include 'nexus.incsem'
      common /psar7/ delx,alam3p,gam3p
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)


      om3x=0.d0
      dsy=dble(engy*engy)
      ddelx=dble(delx)
      if(dsy.le.ddelx**2.d0.or.dsy.le.Eseuil**2..or.inueff.eq.0)return
      if(jj.eq.2)then
       bet1=dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnup(iclegy,icltar)-xnu(iclegy,icltar))
       bet3=dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnum(iclegy,iclpro)+betD1(1,iclegy,iclpro))
      alpp=bet3-bet1
      else
       bet1=dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnup(iclegy,iclpro)-xnu(iclegy,iclpro))
       bet3=dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnum(iclegy,icltar)+betD1(1,iclegy,icltar))
      alpp=bet1-bet3
      endif
      alp=(bet1+bet3)/2.d0

      om3x=(1.d0+bet1)*(1.d0+bet3)
      
      if(dabs(alpp).ge.eps)then
        om3x=om3x/alpp*xh**(alp-alpp/2.d0)*(1-xh**alpp)
      else
        om3x=-om3x*dlog(xh)*xh**alp
      endif

      return
      end

c----------------------------------------------------------------------

      double precision function om3y(xh,yp,jj)

c----------------------------------------------------------------------
c Normalised on y omega3 function
c xh - fraction of the energy squared s for the pomeron;
c bh - impact parameter between the pomeron ends;
c bl - impact parameter between the leg and the pomeron ends;
c yp - rapidity for the pomeron;
c bhl - difference (vector) of impact parameter between the pomeron end and the leg end;
c jj - 1->Y diagram, 2->inversed Y diagram 
c----------------------------------------------------------------------
      double precision xh,yp,dsy,ddelx,bet1,bet3,alpp,alp
      include 'nexus.inc'
      include 'nexus.incsem'
      common /psar7/ delx,alam3p,gam3p
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)


      om3y=0.d0
      dsy=dble(engy*engy)
      ddelx=dble(delx)
      if(dsy.le.ddelx**2.d0.or.dsy.le.Eseuil**2..or.inueff.eq.0)return
      if(jj.eq.2)then
       bet1=dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnup(iclegy,icltar)-xnu(iclegy,icltar))
       bet3=dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnum(iclegy,iclpro)+betD1(1,iclegy,iclpro))
      alpp=bet3-bet1
      else
       bet1=dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnup(iclegy,iclpro)-xnu(iclegy,iclpro))
       bet3=dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnum(iclegy,icltar)+betD1(1,iclegy,icltar))
      alpp=bet1-bet3
      endif
      alp=(bet1+bet3)/2.d0

      om3y=(1.d0+bet1)*(1.d0+bet3)*xh**alp*dexp(alpp*yp)

      return
      end

c----------------------------------------------------------------------

      double precision function om3z(xh,yp,zl,jj)

c----------------------------------------------------------------------
c Normalised on zl omega3 function
c xh - fraction of the energy squared s for the pomeron;
c bh - impact parameter between the pomeron ends;
c bl - impact parameter between the pomeron end and the leg end;
c yp - rapidity for the pomeron;
c bhl - difference (vector) of impact parameter between the pomeron end and the leg end;
c jj - 1->Y diagram, 2->inversed Y diagram 
c----------------------------------------------------------------------
      double precision xh,yp,zl,dsy,ddelx,bet1,bet2,bet3,alpp,alp
      include 'nexus.inc'
      include 'nexus.incsem'
      common /psar7/ delx,alam3p,gam3p
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)


      om3z=0.d0
      dsy=dble(engy*engy)
      ddelx=dble(delx)
      if(dsy.le.ddelx**2.d0.or.dsy.le.Eseuil**2..or.inueff.eq.0)return
      if(jj.eq.2)then
       bet1=dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnup(iclegy,icltar)-xnu(iclegy,icltar))
       bet2=dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnup(iclegy,icltar)-xnu(iclegy,icltar))
       bet3=dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnum(iclegy,iclpro)+betD1(1,iclegy,iclpro))
      alpp=bet3-bet1
      else
       bet1=dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnup(iclegy,iclpro)-xnu(iclegy,iclpro))
       bet2=dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnup(iclegy,iclpro)-xnu(iclegy,iclpro))
       bet3=dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnum(iclegy,icltar)+betD1(1,iclegy,icltar))
      alpp=bet1-bet3
      endif
      alp=(bet1+bet3)/2.d0

      om3z=(1.d0+bet1)*(1.d0+bet2)*(1.d0+bet3)*xh**alp*dexp(alpp*yp)
     &    *zl**bet2

      return
      end

c----------------------------------------------------------------------

      double precision function om3intb(bh,bl,bhl,jj)

c----------------------------------------------------------------------
c  Set integrated over x1, x2 and x3 of omega3 for given b's
c bhl - difference (vector) of impact parameter between the pomeron end 
c and the leg end;
c jj - 1->Y diagram, 2->inversed Y diagram 
c----------------------------------------------------------------------
      double precision dsy,ddelx,bet1,bet2,bet3,coef1,coef2,coef3
     & ,alp,bet,del1,del2,del3,del,b1,b2,b12,G3p,eps
      parameter(eps=1.d-20)
      include 'nexus.inc'
      include 'nexus.incsem'
      common /psar7/ delx,alam3p,gam3p
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)

      om3intb=0.d0
      if(cYfus.eq.0.d0)return
      b1=dble(bh*bh)
      b2=dble(bl*bl)
      b12=dble(bhl*bhl)
      ddelx=dble(delx)
      dsy=dble(engy*engy)
      ddelx=dble(delx)
      if(dsy.le.ddelx**2.d0.or.dsy.le.Eseuil**2..or.inueff.eq.0)return
      if(jj.eq.1)then
       bet=dble(betD(2,iclegy,iclpro,icltar,icdp,icdt))
       del1=dble(delD(2,iclegy,iclpro,icltar,icdp,icdt))/3.d0
       del2=dble(delD(2,iclegy,iclpro,icltar,icdpl1,icdt))/3.d0
       del3=dble(delD(2,iclegy,iclpro,icltar,icdp,icdt))/3.d0
       del=del1*del2+del1*del3+del2*del3
       alp=dble(alpD(2,iclegy,iclpro,icltar,icdp,icdt))
       bet1=dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnup(iclegy,iclpro)-xnu(iclegy,iclpro))
       bet2=dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnup(iclegy,iclpro)-xnu(iclegy,iclpro))
       bet3=dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnum(iclegy,icltar)+betD1(1,iclegy,icltar))
      else
       bet=dble(betD(3,iclegy,iclpro,icltar,icdp,icdt))
       del1=dble(delD(3,iclegy,iclpro,icltar,icdp,icdt))/3.d0
       del2=dble(delD(3,iclegy,iclpro,icltar,icdp,icdtl1))/3.d0
       del3=dble(delD(3,iclegy,iclpro,icltar,icdp,icdt))/3.d0
       del=del1*del2+del1*del3+del2*del3
       alp=dble(alpD(3,iclegy,iclpro,icltar,icdp,icdt))
       bet1=dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnup(iclegy,icltar)-xnu(iclegy,icltar))
       bet2=dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnup(iclegy,icltar)-xnu(iclegy,icltar))
       bet3=dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnum(iclegy,iclpro)+betD1(1,iclegy,iclpro))
      endif
      coef1=1.d0+bet1
      coef2=1.d0+bet2
      coef3=1.d0+bet3

      G3p=alp*dsy**bet/coef1/coef2/coef3
     *   *dexp(-del2*b1/del-del1*b2/del-del3*b12/del)


      om3intb=-2.d0*cYfus*G3p                                   
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
     *  *dble(chad(iclpro)*chad(icltar))
      if(jj.eq.1)then
        om3intb=om3intb*dble(gamdp(icdpl1,iclpro))
      else
        om3intb=om3intb*dble(gamdt(icdtl1,icltar))
      endif  
	
      om3intb=om3intb/2.d0            !not to double counting

      if(om3intb.lt.-eps)then
        write(*,*)'WARNING ! om3intb in nexus-omg is negative or 0!!'
      endif
	
      return 
      end


c----------------------------------------------------------------------

      double precision function om3intbc(bh,bl,bhl,jj)

c----------------------------------------------------------------------
c  Set integrated over x1, x2 and x3 of omega3*F*F*F UNCUT for given 
c b's (used by conb2mx, not for cut pomeron).
c bhl - difference (vector) of impact parameter between the pomeron end 
c and the leg end;
c jj - 1->Y diagram, 2->inversed Y diagram 
c----------------------------------------------------------------------
      double precision dsy,ddelx,bet1,bet2,bet3,coef1,coef2,coef3
     & ,alp,bet,del1,del2,del3,del,b1,b2,b12,coefp,coeft,alppro,alptar
     & ,utgam2,G3p,eps
      parameter(eps=1.d-20)
      include 'nexus.inc'
      include 'nexus.incsem'
      common /psar7/ delx,alam3p,gam3p
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)

      om3intbc=0.d0
      b1=dble(bh*bh)
      b2=dble(bl*bl)
      b12=dble(bhl*bhl)
      ddelx=dble(delx)
      dsy=dble(engy*engy)
      ddelx=dble(delx)
      if(dsy.le.ddelx**2.d0.or.dsy.le.Eseuil**2..or.inueff.eq.0)return
      alppro=dble(alplea(iclpro))
      alptar=dble(alplea(icltar))
      coefp=utgam2(1.d0+alppro)
      coeft=utgam2(1.d0+alptar)

      if(jj.eq.1)then
       bet=dble(betD(2,iclegy,iclpro,icltar,icdp,icdt))
       del1=dble(delD(2,iclegy,iclpro,icltar,icdp,icdt))/3.d0
       del2=dble(delD(2,iclegy,iclpro,icltar,icdpl1,icdt))/3.d0
       del3=dble(delD(2,iclegy,iclpro,icltar,icdp,icdt))/3.d0
       del=del1*del2+del1*del3+del2*del3
       alp=dble(alpD(2,iclegy,iclpro,icltar,icdp,icdt))
       bet1=dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnup(iclegy,iclpro)+betD1(1,iclegy,iclpro))
       bet2=dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnup(iclegy,iclpro)+betD1(1,iclegy,iclpro))
       bet3=dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnum(iclegy,icltar)+betD1(1,iclegy,icltar))
       coef2=utgam2(1.d0+bet2)*coefp/utgam2(2.d0+bet2+alppro)
      else
       bet=dble(betD(3,iclegy,iclpro,icltar,icdp,icdt))
       del1=dble(delD(3,iclegy,iclpro,icltar,icdp,icdt))/3.d0
       del2=dble(delD(3,iclegy,iclpro,icltar,icdp,icdtl1))/3.d0
       del3=dble(delD(3,iclegy,iclpro,icltar,icdp,icdt))/3.d0
       del=del1*del2+del1*del3+del2*del3
       alp=dble(alpD(3,iclegy,iclpro,icltar,icdp,icdt))
       bet3=dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnup(iclegy,icltar)-xnu(iclegy,icltar))
       bet2=dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnup(iclegy,icltar)-xnu(iclegy,icltar))
       bet1=dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnum(iclegy,iclpro)+betD1(1,iclegy,iclpro))
       coef2=utgam2(1.d0+bet2)*coeft/utgam2(2.d0+bet2+alptar)
      endif
       coef1=utgam2(1.d0+bet1)*coefp/utgam2(2.d0+bet1+alppro)
       coef3=utgam2(1.d0+bet3)*coeft/utgam2(2.d0+bet3+alptar)

      G3p=alp*dsy**bet*coef1*coef2*coef3
     *   *dexp(-del2*b1/del-del1*b2/del-del3*b12/del)


      om3intbc=dabs(2.d0*G3p)             ! uncut triple Pomeron nucl.
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
     *  *dble(chad(iclpro)*chad(icltar))
      if(jj.eq.1)then
        om3intbc=om3intbc*dble(gamdp(icdpl1,iclpro))
      else
        om3intbc=om3intbc*dble(gamdt(icdtl1,icltar))
      endif  
	
      om3intbc=om3intbc/2.d0            !not to double counting

      if(om3intbc.lt.-eps)then
        write(*,*)'WARNING ! om3intbc in nexus-omg is negative!!'
      endif
	
      return 
      end

c$$$c----------------------------------------------------------------------
c$$$
c$$$      double precision function om3intbc(bh,bl,bhl,jj)
c$$$
c$$$c----------------------------------------------------------------------
c$$$c  Set integrated over x1, x2 and x3 of omega3*F*F*F for given b's 
c$$$c bhl - difference (vector) of impact parameter between the pomeron end 
c$$$c and the leg end;
c$$$c jj - 1->Y diagram, 2->inversed Y diagram 
c$$$c----------------------------------------------------------------------
c$$$      double precision dsy,ddelx,coef1,coef2,coef3,G3p
c$$$     & ,alp,bet,del1,del2,del3,del,b1,b2,b12
c$$$      include 'nexus.inc'
c$$$      include 'nexus.incsem'
c$$$      common /psar7/ delx,alam3p,gam3p
c$$$      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
c$$$     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
c$$$     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
c$$$      common /cgtilnu/ cfbetpnp,cfbetppnp,cfbetpnm,cfbetppnm,cfalpro
c$$$     &,cfaltar,cfbpap,cfbpam,cfbppap,cfbppam
c$$$      double precision cfbetpnp,cfbetppnp,cfbetpnm,cfbetppnm,cfalpro
c$$$     &,cfaltar,cfbpap,cfbpam,cfbppap,cfbppam
c$$$
c$$$      om3intbc=0.d0
c$$$      b1=dble(bh*bh)
c$$$      b2=dble(bl*bl)
c$$$      b12=dble(bhl*bhl)
c$$$      ddelx=dble(delx)
c$$$      dsy=dble(engy*engy)
c$$$      ddelx=dble(delx)
c$$$      if(dsy.le.ddelx**2.or.dsy.le.Eseuil**2..or.iscreen.eq.0)return
c$$$
c$$$      if(jj.eq.1)then
c$$$       bet=dble(betD(2,iclegy,iclpro,icltar,icdp,icdt))
c$$$       del1=dble(delD(2,iclegy,iclpro,icltar,icdp,icdt))/3.d0
c$$$       del2=dble(delD(2,iclegy,iclpro,icltar,icdpl1,icdt))/3.d0
c$$$       del3=dble(delD(2,iclegy,iclpro,icltar,icdp,icdt))/3.d0
c$$$       del=del1*del2+del1*del3+del2*del3
c$$$       alp=dble(alpD(2,iclegy,iclpro,icltar,icdp,icdt))
c$$$       coef1=cfbetpnp*cfalpro/cfbpap
c$$$       coef2=cfbetpnp*cfalpro/cfbpap
c$$$       coef3=cfbetppnm*cfaltar/cfbppam
c$$$      else
c$$$       bet=dble(betD(3,iclegy,iclpro,icltar,icdp,icdt))
c$$$       del1=dble(delD(3,iclegy,iclpro,icltar,icdp,icdt))/3.d0
c$$$       del2=dble(delD(3,iclegy,iclpro,icltar,icdp,icdtl1))/3.d0
c$$$       del3=dble(delD(3,iclegy,iclpro,icltar,icdp,icdt))/3.d0
c$$$       del=del1*del2+del1*del3+del2*del3
c$$$       alp=dble(alpD(3,iclegy,iclpro,icltar,icdp,icdt))
c$$$       coef1=cfbetpnm*cfaltar/cfbpam
c$$$       coef2=cfbetpnm*cfaltar/cfbpam
c$$$       coef3=cfbetppnp*cfalpro/cfbppap
c$$$      endif
c$$$
c$$$      G3p=alp*dsy**bet*coef1*coef2*coef3
c$$$     *   *dexp(-del2*b1/del-del1*b2/del-del3*b12/del)
c$$$
c$$$
c$$$      om3intbc=-4.d0*G3p                 
c$$$     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
c$$$      if(jj.eq.1)then
c$$$        om3intbc=om3intbc*dble(gamdp(icdpl1,iclpro))
c$$$      else
c$$$        om3intbc=om3intbc*dble(gamdt(icdtl1,icltar))
c$$$      endif  
c$$$	
c$$$      om3intbc=om3intbc/2.d0            !not to double counting
c$$$
c$$$      if(om3intbc.le.0.d0)then
c$$$        write(*,*)'WARNING ! om3intbc in nexus-omg is negative or 0!!'
c$$$      endif
c$$$	
c$$$      return 
c$$$      end

c----------------------------------------------------------------------

      double precision function om3xr(jj)

c----------------------------------------------------------------------
c Random number generated from the function om3x. We solve the equation
c which give om3xr by Newton-Raphson + secant method.
c jj - 1->Y diagram, 2->inversed Y diagram 
c----------------------------------------------------------------------
      double precision dsy,ddelx,bet1,bet3,alpp,alp
      include 'nexus.inc'
      include 'nexus.incsem'
      common /psar7/ delx,alam3p,gam3p
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)
      double precision x,x0,x1,gamp,gampp,eps,betp,betpp
      double precision xt,fx,fpx,r,f1,f0,deltax,prec
      parameter (eps=1.d-20)


      om3xr=0.d0
      dsy=dble(engy*engy)
      ddelx=dble(delx)
      if(dsy.le.ddelx**2.d0.or.dsy.le.Eseuil**2..or.inueff.eq.0)return
      if(jj.eq.2)then
       bet1=dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnup(iclegy,icltar)-xnu(iclegy,icltar))
       bet3=dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnum(iclegy,iclpro)+betD1(1,iclegy,iclpro))
      alpp=bet3-bet1
      else
       bet1=dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnup(iclegy,iclpro)-xnu(iclegy,iclpro))
       bet3=dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnum(iclegy,icltar)+betD1(1,iclegy,icltar))
      alpp=bet1-bet3
      endif
      alp=(bet1+bet3)/2.d0

      gamp=1.d0+bet1
      gampp=1.d0+bet3
      betp=1.d0+alp+alpp/2.d0
      betpp=1.d0+alp-alpp/2.d0

         
c Integration possible only if delta(i)>-1

      if(dabs(betp).lt.eps.or.dabs(betpp).lt.eps.or.        
     &   dabs(alp+1.d0).lt.eps)call utstop
     &  ('Error(1) in nexus-omg in om3xr&')
              
      r=dble(rangen())
         
      x0=2.d0*eps
      x1=1.d0
      if(dabs(alpp).gt.eps)then
        f0=gamp*gampp/alpp/betpp*x0**betpp
     &        *(1.d0-betpp/betp*x0**alpp)
        f1=gamp*gampp/alpp/betpp*x1**betpp
     &        *(1.d0-betpp/betp*x1**alpp)
      else
        f0=gamp*gampp/(alp+1.d0)*x0**(alp+1.d0)
     &        *(1.d0/(alp+1.d0)-dlog(x0))
        f1=gamp*gampp/(alp+1.d0)*x1**(alp+1.d0)
     &        *(1.d0/(alp+1.d0)-dlog(x1))
      endif
      f0=f0-r
      f1=f1-r
c      write(*,*)r,f1,f0,bet3,bet1,alpp,alp
      if(f1*f0.gt.eps)call utstop('Error(2) in nexus-omg in om3xr&')
      if(dabs(f0).lt.eps) then
        om3xr=x0
        return
      endif 
      if(dabs(f1).lt.eps) then
        om3xr=x1
        return
      endif 
c      x=(x1+x0)/2.D0
      x=dsqrt(x1*x0)
      deltax=dabs(x1-x0)  

      ntry=0

 111  continue
      if(ntry.le.1000)then
      if(dabs(alpp).gt.eps)then
        fx=gamp*gampp/alpp/betpp*x**betpp
     &        *(1.d0-betpp/betp*x**alpp)
        fpx=gamp*gampp/alpp*x**(betpp-1.d0)*(1.d0-x**alpp)
      else
        fx=gamp*gampp/(alp+1.d0)*x**(alp+1.d0)
     &        *(1.d0/(alp+1.d0)-dlog(x))
        fpx=-gamp*gampp*dlog(x)*x**alp
      endif
      fx=fx-r
      fpx=fpx
      xt=x-fx/fpx
      
      if (f0*fx.lt.-eps) then
        f1=fx
        x1=x
      else
        f0=fx
        x0=x
      endif
      if ((xt.lt.x0-eps.or.xt.gt.x1+eps).and.dabs(f1-f0).gt.eps) then
        xt=x1-f1*(x1-x0)/(f1-f0)
      endif

      else

        write(ifmt,*)'Warning in om3xr, to much try !'

      endif

      if(dabs(x-xt).gt.deltax/2.d0) then
        xt=dsqrt(x1*x0)
      endif
      deltax=dabs(x-xt)  
      if(dabs(x).gt.eps)then
        prec=deltax/x
      else
        call utstop('Problem in om3xr&')
      endif

      if (prec.gt.1.d-3.and.dabs(f1-f0).gt.eps.and.ntry.le.1000) then
	 x=xt
	 ntry=ntry+1
         goto 111
      endif
      
      om3xr=x

      return
      end	


c----------------------------------------------------------------------

      double precision function om3yr(xh,jj)

c----------------------------------------------------------------------
c Random number generated from the function om3y(x,y). We solve the 
c equation which give om3yr.
c xh - fraction of the energy squared s for the pomeron;
c jj - 1->Y diagram, 2->inversed Y diagram 
c----------------------------------------------------------------------
      double precision xh,dsy,ddelx,alpp,r,bet1,bet3,eps
      parameter(eps=1.d-20)
      include 'nexus.inc'
      include 'nexus.incsem'
      common /psar7/ delx,alam3p,gam3p
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)


      om3yr=0.d0
      dsy=dble(engy*engy)
      ddelx=dble(delx)
      if(dsy.le.ddelx**2.d0.or.dsy.le.Eseuil**2..or.inueff.eq.0)return
      if(jj.eq.2)then
       bet1=dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnup(iclegy,icltar)-xnu(iclegy,icltar))
       bet3=dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnum(iclegy,iclpro)+betD1(1,iclegy,iclpro))
      alpp=bet3-bet1
      else
       bet1=dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnup(iclegy,iclpro)-xnu(iclegy,iclpro))
       bet3=dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnum(iclegy,icltar)+betD1(1,iclegy,icltar))
      alpp=bet1-bet3
      endif

      r=dble(rangen())

      if(dabs(alpp).gt.eps.and.xh.lt.1.d0-eps)then
        om3yr=dlog((1.d0-xh**alpp)/xh**(alpp/2.d0)
     &      *(r+xh**alpp/(1.d0-xh**alpp)))/alpp
      elseif(xh.gt.eps)then
        om3yr=(0.5d0-r)*dlog(xh)
      else
        om3yr=(0.5d0-r)*dble(yhaha)
      endif

      return
      end

c----------------------------------------------------------------------

      double precision function om3zr(jj)

c----------------------------------------------------------------------
c Random number generated from the function om3z. We solve the equation
c which give om3zr.
c bh and bl - impact parameter between the pomeron ends;
c bhl - difference (vector) of impact parameter between the pomeron end and the leg end;
c jj - 1->Y diagram, 2->inversed Y diagram 
c----------------------------------------------------------------------
      double precision dsy,ddelx,bet2,r
      include 'nexus.inc'
      include 'nexus.incsem'
      common /psar7/ delx,alam3p,gam3p
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)


      om3zr=0.d0
      dsy=dble(engy*engy)
      ddelx=dble(delx)
      if(dsy.le.ddelx**2.d0.or.dsy.le.Eseuil**2..or.inueff.eq.0)return
      if(jj.eq.2)then
       bet2=dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnup(iclegy,icltar)-xnu(iclegy,icltar))
      else
       bet2=dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnup(iclegy,iclpro)-xnu(iclegy,iclpro))
      endif

      r=dble(rangen())
      om3zr=r**(1.d0/(bet2+1.d0))

      return
      end

c----------------------------------------------------------------------

      subroutine om3xyzr(xh,yp,zl,jj)

c----------------------------------------------------------------------
c  Proposal function
c----------------------------------------------------------------------
      include "nexus.inc"
      double precision xh,yp,zl,om3xr,om3yr,om3zr


        xh=om3xr(jj)
        yp=om3yr(xh,jj)
        zl=om3zr(jj)

      
      return
      end


c----------------------------------------------------------------------

      double precision function omIuncut(sy,xh,yp,b,iqq)

c----------------------------------------------------------------------
c - chi~(x,y) for uncut I diagram (simple Pomeron)
c sy - (=xh*s) fraction of the energy squared s for the pomeron;
c xh - momentum fraction of the pomeron;
c b - impact parameter between the pomeron ends;
c yp - rapidity for the pomeron;
c iqq=0 - ideal diagram (fit of semi-hard)
c iqq=1 - real diagram (sergej)
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'

      double precision Df,xh,yp,om1p

      b2=b*b
      omIuncut=0.d0

      if(iqq.eq.0)then
        Df=0.d0
        do i=0,1
        Df=Df+dble(alpD(i,iclegy,iclpro,icltar,icdp,icdt)
     *         *sy**(betD(i,iclegy,iclpro,icltar,icdp,icdt)
     *              +gamD(i,iclegy,iclpro,icltar,icdp,icdt)*b2)
     *         *exp(-b2/delD(i,iclegy,iclpro,icltar,icdp,icdt)))
        enddo

        omIuncut=Df*xh**dble(-alppar)
     *          *dble(chad(iclpro)*chad(icltar))
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
	
      else
        do i=0,4
          omIuncut=omIuncut+2.d0*om1p(sy,xh,yp,b,i)
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
        enddo
      endif

      return
      end

c----------------------------------------------------------------------

      double precision function omIcut(xh,yp,b,iqq)

c----------------------------------------------------------------------
c - chi~(x,y)/2 for cut I diagram (simple Pomeron)
c xh - fraction of the energy squared s for the pomeron;
c b - impact parameter between the pomeron ends;
c yp - rapidity for the pomeron;
c iqq=0 - ideal diagram (fit of semi-hard)
c iqq=1 - real diagram (sergej)
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'

      double precision Df,xp,xm,xh,yp,om1p

      Df=0.d0
      b2=b*b
      sy=engy*engy
      omIcut=0.d0

      if(xh.le.0.d0.or.xh.gt.1.d0)return
      if(iqq.eq.0)then
      xp=dsqrt(xh)*dexp(yp)
      xm=xh/xp
      imax=1
      do i=nbpDf0,imax
        Df=Df+dble(alpD(i,iclegy,iclpro,icltar,icdp,icdt)
     *              *real(xp)**(betDp(i,iclegy,iclpro,icltar,icdp,icdt)
     *                      +gamD(i,iclegy,iclpro,icltar,icdp,icdt)*b2)
     *              *real(xm)**(betDpp(i,iclegy,iclpro,icltar,icdp,icdt)
     *                       +gamD(i,iclegy,iclpro,icltar,icdp,icdt)*b2)
     *              *sy**(betD(i,iclegy,iclpro,icltar,icdp,icdt)
     *               +gamD(i,iclegy,iclpro,icltar,icdp,icdt)*b2)
     *              *exp(-b2/delD(i,iclegy,iclpro,icltar,icdp,icdt)))
      enddo

      omIcut=2.d0*xh**dble(-alppar)*Df/2.d0
     *      *dble(chad(iclpro)*chad(icltar))
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
	
      else
        do i=0,4
          omIcut=omIcut+2.d0*om1p(sy*real(xh),xh,yp,b,i)
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
        enddo
      endif

      omIcut=omIcut/2.d0

      return
      end

c----------------------------------------------------------------------

      double precision function omIcutJ(xh,yp,b,iqq)

c----------------------------------------------------------------------
c - chi~(x,y)/2 for cut I diagram (simple Pomeron)
c xh - fraction of the energy squared s for the pomeron;
c b - impact parameter between the pomeron ends;
c yp - rapidity for the pomeron;
c iqq=0 - soft
c iqq=1 - gg
c iqq=2 - qg
c iqq=3 - gq
c iqq=4 - qq
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'

      double precision xh,yp,om1p

      sy=engy*engy
      omIcutJ=0.d0

      if(xh.le.0.d0.or.xh.gt.1.d0)return
      if(iqq.le.4)then
          omIcutJ=2.d0*om1p(sy*real(xh),xh,yp,b,iqq)
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar)) 
          else
            call utstop('wrong iqq in omIcutJ&')
      endif

      omIcutJ=omIcutJ/2.d0

      return
      end

c----------------------------------------------------------------------

      double precision function omIgamint(b,iqq)

c----------------------------------------------------------------------
c - integrated chi~(b)FF/2 for cut I diagram (simple Pomeron)
c b - impact parameter between the pomeron ends;
c yp - rapidity for the pomeron;
c iqq=0 effective one
c iqq=1 soft
c iqq=2 gg
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)

      double precision Df

      Df=0.d0
      b2=b*b
      sy=engy*engy
      omIgamint=0.d0
      imax=1

      if(iqq.eq.0)then
        coefp=1.+alplea(iclpro)
        coeft=1.+alplea(icltar)

        do i=nbpDf0,imax
          betp=1.+betDp(i,iclegy,iclpro,icltar,icdp,icdt)-alppar
     *         +gamD(i,iclegy,iclpro,icltar,icdp,icdt)*b2
          betpp=1.+betDpp(i,iclegy,iclpro,icltar,icdp,icdt)-alppar
     *         +gamD(i,iclegy,iclpro,icltar,icdp,icdt)*b2

          Df=dble(alpD(i,iclegy,iclpro,icltar,icdp,icdt)
     *         *sy**(betD(i,iclegy,iclpro,icltar,icdp,icdt)
     *         +gamD(i,iclegy,iclpro,icltar,icdp,icdt)*b2)
     *         *exp(-b2/delD(i,iclegy,iclpro,icltar,icdp,icdt)))
          if(iAGKch.eq.1)then   !Theoric check
            Df=Df*(dlog(dble(100.*sy))-1.d0)**2.d0
          else
            Df=Df*dble(utgam1(betp)*utgam1(betpp)*utgam1(coefp)
     *           *utgam1(coeft)/utgam1(betp+coefp)/utgam1(betpp+coeft))
          endif
          
          omIgamint=omIgamint+Df
        enddo

      elseif(iqq.le.2)then

        betp=1.+betD2(iqq,iclegy)-alppar
        betpp=1.+betD2(iqq,iclegy)-alppar
        coefp=1.+alplea(iclpro)
        coeft=1.+alplea(icltar)

        omIgamInt=dble(alpD2(iqq,iclegy)
     *       *utgam1(betp)*utgam1(betpp)*utgam1(coefp)*utgam1(coeft)
     *       /utgam1(betp+coefp)/utgam1(betpp+coeft)
     *       *sy**betD2(iqq,iclegy)
     *       *exp(-b2/delD2(iqq,iclegy)))

      else
        call utstop('Wrong iqq in omIgamint&')
      endif

      omIgamint=2.d0*omIgamint/2.d0
     *     *dble(chad(iclpro)*chad(icltar))
     *     *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  

      omIgamint=omIgamint/2.d0

      return
      end


c-----------------------------------------------------------------------
      double precision function omXuncut(sy,xh,yp,b,iqq)
c-----------------------------------------------------------------------
c - chi~(x,y)/2 for uncut X enhanced diagram
c xh - fraction of the energy squared s for the pomeron;
c yp - rapidity for the pomeron;
c b - impact parameter between the pomeron ends;
c iqq=0 ideal G
c iqq=1 exact G
c-----------------------------------------------------------------------
      double precision omXuncutJ,xh,yp

      if(iqq.eq.0)then
        omXuncut=omXuncutJ(sy,xh,yp,b,1,1,1,1,1,1,1,1)
      else
        omXuncut=omXuncutJ(sy,xh,yp,b,2,4,2,4,2,4,2,4)
      endif

      return
      end

c-----------------------------------------------------------------------
      double precision function omXuncutJ(sy,xh,yp,b,min1,max1,min2,max2
     &                                   ,min3,max3,min4,max4)
c-----------------------------------------------------------------------
c - chi~(x,y)/2 for uncut X enhanced diagram
c xh - fraction of the energy squared s for the pomeron;
c yp - rapidity for the pomeron;
c b - impact parameter between the pomeron ends;
c mini, maxi = 1 - G1 for ideal G (all min/max set to 1)
c              2 - soft G1
c              3 - semihard G1
c              4 - valence G1
c min1/max1 and min2/max2 - parallel legs +
c min3/max3 and min4/max4 - parallel legs -
c-----------------------------------------------------------------------
      double precision xh,yp,xp,xm,dsy,ddelx,alp1,alp2,alp3,alp4,
     & del1,del2,del3,del4,dps,utgam2,r4pomp
      include 'nexus.inc'
      include 'nexus.incsem'
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar7/ delx,alam3p,gam3p
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)


      b2=b*b
      
      gamb=gamD(1,iclegy,iclpro,icltar,icdp,icdt)
      alp=xmu(3)      
      betv=xnu(iclegy,iclpro)+gamb*b2/2.
      betp=betD1(1,iclegy,iclpro)+betv
      betm=betD1(1,iclegy,icltar)+betv
      gamp=betDp1(1,iclegy,iclpro)-alppar+xnup(iclegy,iclpro)
      gamm=betDp1(1,iclegy,icltar)-alppar+xnup(iclegy,icltar)
      del=delD1(1,iclegy,iclpro)

      r4pomp=dble(4.*0.0389*gamhad(iclpro)**2.*gamhad(icltar)**2.
     *      *utgam1(2.+2.*betp)/utgam1(1.+betp)**2.
     *      *utgam1(2.+2.*betm)/utgam1(1.+betm)**2.
     *      *utgam1(2.+2.*betp+2.*gamp)/utgam1(1.+betp+gamp)**2.
     *      *utgam1(2.+2.*betm+2.*gamm)/utgam1(1.+betm+gamm)**2.
     *      /pi*del**3./log(sy/delx/delx)/(alp*del)**4.*xmu(2))
     *      /dble(chad(iclpro)*chad(icltar))

      dsy=dble(sy)
      ddelx=dble(delx)
      xp=dsqrt(xh)*dexp(yp)
      if(xp.ne.0.d0)then
        xm=xh/xp
      else
        xm=0.d0
      endif

      omXuncutJ=0.d0

c 1st order, 2 proj legs, 2 targ legs, 0 loops

      if(dsy.gt.ddelx**2.and.dsy.gt.Eseuil**2.and.iscreen.ne.0)then
       

      do i1=min1,max1
        del1=dble(betD1(i1,iclegy,iclpro))
        if(i1.eq.1)del1=del1+dble(betv)
        alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &            +dble(xnup(iclegy,iclpro))
	rh1=delD1(i1,iclegy,iclpro)
      do i2=min2,max2
        del2=dble(betD1(i2,iclegy,iclpro))
        if(i2.eq.1)del2=del2+dble(betv)
        alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &            +dble(xnup(iclegy,iclpro))
	rh2=delD1(i2,iclegy,iclpro)
	rh12=rh1*rh2/(rh1+rh2)
      do i3=min3,max3
        del3=dble(betD1(i3,iclegy,icltar))
        if(i3.eq.1)del3=del3+dble(betv)
        alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &            +dble(xnup(iclegy,icltar))
	rh3=delD1(i3,iclegy,icltar)
      do i4=min4,max4
        del4=dble(betD1(i4,iclegy,icltar))
        if(i4.eq.1)del4=del4+dble(betv)
        alp4=dble(betDp1(i4,iclegy,icltar)-alppar)
     &            +dble(xnup(iclegy,icltar))
	rh4=delD1(i4,iclegy,icltar)
	rh34=rh3*rh4/(rh3+rh4)
	rh=rh12+rh34


        if(dabs(del1+del2-del3-del4).lt.1.d-5)then
          dps=dlog(max(1.d0,dsy/ddelx**2))
        else
          dps=((dsy/ddelx)**(del1+del2-del3-del4)
     *    -ddelx**(del1+del2-del3-del4))
     *    /(del1+del2-del3-del4)
        endif 

        if(i1.ne.1.and.i2.ne.1.and.i3.ne.1.and.i4.ne.1)then
          r4pomp=dble(r4pom)
        endif

        omXuncutJ=omXuncutJ+r4pomp*dps*dsy**(del3+del4)
     *  *xp**(1.d0+alp1+alp2+del1+del2)
     *  *xm**(1.d0+alp3+alp4+del3+del4)
     *  *utgam2(1.d0+alp1+del1)*utgam2(1.d0+alp2+del2)
     *  /utgam2(2.d0+alp1+del1+alp2+del2)
     *  *utgam2(1.d0+alp3+del3)*utgam2(1.d0+alp4+del4)
     *  /utgam2(2.d0+alp3+del3+alp4+del4)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *utgam2(1.d0+del3)*utgam2(1.d0+del4)
     *  /utgam2(2.d0+del3+del4)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)*alpD1(i4,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rh4)/rh*exp(-b2/rh))
      enddo
      enddo
      enddo
      enddo
      omXuncutJ=-(-2.d0)*omXuncutJ*dble(pi/.0389)/2.d0
      endif

c$$$      write(*,*)"4p",dps*dble(r4pom*pi/.0389)/4.d0
c$$$     *  *utgam2(1.d0+alp1+del1)*utgam2(1.d0+alp2+del2)
c$$$     *  /utgam2(2.d0+alp1+del1+alp2+del2)
c$$$     *  *utgam2(1.d0+alp3+del3)*utgam2(1.d0+alp4+del4)
c$$$     *  /utgam2(2.d0+alp3+del3+alp4+del4)
c$$$     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
c$$$     *  /utgam2(2.d0+del1+del2)
c$$$     *  *utgam2(1.d0+del3)*utgam2(1.d0+del4)
c$$$     *  /utgam2(2.d0+del3+del4)
c$$$     *  *dble(alpD1(1,iclegy,iclpro)*alpD1(1,iclegy,iclpro)
c$$$     *  *alpD1(1,iclegy,icltar)*alpD1(1,iclegy,icltar)
c$$$     *  /(rh1+rh2)/(rh3+rh4)/rh),del3+del4,(2.d0+alp1+del1
c$$$     *  +alp2+del2+alp3+del3+alp4+del4)/2.,xnup(iclegy,iclpro),
c$$$     *  gamhad(iclpro)**2.*gamhad(icltar)**2./(alp*del)**3.,
c$$$     *  alpD1(1,iclegy,icltar),alp,gamhad(iclpro)


      omXuncutJ=omXuncutJ/2.d0
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
     *  *dble(chad(iclpro)*chad(icltar))
     *  *dble(chad(iclpro)*chad(icltar))
      return
      end


c-----------------------------------------------------------------------
      double precision function omXcut(xh,yp,xprem,xmrem,b,iqq,iqqq)
c-----------------------------------------------------------------------
c - chi~(xpr,xmr)/2 for uncut integrated X enhanced diagram
c b - impact parameter between the pomeron ends;
c iqq = 1  - 4p(2*scr),
c iqq = 2  - 4p+(scr),
c iqq = 3  - 4p-(scr),
c iqq = 4  - 4p-(dif+scr),
c iqq = 5  - 4p+(dif+scr)
c iqqq=0 ideal G
c iqqq=1 exact G
c iqqq=2 ideal G for distribution probability (= ideal G)
c-----------------------------------------------------------------------
      include "nexus.inc"
      include "nexus.incsem"
      double precision omXcutJ,xprem,xmrem,xh,yp,xp,xm,gamp,gamm
     &,omXgam,gampp,gammp
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)


      if(iqqq.eq.0)then
        omXcut=omXcutJ(xh,yp,xprem,xmrem,b,1,1,1,1,1,1,1,1,iqq)
      elseif(iqqq.eq.1)then
        omXcut=omXcutJ(xh,yp,xprem,xmrem,b,2,4,2,4,2,4,2,4,iqq)
      elseif(iqqq.eq.2)then
        xp=dsqrt(xh)*dexp(yp)
        if(xp.ne.0.d0)then
          xm=xh/xp
        else
          xm=0.d0
        endif
        b2=b*b
        gamb=gamD(1,iclegy,iclpro,icltar,icdp,icdt)
        gamp=dble(xnup(iclegy,iclpro)-xnu(iclegy,iclpro)+gamb*b2/2.
     &       -alppar)
        gamm=dble(xnup(iclegy,icltar)-xnu(iclegy,icltar)+gamb*b2/2.
     &       -alppar)
        gampp=1.d0+2.d0*gamp
        gammp=1.d0+2.d0*gamm
        if(iqq.eq.1)then
          omXcut=omXgam(xp,xm,b,iqq)*xprem**gamp*xmrem**gamm
        elseif(iqq.eq.2)then
          omXcut=omXgam(xp,xm,b,iqq)*xprem**gamp
        elseif(iqq.eq.3)then
          omXcut=omXgam(xp,xm,b,iqq)*xmrem**gamm
        elseif(iqq.eq.4)then
          omXcut=omXgam(xp,xm,b,iqq)*xprem**gamp*xmrem**gammp
        elseif(iqq.eq.5)then
          omXcut=omXgam(xp,xm,b,iqq)*xmrem**gamm*xprem**gampp
        else
          call utstop('Wrong iqq in omXcut&')
        endif
      else
        call utstop('Wrong iqqq in omXcut&')
      endif

      return
      end

c-----------------------------------------------------------------------
      double precision function omXcutJ(xh,yp,xprem,xmrem,b,min1,max1,
     &                              min2,max2,min3,max3,min4,max4,iqq)
c-----------------------------------------------------------------------
c - chi~(x,y,xpr,xmr)/2. for cut X enhanced diagram
c xh - fraction of the energy squared s for the pomeron;
c yp - rapidity for the pomeron;
c xprem,xmrem impulsion fraction of remnant
c b - impact parameter between the pomeron ends;
c iqq = 1  - 4p(2*scr),
c iqq = 2  - 4p+(scr),
c iqq = 3  - 4p-(scr),
c iqq = 4  - 4p-(dif+scr),
c iqq = 5  - 4p+(dif+scr)
c mini, maxi = 1 - G1 for ideal G (all min/max set to 1)
c              2 - soft G1
c              3 - semihard G1
c              4 - valence G1
c min1/max1 and min2/max2 - parallel legs +
c min3/max3 and min4/max4 - parallel legs -
c-----------------------------------------------------------------------
      double precision xh,yp,xprem,xmrem,dsy,ddelx,alp1,alp2,alp3,alp4,
     & del1,del2,del3,del4,dps,xp,xm,utgam2,r4pomp
      include 'nexus.inc'
      include 'nexus.incsem'
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar7/ delx,alam3p,gam3p
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)

      omXcutJ=0.d0
      if(iqq.eq.1.and.cXscr.eq.0.d0)return
      if((iqq.eq.4.or.iqq.eq.5).and.cXdif.eq.0.d0)return
      if((iqq.eq.2.or.iqq.eq.3).and.cXfus.eq.0.d0)return
      b2=b*b
      sy=engy*engy
      dsy=dble(sy)
      ddelx=dble(delx)
      xp=dsqrt(xh)*dexp(yp)
      if(xp.ne.0.d0)then
        xm=xh/xp
      else
        xm=0.d0
      endif

      if(dsy.gt.ddelx**2.and.dsy.gt.Eseuil**2..and.xprem.ge.0.d0
     &                       .and.xmrem.ge.0.d0.and.iscreen.ne.0)then

      gamb=gamD(1,iclegy,iclpro,icltar,icdp,icdt)
      alp=xmu(3)      
      betv=xnu(iclegy,iclpro)+gamb*b2/2.
      betp=betD1(1,iclegy,iclpro)+betv
      betm=betD1(1,iclegy,icltar)+betv
      gamp=betDp1(1,iclegy,iclpro)-alppar+xnup(iclegy,iclpro)
      gamm=betDp1(1,iclegy,icltar)-alppar+xnup(iclegy,icltar)
      del=delD1(1,iclegy,iclpro)

      r4pomp=dble(4.*0.0389*gamhad(iclpro)**2.*gamhad(icltar)**2.
     *      *utgam1(2.+2.*betp)/utgam1(1.+betp)**2.
     *      *utgam1(2.+2.*betm)/utgam1(1.+betm)**2.
     *      *utgam1(2.+2.*betp+2.*gamp)/utgam1(1.+betp+gamp)**2.
     *      *utgam1(2.+2.*betm+2.*gamm)/utgam1(1.+betm+gamm)**2.
     *      /pi*del**3./log(sy/delx/delx)/(alp*del)**4.*xmu(2))
     *      /dble(chad(iclpro)*chad(icltar))

       

        if(iqq.eq.1)then

          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,iclpro))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &           +dble(xnup(iclegy,iclpro))
            rh1=delD1(i1,iclegy,iclpro)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,iclpro))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &             +dble(xnup(iclegy,iclpro))
              rh2=delD1(i2,iclegy,iclpro)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,icltar))
                if(i3.eq.1)del3=del3+dble(betv)
                alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &               +dble(xnup(iclegy,icltar))
                rh3=delD1(i3,iclegy,icltar)
                do i4=min4,max4
                  del4=dble(betD1(i4,iclegy,icltar))
                  if(i4.eq.1)del4=del4+dble(betv)
                  alp4=dble(betDp1(i4,iclegy,icltar)-alppar)
     &                 +dble(xnup(iclegy,icltar))
                  rh4=delD1(i4,iclegy,icltar)
                  rh34=rh3*rh4/(rh3+rh4)
                  rh=rh12+rh34
                  
                  
                  if(dabs(del1+del2-del3-del4).lt.1.d-5)then
                    dps=dlog(max(1.d0,dsy/ddelx**2))
                  else
                    dps=((dsy/ddelx)**(del1+del2-del3-del4)
     *                   -ddelx**(del1+del2-del3-del4))
     *                   /(del1+del2-del3-del4)
                  endif 
                  
                  if(i1.ne.1.and.i2.ne.1.and.i3.ne.1.and.i4.ne.1)then
                    r4pomp=dble(r4pom)
                  endif

                  omXcutJ=omXcutJ+r4pomp*dps*dsy**(del3+del4)
     *  *xp**(alp1+del1)*xprem**(alp2+del2)
     *  *xm**(alp3+del3)*xmrem**(alp4+del4)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *utgam2(1.d0+del3)*utgam2(1.d0+del4)
     *  /utgam2(2.d0+del3+del4)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)*alpD1(i4,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rh4)/rh*exp(-b2/rh))
                enddo
              enddo
            enddo
          enddo
          omXcutJ=omXcutJ*dble(pi/.0389)*cXscr   


        elseif(iqq.eq.2)then
          
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,iclpro))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &           +dble(xnup(iclegy,iclpro))
            rh1=delD1(i1,iclegy,iclpro)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,iclpro))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &             +dble(xnup(iclegy,iclpro))
              rh2=delD1(i2,iclegy,iclpro)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,icltar))
                if(i3.eq.1)del3=del3+dble(betv)
                alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &               +dble(xnup(iclegy,icltar))
                rh3=delD1(i3,iclegy,icltar)
                do i4=min4,max4
                  del4=dble(betD1(i4,iclegy,icltar))
                  if(i4.eq.1)del4=del4+dble(betv)
                  alp4=dble(betDp1(i4,iclegy,icltar)-alppar)
     &                 +dble(xnup(iclegy,icltar))
                  rh4=delD1(i4,iclegy,icltar)
                  rh34=rh3*rh4/(rh3+rh4)
                  rh=rh12+rh34
                  
                  
                  if(dabs(del1+del2-del3-del4).lt.1.d-5)then
                    dps=dlog(max(1.d0,dsy/ddelx**2))
                  else
                    dps=((dsy/ddelx)**(del1+del2-del3-del4)
     *                   -ddelx**(del1+del2-del3-del4))
     *                   /(del1+del2-del3-del4)
                  endif 
                  
                  if(i1.ne.1.and.i2.ne.1.and.i3.ne.1.and.i4.ne.1)then
                    r4pomp=dble(r4pom)
                  endif

                  omXcutJ=omXcutJ+r4pomp*dps*dsy**(del3+del4)
     *  *xp**(alp1+del1)*xprem**(alp2+del2)
     *  *xm**(1.d0+alp3+alp4+del3+del4)
     *  *utgam2(1.d0+alp3+del3)*utgam2(1.d0+alp4+del4)
     *  /utgam2(2.d0+alp3+del3+alp4+del4)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *utgam2(1.d0+del3)*utgam2(1.d0+del4)
     *  /utgam2(2.d0+del3+del4)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)*alpD1(i4,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rh4)/rh*exp(-b2/rh))
                enddo
              enddo
            enddo
          enddo
          omXcutJ=omXcutJ*dble(pi/.0389)*cXfus
      
        elseif(iqq.eq.3)then

          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,iclpro))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &           +dble(xnup(iclegy,iclpro))
            rh1=delD1(i1,iclegy,iclpro)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,iclpro))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &             +dble(xnup(iclegy,iclpro))
              rh2=delD1(i2,iclegy,iclpro)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,icltar))
                if(i3.eq.1)del3=del3+dble(betv)
                alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &               +dble(xnup(iclegy,icltar))
                rh3=delD1(i3,iclegy,icltar)
                do i4=min4,max4
                  del4=dble(betD1(i4,iclegy,icltar))
                  if(i4.eq.1)del4=del4+dble(betv)
                  alp4=dble(betDp1(i4,iclegy,icltar)-alppar)
     &                 +dble(xnup(iclegy,icltar))
                  rh4=delD1(i4,iclegy,icltar)
                  rh34=rh3*rh4/(rh3+rh4)
                  rh=rh12+rh34
                  
                  
                  if(dabs(del1+del2-del3-del4).lt.1.d-5)then
                    dps=dlog(max(1.d0,dsy/ddelx**2))
                  else
                    dps=((dsy/ddelx)**(del1+del2-del3-del4)
     *                   -ddelx**(del1+del2-del3-del4))
     *                   /(del1+del2-del3-del4)
                  endif 
                  
                  if(i1.ne.1.and.i2.ne.1.and.i3.ne.1.and.i4.ne.1)then
                    r4pomp=dble(r4pom)
                  endif

                  omXcutJ=omXcutJ+r4pomp*dps*dsy**(del3+del4)
     *  *xm**(alp3+del3)*xmrem**(alp4+del4)
     *  *xp**(1.d0+alp1+alp2+del1+del2)
     *  *utgam2(1.d0+alp1+del2)*utgam2(1.d0+alp2+del2)
     *  /utgam2(2.d0+alp1+del1+alp2+del2)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *utgam2(1.d0+del3)*utgam2(1.d0+del4)
     *  /utgam2(2.d0+del3+del4)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)*alpD1(i4,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rh4)/rh*exp(-b2/rh))
                enddo
              enddo
            enddo
          enddo
          omXcutJ=omXcutJ*dble(pi/.0389)*cXfus
          

          
        elseif(iqq.eq.4.and.xm.lt.1.d0/ddelx.and.xm.gt.ddelx/dsy)then
          
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,iclpro))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &           +dble(xnup(iclegy,iclpro))
            rh1=delD1(i1,iclegy,iclpro)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,iclpro))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &             +dble(xnup(iclegy,iclpro))
              rh2=delD1(i2,iclegy,iclpro)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,icltar))
                if(i3.eq.1)del3=del3+dble(betv)
                alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &               +dble(xnup(iclegy,icltar))
                rh3=delD1(i3,iclegy,icltar)
                do i4=min4,max4
                  del4=dble(betD1(i4,iclegy,icltar))
                  if(i4.eq.1)del4=del4+dble(betv)
                  alp4=dble(betDp1(i4,iclegy,icltar)-alppar)
     &                 +dble(xnup(iclegy,icltar))
                  rh4=delD1(i4,iclegy,icltar)
                  rh34=rh3*rh4/(rh3+rh4)
                  rh=rh12+rh34
                  
                  if(i1.ne.1.and.i2.ne.1.and.i3.ne.1.and.i4.ne.1)then
                    r4pomp=dble(r4pom)
                  endif

                  omXcutJ=omXcutJ+r4pomp*dsy**(del3+del4)
     *  *xm**(-1.d0+del1+del2-del3-del4)
     *  *xp**(alp1+del1)*xprem**(alp2+del2)
     *  *xmrem**(1.d0+alp3+alp4+del3+del4)
     *  *utgam2(1.d0+alp3+del3)*utgam2(1.d0+alp4+del4)
     *  /utgam2(2.d0+alp3+del3+alp4+del4)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *utgam2(1.d0+del3)*utgam2(1.d0+del4)
     *  /utgam2(2.d0+del3+del4)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)*alpD1(i4,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rh4)/rh*exp(-b2/rh))
                enddo
              enddo
            enddo
          enddo
          omXcutJ=omXcutJ*dble(pi/.0389)*cXdif

        elseif(iqq.eq.5.and.xp.lt.1.d0/ddelx.and.xp.gt.ddelx/dsy)then
          
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,iclpro))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &           +dble(xnup(iclegy,iclpro))
            rh1=delD1(i1,iclegy,iclpro)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,iclpro))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &             +dble(xnup(iclegy,iclpro))
              rh2=delD1(i2,iclegy,iclpro)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,icltar))
                if(i3.eq.1)del3=del3+dble(betv)
                alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &               +dble(xnup(iclegy,icltar))
                rh3=delD1(i3,iclegy,icltar)
                do i4=min4,max4
                  del4=dble(betD1(i4,iclegy,icltar))
                  if(i4.eq.1)del4=del4+dble(betv)
                  alp4=dble(betDp1(i4,iclegy,icltar)-alppar)
     &                 +dble(xnup(iclegy,icltar))
                  rh4=delD1(i4,iclegy,icltar)
                  rh34=rh3*rh4/(rh3+rh4)
                  rh=rh12+rh34
                  
                  if(i1.ne.1.and.i2.ne.1.and.i3.ne.1.and.i4.ne.1)then
                    r4pomp=dble(r4pom)
                  endif
                  
                  omXcutJ=omXcutJ+r4pomp*dsy**(del3+del4)
     *  *xp**(-1.d0+del3+del4-del1-del2)
     *  *xm**(alp3+del3)*xmrem**(alp4+del4)
     *  *xprem**(1.d0+alp1+alp2+del1+del2)
     *  *utgam2(1.d0+alp1+del1)*utgam2(1.d0+alp2+del2)
     *  /utgam2(2.d0+alp1+del1+alp2+del2)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *utgam2(1.d0+del3)*utgam2(1.d0+del4)
     *  /utgam2(2.d0+del3+del4)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)*alpD1(i4,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rh4)/rh*exp(-b2/rh))
                enddo
              enddo
            enddo
          enddo
          omXcutJ=omXcutJ*dble(pi/.0389)*cXdif
      
        elseif(iqq.gt.5.and.iqq.le.0)then
        call utstop('Wrong, iqq in omXcutJ !&')
      endif

      endif
      
      omXcutJ=omXcutJ/2.d0
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
     *  *dble(chad(iclpro)*chad(icltar))
     *  *dble(chad(iclpro)*chad(icltar))

c      write(*,*)xh,yp,xprem,xmrem,dsy,b,omXcutJ

      return
      end

c-----------------------------------------------------------------------
      double precision function omXcutJc(xp1,xp2,xm,xmrem,xpv,b
     &                     ,min1,max1,min2,max2,min3,max3,min4,max4,iqq)
c-----------------------------------------------------------------------
c - chi~(xp1,xp2,xm,xmr,xpv)/2. for triple cut X enhanced diagram
c xp1,xp2 impulsion fraction of cut parallel pomerons
c xm impulsion fraction of cut single pomeron
c xmrem impulsion fraction of remnant
c xpv impulsion fraction of the vertex
c b - impact parameter between the pomeron ends;
c iqq = 1  - 4p+(scr),
c iqq = 2  - 4p-(scr),
c mini, maxi = 1 - G1 for ideal G (all min/max set to 1)
c              2 - soft G1
c              3 - semihard G1
c              4 - valence G1
c min1/max1 and min2/max2 - parallel legs +
c min3/max3 and min4/max4 - parallel legs -
c-----------------------------------------------------------------------
      double precision xp1,xp2,xmrem,dsy,ddelx,alp1,alp2,alp3,alp4,
     & del1,del2,del3,del4,dps,xpv,xm,utgam2,r4pomp
      include 'nexus.inc'
      include 'nexus.incsem'
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar7/ delx,alam3p,gam3p
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)

      omXcutJc=0.d0
      if(cXfus.eq.0.d0)return
      b2=b*b
      sy=engy*engy
      dsy=dble(sy)
      ddelx=dble(delx)

      if(dsy.gt.ddelx**2.and.dsy.gt.Eseuil**2.
     &                       .and.xmrem.gt.0.d0.and.iscreen.ne.0)then

      gamb=gamD(1,iclegy,iclpro,icltar,icdp,icdt)
      alp=xmu(3)      
      betv=xnu(iclegy,iclpro)+gamb*b2/2.
      betp=betD1(1,iclegy,iclpro)+betv
      betm=betD1(1,iclegy,icltar)+betv
      gamp=betDp1(1,iclegy,iclpro)-alppar+xnup(iclegy,iclpro)
      gamm=betDp1(1,iclegy,icltar)-alppar+xnup(iclegy,icltar)
      del=delD1(1,iclegy,iclpro)

      r4pomp=dble(4.*0.0389*gamhad(iclpro)**2.*gamhad(icltar)**2.
     *      *utgam1(2.+2.*betp)/utgam1(1.+betp)**2.
     *      *utgam1(2.+2.*betm)/utgam1(1.+betm)**2.
     *      *utgam1(2.+2.*betp+2.*gamp)/utgam1(1.+betp+gamp)**2.
     *      *utgam1(2.+2.*betm+2.*gamm)/utgam1(1.+betm+gamm)**2.
     *      /pi*del**3./log(sy/delx/delx)/(alp*del)**4.*xmu(2))
     *      /dble(chad(iclpro)*chad(icltar))

       

      if(iqq.eq.2)then
          
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,iclpro))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &           +dble(xnup(iclegy,iclpro))
            rh1=delD1(i1,iclegy,iclpro)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,iclpro))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &             +dble(xnup(iclegy,iclpro))
              rh2=delD1(i2,iclegy,iclpro)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,icltar))
                if(i3.eq.1)del3=del3+dble(betv)
                alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &               +dble(xnup(iclegy,icltar))
                rh3=delD1(i3,iclegy,icltar)
                do i4=min4,max4
                  del4=dble(betD1(i4,iclegy,icltar))
                  if(i4.eq.1)del4=del4+dble(betv)
                  alp4=dble(betDp1(i4,iclegy,icltar)-alppar)
     &                 +dble(xnup(iclegy,icltar))
                  rh4=delD1(i4,iclegy,icltar)
                  rh34=rh3*rh4/(rh3+rh4)
                  rh=rh12+rh34
                  
                  
                  if(dabs(del1+del2-del3-del4).lt.1.d-5)then
                    dps=-1.d0
                  else
                    dps=-(1.d0+del1+del2-del3-del4)
                  endif 
                  
                  if(i1.ne.1.and.i2.ne.1.and.i3.ne.1.and.i4.ne.1)then
                    r4pomp=dble(r4pom)
                  endif

                  omXcutJc=omXcutJc+r4pomp*xpv**dps*dsy**(del3+del4)
     *  *xm**(alp1+del1)*xmrem**(1.d0+alp2+del2)
     *  *xp1**(alp3+del3)*xp2**(alp4+del4)
     *  *utgam2(1.d0+alp2+del2)*utgam2(1.d0+dble(alplea(iclpro)))
     *  /utgam2(2.d0+alp2+del2+dble(alplea(iclpro)))
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *utgam2(1.d0+del3)*utgam2(1.d0+del4)
     *  /utgam2(2.d0+del3+del4)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)*alpD1(i4,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rh4)/rh*exp(-b2/rh))
                enddo
              enddo
            enddo
          enddo
          omXcutJc=omXcutJc*dble(pi/.0389)*cXfus
      
        elseif(iqq.eq.1)then

          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,iclpro))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &           +dble(xnup(iclegy,iclpro))
            rh1=delD1(i1,iclegy,iclpro)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,iclpro))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &             +dble(xnup(iclegy,iclpro))
              rh2=delD1(i2,iclegy,iclpro)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,icltar))
                if(i3.eq.1)del3=del3+dble(betv)
                alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &               +dble(xnup(iclegy,icltar))
                rh3=delD1(i3,iclegy,icltar)
                do i4=min4,max4
                  del4=dble(betD1(i4,iclegy,icltar))
                  if(i4.eq.1)del4=del4+dble(betv)
                  alp4=dble(betDp1(i4,iclegy,icltar)-alppar)
     &                 +dble(xnup(iclegy,icltar))
                  rh4=delD1(i4,iclegy,icltar)
                  rh34=rh3*rh4/(rh3+rh4)
                  rh=rh12+rh34
                  
                  
                  if(dabs(del1+del2-del3-del4).lt.1.d-5)then
                    dps=-1.d0
                  else
                    dps=-(1.d0+del1+del2-del3-del4)
                  endif 
                  
                  if(i1.ne.1.and.i2.ne.1.and.i3.ne.1.and.i4.ne.1)then
                    r4pomp=dble(r4pom)
                  endif

                  omXcutJc=omXcutJc+r4pomp*xpv**dps*dsy**(del3+del4)
     *  *xm**(alp3+del3)*xmrem**(1.d0+alp4+del4)
     *  *xp1**(alp1+del1)*xp2*(alp2+del2)
     *  *utgam2(1.d0+alp4+del4)*utgam2(1.d0+dble(alplea(icltar)))
     *  /utgam2(2.d0+alp4+del4+dble(alplea(icltar)))
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *utgam2(1.d0+del3)*utgam2(1.d0+del4)
     *  /utgam2(2.d0+del3+del4)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)*alpD1(i4,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rh4)/rh*exp(-b2/rh))
                enddo
              enddo
            enddo
          enddo
          omXcutJc=omXcutJc*dble(pi/.0389)*cXfus
          

          
      
        else
        call utstop('Wrong, iqq in omXcutJc !&')
      endif

      endif
      
      omXcutJc=omXcutJc/2.d0
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
     *  *dble(chad(iclpro)*chad(icltar))
     *  *dble(chad(iclpro)*chad(icltar))

c      write(*,*)xp1,xp2,xm,xmrem,xpv,dsy,b,omXcutJc

      return
      end

c-----------------------------------------------------------------------
      double precision function omXcutI(xh,yp,xprem,xmrem,b,iqq)
c-----------------------------------------------------------------------
c - chi~(x,y,xpr,xmr)/2. for cut X enhanced diagram
c xh - fraction of the energy squared s for the pomeron;
c yp - rapidity for the pomeron;
c xprem,xmrem impulsion fraction of remnant integrated
c b - impact parameter between the pomeron ends;
c iqq = 1  - 4p(2*scr),
c iqq = 2  - 4p+(scr),
c iqq = 3  - 4p-(scr),
c iqq = 4  - 4p-(dif+scr),
c iqq = 5  - 4p+(dif+scr)
c-----------------------------------------------------------------------
      double precision xh,yp,xprem,xmrem,omXcutIJ

      omXcutI=omXcutIJ(xh,yp,xprem,xmrem,b,1,1,1,1,1,1,1,1,iqq)
      
      return
      end

c-----------------------------------------------------------------------
      double precision function omXcutIJ(xh,yp,xprem,xmrem,b,min1,max1,
     &                              min2,max2,min3,max3,min4,max4,iqq)
c-----------------------------------------------------------------------
c - chi~(x,y,xpr,xmr)/2. for cut X enhanced diagram
c xh - fraction of the energy squared s for the pomeron;
c yp - rapidity for the pomeron;
c xprem,xmrem impulsion fraction of remnant integrated
c b - impact parameter between the pomeron ends;
c iqq = 1  - 4p(2*scr),
c iqq = 2  - 4p+(scr),
c iqq = 3  - 4p-(scr),
c iqq = 4  - 4p-(dif+scr),
c iqq = 5  - 4p+(dif+scr)
c mini, maxi = 1 - G1 for ideal G (all min/max set to 1)
c              2 - soft G1
c              3 - semihard G1
c              4 - valence G1
c min1/max1 and min2/max2 - parallel legs +
c min3/max3 and min4/max4 - parallel legs -
c-----------------------------------------------------------------------
      double precision xh,yp,xprem,xmrem,dsy,ddelx,alp1,alp2,alp3,alp4,
     & del1,del2,del3,del4,dps,xp,xm,utgam2,r4pomp
      include 'nexus.inc'
      include 'nexus.incsem'
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar7/ delx,alam3p,gam3p
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)


      omXcutIJ=0.d0
      if(iqq.eq.1.and.cXscr.eq.0.d0)return
      if((iqq.eq.4.or.iqq.eq.5).and.cXdif.eq.0.d0)return
      if((iqq.eq.2.or.iqq.eq.3).and.cXfus.eq.0.d0)return
      b2=b*b
      sy=engy*engy
      dsy=dble(sy)
      ddelx=dble(delx)
      xp=dsqrt(xh)*dexp(yp)
      if(xp.ne.0.d0)then
        xm=xh/xp
      else
        xm=0.d0
      endif

      if(dsy.gt.ddelx**2.and.dsy.gt.Eseuil**2..and.xprem.ge.0.d0
     &                       .and.xmrem.ge.0.d0.and.iscreen.ne.0)then

      gamb=gamD(1,iclegy,iclpro,icltar,icdp,icdt)
      alp=xmu(3)      
      betv=xnu(iclegy,iclpro)+gamb*b2/2.
      betp=betD1(1,iclegy,iclpro)+betv
      betm=betD1(1,iclegy,icltar)+betv
      gamp=betDp1(1,iclegy,iclpro)-alppar+xnup(iclegy,iclpro)
      gamm=betDp1(1,iclegy,icltar)-alppar+xnup(iclegy,icltar)
      del=delD1(1,iclegy,iclpro)

      r4pomp=dble(4.*0.0389*gamhad(iclpro)**2.*gamhad(icltar)**2.
     *      *utgam1(2.+2.*betp)/utgam1(1.+betp)**2.
     *      *utgam1(2.+2.*betm)/utgam1(1.+betm)**2.
     *      *utgam1(2.+2.*betp+2.*gamp)/utgam1(1.+betp+gamp)**2.
     *      *utgam1(2.+2.*betm+2.*gamm)/utgam1(1.+betm+gamm)**2.
     *      /pi*del**3./log(sy/delx/delx)/(alp*del)**4.*xmu(2))
     *      /dble(chad(iclpro)*chad(icltar))

       

        if(iqq.eq.1)then

          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,iclpro))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &           +dble(xnup(iclegy,iclpro))
            rh1=delD1(i1,iclegy,iclpro)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,iclpro))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &             +dble(xnup(iclegy,iclpro))
              rh2=delD1(i2,iclegy,iclpro)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,icltar))
                if(i3.eq.1)del3=del3+dble(betv)
                alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &               +dble(xnup(iclegy,icltar))
                rh3=delD1(i3,iclegy,icltar)
                do i4=min4,max4
                  del4=dble(betD1(i4,iclegy,icltar))
                  if(i4.eq.1)del4=del4+dble(betv)
                  alp4=dble(betDp1(i4,iclegy,icltar)-alppar)
     &                 +dble(xnup(iclegy,icltar))
                  rh4=delD1(i4,iclegy,icltar)
                  rh34=rh3*rh4/(rh3+rh4)
                  rh=rh12+rh34
                  
                  
                  if(dabs(del1+del2-del3-del4).lt.1.d-5)then
                    dps=dlog(max(1.d0,dsy/ddelx**2))
                  else
                    dps=((dsy/ddelx)**(del1+del2-del3-del4)
     *                   -ddelx**(del1+del2-del3-del4))
     *                   /(del1+del2-del3-del4)
                  endif 
                  
                  if(i1.ne.1.and.i2.ne.1.and.i3.ne.1.and.i4.ne.1)then
                    r4pomp=dble(r4pom)
                  endif

                  omXcutIJ=omXcutIJ+r4pomp*dps*dsy**(del3+del4)
     *  *xp**(alp1+del1)*xprem**(1.d0+alp2+del2)
     *  *xm**(alp3+del3)*xmrem**(1.d0+alp4+del4)
     *  *utgam2(1.d0+alp2+del2)*utgam2(1.d0+dble(alplea(iclpro)))
     *  /utgam2(2.d0+alp2+del2+dble(alplea(iclpro)))
     *  *utgam2(1.d0+alp4+del4)*utgam2(1.d0+dble(alplea(icltar)))
     *  /utgam2(2.d0+alp4+del4+dble(alplea(icltar)))
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *utgam2(1.d0+del3)*utgam2(1.d0+del4)
     *  /utgam2(2.d0+del3+del4)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)*alpD1(i4,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rh4)/rh*exp(-b2/rh))
                enddo
              enddo
            enddo
          enddo
          omXcutIJ=omXcutIJ*dble(pi/.0389)*cXscr

        elseif(iqq.eq.2)then
          
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,iclpro))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &           +dble(xnup(iclegy,iclpro))
            rh1=delD1(i1,iclegy,iclpro)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,iclpro))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &             +dble(xnup(iclegy,iclpro))
              rh2=delD1(i2,iclegy,iclpro)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,icltar))
                if(i3.eq.1)del3=del3+dble(betv)
                alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &               +dble(xnup(iclegy,icltar))
                rh3=delD1(i3,iclegy,icltar)
                do i4=min4,max4
                  del4=dble(betD1(i4,iclegy,icltar))
                  if(i4.eq.1)del4=del4+dble(betv)
                  alp4=dble(betDp1(i4,iclegy,icltar)-alppar)
     &                 +dble(xnup(iclegy,icltar))
                  rh4=delD1(i4,iclegy,icltar)
                  rh34=rh3*rh4/(rh3+rh4)
                  rh=rh12+rh34
                  
                  
                  if(dabs(del1+del2-del3-del4).lt.1.d-5)then
                    dps=dlog(max(1.d0,dsy/ddelx**2))
                  else
                    dps=((dsy/ddelx)**(del1+del2-del3-del4)
     *                   -ddelx**(del1+del2-del3-del4))
     *                   /(del1+del2-del3-del4)
                  endif 
                  
                  if(i1.ne.1.and.i2.ne.1.and.i3.ne.1.and.i4.ne.1)then
                    r4pomp=dble(r4pom)
                  endif

                  omXcutIJ=omXcutIJ+r4pomp*dps*dsy**(del3+del4)
     *  *xp**(alp1+del1)*xprem**(1.d0+alp2+del2)
     *  *xm**(1.d0+alp3+alp4+del3+del4)
     *  *utgam2(1.d0+alp2+del2)*utgam2(1.d0+dble(alplea(iclpro)))
     *  /utgam2(2.d0+alp2+del2+dble(alplea(iclpro)))
     *  *utgam2(1.d0+alp3+del3)*utgam2(1.d0+alp4+del4)
     *  /utgam2(2.d0+alp3+del3+alp4+del4)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *utgam2(1.d0+del3)*utgam2(1.d0+del4)
     *  /utgam2(2.d0+del3+del4)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)*alpD1(i4,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rh4)/rh*exp(-b2/rh))
                enddo
              enddo
            enddo
          enddo
          omXcutIJ=omXcutIJ*dble(pi/.0389)*cXfus
      
        elseif(iqq.eq.3)then

          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,iclpro))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &           +dble(xnup(iclegy,iclpro))
            rh1=delD1(i1,iclegy,iclpro)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,iclpro))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &             +dble(xnup(iclegy,iclpro))
              rh2=delD1(i2,iclegy,iclpro)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,icltar))
                if(i3.eq.1)del3=del3+dble(betv)
                alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &               +dble(xnup(iclegy,icltar))
                rh3=delD1(i3,iclegy,icltar)
                do i4=min4,max4
                  del4=dble(betD1(i4,iclegy,icltar))
                  if(i4.eq.1)del4=del4+dble(betv)
                  alp4=dble(betDp1(i4,iclegy,icltar)-alppar)
     &                 +dble(xnup(iclegy,icltar))
                  rh4=delD1(i4,iclegy,icltar)
                  rh34=rh3*rh4/(rh3+rh4)
                  rh=rh12+rh34
                  
                  
                  if(dabs(del1+del2-del3-del4).lt.1.d-5)then
                    dps=dlog(max(1.d0,dsy/ddelx**2))
                  else
                    dps=((dsy/ddelx)**(del1+del2-del3-del4)
     *                   -ddelx**(del1+del2-del3-del4))
     *                   /(del1+del2-del3-del4)
                  endif 
                  
                  if(i1.ne.1.and.i2.ne.1.and.i3.ne.1.and.i4.ne.1)then
                    r4pomp=dble(r4pom)
                  endif

                  omXcutIJ=omXcutIJ+r4pomp*dps*dsy**(del3+del4)
     *  *xm**(alp3+del3)*xmrem**(1.d0+alp4+del4)
     *  *xp**(1.d0+alp1+alp2+del1+del2)
     *  *utgam2(1.d0+alp1+del2)*utgam2(1.d0+alp2+del2)
     *  /utgam2(2.d0+alp1+del1+alp2+del2)
     *  *utgam2(1.d0+alp4+del4)*utgam2(1.d0+dble(alplea(icltar)))
     *  /utgam2(2.d0+alp4+del4+dble(alplea(icltar)))
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *utgam2(1.d0+del3)*utgam2(1.d0+del4)
     *  /utgam2(2.d0+del3+del4)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)*alpD1(i4,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rh4)/rh*exp(-b2/rh))
                enddo
              enddo
            enddo
          enddo
          omXcutIJ=omXcutIJ*dble(pi/.0389)*cXfus
          

          
        elseif(iqq.eq.4.and.xm.lt.1.d0/ddelx.and.xm.gt.ddelx/dsy)then
          
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,iclpro))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &           +dble(xnup(iclegy,iclpro))
            rh1=delD1(i1,iclegy,iclpro)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,iclpro))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &             +dble(xnup(iclegy,iclpro))
              rh2=delD1(i2,iclegy,iclpro)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,icltar))
                if(i3.eq.1)del3=del3+dble(betv)
                alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &               +dble(xnup(iclegy,icltar))
                rh3=delD1(i3,iclegy,icltar)
                do i4=min4,max4
                  del4=dble(betD1(i4,iclegy,icltar))
                  if(i4.eq.1)del4=del4+dble(betv)
                  alp4=dble(betDp1(i4,iclegy,icltar)-alppar)
     &                 +dble(xnup(iclegy,icltar))
                  rh4=delD1(i4,iclegy,icltar)
                  rh34=rh3*rh4/(rh3+rh4)
                  rh=rh12+rh34
                  
                  if(i1.ne.1.and.i2.ne.1.and.i3.ne.1.and.i4.ne.1)then
                    r4pomp=dble(r4pom)
                  endif

                  omXcutIJ=omXcutIJ+r4pomp*dsy**(del3+del4)
     *  *xm**(-1.d0+del1+del2-del3-del4)
     *  *xp**(alp1+del1)*xprem**(1.d0+alp2+del2)
     *  *xmrem**(2.d0+alp3+alp4+del3+del4)
     *  *utgam2(1.d0+alp2+del2)*utgam2(1.d0+dble(alplea(iclpro)))
     *  /utgam2(2.d0+alp2+del2+dble(alplea(iclpro)))
     *  *utgam2(1.d0+alp3+del3)*utgam2(1.d0+alp4+del4)
     *  *utgam2(1.d0+dble(alplea(icltar)))
     *  /utgam2(3.d0+alp3+del3+alp4+del4+dble(alplea(icltar)))
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *utgam2(1.d0+del3)*utgam2(1.d0+del4)
     *  /utgam2(2.d0+del3+del4)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)*alpD1(i4,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rh4)/rh*exp(-b2/rh))
                enddo
              enddo
            enddo
          enddo
          omXcutIJ=omXcutIJ*dble(pi/.0389)*cXdif

        elseif(iqq.eq.5.and.xp.lt.1.d0/ddelx.and.xp.gt.ddelx/dsy)then
          
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,iclpro))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &           +dble(xnup(iclegy,iclpro))
            rh1=delD1(i1,iclegy,iclpro)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,iclpro))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &             +dble(xnup(iclegy,iclpro))
              rh2=delD1(i2,iclegy,iclpro)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,icltar))
                if(i3.eq.1)del3=del3+dble(betv)
                alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &               +dble(xnup(iclegy,icltar))
                rh3=delD1(i3,iclegy,icltar)
                do i4=min4,max4
                  del4=dble(betD1(i4,iclegy,icltar))
                  if(i4.eq.1)del4=del4+dble(betv)
                  alp4=dble(betDp1(i4,iclegy,icltar)-alppar)
     &                 +dble(xnup(iclegy,icltar))
                  rh4=delD1(i4,iclegy,icltar)
                  rh34=rh3*rh4/(rh3+rh4)
                  rh=rh12+rh34
                  
                  if(i1.ne.1.and.i2.ne.1.and.i3.ne.1.and.i4.ne.1)then
                    r4pomp=dble(r4pom)
                  endif
                  
                  omXcutIJ=omXcutIJ+r4pomp*dsy**(del3+del4)
     *  *xp**(-1.d0+del3+del4-del1-del2)
     *  *xm**(alp3+del3)*xmrem**(1.d0+alp4+del4)
     *  *xprem**(2.d0+alp1+alp2+del1+del2)
     *  *utgam2(1.d0+alp1+del1)*utgam2(1.d0+alp2+del2)
     *  *utgam2(1.d0+dble(alplea(iclpro)))
     *  /utgam2(3.d0+alp1+del1+alp2+del2+dble(alplea(iclpro)))
     *  *utgam2(1.d0+alp4+del4)*utgam2(1.d0+dble(alplea(icltar)))
     *  /utgam2(2.d0+alp4+del4+dble(alplea(icltar)))
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *utgam2(1.d0+del3)*utgam2(1.d0+del4)
     *  /utgam2(2.d0+del3+del4)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)*alpD1(i4,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rh4)/rh*exp(-b2/rh))
                enddo
              enddo
            enddo
          enddo
          omXcutIJ=omXcutIJ*dble(pi/.0389)*cXdif
      

        elseif(iqq.gt.5.and.iqq.le.0)then
        call utstop('Wrong, iqq in omXcutIJ !&')
      endif

      endif

      omXcutIJ=omXcutIJ/2.d0
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
     *  *dble(chad(iclpro)*chad(icltar))
     *  *dble(chad(iclpro)*chad(icltar))

c      write(*,*)xh,yp,xprem,xmrem,dsy,b,omXcutIJ

      return
      end

c-----------------------------------------------------------------------
      double precision function omXgam(xp,xm,b,iqq)
c-----------------------------------------------------------------------
c - cut part of chi~(x,y,xpr,xmr)/2. for cut X enhanced diagram
c xp,xm impulsion fraction for cut part
c b - impact parameter between the pomeron ends;
c iqq = 1  - 4p(2*scr),
c iqq = 2  - 4p+(scr),
c iqq = 3  - 4p-(scr),
c iqq = 4  - 4p-(dif+scr),
c iqq = 5  - 4p+(dif+scr)
c-----------------------------------------------------------------------
      double precision xp,xm,dsy,ddelx,alp1,alp2,alp3,alp4,
     & del1,del2,del3,del4,dps,utgam2,r4pomp
      include 'nexus.inc'
      include 'nexus.incsem'
      include 'nexus.incems'
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar7/ delx,alam3p,gam3p
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)

      omXgam=0.d0
      if(iqq.eq.1.and.cXscr.eq.0.d0)return
      if((iqq.eq.4.or.iqq.eq.5).and.cXdif.eq.0.d0)return
      if((iqq.eq.2.or.iqq.eq.3).and.cXfus.eq.0.d0)return
      b2=b*b
      sy=engy*engy

      dsy=dble(sy)
      ddelx=dble(delx)

      if(dsy.gt.ddelx**2.and.dsy.gt.Eseuil**2..and.iscreen.ne.0)then
        
      gamb=gamD(1,iclegy,iclpro,icltar,icdp,icdt)
      alp=xmu(3)      
      betv=xnu(iclegy,iclpro)+gamb*b2/2.
      betp=betD1(1,iclegy,iclpro)+betv
      betm=betD1(1,iclegy,icltar)+betv
      gamp=betDp1(1,iclegy,iclpro)-alppar+xnup(iclegy,iclpro)
      gamm=betDp1(1,iclegy,icltar)-alppar+xnup(iclegy,icltar)
      del=delD1(1,iclegy,iclpro)

      r4pomp=dble(4.*0.0389*gamhad(iclpro)**2.*gamhad(icltar)**2.
     *      *utgam1(2.+2.*betp)/utgam1(1.+betp)**2.
     *      *utgam1(2.+2.*betm)/utgam1(1.+betm)**2.
     *      *utgam1(2.+2.*betp+2.*gamp)/utgam1(1.+betp+gamp)**2.
     *      *utgam1(2.+2.*betm+2.*gamm)/utgam1(1.+betm+gamm)**2.
     *      /pi*del**3./log(sy/delx/delx)/(alp*del)**4.*xmu(2))
     *      /dble(chad(iclpro)*chad(icltar))


       
      del1=dble(betD1(1,iclegy,iclpro)+betv)
      alp1=dble(betDp1(1,iclegy,iclpro)-alppar)
     &     +dble(xnup(iclegy,iclpro))
      rh1=delD1(1,iclegy,iclpro)
      del2=dble(betD1(1,iclegy,iclpro)+betv)
      alp2=dble(betDp1(1,iclegy,iclpro)-alppar)
     &     +dble(xnup(iclegy,iclpro))
      rh2=delD1(1,iclegy,iclpro)
      rh12=rh1*rh2/(rh1+rh2)
      del3=dble(betD1(1,iclegy,icltar)+betv)
      alp3=dble(betDp1(1,iclegy,icltar)-alppar)
     &     +dble(xnup(iclegy,icltar))
      rh3=delD1(1,iclegy,icltar)
      del4=dble(betD1(1,iclegy,icltar)+betv)
      alp4=dble(betDp1(1,iclegy,icltar)-alppar)
     &     +dble(xnup(iclegy,icltar))
      rh4=delD1(1,iclegy,icltar)
      rh34=rh3*rh4/(rh3+rh4)
      rh=rh12+rh34
      dps=dlog(max(1.d0,dsy/ddelx**2))

      if(iqq.eq.1)then
          
        omXgam=r4pomp*dps*dsy**(del3+del4)
     *  *xp**(alp1+del1)
     *  *xm**(alp3+del3)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *utgam2(1.d0+del3)*utgam2(1.d0+del4)
     *  /utgam2(2.d0+del3+del4)
     *  *dble(alpD1(1,iclegy,iclpro)*alpD1(1,iclegy,iclpro)
     *  *alpD1(1,iclegy,icltar)*alpD1(1,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rh4)/rh*exp(-b2/rh))
        omXgam=omXgam*dble(pi/.0389)*cXscr


      elseif(iqq.eq.2)then
          

        omXgam=r4pomp*dps*dsy**(del3+del4)
     *  *xp**(alp1+del1)
     *  *xm**(1.d0+alp3+alp4+del3+del4)
     *  *utgam2(1.d0+alp3+del3)*utgam2(1.d0+alp4+del4)
     *  /utgam2(2.d0+alp3+del3+alp4+del4)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *utgam2(1.d0+del3)*utgam2(1.d0+del4)
     *  /utgam2(2.d0+del3+del4)
     *  *dble(alpD1(1,iclegy,iclpro)*alpD1(1,iclegy,iclpro)
     *  *alpD1(1,iclegy,icltar)*alpD1(1,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rh4)/rh*exp(-b2/rh))
        omXgam=omXgam*dble(pi/.0389)*cXfus
      
      elseif(iqq.eq.3)then


        omXgam=r4pomp*dps*dsy**(del3+del4)
     *  *xm**(alp3+del3)
     *  *xp**(1.d0+alp1+alp2+del1+del2)
     *  *utgam2(1.d0+alp1+del2)*utgam2(1.d0+alp2+del2)
     *  /utgam2(2.d0+alp1+del1+alp2+del2)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *utgam2(1.d0+del3)*utgam2(1.d0+del4)
     *  /utgam2(2.d0+del3+del4)
     *  *dble(alpD1(1,iclegy,iclpro)*alpD1(1,iclegy,iclpro)
     *  *alpD1(1,iclegy,icltar)*alpD1(1,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rh4)/rh*exp(-b2/rh))
        omXgam=omXgam*dble(pi/.0389)*cXfus
          

          
      elseif(iqq.eq.4.and.xm.lt.1.d0/ddelx.and.xm.gt.ddelx/dsy)then
          

        omXgam=r4pomp*dsy**(del3+del4)
     *  *xm**(-1.d0+del1+del2-del3-del4)
     *  *xp**(alp1+del1)
     *  *utgam2(1.d0+alp3+del3)*utgam2(1.d0+alp4+del4)
     *  /utgam2(2.d0+alp3+del3+alp4+del4)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *utgam2(1.d0+del3)*utgam2(1.d0+del4)
     *  /utgam2(2.d0+del3+del4)
     *  *dble(alpD1(1,iclegy,iclpro)*alpD1(1,iclegy,iclpro)
     *  *alpD1(1,iclegy,icltar)*alpD1(1,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rh4)/rh*exp(-b2/rh))
        omXgam=omXgam*dble(pi/.0389)*cXdif

      elseif(iqq.eq.5.and.xp.lt.1.d0/ddelx.and.xp.gt.ddelx/dsy)then
        
        omXgam=r4pomp*dsy**(del3+del4)
     *  *xp**(-1.d0+del3+del4-del1-del2)
     *  *xm**(alp3+del3)
     *  *utgam2(1.d0+alp1+del1)*utgam2(1.d0+alp2+del2)
     *  /utgam2(2.d0+alp1+del1+alp2+del2)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *utgam2(1.d0+del3)*utgam2(1.d0+del4)
     *  /utgam2(2.d0+del3+del4)
     *  *dble(alpD1(1,iclegy,iclpro)*alpD1(1,iclegy,iclpro)
     *  *alpD1(1,iclegy,icltar)*alpD1(1,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rh4)/rh*exp(-b2/rh))
        omXgam=omXgam*dble(pi/.0389)*cXdif
      

        elseif(iqq.gt.5.and.iqq.le.0)then

        call utstop('Wrong, iqq in omXgam !&')
      endif

      endif
      omXgam=omXgam/2.d0
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
     *  *dble(chad(iclpro)*chad(icltar))
     *  *dble(chad(iclpro)*chad(icltar))

c      write(*,*)'omXgam',iqq,xp,xm,dsy,b,omXgam,r4pomp

      return
      end

c-----------------------------------------------------------------------
      double precision function omXgamint(b,iqq)
c-----------------------------------------------------------------------
c - integrated cut part of chi/2. for cut X enhanced diagram
c b - impact parameter between the pomeron ends;
c iqq = 1  - 4p(2*scr),
c iqq = 2  - 4p+(scr),
c iqq = 3  - 4p-(scr),
c iqq = 4  - 4p-(dif+scr),
c iqq = 5  - 4p+(dif+scr)
c-----------------------------------------------------------------------
      double precision dsy,ddelx,alp1,alp2,alp3,alp4
     & ,del1,del2,del3,del4,dps,utgam2,r4pomp,alppro,alptar
      include 'nexus.inc'
      include 'nexus.incsem'
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar7/ delx,alam3p,gam3p
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)

      omXgamint=0.d0
      if(iqq.eq.1.and.cXscr.eq.0.d0)return
      if((iqq.eq.4.or.iqq.eq.5).and.cXdif.eq.0.d0)return
      if((iqq.eq.2.or.iqq.eq.3).and.cXfus.eq.0.d0)return
      b2=b*b
      sy=engy*engy

      dsy=dble(sy)
      ddelx=dble(delx)

      if(dsy.gt.ddelx**2.and.dsy.gt.Eseuil**2..and.iscreen.ne.0)then
        
      gamb=gamD(1,iclegy,iclpro,icltar,icdp,icdt)
      alp=xmu(3)      
      betv=xnu(iclegy,iclpro)+gamb*b2/2.
      betp=betD1(1,iclegy,iclpro)+betv
      betm=betD1(1,iclegy,icltar)+betv
      gamp=betDp1(1,iclegy,iclpro)-alppar+xnup(iclegy,iclpro)
      gamm=betDp1(1,iclegy,icltar)-alppar+xnup(iclegy,icltar)
      del=delD1(1,iclegy,iclpro)

      r4pomp=dble(4.*0.0389*gamhad(iclpro)**2.*gamhad(icltar)**2.
     *      *utgam1(2.+2.*betp)/utgam1(1.+betp)**2.
     *      *utgam1(2.+2.*betm)/utgam1(1.+betm)**2.
     *      *utgam1(2.+2.*betp+2.*gamp)/utgam1(1.+betp+gamp)**2.
     *      *utgam1(2.+2.*betm+2.*gamm)/utgam1(1.+betm+gamm)**2.
     *      /pi*del**3./log(sy/delx/delx)/(alp*del)**4.*xmu(2))
     *      /dble(chad(iclpro)*chad(icltar))


       
      del1=dble(betD1(1,iclegy,iclpro)+betv)
      alp1=dble(betDp1(1,iclegy,iclpro)-alppar)
     &     +dble(xnup(iclegy,iclpro))
      rh1=delD1(1,iclegy,iclpro)
      del2=dble(betD1(1,iclegy,iclpro)+betv)
      alp2=dble(betDp1(1,iclegy,iclpro)-alppar)
     &     +dble(xnup(iclegy,iclpro))
      rh2=delD1(1,iclegy,iclpro)
      rh12=rh1*rh2/(rh1+rh2)
      del3=dble(betD1(1,iclegy,icltar)+betv)
      alp3=dble(betDp1(1,iclegy,icltar)-alppar)
     &     +dble(xnup(iclegy,icltar))
      rh3=delD1(1,iclegy,icltar)
      del4=dble(betD1(1,iclegy,icltar)+betv)
      alp4=dble(betDp1(1,iclegy,icltar)-alppar)
     &     +dble(xnup(iclegy,icltar))
      rh4=delD1(1,iclegy,icltar)
      rh34=rh3*rh4/(rh3+rh4)
      rh=rh12+rh34
      dps=dlog(max(1.d0,dsy/ddelx**2))

      alppro=1.d0+dble(alplea(iclpro))
      alptar=1.d0+dble(alplea(icltar))

      omXgamint=r4pomp*dps*dsy**(del3+del4)
     *  *utgam2(1.d0+alp1+del1)*utgam2(1.d0+alp2+del2)*utgam2(alppro)
     *  /utgam2(2.d0+alppro+alp1+del1+alp2+del2)
     *  *utgam2(1.d0+alp3+del3)*utgam2(1.d0+alp4+del4)*utgam2(alptar)
     *  /utgam2(2.d0+alptar+alp3+del3+alp4+del4)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *utgam2(1.d0+del3)*utgam2(1.d0+del4)
     *  /utgam2(2.d0+del3+del4)
     *  *dble(alpD1(1,iclegy,iclpro)*alpD1(1,iclegy,iclpro)
     *  *alpD1(1,iclegy,icltar)*alpD1(1,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rh4)/rh*exp(-b2/rh))
        omXgamint=omXgamint*dble(pi/.0389)

      if(iqq.eq.1)then
          
        omXgamint=omXgamint*cXscr

      elseif(iqq.eq.2.or.iqq.eq.3)then          

        omXgamint=omXgamint*cXfus
                
      elseif(iqq.eq.4.or.iqq.eq.5)then
          
        omXgamint=omXgamint*cXdif

        elseif(iqq.gt.5.and.iqq.le.0)then

        call utstop('Wrong, iqq in omXgamint !&')
      endif

      endif
      omXgamint=omXgamint/2.d0
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
     *  *dble(chad(iclpro)*chad(icltar))
     *  *dble(chad(iclpro)*chad(icltar))

c      write(*,*)'omXgamint',iqq,xp,xm,dsy,b,omXgamint,r4pomp

      return
      end


c----------------------------------------------------------------------

      double precision function omXint(xprem,xmrem,bh,iqq,iqqq)

c----------------------------------------------------------------------
c Log+Lin Integration over xp and xm of omXcut(iqq)
c iqq = 1  - 4p(2*scr),
c iqq = 2  - 4p+(scr),
c iqq = 3  - 4p-(scr),
c iqq = 4  - 4p-(dif+scr),
c iqq = 5  - 4p+(dif+scr)
c iqqq=0 ideal G
c iqqq=1 exact G
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      double precision xh,omXcut,omint,xmrem,xprem,ds,ominty,Gst,zm 
      double precision xi,zp,zpmax,zpmin,zmin,xrem,zmmax
      double precision dzp,dzm,yp,zmmin,alpp,alpm,xp,xm,zalpp,zalpm
c      double precision gamp,gamm
      common /psar7/ delx,alam3p,gam3p
      common /ar3/  x1(7),a1(7)
      double precision dgx1,dga1
      common /dga20/ dgx1(10),dga1(10)
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)

      ds=dble(engy*engy)
      xi=dble(delx)
      zmin=1.d-30
      omXint=0.d0
c$$$        b2=bh*bh
c$$$        gamb=gamD(1,iclegy,iclpro,icltar,icdp,icdt)
c$$$        gamp=dble(xnup(iclegy,iclpro)-xnu(iclegy,iclpro)+gamb*b2/2.
c$$$     &       -alppar)
c$$$        gamm=dble(xnup(iclegy,icltar)-xnu(iclegy,icltar)+gamb*b2/2.
c$$$     &       -alppar)
      if(iqq.eq.2.or.iqq.eq.1.or.iqq.eq.4)then
        alpp=.5d0!  (1.d0+gamp)/1.d0
      endif
      if(iqq.eq.3.or.iqq.eq.1.or.iqq.eq.5)then
        alpm=.5d0!  (1.d0+gamm)/1.d0
      endif

      if(iqq.eq.4.or.iqq.eq.5)then

        if(iqq.eq.5)then
           xrem=xmrem
           zalpm=alpm
         else
           xrem=xprem
           zalpm=alpp
         endif
        
        zpmax=-dlog(xi/ds)
        zpmin=-dlog(1.d0/xi)
        zmmin=zmin**alpm
        zmmax=xrem**alpm

        omint=0.d0
        dzp=(zpmax-zpmin)/2.d0
        dzm=(zmmax-zmmin)/2.d0

        do n=1,2
          do j=1,7
            zp=zpmin+dzp*(1.d0+dble(2.*n-3.)*dble(x1(j)))
            ominty=0.d0
            do m=1,2
              do i=1,7
                zm=zmmin+dzm*(1.d0+dble(2.*m-3.)*dble(x1(i)))
                xp=dexp(-zp)
                xm=zm**(1.d0/zalpm)
                xh=xp*xm
           if(iqq.eq.5)then
             yp=0.5d0*dlog(xp/xm)
           Gst=omXcut(xh,yp,xprem,xmrem-xm,bh,iqq,iqqq)
c           Gst=omXcut(xh,yp,xprem-xp,xmrem-xm,bh,iqq,iqqq)
           else
             yp=-0.5d0*dlog(xp/xm)
           Gst=omXcut(xh,yp,xprem-xm,xmrem,bh,iqq,iqqq)
c           Gst=omXcut(xh,yp,xprem-xm,xmrem-xp,bh,iqq,iqqq)
           endif
           ominty=ominty+dble(a1(i))*Gst*zm**(1.d0/zalpm-1.d0)/zalpm
            enddo
          enddo
          omint=omint+ominty*dble(a1(j))*xp
        enddo
      enddo
      omXint=dzp*dzm*omint
      
       elseif(iqq.eq.2.or.iqq.eq.3)then
         if(iqq.eq.2)then
           xrem=xprem
           zalpp=alpp
         else
           xrem=xmrem
           zalpp=alpm
         endif
         
         zpmin=zmin**zalpp
         zpmax=xrem**zalpp
         
         omint=0.d0
         dzp=(zpmax-zpmin)/2.d0
         
         do n=1,2
           do j=1,7
             zp=zpmin+dzp*(1.d0+dble(2.*n-3.)*dble(x1(j)))
             xp=zp**(1.d0/zalpp)
             if(iqq.eq.2)then
               xm=xmrem
               xh=xp*xm
               yp=.5d0*dlog(xp/xm)
               Gst=omXcut(xh,yp,xprem-xp,0.d0,bh,iqq,iqqq)
             else
               xm=xprem
               xh=xp*xm
               yp=-.5d0*dlog(xp/xm)
               Gst=omXcut(xh,yp,0.d0,xmrem-xp,bh,iqq,iqqq)
               endif
               omint=omint+Gst*dble(a1(j))*zp**(1.d0/zalpp-1.d0)/zalpp
             enddo
           enddo
           omXint=dzp*omint
      
         elseif(iqq.eq.1)then


           zpmin=zmin**alpp
           zpmax=xprem**alpp
           zmmin=zmin**alpm
           zmmax=xmrem**alpm

           omint=0.d0
           dzp=(zpmax-zpmin)/2.d0
           dzm=(zmmax-zmmin)/2.d0
           
           do n=1,2
             do j=1,7
               zp=zpmin+dzp*(1.d0+dble(2.*n-3.)*dble(x1(j)))
               ominty=0.d0
               do m=1,2
                 do i=1,7
                   zm=zmmin+dzm*(1.d0+dble(2.*m-3.)*dble(x1(i)))
                   xp=zp**(1.d0/alpp)
                   xm=zm**(1.d0/alpm)
                   xh=xp*xm
                   yp=0.5d0*dlog(xp/xm)
                   Gst=omXcut(xh,yp,xprem-xp,
     &                  xmrem-xm,bh,iqq,iqqq)
               ominty=ominty+dble(a1(i))*Gst*zm**(1.d0/alpm-1.d0)/alpm
                 enddo
               enddo
               omint=omint+ominty*dble(a1(j))*zp**(1.d0/alpp-1.d0)/alpp
             enddo
           enddo
           omXint=dzp*dzm*omint
           

       else

        call utstop('Wrong iqq in omXint&')

      endif

      return
      end


c----------------------------------------------------------------------

      double precision function SomX(xprem,xmrem,bh,iqq)

c----------------------------------------------------------------------
c Sum of all omXint(iqq)
c iqq=0 ideal G
c iqq=1 exact G
c iqq=2 ideal G for distribution probability (= ideal G)
c----------------------------------------------------------------------
      double precision omXint,xmrem,xprem,ds,xi
      include 'nexus.inc'
      common /psar7/ delx,alam3p,gam3p


      ds=dble(engy*engy)
      xi=dble(delx)
      SomX=0.d0
      if(ds.gt.xi*xi)then

      do i=1,5
        SomX=SomX+omXint(xprem,xmrem,bh,i,iqq)
      enddo

      endif
      
      return
      end




c-----------------------------------------------------------------------
      double precision function omYuncut(sy,xh,yp,b,iqq)
c-----------------------------------------------------------------------
c - chi~(x,y)/2. for sum of uncut Y enhanced diagram
c xh - fraction of the energy squared s for the pomeron;
c yp - rapidity for the pomeron;
c b - impact parameter between the pomeron ends;
c iqq=0 ideal G
c iqq=1 exact G
c-----------------------------------------------------------------------
      double precision omYuncutJ,xh,yp

      if(iqq.eq.0)then
        omYuncut=omYuncutJ(sy,xh,yp,b,1,1,1,1,1,1)
      else
        omYuncut=omYuncutJ(sy,xh,yp,b,2,4,2,4,2,4)
      endif

      return
      end

c-----------------------------------------------------------------------
      double precision function omYuncutJ(sy,xh,yp,b,min1,max1,min2,
     &                                    max2,min3,max3)
c-----------------------------------------------------------------------
c - chi~(x,y)/2. for sum of uncut Y enhanced diagram
c xh - fraction of the energy squared s for the pomeron;
c yp - rapidity for the pomeron;
c b - impact parameter between the pomeron ends;
c mini, maxi = 1 - G1 for ideal G (all min/max set to 1)
c              2 - soft G1
c              3 - semihard G1
c              4 - valence G1
c min1/max1 and min2/max2 - parallel legs
c min3/max3               - simple leg
c-----------------------------------------------------------------------
      double precision xh,yp,xp,xm,dsy,ddelx,alp1,alp2,alp3,dps,utgam2,
     & del1,del2,del3,v1o2p1t0l,v1o1p2t0l,r3pomp,r3pomm
      include 'nexus.inc'
      include 'nexus.incsem'
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar7/ delx,alam3p,gam3p
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)


      b2=b*b

      gamb=gamD(1,iclegy,iclpro,icltar,icdp,icdt)
      alp=xmu(3)
      betv=xnu(iclegy,iclpro)+gamb*b2/2.
      betp=betD1(1,iclegy,iclpro)+betv
      betm=betD1(1,iclegy,icltar)+betv
      gamp=betDp1(1,iclegy,iclpro)-alppar+xnup(iclegy,iclpro)
      gamm=betDp1(1,iclegy,icltar)-alppar+xnup(iclegy,icltar)
      del=delD1(1,iclegy,iclpro)
      rhv=del

      r3pomp=dble(4.*0.0389*gamhad(iclpro)**2.*gamhad(icltar)
     *      /(alp*del)**3.*xmu(1)
     *      *utgam1(2.+2.*betp)/utgam1(1.+betp)**2.
     *      *utgam1(2.+2.*betp+2.*gamp)/utgam1(1.+betp+gamp)**2.
     *      /pi*del**3./log(sy/delx/delx))
     *      /dble(chad(iclpro))

      r3pomm=dble(4.*0.0389*gamhad(icltar)**2.*gamhad(iclpro)
     *      /(alp*del)**3.*xmu(1)
     *      *utgam1(2.+2.*betm)/utgam1(1.+betm)**2.
     *      *utgam1(2.+2.*betm+2.*gamm)/utgam1(1.+betm+gamm)**2.
     *      /pi*del**3./log(sy/delx/delx))
     *      /dble(chad(icltar))

      dsy=dble(sy)
      ddelx=dble(delx)
      xp=dsqrt(xh)*dexp(yp)
      if(xp.ne.0.d0)then
        xm=xh/xp
      else
        xm=0.d0
      endif
      omYuncutJ=0.d0
      

c 1st order, 2 proj legs, 1 targ leg, 0 loops
      v1o2p1t0l=0.D0

      if(dsy.gt.ddelx**2.and.dsy.gt.Eseuil**2..and.iscreen.ne.0)then
       
      
      do i1=min1,max1
        del1=dble(betD1(i1,iclegy,iclpro))
        if(i1.eq.1)del1=del1+dble(betv)
        alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &            +dble(xnup(iclegy,iclpro))
	rh1=delD1(i1,iclegy,iclpro)
      do i2=min2,max2
        del2=dble(betD1(i2,iclegy,iclpro))
        if(i2.eq.1)del2=del2+dble(betv)
        alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &            +dble(xnup(iclegy,iclpro))
	rh2=delD1(i2,iclegy,iclpro)
	rh12=rh1*rh2/(rh1+rh2)
      do i3=min3,max3
        del3=dble(betD1(i3,iclegy,icltar))
        if(i3.eq.1)del3=del3+dble(gamb*b2)
        alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &            +dble(xnum(iclegy,icltar))
	rh3=delD1(i3,iclegy,icltar)
        if(i3.eq.1)then
          rhv=del
          rh3v=rh3*rhv/(rh3+rhv)
        else
          rh3v=rh3
          rhv=1.-rh3
        endif
	rh=rh3v+rh12      


        if(dabs(del1+del2-del3).lt.1.d-5)then
          dps=dlog(max(1.d0,dsy/ddelx**2))
        else
          dps=((dsy/ddelx)**(del1+del2-del3)
     *    -ddelx**(del1+del2-del3))
     *    /(del1+del2-del3)
        endif 

        if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
          r3pomp=dble(r3pom)
        endif

        v1o2p1t0l=v1o2p1t0l+r3pomp*dps*dsy**del3
     *  *xp**(1.d0+alp1+alp2+del1+del2)
     *  *xm**(alp3+del3)
     *  *utgam2(1.d0+alp1+del1)*utgam2(1.d0+alp2+del2)
     *  /utgam2(2.d0+alp1+del1+alp2+del2)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
      enddo
      enddo
      enddo
      v1o2p1t0l=(-2.d0)*v1o2p1t0l*dble(pi/.0389)/2.d0
     *          *dble(chad(iclpro))


      v1o1p2t0l=0.d0  !1st order, 1 proj leg, 2 targ legs, 0 loops
      
      do i1=min1,max1
        del1=dble(betD1(i1,iclegy,icltar))
        if(i1.eq.1)del1=del1+dble(betv)
        alp1=dble(betDp1(i1,iclegy,icltar)-alppar)
     &            +dble(xnup(iclegy,icltar))
	rh1=delD1(i1,iclegy,icltar)
      do i2=min2,max2
        del2=dble(betD1(i2,iclegy,icltar))
        if(i2.eq.1)del2=del2+dble(betv)
        alp2=dble(betDp1(i2,iclegy,icltar)-alppar)
     &            +dble(xnup(iclegy,icltar))
	rh2=delD1(i2,iclegy,icltar)
	rh12=rh1*rh2/(rh1+rh2)
      do i3=min3,max3
        del3=dble(betD1(i3,iclegy,iclpro))
        if(i3.eq.1)del3=del3+dble(gamb*b2)
        alp3=dble(betDp1(i3,iclegy,iclpro)-alppar)
     &            +dble(xnum(iclegy,iclpro))
	rh3=delD1(i3,iclegy,iclpro)
        if(i3.eq.1)then
          rhv=del
          rh3v=rh3*rhv/(rh3+rhv)
        else
          rh3v=rh3
          rhv=1.-rh3
        endif
	rh=rh3v+rh12      


        if(dabs(del1+del2-del3).lt.1.d-5)then
          dps=dlog(max(1.d0,dsy/ddelx**2))
        else
          dps=((dsy/ddelx)**(del1+del2-del3)
     *    -ddelx**(del1+del2-del3))
     *    /(del1+del2-del3)
        endif 

        if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
          r3pomm=dble(r3pom)
        endif

        v1o1p2t0l=v1o1p2t0l+r3pomm*dps*dsy**del3
     *  *xm**(1.d0+alp1+alp2+del1+del2)
     *  *xp**(alp3+del3)
     *  *utgam2(1.d0+alp1+del1)*utgam2(1.d0+alp2+del2)
     *  /utgam2(2.d0+alp1+del1+alp2+del2)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,icltar)*alpD1(i2,iclegy,icltar)
     *  *alpD1(i3,iclegy,iclpro)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
      enddo
      enddo
      enddo
      v1o1p2t0l=(-2.d0)*v1o1p2t0l*dble(pi/.0389)/2.d0
     *      *dble(chad(icltar))


      omYuncutJ=v1o2p1t0l+v1o1p2t0l
c      omYuncutJ=v1o1p2t0l
      endif
      
      omYuncutJ=omYuncutJ/2.d0
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
     *  *dble(chad(iclpro)*chad(icltar))

      return
      end


c-----------------------------------------------------------------------
      double precision function omYcut(xh,yp,xprem,xmrem,b,iqq,iqqq)
c-----------------------------------------------------------------------
c - chi~(x,y,xpr,xmr)/2. for cut Y enhanced diagram
c xh - fraction of the energy squared s for the pomeron;
c yp - rapidity for the pomeron;
c xprem,xmrem impulsion fraction of remnant
c b - impact parameter between the pomeron ends;
c iqq = 1  - 3p+(cut),
c iqq = 2  - 3p+(scr),
c iqq = 3  - 3p+(dif),
c iqq = 4  - 3p-(cut),
c iqq = 5  - 3p-(scr),
c iqq = 6  - 3p-(dif),
c iqqq=0 ideal G
c iqqq=1 exact G
c iqqq=2 ideal G for distribution probability (= ideal G)
c-----------------------------------------------------------------------
      include "nexus.inc"
      include "nexus.incsem"
      double precision omYcutJ,xprem,xmrem,xh,yp,xp,xm,gamp,gamm,
     &gampp,gammp,omYgam
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)

      if(iqqq.eq.0)then
        omYcut=omYcutJ(xh,yp,xprem,xmrem,b,1,1,1,1,1,1,iqq)
      elseif(iqqq.eq.1)then
        omYcut=omYcutJ(xh,yp,xprem,xmrem,b,2,4,2,4,2,4,iqq)
      elseif(iqqq.eq.2)then
        xp=dsqrt(xh)*dexp(yp)
        if(xp.ne.0.d0)then
          xm=xh/xp
        else
          xm=0.d0
        endif
        b2=b*b
        gamb=gamD(1,iclegy,iclpro,icltar,icdp,icdt)
        gamp=dble(xnup(iclegy,iclpro)-xnu(iclegy,iclpro)+gamb*b2/2.
     &       -alppar)
        gamm=dble(xnup(iclegy,icltar)-xnu(iclegy,icltar)+gamb*b2/2.
     &       -alppar)
        gampp=1.d0+2.d0*gamp
        gammp=1.d0+2.d0*gamm

        if(iqq.eq.1)then
          omYcut=omYgam(xp,xm,b,iqq)
        elseif(iqq.eq.2)then
          omYcut=omYgam(xp,xm,b,iqq)*xprem**gamp
        elseif(iqq.eq.3)then
          omYcut=omYgam(xp,xm,b,iqq)*xprem**gampp
        elseif(iqq.eq.4)then
          omYcut=omYgam(xp,xm,b,iqq)
        elseif(iqq.eq.5)then
          omYcut=omYgam(xp,xm,b,iqq)*xmrem**gamm
        elseif(iqq.eq.6)then
          omYcut=omYgam(xp,xm,b,iqq)*xmrem**gammp
        else
          call utstop('Wrong iqq in omYcut&')
        endif
      else
        call utstop('Wrong iqqq in omYcut&')
      endif

      return
      end



c-----------------------------------------------------------------------
      double precision function omYcutJ(xh,yp,xprem,xmrem,b,min1,max1,
     &                                    min2,max2,min3,max3,iqq)
c-----------------------------------------------------------------------
c - chi~(x,y,xpr,xmr)/2. for cut Y enhanced diagram
c xh - fraction of the energy squared s for the pomeron;
c yp - rapidity for the pomeron;
c xprem,xmrem impulsion fraction of remnant
c b - impact parameter between the pomeron ends;
c iqq = 1  - 3p+(cut),
c iqq = 2  - 3p+(scr),
c iqq = 3  - 3p+(dif),
c iqq = 4  - 3p-(cut),
c iqq = 5  - 3p-(scr),
c iqq = 6  - 3p-(dif),
c mini, maxi = 1 - G1 for ideal G (all min/max set to 1)
c              2 - soft G1
c              3 - semihard G1
c              4 - valence G1
c min1/max1 and min2/max2 - parallel legs
c min3/max3               - simple leg
c-----------------------------------------------------------------------
      double precision xh,yp,xp,xm,dsy,ddelx,alp1,alp2,alp3,utgam2,
     & del1,del2,del3,xmrem,xprem,dps,r3pomp,r3pomm
      include 'nexus.inc'
      include 'nexus.incsem'
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar7/ delx,alam3p,gam3p
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)

      omYcutJ=0.d0
      if((iqq.eq.2.or.iqq.eq.5).and.cYscr.eq.0.d0)return
      if((iqq.eq.3.or.iqq.eq.6).and.cYdif.eq.0.d0)return
      if((iqq.eq.1.or.iqq.eq.4).and.cYfus.eq.0.d0)return
      b2=b*b
      sy=engy*engy
      dsy=dble(sy)
      ddelx=dble(delx)
      xp=dsqrt(xh)*dexp(yp)
      if(xp.ne.0.d0)then
        xm=xh/xp
      else
        xm=0.d0
      endif

      if(dsy.gt.Eseuil**2..and.xprem.ge.0.d0.and.xmrem.ge.0.d0
     &                                       .and.iscreen.ne.0)then

      gamb=gamD(1,iclegy,iclpro,icltar,icdp,icdt)
      alp=xmu(3)
      betv=xnu(iclegy,iclpro)+gamb*b2/2.
      betp=betD1(1,iclegy,iclpro)+betv
      betm=betD1(1,iclegy,icltar)+betv
      gamp=betDp1(1,iclegy,iclpro)-alppar+xnup(iclegy,iclpro)
      gamm=betDp1(1,iclegy,icltar)-alppar+xnup(iclegy,icltar)
      del=delD1(1,iclegy,iclpro)
      rhv=del

      r3pomp=dble(4.*0.0389*gamhad(iclpro)**2.*gamhad(icltar)
     *      /(alp*del)**3.*xmu(1)
     *      *utgam1(2.+2.*betp)/utgam1(1.+betp)**2.
     *      *utgam1(2.+2.*betp+2.*gamp)/utgam1(1.+betp+gamp)**2.
     *      /pi*del**3./log(sy/delx/delx))
     *      /dble(chad(iclpro))

      r3pomm=dble(4.*0.0389*gamhad(icltar)**2.*gamhad(iclpro)
     *      /(alp*del)**3.*xmu(1)
     *      *utgam1(2.+2.*betm)/utgam1(1.+betm)**2.
     *      *utgam1(2.+2.*betm+2.*gamm)/utgam1(1.+betm+gamm)**2.
     *      /pi*del**3./log(sy/delx/delx))
     *      /dble(chad(icltar))
      

       
      

c 1st order, 2 proj cut legs, 1 targ cut leg, 0 loops

        if(dsy.gt.ddelx**2.and.iqq.eq.1)then
      
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,iclpro))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &           +dble(xnup(iclegy,iclpro))
            rh1=delD1(i1,iclegy,iclpro)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,iclpro))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &             +dble(xnup(iclegy,iclpro))
              rh2=delD1(i2,iclegy,iclpro)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,icltar))
                if(i3.eq.1)del3=del3+dble(gamb*b2)
                alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &               +dble(xnum(iclegy,icltar))
                rh3=delD1(i3,iclegy,icltar)
                if(i3.eq.1)then
                  rhv=del
                  rh3v=rh3*rhv/(rh3+rhv)
                else
                  rh3v=rh3
                  rhv=1.-rh3
                endif
                rh=rh3v+rh12      
                
                if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
                  r3pomp=dble(r3pom)
                endif
                
                if(dabs(del1+del2-del3).lt.1.d-5)then
                  dps=dlog(max(1.d0,dsy/ddelx**2))
                else
                  dps=((dsy/ddelx)**(del1+del2-del3)
     *                 -ddelx**(del1+del2-del3))
     *                 /(del1+del2-del3)
                endif 

                
                omYcutJ=omYcutJ+r3pomp*dps*dsy**del3
     *  *xp**(1.d0+alp1+alp2+del1+del2)
     *  *xm**(alp3+del3)
     *  *utgam2(1.d0+alp1+del1)*utgam2(1.d0+alp2+del2)
     *  /utgam2(2.d0+alp1+del1+alp2+del2)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
              enddo
            enddo
          enddo
          
          omYcutJ=omYcutJ*dble(pi/.0389)*cYfus

        elseif(dsy.gt.ddelx**2.and.iqq.eq.4)then
      
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,icltar))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,icltar)-alppar)
     &           +dble(xnup(iclegy,icltar))
            rh1=delD1(i1,iclegy,icltar)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,icltar))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,icltar)-alppar)
     &             +dble(xnup(iclegy,icltar))
              rh2=delD1(i2,iclegy,icltar)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,iclpro))
                if(i3.eq.1)del3=del3+dble(gamb*b2)
                alp3=dble(betDp1(i3,iclegy,iclpro)-alppar)
     &               +dble(xnum(iclegy,iclpro))
                rh3=delD1(i3,iclegy,iclpro)
                if(i3.eq.1)then
                  rhv=del
                  rh3v=rh3*rhv/(rh3+rhv)
                else
                  rh3v=rh3
                  rhv=1.-rh3
                endif
                rh=rh3v+rh12      
                
                if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
                  r3pomm=dble(r3pom)
                endif
                
                
                if(dabs(del1+del2-del3).lt.1.d-5)then
                  dps=dlog(max(1.d0,dsy/ddelx**2))
                else
                  dps=((dsy/ddelx)**(del1+del2-del3)
     *                 -ddelx**(del1+del2-del3))
     *                 /(del1+del2-del3)
                endif 


                omYcutJ=omYcutJ+r3pomm*dps*dsy**del3
     *  *xm**(1.d0+alp1+alp2+del1+del2)
     *  *xp**(alp3+del3)
     *  *utgam2(1.d0+alp1+del1)*utgam2(1.d0+alp2+del2)
     *  /utgam2(2.d0+alp1+del1+alp2+del2)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,icltar)*alpD1(i2,iclegy,icltar)
     *  *alpD1(i3,iclegy,iclpro)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
              enddo
            enddo
          enddo

          omYcutJ=omYcutJ*dble(pi/.0389)*cYfus

        elseif(dsy.gt.ddelx**2.and.iqq.eq.2)then
      
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,iclpro))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &           +dble(xnup(iclegy,iclpro))
            rh1=delD1(i1,iclegy,iclpro)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,iclpro))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &             +dble(xnup(iclegy,iclpro))
              rh2=delD1(i2,iclegy,iclpro)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,icltar))
                if(i3.eq.1)del3=del3+dble(gamb*b2)
                alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &               +dble(xnum(iclegy,icltar))
                rh3=delD1(i3,iclegy,icltar)
                if(i3.eq.1)then
                  rhv=del
                  rh3v=rh3*rhv/(rh3+rhv)
                else
                  rh3v=rh3
                  rhv=1.-rh3
                endif
                rh=rh3v+rh12      
                
                if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
                  r3pomp=dble(r3pom)
                endif

                if(dabs(del1+del2-del3).lt.1.d-5)then
                  dps=dlog(max(1.d0,dsy/ddelx**2))
                else
                  dps=((dsy/ddelx)**(del1+del2-del3)
     *                 -ddelx**(del1+del2-del3))
     *                 /(del1+del2-del3)
                endif 
                

                omYcutJ=omYcutJ+r3pomp*dps*dsy**del3
     *  *xp**(alp1+del1)*xprem**(alp2+del2)
     *  *xm**(alp3+del3)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
              enddo
            enddo
          enddo
          omYcutJ=omYcutJ*dble(pi/.0389)*cYscr

        elseif(dsy.gt.ddelx**2.and.iqq.eq.5)then
      
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,icltar))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,icltar)-alppar)
     &           +dble(xnup(iclegy,icltar))
            rh1=delD1(i1,iclegy,icltar)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,icltar))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,icltar)-alppar)
     &             +dble(xnup(iclegy,icltar))
              rh2=delD1(i2,iclegy,icltar)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,iclpro))
                if(i3.eq.1)del3=del3+dble(gamb*b2)
                alp3=dble(betDp1(i3,iclegy,iclpro)-alppar)
     &               +dble(xnum(iclegy,iclpro))
                rh3=delD1(i3,iclegy,iclpro)
                if(i3.eq.1)then
                  rhv=del
                  rh3v=rh3*rhv/(rh3+rhv)
                else
                  rh3v=rh3
                  rhv=1.-rh3
                endif
                rh=rh3v+rh12      
                
                if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
                  r3pomm=dble(r3pom)
                endif
                
                
                if(dabs(del1+del2-del3).lt.1.d-5)then
                  dps=dlog(max(1.d0,dsy/ddelx**2))
                else
                  dps=((dsy/ddelx)**(del1+del2-del3)
     *                 -ddelx**(del1+del2-del3))
     *                 /(del1+del2-del3)
                endif 
                

                omYcutJ=omYcutJ+r3pomm*dps*dsy**del3
     *  *xm**(alp1+del1)*xmrem**(alp2+del2)
     *  *xp**(alp3+del3)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,icltar)*alpD1(i2,iclegy,icltar)
     *  *alpD1(i3,iclegy,iclpro)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
              enddo
            enddo
          enddo
          omYcutJ=omYcutJ*dble(pi/.0389)*cYscr

        elseif(iqq.eq.3.and.xp.lt.1.d0/ddelx.and.xp.gt.ddelx/dsy)then
      
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,iclpro))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &           +dble(xnup(iclegy,iclpro))
            rh1=delD1(i1,iclegy,iclpro)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,iclpro))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &             +dble(xnup(iclegy,iclpro))
              rh2=delD1(i2,iclegy,iclpro)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,icltar))
                if(i3.eq.1)del3=del3+dble(gamb*b2)
                alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &               +dble(xnum(iclegy,icltar))
                rh3=delD1(i3,iclegy,icltar)
                if(i3.eq.1)then
                  rhv=del
                  rh3v=rh3*rhv/(rh3+rhv)
                else
                  rh3v=rh3
                  rhv=1.-rh3
                endif
                rh=rh3v+rh12      
                
                if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
                  r3pomp=dble(r3pom)
                endif
                
                
                omYcutJ=omYcutJ+r3pomp*dsy**del3
     *  *xprem**(1.d0+alp1+alp2+del1+del2)
     *  *xm**(alp3+del3)*xp**(del3-del1-del2-1.d0)
     *  *utgam2(1.d0+alp1+del1)*utgam2(1.d0+alp2+del2)
     *  /utgam2(2.d0+alp1+del1+alp2+del2)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
              enddo
            enddo
          enddo
          omYcutJ=omYcutJ*dble(pi/.0389)*cYdif

        elseif(iqq.eq.6.and.xm.lt.1.d0/ddelx.and.xm.gt.ddelx/dsy)then
      
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,icltar))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,icltar)-alppar)
     &           +dble(xnup(iclegy,icltar))
            rh1=delD1(i1,iclegy,icltar)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,icltar))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,icltar)-alppar)
     &             +dble(xnup(iclegy,icltar))
              rh2=delD1(i2,iclegy,icltar)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,iclpro))
                if(i3.eq.1)del3=del3+dble(gamb*b2)
                alp3=dble(betDp1(i3,iclegy,iclpro)-alppar)
     &               +dble(xnum(iclegy,iclpro))
                rh3=delD1(i3,iclegy,iclpro)
                if(i3.eq.1)then
                  rhv=del
                  rh3v=rh3*rhv/(rh3+rhv)
                else
                  rh3v=rh3
                  rhv=1.-rh3
                endif
                rh=rh3v+rh12      
                
                if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
                  r3pomm=dble(r3pom)
                endif
                
                omYcutJ=omYcutJ+r3pomm*dsy**del3
     *  *xmrem**(1.d0+alp1+alp2+del1+del2)
     *  *xp**(alp3+del3)*xm**(del3-del1-del2-1.d0)
     *  *utgam2(1.d0+alp1+del1)*utgam2(1.d0+alp2+del2)
     *  /utgam2(2.d0+alp1+del1+alp2+del2)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,icltar)*alpD1(i2,iclegy,icltar)
     *  *alpD1(i3,iclegy,iclpro)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
              enddo
            enddo
          enddo
          omYcutJ=omYcutJ*dble(pi/.0389)*cYdif

        elseif(iqq.gt.6.or.iqq.le.0)then
          call utstop('Wrong iqq in omYcutJ !&')
        endif
          
      endif
 
      omYcutJ=omYcutJ/2.d0
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
     *  *dble(chad(iclpro)*chad(icltar))
      if(iqq.le.3)then
        omYcutJ=omYcutJ*dble(chad(iclpro))
      else
        omYcutJ=omYcutJ*dble(chad(icltar))
      endif

      return
      end

c-----------------------------------------------------------------------
      double precision function omYcutJc(xp1,xp2,xm,xpv,b,min1,max1,
     &                                    min2,max2,min3,max3,iqq)
c-----------------------------------------------------------------------
c - chi~(xp1,xp2,xm,xpv)/2. for triple cut Y  enhanced diagram
c xp1,xp2 impulsion fraction of cut parallel pomerons
c xm impulsion fraction of cut single pomeron
c xmrem impulsion fraction of remnant
c xpv impulsion fraction of the vertex
c b - impact parameter between the pomeron ends;
c iqq = 1  - 3p+(cut),
c iqq = 2  - 3p-(cut),
c mini, maxi = 1 - G1 for ideal G (all min/max set to 1)
c              2 - soft G1
c              3 - semihard G1
c              4 - valence G1
c min1/max1 and min2/max2 - parallel legs
c min3/max3               - simple leg
c-----------------------------------------------------------------------
      double precision xp1,xp2,xm,dsy,alp1,alp2,alp3,utgam2,
     & del1,del2,del3,xpv,dps,r3pomp,r3pomm
      include 'nexus.inc'
      include 'nexus.incsem'
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar7/ delx,alam3p,gam3p
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)

      b2=b*b
      sy=engy*engy
      dsy=dble(sy)
      omYcutJc=0.d0
      if(cYfus.eq.0.d0)return

      if(dsy.gt.Eseuil**2..and.iscreen.ne.0)then

      gamb=gamD(1,iclegy,iclpro,icltar,icdp,icdt)
      alp=xmu(3)
      betv=xnu(iclegy,iclpro)+gamb*b2/2.
      betp=betD1(1,iclegy,iclpro)+betv
      betm=betD1(1,iclegy,icltar)+betv
      gamp=betDp1(1,iclegy,iclpro)-alppar+xnup(iclegy,iclpro)
      gamm=betDp1(1,iclegy,icltar)-alppar+xnup(iclegy,icltar)
      del=delD1(1,iclegy,iclpro)
      rhv=del

      r3pomp=dble(4.*0.0389*gamhad(iclpro)**2.*gamhad(icltar)
     *      /(alp*del)**3.*xmu(1)
     *      *utgam1(2.+2.*betp)/utgam1(1.+betp)**2.
     *      *utgam1(2.+2.*betp+2.*gamp)/utgam1(1.+betp+gamp)**2.
     *      /pi*del**3./log(sy/delx/delx))
     *      /dble(chad(iclpro))

      r3pomm=dble(4.*0.0389*gamhad(icltar)**2.*gamhad(iclpro)
     *      /(alp*del)**3.*xmu(1)
     *      *utgam1(2.+2.*betm)/utgam1(1.+betm)**2.
     *      *utgam1(2.+2.*betm+2.*gamm)/utgam1(1.+betm+gamm)**2.
     *      /pi*del**3./log(sy/delx/delx))
     *      /dble(chad(icltar))
      

       
      

c 1st order, 2 proj cut legs, 1 targ cut leg, 0 loops

        if(iqq.eq.1)then
      
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,iclpro))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &           +dble(xnup(iclegy,iclpro))
            rh1=delD1(i1,iclegy,iclpro)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,iclpro))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &             +dble(xnup(iclegy,iclpro))
              rh2=delD1(i2,iclegy,iclpro)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,icltar))
                if(i3.eq.1)del3=del3+dble(gamb*b2)
                alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &               +dble(xnum(iclegy,icltar))
                rh3=delD1(i3,iclegy,icltar)
                if(i3.eq.1)then
                  rhv=del
                  rh3v=rh3*rhv/(rh3+rhv)
                else
                  rh3v=rh3
                  rhv=1.-rh3
                endif
                rh=rh3v+rh12      
                
                if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
                  r3pomp=dble(r3pom)
                endif
                
                if(dabs(del1+del2-del3).lt.1.d-5)then
                  dps=-1.d0
                else
                  dps=-(1.d0+del1+del2-del3)
                endif 

                
                omYcutJc=omYcutJc+r3pomp*xpv**dps*dsy**del3
     *  *xp1**(alp1+del1)*xp2**(alp2+del2)
     *  *xm**(alp3+del3)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
              enddo
            enddo
          enddo
          
          omYcutJc=omYcutJc*dble(pi/.0389)*cYfus

        elseif(iqq.eq.2)then
      
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,icltar))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,icltar)-alppar)
     &           +dble(xnup(iclegy,icltar))
            rh1=delD1(i1,iclegy,icltar)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,icltar))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,icltar)-alppar)
     &             +dble(xnup(iclegy,icltar))
              rh2=delD1(i2,iclegy,icltar)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,iclpro))
                if(i3.eq.1)del3=del3+dble(gamb*b2)
                alp3=dble(betDp1(i3,iclegy,iclpro)-alppar)
     &               +dble(xnum(iclegy,iclpro))
                rh3=delD1(i3,iclegy,iclpro)
                if(i3.eq.1)then
                  rhv=del
                  rh3v=rh3*rhv/(rh3+rhv)
                else
                  rh3v=rh3
                  rhv=1.-rh3
                endif
                rh=rh3v+rh12      
                
                if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
                  r3pomm=dble(r3pom)
                endif
                
                
                if(dabs(del1+del2-del3).lt.1.d-5)then
                  dps=-1.d0
                else
                  dps=-(1.d0+del1+del2-del3)
                endif 


                omYcutJc=omYcutJc+r3pomm*xpv**dps*dsy**del3
     *  *xp1**(alp1+del1)*xp2**(alp2+del2)
     *  *xm**(alp3+del3)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,icltar)*alpD1(i2,iclegy,icltar)
     *  *alpD1(i3,iclegy,iclpro)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
              enddo
            enddo
          enddo

          omYcutJc=omYcutJc*dble(pi/.0389)*cYfus

        else
          call utstop('Wrong iqq in omYcutJc !&')
        endif
          
      endif
 
      omYcutJc=omYcutJc/2.d0
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
     *  *dble(chad(iclpro)*chad(icltar))
      if(iqq.eq.1)then
        omYcutJc=omYcutJc*dble(chad(iclpro))
      else
        omYcutJc=omYcutJc*dble(chad(icltar))
      endif

      return
      end

c-----------------------------------------------------------------------
      double precision function omYcutI(xh,yp,xprem,xmrem,b,iqq)
c-----------------------------------------------------------------------
c - chi~(x,y,xpr,xmr)/2. for cut Y enhanced diagram
c xh - fraction of the energy squared s for the pomeron;
c yp - rapidity for the pomeron;
c xprem,xmrem impulsion fraction of remnant integrated
c b - impact parameter between the pomeron ends;
c iqq = 1  - 3p+(cut),
c iqq = 2  - 3p+(scr),
c iqq = 3  - 3p+(dif),
c iqq = 4  - 3p-(cut),
c iqq = 5  - 3p-(scr),
c iqq = 6  - 3p-(dif),
c-----------------------------------------------------------------------
      double precision omYcutIJ,xh,yp,xmrem,xprem
      
      omYcutI=omYcutIJ(xh,yp,xprem,xmrem,b,1,1,1,1,1,1,iqq)
       
      return
      end


c-----------------------------------------------------------------------
      double precision function omYcutIJ(xh,yp,xprem,xmrem,b,min1,max1,
     &                                    min2,max2,min3,max3,iqq)
c-----------------------------------------------------------------------
c - chi~(x,y,xpr,xmr)/2. for cut Y enhanced diagram
c xh - fraction of the energy squared s for the pomeron;
c yp - rapidity for the pomeron;
c xprem,xmrem impulsion fraction of remnant integrated
c b - impact parameter between the pomeron ends;
c iqq = 1  - 3p+(cut),
c iqq = 2  - 3p+(scr),
c iqq = 3  - 3p+(dif),
c iqq = 4  - 3p-(cut),
c iqq = 5  - 3p-(scr),
c iqq = 6  - 3p-(dif),
c mini, maxi = 1 - G1 for ideal G (all min/max set to 1)
c              2 - soft G1
c              3 - semihard G1
c              4 - valence G1
c min1/max1 and min2/max2 - parallel legs
c min3/max3               - simple leg
c-----------------------------------------------------------------------
      double precision xh,yp,xp,xm,dsy,ddelx,alp1,alp2,alp3,utgam2,
     & del1,del2,del3,xmrem,xprem,dps,r3pomp,r3pomm
      include 'nexus.inc'
      include 'nexus.incsem'
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar7/ delx,alam3p,gam3p
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)

      omYcutIJ=0.d0
      if((iqq.eq.2.or.iqq.eq.5).and.cYscr.eq.0.d0)return
      if((iqq.eq.3.or.iqq.eq.6).and.cYdif.eq.0.d0)return
      if((iqq.eq.1.or.iqq.eq.4).and.cYfus.eq.0.d0)return
      b2=b*b
      sy=engy*engy
      dsy=dble(sy)
      ddelx=dble(delx)
      xp=dsqrt(xh)*dexp(yp)
      if(xp.ne.0.d0)then
        xm=xh/xp
      else
        xm=0.d0
      endif

      if(dsy.gt.Eseuil**2..and.xprem.ge.0.d0.and.xmrem.ge.0.d0
     &                                       .and.iscreen.ne.0)then

      gamb=gamD(1,iclegy,iclpro,icltar,icdp,icdt)
      alp=xmu(3)
      betv=xnu(iclegy,iclpro)+gamb*b2/2.
      betp=betD1(1,iclegy,iclpro)+betv
      betm=betD1(1,iclegy,icltar)+betv
      gamp=betDp1(1,iclegy,iclpro)-alppar+xnup(iclegy,iclpro)
      gamm=betDp1(1,iclegy,icltar)-alppar+xnup(iclegy,icltar)
      del=delD1(1,iclegy,iclpro)
      rhv=del

      r3pomp=dble(4.*0.0389*gamhad(iclpro)**2.*gamhad(icltar)
     *      /(alp*del)**3.*xmu(1)
     *      *utgam1(2.+2.*betp)/utgam1(1.+betp)**2.
     *      *utgam1(2.+2.*betp+2.*gamp)/utgam1(1.+betp+gamp)**2.
     *      /pi*del**3./log(sy/delx/delx))
     *      /dble(chad(iclpro))

      r3pomm=dble(4.*0.0389*gamhad(icltar)**2.*gamhad(iclpro)
     *      /(alp*del)**3.*xmu(1)
     *      *utgam1(2.+2.*betm)/utgam1(1.+betm)**2.
     *      *utgam1(2.+2.*betm+2.*gamm)/utgam1(1.+betm+gamm)**2.
     *      /pi*del**3./log(sy/delx/delx))
     *      /dble(chad(icltar))
      

       
      

c 1st order, 2 proj cut legs, 1 targ cut leg, 0 loops

        if(dsy.gt.ddelx**2.and.iqq.eq.1)then
      
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,iclpro))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &           +dble(xnup(iclegy,iclpro))
            rh1=delD1(i1,iclegy,iclpro)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,iclpro))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &             +dble(xnup(iclegy,iclpro))
              rh2=delD1(i2,iclegy,iclpro)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,icltar))
                if(i3.eq.1)del3=del3+dble(gamb*b2)
                alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &               +dble(xnum(iclegy,icltar))
                rh3=delD1(i3,iclegy,icltar)
                if(i3.eq.1)then
                  rhv=del
                  rh3v=rh3*rhv/(rh3+rhv)
                else
                  rh3v=rh3
                  rhv=1.-rh3
                endif
                rh=rh3v+rh12      
                
                if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
                  r3pomp=dble(r3pom)
                endif
                
                if(dabs(del1+del2-del3).lt.1.d-5)then
                  dps=dlog(max(1.d0,dsy/ddelx**2))
                else
                  dps=((dsy/ddelx)**(del1+del2-del3)
     *                 -ddelx**(del1+del2-del3))
     *                 /(del1+del2-del3)
                endif 

                
                omYcutIJ=omYcutIJ+r3pomp*dps*dsy**del3
     *  *xp**(1.d0+alp1+alp2+del1+del2)
     *  *xm**(alp3+del3)
     *  *utgam2(1.d0+alp1+del1)*utgam2(1.d0+alp2+del2)
     *  /utgam2(2.d0+alp1+del1+alp2+del2)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
              enddo
            enddo
          enddo
          
          omYcutIJ=omYcutIJ*dble(pi/.0389)*cYfus

        elseif(dsy.gt.ddelx**2.and.iqq.eq.4)then
      
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,icltar))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,icltar)-alppar)
     &           +dble(xnup(iclegy,icltar))
            rh1=delD1(i1,iclegy,icltar)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,icltar))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,icltar)-alppar)
     &             +dble(xnup(iclegy,icltar))
              rh2=delD1(i2,iclegy,icltar)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,iclpro))
                if(i3.eq.1)del3=del3+dble(gamb*b2)
                alp3=dble(betDp1(i3,iclegy,iclpro)-alppar)
     &               +dble(xnum(iclegy,iclpro))
                rh3=delD1(i3,iclegy,iclpro)
                if(i3.eq.1)then
                  rhv=del
                  rh3v=rh3*rhv/(rh3+rhv)
                else
                  rh3v=rh3
                  rhv=1.-rh3
                endif
                rh=rh3v+rh12      
                
                if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
                  r3pomm=dble(r3pom)
                endif
                
                
                if(dabs(del1+del2-del3).lt.1.d-5)then
                  dps=dlog(max(1.d0,dsy/ddelx**2))
                else
                  dps=((dsy/ddelx)**(del1+del2-del3)
     *                 -ddelx**(del1+del2-del3))
     *                 /(del1+del2-del3)
                endif 


                omYcutIJ=omYcutIJ+r3pomm*dps*dsy**del3
     *  *xm**(1.d0+alp1+alp2+del1+del2)
     *  *xp**(alp3+del3)
     *  *utgam2(1.d0+alp1+del1)*utgam2(1.d0+alp2+del2)
     *  /utgam2(2.d0+alp1+del1+alp2+del2)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,icltar)*alpD1(i2,iclegy,icltar)
     *  *alpD1(i3,iclegy,iclpro)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
              enddo
            enddo
          enddo

          omYcutIJ=omYcutIJ*dble(pi/.0389)*cYfus

        elseif(dsy.gt.ddelx**2.and.iqq.eq.2)then
      
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,iclpro))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &           +dble(xnup(iclegy,iclpro))
            rh1=delD1(i1,iclegy,iclpro)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,iclpro))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &             +dble(xnup(iclegy,iclpro))
              rh2=delD1(i2,iclegy,iclpro)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,icltar))
                if(i3.eq.1)del3=del3+dble(gamb*b2)
                alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &               +dble(xnum(iclegy,icltar))
                rh3=delD1(i3,iclegy,icltar)
                if(i3.eq.1)then
                  rhv=del
                  rh3v=rh3*rhv/(rh3+rhv)
                else
                  rh3v=rh3
                  rhv=1.-rh3
                endif
                rh=rh3v+rh12      
                
                if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
                  r3pomp=dble(r3pom)
                endif

                if(dabs(del1+del2-del3).lt.1.d-5)then
                  dps=dlog(max(1.d0,dsy/ddelx**2))
                else
                  dps=((dsy/ddelx)**(del1+del2-del3)
     *                 -ddelx**(del1+del2-del3))
     *                 /(del1+del2-del3)
                endif 
                

                omYcutIJ=omYcutIJ+r3pomp*dps*dsy**del3
     *  *xp**(alp1+del1)*xprem**(1.d0+alp2+del2)
     *  *xm**(alp3+del3)
     *  *utgam2(1.d0+alp2+del2)*utgam2(1.d0+dble(alplea(iclpro)))
     *  /utgam2(2.d0+alp2+del2+dble(alplea(iclpro)))
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
              enddo
            enddo
          enddo
          omYcutIJ=omYcutIJ*dble(pi/.0389)*cYscr

        elseif(dsy.gt.ddelx**2.and.iqq.eq.5)then
      
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,icltar))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,icltar)-alppar)
     &           +dble(xnup(iclegy,icltar))
            rh1=delD1(i1,iclegy,icltar)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,icltar))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,icltar)-alppar)
     &             +dble(xnup(iclegy,icltar))
              rh2=delD1(i2,iclegy,icltar)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,iclpro))
                if(i3.eq.1)del3=del3+dble(gamb*b2)
                alp3=dble(betDp1(i3,iclegy,iclpro)-alppar)
     &               +dble(xnum(iclegy,iclpro))
                rh3=delD1(i3,iclegy,iclpro)
                if(i3.eq.1)then
                  rhv=del
                  rh3v=rh3*rhv/(rh3+rhv)
                else
                  rh3v=rh3
                  rhv=1.-rh3
                endif
                rh=rh3v+rh12      
                
                if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
                  r3pomm=dble(r3pom)
                endif
                
                
                if(dabs(del1+del2-del3).lt.1.d-5)then
                  dps=dlog(max(1.d0,dsy/ddelx**2))
                else
                  dps=((dsy/ddelx)**(del1+del2-del3)
     *                 -ddelx**(del1+del2-del3))
     *                 /(del1+del2-del3)
                endif 
                

                omYcutIJ=omYcutIJ+r3pomm*dps*dsy**del3
     *  *xm**(alp1+del1)*xmrem**(1.d0+alp2+del2)
     *  *xp**(alp3+del3)
     *  *utgam2(1.d0+alp2+del2)*utgam2(1.d0+dble(alplea(icltar)))
     *  /utgam2(2.d0+alp2+del2+dble(alplea(icltar)))
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,icltar)*alpD1(i2,iclegy,icltar)
     *  *alpD1(i3,iclegy,iclpro)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
              enddo
            enddo
          enddo
          omYcutIJ=omYcutIJ*dble(pi/.0389)*cYscr

        elseif(iqq.eq.3.and.xp.lt.1.d0/ddelx.and.xp.gt.ddelx/dsy)then
      
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,iclpro))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &           +dble(xnup(iclegy,iclpro))
            rh1=delD1(i1,iclegy,iclpro)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,iclpro))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &             +dble(xnup(iclegy,iclpro))
              rh2=delD1(i2,iclegy,iclpro)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,icltar))
                if(i3.eq.1)del3=del3+dble(gamb*b2)
                alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &               +dble(xnum(iclegy,icltar))
                rh3=delD1(i3,iclegy,icltar)
                if(i3.eq.1)then
                  rhv=del
                  rh3v=rh3*rhv/(rh3+rhv)
                else
                  rh3v=rh3
                  rhv=1.-rh3
                endif
                rh=rh3v+rh12      
                
                if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
                  r3pomp=dble(r3pom)
                endif
                
                if(dabs(del1+del2-del3).lt.1.d-5)then
                  dps=dlog(max(1.d0,dsy/ddelx**2))
                else
                  dps=((dsy/ddelx)**(del1+del2-del3)
     *                 -ddelx**(del1+del2-del3))
     *                 /(del1+del2-del3)
                endif 
                
                
                omYcutIJ=omYcutIJ+r3pomp*dsy**del3
     *  *xprem**(2.d0+alp1+alp2+del1+del2)
     *  *xm**(alp3+del3)*xp**(del3-del1-del2-1.d0)
     *  *utgam2(1.d0+alp1+del1)*utgam2(1.d0+alp2+del2)
     *  *utgam2(1.d0+dble(alplea(iclpro)))
     *  /utgam2(3.d0+alp1+del1+alp2+del2+dble(alplea(iclpro)))
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
              enddo
            enddo
          enddo
          omYcutIJ=omYcutIJ*dble(pi/.0389)*cYdif

        elseif(iqq.eq.6.and.xm.lt.1.d0/ddelx.and.xm.gt.ddelx/dsy)then
      
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,icltar))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,icltar)-alppar)
     &           +dble(xnup(iclegy,icltar))
            rh1=delD1(i1,iclegy,icltar)
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,icltar))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,icltar)-alppar)
     &             +dble(xnup(iclegy,icltar))
              rh2=delD1(i2,iclegy,icltar)
              rh12=rh1*rh2/(rh1+rh2)
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,iclpro))
                if(i3.eq.1)del3=del3+dble(gamb*b2)
                alp3=dble(betDp1(i3,iclegy,iclpro)-alppar)
     &               +dble(xnum(iclegy,iclpro))
                rh3=delD1(i3,iclegy,iclpro)
                if(i3.eq.1)then
                  rhv=del
                  rh3v=rh3*rhv/(rh3+rhv)
                else
                  rh3v=rh3
                  rhv=1.-rh3
                endif
                rh=rh3v+rh12      
                
                if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
                  r3pomm=dble(r3pom)
                endif
                
                omYcutIJ=omYcutIJ+r3pomm*dsy**del3
     *  *xmrem**(2.d0+alp1+alp2+del1+del2)
     *  *xp**(alp3+del3)*xm**(del3-del1-del2-1.d0)
     *  *utgam2(1.d0+alp1+del1)*utgam2(1.d0+alp2+del2)
     *  *utgam2(1.d0+dble(alplea(icltar)))
     *  /utgam2(3.d0+alp1+del1+alp2+del2+dble(alplea(icltar)))
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,icltar)*alpD1(i2,iclegy,icltar)
     *  *alpD1(i3,iclegy,iclpro)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
              enddo
            enddo
          enddo
          omYcutIJ=omYcutIJ*dble(pi/.0389)*cYdif

        elseif(iqq.gt.6.or.iqq.le.0)then
          call utstop('Wrong iqq in omYcutIJ !&')
        endif
          
      endif
      
      omYcutIJ=omYcutIJ/2.d0
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
     *  *dble(chad(iclpro)*chad(icltar))
      if(iqq.le.3)then
        omYcutIJ=omYcutIJ*dble(chad(iclpro))
      else
        omYcutIJ=omYcutIJ*dble(chad(icltar))
      endif

      return
      end

c-----------------------------------------------------------------------
      double precision function omYgam(xp,xm,b,iqq)
c-----------------------------------------------------------------------
c - cut part of chi~(x,y,xpr,xmr)/2. for cut Y enhanced diagram
c xp,xm impulsion fraction of cut part
c b - impact parameter between the pomeron ends;
c iqq = 1  - 3p+(cut),
c iqq = 2  - 3p+(scr),
c iqq = 3  - 3p+(dif),
c iqq = 4  - 3p-(cut),
c iqq = 5  - 3p-(scr),
c iqq = 6  - 3p-(dif),
c-----------------------------------------------------------------------
      double precision xp,xm,dsy,ddelx,alp1,alp2,alp3,utgam2,
     & del1,del2,del3,dps,r3pomp,r3pomm
      include 'nexus.inc'
      include 'nexus.incsem'
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar7/ delx,alam3p,gam3p
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)

      omYgam=0.d0
      if((iqq.eq.2.or.iqq.eq.5).and.cYscr.eq.0.d0)return
      if((iqq.eq.3.or.iqq.eq.6).and.cYdif.eq.0.d0)return
      if((iqq.eq.1.or.iqq.eq.4).and.cYfus.eq.0.d0)return
      b2=b*b
      sy=engy*engy
      dsy=dble(sy)
      ddelx=dble(delx)

      if(dsy.gt.ddelx**2.and.dsy.gt.Eseuil**2..and.iscreen.ne.0)then

      gamb=gamD(1,iclegy,iclpro,icltar,icdp,icdt)
      alp=xmu(3)
      betv=xnu(iclegy,iclpro)+gamb*b2/2.
      betp=betD1(1,iclegy,iclpro)+betv
      betm=betD1(1,iclegy,icltar)+betv
      gamp=betDp1(1,iclegy,iclpro)-alppar+xnup(iclegy,iclpro)
      gamm=betDp1(1,iclegy,icltar)-alppar+xnup(iclegy,icltar)
      del=delD1(1,iclegy,iclpro)
      rhv=del
      dps=dlog(max(1.d0,dsy/ddelx**2))
      r3pomp=0.d0
      r3pomm=0.d0
       
      

      if(iqq.le.3)then
        r3pomp=dble(4.*0.0389*gamhad(iclpro)**2.*gamhad(icltar)
     *      /(alp*del)**3.*xmu(1)
     *      *utgam1(2.+2.*betp)/utgam1(1.+betp)**2.
     *      *utgam1(2.+2.*betp+2.*gamp)/utgam1(1.+betp+gamp)**2.
     *      /pi*del**3./log(sy/delx/delx))
     *      /dble(chad(iclpro))
        del1=dble(betD1(1,iclegy,iclpro)+betv)
        alp1=dble(betDp1(1,iclegy,iclpro)-alppar)
     &       +dble(xnup(iclegy,iclpro))
        rh1=delD1(1,iclegy,iclpro)
        del2=dble(betD1(1,iclegy,iclpro)+betv)
        alp2=dble(betDp1(1,iclegy,iclpro)-alppar)
     &       +dble(xnup(iclegy,iclpro))
        rh2=delD1(1,iclegy,iclpro)
        rh12=rh1*rh2/(rh1+rh2)
        del3=dble(betD1(1,iclegy,icltar)+gamb*b2)
        alp3=dble(betDp1(1,iclegy,icltar)-alppar)
     &       +dble(xnum(iclegy,icltar))
        rh3=delD1(1,iclegy,icltar)
        rh3v=rh3*rhv/(rh3+rhv)
        rh=rh3v+rh12      
      else
        r3pomm=dble(4.*0.0389*gamhad(icltar)**2.*gamhad(iclpro)
     *      /(alp*del)**3.*xmu(1)
     *      *utgam1(2.+2.*betm)/utgam1(1.+betm)**2.
     *      *utgam1(2.+2.*betm+2.*gamm)/utgam1(1.+betm+gamm)**2.
     *      /pi*del**3./log(sy/delx/delx))
     *      /dble(chad(icltar))
        del1=dble(betD1(1,iclegy,icltar)+betv)
        alp1=dble(betDp1(1,iclegy,icltar)-alppar)
     &       +dble(xnup(iclegy,icltar))
        rh1=delD1(1,iclegy,icltar)
        del2=dble(betD1(1,iclegy,icltar)+betv)
        alp2=dble(betDp1(1,iclegy,icltar)-alppar)
     &       +dble(xnup(iclegy,icltar))
        rh2=delD1(1,iclegy,icltar)
        rh12=rh1*rh2/(rh1+rh2)
        del3=dble(betD1(1,iclegy,iclpro)+gamb*b2)
        alp3=dble(betDp1(1,iclegy,iclpro)-alppar)
     &       +dble(xnum(iclegy,iclpro))
        rh3=delD1(1,iclegy,iclpro)
        rh3v=rh3*rhv/(rh3+rhv)
        rh=rh3v+rh12      
      endif



c 1st order, 2 proj cut legs, 1 targ cut leg, 0 loops

        if(iqq.eq.1)then
      
          omYgam=r3pomp*dps*dsy**del3
     *  *xp**(1.d0+alp1+alp2+del1+del2)
     *  *xm**(alp3+del3)
     *  *utgam2(1.d0+alp1+del1)*utgam2(1.d0+alp2+del2)
     *  /utgam2(2.d0+alp1+del1+alp2+del2)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(1,iclegy,iclpro)*alpD1(1,iclegy,iclpro)
     *  *alpD1(1,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
          omYgam=omYgam*dble(pi/.0389)*cYfus

c$$$       write(*,*)xp,xm,xp**(1.d0+alp1+alp2+del1+del2),xm**(alp3+del3)
c$$$     *,r3pomp*dps*dsy**del3,utgam2(1.d0+alp1+del1)
c$$$     *  *utgam2(1.d0+alp2+del2)
c$$$     *  /utgam2(2.d0+alp1+del1+alp2+del2)
c$$$     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
c$$$     *  /utgam2(2.d0+del1+del2)
c$$$     *  *dble(alpD1(1,iclegy,iclpro)*alpD1(1,iclegy,iclpro)
c$$$     *  *alpD1(1,iclegy,icltar)
c$$$     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh)),omYgam
c$$$
c$$$       write(*,*)"???",r3pom,dps,del3,alpD1(1,iclegy,iclpro),rh
c$$$     *,iclegy,iclpro,icltar,icdp,icdt,engy,b

        elseif(iqq.eq.4)then
          omYgam=r3pomm*dps*dsy**del3
     *  *xm**(1.d0+alp1+alp2+del1+del2)
     *  *xp**(alp3+del3)
     *  *utgam2(1.d0+alp1+del1)*utgam2(1.d0+alp2+del2)
     *  /utgam2(2.d0+alp1+del1+alp2+del2)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(1,iclegy,icltar)*alpD1(1,iclegy,icltar)
     *  *alpD1(1,iclegy,iclpro)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
          omYgam=omYgam*dble(pi/.0389)*cYfus   

        elseif(iqq.eq.2)then
      
          omYgam=r3pomp*dps*dsy**del3
     *  *xp**(alp1+del1)
     *  *xm**(alp3+del3)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(1,iclegy,iclpro)*alpD1(1,iclegy,iclpro)
     *  *alpD1(1,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
          omYgam=omYgam*dble(pi/.0389)*cYscr

        elseif(iqq.eq.5)then
      
          omYgam=r3pomm*dps*dsy**del3
     *  *xm**(alp1+del1)
     *  *xp**(alp3+del3)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(1,iclegy,icltar)*alpD1(1,iclegy,icltar)
     *  *alpD1(1,iclegy,iclpro)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
          omYgam=omYgam*dble(pi/.0389)*cYscr

        elseif(iqq.eq.3.and.xp.lt.1.d0/ddelx.and.xp.gt.ddelx/dsy)then
      
          omYgam=r3pomp*dsy**del3
     *  *xm**(alp3+del3)*xp**(del3-del1-del2-1.d0)
     *  *utgam2(1.d0+alp1+del1)*utgam2(1.d0+alp2+del2)
     *  /utgam2(2.d0+alp1+del1+alp2+del2)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(1,iclegy,iclpro)*alpD1(1,iclegy,iclpro)
     *  *alpD1(1,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
          omYgam=omYgam*dble(pi/.0389)*cYdif

        elseif(iqq.eq.6.and.xm.lt.1.d0/ddelx.and.xm.gt.ddelx/dsy)then
      
          omYgam=r3pomm*dsy**del3
     *  *xp**(alp3+del3)*xm**(del3-del1-del2-1.d0)
     *  *utgam2(1.d0+alp1+del1)*utgam2(1.d0+alp2+del2)
     *  /utgam2(2.d0+alp1+del1+alp2+del2)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(1,iclegy,icltar)*alpD1(1,iclegy,icltar)
     *  *alpD1(1,iclegy,iclpro)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
          omYgam=omYgam*dble(pi/.0389)*cYdif

        elseif(iqq.gt.6.or.iqq.le.0)then
          call utstop('Wrong iqq in omYgam !&')
        endif
          
      endif
      
c      write(*,*)'omygam',iqq,xp,xm,dsy,b,omYgam,r3pomp,r3pomm,
c     *del3-del1-del2-1.d0,del1,del2,del3,alp3,rh1,rh2,rh3,rhv,rh

      omYgam=omYgam/2.d0
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
     *  *dble(chad(iclpro)*chad(icltar))
      if(iqq.le.3)then
        omYgam=omYgam*dble(chad(iclpro))
      else
        omYgam=omYgam*dble(chad(icltar))
      endif

c      write(*,*)"gam",omYgam

      return
      end

c-----------------------------------------------------------------------
      double precision function omYgamint(b,iqq)
c-----------------------------------------------------------------------
c - integrated cut part of chi/2. for cut Y enhanced diagram
c b - impact parameter between the pomeron ends;
c iqq = 1  - 3p+(cut),
c iqq = 2  - 3p+(scr),
c iqq = 3  - 3p+(dif),
c iqq = 4  - 3p-(cut),
c iqq = 5  - 3p-(scr),
c iqq = 6  - 3p-(dif),
c-----------------------------------------------------------------------
      double precision dsy,ddelx,alp1,alp2,alp3,utgam2,alppro,alptar
     & ,del1,del2,del3,dps,r3pomp,r3pomm
      include 'nexus.inc'
      include 'nexus.incsem'
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar7/ delx,alam3p,gam3p
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)

      omYgamint=0.d0
      if((iqq.eq.2.or.iqq.eq.5).and.cYscr.eq.0.d0)return
      if((iqq.eq.3.or.iqq.eq.6).and.cYdif.eq.0.d0)return
      if((iqq.eq.1.or.iqq.eq.4).and.cYfus.eq.0.d0)return
      b2=b*b
      sy=engy*engy
      dsy=dble(sy)
      ddelx=dble(delx)

      if(dsy.gt.ddelx**2.and.dsy.gt.Eseuil**2..and.iscreen.ne.0)then

      gamb=gamD(1,iclegy,iclpro,icltar,icdp,icdt)
      alp=xmu(3)
      betv=xnu(iclegy,iclpro)+gamb*b2/2.
      betp=betD1(1,iclegy,iclpro)+betv
      betm=betD1(1,iclegy,icltar)+betv
      gamp=betDp1(1,iclegy,iclpro)-alppar+xnup(iclegy,iclpro)
      gamm=betDp1(1,iclegy,icltar)-alppar+xnup(iclegy,icltar)
      del=delD1(1,iclegy,iclpro)
      rhv=del
      dps=dlog(max(1.d0,dsy/ddelx**2))
      r3pomp=0.d0
      r3pomm=0.d0
       
      
      alppro=1.d0+dble(alplea(iclpro))
      alptar=1.d0+dble(alplea(icltar))

      if(iqq.le.3)then
        r3pomp=dble(4.*0.0389*gamhad(iclpro)**2.*gamhad(icltar)
     *      /(alp*del)**3.*xmu(1)
     *      *utgam1(2.+2.*betp)/utgam1(1.+betp)**2.
     *      *utgam1(2.+2.*betp+2.*gamp)/utgam1(1.+betp+gamp)**2.
     *      /pi*del**3./log(sy/delx/delx))
     *      /dble(chad(iclpro))
        del1=dble(betD1(1,iclegy,iclpro)+betv)
        alp1=dble(betDp1(1,iclegy,iclpro)-alppar)
     &       +dble(xnup(iclegy,iclpro))
        rh1=delD1(1,iclegy,iclpro)
        del2=dble(betD1(1,iclegy,iclpro)+betv)
        alp2=dble(betDp1(1,iclegy,iclpro)-alppar)
     &       +dble(xnup(iclegy,iclpro))
        rh2=delD1(1,iclegy,iclpro)
        rh12=rh1*rh2/(rh1+rh2)
        del3=dble(betD1(1,iclegy,icltar)+gamb*b2)
        alp3=dble(betDp1(1,iclegy,icltar)-alppar)
     &       +dble(xnum(iclegy,icltar))
        rh3=delD1(1,iclegy,icltar)
        rh3v=rh3*rhv/(rh3+rhv)
        rh=rh3v+rh12      
        omYgamint=r3pomp*dps*dsy**del3
     *  *utgam2(1.d0+alp1+del1)*utgam2(1.d0+alp2+del2)*utgam2(alppro)
     *  /utgam2(2.d0+alppro+alp1+alp2+del1+del2)
     *  *utgam2(1.d0+alp3+del3)*utgam2(alptar)
     *  /utgam2(1.d0+alptar+alp3+del3)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(1,iclegy,iclpro)*alpD1(1,iclegy,iclpro)
     *  *alpD1(1,iclegy,icltar)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
      else
        r3pomm=dble(4.*0.0389*gamhad(icltar)**2.*gamhad(iclpro)
     *      /(alp*del)**3.*xmu(1)
     *      *utgam1(2.+2.*betm)/utgam1(1.+betm)**2.
     *      *utgam1(2.+2.*betm+2.*gamm)/utgam1(1.+betm+gamm)**2.
     *      /pi*del**3./log(sy/delx/delx))
     *      /dble(chad(icltar))
        del1=dble(betD1(1,iclegy,icltar)+betv)
        alp1=dble(betDp1(1,iclegy,icltar)-alppar)
     &       +dble(xnup(iclegy,icltar))
        rh1=delD1(1,iclegy,icltar)
        del2=dble(betD1(1,iclegy,icltar)+betv)
        alp2=dble(betDp1(1,iclegy,icltar)-alppar)
     &       +dble(xnup(iclegy,icltar))
        rh2=delD1(1,iclegy,icltar)
        rh12=rh1*rh2/(rh1+rh2)
        del3=dble(betD1(1,iclegy,iclpro)+gamb*b2)
        alp3=dble(betDp1(1,iclegy,iclpro)-alppar)
     &       +dble(xnum(iclegy,iclpro))
        rh3=delD1(1,iclegy,iclpro)
        rh3v=rh3*rhv/(rh3+rhv)
        rh=rh3v+rh12      
        omYgamint=r3pomm*dps*dsy**del3
     *  *utgam2(1.d0+alp1+del1)*utgam2(1.d0+alp2+del2)*utgam2(alptar)
     *  /utgam2(2.d0+alptar+alp1+alp2+del1+del2)
     *  *utgam2(1.d0+alp3+del3)*utgam2(alppro)
     *  /utgam2(1.d0+alppro+alp3+del3)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(1,iclegy,icltar)*alpD1(1,iclegy,icltar)
     *  *alpD1(1,iclegy,iclpro)
     *  /(rh1+rh2)/(rh3+rhv)/rh*exp(-b2/rh))
      endif


c 1st order, 2 proj cut legs, 1 targ cut leg, 0 loops

          omYgamint=omYgamint*dble(pi/.0389)
      
        if(iqq.eq.1.or.iqq.eq.4)then

          omYgamint=omYgamint*cYfus

        elseif(iqq.eq.2.or.iqq.eq.5)then
      
          omYgamint=omYgamint*cYscr

        elseif(iqq.eq.3.or.iqq.eq.6)then
      
          omYgamint=omYgamint*cYdif

        elseif(iqq.gt.6.or.iqq.le.0)then
          call utstop('Wrong iqq in omYgamint !&')
        endif
          
      endif
      
c      write(*,*)'omygam',iqq,xp,xm,dsy,b,omYgamint,r3pomp,r3pomm,
c     *del3-del1-del2-1.d0,del1,del2,del3,alp3,rh1,rh2,rh3,rhv,rh

      omYgamint=omYgamint/2.d0
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
     *  *dble(chad(iclpro)*chad(icltar))
      if(iqq.le.3)then
        omYgamint=omYgamint*dble(chad(iclpro))
      else
        omYgamint=omYgamint*dble(chad(icltar))
      endif

      return
      end


c----------------------------------------------------------------------

      double precision function omYint(xprem,xmrem,bh,iqq,iqqq)

c----------------------------------------------------------------------
c Log+Lin Integration over xp and xm of omYcut(iqq)
c iqqq=0 ideal G
c iqqq=1 exact G
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      double precision xh,omYcut,omint,xmrem,xprem,ds,Gst 
      double precision xi,zp,zpmax,zpmin,zmin,xrem,xp,xm
      double precision dzp,yp,alpp,alpm,zalpp,gamp,gamm
      common /psar7/ delx,alam3p,gam3p
      common /ar3/  x1(7),a1(7)
      double precision dgx1,dga1
      common /dga20/ dgx1(10),dga1(10)
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)

      ds=dble(engy*engy)
      xi=dble(delx)
      zmin=1.d-15
      omYint=0.d0
        b2=bh*bh
        gamb=gamD(1,iclegy,iclpro,icltar,icdp,icdt)
        gamp=dble(xnup(iclegy,iclpro)-xnu(iclegy,iclpro)+gamb*b2/2.
     &       -alppar)
        gamm=dble(xnup(iclegy,icltar)-xnu(iclegy,icltar)+gamb*b2/2.
     &       -alppar)

      if(iqq.eq.2)then
        alpp=(1.d0+gamp)/1.d0
      endif
      if(iqq.eq.5)then
        alpm=(1.d0+gamm)/1.d0
      endif

      if(iqq.eq.1.or.iqq.eq.4)then
        xh=xprem*xmrem
        yp=0.5d0*dlog(xprem/xmrem)
        omYint=omYcut(xh,yp,0.d0,0.d0,bh,iqq,iqqq)

      elseif(iqq.eq.3.or.iqq.eq.6)then

        if(iqq.eq.3)then
          xrem=xmrem
        else
          xrem=xprem
        endif
        
        zpmax=dlog(ds/xi)
        zpmin=dlog(xi)

        omint=0.d0
        dzp=(zpmax-zpmin)/2.d0

        do n=1,2
          do j=1,7
            zp=zpmin+dzp*(1.d0+dble(2.*n-3.)*dble(x1(j)))
            xm=xrem
            xp=dexp(-zp)
            xh=xp*xm
            if(iqq.eq.3)then
              yp=.5d0*dlog(xp/xm)
c            Gst=omYcut(xh,yp,xprem-xp,0.d0,bh,iqq,iqqq)
            Gst=omYcut(xh,yp,xprem,0.d0,bh,iqq,iqqq)
          else
            yp=-.5d0*dlog(xp/xm)
c            Gst=omYcut(xh,yp,0.d0,xmrem-xp,bh,iqq,iqqq)
            Gst=omYcut(xh,yp,0.d0,xmrem,bh,iqq,iqqq)
           endif
           omint=omint+Gst*dble(a1(j))*xp
        enddo
      enddo
      omYint=dzp*omint
      
      elseif(iqq.eq.2.or.iqq.eq.5)then
        if(iqq.eq.2)then
           xrem=xprem
           zalpp=alpp
         else
           xrem=xmrem
           zalpp=alpm
         endif

         zpmin=zmin**zalpp
         zpmax=xrem**zalpp
         
         omint=0.d0
         dzp=(zpmax-zpmin)/2.d0

         do n=1,2
           do j=1,7
             zp=zpmin+dzp*(1.d0+dble(2.*n-3.)*dble(x1(j)))
             xp=zp**(1.d0/zalpp)
             if(iqq.eq.2)then
               xm=xmrem
               xh=xp*xm
               yp=.5d0*dlog(xp/xm)
               Gst=omYcut(xh,yp,xprem-xp,0.d0,bh,iqq,iqqq)
             else
               xm=xprem
               xh=xp*xm
               yp=-.5d0*dlog(xp/xm)
               Gst=omYcut(xh,yp,0.d0,xmrem-xp,bh,iqq,iqqq)
             endif
             omint=omint+Gst*dble(a1(j))*zp**(1.d0/zalpp-1.d0)/zalpp
           enddo
         enddo
         omYint=dzp*omint
           
       else
         call utstop('Wrong iqq in omYint&')
       endif
      

       return
       end


c----------------------------------------------------------------------

      double precision function SomY(xprem,xmrem,bh,iqq)

c----------------------------------------------------------------------
c Sum of all omYint(iqq)
c iqq=0 ideal G
c iqq=1 exact G
c iqq=2 ideal G for distribution probability (= ideal G)
c----------------------------------------------------------------------
      double precision omYint,xmrem,xprem,ds,xi
      include 'nexus.inc'
      common /psar7/ delx,alam3p,gam3p


      ds=dble(engy*engy)
      xi=dble(delx)
      SomY=0.d0
      if(ds.gt.xi*xi)then

      do i=1,6
        SomY=SomY+omYint(xprem,xmrem,bh,i,iqq)
      enddo

      endif

      
      return
      end


c-----------------------------------------------------------------------
      double precision function omNcutJ(xh,yp,zl,xprem,xmrem,zlrem,bh,bl
     &                           ,bhl,min1,max1,min2,max2,min3,max3,iqq)
c-----------------------------------------------------------------------
c - chi~(x,y,z,xpr,xmr,zlr) for nuclear Y enhanced diagram
c xh - fraction of the energy squared s for the pomeron;
c yp - rapidity for the pomeron;
c zl - fraction of the momentum for the leg;
c xprem,xmrem,zmrem impulsion fraction of remnant
c bh - impact parameter between the pomeron ends;
c bl - impact parameter between the pomeron end and the leg end;
c bhl - difference (vector) of impact parameter between the pomeron end 
c iqq = 1  - 3p+(dif nucl),
c iqq = 2  - 3p+(scr nucl),
c iqq = 3  - 3p+(cut nucl)
c iqq = 5  - 3p-(dif nucl)
c iqq = 6  - 3p-(scr nucl),
c iqq = 7  - 3p-(cut nucl)
c mini, maxi = 1 - G1 for ideal G (all min/max set to 1)
c              2 - soft G1
c              3 - semihard G1
c              4 - valence G1
c min1/max1 and min2/max2 - parallel legs
c min3/max3               - simple leg
c-----------------------------------------------------------------------
      double precision xh,yp,xp,xm,dsy,ddelx,alp1,alp2,alp3,utgam2,
     & del1,del2,del3,xmrem,xprem,dps,r3pomp,r3pomm,zl,zlrem,eps
      include 'nexus.inc'
      include 'nexus.incsem'
      parameter(eps=1.d-20)
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar7/ delx,alam3p,gam3p
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)

      omNcutJ=0.d0
      if((iqq.eq.2.or.iqq.eq.6).and.cYscr.eq.0.d0)return
      if((iqq.eq.1.or.iqq.eq.5).and.cYdif.eq.0.d0)return
      if((iqq.eq.3.or.iqq.eq.7).and.cYfus.eq.0.d0)return
      b1=bh*bh
      b2=bl*bl
      b12=bhl*bhl
      sy=engy*engy
      dsy=dble(sy)
      ddelx=dble(delx)
      xp=dsqrt(xh)*dexp(yp)
      if(xp.ne.0.d0)then
        xm=xh/xp
      else
        xm=0.d0
      endif

      if(dsy.gt.Eseuil**2..and.xprem.gt.-eps.and.xmrem.gt.-eps
     &                     .and.zlrem.gt.-eps.and.iscreen.ne.0)then

      alp=xmu(3)
      betv=xnu(iclegy,iclpro)
      betp=betD1(1,iclegy,iclpro)+betv
      betm=betD1(1,iclegy,icltar)+betv
      del=delD1(1,iclegy,iclpro)

      r3pomp=dble(gamhad(iclpro)**2.*gamhad(icltar)
     *      /(alp*del)**3.*xmu(1)
     *      *utgam1(2.+2.*betp)/utgam1(1.+betp)**2.
     *      *del**2./3./log(sy/delx/delx))
     *      /dble(chad(iclpro))

      del=delD1(1,iclegy,icltar)
      r3pomm=dble(gamhad(icltar)**2.*gamhad(iclpro)
     *      /(alp*del)**3.*xmu(1)
     *      *utgam1(2.+2.*betm)/utgam1(1.+betm)**2.
     *      *del**2./3./log(sy/delx/delx))
     *      /dble(chad(icltar))
      

c 1st order, 2 proj cut legs, 1 targ cut leg, 0 loops

        if(iqq.eq.3)then
      
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,iclpro))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &           +dble(xnup(iclegy,iclpro))
            rh1=delD1(i1,iclegy,iclpro)
            if(i1.eq.1)rh1=rh1/3.
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,iclpro))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &             +dble(xnup(iclegy,iclpro))
              rh2=delD1(i2,iclegy,iclpro)
              if(i2.eq.1)rh2=rh2/3.
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,icltar))
                alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &               +dble(xnum(iclegy,icltar))
                rh3=delD1(i3,iclegy,icltar)
                if(i3.eq.1)rh3=rh3/3.

                rh=rh1*rh2+rh1*rh3+rh2*rh3      
                
                if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
                  r3pomp=dble(r3pom)
                endif
                
                if(dabs(del1+del2-del3).lt.1.d-5)then
                  dps=dlog(dsy/ddelx**2)
                else
                  dps=((dsy/ddelx)**(del1+del2-del3)
     *                 -ddelx**(del1+del2-del3))
     *                 /(del1+del2-del3)
                endif 

                
                omNcutJ=omNcutJ+r3pomp*dps*dsy**del3
     *  *xp**(del1+alp1)*zl**(del2+alp2)
     *  *xm**(alp3+del3)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)/rh
     *  *exp(-rh2*b1/rh-rh1*b2/rh-rh3*b12/rh))
              enddo
            enddo
          enddo
          
          omNcutJ=2.d0*omNcutJ*cYfus

        elseif(iqq.eq.7)then
      
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,icltar))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,icltar)-alppar)
     &           +dble(xnup(iclegy,icltar))
            rh1=delD1(i1,iclegy,icltar)
            if(i1.eq.1)rh1=rh1/3.
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,icltar))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,icltar)-alppar)
     &             +dble(xnup(iclegy,icltar))
              rh2=delD1(i2,iclegy,icltar)
              if(i2.eq.1)rh2=rh2/3.
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,iclpro))
                alp3=dble(betDp1(i3,iclegy,iclpro)-alppar)
     &               +dble(xnum(iclegy,iclpro))
                rh3=delD1(i3,iclegy,iclpro)
                if(i3.eq.1)rh3=rh3/3.
                
                rh=rh1*rh2+rh1*rh3+rh2*rh3      
                
                if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
                  r3pomm=dble(r3pom)
                endif
                
                
                if(dabs(del1+del2-del3).lt.1.d-5)then
                  dps=dlog(dsy/ddelx**2)
                else
                  dps=((dsy/ddelx)**(del1+del2-del3)
     *                 -ddelx**(del1+del2-del3))
     *                 /(del1+del2-del3)
                endif 


                omNcutJ=omNcutJ+r3pomm*dps*dsy**del3
     *  *xm**(alp1+del1)*zl**(alp2+del2)
     *  *xp**(alp3+del3)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,icltar)*alpD1(i2,iclegy,icltar)
     *  *alpD1(i3,iclegy,iclpro)/rh
     *  *exp(-rh2*b1/rh-rh1*b2/rh-rh3*b12/rh))
              enddo
            enddo
          enddo

          omNcutJ=2.d0*omNcutJ*cYfus

        elseif(iqq.eq.2)then
      
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,iclpro))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &           +dble(xnup(iclegy,iclpro))
            rh1=delD1(i1,iclegy,iclpro)
            if(i1.eq.1)rh1=rh1/3.
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,iclpro))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &             +dble(xnup(iclegy,iclpro))
              rh2=delD1(i2,iclegy,iclpro)
              if(i2.eq.1)rh2=rh2/3.
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,icltar))
                alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &               +dble(xnum(iclegy,icltar))
                rh3=delD1(i3,iclegy,icltar)
                if(i3.eq.1)rh3=rh3/3.
                
                rh=rh1*rh2+rh1*rh3+rh2*rh3      

                if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
                  r3pomp=dble(r3pom)
                endif

                if(dabs(del1+del2-del3).lt.1.d-5)then
                  dps=dlog(dsy/ddelx**2)
                else
                  dps=((dsy/ddelx)**(del1+del2-del3)
     *                 -ddelx**(del1+del2-del3))
     *                 /(del1+del2-del3)
                endif 
                

                omNcutJ=omNcutJ+r3pomp*dps*dsy**del3
     *  *xp**(alp1+del1)*zlrem**(alp2+del2)
     *  *xm**(alp3+del3)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)/rh
     *  *exp(-rh2*b1/rh-rh1*b2/rh-rh3*b12/rh))
              enddo
            enddo
          enddo
          omNcutJ=2.d0*omNcutJ*cYscr

        elseif(iqq.eq.6)then
      
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,icltar))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,icltar)-alppar)
     &           +dble(xnup(iclegy,icltar))
            rh1=delD1(i1,iclegy,icltar)
            if(i1.eq.1)rh1=rh1/3.
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,icltar))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,icltar)-alppar)
     &             +dble(xnup(iclegy,icltar))
              rh2=delD1(i2,iclegy,icltar)
              if(i2.eq.1)rh2=rh2/3.
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,iclpro))
                alp3=dble(betDp1(i3,iclegy,iclpro)-alppar)
     &               +dble(xnum(iclegy,iclpro))
                rh3=delD1(i3,iclegy,iclpro)
                if(i3.eq.1)rh3=rh3/3.
                
                rh=rh1*rh2+rh1*rh3+rh2*rh3      
                
                if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
                  r3pomm=dble(r3pom)
                endif
                
                
                if(dabs(del1+del2-del3).lt.1.d-5)then
                  dps=dlog(dsy/ddelx**2)
                else
                  dps=((dsy/ddelx)**(del1+del2-del3)
     *                 -ddelx**(del1+del2-del3))
     *                 /(del1+del2-del3)
                endif 
                

                omNcutJ=omNcutJ+r3pomm*dps*dsy**del3
     *  *xm**(alp1+del1)*zlrem**(alp2+del2)
     *  *xp**(alp3+del3)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,icltar)*alpD1(i2,iclegy,icltar)
     *  *alpD1(i3,iclegy,iclpro)/rh
     *  *exp(-rh2*b1/rh-rh1*b2/rh-rh3*b12/rh))
              enddo
            enddo
          enddo
          omNcutJ=2.d0*omNcutJ*cYscr

        elseif(iqq.eq.1.and.xp.lt.1.d0/ddelx.and.xp.gt.ddelx/dsy)then
      
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,iclpro))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &           +dble(xnup(iclegy,iclpro))
            rh1=delD1(i1,iclegy,iclpro)
            if(i1.eq.1)rh1=rh1/3.
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,iclpro))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &             +dble(xnup(iclegy,iclpro))
              rh2=delD1(i2,iclegy,iclpro)
              if(i2.eq.1)rh2=rh2/3.
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,icltar))
                alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &               +dble(xnum(iclegy,icltar))
                rh3=delD1(i3,iclegy,icltar)
                if(i3.eq.1)rh3=rh3/3.
                
                rh=rh1*rh2+rh1*rh3+rh2*rh3      
                
                if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
                  r3pomp=dble(r3pom)
                endif
                                
                omNcutJ=omNcutJ+r3pomp*dsy**del3
     *  *xprem**(alp1+del1)*zlrem**(alp2+del2)
     *  *xm**(alp3+del3)*xp**(del3-del1-del2-1.d0)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar)/rh
     *  *exp(-rh2*b1/rh-rh1*b2/rh-rh3*b12/rh))
              enddo
            enddo
          enddo
          omNcutJ=2.d0*omNcutJ*cYdif

        elseif(iqq.eq.5.and.xm.lt.1.d0/ddelx.and.xm.gt.ddelx/dsy)then
      
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,icltar))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,icltar)-alppar)
     &           +dble(xnup(iclegy,icltar))
            rh1=delD1(i1,iclegy,icltar)
            if(i1.eq.1)rh1=rh1/3.
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,icltar))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,icltar)-alppar)
     &             +dble(xnup(iclegy,icltar))
              rh2=delD1(i2,iclegy,icltar)
              if(i2.eq.1)rh2=rh2/3.
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,iclpro))
                alp3=dble(betDp1(i3,iclegy,iclpro)-alppar)
     &               +dble(xnum(iclegy,iclpro))
                rh3=delD1(i3,iclegy,iclpro)
                if(i3.eq.1)rh3=rh3/3.
                
                rh=rh1*rh2+rh1*rh3+rh2*rh3      
                
                if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
                  r3pomm=dble(r3pom)
                endif
                
                omNcutJ=omNcutJ+r3pomm*dsy**del3
     *  *xmrem**(alp1+del1)*zlrem**(alp2+del2)
     *  *xp**(alp3+del3)*xm**(del3-del1-del2-1.d0)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,icltar)*alpD1(i2,iclegy,icltar)
     *  *alpD1(i3,iclegy,iclpro)/rh
     *  *exp(-rh2*b1/rh-rh1*b2/rh-rh3*b12/rh))
              enddo
            enddo
          enddo
          omNcutJ=2.d0*omNcutJ*cYdif

        else
          call utstop('Wrong iqq in omNcutJ !&')
        endif
          
      endif
 
      omNcutJ=omNcutJ/2.d0         !not to double counting
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
     *  *dble(chad(iclpro)*chad(icltar))
      if(iqq.le.3)then
        omNcutJ=omNcutJ*dble(gamdp(icdpl1,iclpro)*chad(iclpro))
      else
        omNcutJ=omNcutJ*dble(gamdt(icdtl1,icltar)*chad(icltar))
      endif  


      return
      end

c-----------------------------------------------------------------------
      double precision function omNcutIJ(min1,max1,min2,max2
     &                                            ,min3,max3,iqq)
c-----------------------------------------------------------------------
c - chi integrated over x without b dependance for cut Nuclear diagram
c iqq = 0  - 3p+(unc nucl),
c iqq = 1  - 3p+(dif nucl),
c iqq = 2  - 3p+(scr nucl),
c iqq = 3  - 3p+(cut nucl)
c iqq = 4  - 3p-(unc nucl),
c iqq = 5  - 3p-(dif nucl)
c iqq = 6  - 3p-(scr nucl),
c iqq = 7  - 3p-(cut nucl)
c mini, maxi = 1 - G1 for ideal G (all min/max set to 1) -> not used
c              2 - soft G1
c              3 - semihard G1
c              4 - valence G1
c min1/max1 and min2/max2 - parallel legs
c min3/max3               - simple leg
c-----------------------------------------------------------------------
      double precision dsy,ddelx,alp1,alp2,alp3,utgam2,alppro,alptar
     & ,del1,del2,del3,dps,r3pomp,r3pomm,coefp,coeft,eps
      parameter(eps=1.d-10)
      include 'nexus.inc'
      include 'nexus.incsem'
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar7/ delx,alam3p,gam3p
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)
      common /omNfac/ facOmNp(4,4,4),facOmNm(4,4,4)
      double precision facOmNp,facOmNm,fact

      omNcutIJ=0.d0
      if((iqq.eq.2.or.iqq.eq.6).and.cYscr.eq.0.d0)return
      if((iqq.eq.1.or.iqq.eq.5).and.cYdif.eq.0.d0)return
      if((iqq.eq.3.or.iqq.eq.7).and.cYfus.eq.0.d0)return
      sy=engy*engy
      dsy=dble(sy)
      ddelx=dble(delx)

      if(dsy.gt.Eseuil**2..and.inueff.ne.0)then

        alppro=dble(alplea(iclpro))
        alptar=dble(alplea(icltar))
        coefp=utgam2(1.d0+alppro)
        coeft=utgam2(1.d0+alptar)

        alp=xmu(3)
        betv=xnu(iclegy,iclpro)
        betp=betD1(1,iclegy,iclpro)+betv
        betm=betD1(1,iclegy,icltar)+betv

        if(iqq.le.3)then
      
          del=delD1(1,iclegy,iclpro)
          r3pomp=dble(gamhad(iclpro)**2.*gamhad(icltar)
     *         /(alp*del)**3.*xmu(1)
     *         *utgam1(2.+2.*betp)/utgam1(1.+betp)**2.
     *         *del**2./3./log(sy/delx/delx))
     *      /dble(chad(iclpro))
          

          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,iclpro))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,iclpro)-alppar)
     &           +dble(xnup(iclegy,iclpro))
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,iclpro))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,iclpro)-alppar)
     &             +dble(xnup(iclegy,iclpro))
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,icltar))
                alp3=dble(betDp1(i3,iclegy,icltar)-alppar)
     &               +dble(xnum(iclegy,icltar))
                
                if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
                  r3pomp=dble(r3pom)
                endif

               if(dabs(del1+del2-del3).lt.eps)then
                  dps=dlog(dsy/ddelx**2)
                else
                  dps=((dsy/ddelx)**(del1+del2-del3)
     *                 -ddelx**(del1+del2-del3))
     *                 /(del1+del2-del3)
                endif 
                
                fact=r3pomp*dps*dsy**del3
     *  *utgam2(1.d0+alp1+del1)*coefp
     *  /utgam2(2.d0+alp1+del1+alppro)
     *  *utgam2(1.d0+alp2+del2)*coefp
     *  /utgam2(2.d0+alp2+del2+alppro)
     *  *utgam2(1.d0+alp3+del3)*coeft
     *  /utgam2(2.d0+alp3+del3+alptar)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *  *alpD1(i3,iclegy,icltar))

                if(iqq.eq.2)facOmNp(i1,i2,i3)=fact

                omNcutIJ=omNcutIJ+fact
              enddo
            enddo
          enddo

        else

          del=delD1(1,iclegy,icltar)
          r3pomm=dble(gamhad(icltar)**2.*gamhad(iclpro)
     *         /(alp*del)**3.*xmu(1)
     *         *utgam1(2.+2.*betm)/utgam1(1.+betm)**2.
     *         *del**2./3./log(sy/delx/delx))
     *      /dble(chad(icltar))
      
          do i1=min1,max1
            del1=dble(betD1(i1,iclegy,icltar))
            if(i1.eq.1)del1=del1+dble(betv)
            alp1=dble(betDp1(i1,iclegy,icltar)-alppar)
     &           +dble(xnup(iclegy,icltar))
            do i2=min2,max2
              del2=dble(betD1(i2,iclegy,icltar))
              if(i2.eq.1)del2=del2+dble(betv)
              alp2=dble(betDp1(i2,iclegy,icltar)-alppar)
     &             +dble(xnup(iclegy,icltar))
              do i3=min3,max3
                del3=dble(betD1(i3,iclegy,iclpro))
                alp3=dble(betDp1(i3,iclegy,iclpro)-alppar)
     &               +dble(xnum(iclegy,iclpro))
               
                if(i1.ne.1.and.i2.ne.1.and.i3.ne.1)then
                  r3pomm=dble(r3pom)
                endif

                if(dabs(del1+del2-del3).lt.eps)then
                  dps=dlog(dsy/ddelx**2)
                else
                  dps=((dsy/ddelx)**(del1+del2-del3)
     *                 -ddelx**(del1+del2-del3))
     *                 /(del1+del2-del3)
                endif 
                
                fact=r3pomm*dps*dsy**del3
     *  *utgam2(1.d0+alp1+del1)*coeft
     *  /utgam2(2.d0+alp1+del1+alptar)
     *  *utgam2(1.d0+alp2+del2)*coeft
     *  /utgam2(2.d0+alp2+del2+alptar)
     *  *utgam2(1.d0+alp3+del3)*coefp
     *  /utgam2(2.d0+alp3+del3+alppro)
     *  *utgam2(1.d0+del1)*utgam2(1.d0+del2)
     *  /utgam2(2.d0+del1+del2)
     *  *dble(alpD1(i1,iclegy,icltar)*alpD1(i2,iclegy,icltar)
     *  *alpD1(i3,iclegy,iclpro))

                if(iqq.eq.6)facOmNm(i1,i2,i3)=fact

                omNcutIJ=omNcutIJ+fact
              enddo
            enddo
          enddo

        endif

        if(iqq.eq.0.or.iqq.eq.4)then

          omNcutIJ=-omNcutIJ*2.d0
            
        elseif(iqq.eq.1.or.iqq.eq.5)then
            
          omNcutIJ=omNcutIJ*2.d0*cYdif
        
        elseif(iqq.eq.2.or.iqq.eq.6)then
        
          omNcutIJ=omNcutIJ*2.d0*cYscr

        elseif(iqq.eq.3.or.iqq.eq.7)then

          omNcutIJ=omNcutIJ*2.d0*cYfus

        elseif(iqq.gt.6.or.iqq.le.0)then
          call utstop('Wrong iqq in omNcutIJ !&')
        endif
          
      endif
      
      omNcutIJ=omNcutIJ/2.d0         !not to double counting
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
     *  *dble(chad(iclpro)*chad(icltar))
      if(iqq.le.3)then
        omNcutIJ=omNcutIJ*dble(gamdp(icdpl1,iclpro)*chad(iclpro))
      else
        omNcutIJ=omNcutIJ*dble(gamdt(icdtl1,icltar)*chad(icltar))
      endif  

      return
      end


c-----------------------------------------------------------------------
      double precision function omNcutIJb(bh,bl,bhl,min1,max1,min2,max2
     &                                            ,min3,max3,iqq)
c-----------------------------------------------------------------------
c Cut Eikonale (for A-A shadowing effect) b dependance
c bh - impact parameter between the pomeron ends;
c bl - impact parameter between the pomeron end and the leg end;
c bhl - difference (vector) of impact parameter between the pomeron end 
c and the leg end;
c iqq = 1  - 3p+,
c iqq = 2  - 3p-.
c mini, maxi = 1 - G1 for ideal G (all min/max set to 1) -> not used
c              2 - soft G1
c              3 - semihard G1
c              4 - valence G1
c min1/max1 and min2/max2 - parallel legs
c min3/max3               - simple leg
c-----------------------------------------------------------------------
      double precision dsy
      include 'nexus.inc'
      include 'nexus.incsem'
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /omNfac/ facOmNp(4,4,4),facOmNm(4,4,4)
      double precision facOmNp,facOmNm

      sy=engy*engy
      dsy=dble(sy)
      omNcutIJb=0.d0
      b1=bh*bh
      b2=bl*bl
      b12=bhl*bhl

      if(dsy.le.Eseuil**2..or.inueff.eq.0)return


        if(iqq.eq.1)then
      
          do i1=min1,max1
            rh1=delD1(i1,iclegy,iclpro)
            if(i1.eq.1)rh1=rh1/3.
            do i2=min2,max2
              rh2=delD1(i2,iclegy,iclpro)
              if(i2.eq.1)rh2=rh2/3.
              do i3=min3,max3
                rh3=delD1(i3,iclegy,icltar)
                if(i3.eq.1)rh3=rh3/3.
                rh=rh1*rh2+rh1*rh3+rh2*rh3      

                omNcutIJb=omNcutIJb+facOmNp(i1,i2,i3)
     * *dble(exp(-rh2*b1/rh-rh1*b2/rh-rh3*b12/rh)/rh)
              enddo
            enddo
          enddo

        else
      
          do i1=min1,max1
            rh1=delD1(i1,iclegy,icltar)
            if(i1.eq.1)rh1=rh1/3.
            do i2=min2,max2
              rh2=delD1(i2,iclegy,icltar)
              if(i2.eq.1)rh2=rh2/3.
              do i3=min3,max3
                rh3=delD1(i3,iclegy,iclpro)
                if(i3.eq.1)rh3=rh3/3.
                rh=rh1*rh2+rh1*rh3+rh2*rh3      
               

                omNcutIJb=omNcutIJb+facOmNm(i1,i2,i3)
     *  *dble(exp(-rh2*b1/rh-rh1*b2/rh-rh3*b12/rh)/rh)
              enddo
            enddo
          enddo

        endif

      omNcutIJb=2.d0*cYscr*omNcutIJb/2.d0         !not to double counting
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
     *  *dble(chad(iclpro)*chad(icltar))
      if(iqq.eq.1)then
        omNcutIJb=omNcutIJb*dble(gamdp(icdpl1,iclpro)*chad(iclpro))
      else
        omNcutIJb=omNcutIJb*dble(gamdt(icdtl1,icltar)*chad(icltar))
      endif  

      return
      end

c----------------------------------------------------------------------

      double precision function omNgam(iqq)

c----------------------------------------------------------------------
c Triple cut Eikonale (for A-A shadowing effect) (no F+ or F- function)
c without b dependance
c iqq = 1  - 3p+(cut nucl),
c iqq = 2  - 3p-(cut nucl),
c----------------------------------------------------------------------
      double precision dsy,ddelx,alp,bet,coef1,coef2,coef3
      include 'nexus.inc'
      include 'nexus.incsem'
      common /psar7/ delx,alam3p,gam3p
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)

      omNgam=0.d0
      if(cYfus.eq.0.d0)return
      if(iqq.gt.2.or.iqq.lt.0)then
        call utstop('Wrong iqq in omNgam !&')
      endif
      ddelx=dble(delx)
      dsy=dble(engy*engy)
      ddelx=dble(delx)
      if(dsy.le.ddelx**2.d0.or.dsy.le.Eseuil**2..or.inueff.eq.0)return
      if(iqq.eq.1)then
       alp=dble(alpD(2,iclegy,iclpro,icltar,icdp,icdt))
       bet=dble(betD(2,iclegy,iclpro,icltar,icdp,icdt))
       coef1=1.d0+dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnup(iclegy,iclpro)-xnu(iclegy,iclpro))
       coef2=1.d0+dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnup(iclegy,iclpro)-xnu(iclegy,iclpro))
       coef3=1.d0+dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnum(iclegy,icltar)+betD1(1,iclegy,icltar))
      else
       alp=dble(alpD(3,iclegy,iclpro,icltar,icdp,icdt))
       bet=dble(betD(3,iclegy,iclpro,icltar,icdp,icdt))
       coef1=1.d0+dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnup(iclegy,icltar)-xnu(iclegy,icltar))
       coef2=1.d0+dble(betDp1(1,iclegy,icltar)-alppar)
     &            +dble(xnup(iclegy,icltar)-xnu(iclegy,icltar))
       coef3=1.d0+dble(betDp1(1,iclegy,iclpro)-alppar)
     &            +dble(xnum(iclegy,iclpro)+betD1(1,iclegy,iclpro))
      endif

      omNgam=alp*dsy**bet/coef1/coef2/coef3


      omNgam=-2.d0*cYfus*omNgam               
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
     *  *dble(chad(iclpro)*chad(icltar))
      if(iqq.le.3)then
        omNgam=omNgam*dble(gamdp(icdpl1,iclpro))
      else
        omNgam=omNgam*dble(gamdt(icdtl1,icltar))
      endif  
	

      omNgam=omNgam/2.d0           !not to double counting

      return
      end

c----------------------------------------------------------------------

      double precision function omNgamint(iqq)

c----------------------------------------------------------------------
c Triple uncut and cut Eikonale (for A-A shadowing effect) integrated 
c without b dependance
c iqq = 0  - 3p+(unc nucl),
c iqq = 1  - 3p+(dif nucl),
c iqq = 2  - 3p+(scr nucl),
c iqq = 3  - 3p+(cut nucl)
c iqq = 4  - 3p-(unc nucl),
c iqq = 5  - 3p-(dif nucl)
c iqq = 6  - 3p-(scr nucl),
c iqq = 7  - 3p-(cut nucl)
c----------------------------------------------------------------------
      double precision dsy,ddelx,alp,bet,coef1,coef2,coef3
      include 'nexus.inc'
      include 'nexus.incsem'
      common /psar7/ delx,alam3p,gam3p
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /cgtilnu/ cfbetpnp,cfbetppnp,cfbetpnm,cfbetppnm,cfalpro
     &,cfaltar,cfbpap,cfbpam,cfbppap,cfbppam
      double precision cfbetpnp,cfbetppnp,cfbetpnm,cfbetppnm,cfalpro
     &,cfaltar,cfbpap,cfbpam,cfbppap,cfbppam

      omNgamint=0.d0
      if((iqq.eq.2.or.iqq.eq.6).and.cYscr.eq.0.d0)return
      if((iqq.eq.1.or.iqq.eq.5).and.cYdif.eq.0.d0)return
      if((iqq.eq.3.or.iqq.eq.7).and.cYfus.eq.0.d0)return
      ddelx=dble(delx)
      dsy=dble(engy*engy)
      if(dsy.le.ddelx**2.d0.or.dsy.le.Eseuil**2..or.inueff.eq.0)return
      if(iqq.le.2)then
       alp=dble(alpD(2,iclegy,iclpro,icltar,icdp,icdt))
       bet=dble(betD(2,iclegy,iclpro,icltar,icdp,icdt))
       coef1=cfbetpnp*cfalpro/cfbpap
       coef2=cfbetpnp*cfalpro/cfbpap
       coef3=cfbetppnm*cfaltar/cfbppam
      else
       alp=dble(alpD(3,iclegy,iclpro,icltar,icdp,icdt))
       bet=dble(betD(3,iclegy,iclpro,icltar,icdp,icdt))
       coef1=cfbetpnm*cfaltar/cfbpam
       coef2=cfbetpnm*cfaltar/cfbpam
       coef3=cfbetppnp*cfalpro/cfbppap
      endif

      omNgamint=alp*dsy**bet*coef1*coef2*coef3


      omNgamint=omNgamint               
     *  *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))  
     *  *dble(chad(iclpro)*chad(icltar))
      if(iqq.le.3)then
        omNgamint=omNgamint*dble(gamdp(icdpl1,iclpro))
      else
        omNgamint=omNgamint*dble(gamdt(icdtl1,icltar))
      endif  
	
      if(iqq.eq.0.or.iqq.eq.4)then

        omNgamint=omNgamint*2.d0

      elseif(iqq.eq.1.or.iqq.eq.5)then

        omNgamint=-omNgamint*2.d0*cYdif

      elseif(iqq.eq.2.or.iqq.eq.6)then
        
        omNgamint=-omNgamint*2.d0*cYscr

      elseif(iqq.eq.3.or.iqq.eq.7)then

        omNgamint=-omNgamint*2.d0*cYfus


      elseif(iqq.gt.7.or.iqq.lt.0)then
        call utstop('Wrong iqq in omNgamint !&')
      endif

      omNgamint=omNgamint/2.d0           !not to double counting

      return
      end

c----------------------------------------------------------------------

      double precision function omNgamintb(bh,bl,bhl,iqq)

c----------------------------------------------------------------------
c Triple cut Eikonale (for A-A shadowing effect) b dependance
c bh - impact parameter between the pomeron ends;
c bl - impact parameter between the pomeron end and the leg end;
c bhl - difference (vector) of impact parameter between the pomeron 
c end and the leg end;
c iqq = 1  - 3p+,
c iqq = 2  - 3p-.
c----------------------------------------------------------------------
      double precision del1,del2,del3,del,b1,b2,b12
      include 'nexus.inc'
      include 'nexus.incsem'

      omNgamintb=0.d0
      b1=dble(bh*bh)
      b2=dble(bl*bl)
      b12=dble(bhl*bhl)
      if(iqq.eq.1)then
       del1=dble(delD(2,iclegy,iclpro,icltar,icdp,icdt))/3.d0
       del2=dble(delD(2,iclegy,iclpro,icltar,icdpl1,icdt))/3.d0
       del3=dble(delD(2,iclegy,iclpro,icltar,icdp,icdt))/3.d0
      else
       del1=dble(delD(3,iclegy,iclpro,icltar,icdp,icdt))/3.d0
       del2=dble(delD(3,iclegy,iclpro,icltar,icdp,icdtl1))/3.d0
       del3=dble(delD(3,iclegy,iclpro,icltar,icdp,icdt))/3.d0
      endif
      del=del1*del2+del1*del3+del2*del3

      omNgamintb=dexp(-del2*b1/del-del1*b2/del-del3*b12/del)

      return
      end

c-----------------------------------------------------------------------
      subroutine WomTyN(w,iqq)
c-----------------------------------------------------------------------
c - w(ity) ity contribution for nuclear shadowing diagram
c iqq = 2  Y+ nucl
c iqq = 6  Y- nucl
c ity = 0   - soft
c ity = 1   - gg+soft
c ity = 2   - soft+gg
c-----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incems'
      include 'nexus.incsem'
      doubleprecision omNcutIJ,w(0:4),Ynorm

      do i=0,4
        w(i)=0.d0
      enddo

      if(inueff.eq.0)return

      if(iqq.eq.2.or.iqq.eq.6)then

        Ynorm=omNcutIJ(2,4,2,4,2,4,iqq)      !Let it to calculate facOmN

        w(0)=omNcutIJ(2,2,2,3,2,2,iqq)!/Ynorm
        w(1)=omNcutIJ(2,2,2,3,3,3,iqq)!/Ynorm
        w(2)=omNcutIJ(3,3,2,3,2,2,iqq)!/Ynorm
c        w(3)=omNcutIJ(3,3,2,3,3,3,iqq)/Ynorm
c        w(4)=omNcutIJ(2,2,2,3,4,4,iqq)/Ynorm
c        w(5)=omNcutIJ(3,3,2,3,4,4,iqq)/Ynorm
c        w(6)=omNcutIJ(4,4,2,3,2,2,iqq)/Ynorm
c        w(7)=omNcutIJ(4,4,2,3,3,3,iqq)/Ynorm
c        w(8)=omNcutIJ(4,4,2,3,4,4,iqq)/Ynorm
     
        else
          call utstop('Wrong iqq in WomTyN&')
        endif

      return
      end

c-----------------------------------------------------------------------
      subroutine WomTy(w,xh,yp,xprem,xmrem,k,iqq)
c-----------------------------------------------------------------------
c - w(ity) for group iqq of cut enhanced diagram giving
c the probability of the type of the same final state. 
c k - pair indice;
c xh - fraction of the energy squared s for the pomeron;
c yp - rapidity for the pomeron;
c xpr,xmr impulsion fraction of remnant
c iqq = -1   - 1 cut no screening,
c iqq = 0    - 1 cut screening,
c    ity = 0   - soft
c    ity = 1   - gg
c    ity = 2   - qg
c    ity = 3   - gq
c    ity = 4   - qq
c iqq = 1/2   - type of Y cut +/-
c    ity = 0   - soft
c    ity = 1   - gg
c    ity = 2   - qg
c    ity = 3   - gq
c iqq = 3/4   - type of diff +/-
c    ity = 0   - soft
c    ity = 1   - gg
c    ity = 2   - qg
c-----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incems'
      include 'nexus.incsem'
      doubleprecision xh,yp,omIcutJ,omXcutIJ,omYcutIJ,xprem,xmrem,w(0:7)
     &,Xnorm,Ynorm,Ynorm1,Ynorm2,xInorm,omIcut,eps
      parameter(eps=1.d-10)

      do i=0,7
        w(i)=0.d0
      enddo
      
      bh=bk(k)

      if(iscreen.eq.0.or.iqq.eq.-1)then
        do i=0,4
          w(i)=omIcutJ(xh,yp,bh,i)
        enddo
      else

      if(iqq.eq.0)then

        xInorm=omIcut(xh,yp,bh,1)
        if(dabs(xInorm).gt.eps)xInorm=omIcut(xh,yp,bh,0)/xInorm

        Ynorm1=omYcutIJ(xh,yp,xprem,xmrem,bh,2,4,2,4,2,4,2)
        if(dabs(Ynorm1).gt.eps)
     &  Ynorm1=omYcutIJ(xh,yp,xprem,xmrem,bh,1,1,1,1,1,1,2)/Ynorm1

        Ynorm2=omYcutIJ(xh,yp,xprem,xmrem,bh,2,4,2,4,2,4,5)
        if(dabs(Ynorm2).gt.eps)
     &  Ynorm2=omYcutIJ(xh,yp,xprem,xmrem,bh,1,1,1,1,1,1,5)/Ynorm2

        Xnorm =omXcutIJ(xh,yp,xprem,xmrem,bh,2,4,2,4,2,4,2,4,1)
        if(dabs(Xnorm).gt.eps)
     &  Xnorm= omXcutIJ(xh,yp,xprem,xmrem,bh,1,1,1,1,1,1,1,1,1)/Xnorm

        w(0)=(1+shaeffsf(k))*omIcutJ(xh,yp,bh,0)*xInorm
     &      +omYcutIJ(xh,yp,xprem,xmrem,bh,2,4,2,2,2,2,2)*Ynorm1
     &      +omYcutIJ(xh,yp,xprem,xmrem,bh,2,4,2,2,2,2,5)*Ynorm2
     &      +omXcutIJ(xh,yp,xprem,xmrem,bh,2,4,2,2,2,2,2,4,1)*Xnorm
        w(1)=(1+shaeffsh(k))*omIcutJ(xh,yp,bh,1)*xInorm
     &      +omYcutIJ(xh,yp,xprem,xmrem,bh,2,4,2,2,3,3,2)*Ynorm1
     &      +omYcutIJ(xh,yp,xprem,xmrem,bh,2,4,2,2,3,3,5)*Ynorm2
     &      +omXcutIJ(xh,yp,xprem,xmrem,bh,2,4,2,2,3,3,2,4,1)*Xnorm
     &      +omYcutIJ(xh,yp,xprem,xmrem,bh,2,4,3,3,2,2,2)*Ynorm1
     &      +omYcutIJ(xh,yp,xprem,xmrem,bh,2,4,3,3,2,2,5)*Ynorm2
     &      +omXcutIJ(xh,yp,xprem,xmrem,bh,2,4,3,3,2,2,2,4,1)*Xnorm
        w(2)=omIcutJ(xh,yp,bh,2)*xInorm
     &      +omYcutIJ(xh,yp,xprem,xmrem,bh,2,4,4,4,2,2,2)*Ynorm1
     &      +omYcutIJ(xh,yp,xprem,xmrem,bh,2,4,4,4,2,2,5)*Ynorm2
     &      +omXcutIJ(xh,yp,xprem,xmrem,bh,2,4,4,4,2,2,2,4,1)*Xnorm
        w(3)=omIcutJ(xh,yp,bh,3)*xInorm
     &      +omYcutIJ(xh,yp,xprem,xmrem,bh,2,4,2,2,4,4,2)*Ynorm1
     &      +omYcutIJ(xh,yp,xprem,xmrem,bh,2,4,2,2,4,4,5)*Ynorm2
     &      +omXcutIJ(xh,yp,xprem,xmrem,bh,2,4,2,2,4,4,2,4,1)*Xnorm
        w(4)=omIcutJ(xh,yp,bh,4)*xInorm



c ??????????? What about double hard ?


        elseif(iqq.eq.1.or.iqq.eq.2)then
          
          if(iqq.eq.1)then
            iqY=1
            iqX=3
          elseif(iqq.eq.2)then
            iqY=4
            iqX=2
          endif

          Ynorm=omYcutIJ(xh,yp,xprem,xmrem,bh,2,4,2,4,2,4,iqY)
          if(dabs(Ynorm).gt.eps)
     &    Ynorm=omYcutIJ(xh,yp,xprem,xmrem,bh,1,1,1,1,1,1,iqY)/Ynorm

          Xnorm=omXcutIJ(xh,yp,xprem,xmrem,bh,2,4,2,4,2,4,2,4,iqX)
          if(dabs(Xnorm).gt.eps)
     & Xnorm=omXcutIJ(xh,yp,xprem,xmrem,bh,1,1,1,1,1,1,1,1,iqX)/Xnorm


          w(0)=omYcutIJ(xh,yp,xprem,xmrem,bh,2,2,2,2,2,2,iqY)*Ynorm
     &      +omXcutIJ(xh,yp,xprem,xmrem,bh,2,2,2,2,2,2,2,4,iqX)*Xnorm
          w(1)=omYcutIJ(xh,yp,xprem,xmrem,bh,2,2,2,2,3,3,iqY)*Ynorm
     &      +omXcutIJ(xh,yp,xprem,xmrem,bh,2,2,2,2,3,3,2,4,iqX)*Xnorm
     & +2.d0*omYcutIJ(xh,yp,xprem,xmrem,bh,2,2,3,3,2,2,iqY)*Ynorm
     & +2.d0*omXcutIJ(xh,yp,xprem,xmrem,bh,2,2,3,3,2,2,2,4,iqX)*Xnorm
          w(2)=omYcutIJ(xh,yp,xprem,xmrem,bh,2,2,2,2,4,4,iqY)*Ynorm
     &      +omXcutIJ(xh,yp,xprem,xmrem,bh,2,2,2,2,4,4,2,4,iqX)*Xnorm
          w(3)=2.d0*omYcutIJ(xh,yp,xprem,xmrem,bh,2,2,4,4,2,2,iqY)*Ynorm
     & +2.d0*omXcutIJ(xh,yp,xprem,xmrem,bh,2,2,4,4,2,2,2,4,iqX)*Xnorm

      elseif(iqq.eq.3.or.iqq.eq.4)then

          if(iqq.eq.3)then
            iqY=3
            iqX=5
          elseif(iqq.eq.4)then
            iqY=6
            iqX=4
          endif

          Ynorm=omYcutIJ(xh,yp,xprem,xmrem,bh,2,4,2,4,2,4,iqY)
          if(dabs(Ynorm).gt.eps)
     &    Ynorm=omYcutIJ(xh,yp,xprem,xmrem,bh,1,1,1,1,1,1,iqY)/Ynorm

          Xnorm=omXcutIJ(xh,yp,xprem,xmrem,bh,2,4,2,4,2,4,2,4,iqX)
          if(dabs(Xnorm).gt.eps)
     & Xnorm=omXcutIJ(xh,yp,xprem,xmrem,bh,1,1,1,1,1,1,1,1,iqX)/Xnorm


          w(0)=omYcutIJ(xh,yp,xprem,xmrem,bh,2,4,2,4,2,2,iqY)*Ynorm
     &      +omXcutIJ(xh,yp,xprem,xmrem,bh,2,4,2,4,2,2,2,4,iqX)*Xnorm
          w(1)=omYcutIJ(xh,yp,xprem,xmrem,bh,2,4,2,4,3,3,iqY)*Ynorm
     &      +omXcutIJ(xh,yp,xprem,xmrem,bh,2,4,2,4,2,3,3,4,iqX)*Xnorm
          w(2)=omYcutIJ(xh,yp,xprem,xmrem,bh,2,4,2,4,4,4,iqY)*Ynorm
     &      +omXcutIJ(xh,yp,xprem,xmrem,bh,2,4,2,4,2,4,4,4,iqX)*Xnorm


      else
        call utstop('Wrong iqq in WomTy&')
      endif
      endif


      return
      end

c-----------------------------------------------------------------------
      subroutine WomTy3p(w,xp1,xp2,xm,xmrem,xpv,k,iqq,jj)
c-----------------------------------------------------------------------
c - w(ity) for group of 3 cut enhanced 3p diagram giving
c the probability of the type of the same final state. 
c k - pair indice;
c xp1 - momentum fraction of pomeron 1 (parallel) ;
c xp2 - momentum fraction of pomeron 2 (parallel) ;
c xm -  momentum fraction of pomeron 3 (single) ;
c xpv - impulsion fraction of the vertex
c iqq = 1   - # of soft diagram
c    ity = 3   - 0
c    ity = 1   - 1 (single)
c    ity = 2   - 1 (parallel 1)
c    ity = 4   - 1 (parallel 2)
c    ity = 0   - 3
c    ity = 5   - 2 (both parallel)
c    ity = 6   - 2 (single+parallel 1)
c    ity = 7   - 2 (single+parallel 2)
c iqq = 2   - hard conf if 2 soft both parallel
c    ity = 0   - gg
c    ity = 1   - qg
c iqq = 3   - hard conf if 2 soft single+parallel1
c    ity = 0   - gg
c    ity = 1   - qg
c iqq = 4   - hard conf if 2 soft single+parallel2
c    ity = 0   - gg
c    ity = 1   - qg
c iqq = 5   - hard conf if 1 soft single
c    ity = 0   - gg+gg
c    ity = 1   - gg+qg
c    ity = 2   - qg+gg
c    ity = 3   - qg+qg
c iqq = 6   - hard conf if 1 soft parallel1
c    ity = 0   - gg,gg
c    ity = 1   - qg,gg
c    ity = 2   - gg,qg
c    ity = 3   - qg,qg
c iqq = 7   - hard conf if 1 soft parallel2
c    ity = 0   - gg,gg
c    ity = 1   - qg,gg
c    ity = 2   - gg,qg
c    ity = 3   - qg,qg
c iqq = 8   - hard conf if 0 soft
c    ity = 0   - gg+gg,gg
c    ity = 1   - qg+gg,gg
c    ity = 2   - gg+qg,gg
c    ity = 3   - qg+qg,gg
c    ity = 4   - gg+gg,qg
c    ity = 5   - qg+gg,qg
c    ity = 6   - gg+qg,qg
c    ity = 7   - qg+qg,qg
c jj=1 -> + , jj=2 -> -
c-----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incems'
      include 'nexus.incsem'
      doubleprecision xp1,xp2,xm,xpv,omXcutJc,omYcutJc,w(0:7),xmrem
     &,Xnorm,Ynorm,eps
      parameter(eps=1.d-10)

      do i=0,7
        w(i)=0.d0
      enddo
      
      bh=bk(k)

      if(iscreen.eq.0)return

      Ynorm=omYcutJc(xp1,xp2,xm,xpv,bh,2,4,2,4,2,4,jj)
      if(dabs(Ynorm).gt.eps)
     &Ynorm=omYcutJc(xp1,xp2,xm,xpv,bh,1,1,1,1,1,1,jj)/Ynorm

      Xnorm=omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,2,4,2,4,2,4,2,4,jj)
      if(dabs(Xnorm).gt.eps)
     &Xnorm=omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,1,1,1,1,1,1,1,1,jj)/Xnorm


      if(iqq.eq.1)then

        w(0)=omYcutJc(xp1,xp2,xm,xpv,bh,2,2,2,2,2,2,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,2,2,2,2,2,2,2,4,jj)*Xnorm
        w(5)=omYcutJc(xp1,xp2,xm,xpv,bh,2,2,2,2,3,4,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,2,2,2,2,3,4,2,4,jj)*Xnorm
        w(6)=omYcutJc(xp1,xp2,xm,xpv,bh,2,2,3,4,2,2,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,2,2,3,4,2,2,2,4,jj)*Xnorm
        w(7)=omYcutJc(xp1,xp2,xm,xpv,bh,3,4,2,2,2,2,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,3,4,2,2,2,2,2,4,jj)*Xnorm
        w(1)=omYcutJc(xp1,xp2,xm,xpv,bh,3,4,3,4,2,2,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,3,4,3,4,2,2,2,4,jj)*Xnorm
        w(2)=omYcutJc(xp1,xp2,xm,xpv,bh,2,2,3,4,3,4,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,2,2,3,4,3,4,2,4,jj)*Xnorm
        w(4)=omYcutJc(xp1,xp2,xm,xpv,bh,3,4,2,2,3,4,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,3,4,2,2,3,4,2,4,jj)*Xnorm
        w(3)=omYcutJc(xp1,xp2,xm,xpv,bh,3,4,3,4,3,4,1)*Ynorm

      elseif(iqq.eq.2)then

        w(0)=omYcutJc(xp1,xp2,xm,xpv,bh,2,2,2,2,3,3,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,2,2,2,2,3,3,2,4,jj)*Xnorm
        w(1)=omYcutJc(xp1,xp2,xm,xpv,bh,2,2,2,2,4,4,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,2,2,2,2,4,4,2,4,jj)*Xnorm

      elseif(iqq.eq.3)then

        w(0)=omYcutJc(xp1,xp2,xm,xpv,bh,2,2,3,3,2,2,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,2,2,3,3,2,2,2,4,jj)*Xnorm
        w(1)=omYcutJc(xp1,xp2,xm,xpv,bh,2,2,4,4,2,2,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,2,2,4,4,2,2,2,4,jj)*Xnorm

      elseif(iqq.eq.4)then

        w(0)=omYcutJc(xp1,xp2,xm,xpv,bh,3,3,2,2,2,2,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,3,3,2,2,2,2,2,4,jj)*Xnorm
        w(1)=omYcutJc(xp1,xp2,xm,xpv,bh,4,4,2,2,2,2,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,4,4,2,2,2,2,2,4,jj)*Xnorm

      elseif(iqq.eq.5)then

        w(0)=omYcutJc(xp1,xp2,xm,xpv,bh,3,3,3,3,2,2,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,3,3,3,3,2,2,2,4,jj)*Xnorm
        w(1)=omYcutJc(xp1,xp2,xm,xpv,bh,3,3,4,4,2,2,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,3,3,4,4,2,2,2,4,jj)*Xnorm
        w(2)=omYcutJc(xp1,xp2,xm,xpv,bh,4,4,3,3,2,2,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,4,4,3,3,2,2,2,4,jj)*Xnorm
        w(3)=omYcutJc(xp1,xp2,xm,xpv,bh,4,4,4,4,2,2,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,4,4,4,4,2,2,2,4,jj)*Xnorm

      elseif(iqq.eq.6)then

        w(0)=omYcutJc(xp1,xp2,xm,xpv,bh,2,2,3,3,3,3,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,2,2,3,3,3,3,2,4,jj)*Xnorm
        w(1)=omYcutJc(xp1,xp2,xm,xpv,bh,2,2,4,4,3,3,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,2,2,4,4,3,3,2,4,jj)*Xnorm
        w(2)=omYcutJc(xp1,xp2,xm,xpv,bh,2,2,3,3,4,4,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,2,2,3,3,4,4,2,4,jj)*Xnorm
        w(3)=omYcutJc(xp1,xp2,xm,xpv,bh,2,2,4,4,4,4,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,2,2,4,4,4,4,2,4,jj)*Xnorm

      elseif(iqq.eq.7)then

        w(0)=omYcutJc(xp1,xp2,xm,xpv,bh,3,3,2,2,3,3,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,3,3,2,2,3,3,2,4,jj)*Xnorm
        w(1)=omYcutJc(xp1,xp2,xm,xpv,bh,4,4,2,2,3,3,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,4,4,2,2,3,3,2,4,jj)*Xnorm
        w(2)=omYcutJc(xp1,xp2,xm,xpv,bh,3,3,2,2,4,4,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,3,3,2,2,4,4,2,4,jj)*Xnorm
        w(3)=omYcutJc(xp1,xp2,xm,xpv,bh,4,4,2,2,4,4,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,4,4,2,2,4,4,2,4,jj)*Xnorm

      elseif(iqq.eq.8)then

        w(0)=omYcutJc(xp1,xp2,xm,xpv,bh,3,3,3,3,3,3,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,3,3,3,3,3,3,2,4,jj)*Xnorm
        w(1)=omYcutJc(xp1,xp2,xm,xpv,bh,4,4,3,3,3,3,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,4,4,3,3,3,3,2,4,jj)*Xnorm
        w(2)=omYcutJc(xp1,xp2,xm,xpv,bh,3,3,4,4,3,3,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,3,3,4,4,3,3,2,4,jj)*Xnorm
        w(3)=omYcutJc(xp1,xp2,xm,xpv,bh,4,4,4,4,3,3,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,4,4,4,4,3,3,2,4,jj)*Xnorm
        w(4)=omYcutJc(xp1,xp2,xm,xpv,bh,3,3,3,3,4,4,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,3,3,3,3,4,4,2,4,jj)*Xnorm
        w(5)=omYcutJc(xp1,xp2,xm,xpv,bh,4,4,3,3,4,4,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,4,4,3,3,4,4,2,4,jj)*Xnorm
        w(6)=omYcutJc(xp1,xp2,xm,xpv,bh,3,3,4,4,4,4,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,3,3,4,4,4,4,2,4,jj)*Xnorm
        w(7)=omYcutJc(xp1,xp2,xm,xpv,bh,4,4,4,4,4,4,jj)*Ynorm
     &      +omXcutJc(xp1,xp2,xm,xmrem,xpv,bh,4,4,4,4,4,4,2,4,jj)*Xnorm

      else
        call utstop('Wrong iqq in WomTy3p&')
      endif

      return
      end

c-----------------------------------------------------------------------
      double precision function Womega(xh,yp,xprem,xmrem,bh,iqq,iqqq)
c-----------------------------------------------------------------------
c - chi~(xp,xm,xpr,xmr)/2. for group of cut enhanced diagram giving
c the same final state (without nuclear effect).
c bh - impact parameter between the pomeron ends;
c xh - fraction of the energy squared s for the pomeron;
c yp - rapidity for the pomeron;
c xprem,xmrem impulsion fraction of remnant
c iqq = 1   - 1 cut,
c iqq = 2   - 3 cut+,
c iqq = 3   - 3 cut-,
c iqq = 4   - 1 cut diff+,
c iqq = 5   - 1 cut diff-,
c iqqq=0 ideal G
c iqqq=1 exact G
c-----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      double precision xh,yp,omIcut,omXcut,omYcut,xprem,xmrem

      Womega=0.d0

      if(iqq.eq.1)then
        Womega=omIcut(xh,yp,bh,iqqq)
     &        +omYcut(xh,yp,xprem,xmrem,bh,2,iqqq)
     &        +omYcut(xh,yp,xprem,xmrem,bh,5,iqqq)
     &        +omXcut(xh,yp,xprem,xmrem,bh,1,iqqq)
      elseif(iqq.eq.2)then
        Womega=omYcut(xh,yp,xprem,xmrem,bh,1,iqqq)
     &        +omXcut(xh,yp,xprem,xmrem,bh,3,iqqq)
      elseif(iqq.eq.3)then
        Womega=omYcut(xh,yp,xprem,xmrem,bh,4,iqqq)
     &        +omXcut(xh,yp,xprem,xmrem,bh,2,iqqq)
      elseif(iqq.eq.4)then
        Womega=omYcut(xh,yp,xprem,xmrem,bh,3,iqqq)
     &        +omXcut(xh,yp,xprem,xmrem,bh,5,iqqq)
      elseif(iqq.eq.5)then
        Womega=omYcut(xh,yp,xprem,xmrem,bh,6,iqqq)
     &        +omXcut(xh,yp,xprem,xmrem,bh,4,iqqq)
      else
        call utstop('Wrong iqq in Womega&')
      endif

      return
      end

c-----------------------------------------------------------------------
      double precision function Womegak(xh,yp,k,iqq)
c-----------------------------------------------------------------------
c - sum(omGam(x,y)) for group of cut enhanced diagram giving
c the same final state (without nuclear effect).
c xh - fraction of the energy squared s for the pomeron;
c yp - rapidity for the pomeron;
c k - pair index
c iqq = 1   - 1 cut,
c iqq = 2   - Y cut+,
c iqq = 3   - Y cut-,
c iqq = 4   - Y cut diff+,
c iqq = 5   - Y cut diff-,
c-----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incems'
      double precision xp,xm,xh,yp,dsy,ddelx,eps
      parameter(eps=1.d-20)
      common /psar7/ delx,alam3p,gam3p
      common/cgtilde/atilde(ntymi:ntymx,kollmx)
     &,btildep(ntymi:ntymx,kollmx),btildepp(ntymi:ntymx,kollmx)
     &              ,atildg(nbpDf0:nbpDf1,kollmx)
     &,btildgp(nbpDf0:nbpDf1,kollmx),btildgpp(nbpDf0:nbpDf1,kollmx)
      double precision atilde,btildep,btildepp,atildg,btildgp,btildgpp

      Womegak=0.d0

      if(iqq.lt.1.or.iqq.gt.5)call utstop('Wrong iqq in Womegak&')

      dsy=dble(engy*engy)
      ddelx=dble(delx)
      xp=dsqrt(xh)*dexp( yp)
      xm=dsqrt(xh)*dexp(-yp)

      if(iscreen.eq.0)then
        
        do i=ntymi,1
          Womegak=Womegak+atilde(i,k)*xp**btildep(i,k)*xm**btildepp(i,k)
        enddo
        
      elseif(iqq.eq.1)then

        do i=ntymi,1!4
          Womegak=Womegak+atilde(i,k)*xp**btildep(i,k)*xm**btildepp(i,k)
        enddo

      elseif(iqq.eq.2)then

          Womegak=atilde(5,k)*xp**btildep(5,k)*xm**btildepp(5,k)
c     &           +atilde(6,k)*xp**btildep(6,k)*xm**btildepp(6,k)

      elseif(iqq.eq.3)then

          Womegak=atilde(7,k)*xp**btildep(7,k)*xm**btildepp(7,k)
c     &           +atilde(8,k)*xp**btildep(8,k)*xm**btildepp(8,k)

      elseif(iqq.eq.4.and.xp.lt.1.d0/ddelx-eps
     &               .and.xp.gt.ddelx/dsy+eps)then

          Womegak=atilde(9,k)*xp**btildep(9,k)*xm**btildepp(9,k)
c     &           +atilde(10,k)*xp**btildep(10,k)*xm**btildepp(10,k)
c     &           +atilde(13,k)*xp**btildep(13,k)*xm**btildepp(13,k)

      elseif(iqq.eq.5.and.xm.lt.1.d0/ddelx-eps
     &               .and.xm.gt.ddelx/dsy+eps)then

          Womegak=atilde(11,k)*xp**btildep(11,k)*xm**btildepp(11,k)
c     &           +atilde(12,k)*xp**btildep(12,k)*xm**btildepp(12,k)
c     &           +atilde(14,k)*xp**btildep(14,k)*xm**btildepp(14,k)

      endif
      

      return
      end


c----------------------------------------------------------------------

      double precision function omNpuncut(sy,xh,yp,bh,iqq)

c----------------------------------------------------------------------
c Sum of uncut enhanced diagrams
c sy - (=xh*s) fraction of the energy squared s for the pomeron;
c xh - momentum fraction of the pomeron;
c b - impact parameter between the pomeron ends;
c yp - rapidity for the pomeron;
c iqq=0 ideal G
c iqq=1 exact G
c----------------------------------------------------------------------
      include "nexus.inc"
      double precision omXuncut,omYuncut,xh,yp


      ds=sy/real(xh)

      omNpuncut=(omXuncut(ds,xh,yp,bh,iqq)+omYuncut(ds,xh,yp,bh,iqq))
     *          *2.d0

      return
      end

c----------------------------------------------------------------------

      double precision function omNpcut(xp,xm,xprem,xmrem,bh,iqq)

c----------------------------------------------------------------------
c Sum of all cut diagrams
c iqq=0 ideal G
c iqq=1 exact G
c----------------------------------------------------------------------
      include"nexus.inc"
      double precision omIcut,omXcutI,omYcutI,xh,yp,xprem,xmrem,xp,xm

      omNpcut=0.d0
      xh=xp*xm
      if(dabs(xh).gt.1.d-10)then
        yp=0.5d0*dlog(xp/xm)
      else
        yp=0.d0
      endif

      omNpcut=omIcut(xh,yp,bh,iqq)
      do i=1,6
        omNpcut=omNpcut+omYcutI(xh,yp,xprem,xmrem,bh,i)
      enddo
      do i=1,5
        omNpcut=omNpcut+omXcutI(xh,yp,xprem,xmrem,bh,i)
      enddo

      omNpcut=omNpcut*2.d0

      return
      end


c----------------------------------------------------------------------

      double precision function omGam(xp,xm,bh,iqq)

c-----------------------------------------------------------------------
c Cut diagram part for calculation of probability distribution
c xp,xm impulsion fraction of remnant
c bh - impact parameter between the pomeron ends;
c iqq = 1   - 1p(cut),
c iqq = 2   - 3p+(scr),
c iqq = 3   - 3p-(scr),
c iqq = 4   - 4p(2*scr),
c iqq = 5   - 3p+(cut),
c iqq = 6   - 4p-(scr),
c iqq = 7   - 3p-(cut),
c iqq = 8   - 4p+(scr),
c iqq = 9   - 3p+(dif),
c iqq = 10  - 4p+(dif+scr)
c iqq = 11  - 3p-(dif),
c iqq = 12  - 4p-(dif+scr),
c iqq = 13  - 3p+(dif nucl),
c iqq = 14  - 3p-(dif nucl),
c iqq = 15  - 3p+(cut nucl),
c iqq = 16  - 3p-(cut nucl)
c-----------------------------------------------------------------------
      include"nexus.inc"
      include"nexus.incems"
      double precision omIcut,omXgam,omYgam,xp,xm,xh,yp,eps
      parameter (eps=1.d-20)
      
      omGam=0.d0
      if(xp.lt.eps.or.xm.lt.eps)return
      xh=xp*xm
      if(dabs(xh).gt.1.d-10)then
        yp=0.5d0*dlog(xp/xm)
      else
        yp=0.d0
      endif

      if(iqq.eq.1)then
        omGam=omIcut(xh,yp,bh,0)
      elseif(iqq.eq.2)then
        omGam=omYgam(xp,xm,bh,2)
      elseif(iqq.eq.3)then
        omGam=omYgam(xp,xm,bh,5)
      elseif(iqq.eq.4)then
        omGam=omXgam(xp,xm,bh,1)
      elseif(iqq.eq.5)then
        omGam=omYgam(xp,xm,bh,1)
      elseif(iqq.eq.6)then
        omGam=omXgam(xp,xm,bh,3)
      elseif(iqq.eq.7)then
        omGam=omYgam(xp,xm,bh,4)
      elseif(iqq.eq.8)then
        omGam=omXgam(xp,xm,bh,2)
      elseif(iqq.eq.9)then
        omGam=omYgam(xp,xm,bh,3)
      elseif(iqq.eq.10)then
        omGam=omXgam(xp,xm,bh,5)
      elseif(iqq.eq.11)then
        omGam=omYgam(xp,xm,bh,6)
      elseif(iqq.eq.12)then
        omGam=omXgam(xp,xm,bh,4)
      else
        call utstop('Wrong iqq in omGam&')
      endif
      
      omGam=2.d0*omGam

      return
      end

c----------------------------------------------------------------------

      double precision function omGamk(k,xp,xm,zl,bh,bl,bhl,iqq)

c-----------------------------------------------------------------------
c Cut diagram part for calculation of probability distribution (for omega)
c xp,xm impulsion fraction of remnant
c bh - impact parameter between the pomeron ends;
c iqq = 0   - 1p(cut soft),
c iqq = 1   - 1p(cut sh),
c iqq = 2   - 3p+(scr),
c iqq = 3   - 3p+(dif),
c iqq = 4   - 4p(2*scr),
c iqq = 5   - 3p+(cut),
c iqq = 6   - 4p-(scr),
c iqq = 7   - 3p-(cut),
c iqq = 8   - 4p+(scr),
c iqq = 9   - 3p-(scr),
c iqq = 10  - 4p+(dif+scr)
c iqq = 11  - 3p-(dif),
c iqq = 12  - 4p-(dif+scr),
c iqq = 13  - 3p+(dif nucl),
c iqq = 14  - 3p-(dif nucl),
c iqq = 15  - 3p+(cut nucl),
c iqq = 16  - 3p-(cut nucl),
c iqq = 17  - 3p+-(soft nucl sha),
c iqq = 18  - 3p+-(sh nucl sha)
c-----------------------------------------------------------------------
      include"nexus.inc"
      include"nexus.incems"
      double precision om3,xp,xm,xh,yp,zl,dsy,ddelx,eps
      parameter(eps=1.d-20)
      common /psar7/ delx,alam3p,gam3p
      common/cgtilde/atilde(ntymi:ntymx,kollmx)
     &,btildep(ntymi:ntymx,kollmx),btildepp(ntymi:ntymx,kollmx)
     &              ,atildg(nbpDf0:nbpDf1,kollmx)
     &,btildgp(nbpDf0:nbpDf1,kollmx),btildgpp(nbpDf0:nbpDf1,kollmx)
      double precision atilde,btildep,btildepp,atildg,btildgp,btildgpp
      
      omGamk=0.d0

      if(iqq.lt.0.or.iqq.gt.18)call utstop('Wrong iqq in omGamk&')

      if(xp.lt.eps.or.xm.lt.eps)return
      if(zl.lt.eps.and.(iqq.eq.15.or.iqq.eq.16))return
 
      dsy=dble(engy*engy)
      ddelx=dble(delx)
      xh=xp*xm
      if(dabs(xh).gt.eps)then
        yp=0.5d0*dlog(xp/xm)
      else
        yp=0.d0
      endif

      if(iqq.le.8.or.iqq.eq.17.or.iqq.eq.18)then

        omGamk=atilde(iqq,k)*xp**btildep(iqq,k)*xm**btildepp(iqq,k)

      elseif((iqq.eq.9.or.iqq.eq.10.or.iqq.eq.13)
     &        .and.xp.lt.1.d0/ddelx-eps.and.xp.gt.ddelx/dsy+eps)then

        omGamk=atilde(iqq,k)*xp**btildep(iqq,k)*xm**btildepp(iqq,k)

      elseif((iqq.eq.11.or.iqq.eq.12.or.iqq.eq.14)
     &          .and.xm.lt.1.d0/ddelx-eps.and.xm.gt.ddelx/dsy+eps)then

        omGamk=atilde(iqq,k)*xp**btildep(iqq,k)*xm**btildepp(iqq,k)

      elseif(iqq.eq.15)then

        omGamk=om3(xh,yp,zl,bh,bl,bhl,1)

      elseif(iqq.eq.16)then

        omGamk=om3(xh,yp,zl,bh,bl,bhl,2)

      endif
      

      return
      end

c----------------------------------------------------------------------

      double precision function omGamint(bh,iqq)

c-----------------------------------------------------------------------
c Integrated cut diagram part for calculation of probability distribution
c bh - impact parameter between the pomeron ends;
c iqq = 1   - 1p(cut),
c iqq = 2   - 3p+(scr),
c iqq = 3   - 3p+(dif),
c iqq = 4   - 4p(2*scr),
c iqq = 5   - 3p+(cut),
c iqq = 6   - 4p-(scr),
c iqq = 7   - 3p-(cut),
c iqq = 8   - 4p+(scr),
c iqq = 9   - 3p-(scr),
c iqq = 10  - 4p+(dif+scr)
c iqq = 11  - 3p-(dif),
c iqq = 12  - 4p-(dif+scr),
c iqq = 17  - 3p+-(soft nucl sha),
c iqq = 18  - 3p+-(sh nucl sha)
c-----------------------------------------------------------------------
      include"nexus.inc"
      double precision omIgamint,omXgamint,omYgamint
      
      omGamint=0.d0

      if(iqq.eq.1)then
        omGamint=omIgamint(bh,0)
      elseif(iqq.eq.2)then
        omGamint=omYgamint(bh,2)
      elseif(iqq.eq.3)then
        omGamint=omYgamint(bh,5)
      elseif(iqq.eq.4)then
        omGamint=omXgamint(bh,1)
      elseif(iqq.eq.5)then
        omGamint=omYgamint(bh,1)
      elseif(iqq.eq.6)then
        omGamint=omXgamint(bh,3)
      elseif(iqq.eq.7)then
        omGamint=omYgamint(bh,4)
      elseif(iqq.eq.8)then
        omGamint=omXgamint(bh,2)
      elseif(iqq.eq.9)then
        omGamint=omYgamint(bh,3)
      elseif(iqq.eq.10)then
        omGamint=omXgamint(bh,5)
      elseif(iqq.eq.11)then
        omGamint=omYgamint(bh,6)
      elseif(iqq.eq.12)then
        omGamint=omXgamint(bh,4)
      elseif(iqq.eq.17)then
        omGamint=omIgamint(bh,1)
      elseif(iqq.eq.18)then
        omGamint=omIgamint(bh,2)
      else
        call utstop('Wrong iqq in omGamint&')
      endif
      
      omGamint=2.d0*omGamint

      return
      end





c----------------------------------------------------------------------
      block data dgdata
c----------------------------------------------------------------------
c constants for numerical integration (gaussian weights)
c----------------------------------------------------------------------
      double precision dgx1,dga1
      common /dga20/ dgx1(10),dga1(10)


      data dgx1/
     &   .765265211334973D-01,
     &   .227785851141645D+00,
     &   .373706088715420D+00,
     &   .510867001950827D+00,
     &   .636053680726515D+00,
     &   .746331906460151D+00,
     &   .839116971822219D+00,
     &   .912234428251326D+00,
     &   .963971927277914D+00,
     &   .993128599185095D+00/
      data dga1/
     &   .152753387130726D+00,
     &   .149172986472604D+00,
     &   .142096109318382D+00,
     &   .131688638449177D+00,
     &   .118194531961518D+00,
     &   .101930119817233D+00,
     &   .832767415767047D-01,
     &   .626720483341090D-01,
     &   .406014298003871D-01,
     &   .176140071391506D-01/

      end


c----------------------------------------------------------------------

      double precision function PhiExactij(fj,xp,xm,s,b,iicdp,iicdt)

c----------------------------------------------------------------------
c    Exact expression of the Phi function for pp collision (virtual
c Emissions m=0) 
c----------------------------------------------------------------------
      include 'nexus.incems'
      double precision PhiExactM,xp,xm
      dimension mk(ntymi:ntymx)

      do i=ntymi,ntymx
        mk(i)=0
      enddo

      PhiExactij=PhiExactM(fj,xp,xm,s,b,iicdp,iicdt,mk)

      return
      end

c----------------------------------------------------------------------

      double precision function PhiExactM(fj,xp,xm,s,b,iicdp,iicdt,mk)

c----------------------------------------------------------------------
c    Exact expression of the Phi function for pp collision (virtual
c Emissions) 
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      include 'nexus.incems'
      double precision al(nbpDf0:nbpDf1),gam,betp(nbpDf0:nbpDf1)
     *,z,xIrst,ffacto
      double precision zp(nbpDf0:nbpDf1),Phitmp,betpp(nbpDf0:nbpDf1)
     *,yp,ym,xm,xp
      double precision gamtp,gamtm,gamtpp,gamtmp,utgam2,eps
      parameter(eps=1.d-20)
      dimension ipr(nbpDf0:nbpDf1),imax(nbpDf0:nbpDf1),mk(ntymi:ntymx)
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)

      if(nbpDf0.ne.0.or.nbpDf1.ne.3) stop "Problem in PhiExact"
      PhiExactM=0.d0

      if(xp.gt.eps.and.xm.gt.eps.and.xp.le.1.d0+eps
     &   .and.xm.le.1.d0+eps)then
 
      b2=b*b
      gamb=gamD(1,iclegy,iclpro,icltar,icdp,icdt)
      gamtp=1.d0
     &  +dble(xnup(iclegy,iclpro)-xnu(iclegy,iclpro)+gamb*b2/2.-alppar)
      gamtm=1.d0
     &  +dble(xnup(iclegy,icltar)-xnu(iclegy,icltar)+gamb*b2/2.-alppar)
      gamtpp=2.d0*gamtp
      gamtmp=2.d0*gamtm


      do i=nbpDf0,nbpDf1
        imax(i)=0
        ipr(i)=0
        zp(i)=1.d0
        al(i)=0.d0
        betp(i)=0.d0
        betpp(i)=0.d0
      enddo

      do i=nbpDf0,nbpDf1
        imax(i)=6+max(5,int(alog10(s)))
        if(b.ge.1.5)imax(i)=2+max(3,int(alog10(sqrt(s))))
        if(iicdp+iicdt.eq.3)imax(i)=2*imax(i)
        if(iicdp+iicdt.eq.2)imax(i)=3*imax(i)
      enddo
      imax0=nbpDf1
      if(iscreen.eq.0)then
        imax(2)=0
        imax(3)=0
        imax0=1
      endif

      if(iAGKch.eq.1)imax(1)=30
        
      Phitmp=0.d0
	do i=nbpDf0,imax0
          gam=dble(betD(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *             +gamD(i,iclegy,iclpro,icltar,iicdp,iicdt)*b2)
          betp(i)=dble(betDp(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *             +gamD(i,iclegy,iclpro,icltar,iicdp,iicdt)*b2
     *             -alppar)+1.d0
          betpp(i)=dble(betDpp(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *             +gamD(i,iclegy,iclpro,icltar,iicdp,iicdt)*b2
     *             -alppar)+1.d0
          al(i)=dble(alpD(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *         *exp(-b2/delD(i,iclegy,iclpro,icltar,iicdp,iicdt)))
     *         *dble(s)**gam
     *         *dble(gamdp(iicdp,iclpro)*gamdt(iicdt,icltar))  
     *         *dble(chad(iclpro)*chad(icltar))
	enddo
c      if(xp.eq.1.d0)write(*,*)'R',al,betp,betpp



	do ipr0=0,imax(0)
           ipr(0)=ipr0
           zp(0)=1.d0
         if (ipr(0).ne.0) zp(0)=(-dble(fj)*al(0))**ipr(0)/ffacto(ipr(0))
	 do ipr1=0,imax(1)
            ipr(1)=ipr1
            zp(1)=1.d0
         if (ipr(1).ne.0) zp(1)=(-dble(fj)*al(1))**ipr(1)/ffacto(ipr(1))
           do ipr2=0,imax(2)
              ipr(2)=ipr2
              zp(2)=1.d0
         if (ipr(2).ne.0) zp(2)=(-dble(fj)*al(2))**ipr(2)/ffacto(ipr(2))
              do ipr3=0,imax(3)
                 ipr(3)=ipr3
                 zp(3)=1.d0
         if (ipr(3).ne.0) zp(3)=(-dble(fj)*al(3))**ipr(3)/ffacto(ipr(3))
           yp=0.d0
           ym=0.d0
           z=1.d0
           do i=nbpDf0,nbpDf1             
             yp=yp+dble(ipr(i))*betp(i)
             ym=ym+dble(ipr(i))*betpp(i)
             z=z*zp(i)
           enddo
           yp=yp+dble(mk(2)+mk(8)+mk(4)+mk(12)+mk(13))*gamtp
     &          +dble(mk(9)+mk(10))*gamtpp
           ym=ym+dble(mk(3)+mk(6)+mk(4)+mk(10)+mk(14))*gamtm
     &          +dble(mk(11)+mk(12))*gamtmp
           
           if(iAGKch.eq.0)then
             z=z*xIrst(1,xp,yp,betp,ipr)
             z=z*xIrst(2,xm,ym,betpp,ipr)
           else      ! Theoric check for AGK
             z=z*xp*(dlog(dble(100.*s))-1.d0)**ipr(1)
             z=z*xm*(dlog(dble(100.*s))-1.d0)**ipr(1)
           endif
           Phitmp=Phitmp+z
c           if(xp.eq.1.d0)write(*,*)Phitmp,z,yp,ym,ipr
c           write(*,*)Phitmp,z,yp,ym,ipr,xp,xm,betp,betpp

            enddo
           enddo
          enddo
         enddo

	
         Phitmp=Phitmp*facto(mk(1))
         if(mk(2).ne.0)Phitmp=Phitmp
     *         *(utgam2(gamtp))**mk(2)*facto(mk(2))
         if(mk(3).ne.0)Phitmp=Phitmp
     *         *(utgam2(gamtm))**mk(3)*facto(mk(3))
         if(mk(4).ne.0)Phitmp=Phitmp
     *         *(utgam2(gamtp)*utgam2(gamtm))**mk(4)*facto(mk(4))
         Phitmp=Phitmp*facto(mk(5))
         if(mk(6).ne.0)Phitmp=Phitmp
     *         *(utgam2(gamtm))**mk(6)*facto(mk(6))
         Phitmp=Phitmp*facto(mk(7))
         if(mk(8).ne.0)Phitmp=Phitmp
     *         *(utgam2(gamtp))**mk(8)*facto(mk(8))
         if(mk(9).ne.0)Phitmp=Phitmp
     *         *(utgam2(gamtpp))**mk(9)*facto(mk(9))
         if(mk(10).ne.0)Phitmp=Phitmp
     *         *(utgam2(gamtpp)*utgam2(gamtm))**mk(10)*facto(mk(10))
         if(mk(11).ne.0)Phitmp=Phitmp
     *         *(utgam2(gamtmp))**mk(11)*facto(mk(11))
         if(mk(12).ne.0)Phitmp=Phitmp
     *         *(utgam2(gamtmp)*utgam2(gamtp))**mk(12)*facto(mk(12))
         if(mk(13).ne.0)Phitmp=Phitmp
     *         *(utgam2(gamtp))**mk(13)*facto(mk(13))
         if(mk(14).ne.0)Phitmp=Phitmp
     *         *(utgam2(gamtm))**mk(14)*facto(mk(14))
         Phitmp=Phitmp*facto(mk(15))
         Phitmp=Phitmp*facto(mk(16))
         Phitmp=Phitmp*facto(mk(17))
         Phitmp=Phitmp*facto(mk(18))
         if(ntymi.eq.0)Phitmp=Phitmp*facto(mk(ntymi))

      endif

      PhiExactM=Phitmp


      return
      end


c----------------------------------------------------------------------

      double precision function PhiExact(fj,xp,xm,s,b)

c----------------------------------------------------------------------
c   Sum over all 4 diffractive contributions of PhiExact
c----------------------------------------------------------------------
      include "nexus.inc"
      include "nexus.incsem"
      double precision xp,xm,PhiExactij


      PhiExact=0.d0

      do iicdp=icdp1,icdp2
      do iicdt=icdt1,icdt2

       PhiExact=PhiExact+PhiExactij(fj,xp,xm,s,b,iicdp,iicdt)
     &                  *dble(ccproj(iicdp,iclpro)*cctarg(iicdt,icltar))

       enddo
       enddo

       return
       end


c----------------------------------------------------------------------

      double precision function PhiExpoij(fj,xp,xm,s,b,iicdp,iicdt)

c----------------------------------------------------------------------
c    Exact expression of the Phi function for pp collision (virtual
c Emissions m=0) 
c----------------------------------------------------------------------
      include 'nexus.incems'
      include 'nexus.inc'
      double precision PhiExpoM,xp,xm
      dimension mk(ntymi:ntymx)

      do i=ntymi,ntymx
        mk(i)=0
      enddo

      PhiExpoij=PhiExpoM(fj,xp,xm,s,b,iicdp,iicdt,mk)

      return
      end

c----------------------------------------------------------------------

      double precision function PhiExpoMk(k,fj,xp,xm,s,mk)

c----------------------------------------------------------------------
c    Exponentiel expression of the Phi function for pp collision 
c (virtual Emissions) (warning : facto(n)=1/n!)
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      include 'nexus.incems'

      double precision Di1(nbpDf0:nbpDf1),Gt(nbpDf0:nbpDf1)
     &                 ,Di2(nbpDf0:nbpDf1,nbpDf0:nbpDf1)
      double precision xp,xm,Phitmp,Gt1,Gt2,PhiExpoM
      double precision gamtp,gamtm,gamtpp,gamtmp,eps
      parameter(eps=1.d-20)
      dimension mk(ntymi:ntymx)
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)
      common /kfitd/ xkappafit(nclegy,nclha,nclha,2,2,20),bkbin
      common/cgtilde/atilde(ntymi:ntymx,kollmx)
     &,btildep(ntymi:ntymx,kollmx),btildepp(ntymi:ntymx,kollmx)
     &              ,atildg(nbpDf0:nbpDf1,kollmx)
     &,btildgp(nbpDf0:nbpDf1,kollmx),btildgpp(nbpDf0:nbpDf1,kollmx)
      double precision atilde,btildep,btildepp,atildg,btildgp,btildgpp
      common /coefgam/coefgamtp(kllmxg),coefgamtm(kllmxg)
     &,coefgamtpp(kllmxg),coefgamtmp(kllmxg)
     &,coefMgamtp(kllmxg,0:npmxg,0:npmxg)
     &,coefMgamtm(kllmxg,0:npmxg,0:npmxg)
     &,coefMgambetp(kllmxg,nbpDf0:nbpDf1,0:npmxg,0:npmxg)
     &,coefMgambetpp(kllmxg,nbpDf0:nbpDf1,0:npmxg,0:npmxg)
     &,coefMgambet2p(kllmxg,nbpDf0:nbpDf1,nbpDf0:nbpDf1,0:npmxg,0:npmxg)
     &,coefMgambet2pp(kllmxg,nbpDf0:nbpDf1,nbpDf0:nbpDf1,0:npmxg
     &,0:npmxg)
      double precision coefgamtp,coefgamtm,coefgamtpp,coefgamtmp
     &,coefMgamtp,coefMgamtm,coefMgambetp
     &,coefMgambetpp,coefMgambet2p,coefMgambet2pp

      if(ntymx.ne.18) stop "Check PhiExpoMk !"

      PhiExpoMk=0.d0
      Phitmp=0.d0
      if(xp.gt.eps.and.xm.gt.eps.and.xp.le.1.d0+eps
     &   .and.xm.le.1.d0+eps)then

      fi=fj*real(trieff(k))

      m1p=mk(2)+mk(8)+mk(4)+mk(12)+mk(13)
      m2p=mk(9)+mk(10)
      m1m=mk(3)+mk(6)+mk(4)+mk(10)+mk(14)
      m2m=mk(11)+mk(12)

      npmax=npmxg
      if(s.le.1.E4.and.npmxg.ge.5)npmax=5
      if(s.le.1.E6.and.npmxg.ge.10)npmax=10
      if(s.le.1.E8.and.npmxg.ge.15)npmax=15
c      if(koll.eq.1)npmax=4


      if(m1p.gt.npmax.or.m2p.gt.(npmax-m1p).or.m1m.gt.npmax
     &  .or.m2m.gt.(npmax-m1m).or.koll.gt.kllmxg.or.koll.le.klllim)then
c     &  .or.iclegy.eq.iclegy2)then
        PhiExpoMk=PhiExpoM(fi,xp,xm,s,bk(k),icdp,icdt,mk)
     &     /xp**dble(alplea(iclpro))
     &     /xm**dble(alplea(icltar))
        return
      endif
      gamb=gamD(1,iclegy,iclpro,icltar,icdp,icdt)*bk(k)*bk(k)
      gamtp=1.d0
     &  +dble(xnup(iclegy,iclpro)-xnu(iclegy,iclpro)+gamb/2.-alppar)
      gamtm=1.d0
     &  +dble(xnup(iclegy,icltar)-xnu(iclegy,icltar)+gamb/2.-alppar)
      gamtpp=2.d0*gamtp
      gamtmp=2.d0*gamtm
        
      imax=nbpDf1
      if(iscreen.eq.0)imax=1


      Phitmp=0.d0
	Gt1=0.d0
        if(iAGKch.eq.1)then
          Gt1=atildg(1,k)
        else
	do i=nbpDf0,imax
          Di1(i)=coefMgamtp(k,m1p,m2p)*coefMgamtm(k,m1m,m2m)
     *          /coefMgambetp(k,i,m1p,m2p)/coefMgambetpp(k,i,m1m,m2m)
          Gt(i)=dble(fi)*atildg(i,k)*xp**btildgp(i,k)*xm**btildgpp(i,k)
     *          /coefMgamtp(k,0,0)/coefMgamtm(k,0,0)
     *          *coefMgambetp(k,i,0,0)*coefMgambetpp(k,i,0,0)
     *          *dble(gamdp(icdp,iclpro)*gamdt(icdt,icltar))
           Gt1=Gt1+Gt(i)*Di1(i)
	enddo
        endif

c        imax=-1
        if(koll.gt.1)imax=-1          !important, do not change this !

        if(iAGKch.eq.1)imax=-1

	Gt2=0.d0
        do i=nbpDf0,imax
          do j=nbpDf0,imax
            Di2(i,j)=Di1(i)*Di1(j)-
     *            coefMgamtp(k,m1p,m2p)/coefMgambet2p(k,i,j,m1p,m2p)
     *           *coefMgamtm(k,m1m,m2m)/coefMgambet2pp(k,i,j,m1m,m2m)
            Gt2=Gt2+Di2(i,j)*Gt(i)*Gt(j)
          enddo
        enddo



        Phitmp=(xp**gamtp*coefgamtp(k))**dble(m1p)
     *        *(xp**gamtpp*coefgamtpp(k))**dble(m2p)
     *        *(xm**gamtm*coefgamtm(k))**dble(m1m)
     *        *(xm**gamtmp*coefgamtmp(k))**dble(m2m)
     *           *coefMgamtp(k,0,0)/coefMgamtp(k,m1p,m2p)
     *           *coefMgamtm(k,0,0)/coefMgamtm(k,m1m,m2m)
     *        *dexp(-(Gt1+Gt2*0.5d0))

        do i=ntymi,ntymx
          Phitmp=Phitmp*facto(mk(i))
        enddo

      endif
       PhiExpoMk=Phitmp
      
      return
      end

c----------------------------------------------------------------------

      double precision function PhiExpoM(fj,xp,xm,s,b,iicdp,iicdt,mk)

c----------------------------------------------------------------------
c    Exponentiel expression of the Phi function for pp collision 
c (virtual Emissions)  (warning : facto(n)=1/n!)
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      include 'nexus.incems'

      double precision al,gam,AlTi
      double precision BeTip(nbpDf0:nbpDf1),BeTipp(nbpDf0:nbpDf1)
     *,Di1(nbpDf0:nbpDf1),Di2(nbpDf0:nbpDf1,nbpDf0:nbpDf1)
     *,Di3(nbpDf0:nbpDf1,nbpDf0:nbpDf1,nbpDf0:nbpDf1),Gt(nbpDf0:nbpDf1)
     *,Di4(nbpDf0:nbpDf1,nbpDf0:nbpDf1,nbpDf0:nbpDf1,nbpDf0:nbpDf1)!,Di5
      double precision xp,xm,Phitmp,Gt1,Gt2,Gt3,Gt4,utgam2!,Gt5
      double precision gamtp,gamtm,gamtpp,gamtmp,Mgamtp,Mgamtm,eps
      parameter(eps=1.d-20)
      dimension mk(ntymi:ntymx)
      common /omgtd/xmu(3),xnu(nclegy,nclha),xnup(nclegy,nclha)
     &              ,xnum(nclegy,nclha)
      common /kfitd/ xkappafit(nclegy,nclha,nclha,2,2,20),bkbin

      if(ntymx.ne.18) stop "Check PhiExpoM"

      PhiExpoM=0.d0
      Phitmp=0.d0
      if(xp.gt.eps.and.xm.gt.eps.and.xp.le.1.d0+eps
     &   .and.xm.le.1.d0+eps)then

      b2=b*b
      gamb=gamD(1,iclegy,iclpro,icltar,icdp,icdt)
      gamtp=1.d0
     &  +dble(xnup(iclegy,iclpro)-xnu(iclegy,iclpro)+gamb*b2/2.-alppar)
      gamtm=1.d0
     &  +dble(xnup(iclegy,icltar)-xnu(iclegy,icltar)+gamb*b2/2.-alppar)
      gamtpp=2.d0*gamtp
      gamtmp=2.d0*gamtm

      Mgamtp=dble(mk(2)+mk(8)+mk(4)+mk(12)+mk(13))*gamtp
     &      +dble(mk(9)+mk(10))*gamtpp
      Mgamtm=dble(mk(3)+mk(6)+mk(4)+mk(10)+mk(14))*gamtm
     &      +dble(mk(11)+mk(12))*gamtmp


      if(xkappafit(iclegy,iclpro,icltar,iicdp,iicdt,1).gt.1.
     *   .and.b.lt.19.*bkbin)then
        ibk=int(b/bkbin)+1
        egy0=egylow*egyfac**real(iclegy)
        xkappa1=xkappafit(iclegy,iclpro,icltar,iicdp,iicdt,ibk)
     *         +(b-bkbin*real(ibk-1))/bkbin
     *           *(xkappafit(iclegy,iclpro,icltar,iicdp,iicdt,ibk+1)
     *            -xkappafit(iclegy,iclpro,icltar,iicdp,iicdt,ibk))
        xkappa2=xkappafit(iclegy+1,iclpro,icltar,iicdp,iicdt,ibk)
     *         +(b-bkbin*real(ibk-1))/bkbin
     *           *(xkappafit(iclegy+1,iclpro,icltar,iicdp,iicdt,ibk+1)
     *            -xkappafit(iclegy+1,iclpro,icltar,iicdp,iicdt,ibk))
        xkappa=xkappa1+(xkappa2-xkappa1)/(egy0*(egyfac-1.))
     *          *(sqrt(s)-egy0)
        else
          xkappa=1.
      endif

c          xkappa=1.2*xkappa

c      write(*,*)"Mgam+/-",Mgamtp,Mgamtm
c     *       ,xkappafit(iclegy,iclpro,icltar,iicdp,iicdt,ibk),ibk
        
      imax=nbpDf1
      if(iscreen.eq.0)imax=1


      Phitmp=0.d0
	Gt1=0.d0
	do i=nbpDf0,imax
          gam=dble(betD(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *             +gamD(i,iclegy,iclpro,icltar,iicdp,iicdt)*b2)
          BeTip(i)=dble(betDp(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *             +gamD(i,iclegy,iclpro,icltar,iicdp,iicdt)*b2
     *             -alppar)+1.d0
          BeTipp(i)=dble(betDpp(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *             +gamD(i,iclegy,iclpro,icltar,iicdp,iicdt)*b2
     *             -alppar)+1.d0
          al=dble(alpD(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *            *exp(-b2/delD(i,iclegy,iclpro,icltar,iicdp,iicdt)))
     *            *dble(s)**gam

          if(iAGKch.eq.1)then
            Gt1=al*(dlog(dble(100.*s))-1.d0)**2.d0
c            write(*,*)dexp(-Gt1),Gt1
          else
          Di1(i)=utgam2(1.d0+dble(alplea(iclpro))+Mgamtp)
     *          *utgam2(1.d0+dble(alplea(icltar))+Mgamtm)
     *        /utgam2(1.d0+dble(alplea(iclpro))+BeTip(i)+Mgamtp)
     *       /utgam2(1.d0+dble(alplea(icltar))+BeTipp(i)+Mgamtm)
          AlTi=al*utgam2(BeTip(i))*utgam2(BeTipp(i))
          Gt(i)=AlTi*xp**BeTip(i)*xm**BeTipp(i)
     *              *dble(xkappa*xkappa)
     *              *dble(fj*chad(iclpro)*chad(icltar))
     *              *dble(gamdp(iicdp,iclpro)*gamdt(iicdt,icltar))  
          Gt1=Gt1+Gt(i)*Di1(i)
          endif
	enddo

c        imax=-1

        if(koll.gt.1)imax=-1          !important, do not change this !
        if(iAGKch.eq.1)imax=-1

	Gt2=0.d0
        do i=nbpDf0,imax
          do j=nbpDf0,imax
            Di2(i,j)=Di1(i)*Di1(j)-
     *           (utgam2(1.d0+dble(alplea(iclpro))+Mgamtp)
     *           *utgam2(1.d0+dble(alplea(icltar))+Mgamtm)
     */utgam2(1.d0+dble(alplea(iclpro))+BeTip(i)+BeTip(j)+Mgamtp)/
     *utgam2(1.d0+dble(alplea(icltar))+BeTipp(i)+BeTipp(j)+Mgamtm))
            Gt2=Gt2+Di2(i,j)*Gt(i)*Gt(j)
          enddo
        enddo

      imax=-1
        if(isetcs.ne.1.and.iclegy.lt.iclegy2)imax=-1


	Gt3=0.d0
        do i=nbpDf0,imax
          do j=nbpDf0,imax
            do k=nbpDf0,imax
              Di3(i,j,k)=Di1(i)*Di2(j,k)+Di1(j)*Di2(k,i)+Di1(k)*Di2(i,j)
     *-Di1(i)*Di1(j)*Di1(k)
     *+(utgam2(1.d0+dble(alplea(iclpro))+Mgamtp)
     * *utgam2(1.d0+dble(alplea(icltar))+Mgamtm)
     * /utgam2(1.d0+dble(alplea(iclpro))+Mgamtp+BeTip(k)+BeTip(i)
     *                                  +BeTip(j))
     * /utgam2(1.d0+dble(alplea(icltar))+Mgamtm+BeTipp(k)+BeTipp(i)
     *                                  +BeTipp(j)))
              Gt3=Gt3+Di3(i,j,k)*Gt(i)*Gt(j)*Gt(k)
            enddo
          enddo
        enddo

      imax=-1
c      if(iscreen.eq.1.and.isetcs.ne.1)imax=-1

	Gt4=0.d0
        do i=nbpDf0,imax
          do j=nbpDf0,imax
            do k=nbpDf0,imax
              do l=nbpDf0,imax
             Di4(i,j,k,l)=Di1(i)*Di3(j,k,l)+Di1(j)*Di3(k,l,i)+Di1(k)
     **Di3(l,i,j)+Di1(l)*Di3(i,j,k)+(Di2(i,j)*Di2(k,l)
     *+Di2(j,k)*Di2(l,i)+Di2(k,l)*Di2(i,j)+Di2(l,i)*Di2(j,k))
     *+Di1(i)*Di1(j)*Di1(k)*Di1(l)-(Di1(i)*Di1(j)*Di2(k,l)
     *+Di1(j)*Di1(k)*Di2(l,i)+Di1(k)*Di1(l)*Di2(i,j)+Di1(l)*Di1(i)
     **Di2(j,k))-(utgam2(1.d0+dble(alplea(iclpro))+Mgamtp)
     * *utgam2(1.d0+dble(alplea(icltar))+Mgamtm)
     * /utgam2(1.d0+dble(alplea(iclpro))+Mgamtp+BeTip(i)+BeTip(j)
     *         +BeTip(k)+BeTip(l))
     * /utgam2(1.d0+dble(alplea(icltar))+Mgamtm+BeTipp(i)+BeTipp(j)
     *         +BeTipp(k)+BeTipp(l)))
                Gt4=Gt4+Di4(i,j,k,l)*Gt(i)*Gt(j)*Gt(k)*Gt(l)
              enddo
            enddo
          enddo
        enddo

c$$$	Gt5=0.d0
c$$$        do i=nbpDf0,imax              !faux : probleme a haute energie 
c$$$          do j=nbpDf0,imax
c$$$            do k=nbpDf0,imax
c$$$              do l=nbpDf0,imax
c$$$                do m=nbpDf0,imax
c$$$                  Di5=0.d0
c$$$     *+(Di1(i)*Di4(j,k,l,m)+Di1(j)*Di4(k,l,m,i)+Di1(k)*Di4(l,m,i,j)
c$$$     *  +Di1(l)*Di4(m,i,j,k)+Di1(m)*Di4(i,j,k,l))
c$$$     *-(Di1(i)*Di2(j,k)*Di2(l,m)+Di1(j)*Di2(k,l)*Di2(m,i)
c$$$     *  +Di1(k)*Di2(l,m)*Di2(i,j)+Di1(l)*Di2(m,i)*Di2(j,k)
c$$$     *  +Di1(m)*Di2(i,j)*Di2(k,l))
c$$$     *-Di1(i)*Di1(j)*Di1(k)*Di1(l)*Di1(m)
c$$$     *+(Di1(i)*Di1(j)*Di1(k)*Di2(l,m)+Di1(j)*Di1(k)*Di1(l)*Di2(m,i)
c$$$     *  +Di1(k)*Di1(l)*Di1(m)*Di2(i,j)+Di1(l)*Di1(m)*Di1(i)*Di2(j,k)
c$$$     *  +Di1(m)*Di1(i)*Di1(j)*Di2(k,l))
c$$$     *-(Di1(i)*Di1(j)*Di3(k,l,m)+Di1(j)*Di1(k)*Di3(l,m,i)
c$$$     *  +Di1(k)*Di1(l)*Di3(m,i,j)+Di1(l)*Di1(m)*Di3(i,j,k)
c$$$     *  +Di1(m)*Di1(i)*Di3(j,k,l))
c$$$     *+(Di2(i,j)*Di3(k,l,m)+Di2(j,k)*Di3(l,m,i)+Di2(k,l)*Di3(m,i,j)
c$$$     * +Di2(l,m)*Di3(i,j,k)+Di2(m,i)*Di3(j,k,l))
c$$$     *+(utgam2(1.d0+dble(alplea(iclpro))+Mgamtp)
c$$$     * *utgam2(1.d0+dble(alplea(icltar))+Mgamtm)
c$$$     * /utgam2(1.d0+dble(alplea(iclpro))+Mgamtp+BeTip(i)+BeTip(j)
c$$$     *         +BeTip(k)+BeTip(l)+BeTip(m))
c$$$     * /utgam2(1.d0+dble(alplea(icltar))+Mgamtm+BeTipp(i)+BeTipp(j)
c$$$     *         +BeTipp(k)+BeTipp(l)+BeTipp(m)))
c$$$                Gt5=Gt5+Di5*Gt(i)*Gt(j)*Gt(k)*Gt(l)*Gt(m)
c$$$                enddo
c$$$              enddo
c$$$            enddo
c$$$          enddo
c$$$        enddo


        Phitmp=xp**dble(alplea(iclpro))*xm**dble(alplea(icltar))
     * *(xp**gamtp*utgam2(gamtp))**dble(mk(2)+mk(8)+mk(4)+mk(12)+mk(13))
     *   *(xp**gamtpp*utgam2(gamtpp))**dble(mk(9)+mk(10))
     * *(xm**gamtm*utgam2(gamtm))**dble(mk(3)+mk(6)+mk(4)+mk(10)+mk(14))
     *  *(xm**gamtmp*utgam2(gamtmp))**dble(mk(11)+mk(12))
     *           *utgam2(1.d0+dble(alplea(iclpro)))
     *           *utgam2(1.d0+dble(alplea(icltar)))
     *           /utgam2(1.d0+dble(alplea(iclpro))+Mgamtp)
     *           /utgam2(1.d0+dble(alplea(icltar))+Mgamtm)
     *        *dexp(-(Gt1+Gt2*0.5d0+Gt3*0.16667d0+Gt4*0.04167d0))!+Gt5/120.d0))

        do i=ntymi,ntymx
          Phitmp=Phitmp*facto(mk(i))
        enddo

      endif
       PhiExpoM=Phitmp
      
      return
      end


c----------------------------------------------------------------------

      double precision function PhiExpo(fj,xp,xm,s,b)

c----------------------------------------------------------------------
c   Sum over all 4 diffractive contributions of PhiExpo
c----------------------------------------------------------------------
      include "nexus.inc"
      include "nexus.incsem"
      double precision xp,xm,PhiExpoij


      PhiExpo=0.d0

      do iicdp=icdp1,icdp2
      do iicdt=icdt1,icdt2

       PhiExpo=PhiExpo+PhiExpoij(fj,xp,xm,s,b,iicdp,iicdt)
     &                *dble(ccproj(iicdp,iclpro)*cctarg(iicdt,icltar))

       enddo
       enddo

       return
       end

c----------------------------------------------------------------------

      double precision function PhiUnitij(xp,xm,s,b,iicdp,iicdt)

c----------------------------------------------------------------------
      include 'nexus.inc'
      double precision xp,xm,PhiExpoij,Znormij
      
      PhiUnitij=PhiExpoij(1.,xp,xm,s,b,iicdp,iicdt)
     &          /Znormij(s,b,iicdp,iicdt)
	      
      return
      end

c----------------------------------------------------------------------

      double precision function PhiUnit(xp,xm,s,b)

c----------------------------------------------------------------------
c   Sum over all 4 diffractive contributions of PhiUnit
c----------------------------------------------------------------------
      include "nexus.inc"
      include "nexus.incsem"
      double precision xp,xm,PhiUnitij


      PhiUnit=0.d0

      do iicdp=icdp1,icdp2
      do iicdt=icdt1,icdt2

       PhiUnit=PhiUnit+PhiUnitij(xp,xm,s,b,iicdp,iicdt)
     &                *dble(ccproj(iicdp,iclpro)*cctarg(iicdt,icltar))

       enddo
       enddo

       return
       end

c----------------------------------------------------------------------

      double precision function PhiTr(k,s)

c----------------------------------------------------------------------
c Virtual contribution of nuclear diagrams
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incems'
      common/cncl2/ diffbpr(mamx,mamx),diffbtg(mamx,mamx)
      double precision om3uncut,G3p

      PhiTr=1.d0
      G3p=0.d0

      ntot=0

      ip=iproj(k)
      it=itarg(k)

! Triplets where the projectile is.


      do lp=1,lproj3(ip)
        
        kp=kproj3(ip,lp)
        itt=itarg(kp)

        do ll=1,lproj3(ip)              ! Y+

          kl=kproj3(ip,ll)
          itl=itarg(kl)
          
          if(itl.ne.itt)then
            ntot=ntot+1
            b1=bk(kp)
            b2=bk(kl)
            b12=diffbtg(itt,itl)
          G3p=G3p+om3uncut(xmt(it),xmt(itl),xpp(ip),s,b1,b2,b12,2)/2.d0
          endif

        enddo

        do ll=1,ltarg3(itt)             !Y-

          kl=ktarg3(itt,ll)
          ipl=iproj(kl)
          
          if(ipl.ne.ip)then
            ntot=ntot+1
            b1=bk(kp)
            b2=bk(kl)
            b12=diffbpr(ip,ipl)
          G3p=G3p+om3uncut(xpp(ip),xpp(ipl),xmt(itt),s,b1,b2,b12,1)
          endif

        enddo

      enddo

! Triplets where the target is.

      do lt=1,ltarg3(it)
        
        kt=ktarg3(it,lt)
        ipp=iproj(kt)

        if(kt.ne.k)then    ! not to double counting triplet with pair k

          do ll=1,ltarg3(it)        ! Y+

            kl=ktarg3(it,ll)
            ipl=iproj(kl)
          
            if(ipl.ne.ipp)then
              ntot=ntot+1
              b1=bk(kt)
              b2=bk(kl)
              b12=diffbpr(ipp,ipl)
          G3p=G3p+om3uncut(xpp(ipp),xpp(ipl),xmt(it),s,b1,b2,b12,1)/2.d0
            endif

          enddo

          do ll=1,lproj3(ipp)

            kl=kproj3(ipp,ll)
            itl=itarg(kl)
            
            if(itl.ne.it)then
              ntot=ntot+1
              b1=bk(kt)
              b2=bk(kl)
              b12=diffbtg(it,itl)
          G3p=G3p+om3uncut(xmt(it),xmt(itl),xpp(ipp),s,b1,b2,b12,2)
            endif

          enddo

        endif

      enddo

      Phitr=dexp(-G3p)

      if(ntot.ge.1000)write(ifmt,*) 'Phitr',Phitr,k,G3p,ntot


      return
      end

c----------------------------------------------------------------------

      double precision function Hrstij(fj,xp,xm,s,b,iicdp,iicdt)

c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incems'
      include 'nexus.incsem'
      double precision al(nbpDf0:nbpDf1),gam,betp(nbpDf0:nbpDf1)
     *,z,xJrst,ffacto
      double precision zp(nbpDf0:nbpDf1),Htmp,betpp(nbpDf0:nbpDf1)
     *,yp,ym,xp,xm
      dimension ipr(nbpDf0:nbpDf1),imax(nbpDf0:nbpDf1)
  
      if(nbpDf0.ne.0.or.nbpDf1.ne.3) stop "Problem in Hrst"
      Hrstij=0.d0

      do i=nbpDf0,nbpDf1
        imax(i)=0
        ipr(i)=0
        zp(i)=1.d0
        al(i)=0.d0
      enddo


      if(xp.ge.0.d0.and.xm.ge.0.d0.and.xp.lt.1.d0.and.xm.le.1.d0)then
		
        
      do i=nbpDf0,nbpDf1
        imax(i)=0+max(5,int(alog10(s)))
        if(b.ge.1.5)imax(i)=max(3,int(alog10(sqrt(s))))
        if(iicdp+iicdt.eq.3)imax(i)=2*imax(i)
        if(iicdp+iicdt.eq.2)imax(i)=3*imax(i)
      enddo
      imax0=nbpDf1
      if(iscreen.eq.0)then
        imax(2)=0
        imax(3)=0
        imax0=1
      endif

      Htmp=0.d0
	do i=nbpDf0,imax0
          gam=dble(betD(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *             +gamD(i,iclegy,iclpro,icltar,iicdp,iicdt)*b**2)
          betp(i)=dble(betDp(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *            +gamD(i,iclegy,iclpro,icltar,iicdp,iicdt)*b**2
     *            -alppar)+1.d0
          betpp(i)=dble(betDpp(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *            +gamD(i,iclegy,iclpro,icltar,iicdp,iicdt)*b**2
     *            -alppar)+1.d0
          al(i)=dble(alpD(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *          *exp(-b**2/delD(i,iclegy,iclpro,icltar,iicdp,iicdt)))
     *          *dble(s)**gam
     *          *dble(gamdp(iicdp,iclpro)*gamdt(iicdt,icltar))  
     *          *dble(chad(iclpro)*chad(icltar))
	enddo
c      if(xp.ge..99d0)write(*,*)'H',al,betp,betpp,iicdp,iicdt

	do ipr0=0,imax(0)
           ipr(0)=ipr0
           zp(0)=1.d0
          if (ipr(0).ne.0) zp(0)=(dble(fj)*al(0))**ipr(0)/ffacto(ipr(0))
	 do ipr1=0,imax(1)
            ipr(1)=ipr1
            zp(1)=1.d0
          if (ipr(1).ne.0) zp(1)=(dble(fj)*al(1))**ipr(1)/ffacto(ipr(1))
           do ipr2=0,imax(2)
              ipr(2)=ipr2
              zp(2)=1.d0
          if (ipr(2).ne.0) zp(2)=(dble(fj)*al(2))**ipr(2)/ffacto(ipr(2))
              do ipr3=0,imax(3)
                 ipr(3)=ipr3
                 zp(3)=1.d0
          if (ipr(3).ne.0) zp(3)=(dble(fj)*al(3))**ipr(3)/ffacto(ipr(3))
           if (ipr(0)+ipr(1)+ipr(2)+ipr(3).ne.0) then
             yp=0.d0
             ym=0.d0
             z=1.d0
             do i=nbpDf0,nbpDf1             
               yp=yp+dble(ipr(i))*betp(i)
               ym=ym+dble(ipr(i))*betpp(i)
               z=z*zp(i)
             enddo
             z=z*xJrst(xp,yp,betp,ipr)
             z=z*xJrst(xm,ym,betpp,ipr)
             Htmp=Htmp+z
           endif
            enddo
           enddo
          enddo
         enddo
	
      endif

      Hrstij=Htmp
	      
      return
      end


c----------------------------------------------------------------------

      double precision function Hrst(fj,xp,xm,s,b)

c----------------------------------------------------------------------
c   Sum over all 4 diffractive contributions of Hrst
c----------------------------------------------------------------------
      include "nexus.inc"
      include "nexus.incsem"
      double precision xp,xm,Hrstij


      Hrst=0.d0

      do iicdp=icdp1,icdp2
      do iicdt=icdt1,icdt2

       Hrst=Hrst+Hrstij(fj,xp,xm,s,b,iicdp,iicdt)
     &          *dble(ccproj(iicdp,iclpro)*cctarg(iicdt,icltar))

       enddo
       enddo

       return
       end

c----------------------------------------------------------------------

      double precision function HrstIij(fj,xp,xm,s,b,iicdp,iicdt)

c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incems'
      include 'nexus.incsem'
      double precision al(nbpDf0:nbpDf1),gam,betp(nbpDf0:nbpDf1)
     *,z,xJrstI,ffacto
      double precision zp(nbpDf0:nbpDf1),Htmp,betpp(nbpDf0:nbpDf1)
     *,yp,ym,xp,xm
      dimension ipr(nbpDf0:nbpDf1),imax(nbpDf0:nbpDf1)

      if(nbpDf0.ne.0.or.nbpDf1.ne.3) stop "Problem in HrstIij"
      HrstIij=0.d0

      do i=nbpDf0,nbpDf1
        imax(i)=0
        ipr(i)=0
        zp(i)=1.d0
        al(i)=0.d0
      enddo

      if(xp.ge.0.d0.and.xm.ge.0.d0.and.xp.lt.1.d0.and.xm.lt.1.d0)then
		
      HrstIij=0.d0
        
      do i=nbpDf0,nbpDf1
        imax(i)=0+max(5,int(alog10(s)))
        if(b.ge.1.5)imax(i)=max(3,int(alog10(sqrt(s))))
        if(iicdp+iicdt.eq.3)imax(i)=2*imax(i)
        if(iicdp+iicdt.eq.2)imax(i)=3*imax(i)
      enddo
      imax0=nbpDf1
      if(iscreen.eq.0)then
        imax(2)=0
        imax(3)=0
        imax0=1
      endif

      Htmp=0.d0
	do i=nbpDf0,imax0
          gam=dble(betD(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *             +gamD(i,iclegy,iclpro,icltar,iicdp,iicdt)*b**2)
          betp(i)=dble(betDp(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *             +gamD(i,iclegy,iclpro,icltar,iicdp,iicdt)*b**2
     *             -alppar)+1.d0
          betpp(i)=dble(betDpp(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *             +gamD(i,iclegy,iclpro,icltar,iicdp,iicdt)*b**2
     *             -alppar)+1.d0
          al(i)=dble(alpD(i,iclegy,iclpro,icltar,iicdp,iicdt)
     *          *exp(-b**2/delD(i,iclegy,iclpro,icltar,icdp,icdt)))
     *          *dble(s)**gam
     *          *dble(gamdp(iicdp,iclpro)*gamdt(iicdt,icltar))  
     *          *dble(chad(iclpro)*chad(icltar))
	enddo
	
	do ipr0=0,imax(0)
           ipr(0)=ipr0
           zp(0)=1.d0
          if (ipr(0).ne.0) zp(0)=(dble(fj)*al(0))**ipr(0)/ffacto(ipr(0))
	 do ipr1=0,imax(1)
            ipr(1)=ipr1
            zp(1)=1.d0
          if (ipr(1).ne.0) zp(1)=(dble(fj)*al(1))**ipr(1)/ffacto(ipr(1))
           do ipr2=0,imax(2)
              ipr(2)=ipr2
              zp(2)=1.d0
          if (ipr(2).ne.0) zp(2)=(dble(fj)*al(2))**ipr(2)/ffacto(ipr(2))
              do ipr3=0,imax(3)
                 ipr(3)=ipr3
                 zp(3)=1.d0
          if (ipr(3).ne.0) zp(3)=(dble(fj)*al(3))**ipr(3)/ffacto(ipr(3))
           if (ipr(0)+ipr(1)+ipr(2)+ipr(3).ne.0) then
             yp=0.d0
             ym=0.d0
             z=1.d0
             do i=nbpDf0,nbpDf1             
               yp=yp+dble(ipr(i))*betp(i)
               ym=ym+dble(ipr(i))*betpp(i)
               z=z*zp(i)
             enddo
             z=z*xJrstI(xp,yp,betp,ipr)
             z=z*xJrstI(xm,ym,betpp,ipr)
             Htmp=Htmp+z
           endif
            enddo
           enddo
          enddo
         enddo
	
       HrstIij=Htmp

      endif
	      
      return
      end

c----------------------------------------------------------------------

      double precision function HrstI(fj,xp,xm,s,b)

c----------------------------------------------------------------------
c   Sum over all 4 diffractive contributions of HrstI
c----------------------------------------------------------------------
      include "nexus.inc"
      include "nexus.incsem"
      double precision xp,xm,HrstIij


      HrstI=0.d0

      do iicdp=icdp1,icdp2
      do iicdt=icdt1,icdt2

       HrstI=HrstI+HrstIij(fj,xp,xm,s,b,iicdp,iicdt)
     &          *dble(ccproj(iicdp,iclpro)*cctarg(iicdt,icltar))

       enddo
       enddo

       return
       end

c----------------------------------------------------------------------

	double precision function ffacto(n)
	
c----------------------------------------------------------------------
        
        ffacto=1.D0
        do i=1,n
          ffacto=ffacto*dble(i)
        enddo
        return
	end
      
      
c----------------------------------------------------------------------

      double precision function xIrst(id,x,y,bet,ipr)
	
c----------------------------------------------------------------------
      include 'nexus.inc'
      double precision y,gammag,utgam2,x,bet(nbpDf0:nbpDf1)
      dimension ipr(nbpDf0:nbpDf1)


      if(id.eq.1)iclrem=iclpro
      if(id.eq.2)iclrem=icltar
      imax=nbpDf1
      if(iscreen.eq.0)imax=1
      
      xIrst=gammag(iclrem,y)*x**dble(alplea(iclrem)) 
      if(xIrst.gt.0.d0)then
        do i=nbpDf0,imax
          if(ipr(i).ne.0.and.bet(i).gt.1.d-10)   
     &         xIrst=xIrst*utgam2(bet(i))**dble(ipr(i))
        enddo
        if (dabs(y).gt.1.d-10) xIrst=xIrst*x**y
      endif
      return
      end


c----------------------------------------------------------------------

      double precision function xJrst(x,y,bet,ipr)
	
c----------------------------------------------------------------------
      include 'nexus.inc'
      double precision y,utgam2,x,bet(nbpDf0:nbpDf1),eps,gam
      dimension ipr(nbpDf0:nbpDf1)
      
      eps=1.d-10
      imax=nbpDf1
      if(iscreen.eq.0)imax=1

      gam=utgam2(y)

      if(gam.lt.1.d99)then
	
      if ((x-1.d0).gt.eps.or.(y-1.d0).gt.eps) then
	                xJrst=(1.d0-x)**(y-1.d0)/gam
                        do i=nbpDf0,imax
      if (ipr(i).ne.0)   xJrst=xJrst*utgam2(bet(i))**dble(ipr(i))
                        enddo
	  else
c	    write (*,*) 'Warning in xJrst, infinite value !'
	                xJrst=(1.d0-x+eps)**(y-1.d0)/gam
                        do i=nbpDf0,imax
      if (ipr(i).ne.0)   xJrst=xJrst*utgam2(bet(i))**dble(ipr(i))
                        enddo
      endif
      else
        xJrst=0.d0
      endif

      return
      end


c----------------------------------------------------------------------

      double precision function xJrstI(x,y,bet,ipr)
	
c----------------------------------------------------------------------
c Function used for the integration of H*Phi. We do the changement of 
c variable (1-x)=z**alpha. The power alpha can be change if necessary. 
c----------------------------------------------------------------------
      include 'nexus.inc'
      double precision y,utgam2,x,bet(nbpDf0:nbpDf1),alpha,w,gam
      dimension ipr(nbpDf0:nbpDf1)
      
      alpha=2.d0
      w=alpha*(y-1.d0)+alpha-1.d0
      imax=nbpDf1
      if(iscreen.eq.0)imax=1

      gam=utgam2(y)

      if(gam.lt.1.d99)then
	
      if (w.ge.0)then
	
	                xJrstI=alpha*x**w/gam
                        do i=nbpDf0,imax
      if (ipr(i).ne.0)   xJrstI=xJrstI*utgam2(bet(i))**dble(ipr(i))
                        enddo
	
         else
	  stop 'Error in xJrstI in nexus-omg, integration not possible'
       endif

      else
        xJrstI=0.d0
      endif

	
      return
      end

c----------------------------------------------------------------------

      double precision function HPhiIntij(s,b,iicdp,iicdt)

c----------------------------------------------------------------------
c  Set integrated over xp and xm (x and y) H(x,y)*Phi(x,y) for a 
c  given b by gauss method
c----------------------------------------------------------------------
      include 'nexus.inc'
      double precision xhm,x,y,yhm,w,Hrstij,eps,PhiExpoij!,PhiExactij
c      double precision zpmax,zpmin,zmmax,zmmin,dzp,dzm,Gst,zp,zm,w1,w2
      common /ar3/  x1(7),a1(7)

      eps=1.d-0

      w=0.d0
      xhm=.5d0*eps
      yhm=.5d0*eps
      do m=1,2
        do i=1,7
          x=xhm+dble((2*m-3)*x1(i))*xhm
          do n=1,2
            do j=1,7
              y=yhm+dble((2*n-3)*x1(j))*yhm
             w=w+dble(a1(i)*a1(j))*Hrstij(1.,x,y,s,b,iicdp,iicdt)
     &          *PhiExpoij(1.,x,y,s,b,iicdp,iicdt)
c     &          *PhiExactij(1.,x,y,s,b,iicdp,iicdt)
	    enddo
          enddo
        enddo
      enddo
      
      HPhiIntij=w*xhm*yhm
	

c$$$        zpmax=dlog(dble(s))
c$$$        zpmin=dlog(eps)
c$$$        zmmax=dlog(dble(s))
c$$$        zmmin=dlog(eps)
c$$$
c$$$        w1=0.d0
c$$$        dzp=(zpmax-zpmin)/2.d0
c$$$        dzm=(zmmax-zmmin)/2.d0
c$$$
c$$$      do n=1,2
c$$$        do j=1,7
c$$$          zp=zpmin+dzp*(1.d0+dble(2.*n-3.)*dble(x1(j)))
c$$$          w2=0.d0
c$$$          do m=1,2
c$$$            do i=1,7
c$$$              zm=zmmin+dzm*(1.d0+dble(2.*m-3.)*dble(x1(i)))
c$$$              x=dexp(-zp)
c$$$              y=dexp(-zm)
c$$$              Gst=Hrst(1.,x,y,s,b,iicdp,iicdt)
c$$$     &           *PhiExpoij(1.,x,y,s,b,iicdp,iicdt)
c$$$           w2=w2+dble(a1(i))*Gst*dexp(-zm)
c$$$            enddo
c$$$          enddo
c$$$          w1=w1+w2*dble(a1(j))*dexp(-zp)
c$$$        enddo
c$$$      enddo
c$$$      HPhiIntij=HPhiIntij+dzp*dzm*w1
c$$$


      return 
      end


c----------------------------------------------------------------------

      double precision function HPhiInt(s,b)

c----------------------------------------------------------------------
c   Sum over all 4 diffractive contributions of HPhiInt
c----------------------------------------------------------------------
      include "nexus.inc"
      include "nexus.incsem"
      double precision HPhiIntij


      HPhiInt=0.d0

      do iicdp=icdp1,icdp2
      do iicdt=icdt1,icdt2

       HPhiInt=HPhiInt+HPhiIntij(s,b,iicdp,iicdt)
     &                *dble(ccproj(iicdp,iclpro)*cctarg(iicdt,icltar))

       enddo
       enddo

       return
       end

c----------------------------------------------------------------------

      subroutine Kfit(iiclegy)

c----------------------------------------------------------------------
      include "nexus.inc"
      include "nexus.incsem"
      double precision Znormij
      common /kfitd/ xkappafit(nclegy,nclha,nclha,2,2,20),bkbin
      parameter (eps=1.e-3,nmax=30)

      if(iiclegy.eq.-1.or.iiclegy.eq.iclegy2)then
        do iiicdp=1,2
        do iiicdt=1,2
        do iiiegy=1,nclegy
        do iiipro=1,nclha
        do iiitar=1,nclha
        do iiibk=1,20
          xkappafit(iiiegy,iiipro,iiitar,iiicdp,iiicdt,iiibk)=1.
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo

      else

      write(ifmt,*)'Calculation of Kfit with bkbin=',bkbin
      
      iicdp=icdp
      iicdt=icdt
      s=(egylow*egyfac**real(iiclegy))**2.

      b=0.
      xkf=xkappafit(iiclegy+1,iclpro,icltar,iicdp,iicdt,1)
      delta=0.
        

      write(*,*)'i,i+1,k',iclegy2,iiclegy,xkf

      ib=0
 5    continue
      ib=ib+1
      b=real(ib-1)*bkbin
      xkappafit(iiclegy,iclpro,icltar,iicdp,iicdt,ib)=xkf

      delta=1.-real(Znormij(s,b,iicdp,iicdt))
      write(ifmt,*)"Kfit",ib,0,delta,xkf,s,b,iiclegy,iicdp,iicdt
     *     ,iclpro,icltar
      if(abs(delta).lt.eps.and.ib.le.19)then
        xkfs=xkf-delta
        xkf=1.
        deltas=delta
        goto 5
      elseif(ib.le.19)then


        if(delta.gt.0.d0)then
          xkf0=1.
          xkf1=xkf
          delta0=delta
          xkappafit(iiclegy,iclpro,icltar,iicdp,iicdt,ib)=xkf-delta0
          delta1=1.-real(Znormij(s,b,iicdp,iicdt))
          if(delta1.lt.0.d0)then
            xkf1=xkf
            xkf=xkf-delta0
            delta=delta1
          endif
        else
          xkf0=xkf
          xkf1=1.-delta
        endif

        if(ib.eq.1)then
          deltas=delta
          xkfs=1.-delta
        endif

        if(abs(delta).ge.abs(deltas))xkf=xkfs

        n=0
 10     continue
        n=n+1
        if(n.le.nmax.and.xkf1.ne.xkf0)then
          if(n.ne.1.or.abs(delta).ge.abs(deltas))then
            xkappafit(iiclegy,iclpro,icltar,iicdp,iicdt,ib)=xkf
            delta=1.-real(Znormij(s,b,iicdp,iicdt))
          endif
          write(ifmt,*)"Kfit",ib,n,delta,xkf
          if(delta.gt.eps)then
            xkf1=xkf
            xkf=(xkf1+xkf0)/2.
            goto 10
          elseif(delta.lt.-eps)then
            xkf0=xkf
            xkf=(xkf1+xkf0)/2.
            goto 10
          endif
        else
          write(ifmt,*)"Warning in Kfit, nmax reached : xkappafit=1."
          xkappafit(iiclegy,iclpro,icltar,iicdp,iicdt,ib)=xkf
        endif
        goto 5
      endif
      
      if(xkf.gt.1.+eps)write(ifmt,*)
     *     "Warning in Kfit, xkappafit not yet 1"
      xkappafit(iiclegy,iclpro,icltar,iicdp,iicdt,20)=1.

      endif

      return
      end

c----------------------------------------------------------------------

      double precision function Znormij(s,b,iicdp,iicdt)

c----------------------------------------------------------------------
      include 'nexus.inc'
      double precision HPhiIntij,PhiExpoij!,PhiExactij
      
      Znormij=1.d0
      if(iAGKch.ne.1)then
      Znormij=HPhiIntij(s,b,iicdp,iicdt)
     &       +PhiExpoij(1.,1.d0,1.d0,s,b,iicdp,iicdt)
c     &       +PhiExactij(1.,1.d0,1.d0,s,b,iicdp,iicdt)
      endif

      return
      end

c----------------------------------------------------------------------

      double precision function Znorm(s,b)

c----------------------------------------------------------------------
c   Sum over all 4 diffractive contributions of Znorm
c----------------------------------------------------------------------
      include "nexus.inc"
      include "nexus.incsem"
      double precision Znormij


      Znorm=0.d0

      do iicdp=icdp1,icdp2
      do iicdt=icdt1,icdt2

       Znorm=Znorm+Znormij(s,b,iicdp,iicdt)
     &            *dble(ccproj(iicdp,iclpro)*cctarg(iicdt,icltar))

       enddo
       enddo

       return
       end

c----------------------------------------------------------------------

      double precision function gammag(iclrem,x)
	
c----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      double precision x,utgam2
	
      gammag=utgam2(dble(alplea(iclrem))+1.D0)   
     &       /utgam2(dble(alplea(iclrem))+1.D0+x)  

      return
      end
      

