c-----------------------------------------------------------------------
      subroutine xsigma
c-----------------------------------------------------------------------
c hadron-hadron and hadron-nucleus cross sections calculation
c b - impact parameter squared (in case of hadron-nucleus interaction);
c-----------------------------------------------------------------------
      common /ar3/  x1(7),a1(7)
      include 'nexus.inc'
      include 'nexus.incsem'
      double precision PhiExpoij,om1p,vvv11(2,2),vvv12(2,2),vvv21(2,2)
     *,vvv22(2,2),ww01,ww02,ww11,ww12,ww21,ww22,gz(0:3)
c     *,PhiExact,om1intbc

      icdptmp=icdp
      icdttmp=icdt

      sigcut=0.
      sigtot=0.
      sigela=0.
      sigine=0.
      sigdifr=0.
      sloela=0.
      sigsd=0.


      if(isigma.eq.0)return

      call utpri('xsigma',ish,ishini,4)


      if(isigma.ne.3)then

      rs=r2had(iclpro)+r2had(icltar)+slopom*log(engy**2) 
                      !soft pomeron elastic scattering slope
      rpom=4.*.0389*rs    !???????????????????
      do l=0,3
        gz(l)=0.d0
      enddo
      e1=exp(-1.)

      cpt=chad(iclpro)*chad(icltar)
      do i1=1,7
      do m=1,2
        z=.5+x1(i1)*(m-1.5)
        zv1=exp(-z)
        zv2=(e1*z)
        b1=sqrt(-rpom*log(zv1))
        b2=sqrt(-rpom*log(zv2))

        if(isigma.eq.2)then     !exact
	  do iicdp=icdp1,icdp2
            do iicdt=icdt1,icdt2
             vvv11(iicdp,iicdt)=max(0.d0,PhiExpoij(.5,1.d0,1.d0,engy**2,
     &             b1,iicdp,iicdt))
             vvv12(iicdp,iicdt)=max(0.d0,PhiExpoij(.5,1.d0,1.d0,engy**2,
     &             b2,iicdp,iicdt))
             vvv21(iicdp,iicdt)=max(0.d0,PhiExpoij(1.,1.d0,1.d0,engy**2,
     &             b1,iicdp,iicdt))
             vvv22(iicdp,iicdt)=max(0.d0,PhiExpoij(1.,1.d0,1.d0,engy**2,
     &             b2,iicdp,iicdt))
            enddo
	  enddo
          ww01=0.d0
          ww02=0.d0      
          ww11=0.d0
          ww12=0.d0      
          ww21=0.d0
          ww22=0.d0      
          do iicdp=icdp1,icdp2
            do iicdt=icdt1,icdt2
              ww11=ww11+(1.d0-vvv11(iicdp,iicdt))
     *             *ccproj(iicdp,iclpro)*cctarg(iicdt,icltar)
              ww12=ww12+(1.d0-vvv12(iicdp,iicdt))
     *             *ccproj(iicdp,iclpro)*cctarg(iicdt,icltar)
              ww21=ww21+(1.d0-vvv21(iicdp,iicdt))
     *             *ccproj(iicdp,iclpro)*cctarg(iicdt,icltar)
              ww22=ww22+(1.d0-vvv22(iicdp,iicdt))
     *             *ccproj(iicdp,iclpro)*cctarg(iicdt,icltar)
              ww01=ww01+(1.d0+vvv21(iicdp,iicdt))
     *             *ccproj(iicdp,iclpro)*cctarg(iicdt,icltar)
              ww02=ww02+(1.d0+vvv22(iicdp,iicdt))
     *             *ccproj(iicdp,iclpro)*cctarg(iicdt,icltar)
              do iicdp1=icdp1,icdp2    !?????????????????
                do iicdt1=icdt1,icdt2  !not sure it's work if not icdt=idpt=2
                  ww01=ww01-(vvv11(iicdp,iicdt)
     *                 *ccproj(iicdp,iclpro)*cctarg(iicdt,icltar)
     *                 +vvv11(iicdp1,iicdt1)
     *                 *ccproj(iicdp1,iclpro)*cctarg(iicdt1,icltar))
                  ww02=ww02-(vvv12(iicdp,iicdt)
     *                 *ccproj(iicdp,iclpro)*cctarg(iicdt,icltar)
     *                 +vvv12(iicdp1,iicdt1)
     *                 *ccproj(iicdp1,iclpro)*cctarg(iicdt1,icltar))
                enddo
              enddo
            enddo
          enddo
       
        elseif(isigma.eq.1)then !sergej
	  do icdp=icdp1,icdp2
            do icdt=icdt1,icdt2
              vvv11(icdp,icdt)=om1p(engy**2,1.d0,0.d0,b1,11) 
              vvv12(icdp,icdt)=om1p(engy**2,1.d0,0.d0,b2,11)  
              vvv21(icdp,icdt)=2.d0*om1p(engy**2,1.d0,0.d0,b1,11) 
              vvv22(icdp,icdt)=2.d0*om1p(engy**2,1.d0,0.d0,b2,11)  
            enddo
	  enddo
          ww01=0.d0
          ww02=0.d0      
          ww11=0.d0
          ww12=0.d0      
          ww21=0.d0
          ww22=0.d0      
          do iicdp=icdp1,icdp2
            do iicdt=icdt1,icdt2
              ww11=ww11+(1.d0-vvv11(iicdp,iicdt))
     *             *ccproj(iicdp,iclpro)*cctarg(iicdt,icltar)
              ww12=ww12+(1.d0-vvv12(iicdp,iicdt))
     *             *ccproj(iicdp,iclpro)*cctarg(iicdt,icltar)
              ww21=ww21+(1.d0-vvv21(iicdp,iicdt))
     *             *ccproj(iicdp,iclpro)*cctarg(iicdt,icltar)
              ww22=ww22+(1.d0-vvv22(iicdp,iicdt))
     *             *ccproj(iicdp,iclpro)*cctarg(iicdt,icltar)
              do iicdp1=icdp1,icdp2
                do iicdt1=icdt1,icdt2
                  ww01=ww01+(1.d0-vvv11(iicdp,iicdt))
     *                 *(1.d0-vvv11(iicdp1,iicdt1))
     *                 *ccproj(iicdp,iclpro)*cctarg(iicdt,icltar)
     *                 *ccproj(iicdp1,iclpro)*cctarg(iicdt1,icltar)
                  ww02=ww02+(1.d0-vvv12(iicdp,iicdt))
     *                 *(1.d0-vvv12(iicdp1,iicdt1))
     *                 *ccproj(iicdp,iclpro)*cctarg(iicdt,icltar)
     *                 *ccproj(iicdp1,iclpro)*cctarg(iicdt1,icltar)
                enddo
              enddo
            enddo
          enddo
        else
          stop'wrong isigma in xsigma' 
        endif
         
c	write (*,*)'engy,z,ww',engy,z,ww11,ww12,ww21,ww22
c--------------------------------

        gz(0)=gz(0)+a1(i1)*(ww01+ww02/z)
        gz(1)=gz(1)+a1(i1)*(ww11+ww12/z)
        gz(2)=gz(2)+a1(i1)*(ww21+ww22/z)
        gz(3)=gz(3)+a1(i1)*(ww11*z+ww12/z*(1.-log(z)))
      enddo
      enddo

      g0=pi*rpom*10./cpt                 !common factor
      sigcut=g0*gz(2)/2.                 !cut pomerons cross-section
      sigtot=g0*gz(1)                    !tot cross-section
      sigela=g0*gz(0)/2./cpt             !elastic cross section
      sigdifr=sigtot-sigcut-sigela       !diffractive cross section
      sigine=sigcut+sigdifr              !inelastic cross section
c      sigcut=sigine
      sloela=2.*rs*gz(3)/gz(1)
      sigsd=sigela*((chad(iclpro)-1.)+(chad(icltar)-1.))

      else                 ! only sigine (from tabulation)

        sigine=pscrse(ekin,maproj,matarg)

      endif
      
      write (ifmt,225)engy,sigtot,sigine,sigela,sigcut,sloela,sigdifr
     *,sigsd
      if(ish.ge.4)write (ifch,225)engy,sigtot,sigine,sigela,sigcut
     *,sloela,sigdifr,sigsd
225   format(' hadron-proton cross sections for energy:',f10.2,' GeV'/
     *4x,'total cross section:    ',e10.3/
     *4x,'inelastic cross section: ',e10.3/
     *4x,'elastic cross section:  ',e10.3/
     *4x,'cut cross section:  ',e10.3/
     *4x,'elastic slope parameter:',e10.3/
     *4x,'diffr. cross section:',e10.3/
     *4x,'single diffr. cross section:',e10.3)

      call utprix('xsigma',ish,ishini,4)

      icdp=icdptmp
      icdt=icdttmp

      return
      end

c-----------------------------------------------------------------------
      double precision function om1p(sy,xh,yp,b,iqq)
c-----------------------------------------------------------------------
c om1p - chi~(x,y)
c xh - fraction of the energy squared s for the pomeron;
c yp - rapidity for the pomeron;
c b - impact parameter between the pomeron ends;
c iqq =-1  - 0+1+2+3+4,
c iqq = 0  - soft pomeron,
c iqq = 1  - gg,
c iqq = 2  - qg,
c iqq = 3  - gq,
c iqq = 4  - qq,
c iqq = 5  - soft(int)|b,
c iqq = 6  - gg(int)|b,
c iqq = 7  - soft(proj)|b,
c iqq = 8  - gg(proj)|b,
c iqq = 9  - qg(proj)|b,
c iqq = 10 - total fro-uncut integrated,
c iqq = 11 - total uncut integrated,
c iqq = 12 - soft(int),
c iqq = 13 - gg(int),
c iqq = 14 - <b^2*soft(int)>,
c iqq = 15 - <b^2*gg(int)>,
c iqq = 16 - soft(proj-int),
c iqq = 17 - gg(proj-int),
c iqq = 18 - qg(proj-int),
c iqq = 19 - <b^2*soft(proj)>,
c iqq = 20 - <b^2*gg(proj)>,
c iqq = 21 - <b^2*qg(proj)>
c-----------------------------------------------------------------------
      double precision xh,yp!,coefom1,coefom2
      common /psar7/  delx,alam3p,gam3p
      common /psar37/ coefom1,coefom2
      include 'nexus.inc'
      include 'nexus.incsem'
      
      xp=dsqrt(xh)*exp(yp)
      if(xh.ne.0.d0)then
        xm=xh/xp
      else
        xm=0.
      endif
      rp=r2had(iclpro)+r2had(icltar)+slopom*log(max(1.,sy))
      zb=exp(-b**2/(4.*.0389*rp))
      if(iqq.eq.0)then          !soft
        om1p=chad(iclpro)*chad(icltar)*gamhad(iclpro)
     *  *gamhad(icltar)*sy**dels*(xp*xm)**(-alppar)*zb/rp
      elseif(iqq.le.4)then      !gg,qg,gq,qq
        om1p=psvin(sy,xp,xm,zb,iqq)
      elseif(iqq.eq.5)then      !soft(int)|b
        rh=alam3p+slopom*log(max(1.,sy))
        om1p=sy**dels*zb**(rp/rh)/rh
      elseif(iqq.eq.6)then      !gg(int)|b
        om1p=psvin(sy,xp,xm,zb,14)
      elseif(iqq.eq.7)then      !soft(proj)b
        rh=r2had(iclpro)+.5*alam3p+slopom*log(max(1.,sy))
        om1p=chad(iclpro)*gamhad(iclpro)*sy**dels
     *  *xp**(-alppar)*zb**(rp/rh)/rh
       elseif(iqq.eq.8)then     !gg(proj)b
        om1p=psvin(sy,xp,xm,zb,16)
       elseif(iqq.eq.9)then     !qg(proj)b
        om1p=psvin(sy,xp,xm,zb,18)
       elseif(iqq.eq.10)then    !total fro-uncut integrated
c         om1p=0.d0
c	 return   !!!!!!!!!
        om1p=psvin(sy,xp,xm,zb,10)
       elseif(iqq.eq.11)then    !total uncut integrated
        om1p=psvin(sy,xp,xm,zb,9)
c        om1p=om1p+dble(coefom1)/2.d0*om1p**2+dble(coefom2)/6.d0*om1p**3 !!!!!!!!!!
c        if(om1p.gt.100.d0)om1p=100.d0
      elseif(iqq.eq.12)then      !soft(int)
        om1p=sy**dels*4.*.0389
      elseif(iqq.eq.13)then      !gg(int)
        om1p=psvin(sy,xp,xm,zb,5)
      elseif(iqq.eq.14)then      !<b^2*soft(int)>
        rh=alam3p+slopom*log(max(1.,sy))
        om1p=sy**dels*rh*(4.*.0389)**2
      elseif(iqq.eq.15)then      !<b^2*gg(int)>
        om1p=psvin(sy,xp,xm,zb,15)
      elseif(iqq.eq.16)then      !soft(proj-int)
        om1p=chad(iclpro)*gamhad(iclpro)*sy**dels
     *  *xp**(-alppar)*4.*.0389
       elseif(iqq.eq.17)then     !gg(proj-int)
        om1p=psvin(sy,xp,xm,zb,6)
       elseif(iqq.eq.18)then     !qg(proj-int)
        om1p=psvin(sy,xp,xm,zb,7)
      elseif(iqq.eq.19)then      !<b^2*soft(proj)>
        rh=r2had(iclpro)+.5*alam3p+slopom*log(max(1.,sy))
        om1p=chad(iclpro)*gamhad(iclpro)*sy**dels
     *  *xp**(-alppar)*rh*(4.*.0389)**2
       elseif(iqq.eq.20)then     !<b^2*gg(proj)>
        om1p=psvin(sy,xp,xm,zb,17)
       elseif(iqq.eq.21)then     !<b^2*qg(proj)>
        om1p=psvin(sy,xp,xm,zb,19)
      endif
      return
      end

c-----------------------------------------------------------------------
      double precision function om2p(xh,yp,xprem0,xmrem0,b,iqq)
c-----------------------------------------------------------------------
c om2p - chi~(x,y) for cut pomeron
c xh - fraction of the energy squared s for the pomeron;
c yp - rapidity for the pomeron;
c xprem - x+ for the projectile remnant;
c xmrem - x- for the target remnant;
c b - impact parameter between the pomeron ends;
c iqq = 0  - total,
c iqq = 1  - 1-cut,
c iqq = 2  - Y+,
c iqq = -2 - Y-,
c iqq = 3  - 1-cut(soft),
c iqq = 4  - 1+(gg),
c iqq = 5  - 1+(qg),
c iqq = 6  - 1+(gq),
c iqq = 7  - 1+(difr)
c iqq = -7 - 1-(difr)
c-----------------------------------------------------------------------
      double precision xh,yp,xprem0,xmrem0
      include 'nexus.inc'
      include 'nexus.incsem'

      om2p=0.d0
      sy=xh*engy**2
      xprem=sngl(xprem0)
      xmrem=sngl(xmrem0)
      xp=dsqrt(xh)*dexp(yp)
      if(xh.ne.0.d0)then
        xm=xh/xp
      else
        xm=0.
      endif
      rp=r2had(iclpro)+r2had(icltar)+slopom*log(max(1.,sy))
      zb=exp(-b**2/(4.*.0389*rp))
     
      if(iqq.eq.0)then
        om2p=psvy(xp,xprem,xm,xmrem,b,2)
     *  +psvy(xp,xprem,xm,xmrem,b,-2)
     *  +psvy(xp,xprem,xm,xmrem,b,3)
     *  +psvy(xp,xprem,xm,xmrem,b,-3)
     *  +psvy(xp,xprem,xm,xmrem,b,9)
     *  +psvy(xp,xprem,xm,xmrem,b,-9)
     *  +psvx(xp,xprem,xm,xmrem,b,1)
     *  +psvx(xp,xprem,xm,xmrem,b,2)
     *  +psvx(xp,xprem,xm,xmrem,b,-2)
     *  +psvx(xp,xprem,xm,xmrem,b,6)
     *  +psvx(xp,xprem,xm,xmrem,b,-6)
        om2p=om2p+(chad(iclpro)*chad(icltar)*gamhad(iclpro)
     *  *gamhad(icltar)*sy**dels*(xp*xm)**(-alppar)*zb/rp
     *  +psvin(sy,xp,xm,zb,1)+psvin(sy,xp,xm,zb,2)
     *  +psvin(sy,xp,xm,zb,3)+psvin(sy,xp,xm,zb,4))
     *  *gamdp(icdp,iclpro)*gamdt(icdt,icltar)
      elseif(iqq.eq.1)then
        om2p=psvy(xp,xprem,xm,xmrem,b,2)+psvy(xp,xprem,xm,xmrem,b,-2)
     *  +psvx(xp,xprem,xm,xmrem,b,1)
      elseif(iqq.eq.2)then
        om2p=psvy(xp,xprem,xm,xmrem,b,3)
     *  +psvx(xp,xprem,xm,xmrem,b,2)
      elseif(iqq.eq.-2)then
        om2p=psvy(xp,xprem,xm,xmrem,b,-3)
     *  +psvx(xp,xprem,xm,xmrem,b,-2)
      elseif(iqq.eq.3)then
        om2p=psvy(xp,xprem,xm,xmrem,b,4)+psvy(xp,xprem,xm,xmrem,b,-4)
     *  +psvx(xp,xprem,xm,xmrem,b,3)
      elseif(iqq.eq.4)then
        om2p=psvy(xp,xprem,xm,xmrem,b,5)+psvy(xp,xprem,xm,xmrem,b,7)
     *  +psvy(xp,xprem,xm,xmrem,b,-5)+psvy(xp,xprem,xm,xmrem,b,-7)
     *  +psvx(xp,xprem,xm,xmrem,b,4)+psvx(xp,xprem,xm,xmrem,b,-4)
      elseif(iqq.eq.5)then
        om2p=psvy(xp,xprem,xm,xmrem,b,6)+psvy(xp,xprem,xm,xmrem,b,-8)
     *  +psvx(xp,xprem,xm,xmrem,b,5)
      elseif(iqq.eq.6)then
        om2p=psvy(xp,xprem,xm,xmrem,b,-6)+psvy(xp,xprem,xm,xmrem,b,8)
     *  +psvx(xp,xprem,xm,xmrem,b,-5)
      elseif(iqq.eq.7)then
        om2p=psvy(xp,xprem,xm,xmrem,b,9)
     *  +psvx(xp,xprem,xm,xmrem,b,6)
      elseif(iqq.eq.-7)then
        om2p=psvy(xp,xprem,xm,xmrem,b,-9)
     *  +psvx(xp,xprem,xm,xmrem,b,-6)
      else
        stop'om2p-wrong iqq!!!'
      endif
      return
      end

c-----------------------------------------------------------------------
      double precision function om3p(xh,yp,xleg,xprem,xmrem,xlrem
     *,b1,b2,b12,iqq)
c-----------------------------------------------------------------------
c om3p - chi~(x,y) for cut pomeron (nuclear effects)
c xh     - fraction of the energy squared s for the pomeron;
c yp     - rapidity for the pomeron;
c xleg   - x for the pomeron leg;
c xprem  - x+ for the projectile remnant;
c xmrem  - x- for the target remnant;
c xlrem  - x for the leg remnant;
c b1     - impact parameter between the pomeron ends;
c b2     - impact parameter for the second pomeron end;
c iqq = 1  - uncut+,
c iqq = 2  - cut+,
c iqq = 3  - scr+,
c iqq = 4  - diffr+,
c iqq = 5  - uncut-,
c iqq = 6  - cut-,
c iqq = 7  - scr-,
c iqq = 8  - diff-
c iqq = 9  - uncut-h+,
c iqq = 10 - uncut-h-,
c iqq = 11 - uncut-YY+,
c iqq = 12 - uncut-YY-,
c-----------------------------------------------------------------------
      double precision xh,yp,xleg,xprem,xmrem,xlrem
ctp060202 to avoid warnings with gfortran compilation
      logical ctp060202
      ctp060202=.false.
      if(ctp060202)write(*,*)xh,yp,xleg,xprem,xmrem,xlrem
     *,b1,b2,b12,iqq
ctp060202 end

      om3p=0.d0
      return !!!!!!!!!!!!!!!
c      if(iqq.ne.1.and.iqq.ne.5.and.iqq.ne.9.and.iqq.ne.10
c     *.and.iqq.ne.11.and.iqq.ne.12)return
     
c$$$      xp=dsqrt(xh)*exp(yp)
c$$$      if(xh.ne.0.d0)then
c$$$        xm=xh/xp
c$$$      else
c$$$        xm=0.d0
c$$$      endif
c$$$      
c$$$      return
      end      
 
c-----------------------------------------------------------------------
      double precision function om4p(xx1,xx2,xx3,xx4
     *,b12,b13,b14,b23,b24,b34,iqq)
c-----------------------------------------------------------------------
c om4p - chi for 2-leg contributions
c xx_i - x+- for pomeron ends;
c b_ij - impact parameter diff. between pomeron ends;
c iqq = 1   - uncut-H,
c iqq = 2   - uncut-YY+,
c iqq = 3   - uncut-YY-
c-----------------------------------------------------------------------
      double precision xx1,xx2,xx3,xx4      
ctp060202 to avoid warnings with gfortran compilation
      logical ctp060202
      ctp060202=.false.
      if(ctp060202)write(*,*)xx1,xx2,xx3,xx4
     *,b12,b13,b14,b23,b24,b34,iqq
ctp060202 end
      om4p=0.d0
      return
      end      
 
c------------------------------------------------------------------------
      subroutine psaini
c-----------------------------------------------------------------------
c common initialization procedure
c-----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incpar'
      include 'nexus.incsem'
      logical lcalc!,lcalc2
      double precision seedhere
c      double precision om1p,xh,yh,v3pom(4),om2p
      dimension gamhad0(nclha),r2had0(nclha),chad0(nclha)
     *,alplea0(nclha),asect1(7,4,7),asect2(7,4,7),asect3(7,7,7)!,cgam(nbpDf)
      common /psar2/  edmax,epmax
      common /psar4/  fhgg(11,10,8),fhqg(11,10,80)
     *,fhgq(11,10,80),fhqq(11,10,80),fhgg0(11,10),fhgg1(11,10,4)
     *,fhqg1(11,10,40),fhgg01(11),fhgg02(11),fhgg11(11,4)
     *,fhgg12(11,4),fhqg11(11,10,4),fhqg12(11,10,4)
     *,ftoint(11,14,2,2,3),ftounc(11,100,168)
      common /psar6/  coefu1(nbpDf,nclha)
     *,coefu2(nbpDf*nbpDf,nclha)
     *,coefu3(nbpDf*nbpDf*nbpDf,nclha)
     *,coefu4(nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefu5(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefu6(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefc2(nbpDf*nbpDf,nclha)
     *,coefc3(nbpDf*nbpDf*nbpDf,nclha)
     *,coefc4(nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefc5(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
      common /psar7/  delx,alam3p,gam3p
      common /psar9/  alpr
      common /psar15/ sudx(40,2)
      common /psar19/ cstot(20,20,240)
      common /psar20/ cs0(20,20,240)
      common /psar21/ csborn(20,160,2)
      common /psar22/ csq(20,4,2),csbq(20,4,2)
      common /psar23/ cschar(20,20,2)
      common /psar25/ csdsi(21,21,104)
      common /psar27/ csds(21,26,4),csdt(21,26,2),csdr(21,26,2)      
      common /psar33/ asect(7,4,7),asectn(7,7,7)
      common /psar34/ rrr,rrrm
      common /psar35/ anorm
      common /psar36/ alvc
      common /psar37/ coefom1,coefom2
      common /psar38/ vfro(11,14,3,2)
      common /psar39/ vnorm(11,14,3,2,2)
      common /psar40/ coefxu1(nbpDf,nclha,10)
     *,coefxu2(nbpDf,nbpDf,nclha,10),coefxc2(nbpDf,nbpDf,nclha,10)
      common /ar3/    x1(7),a1(7)
      common /testj/  ajeth(4),ajete(5),ajet0(7)
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /kfitd/ xkappafit(nclegy,nclha,nclha,2,2,20),bkbin
      common/geom/rmproj,rmtarg,bmax,bkmx

      icdps=icdp
      icdts=icdt

      call utpri('psaini',ish,ishini,4)

      do i=1,4
      ajeth(i)=0.
      enddo
      do i=1,5
      ajete(i)=0.
      ajet0(i)=0.
      enddo
      ajet0(6)=0.
      ajet0(7)=0.
      

      bkbin=0.15             !for Kfit

      edmax=1.e9
      epmax=1.e9
      delx=exp(2.5)   
      alam3p=.6  
      gam3p=.1   
      
      do i=iclpro1,iclpro2  !hadron type 
       gamdp(1,i)=1.  
       gamdp(2,i)=1.
       if(icdp1.eq.icdp2)then
         ccproj(1,i)=1.  
         ccproj(2,i)=1. 
       else
         ccproj(1,i)=.5  
         ccproj(2,i)=.5 
       endif
      enddo
      do i=icltar1,icltar2  !hadron type 
       gamdt(1,i)=1.  
       gamdt(2,i)=1.   
       if(icdt1.eq.icdt2)then
         cctarg(1,i)=1.  
         cctarg(2,i)=1. 
       else
         cctarg(1,i)=.5  
         cctarg(2,i)=.5 
       endif
      enddo


c   interface to 'bas'
c    ----------------

      dels=alppom-1.
      alpqua=(alppar+1.)/2.
      if(abs(alpqua).lt.1.e-6)call utstop('alpar should not be -1 !&')
      alpr=-2.+alpqua      !x-exponent for remnant mass

c   omega coeffs
c    ----------------
c$$$      coefom0=utgam1(1.+dels-alppar)*utgam1(1.+alplea(iclpro))
c$$$     */utgam1(2.+alplea(iclpro)+dels-alppar)
c$$$     **utgam1(1.+dels-alppar)*utgam1(1.+alplea(icltar))
c$$$     */utgam1(2.+alplea(icltar)+dels-alppar)
c$$$      coefom1=1.-utgam1(1.+dels-alppar)**2*utgam1(1.+alplea(iclpro))
c$$$     */utgam1(1.+alplea(iclpro)+2.*(1.+dels-alppar))
c$$$     **utgam1(1.+dels-alppar)**2*utgam1(1.+alplea(icltar))
c$$$     */utgam1(1.+alplea(icltar)+2.*(1.+dels-alppar))/coefom0**2
c$$$      coefom2=3.*coefom1-1.
c$$$     *+utgam1(1.+dels-alppar)**3*utgam1(1.+alplea(iclpro))
c$$$     */utgam1(1.+alplea(iclpro)+3.*(1.+dels-alppar))
c$$$     **utgam1(1.+dels-alppar)**3*utgam1(1.+alplea(icltar))
c$$$     */utgam1(1.+alplea(icltar)+3.*(1.+dels-alppar))/coefom0**3
c$$$      if(ish.ge.4)write(ifmt,*)'coefom',coefom0,coefom1,coefom2

c soft pomeron: abbreviations
c---------------------------------------
      if(iappl.eq.1.or.iappl.eq.8.or.iappl.eq.9)then

        quamas=.35
        gamhad(4)=gamhad(1)*(quamas/qcmass)**2
        r2had(4)=0.
        chad(4)=1.


c---------------------------------------
c auxiliary constants:
c---------------------------------------
        stmass=.05               !string mass cutoff

c---------------------------------------
c parton density normalization
        sq=log(log(q2min/.232**2)/log(.23/.232**2))
        du=2.997+.753*sq-.076*sq*sq
        qnorm=0.
        do i=1,7
        do m=1,2
          xx=.5+x1(i)*(m-1.5)
          xxq=1.-xx**(1./(1.+du))
          qnorm=qnorm+a1(i)*(psdfh4(xxq,q2min,0.,2,1)+
     *    psdfh4(xxq,q2min,0.,2,2))/(1.-xxq)**du
        enddo
        enddo
        qnorm=qnorm*.5/(1.+du)
        qnormp=qnorm
        rr=(1.-qnorm)/4./pi/gamhad(2)
     *  *utgam1(2.+betpom-dels)/utgam1(1.-dels)
     *  /utgam1(1.+betpom)/utgam1(1.+alplea(2))/
     *  utgam1(2.-alppar)*utgam1(3.+alplea(2)-alppar)
        if(ish.ge.4)write (ifmt,*)'rr,qnorm',rr,qnorm

        gnorm=0.
        dg=3.
        do i=1,7
        do m=1,2
          xx=.5+x1(i)*(m-1.5)
          xxg=1.-xx**(1./(1.+dg))
          gnorm=gnorm+a1(i)*psftig(xxg,0.,0)/(1.-xxg)**dg
     *    -a1(i)*psftig(xxg,0.,2)/(1.-xxg)**dg
        enddo
        enddo
        gnorm=gnorm*.5/(1.+dg)/(1.-glusea)
        if(ish.ge.4)write(ifmt,*)'balance',1.-qnorm-gnorm
     *                                    ,(1.-qnorm)/gnorm

        sq=log(log(q2min/.232**2)/log(.25/.232**2))
        dpi=.367+.563*sq
        qnorm=0.
        do i=1,7
        do m=1,2
          xx=.5+x1(i)*(m-1.5)
          xxq=1.-xx**(1./(1.+dpi))
          qnorm=qnorm+a1(i)*(psdfh4(xxq,q2min,0.,1,1)+
     *    psdfh4(xxq,q2min,0.,1,2))/(1.-xxq)**dpi
        enddo
        enddo
        qnorm=qnorm*.5/(1.+dpi)
        gamhad(1)=gamhad(2)/(1.-qnormp)*(1.-qnorm)
     *  *utgam1(alplea(2)+1.)/utgam1(alplea(2)+3.-alppar)
     *  /utgam1(alplea(1)+1.)*utgam1(alplea(1)+3.-alppar)
        if(ish.ge.4)write (ifmt,*)'gamhad(1)',gamhad(1)

        qnorm=0.
        do i=1,7
        do m=1,2
          xx=.5+x1(i)*(m-1.5)
          xxq=1.-xx**(1./(1.+dpi))
          qnorm=qnorm+a1(i)*(psdfh4(xxq,q2min,0.,1,1)+
     *    psdfh4(xxq,q2min,0.,1,2))/(1.-xxq)**dpi
        enddo
        enddo
        qnorm=qnorm*.5/(1.+dpi)
        gamhad(3)=gamhad(2)/(1.-qnormp)*(1.-qnorm)
     *  *utgam1(alplea(2)+1.)/utgam1(alplea(2)+3.-alppar)
     *  /utgam1(alplea(3)+1.)*utgam1(alplea(3)+3.-alppar) *.8 !???
        if(ish.ge.4)write (ifmt,*)'gamhad(3)',gamhad(3)

        gnorm=0.
        do i=1,7
        do m=1,2
          xx=.5+x1(i)*(m-1.5)
          xxg=xx**(1./(1.-dels))
          gnorm=gnorm+a1(i)*(psftild(xxg,4)+psftile(xxg,4))
        enddo
        enddo
        gnorm=gnorm/(1.-dels)*2.*pi*gamhad(4)*rr
        alvc=6./(1.-gnorm)-4.
        if(ish.ge.4) write (ifch,*)'rr,qnorm,gnorm,alvc',
     *  rr,qnorm,gnorm,alvc
c        write (*,*)'rr-c,qnorm,gnorm,alvc',rr,qnorm,gnorm,alvc
      endif

c-----------------------------------------------
c tabulation of inclusive jet cross sections
c--------------------------------------------------
      do i=1,40
        qi=q2min*exp(.5*(i-1))
        sudx(i,1)=psudx(qi,1)
        sudx(i,2)=psudx(qi,2)
      enddo
      if(ish.ge.4)write(ifch,*)'bare cross sections ...'

      call psaevc

      inquire(file=fnii(1:nfnii),exist=lcalc)
      if(lcalc)then
        write(ifmt,'(a)')'read from initl ...'
        open(1,file=fnii(1:nfnii),status='old')
        read (1,*)qcdlam0,q2min0,q2ini0,naflav0,epmax0,pt2cut0
        if(qcdlam0.ne.qcdlam)write(ifmt,'(a)')'initl: wrong qcdlam'
        if(q2min0 .ne.q2min )write(ifmt,'(a)')'initl: wrong q2min'
        if(q2ini0 .ne.q2ini )write(ifmt,'(a)')'initl: wrong q2ini'
        if(naflav0.ne.naflav)write(ifmt,'(a)')'initl: wrong naflav'
        if(epmax0 .ne.epmax )write(ifmt,'(a)')'initl: wrong epmax'
        if(pt2cut0 .ne.pt2cut )write(ifmt,'(a)')'initl: wrong pt2cut'
        if(qcdlam0.ne.qcdlam.or.q2min0 .ne.q2min .or.q2ini0 .ne.q2ini
     *  .or.naflav0.ne.naflav.or.epmax0 .ne.epmax.or. pt2cut.ne.pt2cut0) 
     *  then
          write(ifmt,'(//a//)')'   initl has to be reinitialized!!!'
          stop
        endif
        read (1,*)csborn,cs0,cstot,csq,csbq
        close(1)
       
       goto 1  
      endif

      write(ifmt,'(a)')'initl does not exist -> calculate tables  ...'
      spmin=4.*q2min
      spminc=4.*q2min+qcmass**2
      do m=1,4   !parton type at upper end of the ladder (1...4 - g,u,d,c)
      do k=1,20
        if(m.ne.4)then
          sk=spmin*(epmax/2./spmin)**((k-1)/19.)  !c.m. energy squared for the hard
          p1=sk
        else
          sk=spminc*(epmax/2./spminc)**((k-1)/19.) 
          p1=sk/(1.+qcmass**2/sk)
        endif  
        qmax=p1/4.
      do i=1,20
        qq=q2min*(qmax/q2min)**((i-1)/19.)
      do l=1,2    !parton type at lower end of the ladder 
        k1=k+20*(m-1)+80*(l-1)
        m1=m-1
        if(m.eq.3.and.l.eq.1)then  !dd~
          l1=-m1
        else                       !du
          l1=l-1
        endif                                       !born cr.-sect.
        csborn(i,k1,1)=log(max(1.e-30,psborn(qq,qq,qq,sk,m1,l1,0))) 
        if(m.ne.4)then
          csborn(i,k1,2)=log(max(1.e-30,psborn(4.*qq,qq,qq,sk,m1,l1,1)))
        endif
      enddo
      enddo
      enddo
      enddo

      do m=1,4            !parton type at upper end of the ladder
      do k=1,20
        write (*,*)'k,m',k,m
        if(m.ne.4)then
          sk=spmin*(epmax/2./spmin)**((k-1)/19.)  !c.m. energy squared for the hard
          p1=sk
        else
          sk=spminc*(epmax/2./spminc)**((k-1)/19.) 
          p1=sk/(1.+qcmass**2/sk)
        endif  
	qmax=p1/4.
	tmax=p1/2.
      do i=1,20             !cross-sections initialization
        qi=q2min*(qmax/q2min)**((i-1)/19.)
      do j=1,20
        qq=qi*(qmax/qi)**((j-1)/19.)
        if(p1.gt.4.*qq)then               
          tmin=2.*qq/(1.+sqrt(1.-4.*qq/p1))
        else
          tmin=2.*qq
        endif
      do l=1,2              !parton type at lower end of the ladder
        m1=m-1
        if(m.eq.3.and.l.eq.1)then
          l1=-m1
        else
          l1=l-1
        endif
        if(m.ne.4)then
          k1=k+20*(m-1)+60*(l-1)
          if(k.eq.1.or.i.eq.20.or.j.eq.20)then
            cs0(i,j,k1)=log(max(1.e-30,psborn(qi,qq,qq,sk,m1,l1,0)))
            cs0(i,j,k1+120)=
     *                  log(max(1.e-30,psborn(4.*qq,qi,qq,sk,l1,m1,1)))
          else
            cs0(i,j,k1)=log(psjet1(qi,qq,qq,sk,m1,l1,0)
     *      /(1./tmin-1./tmax)+psborn(qi,qq,qq,sk,m1,l1,0))
            cs0(i,j,k1+120)=log(psjet1(qi,4.*qq,qq,sk,m1,l1,2)
     *      /(1./tmin-1./tmax)+psborn(4.*qq,qi,qq,sk,l1,m1,1))
          endif
        elseif(j.eq.1)then
          if(k.eq.1.or.i.eq.20)then
           cschar(i,k,l)=log(max(1.e-30,psborn(q2min,qi,qq,sk,m1,l1,0)))
          else
            cschar(i,k,l)=log(psjet1(qi,q2min,qq,sk,l1,m1,0)
     *      /(1./tmin-1./tmax)+psborn(q2min,qi,qq,sk,m1,l1,0))
          endif
        endif  
      enddo
      enddo
      enddo
      enddo
      enddo
      
      do k=1,3
        sk=spmin*1.5**k
      do n=1,2
        if(n.eq.1)then
          qmax1=sk/4.
          qmax2=sk/4.
        elseif(n.eq.2)then
          qmax1=sk/4.
          qmax2=sk
        endif
      do i=1,3             !cross-sections initialization
        qi=q2min*(qmax1/q2min)**((i-1)/3.)
      do j=1,3
        qj=q2min*(qmax2/q2min)**((j-1)/3.)
        qqmax=sk/4.
        if(n.eq.1)then
	  qqmin=max(qi,qj)
        else
	  qqmin=max(qi,qj/4.)
	endif
      do lq=1,3
        qq=qqmin*(qqmax/qqmin)**((lq-1)/3.)
        if(sk.gt.4.*qq)then              
          tmin=2.*qq/(1.+sqrt(1.-4.*qq/sk))
        else
          tmin=2.*qq
        endif	
        tmax=sk/2.
      do m=1,1             !parton type at upper end of the ladder (1
      do l=1,1              !parton type at lower end of the ladder (1
        m1=m-1
        if(m.eq.3.and.l.eq.1)then
          l1=-m1
        else
          l1=l-1
        endif
        
        csb=psborn(qj,qi,qq,sk,l1,m1,n-1)*(1./tmin-1./tmax)
        psb=psbint(qj,qi,qq,sk,l1,m1,n-1)
        write (ifmt,*)'n-1,sk,qi,qj,qq,born',n-1,sk,qi,qj,qq,csb,psb
        csj=psjet1(qi,qj,qq,sk,m1,l1,2*(n-1))
     *  +psborn(qj,qi,qq,sk,l1,m1,n-1)*(1./tmin-1./tmax)

        psj=psjti1(qi,qj,qq,sk,m1,l1,n-1)
        write (ifmt,*)'n-1,jet1',n-1,csj,psj
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo

      do k=1,20
        write (*,*)'k-tot',k
        sk=spmin*(epmax/2./spmin)**((k-1)/19.)  !c.m. energy squared for the hard
        qmax=sk/4.
	tmax=sk/2.
      do i=1,20             !cross-sections initialization
      do n=1,2
        if(n.eq.1)then
          qi=q2min*(qmax/q2min)**((i-1)/19.)
        else
          qi=q2min*(4.*qmax/q2min)**((i-1)/19.)
        endif
      do j=1,20
        if(n.eq.1)then
          qq=qi*(qmax/qi)**((j-1)/19.)
        else
          qq=max(q2min,qi/4.)*(qmax/max(q2min,qi/4.))**
     *    ((j-1)/19.)
        endif
        if(sk.gt.4.*qq)then              
          tmin=2.*qq/(1.+sqrt(1.-4.*qq/sk))
        else
          tmin=2.*qq
        endif	
      do m=1,3              !parton type at upper end of the ladder (1
      do l=1,2              !parton type at lower end of the ladder (1
        m1=m-1
        if(m.eq.3.and.l.eq.1)then
          l1=-m1
        else
          l1=l-1
        endif
        k1=k+20*(m-1)+60*(l-1)+120*(n-1)
        if(k.eq.1.or.i.eq.20.or.j.eq.20)then
         cstot(i,j,k1)=log(max(1.e-30,psborn(qi,q2min,qq,sk,m1,l1,n-1)))
        else
          if(n.eq.1)then
            cstot(i,j,k1)=log((psjet(qi,q2min,qq,sk,m1,l1,0)+
     *      psjti1(qi,q2min,qq,sk,m1,l1,0)+
     *      psjti1(q2min,qi,qq,sk,l1,m1,0)
     *      -psbint(qi,q2min,qq,sk,m1,l1,0))/(1./tmin-1./tmax))
          else
            cstot(i,j,k1)=log((psjet(qi,q2min,qq,sk,m1,l1,1)+
     *      psjet1(qi,q2min,qq,sk,m1,l1,1)+
     *      psjti1(q2min,qi,qq,sk,l1,m1,1))/(1./tmin-1./tmax))
          endif
        endif
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      
c total and born hard cross-sections logarithms for minimal cutoff
c (q2min), interpolated in the psjti0 procedure
      spmin=4.*q2min
      spminc=4.*q2min+qcmass**2
      do m=1,4
      do l=1,2
        m1=m-1
        if(m.eq.3.and.l.eq.1)then
          l1=-m1
        else
          l1=l-1
        endif
      do k=1,20
        if(m.ne.4)then
          sk=spmin*(epmax/2./spmin)**((k-1)/19.)  !c.m. energy squared for the hard
          p1=sk
          qq=q2min
        else
          sk=spminc*(epmax/2./spminc)**((k-1)/19.) 
          p1=sk/(1.+qcmass**2/sk)
          qq=q2min
        endif  
        if(p1.gt.4.*qq)then               
          tmin=2.*qq/(1.+sqrt(1.-4.*qq/p1))
        else
          tmin=2.*qq
        endif
        tmax=p1/2.

        k1=k+20*(m-1)+80*(l-1)
        csbq(k,m,l)=log(max(1.e-30,psborn(q2min,q2min,qq,sk,m1,l1,0)))
        if(k.eq.1)then
          csq(k,m,l)=csbq(k,m,l)
        elseif(m.ne.4)then
          csq(k,m,l)=log(psjti(q2min,qq,sk,m1,l1,0)/
     *    (1./tmin-1./tmax))
        else
          smins=2.5*q2min*(1.+sqrt(1.+4.*qcmass**2/q2min))   
          if(sk.le.smins)then
            csq(k,m,l)=log(psjci(q2min,sk,l1)/(1./tmin-1./tmax))
          else  
            csq(k,m,l)=log((psjci(q2min,sk,l1)+psjct(sk,spmin,l1))
     *      /(1./tmin-1./tmax))
          endif
        endif
      enddo
      enddo
      enddo
      
      write(ifmt,'(a)')'write to initl ...'
      open(1,file=fnii(1:nfnii),status='unknown')
      write (1,*)qcdlam,q2min,q2ini,naflav,epmax,pt2cut
      write (1,*)csborn,cs0,cstot,csq,csbq,cschar
      close(1)

1     continue

      if(iappl.ne.8)goto 3
      if(ish.ge.3)write(ifch,*)'dis cross sections ...'
      inquire(file=fnid(1:nfnid),exist=lcalc)
      if(lcalc)then
        write(ifmt,'(a)')'read from inidi ...'
        open(1,file=fnid(1:nfnid),status='old')
        read (1,*)qcdlam0,q2min0,q2ini0,naflav0,epmax0,edmax0
        if(qcdlam0.ne.qcdlam)write(ifmt,'(a)')'inidi: wrong qcdlam'
        if(q2min0 .ne.q2min )write(ifmt,'(a)')'inidi: wrong q2min'
        if(q2ini0 .ne.q2ini )write(ifmt,'(a)')'inidi: wrong q2ini'
        if(naflav0.ne.naflav)write(ifmt,'(a)')'inidi: wrong naflav'
        if(epmax0 .ne.epmax )write(ifmt,'(a)')'inidi: wrong epmax'
        if(edmax0 .ne.edmax )write(ifmt,'(a)')'inidi: wrong edmax'
        if(qcdlam0.ne.qcdlam.or.q2min0 .ne.q2min.or.q2ini0 .ne.q2ini
     *  .or.naflav0.ne.naflav.or.epmax0 .ne.epmax
     *  .or.edmax0 .ne.edmax)then
           write(ifmt,'(//a//)')'   inidi has to be reinitialized!!!'    
           stop
        endif
        read (1,*)csdsi,csds,csdt,csdr
        close(1)
       goto 3
      endif

      write(ifmt,'(a)')'inidi does not exist -> calculate tables  ...'
      do j=1,21
        qq=q2min*exp(.5*(j-1))                !photon virtuality

        do m=1,2               !parton type at the end of the ladder
	  q2mass=qcmass**2
          s2min=4.*max(q2mass,q2min)+qq
          if(m.eq.2)s2min=s2min/(1.-4.*q2ini/(s2min-qq))
        do k=1,26
          write (*,*)'sin,j,m,k',j,m,k
          sk=s2min*(edmax/s2min)**(.04*(k-1))      !c.m. energy squared
          if(k.eq.26)sk=1.01*sk
          qmin=q2min
          if(m.eq.1)then
            qmax=(sk-qq)/4.
          else
            qmax=(sk-qq+sqrt((sk-qq)**2-16.*sk*q2ini))/8.
          endif

          do i=1,21               !cross-sections calculation
            qi=qmin*(qmax/qmin)**((i-1)/20.)
	    tmax=.5*sk
            qtq=4.*max(q2mass,qi)/(sk-qq)
            if(qtq.lt.1.)then
              tmin=.5*sk*qtq/(1.+sqrt(1.-qtq))
            else
              tmin=.5*sk
            endif

            do ilong=1,2
              k1=k+26*(m-1)+52*(ilong-1)
              if(m.eq.1)then
                if(tmax.gt.1.01*tmin)then
                  sij=psds(qi,qq,sk,m-1,ilong-1)
                  if(sij.lt.0.)write (*,*)'qi,qq,sk,m,long,sij',
     *            qi,qq,sk,m,ilong,sij
                  csdsi(i,j,k1)=log(max(0.,sij)/(1./tmin-1./tmax)
     *            +psdbor(qi,qq,sk,ilong-1))
                else
                  csdsi(i,j,k1)=
     *            log(max(1.e-25,psdbor(qi,qq,sk,ilong-1)))
                endif
              else
                csdsi(i,j,k1)=psds(qi,qq,sk,m-1,ilong-1)
              endif
            enddo
          enddo
        enddo
        enddo
      enddo

      do j=1,21
        qq=q2min*exp(.5*(j-1))                       !photon virtuality
        s2min=max(4.*qq,16.*q2min)    !pt2dis=qq
      do m=1,2
      do k=1,26
        do ilong=1,2               
          k1=k+26*(m-1)+52*(ilong-1)
          csds(j,k,m+2*(ilong-1))=csdsi(1,j,k1)
        enddo

        sk=(s2min+qq)*(edmax/(s2min+qq))**(.04*(k-1)) 
        csdt(j,k,m)=psdres(qq,sk,s2min,m-1)
        csdr(j,k,m)=psdrga(qq,sk-qq,s2min,m-1)
      enddo
      enddo
      enddo
      
      write(ifmt,'(a)')'write to inidi ...'

      write(ifmt,'(a)')'write to inidi ...'
      open(1,file=fnid(1:nfnid),status='unknown')
      write (1,*)qcdlam,q2min,q2ini,naflav,epmax,edmax
      write (1,*)csdsi,csds,csdt,csdr
      close(1)
3     continue

c---------------------------------------
c tabulation of semihard eikonals
c---------------------------------------

!!!!!!!!!      if(iappl.eq.1)then

      if(ish.ge.4)write(ifch,*)'semihard eikonals ...'
5     continue
      inquire(file=fnrj,exist=lcalc)
      if(lcalc)then
        write(ifmt,'(a)')'read from inirj ...'
        open(1,file=fnrj,status='old')
        read (1,*)alpqua0,alplea0,alppom0,slopom0,
     *  gamhad0,r2had0,chad0,
     *  qcdlam0,q2min0,q2ini0,betpom0,glusea0,naflav0,
     *  factk0,pt2cut0
        if(alpqua0.ne.alpqua)write(ifmt,'(a,2f8.4)')
     *  'inirj: wrong alpqua',alpqua0,alpqua
        if(alppom0.ne.alppom)write(ifmt,'(a,2f8.4)')
     *  'inirj: wrong alppom',alppom0,alppom
        if(slopom0.ne.slopom)write(ifmt,'(a,2f8.4)')
     *  'inirj: wrong slopom',slopom0,slopom
        iii=2
        if(gamhad0(iii).ne.gamhad(iii))write(ifmt,'(a,i1,a,2f8.4)')
     *  'inirj: wrong gamhad(',iii,')',gamhad0(iii),gamhad(iii)
        do iii=1,3 
        if(r2had0(iii) .ne.r2had(iii) )write(ifmt,'(a,i1,a,2f8.4)')
     *  'inirj: wrong r2had(',iii,')',r2had0(iii),r2had(iii)
        if(chad0(iii)  .ne.chad(iii)  )write(ifmt,'(a,i1,a,2f8.4)')
     *  'inirj: wrong chad(',iii,')',chad0(iii),chad(iii)
        if(alplea0(iii).ne.alplea0(iii))write(ifmt,'(a,i1,a,2f8.4)')
     *  'inirj: wrong alplea(',iii,')',alplea0(iii),alplea(iii)
        enddo
        if(qcdlam0.ne.qcdlam)write(ifmt,'(a,2f8.4)')
     *  'inirj: wrong qcdlam',qcdlam0,qcdlam
        if(q2min0 .ne.q2min )write(ifmt,'(a,2f8.4)')
     *  'inirj: wrong q2min',q2min0,q2min
        if(q2ini0 .ne.q2ini )write(ifmt,'(a,2f8.4)')
     *  'inirj: wrong q2ini',q2ini0,q2ini
        if(betpom0.ne.betpom)write(ifmt,'(a,2f8.4)')
     *  'inirj: wrong betpom',betpom0,betpom
        if(glusea0.ne.glusea)write(ifmt,'(a,2f8.4)')
     *  'inirj: wrong glusea',glusea0,glusea
        if(naflav0.ne.naflav)write(ifmt,'(a,2f8.4)')
     *  'inirj: wrong naflav',naflav0,naflav
        if(factk0 .ne.factk )write(ifmt,'(a,2f8.4)')
     *  'inirj: wrong factk', factk0,factk
        if(pt2cut0 .ne.pt2cut )write(ifmt,'(a,2f8.4)')
     *  'inirj: wrong pt2cut', pt2cut0,pt2cut
        if(alpqua0.ne.alpqua.or.alppom0.ne.alppom
     *  .or.slopom0.ne.slopom.or.gamhad0(2).ne.gamhad(2)
     *  .or.r2had0(1).ne.r2had(1).or.r2had0(2).ne.r2had(2)
     *  .or.r2had0(3).ne.r2had(3)
     *  .or.chad0(1).ne.chad(1).or.chad0(2).ne.chad(2)
     *  .or.chad0(3).ne.chad(3)
     *  .or.alplea0(1).ne.alplea(1).or.alplea0(2).ne.alplea(2)
     *  .or.alplea0(3).ne.alplea(3)
     *  .or.qcdlam0.ne.qcdlam.or.q2min0 .ne.q2min
     *  .or.q2ini0 .ne.q2ini
     *  .or.betpom0.ne.betpom.or.glusea0.ne.glusea.or.naflav0.ne.naflav
     *  .or.factk0 .ne.factk .or.pt2cut0.ne.pt2cut)then
           write(ifmt,'(//a//)')'   inirj has to be reinitialized!!!!'
           stop
        endif
        
        read(1,*)fhgg,fhqg,fhgq,fhqq,fhgg0,fhgg1,fhqg1
     *  ,fhgg01,fhgg02,fhgg11,fhgg12,fhqg11,fhqg12
     *  ,ftoint,vfro,ftounc,vnorm,coefxu1,coefxu2,coefxc2
     *  ,coefu1,coefu2,coefu3,coefu4,coefu5,coefu6
     *  ,coefc2,coefc3,coefc4,coefc5
        read(1,*)bkbin0,iclpro10,iclpro20,icltar10,icltar20,iclegy10
     *   ,iclegy20,egylow0,egyfac0,iomega0,icdp10,icdp20,icdt10,icdt20
     *            ,Esmax0,epscr0,epscrp0
        if(iclpro10.ne.iclpro1)write(ifmt,'(a,2i2)')
     *  'inirj: wrong iclpro1',iclpro10,iclpro1
        if(iclpro20.ne.iclpro2)write(ifmt,'(a,2i2)')
     *  'inirj: wrong iclpro2',iclpro20,iclpro2
        if(icltar10.ne.icltar1)write(ifmt,'(a,2i2)')
     *  'inirj: wrong icltar1',icltar10,icltar1
        if(icltar20.ne.icltar2)write(ifmt,'(a,2i2)')
     *  'inirj: wrong icltar2',icltar20,icltar2
        if(iclegy10.ne.iclegy1)write(ifmt,'(a,2i4)')
     *  'inirj: wrong iclegy1',iclegy10,iclegy1
        if(iclegy20.ne.iclegy2)write(ifmt,'(a,2i4)')
     *  'inirj: wrong iclegy2',iclegy20,iclegy2
        if(egylow0.ne.egylow)write(ifmt,'(a,2f8.4)')
     *  'inirj: wrong egylow',egylow0,egylow
        if(egyfac0.ne.egyfac)write(ifmt,'(a,2f12.4)')
     *  'inirj: wrong egyfac',egyfac0,egyfac
        if(icdp10.ne.icdp1)write(ifmt,'(a,2i2)')
     *  'inirj: wrong icdp1',icdp10,icdp1
        if(icdp20.ne.icdp2)write(ifmt,'(a,2i2)')
     *  'inirj: wrong icdp2',icdp20,icdp2
        if(icdt10.ne.icdt1)write(ifmt,'(a,2i2)')
     *  'inirj: wrong icdt1',icdt10,icdt1
        if(icdt20.ne.icdt2)write(ifmt,'(a,2i2)')
     *  'inirj: wrong icdt2',icdt20,icdt2
        if(Esmax0.ne.Esmax)write(ifmt,'(a,2f8.4)')
     *  'inirj: wrong Esmax ',Esmax0,Esmax
        if(epscr0.ne.epscr)write(ifmt,'(a,2f8.4)')
     *  'inirj: wrong epscr',epscr0,epscr
        if(epscrp0.ne.epscrp)write(ifmt,'(a,2f8.4)')
     *  'inirj: wrong epscrp',epscrp0,epscrp
        if(bkbin0.ne.bkbin)write(ifmt,'(a,2f8.4)')
     *  'inirj: wrong bkbin',bkbin0,bkbin
        if(iclpro10.ne.iclpro1.or.iclpro20.ne.iclpro2
     *   .or.icltar10.ne.icltar1.or.icltar20.ne.icltar2 
     *   .or.iclegy10.ne.iclegy1.or.iclegy20.ne.iclegy2
     *   .or.egylow0.ne.egylow.or.egyfac0.ne.egyfac
     *   .or.icdp10.ne.icdp1.or.icdp20.ne.icdp2 
     *   .or.icdt10.ne.icdt1.or.icdt20.ne.icdt2.or.(isetcs.ne.1 
     *   .and.(Esmax0.ne.Esmax.or.epscr0.ne.epscr.or.epscrp0.ne.epscrp))
     *   .or.bkbin0.ne.bkbin.or.iomega0.ne.iomega)then
           write(ifmt,'(//a//)')'   inirj has to be reinitialized!!!!'
           stop
        endif
        do iiipro=iclpro1,iclpro2
        do iiitar=icltar1,icltar2
        do iiiegy=iclegy1,iclegy2
        do iiicdp=icdp1,icdp2   
        do iiicdt=icdt1,icdt2  
        do iiib=1,20
          read(1,*)xkappafit(iiiegy,iiipro,iiitar,iiicdp,iiicdt,iiib)
        enddo
        do iiidf=nbpDf0,nbpDf1
         read(1,*)alpD(iiidf,iiiegy,iiipro,iiitar,iiicdp,iiicdt),
     *   alpDp(iiidf,iiiegy,iiipro,iiitar,iiicdp,iiicdt),
     *   alpDpp(iiidf,iiiegy,iiipro,iiitar,iiicdp,iiicdt),
     *   betD(iiidf,iiiegy,iiipro,iiitar,iiicdp,iiicdt),
     *   betDp(iiidf,iiiegy,iiipro,iiitar,iiicdp,iiicdt),
     *   betDpp(iiidf,iiiegy,iiipro,iiitar,iiicdp,iiicdt),
     *   gamD(iiidf,iiiegy,iiipro,iiitar,iiicdp,iiicdt),
     *   delD(iiidf,iiiegy,iiipro,iiitar,iiicdp,iiicdt)
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        do iiipro=iclpro1,iclpro2
        do iiiegy=iclegy1,iclegy2
        do iiidf=1,nbpDf
         read(1,*)alpD1(iiidf,iiiegy,iiipro),
     *   betD1(iiidf,iiiegy,iiipro),
     *   betDp1(iiidf,iiiegy,iiipro),
     *   delD1(iiidf,iiiegy,iiipro)
        enddo
        enddo
        enddo

        close(1)

        goto 4 
      endif

      write(ifmt,'(a)')'inirj does not exist -> calculate tables  ...'

      engysave=engy
      maprojsave=maproj
      matargsave=matarg
      iclpros=iclpro
      icltars=icltar
      spmin=4.*q2min
      spminc=4.*q2min+2.*qcmass**2
      icltar=2
       
      do iy=1,11
        sy=spmin*(epmax/2./spmin)**((iy-1)/10.)
        iclpro=2
        icltar=2
        if(iy.eq.1)then
          fhgg01(iy)=-80.
          fhgg02(iy)=-80.
        else
          fhgg01(iy)=log(psfsh(sy,1.,1.,3))
          fhgg02(iy)=log(psfsh(sy,1.,1.,7))
        endif
	
        do iclpro=iclpro1,iclpro2    
          if(iy.eq.1)then
            fhgg11(iy,iclpro)=-80.
            fhgg12(iy,iclpro)=-80.
          else
            fhgg11(iy,iclpro)=log(psfsh(sy,1.,1.,4))
            fhgg12(iy,iclpro)=log(psfsh(sy,1.,1.,9))
          endif
          do ix=1,10
            if(ix.le.5)then
              xp=.1*2.**(ix-5)
            else
              xp=.2*(ix-5)
            endif
            if(iy.eq.1)then
              fhqg11(iy,ix,iclpro)=-80.
              fhqg12(iy,ix,iclpro)=-80.
            else
              fhqg11(iy,ix,iclpro)=log(psfsh(sy,xp,1.,5))              
              fhqg12(iy,ix,iclpro)=log(psfsh(sy,xp,1.,11))              
            endif
          enddo
	enddo
	
      do iz=1,10
        z=.1*iz

        iclpro=2
        icltar=2
        if(iy.eq.1)then
          fhgg0(iy,iz)=-80.
        else
          fhgg0(iy,iz)=log(psfsh(sy,1.,z,6)/z)
        endif
	
        do iclpro=iclpro1,iclpro2    
          if(iy.eq.1)then
            fhgg1(iy,iz,iclpro)=-80.
          else
            fhgg1(iy,iz,iclpro)=log(psfsh(sy,1.,z,8)/z)
          endif
        
          do ix=1,10
            if(ix.le.5)then
              xp=.1*2.**(ix-5)
            else
              xp=.2*(ix-5)
            endif
            if(iy.eq.1)then
              fhqg1(iy,ix,iz+10*(iclpro-1))=-80.
            else
              fhqg1(iy,ix,iz+10*(iclpro-1))=log(psfsh(sy,xp,z,10)/z) 
            endif
          enddo
        enddo
      enddo
      enddo
            
      do iclpro=iclpro1,iclpro2 !hadron type (1 - pion, 2 - nucleon, 3 - kaon)
      do icltar=icltar1,icltar2 !hadron type (1 - pion, 2 - nucleon, 3 - kaon)
        do iy=1,11
          sy=spmin*(epmax/2./spmin)**((iy-1)/10.)
          syc=spminc*(epmax/2./spminc)**((iy-1)/10.)
          do iz=1,10 
            z=.1*iz
            if(iy.eq.1)then
              fhgg(iy,iz,iclpro+4*(icltar-1))=-80.
            else
              fhgg(iy,iz,iclpro+4*(icltar-1))=log(psfsh(sy,1.,z,0)/z)
            endif
            
          do ix=1,10
            if(ix.le.5)then
              xp=.1*2.**(ix-5)
            else
              xp=.2*(ix-5)
            endif
            if(iy.eq.1)then
              fhqg(iy,ix,iz+10*(iclpro+4*(icltar-1)-1))=-80.
              fhgq(iy,ix,iz+10*(iclpro+4*(icltar-1)-1))=-80.
            else
              if(iclpro.ne.4)then
                syx=sy
              else
                syx=syc
              endif
              fhqg(iy,ix,iz+10*(iclpro+4*(icltar-1)-1))=
     *        log(psfsh(syx,xp,z,1)/z)
              if(icltar.ne.4)then
                syx=sy
              else
                syx=syc
              endif
              fhgq(iy,ix,iz+10*(iclpro+4*(icltar-1)-1))=
     *        log(psfsh(syx,xp,z,2)/z)
            endif
          enddo
          enddo
            
          do ix1=1,10
            if(ix1.le.5)then
              xpp=.1*2.**(ix1-5)
            else
              xpp=.2*(ix1-5)
            endif
          do ix2=1,10
            if(ix2.le.5)then
              xmm=.1*2.**(ix2-5)
            else
              xmm=.2*(ix2-5)
            endif

            if(iy.eq.1)then
              fhqq(iy,ix1,ix2+10*(iclpro+4*(icltar-1)-1))=-80.
            else
              if(iclpro.ne.4.and.icltar.ne.4)then
                syx=sy
              else
                syx=syc
              endif
              fhqq(iy,ix1,ix2+10*(iclpro+4*(icltar-1)-1))=
     *        log(pshard(syx,xpp,xmm))
            endif
          enddo
          enddo
        enddo        
      enddo

      enddo
      

      call Kfit(-1)

      write(ifmt,'(a,i2)')'calculate fit for iscreen',iscreen

      do iclegy=iclegy2,iclegy1,-1
      do iclpro=iclpro1,iclpro2 !hadron type (1 - pion, 2 - nucleon, 3 - kaon) 
      do icltar=icltar1,icltar2 !hadron type (1 - pion, 2 - nucleon, 3 - kaon)
      do icdp=icdp1,icdp2  !hadron excitation type (projectile)
      do icdt=icdt1,icdt2  !hadron excitation type (target)
        write(ifmt,'(a)')'calculate second fit parameters ...'
        write(ifmt,'(a,i2)')'projtl excit:',icdp
        write(ifmt,'(a,i2)')'target excit:',icdt
        write(ifmt,'(a,i2)')'projtl class:',iclpro
        write(ifmt,'(a,i2)')'target class:',icltar
        write(ifmt,'(a,i2)')'energy class:',iclegy
        call param
c        if(isetcs.ne.1)call Kfit(iclegy)      
      enddo
      enddo
      icdp=icdps
      icdt=icdts
      enddo
      call param2
      enddo
      enddo


      
      iclegy=iclegy2
      do iclpro=iclpro1,iclpro2  !hadron type 
        cgaml=utgam1(1.+alplea(iclpro))         
      do i1=1,nbpDf
        del1=betD1(i1,iclegy,iclpro)
        alp1=betDp1(i1,iclegy,iclpro)-alppar
        cgamp1=utgam1(1.+del1+alp1)
c        cgami1=utgam1(1.+del1-alppar)
        coefu1(i1,iclpro)=cgamp1*cgaml
     *  /utgam1(2.+del1+alp1+alplea(iclpro))

        do ix1=1,10  
          if(ix1.le.5)then
            zz=.04*(ix1-1)
          else
            zz=.2*(ix1-5)
          endif
	  if(ix1.eq.10)then
            coefxu1(i1,iclpro,ix1)=0.
	  else
            coefxu1(i1,iclpro,ix1)=pscoef(zz,del1+alp1,0.,iclpro,1)
c	    write(*,*)'u1',pscoefi(zz,i1,0,iclpro,1)
c     *      ,coefxu1(i1,iclpro,ix1),coefu1(i1,iclpro)
	  endif
	enddo
      do i2=1,nbpDf
        del2=betD1(i2,iclegy,iclpro)
        alp2=betDp1(i2,iclegy,iclpro)-alppar
        cgamp2=utgam1(1.+del2+alp2)
c        cgami2=utgam1(1.+del2-alppar)
        coefu2(i1+nbpDf*(i2-1),iclpro)=cgamp1*cgamp2*cgaml
     *  /utgam1(3.+del1+del2+alp1+alp2+alplea(iclpro))
        coefc2(i1+nbpDf*(i2-1),iclpro)=cgamp1*cgamp2
     *  /utgam1(2.+del1+del2+alp1+alp2)

        do ix1=1,10  
          if(ix1.le.5)then
            zz=.02*(ix1-1)
          else
            zz=.1*(ix1-5)
          endif
	  if(ix1.eq.10)then
            coefxu2(i1,i2,iclpro,ix1)=0.
            coefxc2(i1,i2,iclpro,ix1)=0.
	  else
            coefxu2(i1,i2,iclpro,ix1)
     *      =pscoef(zz,del1+alp1,del2+alp2,iclpro,2)
            coefxc2(i1,i2,iclpro,ix1)
     *      =pscoef(zz,del1+alp1,del2+alp2,iclpro,0)
c	    write(*,*)'u2,c2',pscoefi(zz,i1,i2,iclpro,2)
c     *      ,coefxu2(i1,i2,iclpro,ix1),coefu2(i1+nbpDf*(i2-1),iclpro)
c     *      ,pscoefi(zz,i1,i2,iclpro,0)
c     *      ,coefxc2(i1,i2,iclpro,ix1),coefc2(i1+nbpDf*(i2-1),iclpro)
	  endif
	enddo
      do i3=1,nbpDf
        del3=betD1(i3,iclegy,iclpro)
        alp3=betDp1(i3,iclegy,iclpro)-alppar
        cgamp3=utgam1(1.+del3+alp3)
c        cgami3=utgam1(1.+del3-alppar)
        coefu3(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1),iclpro)
     *  =cgamp1*cgamp2*cgamp3*cgaml
     *  /utgam1(4.+del1+del2+del3+alp1+alp2+alp3+alplea(iclpro))
        coefc3(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1),iclpro)
     *  =cgamp1*cgamp2*cgamp3
     *  /utgam1(3.+del1+del2+del3+alp1+alp2+alp3)
      do i4=1,nbpDf
        del4=betD1(i4,iclegy,iclpro)
        alp4=betDp1(i4,iclegy,iclpro)-alppar
        cgamp4=utgam1(1.+del4+alp4)
c        cgami4=utgam1(1.+del4-alppar)
        coefu4(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)
     *  +nbpDf*nbpDf*nbpDf*(i4-1),iclpro)
     *  =cgamp1*cgamp2*cgamp3*cgamp4*cgaml
     *  /utgam1(5.+del1+del2+del3+del4
     *  +alp1+alp2+alp3+alp4+alplea(iclpro))
        coefc4(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)
     *  +nbpDf*nbpDf*nbpDf*(i4-1),iclpro)
     *  =cgamp1*cgamp2*cgamp3*cgamp4
     *  /utgam1(4.+del1+del2+del3+del4+alp1+alp2+alp3+alp4)
      do i5=1,nbpDf
        del5=betD1(i5,iclegy,iclpro)
        alp5=betDp1(i5,iclegy,iclpro)-alppar
        cgamp5=utgam1(1.+del5+alp5)
c        cgami5=utgam1(1.+del5-alppar)
        coefu5(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)+nbpDf*nbpDf
     *  *nbpDf*(i4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(i5-1),iclpro)
     *  =cgamp1*cgamp2*cgamp3*cgamp4*cgamp5*cgaml
     *  /utgam1(6.+del1+del2+del3+del4+del5
     *  +alp1+alp2+alp3+alp4+alp5+alplea(iclpro))
        coefc5(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)+nbpDf*nbpDf
     *  *nbpDf*(i4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(i5-1),iclpro)
     *  =cgamp1*cgamp2*cgamp3*cgamp4*cgamp5
     *  /utgam1(5.+del1+del2+del3+del4+del5+alp1+alp2+alp3+alp4+alp5)
      do i6=1,nbpDf
        del6=betD1(i6,iclegy,iclpro)
        alp6=betDp1(i6,iclegy,iclpro)-alppar
        cgamp6=utgam1(1.+del6+alp6)
c        cgami6=utgam1(1.+del6-alppar)
        coefu6(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)
     *  +nbpDf*nbpDf*nbpDf*(i4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(i5-1)
     *  +nbpDf*nbpDf*nbpDf*nbpDf*nbpDf*(i6-1),iclpro)
     *  =cgamp1*cgamp2*cgamp3*cgamp4*cgamp5*cgamp6*cgaml
     *  /utgam1(7.+del1+del2+del3+del4+del5+del6
     *  +alp1+alp2+alp3+alp4+alp5+alp6+alplea(iclpro))
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo

            
      write(ifmt,'(a)')'write to inirj ...'
      open(1,file=fnrj,status='unknown')
      write (1,*)alpqua,alplea,alppom,slopom,gamhad,r2had,chad,
     *qcdlam,q2min,q2ini,betpom,glusea,naflav,factk,pt2cut
      write (1,*)fhgg,fhqg,fhgq,fhqq,fhgg0,fhgg1,fhqg1
     *,fhgg01,fhgg02,fhgg11,fhgg12,fhqg11,fhqg12
     *,ftoint,vfro,ftounc,vnorm,coefxu1,coefxu2,coefxc2
     *,coefu1,coefu2,coefu3,coefu4,coefu5,coefu6
     *,coefc2,coefc3,coefc4,coefc5
      write(1,*)bkbin,iclpro1,iclpro2,icltar1,icltar2,iclegy1,iclegy2
     *,egylow,egyfac,iomega,icdp1,icdp2,icdt1,icdt2,Esmax,epscr,epscrp
      do iiipro=iclpro1,iclpro2
       do iiitar=icltar1,icltar2
        do iiiegy=iclegy1,iclegy2
        do iiicdp=icdp1,icdp2   
        do iiicdt=icdt1,icdt2
        do iiib=1,20
          write(1,*)xkappafit(iiiegy,iiipro,iiitar,iiicdp,iiicdt,iiib)
        enddo
        do iiidf=nbpDf0,nbpDf1
         write(1,*)alpD(iiidf,iiiegy,iiipro,iiitar,iiicdp,iiicdt),
     *   alpDp(iiidf,iiiegy,iiipro,iiitar,iiicdp,iiicdt),
     *   alpDpp(iiidf,iiiegy,iiipro,iiitar,iiicdp,iiicdt),
     *   betD(iiidf,iiiegy,iiipro,iiitar,iiicdp,iiicdt),
     *   betDp(iiidf,iiiegy,iiipro,iiitar,iiicdp,iiicdt),
     *   betDpp(iiidf,iiiegy,iiipro,iiitar,iiicdp,iiicdt),
     *   gamD(iiidf,iiiegy,iiipro,iiitar,iiicdp,iiicdt),
     *   delD(iiidf,iiiegy,iiipro,iiitar,iiicdp,iiicdt)
        enddo
        enddo
        enddo
        enddo
       enddo
      enddo
      do iiipro=iclpro1,iclpro2
        do iiiegy=iclegy1,iclegy2
        do iiidf=1,nbpDf
         write(1,*)alpD1(iiidf,iiiegy,iiipro),
     *   betD1(iiidf,iiiegy,iiipro),
     *   betDp1(iiidf,iiiegy,iiipro),
     *   delD1(iiidf,iiiegy,iiipro)
        enddo
        enddo
      enddo
      
      close(1)

      engy=engysave
      maproj=maprojsave
      matarg=matargsave
      iclpro=iclpros
      icltar=icltars
      goto 5

4     continue

c--------------------------------------
c inelastic cross sections
c---------------------------------------

      if(isetcs.ge.2)then

      if(ish.ge.4)write(ifch,*)'cross sections ...'
 6    continue
      inquire(file=fncs,exist=lcalc)
      if(lcalc)then
        write(ifmt,'(a)')'read from inics ...'
        open(1,file=fncs,status='old')
        read (1,*)alpqua0,alplea0,alppom0,slopom0,
     *  gamhad0,r2had0,chad0,
     *  qcdlam0,q2min0,q2ini0,betpom0,glusea0,naflav0,
     *  factk0,pt2cut0
        if(alpqua0.ne.alpqua)write(ifmt,'(a,2f8.4)')
     *  'inics: wrong alpqua',alpqua0,alpqua
        if(alppom0.ne.alppom)write(ifmt,'(a,2f8.4)')
     *  'inics: wrong alppom',alppom0,alppom
        if(slopom0.ne.slopom)write(ifmt,'(a,2f8.4)')
     *  'inics: wrong slopom',slopom0,slopom
        iii=2
        if(gamhad0(iii).ne.gamhad(iii))write(ifmt,'(a,i1,a,2f8.4)')
     *  'inics: wrong gamhad(',iii,')',gamhad0(iii),gamhad(iii)
        do iii=1,3 
        if(r2had0(iii) .ne.r2had(iii) )write(ifmt,'(a,i1,a,2f8.4)')
     *  'inics: wrong r2had(',iii,')',r2had0(iii),r2had(iii)
        if(chad0(iii)  .ne.chad(iii)  )write(ifmt,'(a,i1,a,2f8.4)')
     *  'inics: wrong chad(',iii,')',chad0(iii),chad(iii)
        if(alplea0(iii).ne.alplea0(iii))write(ifmt,'(a,i1,a,2f8.4)')
     *  'inics: wrong alplea(',iii,')',alplea0(iii),alplea(iii)
        enddo
        if(qcdlam0.ne.qcdlam)write(ifmt,'(a,2f8.4)')
     *  'inics: wrong qcdlam',qcdlam0,qcdlam
        if(q2min0 .ne.q2min )write(ifmt,'(a,2f8.4)')
     *  'inics: wrong q2min',q2min0,q2min
        if(q2ini0 .ne.q2ini )write(ifmt,'(a,2f8.4)')
     *  'inics: wrong q2ini',q2ini0,q2ini
        if(betpom0.ne.betpom)write(ifmt,'(a,2f8.4)')
     *  'inics: wrong betpom',betpom0,betpom
        if(glusea0.ne.glusea)write(ifmt,'(a,2f8.4)')
     *  'inics: wrong glusea',glusea0,glusea
        if(naflav0.ne.naflav)write(ifmt,'(a,2f8.4)')
     *  'inics: wrong naflav',naflav0,naflav
        if(factk0 .ne.factk )write(ifmt,'(a,2f8.4)')
     *  'inics: wrong factk', factk0,factk
        if(pt2cut0 .ne.pt2cut )write(ifmt,'(a,2f8.4)')
     *  'inics: wrong pt2cut', pt2cut0,pt2cut
        if(alpqua0.ne.alpqua.or.alppom0.ne.alppom
     *  .or.slopom0.ne.slopom.or.gamhad0(2).ne.gamhad(2)
     *  .or.r2had0(1).ne.r2had(1).or.r2had0(2).ne.r2had(2)
     *  .or.r2had0(3).ne.r2had(3)
     *  .or.chad0(1).ne.chad(1).or.chad0(2).ne.chad(2)
     *  .or.chad0(3).ne.chad(3)
     *  .or.alplea0(1).ne.alplea(1).or.alplea0(2).ne.alplea(2)
     *  .or.alplea0(3).ne.alplea(3)
     *  .or.qcdlam0.ne.qcdlam.or.q2min0 .ne.q2min
     *  .or.q2ini0 .ne.q2ini
     *  .or.betpom0.ne.betpom.or.glusea0.ne.glusea.or.naflav0.ne.naflav
     *  .or.factk0 .ne.factk .or.pt2cut0.ne.pt2cut)then
           write(ifmt,'(//a//)')'   inics has to be reinitialized!!!!'
           stop
        endif

        read(1,*)bkbin0,iclpro10,iclpro20,icltar10,icltar20,iclegy10
     *   ,iclegy20,egylow0,egyfac0,iomega0,icdp10,icdp20,icdt10,icdt20
     *            ,Esmax0,epscr0,epscrp0
        
        if(iclpro10.ne.iclpro1)write(ifmt,'(a,2i2)')
     *  'inics: wrong iclpro1',iclpro10,iclpro1
        if(iclpro20.ne.iclpro2)write(ifmt,'(a,2i2)')
     *  'inics: wrong iclpro2',iclpro20,iclpro2
        if(icltar10.ne.icltar1)write(ifmt,'(a,2i2)')
     *  'inics: wrong icltar1',icltar10,icltar1
        if(icltar20.ne.icltar2)write(ifmt,'(a,2i2)')
     *  'inics: wrong icltar2',icltar20,icltar2
        if(iclegy10.ne.iclegy1)write(ifmt,'(a,2i4)')
     *  'inics: wrong iclegy1',iclegy10,iclegy1
        if(iclegy20.ne.iclegy2)write(ifmt,'(a,2i4)')
     *  'inics: wrong iclegy2',iclegy20,iclegy2
        if(egylow0.ne.egylow)write(ifmt,'(a,2f8.4)')
     *  'inics: wrong egylow',egylow0,egylow
        if(egyfac0.ne.egyfac)write(ifmt,'(a,2f12.4)')
     *  'inics: wrong egyfac',egyfac0,egyfac
        if(icdp10.ne.icdp1)write(ifmt,'(a,2i2)')
     *  'inics: wrong icdp1',icdp10,icdp1
        if(icdp20.ne.icdp2)write(ifmt,'(a,2i2)')
     *  'inics: wrong icdp2',icdp20,icdp2
        if(icdt10.ne.icdt1)write(ifmt,'(a,2i2)')
     *  'inics: wrong icdt1',icdt10,icdt1
        if(icdt20.ne.icdt2)write(ifmt,'(a,2i2)')
     *  'inics: wrong icdt2',icdt20,icdt2
        if(Esmax0.ne.Esmax)write(ifmt,'(a,2f8.4)')
     *  'inics: wrong Esmax ',Esmax0,Esmax
        if(epscr0.ne.epscr)write(ifmt,'(a,2f8.4)')
     *  'inics: wrong epscr',epscr0,epscr
        if(epscrp0.ne.epscrp)write(ifmt,'(a,2f8.4)')
     *  'inics: wrong epscrp',epscrp0,epscrp
        if(bkbin0.ne.bkbin)write(ifmt,'(a,2f8.4)')
     *  'inics: wrong bkbin',bkbin0,bkbin
        if(iclpro10.ne.iclpro1.or.iclpro20.ne.iclpro2
     *   .or.icltar10.ne.icltar1.or.icltar20.ne.icltar2 
     *   .or.iclegy10.ne.iclegy1.or.iclegy20.ne.iclegy2
     *   .or.egylow0.ne.egylow.or.egyfac0.ne.egyfac
     *   .or.icdp10.ne.icdp1.or.icdp20.ne.icdp2 
     *   .or.icdt10.ne.icdt1.or.icdt20.ne.icdt2 
     *   .or.Esmax0.ne.Esmax.or.epscr0.ne.epscr.or.bkbin0.ne.bkbin 
     *   .or.epscrp0.ne.epscrp)then
           write(ifmt,'(//a//)')'   inics has to be reinitialized!!!!'
           stop
        endif
        if(isetcs.eq.2)then
          read (1,*)asect,asect2,asectn
        elseif(isetcs.eq.3)then
          read (1,*)asect1,asect,asectn
        else
           write(ifmt,'(//a//)')' Wrong isetcs in psaini !!!!'
        endif

        close(1)
            
       
        goto 7    

      endif

      idprojsave=idproj
      ldtargsave=idtarg
      laprojsave=laproj
      latargsave=latarg
      maprojsave=maproj
      matargsave=matarg
      icltarsave=icltar
      iclprosave=iclpro
      engysave=engy
      pnllsave=pnll
      elabsave=elab
      ecmssave=ecms
      iclegysave=iclegy
      nrevtsave=nrevt
      neventsave=nevent
      ntevtsave=ntevt
      isetcssave=isetcs
      noebinsave=noebin
      isigmasave=isigma
      ifradesave=ifrade

      isetcs=0
      isigma=0
      noebin=1
      nevent=100
      ifrade=0
      idtarg=1120

      write(ifmt,'(a)')'inics does not exist -> calculate tables  ...'
        
      if(icdp1.ne.2.or.icdp2.ne.2.or.icdt1.ne.2.or.icdt2.ne.2)then
        write(ifmt,'(//a//)')
     *       ' Wrong icdp or icdt for cross section (only =2)'
        stop
      endif



      laproj=-1
      maproj=1
      icltar=2

      do iclpro=1,4
        if(iclpro.lt.iclpro1.or.iclpro.gt.iclpro2)then
          do ie=1,7    
            do iia=1,7    
              asect1(ie,iclpro,iia)=0.
              asect2(ie,iclpro,iia)=0.
            enddo
          enddo
        else
      do ie=1,7    
c energy dependent factors:
        if(ie.eq.1)then
          engy=5.
        else
          engy=1.5*10.**(ie-1)
        endif
        write(ifmt,*)'  calcul.   ',ie,'  (',iclpro,')',engy
        iclegy=1+max(0,int((log(engy)-log(egylow))/log(egyfac))) 
        iclegy=min(iclegy,iclegy2)

        do iia=1,7
          matarg=2**(iia-1)        
          if(matarg.eq.1)then  !hadron-proton interaction   
            call psfz(gz1,gz2,0.)
            gin=(2./chad(iclpro)/chad(icltar)*gz1
     *      -1./(chad(iclpro)*chad(icltar))**2*(2.*gz1-gz2))*pi*10.
            asect1(ie,iclpro,iia)=log(gin)
          else
	  
            if(matarg.gt.10)then
c             rad=1.19*matarg**0.33333-1.38*matarg**(-0.33333) !option 1
c             rad=0.7*float(matarg)**.446                    !option 2
              rad=1.12*matarg**0.33333-0.86*matarg**(-0.33333) !option 3
            else
              rad=.9*float(matarg)**.3333
              if(matarg.eq.2)rad=3.16
            endif
            bm=rad+2.   
            rrr=rad/amws         
            rrrm=rrr+log(9.)    
            anorm=1.5/pi/rrr**3/(1.+(pi/rrr)**2)/amws**2
            gin=(ptgau(bm)+ptgau1(bm))*10.  !sig_in
            if(ish.ge.3)write (ifch,226)gin
226         format(2x,'psaini: hadron-nucleus cross sections:'/
     *      4x,'gin=',e10.3)
            asect1(ie,iclpro,iia)=log(gin)
          endif
        enddo
      enddo
      

      if(iclpro.eq.1)then
        idproj=120
      elseif(iclpro.eq.2)then
        idproj=1120
      elseif(iclpro.eq.3)then
        idproj=130
      endif

      do ie=1,7
        if(ie.eq.1)then
          engy=5.
        else
          engy=1.5*10.**(ie-1)
        endif
        if(engy.ge.egymin.and.engy.le.egymax)then
        write(ifmt,*)'  simul.   ',ie,'  (',iclpro,')',engy

        do iia=1,7
          if(iia.eq.1)then
            matarg=1
          else
            matarg=2**(iia-1)
          endif
          latarg=max(1,matarg/2)
          ntevt=0
          nrevt=0
          pnll=-1.
          elab=-1.
          ecms=-1.
          ekin=-1.
          call ainit
          do  n=1,nevent
            call anexus(1)
          enddo
          a=pi*bmax**2
          if(a.gt.0..and.ntevt.gt.0.)then
          write(ifmt,*)'  matarg,nevent,ntevt,a :',matarg,nevent,ntevt,a
            asect2(ie,iclpro,iia)=log(float(nevent)/float(ntevt)*a*10.)
          else
            write(ifmt,*)' Problem ? ',iclpro,matarg,bmax,ntevt
            asect2(ie,iclpro,iia)=0.
          endif
        enddo
        else
          do iia=1,7
            asect2(ie,iclpro,iia)=0.
          enddo          
        endif
      enddo

      endif
      enddo

c      goto 436  !????????????????????

      idproj=1120
      iclpro=2
      icltar=2
      do ie=1,7 
        if(ie.eq.1)then
          engy=5.
        else
          engy=1.5*10.**(ie-1)
        endif
        if(engy.ge.egymin.and.engy.le.egymax)then
        write(ifmt,*)'  simul. AB   ',ie,engy

        do iia=1,7 
          if(iia.eq.1)then
            maproj=1
          else
            maproj=2**(iia-1)
          endif
          laproj=max(1,maproj/2)
        do iib=1,7 
          if(iib.eq.1)then
            matarg=1
          else
            matarg=2**(iib-1)
          endif
          latarg=max(1,matarg/2)
          ntevt=0
          nrevt=0
          pnll=-1.
          elab=-1.
          ecms=-1.
          ekin=-1.
          call ainit
          do  n=1,nevent
            call ranfgt(seedhere)
            call anexus(1)
          enddo
          a=pi*bmax**2
          if(a.gt.0..and.ntevt.gt.0.)then
          write(ifmt,*)'  maproj,matarg,nevent,ntevt,a :',maproj,matarg
     &                                                   ,nevent,ntevt,a
            asect3(ie,iia,iib)=log(float(nevent)/float(ntevt)*a*10.)
          else
            write(ifmt,*)' Problem ? ',maproj,matarg,bmax,ntevt
            asect3(ie,iia,iib)=0.
          endif
        enddo
      enddo
      else
        do iia=1,7
          do iib=1,7
            asect3(ie,iia,iib)=0.
          enddo          
        enddo          
      endif
      enddo

c 436  continue

      write(ifmt,'(a)')'write to inics ...'
      open(1,file=fncs,status='unknown')
      write (1,*)alpqua,alplea,alppom,slopom,gamhad,r2had,chad,
     *qcdlam,q2min,q2ini,betpom,glusea,naflav,factk,pt2cut
      write(1,*)bkbin,iclpro1,iclpro2,icltar1,icltar2,iclegy1,iclegy2
     *,egylow,egyfac,iomega,icdp1,icdp2,icdt1,icdt2,Esmax,epscr,epscrp
      write (1,*)asect1,asect2,asect3
      
      close(1)

      idproj=idprojsave
      ldtarg=idtargsave
      laproj=laprojsave
      latarg=latargsave
      maproj=maprojsave
      matarg=matargsave
      icltar=icltarsave
      iclpro=iclprosave
      engy=engysave
      pnll=pnllsave
      elab=elabsave
      ecms=ecmssave
      iclegy=iclegysave
      nrevt=nrevtsave
      nevent=neventsave
      ntevt=ntevtsave
      isetcs=isetcssave
      noebin=noebinsave
      isigma=isigmasave
      ifrade=ifradesave

      goto 6

 7    continue
      endif
      call utprix('psaini',ish,ishini,4)

      icdp=icdps
      icdt=icdts

      return
      end


c------------------------------------------------------------------------
      function psfsh1(sy,xpp,xpm,z,iqq)
c-----------------------------------------------------------------------
c psfsh1 - integrated semihard interaction eikonal
c sy - energy squared for the hard interaction,
c z - impact parameter factor, z=exp(-b**2/rp),
c iqq - type of the hard interaction: 
c 0  - soft, 1 - gg, 2 - qg, 3 - gq
c-----------------------------------------------------------------------
      common /ar3/    x1(7),a1(7)
      common /ar9/    x9(3),a9(3)
      include 'nexus.inc'
      include 'nexus.incsem'
      fsy(zsy)=zsy**dels   !*(1.-1./zsy)**betpom

      psfsh1=0.
      if(iclpro.eq.4.and.iqq.eq.2.or.icltar.eq.4.and.iqq.eq.3)then
        spmin=4.*q2min+2.*qcmass**2
      elseif(iqq.ne.0)then
        spmin=4.*q2min
      else
        spmin=0.  
      endif
      if(sy.le.spmin)return
            
      rp=r2had(iclpro)+r2had(icltar)+slopom*log(max(1.,sy))
      alpq=(alppar+1.)/2.
      if(iqq.eq.3)then
        iclt=iclpro
        iclp=icltar
      else
        iclp=iclpro
        iclt=icltar
      endif
      
      if(iqq.eq.0)then
        xpmax=(1.-spmin/sy)**(1.+alplea(iclp))
        do i=1,3
        do m=1,2
          xp=1.-(xpmax*(.5+x9(i)*(m-1.5)))**(1./(1.+alplea(iclp)))
	  xmmax=(1.-spmin/sy/xp)**(1.+alplea(iclt))
          do i1=1,3
          do m1=1,2
            xm=1.-(xmmax*(.5+x9(i1)*(m1-1.5)))**(1./(1.+alplea(iclt)))
      
            sy1=sy*xp*xm
            rh=r2had(iclpro)+r2had(icltar)+slopom*log(max(1.,sy1))
            psfsh1=psfsh1+a9(i)*a9(i1)*fsy(sy1)*xmmax*z**(rp/rh)/rh
     *      *(xp*xm)**(-alppar)
          enddo
          enddo
        enddo
        enddo
        psfsh1=psfsh1*xpmax/(1.+alplea(iclp))/(1.+alplea(iclt))
     *  *chad(iclpro)*chad(icltar)*gamhad(iclpro)*gamhad(icltar)
     *  *(xpp*xpm)**(1.-alppar)/4.
        return
      else
            
        xmin=(spmin/sy)**(delh-dels)
        do i=1,3
        do m=1,2
          zh=(.5*(1.+xmin-(2*m-3)*x9(i)*(1.-xmin)))**(1./(delh-dels))
          if(iclpro.eq.4.and.iqq.eq.2.or.icltar.eq.4.and.iqq.eq.3)then
            call psjti0(zh*sy,sgq,sgqb,4,0)
            call psjti0(zh*sy,sqq,sqqb,4,1)
          else
            call psjti0(zh*sy,sgg,sggb,0,0) 
            call psjti0(zh*sy,sgq,sgqb,0,1)
            call psjti0(zh*sy,sqq,sqqb,1,1)
            call psjti0(zh*sy,sqaq,sqaqb,-1,1)
            call psjti0(zh*sy,sqqp,sqqpb,1,2)
            sqq=(sqq+sqaq+2.*(naflav-1)*sqqp)/naflav/2.
          endif

          if(iqq.eq.1)then
            stg=0.
            do i1=1,3
            do m1=1,2
              xx=.5+x9(i1)*(m1-1.5)
              xp=zh**xx
              xm=zh/xp
	      
              xp1max=(1.-xp)**(1.+alplea(iclp))
	      xm1max=(1.-xm)**(1.+alplea(iclt))
              do i2=1,3
              do m2=1,2
                xp1=1.-(xp1max*(.5+x9(i2)*(m2-1.5)))
     *          **(1./(1.+alplea(iclp)))
                do i3=1,3
                do m3=1,2
                  xm1=1.-(xm1max*(.5+x9(i3)*(m3-1.5)))
     *            **(1./(1.+alplea(iclt)))
                  if(xp1.lt.xp.or.xm1.lt.xm)write (*,*)'xp1,xm1,xp,xm'
     *            ,xp1,xm1,xp,xm
      
                  rh=r2had(iclpro)+r2had(icltar)+slopom
     *            *log(xp1*xm1/xp/xm)
                  glu1=(1.-xp/xp1)**betpom*(1.-glusea)
                  sea1=psftilf(xp/xp1)*glusea
                  glu2=(1.-xm/xm1)**betpom*(1.-glusea)
                  sea2=psftilf(xm/xm1)*glusea
                  stg=stg+a9(i1)*a9(i2)*a9(i3)*(glu1*glu2*sgg
     *            +(glu1*sea2+sea1*glu2)*sgq+sea1*sea2*sqq)
     *            *xp1max*xm1max*(xp1*xm1)**(dels-alppar)
     *            *z**(rp/rh)/rh
                enddo
                enddo
              enddo
              enddo
            enddo
            enddo
            psfsh1=psfsh1-a9(i)*log(zh)*stg/zh**delh
          
          else
            stq=0.
	    xpmin=zh**(dels+.5)
            do i1=1,3
            do m1=1,2
              xp=(.5*(1.+xpmin-(2*m1-3)*x9(i1)*(1.-xpmin)))
     *        **(1./(dels+.5))
              xm=zh/xp
              if(xp*xpp.lt..99999)then
                uv1=psdfh4(xp*xpp,q2min,0.,iclp,1)
                dv1=psdfh4(xp*xpp,q2min,0.,iclp,2)
	        xm1max=(1.-xm)**(1.+alplea(iclt))
                do i2=1,3
                do m2=1,2
                  xm1=1.-(xm1max*(.5+x9(i2)*(m2-1.5)))
     *            **(1./(1.+alplea(iclt)))
      
                  rh=r2had(iclpro)+r2had(icltar)+slopom*log(xm1/xm)
                  glu2=(1.-xm/xm1)**betpom*(1.-glusea)
                  sea2=psftilf(xm/xm1)*glusea
                  stq=stq+a9(i1)*a9(i2)*(glu2*sgq+sea2*sqq)*(uv1+dv1)
     *            *z**(rp/rh)/rh*xm1max*xm1**(dels-alppar)/sqrt(xp)
     *            *((1.-xp)/(1.-xp*xpp))**(1.-alpq+alplea(iclp))
                enddo
                enddo
              endif
            enddo
            enddo
            stq=stq*(1.-xpmin)
            psfsh1=psfsh1+a9(i)*stq/zh**delh
          endif
        enddo
        enddo
      endif

      psfsh1=psfsh1*(1.-xmin)/(delh-dels)
      if(iqq.eq.1)then
        psfsh1=psfsh1*chad(iclp)*chad(iclt)*gamhad(iclp)
     *  *gamhad(iclt)*rr**2*(xpp*xpm)**(1.-alppar)
     *  /(1.+alplea(iclp))/(1.+alplea(iclt))*pi/8.*factk
      else
        psfsh1=psfsh1*chad(iclp)*chad(iclt)*rr*gamhad(iclt)
     *  *xpp**(1.-alpq)*xpm**(1.-alppar)/(.5+dels)
     *  /(1.+alplea(iclt))/16.*factk
      endif
      return
      end

c------------------------------------------------------------------------
      function psfsh(sy,xpp,z,iqq)
c-----------------------------------------------------------------------
c psfsh - semihard interaction eikonal
c sy  - energy squared for the hard interaction,
c z   - impact parameter factor, z=exp(-b**2/rp),
c iqq - type of the hard interaction: 
c   0 - gg, 1 - qg, 2 - gq, 3 - gg(int), 4 - gg(proj), 5 - qg(proj),
c   6 - gg(int)|b=0, 7 - <b^2*gg(int)>, 8 - gg(proj)|b=0,
c   9 - <b^2*gg(proj)>, 10 - qg(proj)|b=0, 11 - <b^2*qg(proj)>
c-----------------------------------------------------------------------
      common /ar3/    x1(7),a1(7)
      common /psar7/  delx,alam3p,gam3p
      include 'nexus.inc'
      include 'nexus.incsem'

      psfsh=0.
      if(iqq.eq.0.or.iqq.eq.3.or.iqq.eq.4
     *.or.iqq.eq.6.or.iqq.eq.7.or.iqq.eq.8.or.iqq.eq.9
     *.or.iclpro.ne.4.and.(iqq.eq.1.or.iqq.eq.5
     *.or.iqq.eq.10.or.iqq.eq.11)
     *.or.icltar.ne.4.and.iqq.eq.2)then
        spmin=4.*q2min
      else
        spmin=4.*q2min+2.*qcmass**2
      endif
      if(sy.le.spmin)return
            
      if(iqq.eq.1.or.iqq.eq.5.or.iqq.eq.10.or.iqq.eq.11)then
        iclv=iclpro
        icls=icltar
      elseif(iqq.eq.2)then
        icls=iclpro
        iclv=icltar
      endif
      
      xmin=spmin/sy
      xmin=xmin**(delh-dels)
      rp=r2had(iclpro)+r2had(icltar)+slopom*log(max(1.,sy))
      alpq=(alppar+1.)/2.

c numerical integration over zh
      do i=1,7
      do m=1,2
        zh=(.5*(1.+xmin-(2*m-3)*x1(i)*(1.-xmin)))**(1./
     *  (delh-dels))
        if(iqq.eq.0.or.iqq.eq.3.or.iqq.eq.4
     *  .or.iqq.eq.6.or.iqq.eq.7.or.iqq.eq.8.or.iqq.eq.9
     *  .or.iclpro.ne.4.and.(iqq.eq.1.or.iqq.eq.5
     *  .or.iqq.eq.10.or.iqq.eq.11)
     *  .or.icltar.ne.4.and.iqq.eq.2)then
          call psjti0(zh*sy,sgg,sggb,0,0)  !inclusive (sj) and born (sjb)
          call psjti0(zh*sy,sgq,sgqb,0,1)
          call psjti0(zh*sy,sqq,sqqb,1,1)
          call psjti0(zh*sy,sqaq,sqaqb,-1,1)
          call psjti0(zh*sy,sqqp,sqqpb,1,2)
          sqq=(sqq+sqaq+2.*(naflav-1)*sqqp)/naflav/2.
        else
          call psjti0(zh*sy,sgq,sgqb,4,0)
          call psjti0(zh*sy,sqq,sqqb,4,1)
        endif

        if(iqq.eq.0.or.iqq.eq.3.or.iqq.eq.4
     *  .or.iqq.eq.6.or.iqq.eq.7.or.iqq.eq.8.or.iqq.eq.9)then
          stg=0.
          do i1=1,7
          do m1=1,2
            xx=.5+x1(i1)*(m1-1.5)
            xp=zh**xx
            xm=zh/xp
            glu1=(1.-xp)**betpom*(1.-glusea)
            sea1=psftilf(xp)*glusea
            glu2=(1.-xm)**betpom*(1.-glusea)
            sea2=psftilf(xm)*glusea
            if(iqq.eq.0)then
              rh=r2had(iclpro)+r2had(icltar)-slopom*log(zh)
            elseif(iqq.eq.3.or.iqq.eq.4)then
              rh=1.
            elseif(iqq.eq.6.or.iqq.eq.7)then
              rh=alam3p-slopom*log(zh)
            elseif(iqq.eq.8.or.iqq.eq.9)then
              rh=r2had(iclpro)+.5*alam3p-slopom*log(zh)
            endif
            dstg=(glu1*glu2*sgg+
     *      (glu1*sea2+sea1*glu2)*sgq+sea1*sea2*sqq)
     *      *z**(rp/rh)/rh
            if(iqq.eq.7.or.iqq.eq.9)dstg=dstg*rh**2
	    stg=stg+a1(i1)*dstg
          enddo
          enddo
          psfsh=psfsh-a1(i)*log(zh)*stg/zh**delh
          
        else
          stq=0.
          tmax=acos(sqrt(zh))
          do i1=1,7
          do m1=1,2
            t=tmax*(.5+x1(i1)*(m1-1.5))
            xp=cos(t)**2
            xm=zh/xp
            if(xp*xpp.lt..99999)then
              uv1=psdfh4(xp*xpp,q2min,0.,iclv,1)
              dv1=psdfh4(xp*xpp,q2min,0.,iclv,2)
              glu2=(1.-xm)**betpom*(1.-glusea)
              sea2=psftilf(xm)*glusea
              if(iqq.le.2)then
                rh=r2had(iclpro)+r2had(icltar)-slopom*log(xm)
              elseif(iqq.eq.5)then
                rh=1.
              elseif(iqq.le.10.or.iqq.le.11)then
                rh=r2had(iclpro)+.5*alam3p-slopom*log(xm)
              endif
              dstq=(glu2*sgq+sea2*sqq)*(uv1+dv1)
     *        *z**(rp/rh)/rh
     *        *(1.-xp*xpp)**(-1.+alpq-alplea(iclv))
     *        *xp**(dels-.5)*(1.-xp)**(-alpq+.5)
              if(iqq.eq.11)dstq=dstq*rh**2
              stq=stq+a1(i1)*dstq
            endif
          enddo
          enddo
          stq=stq*tmax
          psfsh=psfsh+a1(i)*stq/zh**delh
        endif
      enddo
      enddo

      psfsh=psfsh*(1.-xmin)/(delh-dels)/sy**delh/2.
      if(iqq.eq.0)then
        psfsh=psfsh*chad(iclpro)*chad(icltar)*gamhad(iclpro)
     *  *gamhad(icltar)*rr**2*pi
      elseif(iqq.eq.3)then
        psfsh=psfsh*rr**2*pi*4.*.0389
      elseif(iqq.eq.6)then
        psfsh=psfsh*rr**2*pi
      elseif(iqq.eq.7)then
        psfsh=psfsh*rr**2*pi*(4.*.0389)**2
      elseif(iqq.eq.4.or.iqq.eq.8.or.iqq.eq.9)then
        psfsh=psfsh*rr**2*pi*chad(iclpro)*gamhad(iclpro)
        if(iqq.eq.4)psfsh=psfsh*4.*.0389
        if(iqq.eq.9)psfsh=psfsh*(4.*.0389)**2
      elseif(iqq.le.2)then
        psfsh=psfsh*chad(iclpro)*chad(icltar)*rr*gamhad(icls)
     *  *utgam1(2.+alplea(iclv)-alpq)/utgam1(1.+alplea(iclv))
     *  /utgam1(1.-alpq)/2./xpp**alpq
      elseif(iqq.eq.5.or.iqq.eq.10.or.iqq.eq.11)then
        psfsh=psfsh*chad(iclv)*rr
     *  *utgam1(2.+alplea(iclv)-alpq)/utgam1(1.+alplea(iclv))
     *  /utgam1(1.-alpq)/2./xpp**alpq
        if(iqq.eq.5)psfsh=psfsh*4.*.0389
        if(iqq.eq.11)psfsh=psfsh*(4.*.0389)**2
      endif
      return
      end

c------------------------------------------------------------------------
      function psftild(z,iclh)
c-----------------------------------------------------------------------
c psftild - auxilliary function for semihard eikonals calculation
c (proportional to gluon sf: g(z)*z^(1+dels))
c integration over semihard pomeron light cone momentum share xp
c psftild=int(dx_P) N(x_P) * x_P^dels * (1-z/x_P)**betpom
c z - light cone x of the gluon,
c iclh - hadron class
c-----------------------------------------------------------------------
      double precision xpmin,xp
      include 'nexus.inc'
      common /ar3/   x1(7),a1(7)
      include 'nexus.incsem'

      psftild=0.
      xpmin=z
      xpmin=xpmin**(1.-alppar+dels)
      do i=1,7
      do m=1,2
        xp=(.5*(1.+xpmin+(2*m-3)*x1(i)*(1.-xpmin)))**(1./
     *  (1.-alppar+dels))
        psftild=psftild+a1(i)*(1.-xp)**alplea(iclh)*(1.-z/xp)**betpom
      enddo
      enddo
      psftild=psftild*.5*(1.-xpmin)/(1.-alppar+dels)*(1.-glusea)
      return
      end

c------------------------------------------------------------------------
      function psftile(z,iclh)
c-----------------------------------------------------------------------
c psftile - auxilliary function for semihard eikonals calculation
c (proportional to sea quark sf: q_s(z)*z^(1+dels))
c integration over semihard pomeron light cone momentum share xp:
c psftile=x**(1+dels) * int(dx_P) N(x_P) * int(dx_G) (x_P/x_G)^dels
c * (1-x_G/x_P)^betpom * P_qG(x/x_G) * 1/x_G^2 = 
c = int(dx_P) N(x_P) * x_P^dels * psftilf(x/x_P)
c z - light cone x of the quark,
c iclh - hadron class
c-----------------------------------------------------------------------
      double precision xpmin,xp
      common /ar3/   x1(7),a1(7)
      include 'nexus.inc'
      include 'nexus.incsem'

      psftile=0.
      xpmin=z
      xpmin=xpmin**(1.-alppar+dels)
      do i=1,7
      do m=1,2
        xp=(.5*(1.+xpmin+(2*m-3)*x1(i)*(1.-xpmin)))**(1./
     *  (1.-alppar+dels))
        zz=z/xp
        psftile=psftile+a1(i)*(1.-xp)**alplea(iclh)*psftilf(zz)
      enddo
      enddo
      psftile=psftile*.5*(1.-xpmin)/(1.-alppar+dels)*glusea
      return
      end
    
c------------------------------------------------------------------------
      function psftilf(zz)
c-----------------------------------------------------------------------
c psftilf - auxilliary function for semihard eikonals calculation
c zz - ratio of the quark and pomeron light cone x (zz=x_G/x_P)
c integration over quark to gluon light cone momentum ratio (z=x/x_G):
c psftilf=int(dz) z^dels * (1-zz/z)^betpom * P_qG(z)
c-----------------------------------------------------------------------
      double precision zmin,z
      common /ar3/   x1(7),a1(7)
      include 'nexus.incsem'

      psftilf=0.
      zmin=zz
      zmin=zmin**(1.+dels)
      do i=1,7
      do m=1,2
        z=(.5d0*(1.+zmin+(2*m-3)*x1(i)*(1.d0-zmin)))
     *  **(1.d0/(1.d0+dels))
        psftilf=psftilf+a1(i)*max(1.d-5,(1.d0-zz/z))**betpom
     *  *(z**2+(1.-z)**2)
      enddo
      enddo
      psftilf=psftilf*1.5*(1.d0-zmin)/(1.+dels)   !1.5=naflav/2 at Q0
      return
      end
                 
c------------------------------------------------------------------------
      subroutine psfz(gz1,gz2,b)
c-----------------------------------------------------------------------
c hadron-nucleus cross sections calculation
c b - impact parameter squared
c-----------------------------------------------------------------------
      double precision PhiExpoij
      include 'nexus.inc'
      common /ar3/ x1(7),a1(7)

      gz1=0.
      gz2=0.
      e1=exp(-1.)
      rs=r2had(iclpro)+r2had(icltar)+slopom*log(engy**2)
      rpom=4.*.0389*rs

      do i1=1,7
      do m=1,2
        z=.5+x1(i1)*(m-1.5)
        zv1=exp(-z)
        zv2=(e1*z)
        b1=sqrt(-rpom*log(zv1))
        b2=sqrt(-rpom*log(zv2))
	  
        vv11=real(PhiExpoij(.5,1.d0,1.d0,engy**2,b1,2,2)) 
        vv12=real(PhiExpoij(.5,1.d0,1.d0,engy**2,b2,2,2))
        vv21=real(PhiExpoij(1.,1.d0,1.d0,engy**2,b1,2,2)) 
        vv22=real(PhiExpoij(1.,1.d0,1.d0,engy**2,b2,2,2))

        if(matarg.eq.1)then
          cg1=1.
          cg2=1.
        else
          cg1=ptrot(b,b1)
          cg2=ptrot(b,b2)
        endif

        gz1=gz1+a1(i1)*(cg1*(1.-vv11)+cg2*(1.-vv12)/z)
        gz2=gz2+a1(i1)*(cg1*(1.-vv21)+cg2*(1.-vv22)/z)
      enddo
      enddo
      gz1=gz1*rpom/2.
      gz2=gz2*rpom/2.
      return
      end   
        

c------------------------------------------------------------------------
      function ptgau(bm)
c-----------------------------------------------------------------------
c impact parameter integration for impact parameters <bm -
c for hadron-hadron and hadron-nucleus cross-sections calculation
c-----------------------------------------------------------------------
      include 'nexus.inc'
      common /ar3/ x1(7),a1(7)

      ptgau=0.
      do i=1,7
      do m=1,2
        b=bm*sqrt(.5+x1(i)*(m-1.5))
        ptgau=ptgau+ptfau(b)*a1(i)
      enddo
      enddo      
      ptgau=ptgau*bm**2*pi*.5
      return
      end

c------------------------------------------------------------------------
      function ptgau1(bm)
c-----------------------------------------------------------------------
c impact parameter integration for impact parameters >bm -
c for hadron-hadron and hadron-nucleus cross-sections calculation
c-----------------------------------------------------------------------
      include 'nexus.inc'
      common /ar5/    x5(2),a5(2)

      ptgau1=0.
      do i=1,2
        b=bm+x5(i)*amws
        ptgau1=ptgau1+ptfau(b)*a5(i)*exp(x5(i))*b*2.*pi*amws
      enddo
      return
      end

c------------------------------------------------------------------------
      function ptfau(b)
c-----------------------------------------------------------------------
c ptfau - integrands for hadron-nucleus cross-sections calculation
c-----------------------------------------------------------------------
      include 'nexus.inc'
      common /psar35/anorm
      
      call psfz(gz1,gz2,b)
      
      ptfau=2./chad(iclpro)
     **(1.-(1.-anorm/chad(icltar)*gz1)**float(matarg))
     *-1./chad(iclpro)**2
     **(1.-2.*(1.-anorm/chad(icltar)*gz1)**float(matarg)
     *+(1.-2.*anorm*(chad(icltar)-1.)/chad(icltar)**2*gz1
     *-anorm/chad(icltar)**2*gz2)**float(matarg))
      return
      end

c------------------------------------------------------------------------
      function ptrot(s,b)
c-----------------------------------------------------------------------
c convolution of nuclear profile functions (axial angle integration)
c-----------------------------------------------------------------------
      common /ar8/ x2(4),a2

      ptrot=0.
      do i=1,4
        sb1=b**2+s**2-2.*b*s*(2.*x2(i)-1.)
        sb2=b**2+s**2-2.*b*s*(1.-2.*x2(i))
       ptrot=ptrot+(pttcs(sb1)+pttcs(sb2))
      enddo
      ptrot=ptrot*a2
      return
      end

c------------------------------------------------------------------------
      function pttcs(b0)
c-----------------------------------------------------------------------
c ptt - nuclear profile function value at impact parameter squared b*amws**2
c-----------------------------------------------------------------------
      common /psar10/ amws 
      common /psar34/ rrr,rrrm
      common /ar5/    x5(2),a5(2)
      common /ar9/    x9(3),a9(3)

      b=b0/amws**2
      pttcs=0.
      zm=rrrm**2-b
      if(zm.gt.4.*b)then
        zm=sqrt(zm)
      else
        zm=2.*sqrt(b)
      endif

      do i=1,3
        z1=zm*(1.+x9(i))*0.5
        z2=zm*(1.-x9(i))*0.5
        quq=sqrt(b+z1**2)-rrr
        if (quq.lt.85.)pttcs=pttcs+a9(i)/(1.+exp(quq))
        quq=sqrt(b+z2**2)-rrr
        if (quq.lt.85.)pttcs=pttcs+a9(i)/(1.+exp(quq))
      enddo
      pttcs=pttcs*zm*0.5

      dt=0.
      do i=1,2
        z1=x5(i)+zm
        quq=sqrt(b+z1**2)-rrr-x5(i)
        if (quq.lt.85.)dt=dt+a5(i)/(exp(-x5(i))+exp(quq))
      enddo

      pttcs=pttcs+dt
      return
      end

c------------------------------------------------------------------------------
      function pscrse(ek,mapr,matg)
c------------------------------------------------------------------------------
c hadron-nucleus (hadron-proton) and nucl-nucl particle production cross section
c ek     - lab kinetic energy for the interaction
c maproj - projec mass number     (1<maproj<64)
c matarg - target mass number     (1<matarg<64)
c------------------------------------------------------------------------------
      dimension wk(3),wa(3),wb(3)
      include 'nexus.inc'
      common /psar33/ asect(7,4,7),asectn(7,7,7)

      pscrse=0.
      call idmass(1120,amt1)
      call idmass(1220,amt2)
      amtar=0.5*(amt1+amt2)
      if(matg.eq.1)amtar=amt1
      if(mapr.eq.1)then
        call idmass(idproj,ampro)
      else
        ampro=amtar
      endif
      egy=ek+ampro
      p=sqrt(max(0.,egy**2-ampro**2))   
      egy=sqrt( 2*egy*amtar+amtar**2+ampro**2 )      
      ye=log10(max(1.,egy/1.5))+1.
      je=min(5,int(ye))

      wk(2)=ye-je
      wk(3)=wk(2)*(wk(2)-1.)*.5
      wk(1)=1.-wk(2)+wk(3)
      wk(2)=wk(2)-2.*wk(3)

      ya=matg
      ya=log(ya)/.69315+1.
      ja=min(int(ya),5)
      wa(2)=ya-ja
      wa(3)=wa(2)*(wa(2)-1.)*.5
      wa(1)=1.-wa(2)+wa(3)
      wa(2)=wa(2)-2.*wa(3)

      if(mapr.eq.1)then

        do i=1,3
          do m=1,3
            pscrse=pscrse+asect(je+i-1,iclpro,ja+m-1)*wk(i)*wa(m)
          enddo
        enddo

      else

        yb=mapr
        yb=log(yb)/.69315+1.
        jb=min(int(yb),5)
        wb(2)=yb-jb
        wb(3)=wb(2)*(wb(2)-1.)*.5
        wb(1)=1.-wb(2)+wb(3)
        wb(2)=wb(2)-2.*wb(3)

        do i=1,3
          do m=1,3
            do n=1,3
        pscrse=pscrse+asectn(je+i-1,jb+n-1,ja+m-1)*wk(i)*wa(m)*wb(n)
            enddo
          enddo
        enddo

      endif

      pscrse=exp(pscrse)
      return
      end

c------------------------------------------------------------------------------
      function anxscrse(ek,mapro,matar,id)
c------------------------------------------------------------------------------
c inelastic cross section of nexus 
c (id=0 corresponds to air)
c ek     - kinetic energy for the interaction
c maproj - projec mass number     (1<maproj<64)
c matarg - target mass number     (1<matarg<64)
c------------------------------------------------------------------------------
      include 'nexus.inc'

      anxscrse=0.
      if(id.eq.0)then
        do k=1,3
          mt=int(airanxs(k))
          anxscrse=anxscrse+airwnxs(k)*pscrse(ek,mapro,mt)
        enddo
      else
        anxscrse=pscrse(ek,mapro,matar)
      endif

      return
      end


c------------------------------------------------------------------------
      function pshard1(sy,xpp,xpm,z)
c-----------------------------------------------------------------------
c pshard - qq-pomeron eikonal
c sy - energy squared for the pomeron,
c xpp - lc+ for the pomeron,
c xpm - lc- for the pomeron
c-----------------------------------------------------------------------
      common /ar3/   x1(7),a1(7)
      common /ar9/   x9(3),a9(3)
      include 'nexus.inc'
      include 'nexus.incsem'

      pshard1=0.
      if(iclpro.ne.4.and.icltar.ne.4)then
        spmin=4.*q2min
      else
        spmin=4.*q2min+2.*qcmass**2
      endif
      if(sy.le.spmin)return
      
      rp=r2had(iclpro)+r2had(icltar)+slopom*log(max(1.,sy))
      alpq=(alppar+1.)/2.
      xmin=spmin/sy             !min hard pomeron mass share
      xminl=xmin**(delh+.5)

      do i=1,3
      do m=1,2
        zh=(.5*(1.+xminl-(2*m-3)*x9(i)*(1.-xminl)))**(1./(delh+.5))
        if(iclpro.ne.4.and.icltar.ne.4)then
          call psjti0(zh*sy,sqq,sqqb,1,1)
          call psjti0(zh*sy,sqqp,sqqpb,1,2)
          call psjti0(zh*sy,sqaq,sqaqb,-1,1)
        else
          call psjti0(zh*sy,sqq,sqqb,4,1)
          sqq=0.
          sqaq=0.
        endif

        stq=0. 
        do i1=1,3
        do m1=1,2
          xx=.5+x9(i1)*(m1-1.5)
          xp=zh**xx
          xm=zh/xp
          if(xp*xpp.le..9999.and.xm*xpm.le..9999.or.
     *    xm*xpp.le..9999.and.xp*xpm.le..9999)then
          stq=stq+a9(i1)*psharf(xp*xpp,xm*xpm,sqq,sqqp,sqaq)
     *    *(1.-xp)**(1.+alplea(iclpro)-alpq)
     *    *(1.-xm)**(1.+alplea(icltar)-alpq)
          endif
        enddo
        enddo
        pshard1=pshard1-a9(i)*stq/zh**(delh+0.5)*log(zh)
      enddo
      enddo
      pshard1=pshard1*(1.-xminl)/(delh+.5)/4.*factk
     **chad(iclpro)*chad(icltar)*(xpp*xpm)**(1.-alpq)
     **z**(rp/(r2had(iclpro)+r2had(icltar)))
     */(8.*pi*(r2had(iclpro)+r2had(icltar)))
      return
      end
      
c------------------------------------------------------------------------
      function pshard(sy,xpp,xpm)
c-----------------------------------------------------------------------
c pshard - qq-pomeron eikonal
c sy - energy squared for the pomeron,
c xpp - lc+ for the pomeron,
c xpm - lc- for the pomeron
c-----------------------------------------------------------------------
      double precision z01
      common /ar3/   x1(7),a1(7)
      include 'nexus.inc'
      include 'nexus.incsem'

      pshard=0.
      if(iclpro.ne.4.and.icltar.ne.4)then
        spmin=4.*q2min
      else
        spmin=4.*q2min+2.*qcmass**2
      endif
      if(sy.le.spmin)return
      
      alpq=(alppar+1.)/2.
      xmin=spmin/sy             !min hard pomeron mass share
      xminl=xmin**(delh+.5)

      do i=1,7
      do m=1,2
        zh=(.5*(1.+xminl-(2*m-3)*x1(i)*(1.-xminl)))**(1./(delh+.5))
        if(iclpro.ne.4.and.icltar.ne.4)then
          call psjti0(zh*sy,sqq,sqqb,1,1)
          call psjti0(zh*sy,sqqp,sqqpb,1,2)
          call psjti0(zh*sy,sqaq,sqaqb,-1,1)
        else
          call psjti0(zh*sy,sqq,sqqb,4,1)
          sqq=0.
          sqaq=0.
        endif

        stq=0.  !int^1_(sqrt(z)) dx_p / x_p / sqrt(1-x_p) =int^(tmax)_(0) dt 
        tmax=sqrt(1.-sqrt(zh))        !t=ln((1+sqrt(1-x_p))/(1-sqrt(1-x_p)))
        tmax=log((1.+tmax)/(1.-tmax))
        if(tmax.gt.1.e-20)then
        do i1=1,7
        do m1=1,2
          t=tmax*(.5+x1(i1)*(m1-1.5))
          z01=((1.d0-exp(-1.d0*t))/(1.d0+exp(-1.d0*t)))**2
          xp=1.-z01
          xm=zh/xp
          if(xp*xpp.le..9999.and.xm*xpm.le..9999.or.
     *    xm*xpp.le..9999.and.xp*xpm.le..9999)then
          stq=stq+a1(i1)*(psharf(xp*xpp,xm*xpm,sqq,sqqp,sqaq)+
     *    psharf(xm*xpp,xp*xpm,sqq,sqqp,sqaq))
     *    *z01**(.5-alpq)/(1.-xm)**alpq
          endif
        enddo
        enddo
        stq=stq*tmax
        endif
        pshard=pshard+a1(i)*stq/zh**(delh+0.5)
      enddo
      enddo
      pshard=pshard*(1.-xminl)/(delh+.5)/4.*
     *utgam1(2.+alplea(iclpro)-alpq)/utgam1(1.+alplea(iclpro))/
     *utgam1(1.-alpq)*
     *utgam1(2.+alplea(icltar)-alpq)/utgam1(1.+alplea(icltar))/
     *utgam1(1.-alpq)*
     *chad(iclpro)*chad(icltar)/(8.*pi*(r2had(iclpro)+r2had(icltar)))*
     *(xpp*xpm)**(-alpq)/sy**delh
      return
      end

c------------------------------------------------------------------------
      function psharf(zh1,zh2,sqq,sqqp,sqaq)
c-----------------------------------------------------------------------
      include 'nexus.incsem'
      include 'nexus.inc'

      alpq=(alppar+1.)/2.
      if(zh1.le..9999.and.zh2.le..9999)then
        uv1=psdfh4(zh1,q2min,0.,iclpro,1)
        dv1=psdfh4(zh1,q2min,0.,iclpro,2)
        uv2=psdfh4(zh2,q2min,0.,icltar,1)
        dv2=psdfh4(zh2,q2min,0.,icltar,2)
        if(iclpro.eq.2.and.icltar.eq.2)then       !proton
          fff=sqq*(uv1*uv2+dv1*dv2)+sqqp*(uv1*dv2+dv1*uv2)
        elseif(iclpro.eq.1.or.icltar.eq.1)then   !pion
          fff=sqq*uv1*uv2+sqaq*dv1*dv2+sqqp*(uv1*dv2+dv1*uv2)
        elseif(iclpro.eq.3.or.icltar.eq.3)then   !kaon
          fff=sqq*uv1*uv2+sqqp*(uv1*dv2+dv1*uv2+dv1*dv2)
        elseif(iclpro.eq.4.or.icltar.eq.4)then   !J/psi
          fff=sqq*uv1*(uv2+dv2)
        endif
        psharf=fff*(1.-zh1)**(-1.+alpq-alplea(iclpro))*
     *  (1.-zh2)**(-1.+alpq-alplea(icltar))
      else
        psharf=0.
      endif
      return
      end

c------------------------------------------------------------------------
      function pspdf0(xx,qq,j)
c-----------------------------------------------------------------------
c pspdf - parton distribution function for proton
c qq  - virtuality scale
c qqs - initial virtuality for the input distributions
c j   - parton type
c-----------------------------------------------------------------------
      double precision z
      common/ar3/    x1(7),a1(7)
      include 'nexus.inc'
      include 'nexus.incsem'

      if(j.eq.0)then
        pspdf0=psftild(xx,2)*xx**(-dels)*rr*4.*pi*gamhad(2)
      elseif(j.eq.1.or.j.eq.2)then
        pspdf0=psdfh4(xx,q2min,0.,2,j)
      else
        pspdf0=psftile(xx,2)*xx**(-dels)*rr*4.*pi*gamhad(2)
      endif

      pspdf0=pspdf0*psuds(qq,j)/psuds(q2min,j)

      xmin=xx/(1.-q2ini/qq)
      if(xmin.lt.1.)then
        dpd1=0.
        dpd2=0.
        xm=max(xmin,.3)
        do i=1,7         !numerical integration over zx
        do m=1,2
          zx=1.-(1.-xm)*(.5+(m-1.5)*x1(i))**.25
          z=xx/zx

          gl=psftild(zx,2)*zx**(-dels)*rr*4.*pi*gamhad(2)
          uv=0. !?????????????psdfh4(zx,q2min,0.,2,1)
          dv=0. !?????????????psdfh4(zx,q2min,0.,2,2)
          uv=psdfh4(zx,q2min,0.,2,1)
          dv=psdfh4(zx,q2min,0.,2,2)
          sea=psftile(zx,2)*zx**(-dels)*rr*4.*pi*gamhad(2)

          if(j.eq.0)then
            fz=psevi(q2min,qq,z,1,1)*gl+(uv+dv+sea)
     *      *psevi(q2min,qq,z,2,1)
          elseif(j.eq.1)then
            fz=psevi(q2min,qq,z,3,2)*uv
          elseif(j.eq.2)then
            fz=psevi(q2min,qq,z,3,2)*dv
          else
            akns=psevi(q2min,qq,z,3,2)            !nonsinglet contribution
            aks=(psevi(q2min,qq,z,2,2)-akns)      !singlet contribution
            fz=(psevi(q2min,qq,z,1,2)*gl+(uv+dv+sea)*aks+sea*akns)
          endif
          dpd1=dpd1+a1(i)*fz/zx**2/(1.-zx)**3
        enddo
        enddo
        dpd1=dpd1*(1.-xm)**4/8.*xx

        if(xm.gt.xmin)then
          do i=1,7         !numerical integration
          do m=1,2
            zx=xx+(xm-xx)*((xmin-xx)/(xm-xx))**(.5-(m-1.5)*x1(i))
            z=xx/zx

            gl=psftild(zx,2)*zx**(-dels)*rr*4.*pi*gamhad(2)
            uv=0. !?????????????psdfh4(zx,q2min,0.,2,1)
            dv=0. !?????????????psdfh4(zx,q2min,0.,2,2)
            uv=psdfh4(zx,q2min,0.,2,1)
            dv=psdfh4(zx,q2min,0.,2,2)
            sea=psftile(zx,2)*zx**(-dels)*rr*4.*pi*gamhad(2)

            if(j.eq.0)then
              fz=psevi(q2min,qq,z,1,1)*gl+(uv+dv+sea)*
     *        psevi(q2min,qq,z,2,1)
            elseif(j.eq.1)then
              fz=psevi(q2min,qq,z,3,2)*uv
            elseif(j.eq.2)then
              fz=psevi(q2min,qq,z,3,2)*dv
            else
              akns=psevi(q2min,qq,z,3,2)            !nonsinglet contribution
              aks=(psevi(q2min,qq,z,2,2)-akns)      !singlet contribution
              fz=(psevi(q2min,qq,z,1,2)*gl+(uv+dv+sea)*aks+sea*akns)
            endif
            dpd2=dpd2+a1(i)*fz*(1.-xx/zx)/zx
          enddo
          enddo
          dpd2=dpd2*log((xm-xx)/(xmin-xx))*.5*xx
        endif
        pspdf0=pspdf0+dpd2+dpd1
      endif
      if(j.lt.0)pspdf0=pspdf0/naflav/2.
      return
      end

c------------------------------------------------------------------------
      function psvin(sy,xpp,xpm,z,iqq)
c-----------------------------------------------------------------------
c psvin - contributions to the interaction eikonal
c sy  - energy squared for the hard interaction,
c xpp - lc+ for the sh pomeron,
c xpm - lc- for the sh pomeron,
c z   - impact parameter factor, z=exp(-b**2/4*rp),
c iqq = 1  - gg,
c iqq = 2  - qg,
c iqq = 3  - gq,
c iqq = 4  - qq,
c iqq = 5  - gg(int),
c iqq = 6  - gg(proj),
c iqq = 7  - qg(proj),
c iqq = 9  - total uncut-integrated,
c iqq = 10 - total cut,
c iqq = 14  - gg(int)|b=0,
c iqq = 15  - <b^2*gg(int)>,
c iqq = 16  - gg(proj)|b=0,
c iqq = 17  - <b^2*gg(proj)>,
c iqq = 18  - qg(proj)|b=0,
c iqq = 19  - <b^2*qg(proj)>
c-----------------------------------------------------------------------
      dimension wk(3),wi(3),wj(3),wz(3),fa(3)
      common /psar2/  edmax,epmax
      common /psar4/  fhgg(11,10,8),fhqg(11,10,80)
     *,fhgq(11,10,80),fhqq(11,10,80),fhgg0(11,10),fhgg1(11,10,4)
     *,fhqg1(11,10,40),fhgg01(11),fhgg02(11),fhgg11(11,4)
     *,fhgg12(11,4),fhqg11(11,10,4),fhqg12(11,10,4)
     *,ftoint(11,14,2,2,3),ftounc(11,100,168)
      common /psar7/  delx,alam3p,gam3p
      include 'nexus.inc'
      include 'nexus.incsem'
 
      if(iqq.eq.3)then
        xp=xpm
        xm=xpp
        iclp=icltar
        iclt=iclpro
      else
        xp=xpp
        xm=xpm
        iclp=iclpro
        iclt=icltar
      endif
      rp=r2had(iclpro)+r2had(icltar)+slopom*log(max(1.,sy))

      psvin=0.
      if(iqq.eq.1.or.iqq.eq.5.or.iqq.eq.6.or.iqq.eq.14
     *.or.iqq.eq.15.or.iqq.eq.16.or.iqq.eq.17
     *.or.iclpro.ne.4.and.(iqq.eq.2.or.iqq.eq.7
     *.or.iqq.eq.18.or.iqq.eq.19)
     *.or.icltar.ne.4.and.iqq.eq.3
     *.or.iclpro.ne.4.and.icltar.ne.4)then
        spmin=4.*q2min
      else
        spmin=4.*q2min+2.*qcmass**2
      endif
      if(sy.le.spmin.and.(iqq.le.7.or.iqq.gt.13))return

      if(iqq.le.7.or.iqq.gt.13)then
        yl=log(sy/spmin)/log(epmax/2./spmin)*10.+1
        k=int(yl)
        if(k.gt.9)k=9
        wk(2)=yl-k
        wk(3)=wk(2)*(wk(2)-1.)*.5
        wk(1)=1.-wk(2)+wk(3)
        wk(2)=wk(2)-2.*wk(3)

        if(iqq.ne.4)then
          if(iqq.eq.5)then
            if(k.eq.1)then
              psvin=max(0.,exp(fhgg01(k+1))*wk(2)
     *        +exp(fhgg01(k+2))*wk(3))
            else
              psvin=exp(fhgg01(k)*wk(1)+fhgg01(k+1)*wk(2)
     *        +fhgg01(k+2)*wk(3))
            endif
            psvin=psvin*factk*sy**delh
	    return
	    
          elseif(iqq.eq.15)then
            if(k.eq.1)then
              psvin=max(0.,exp(fhgg02(k+1))*wk(2)
     *        +exp(fhgg02(k+2))*wk(3))
            else
              psvin=exp(fhgg02(k)*wk(1)+fhgg02(k+1)*wk(2)
     *        +fhgg02(k+2)*wk(3))
            endif
            psvin=psvin*factk*sy**delh
	    return
	    
          elseif(iqq.eq.6)then
            if(k.eq.1)then
              psvin=max(0.,exp(fhgg11(k+1,iclpro))*wk(2)
     *        +exp(fhgg11(k+2,iclpro))*wk(3))
            else
              psvin=exp(fhgg11(k,iclpro)*wk(1)+fhgg11(k+1,iclpro)*wk(2)
     *        +fhgg11(k+2,iclpro)*wk(3))
            endif
            psvin=psvin*factk*sy**delh*xp**(-alppar)
	    return

          elseif(iqq.eq.17)then
            if(k.eq.1)then
              psvin=max(0.,exp(fhgg12(k+1,iclpro))*wk(2)
     *        +exp(fhgg12(k+2,iclpro))*wk(3))
            else
              psvin=exp(fhgg12(k,iclpro)*wk(1)+fhgg12(k+1,iclpro)*wk(2)
     *        +fhgg12(k+2,iclpro)*wk(3))
            endif
            psvin=psvin*factk*sy**delh*xp**(-alppar)
	    return

          elseif(iqq.eq.7.or.iqq.eq.19)then
            if(xp.lt..2)then
              xl=log(10.*xp)/log(2.)+5.
            else
              xl=5.*xp+5.
            endif
            i=int(xl)
            if(i.lt.1)i=1
            if(i.eq.5)i=4
            if(i.gt.8)i=8
            wi(2)=xl-i
            wi(3)=wi(2)*(wi(2)-1.)*.5
            wi(1)=1.-wi(2)+wi(3)
            wi(2)=wi(2)-2.*wi(3)
            do k1=1,3
              fa(k1)=0.
            do i1=1,3
              k2=k+k1-1
	      if(iqq.eq.7)then
                fhhh=fhqg11(k2,i+i1-1,iclpro)    
	      elseif(iqq.eq.19)then
                fhhh=fhqg12(k2,i+i1-1,iclpro)
              endif    
              fa(k1)=fa(k1)+fhhh*wi(i1)
            enddo
            enddo
            if(k.eq.1)then
              psvin=max(0.,exp(fa(2))*wk(2)+exp(fa(3))*wk(3))
            else
              psvin=exp(fa(1)*wk(1)+fa(2)*wk(2)+fa(3)*wk(3))
            endif
            psvin=psvin*factk*sy**delh
	    return
	  endif
      
          jz=int(10.*z)
          if(jz.gt.8)jz=8
          if(jz.lt.1)jz=1
          wz(2)=10.*z-jz
          wz(3)=wz(2)*(wz(2)-1.)*.5
          wz(1)=1.-wz(2)+wz(3)
          wz(2)=wz(2)-2.*wz(3)

          if(iqq.eq.14)then
            do k1=1,3
              k2=k+k1-1
              fa(k1)=fhgg0(k2,jz)*wz(1)+fhgg0(k2,jz+1)
     *        *wz(2)+fhgg0(k2,jz+2)*wz(3)
            enddo
            if(k.eq.1)then
              psvin=max(0.,exp(fa(2))*wk(2)+exp(fa(3))*wk(3))
            else
              psvin=exp(fa(1)*wk(1)+fa(2)*wk(2)+fa(3)*wk(3))
            endif
            psvin=psvin*z*factk*sy**delh
	    
          elseif(iqq.eq.16)then
            do k1=1,3
              k2=k+k1-1
              fa(k1)=fhgg1(k2,jz,iclpro)*wz(1)+fhgg1(k2,jz+1,iclpro)
     *        *wz(2)+fhgg1(k2,jz+2,iclpro)*wz(3)
            enddo
            if(k.eq.1)then
              psvin=max(0.,exp(fa(2))*wk(2)+exp(fa(3))*wk(3))
            else
              psvin=exp(fa(1)*wk(1)+fa(2)*wk(2)+fa(3)*wk(3))
            endif
            psvin=psvin*z*factk*sy**delh*xp**(-alppar)

          elseif(iqq.eq.18)then
            if(xp.lt..2)then
              xl=log(10.*xp)/log(2.)+5.
            else
              xl=5.*xp+5.
            endif
            i=int(xl)
            if(i.lt.1)i=1
            if(i.eq.5)i=4
            if(i.gt.8)i=8
            wi(2)=xl-i
            wi(3)=wi(2)*(wi(2)-1.)*.5
            wi(1)=1.-wi(2)+wi(3)
            wi(2)=wi(2)-2.*wi(3)
            do k1=1,3
              fa(k1)=0.
            do i1=1,3
            do l1=1,3
              k2=k+k1-1
              l2=jz+l1-1+10*(iclpro-1)
              fhhh=fhqg1(k2,i+i1-1,l2)    
              fa(k1)=fa(k1)+fhhh*wi(i1)*wz(l1)
            enddo
            enddo
            enddo
            if(k.eq.1)then
              psvin=max(0.,exp(fa(2))*wk(2)+exp(fa(3))*wk(3))
            else
              psvin=exp(fa(1)*wk(1)+fa(2)*wk(2)+fa(3)*wk(3))
            endif
            psvin=psvin*z*factk*sy**delh
      
          elseif(iqq.eq.1)then
            do k1=1,3
              k2=k+k1-1
              iclpt=iclpro+4*(icltar-1)
              fa(k1)=fhgg(k2,jz,iclpt)*wz(1)+fhgg(k2,jz+1,iclpt)
     *        *wz(2)+fhgg(k2,jz+2,iclpt)*wz(3)
            enddo
            if(k.eq.1)then
              psvin=max(0.,exp(fa(2))*wk(2)+exp(fa(3))*wk(3))
            else
              psvin=exp(fa(1)*wk(1)+fa(2)*wk(2)+fa(3)*wk(3))
            endif
            psvin=psvin*z*factk*sy**delh*(xp*xm)**(-alppar)
          else
            if(xp.lt..2)then
              xl=log(10.*xp)/log(2.)+5.
            else
              xl=5.*xp+5.
            endif
            i=int(xl)
            if(i.lt.1)i=1
            if(i.eq.5)i=4
            if(i.gt.8)i=8
            wi(2)=xl-i
            wi(3)=wi(2)*(wi(2)-1.)*.5
            wi(1)=1.-wi(2)+wi(3)
            wi(2)=wi(2)-2.*wi(3)
            do k1=1,3
              fa(k1)=0.
            do i1=1,3
            do l1=1,3
              k2=k+k1-1
              if(iqq.eq.2)then
                l2=jz+l1-1+10*(iclpro+4*(icltar-1)-1)
                fhhh=fhqg(k2,i+i1-1,l2)
              elseif(iqq.eq.3)then
                l2=jz+l1-1+10*(iclpro+4*(icltar-1)-1)
                fhhh=fhgq(k2,i+i1-1,l2)
              endif
              fa(k1)=fa(k1)+fhhh*wi(i1)*wz(l1)
            enddo
            enddo
            enddo
            if(k.eq.1)then
              psvin=max(0.,exp(fa(2))*wk(2)+exp(fa(3))*wk(3))
            else
              psvin=exp(fa(1)*wk(1)+fa(2)*wk(2)+fa(3)*wk(3))
            endif
            psvin=psvin*xm**(-alppar)*z*factk*sy**delh
          endif
	  
        else
          if(xp.lt..2)then 
            xl1=log(10.*xp)/log(2.)+5.
          else
            xl1=5.*xp+5.
          endif
          i=max(1,int(xl1))
          if(i.eq.5)i=4
          i=min(8,i)
          wi(2)=xl1-i
          wi(3)=wi(2)*(wi(2)-1.)*.5
          wi(1)=1.-wi(2)+wi(3)
          wi(2)=wi(2)-2.*wi(3)

          if(xm.lt..2)then 
            xl2=log(10.*xm)/log(2.)+5.
          else
            xl2=5.*xm+5.
          endif
          j=max(1,int(xl2))
          if(j.eq.5)j=4
          j=min(8,j)
          wj(2)=xl2-j
          wj(3)=wj(2)*(wj(2)-1.)*.5
          wj(1)=1.-wj(2)+wj(3)
          wj(2)=wj(2)-2.*wj(3)
	
          do k1=1,3
            fa(k1)=0.
          do i1=1,3
          do j1=1,3
            k2=k+k1-1
            j2=j+j1-1+10*(iclp+4*(iclt-1)-1)
            fa(k1)=fa(k1)+fhqq(k2,i+i1-1,j2)*wi(i1)*wj(j1)
          enddo
          enddo
          enddo
          if(k.eq.1)then
            psvin=max(0.,exp(fa(2))*wk(2)+exp(fa(3))*wk(3))
          else
            psvin=exp(fa(1)*wk(1)+fa(2)*wk(2)+fa(3)*wk(3))
          endif
          psvin=psvin*z**(rp/(r2had(iclpro)+r2had(icltar)))*
     *    factk*sy**delh
        endif
	return
      endif
      
      yl=log(sy)/log(1.e8)*10.+1
      k=max(1,int(yl))
      k=min(k,9)     !?????????????9
      wk(2)=yl-k
      wk(3)=wk(2)*(wk(2)-1.)*.5
      wk(1)=1.-wk(2)+wk(3)
      wk(2)=wk(2)-2.*wk(3)

      if(z.gt..1)then
        zz=10.*z+4
      else
        zz=50.*z
      endif
      jz=min(12,int(zz))
      if(jz.eq.0)jz=1
      if(jz.eq.4)jz=3
      wz(2)=zz-jz
      wz(3)=wz(2)*(wz(2)-1.)*.5
      wz(1)=1.-wz(2)+wz(3)
      wz(2)=wz(2)-2.*wz(3)

      if(iqq.eq.9)then
        do k1=1,3
        do l1=1,3
          k2=k+k1-1
          l2=jz+l1-1
          psvin=psvin+ftoint(k2,l2,icdp,icdt,iclp)*wk(k1)*wz(l1)
        enddo
        enddo
        psvin=exp(psvin)*z
	
      elseif(iqq.eq.10)then
        if(xpp.lt..2)then
          xl1=log(10.*xpp)/log(2.)+5.
        else
          xl1=5.*xpp+5.
        endif
        i=max(1,int(xl1))
        if(i.eq.5)i=4
        i=min(8,i)
        wi(2)=xl1-i
        wi(3)=wi(2)*(wi(2)-1.)*.5
        wi(1)=1.-wi(2)+wi(3)
        wi(2)=wi(2)-2.*wi(3)

        if(xpm.lt..2)then
          xl2=log(10.*xpm)/log(2.)+5.
        else
          xl2=5.*xpm+5.
        endif
        j=max(1,int(xl2))
        if(j.eq.5)j=4
        j=min(8,j)
        wj(2)=xl2-j
        wj(3)=wj(2)*(wj(2)-1.)*.5
        wj(1)=1.-wj(2)+wj(3)
        wj(2)=wj(2)-2.*wj(3)
	
        do k1=1,3
        do i1=1,3
        do j1=1,3
        do l1=1,3
          k2=k+k1-1
          j2=i+i1-1+10*(j+j1-2)
          l2=jz+l1-1+14*(iclp-1)+42*(icdp-1)+84*(icdt-1)
          psvin=psvin+ftounc(k2,j2,l2)*wi(i1)*wj(j1)*wk(k1)*wz(l1)
        enddo
        enddo
        enddo
        enddo
        psvin=exp(psvin)*z
      endif
      return
      end
      
c------------------------------------------------------------------------
      function psftig(x,xpomr,jj)
c-----------------------------------------------------------------------
      common /ar3/   x1(7),a1(7)
      include 'nexus.inc'
      include 'nexus.incsem'

      if(jj.eq.0)then
        psftig=0.
        xpmin=x**(1.-alppar+dels)
        do i=1,7
        do m=1,2
          xp=(.5*(1.+xpmin+(2*m-3)*x1(i)*(1.-xpmin)))**(1./
     *    (1.-alppar+dels))
          psftig=psftig+a1(i)*(1.-xp)**alplea(2)*(1.-x/xp)**betpom
        enddo
        enddo
        psftig=psftig*(1.-xpmin)/(1.-alppar+dels)*(1.-glusea)
     *  *2.*pi*gamhad(2)*rr/x**dels
      elseif(jj.eq.1)then
        psftig=(1.-x/xpomr)**betpom/xpomr**dels/x**dels
     *  *4.*pi**2*gamhad(2)**2*rr*r3pom
     *  /(r2had(2)-slopom*log(min(1.,xpomr*4.)))
     *  *utgam1(1.-alppar+dels)**2*utgam1(1.+alplea(2))
     *  /utgam1(1.+alplea(2)+2.*(1.-alppar+dels))*(1.-glusea)
      elseif(jj.eq.2)then
        psftig=0.
        zmin=x**dels
        do i=1,7
        do m=1,2
          z=(.5*(1.+zmin+(2*m-3)*x1(i)*(1.-zmin)))**(1./dels)
          psftig=psftig+a1(i)*(1.-z)**betpom
     *    /(r2had(2)+slopom*log(z/x))
        enddo
        enddo
        psftig=psftig*(1.-zmin)/dels/x**(2.*dels)*(1.-glusea)/2.
     *  *4.*pi**2*gamhad(2)**2*rr*r3pom
     *  *utgam1(1.-alppar+dels)**2*utgam1(1.+alplea(2))
     *  /utgam1(1.+alplea(2)+2.*(1.-alppar+dels))
      elseif(jj.eq.3)then
        psftig=-(1.-x/xpomr)**betpom/xpomr**dels
     *  *(xpomr**(-dels)-1.)/dels/x**dels
     *  *32./3.*pi**3*gamhad(2)**3*rr*r3pom**2
     *  /(r2had(2)-slopom*log(min(1.,xpomr*9.)))**2
     *  *utgam1(1.-alppar+dels)**3*utgam1(1.+alplea(2))
     *  /utgam1(1.+alplea(2)+3.*(1.-alppar+dels))*(1.-glusea) 
      elseif(jj.eq.4)then
        psftig=0.
        zmin=x**dels
        do i=1,7
        do m=1,2
          z=(.5*(1.+zmin+(2*m-3)*x1(i)*(1.-zmin)))**(1./dels)
          psftig=psftig+a1(i)*(1.-z)**betpom*((z/x)**dels-1.)
     *    /(r2had(2)+slopom*log(z/x))**2
        enddo
        enddo
        psftig=-psftig*(1.-zmin)/dels**2/x**(2.*dels)/2.
     *  *32./3.*pi**3*gamhad(2)**3*rr*r3pom**2
     *  *utgam1(1.-alppar+dels)**3*utgam1(1.+alplea(2))
     *  /utgam1(1.+alplea(2)+3.*(1.-alppar+dels))*(1.-glusea) 
      elseif(jj.eq.5)then
        psftig=(1.-x/xpomr)**betpom/xpomr**dels
     *  *((xpomr**(-dels)-1.)/dels)**2/x**dels
     *  *8.*pi**4*gamhad(2)**4*rr*r3pom**3
     *  /(r2had(2)-slopom*log(min(1.,xpomr*16.)))**3
     *  *utgam1(1.-alppar+dels)**4*utgam1(1.+alplea(2))
     *  /utgam1(1.+alplea(2)+4.*(1.-alppar+dels))*(1.-glusea) 
      elseif(jj.eq.6)then
        psftig=(1.-x/xpomr)**betpom/xpomr**dels
     *  *((xpomr**(-dels)-1.)/dels)**2/x**dels
     *  *16.*pi**4*gamhad(2)**4*rr*r3pom**3
     *  /(r2had(2)-slopom*log(min(1.,xpomr*16.)))**3
     *  *utgam1(1.-alppar+dels)**4*utgam1(1.+alplea(2))
     *  /utgam1(1.+alplea(2)+4.*(1.-alppar+dels))*(1.-glusea) 
      elseif(jj.eq.7)then
        psftig=-(1.-x/xpomr)**betpom/xpomr**dels
     *  *((xpomr**(-dels)-1.)/dels**2+log(xpomr)/dels)/x**dels
     *  *32.*pi**4*gamhad(2)**2*rr*r3pom**3/r2had(2)/r2had(1)
     *  *utgam1(1.-alppar+dels)**2*utgam1(1.+alplea(2))
     *  /utgam1(1.+alplea(2)+2.*(1.-alppar+dels))*(1.-glusea) 
      endif
      return
      end
      
c------------------------------------------------------------------------
      function psftis(x,xpomr,jj)
c-----------------------------------------------------------------------
      common /ar3/   x1(7),a1(7)
      include 'nexus.inc'
      include 'nexus.incsem'

      if(jj.eq.0)then
        psftis=0.
        xpmin=x**(1.-alppar+dels)
        do i=1,7
        do m=1,2
          xp=(.5*(1.+xpmin+(2*m-3)*x1(i)*(1.-xpmin)))**(1./
     *    (1.-alppar+dels))
          psftis=psftis+a1(i)*(1.-xp)**alplea(2)*psftilf(x/xp)
        enddo
        enddo
        psftis=psftis*(1.-xpmin)/(1.-alppar+dels)*glusea
     *  *2.*pi*gamhad(2)*rr/x**dels
      elseif(jj.eq.1)then
        psftis=psftilf(x/xpomr)/xpomr**dels/x**dels
     *  *4.*pi**2*gamhad(2)**2*rr*r3pom
     *  /(r2had(2)-slopom*log(xpomr))
     *  *utgam1(1.-alppar+dels)**2*utgam1(1.+alplea(2))
     *  /utgam1(1.+alplea(2)+2.*(1.-alppar+dels))*glusea
      elseif(jj.eq.2)then
        psftis=0.
        xpmin=x**(-dels)
        do i=1,7
        do m=1,2
          xp=(.5*(1.+xpmin+(2*m-3)*x1(i)*(1.-xpmin)))**(-1./dels)
          psftis=psftis+a1(i)*psftilf(x/xp)
     *    /(r2had(2)-slopom*log(xp))
        enddo
        enddo
        psftis=psftis*(xpmin-1.)/dels/x**dels*glusea/2.
     *  *4.*pi**2*gamhad(2)**2*rr*r3pom/r2had(2)
     *  *utgam1(1.-alppar+dels)**2*utgam1(1.+alplea(2))
     *  /utgam1(1.+alplea(2)+2.*(1.-alppar+dels))
      endif
      return
      end
         
c------------------------------------------------------------------------
      function psftih(zz,ddd)
c-----------------------------------------------------------------------
      double precision zmin,z
      common /ar3/   x1(7),a1(7)
      include 'nexus.incsem'

      psftih=0.
      zmin=zz**ddd
      do i=1,7
      do m=1,2
        z=(.5d0*(1.+zmin+(2*m-3)*x1(i)*(1.d0-zmin)))
     *  **(1.d0/ddd)
        psftih=psftih+a1(i)*max(1.d-5,(1.d0-z))**betpom
      enddo
      enddo
      psftih=psftih*(1.d0-zmin)/ddd/2.  
      return
      end          
     
c------------------------------------------------------------------------
      function psftij(zz,ddd)
c------------------------------------------------------------------------
      double precision zmin,z
      common /ar3/ x1(7),a1(7)
      include 'nexus.incsem'

      psftij=0.
      zmin=zz
      zmin=zmin**(1.+ddd+dels)
      do i=1,7
      do m=1,2
        z=(.5d0*(1.+zmin+(2*m-3)*x1(i)*(1.d0-zmin)))
     *  **(1.d0/(1.d0+ddd+dels))
        psftij=psftij+a1(i)*psftih(sngl(zz/z),ddd)
     *  *(z**2+(1.-z)**2)
      enddo
      enddo
      psftij=psftij*1.5*(1.d0-zmin)/(1.+ddd+dels)  
      !1.5=naflav/2 at Q0
      return
      end
         
c------------------------------------------------------------------------
      function psftik(xp,del1,rh1,rh2,rh3,rp,z)
c-----------------------------------------------------------------------
      common /psar7/ delx,alam3p,gam3p
      common /ar3/   x1(7),a1(7)
      include 'nexus.incsem'

      psftik=0.
      zmin=xp**del1
      zmax=delx**(-del1)
      do i=1,7
      do m=1,2
        xp1=(.5*(zmax+zmin+(2*m-3)*x1(i)*(zmax-zmin)))**(1./del1)
        psftik=psftik+a1(i)*psftim(xp1,xp,del1,rh1,rh2,rh3,rp,z)
      enddo
      enddo
      psftik=psftik*(zmax-zmin)/del1/2.  
      return
      end          
     
c------------------------------------------------------------------------
      function psftim(xp1,xp,del1,rh1,rh2,rh3,rp,z)
c-----------------------------------------------------------------------
      double precision zmin,zmax,zz
      common /psar7/ delx,alam3p,gam3p
      common /ar3/   x1(7),a1(7)
      include 'nexus.inc'
      include 'nexus.incsem'

      psftim=0.
      rha=(rh3-slopom*log(xp1))
      zmin=dble(xp/xp1)
      zmax=1.d0
      do i=1,7
      do m=1,2
        zz=.5d0*(zmax+zmin+(2*m-3)*x1(i)*(zmax-zmin))
        rhb=(rh2-slopom*log(xp/zz/xp1))
	rhh=rha+rh1*rhb/(rh1+rhb)
	
        psftim=psftim+a1(i)*zz**dels**max(1.d-5,(1.d0-zz))**del1
     *  *max(1.d-5,(1.d0-xp/zz/xp1))**betpom
     *  *z**(rp/rhh)/rhh/(rh1+rhb)
      enddo
      enddo
      psftim=psftim*(zmax-zmin)/2.  
      return
      end          
     
c------------------------------------------------------------------------
      function psftil(xp,del1,rh1,rh2,rh3,rp,z)
c------------------------------------------------------------------------
      double precision zmin,zz
      common /psar7/ delx,alam3p,gam3p
      common /ar3/   x1(7),a1(7)
      include 'nexus.incsem'

      psftil=0.
      zmin=dble(xp)*delx
      do i=1,7
      do m=1,2
        zz=.5d0*(1.d0+zmin+(2*m-3)*x1(i)*(1.d0-zmin))
        psftil=psftil+a1(i)*psftik(sngl(xp/zz),del1
     *  ,rh1,rh2,rh3,rp,z)*(zz**2+(1.-zz)**2)*zz**dels
      enddo
      enddo
      psftil=psftil*1.5*(1.-zmin)    !1.5=naflav/2 at Q0
      return
      end

c------------------------------------------------------------------------
      function psftigt(x)
c-----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      double precision ftigt,del1,del2,del3,del4,del5,del6,ddelx
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar6/  coefu1(nbpDf,nclha)
     *,coefu2(nbpDf*nbpDf,nclha)
     *,coefu3(nbpDf*nbpDf*nbpDf,nclha)
     *,coefu4(nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefu5(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefu6(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefc2(nbpDf*nbpDf,nclha)
     *,coefc3(nbpDf*nbpDf*nbpDf,nclha)
     *,coefc4(nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefc5(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
      common /psar7/ delx,alam3p,gam3p
      common /ar3/   x1(7),a1(7)

      icdps=icdp
      iclpros=iclpro
      iclegys=iclegy
      iclpro=2
      ddelx=dble(delx)
      iclegy=1+max(0,int((.25*log(1./x)-log(egylow))/log(egyfac)))
      iclegy=min(iclegy,iclegy2)
      psftigt=0.
      
      do icdp=icdp1,icdp2

      psftigt=psftigt+psftild(x,2)*4.*pi*rr*gamhad(2)/x**dels      
     **gamdp(icdp,iclpro)*ccproj(icdp,iclpro)
     
      if(x.lt.1./delx)then
        ftigt=0.d0
        do i1=1,nbpDf
          del1=betD1(i1,iclegy,iclpro)
c          alp1=betDp1(i1,iclegy,iclpro)-alppar
	  rh1=delD1(i1,iclegy,iclpro)
        do i2=1,nbpDf
          del2=betD1(i2,iclegy,iclpro)
c          alp2=betDp1(i2,iclegy,iclpro)-alppar
	  rh2=delD1(i2,iclegy,iclpro)
	  ftih=psftih(x*delx,sngl(del1+del2-dels))/x**(del1+del2)
          
          ftigt=ftigt+
     *    alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *    *coefu2(i1+nbpDf*(i2-1),iclpro)
     *    *ftih/(rh1+rh2)
        enddo
        enddo
        psftigt=psftigt-ftigt
     *  *2.*pi*rr*(r3pom*pi/.0389)*(1.-glusea)
     *  *gamdp(icdp,iclpro)**2*ccproj(icdp,iclpro)
      endif
     
      if(x.lt.1./delx**2)then
        ftigt=0.d0
        do i3=1,nbpDf
          del3=betD1(i3,iclegy,iclpro)
c          alp3=betDp1(i3,iclegy,iclpro)-alppar
	  rh3=delD1(i3,iclegy,iclpro)
        do i4=1,nbpDf
          del4=betD2(i4,iclegy)
	  rh4=delD2(i4,iclegy)
	  ftih1=psftih(x*delx**2,sngl(del3+del4-dels))
     *    /x**(del3+del4)
        do i1=1,nbpDf
          del1=betD1(i1,iclegy,iclpro)
c          alp1=betDp1(i1,iclegy,iclpro)-alppar
	  rh1=delD1(i1,iclegy,iclpro)
        do i2=1,nbpDf
          del2=betD1(i2,iclegy,iclpro)
c          alp2=betDp1(i2,iclegy,iclpro)-alppar
	  rh2=delD1(i2,iclegy,iclpro)
	  rh12=rh1*rh2/(rh1+rh2)
	  ftih2=psftih(x*delx**2,sngl(del1+del2+del3-dels))
     *    /x**(del1+del2+del3)
          
          ftigt=ftigt+
     *    alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *    *alpD1(i3,iclegy,iclpro)*alpD2(i4,iclegy)
     *    *coefu3(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1),iclpro)
     *    *(ddelx**(del4-del1-del2)*ftih2-ddelx**(del1+del2-del4)*ftih1)
     *    /(del1+del2-del4)/(rh3+rh4+rh12)/(rh1+rh2)
        enddo
        enddo
        enddo
        enddo
        psftigt=psftigt+ftigt
     *  *2.*pi*rr*(r3pom*pi/.0389)**2*(1.-glusea)
     *  *gamdp(icdp,iclpro)**3*ccproj(icdp,iclpro)
      endif
          
      if(x.lt.delx**(-3.))then
        ftigt=0.d0
        do i4=1,nbpDf
          del4=betD1(i4,iclegy,iclpro)
c          alp4=betDp1(i4,iclegy,iclpro)-alppar
	  rh4=delD1(i4,iclegy,iclpro)
        do i6=1,nbpDf
          del6=betD2(i6,iclegy)
	  rh6=delD2(i6,iclegy)
	  ftih1=psftih(x*delx**3,sngl(del4+del6-dels))
     *    /x**(del4+del6)
        do i3=1,nbpDf
          del3=betD1(i3,iclegy,iclpro)
c          alp3=betDp1(i3,iclegy,iclpro)-alppar
	  rh3=delD1(i3,iclegy,iclpro)
        do i5=1,nbpDf
          del5=betD2(i5,iclegy)
	  rh5=delD2(i5,iclegy)
	  ftih2=psftih(x*delx**3,sngl(del3+del4+del5-dels))
     *    /x**(del3+del4+del5)
        do i1=1,nbpDf
          del1=betD1(i1,iclegy,iclpro)
c          alp1=betDp1(i1,iclegy,iclpro)-alppar
	  rh1=delD1(i1,iclegy,iclpro)
        do i2=1,nbpDf
          del2=betD1(i2,iclegy,iclpro)
c          alp2=betDp1(i2,iclegy,iclpro)-alppar
	  rh2=delD1(i2,iclegy,iclpro)
	  rh12=rh1*rh2/(rh1+rh2)
	  ftih3=psftih(x*delx**3,sngl(del1+del2+del3+del4-dels))
     *    /x**(del1+del2+del3+del4)
          
          ftigt=ftigt+
     *    alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *    *alpD1(i3,iclegy,iclpro)*alpD1(i4,iclegy,iclpro)
     *    *alpD2(i5,iclegy)*alpD2(i6,iclegy)
     *    *coefu4(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)
     *    +nbpDf*nbpDf*nbpDf*(i4-1),iclpro)
     *    *((ddelx**(del6-del1-del2-del3)*ftih3
     *    -ddelx**(2.d0*(del1+del2+del3-del6))*ftih1)
     *    /(del1+del2+del3-del6)*ddelx**(del5-del1-del2)
     *    -(ddelx**(del6-del3-del5)*ftih2
     *    -ddelx**(2.d0*(del3+del5-del6))*ftih1)
     *    /(del3+del5-del6)*ddelx**(del1+del2-del5))/(del1+del2-del5)
     *    /(rh3*(rh5+rh12)+(rh4+rh6)*(rh3+rh5+rh12))/(rh1+rh2)
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        psftigt=psftigt-ftigt
     *  *2.*pi*rr*(r3pom*pi/.0389)**3*(1.-glusea)
     *  *gamdp(icdp,iclpro)**4*ccproj(icdp,iclpro)
      endif
c      goto 1000
     
      if(x.lt.delx**(-20.))then!!!!!!!!!!!
        ftigt=0.d0
        do i5=1,nbpDf
          del5=betD2(i5,iclegy)
	  rh5=delD2(i5,iclegy)
        do i6=1,nbpDf
          del6=betD2(i6,iclegy)
	  rh6=delD2(i6,iclegy)
	  ftih1=psftih(x*delx**2,sngl(del5+del6-dels))
     *    /x**(del5+del6)
        do i1=1,nbpDf
          del1=betD1(i1,iclegy,iclpro)
c          alp1=betDp1(i1,iclegy,iclpro)-alppar
	  rh1=delD1(i1,iclegy,iclpro)
        do i2=1,nbpDf
          del2=betD1(i2,iclegy,iclpro)
c          alp2=betDp1(i2,iclegy,iclpro)-alppar
	  rh2=delD1(i2,iclegy,iclpro)
	  rh12=rh1*rh2/(rh1+rh2)
	  ftih2=psftih(x*delx**2,sngl(del1+del2+del6-dels))
     *    /x**(del1+del2+del6)
        do i3=1,nbpDf
          del3=betD1(i3,iclegy,iclpro)
c          alp3=betDp1(i3,iclegy,iclpro)-alppar
	  rh3=delD1(i3,iclegy,iclpro)
        do i4=1,nbpDf
          del4=betD1(i4,iclegy,iclpro)
c          alp4=betDp1(i4,iclegy,iclpro)-alppar
	  rh4=delD1(i4,iclegy,iclpro)
	  rh34=rh3*rh4/(rh3+rh4)
	  ftih3=psftih(x*delx**2,sngl(del3+del4+del5-dels))
     *    /x**(del3+del4+del5)
	  ftih4=psftih(x*delx**2,sngl(del1+del2+del3+del4-dels))
     *    /x**(del1+del2+del3+del4)
          
          ftigt=ftigt
     *    +alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *    *alpD1(i3,iclegy,iclpro)*alpD1(i4,iclegy,iclpro)
     *    *alpD2(i5,iclegy)*alpD2(i6,iclegy)
     *    *coefu4(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)
     *    +nbpDf*nbpDf*nbpDf*(i4-1),iclpro)
     *    *(ddelx**(del5-del1-del2-del3-del4)*ftih4
     *    -ddelx**(del1+del2+del6-del3-del4-del5)*ftih3
     *    -ddelx**(del3+del4+del5-del1-del2-del6)*ftih2
     *    +ddelx**(del1+del2+del3+del4-del5-del6)*ftih1)
     *    /(del1+del2-del5)/(del3+del4-del6)
     *    /(rh5+rh6+rh12+rh34)/(rh1+rh2)/(rh3+rh4)
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        psftigt=psftigt-ftigt
     *  *.5*pi*rr*(r3pom*pi/.0389)**3*(1.-glusea)
     *  *gamdp(icdp,iclpro)**4*ccproj(icdp,iclpro)
      endif
      
      if(x.lt.delx**(-2.))then
        ftigt=0.d0
        do i1=1,nbpDf
          del1=betD1(i1,iclegy,iclpro)
c          alp1=betDp1(i1,iclegy,iclpro)-alppar
	  rh1=delD1(i1,iclegy,iclpro)
	  ftih1=psftih(x*delx**2,sngl(del1-dels))
     *    /x**del1
        do i2=1,nbpDf
          del2=betD2(i2,iclegy)
	  rh2=delD2(i2,iclegy)
        do i3=1,nbpDf
          del3=betD2(i3,iclegy)
	  rh3=delD2(i3,iclegy)
	  ftih2=psftih(x*delx**2,sngl(del2+del3-dels))
     *    /x**(del2+del3)
          
          ftigt=ftigt
     *    +alpD1(i1,iclegy,iclpro)*alpD2(i2,iclegy)*alpD2(i3,iclegy)
     *    *coefu1(i1,iclpro)
     *    *(ddelx**(del1-del2-del3)*ftih2
     *    -ddelx**(del2+del3-del1)*ftih1)/(del2+del3-del1)
     *    /(rh2+rh3)
        enddo
        enddo
        enddo
        psftigt=psftigt-ftigt
     *  *2.*pi*rr*(r3pom*pi/.0389)**2*(1.-glusea)
     *  *gamdp(icdp,iclpro)*ccproj(icdp,iclpro)
      endif
      
      if(x.lt.delx**(-3.))then
        ftigt=0.d0
        do i1=1,nbpDf
          del1=betD1(i1,iclegy,iclpro)
c          alp1=betDp1(i1,iclegy,iclpro)-alppar
	  rh1=delD1(i1,iclegy,iclpro)
        do i2=1,nbpDf
          del2=betD1(i2,iclegy,iclpro)
c          alp2=betDp1(i2,iclegy,iclpro)-alppar
	  rh2=delD1(i2,iclegy,iclpro)
	  ftih1=psftih(x*delx**3,sngl(del1+del2-dels))
     *    /x**(del1+del2)
        do i4=1,nbpDf
          del4=betD2(i4,iclegy)
	  rh4=delD2(i4,iclegy)
        do i5=1,nbpDf
          del5=betD2(i5,iclegy)
	  rh5=delD2(i5,iclegy)
	  ftih2=psftih(x*delx**3,sngl(del4+del5-dels))
     *    /x**(del4+del5)
        do i3=1,nbpDf
          del3=betD2(i3,iclegy)
	  rh3=delD2(i3,iclegy)
	  ftih3=psftih(x*delx**3,sngl(del2+del3+del4-dels))
     *    /x**(del2+del3+del4)
          
          ftigt=ftigt
     *    +alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *    *alpD2(i3,iclegy)*alpD2(i4,iclegy)*alpD2(i5,iclegy)
     *    *coefu2(i1+nbpDf*(i2-1),iclpro)
     *    *((ddelx**(del5-del2-del3)*ftih3
     *    -ddelx**(2.d0*(del2+del3-del5))*ftih2)
     *    /(del2+del3-del5)*ddelx**(del1-del3-del4)
     *    -(ddelx**(del4+del5-del1-del2)*ftih1
     *    -ddelx**(2.d0*(del1+del2-del4-del5))*ftih2)
     *    /(del1+del2-del4-del5)*ddelx**(del3+del4-del1))
     *    /(del3+del4-del1)
     *    /((rh1+rh2)*(rh3+rh4+rh5)+rh3*(rh4+rh5))
        enddo
        enddo
        enddo
        enddo
        enddo
        psftigt=psftigt+ftigt
     *  *4.*pi*rr*(r3pom*pi/.0389)**3*(1.-glusea)
     *  *gamdp(icdp,iclpro)**2*ccproj(icdp,iclpro)
      endif
         
      if(x.lt.delx**(-3.))then
        ftigt=0.d0
        do i1=1,nbpDf
          del1=betD1(i1,iclegy,iclpro)
c          alp1=betDp1(i1,iclegy,iclpro)-alppar
	  rh1=delD1(i1,iclegy,iclpro)
        do i2=1,nbpDf
          del2=betD1(i2,iclegy,iclpro)
c          alp2=betDp1(i2,iclegy,iclpro)-alppar
	  rh2=delD1(i2,iclegy,iclpro)
	  ftih1=psftih(x*delx**3,sngl(del1+del2-dels))
     *    /x**(del1+del2)
        do i5=1,nbpDf
          del5=betD2(i5,iclegy)
	  rh5=delD2(i5,iclegy)
	  ftih2=psftih(x*delx**3,sngl(del2+del5-dels))
     *    /x**(del2+del5)
        do i3=1,nbpDf
          del3=betD2(i3,iclegy)
	  rh3=delD2(i3,iclegy)
        do i4=1,nbpDf
          del4=betD2(i4,iclegy)
	  rh4=delD2(i4,iclegy)
	  rh34=rh3*rh4/(rh3+rh4)
	  ftih3=psftih(x*delx**3,sngl(del2+del3+del4-dels))
     *    /x**(del2+del3+del4)
          
          ftigt=ftigt
     *    +alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *    *alpD2(i3,iclegy)*alpD2(i4,iclegy)*alpD2(i5,iclegy)
     *    *coefu2(i1+nbpDf*(i2-1),iclpro)
     *    *((ddelx**(del5-del3-del4)*ftih3
     *    -ddelx**(2.d0*(del3+del4-del5))*ftih2)
     *    /(del3+del4-del5)*ddelx**(del1-del3-del4)
     *    -(ddelx**(del5-del1)*ftih1-ddelx**(2.d0*(del1-del5))*ftih2)
     *    /(del1-del5)*ddelx**(del3+del4-del1))/(del3+del4-del1)
     *    /(rh1+rh2+rh34+rh5)/(rh3+rh4)
        enddo
        enddo
        enddo
        enddo
        enddo
        psftigt=psftigt+ftigt
     *  *2.*pi*rr*(r3pom*pi/.0389)**3*(1.-glusea)
     *  *gamdp(icdp,iclpro)**2*ccproj(icdp,iclpro)
       endif
c1000       continue
       enddo
       icdp=icdps
       iclpro=iclpros
       iclegy=iclegys
       return
       end
                  
c------------------------------------------------------------------------
      function psftist(x)
c-----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      double precision ftist,del1,del2,del3,del4,del5,del6,ddelx
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar6/  coefu1(nbpDf,nclha)
     *,coefu2(nbpDf*nbpDf,nclha)
     *,coefu3(nbpDf*nbpDf*nbpDf,nclha)
     *,coefu4(nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefu5(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefu6(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefc2(nbpDf*nbpDf,nclha)
     *,coefc3(nbpDf*nbpDf*nbpDf,nclha)
     *,coefc4(nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefc5(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
      common /psar7/ delx,alam3p,gam3p
      common /ar3/   x1(7),a1(7)

      iclpros=iclpro
      icdps=icdp
      icdts=icdt
      iclegys=iclegy

      iclpro=2
      ddelx=dble(delx)
      iclegy=1+max(0,int((.25*log(1./x)-log(egylow))/log(egyfac)))
      iclegy=min(iclegy,iclegy2)
      psftist=0.

      do icdp=icdp1,icdp2
      psftist=psftist+psftile(x,2)*4.*pi*rr*gamhad(2)/x**dels      
     **gamdp(icdp,iclpro)*ccproj(icdp,iclpro)
     
c      write(*,*)'0',psftist,x
      if(x.lt.1./delx)then
        ftist=0.d0
        do i1=1,nbpDf
          del1=betD1(i1,iclegy,iclpro)
c          alp1=betDp1(i1,iclegy,iclpro)-alppar
	  rh1=delD1(i1,iclegy,iclpro)
        do i2=1,nbpDf
          del2=betD1(i2,iclegy,iclpro)
c          alp2=betDp1(i2,iclegy,iclpro)-alppar
	  rh2=delD1(i2,iclegy,iclpro)
	  ftij=psftij(x*delx,sngl(del1+del2-dels))/x**(del1+del2)
          
          ftist=ftist+
     *    alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *    *coefu2(i1+nbpDf*(i2-1),iclpro)
     *    *ftij/(rh1+rh2)
        enddo
        enddo
        psftist=psftist-ftist
     *  *2.*pi*rr*(r3pom*pi/.0389)*glusea
     *  *gamdp(icdp,iclpro)**2*ccproj(icdp,iclpro)
c      write(*,*)'1',psftist
      endif
     
      if(x.lt.1./delx**2)then
        ftist=0.d0
        do i3=1,nbpDf
          del3=betD1(i3,iclegy,iclpro)
c          alp3=betDp1(i3,iclegy,iclpro)-alppar
	  rh3=delD1(i3,iclegy,iclpro)
        do i4=1,nbpDf
          del4=betD2(i4,iclegy)
	  rh4=delD2(i4,iclegy)
	  ftij1=psftij(x*delx**2,sngl(del3+del4-dels))
     *    /x**(del3+del4)
        do i1=1,nbpDf
          del1=betD1(i1,iclegy,iclpro)
c          alp1=betDp1(i1,iclegy,iclpro)-alppar
	  rh1=delD1(i1,iclegy,iclpro)
        do i2=1,nbpDf
          del2=betD1(i2,iclegy,iclpro)
c          alp2=betDp1(i2,iclegy,iclpro)-alppar
	  rh2=delD1(i2,iclegy,iclpro)
	  rh12=rh1*rh2/(rh1+rh2)
	  ftij2=psftij(x*delx**2,sngl(del1+del2+del3-dels))
     *    /x**(del1+del2+del3)
          
          ftist=ftist+
     *    alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *    *alpD1(i3,iclegy,iclpro)*alpD2(i4,iclegy)
     *    *coefu3(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1),iclpro)
     *    *(ddelx**(del4-del1-del2)*ftij2-ddelx**(del1+del2-del4)*ftij1)
     *    /(del1+del2-del4)/(rh3+rh4+rh12)/(rh1+rh2)
        enddo
        enddo
        enddo
        enddo
        psftist=psftist+ftist
     *  *2.*pi*rr*(r3pom*pi/.0389)**2*glusea
     *  *gamdp(icdp,iclpro)**3*ccproj(icdp,iclpro)
c      write(*,*)'2',psftist
      endif
          
      if(x.lt.delx**(-3.))then
        ftist=0.d0
        do i4=1,nbpDf
          del4=betD1(i4,iclegy,iclpro)
c          alp4=betDp1(i4,iclegy,iclpro)-alppar
	  rh4=delD1(i4,iclegy,iclpro)
        do i6=1,nbpDf
          del6=betD2(i6,iclegy)
	  rh6=delD2(i6,iclegy)
	  ftij1=psftij(x*delx**3,sngl(del4+del6-dels))
     *    /x**(del4+del6)
        do i3=1,nbpDf
          del3=betD1(i3,iclegy,iclpro)
c          alp3=betDp1(i3,iclegy,iclpro)-alppar
	  rh3=delD1(i3,iclegy,iclpro)
        do i5=1,nbpDf
          del5=betD2(i5,iclegy)
	  rh5=delD2(i5,iclegy)
	  ftij2=psftij(x*delx**3,sngl(del3+del4+del5-dels))
     *    /x**(del3+del4+del5)
        do i1=1,nbpDf
          del1=betD1(i1,iclegy,iclpro)
c          alp1=betDp1(i1,iclegy,iclpro)-alppar
	  rh1=delD1(i1,iclegy,iclpro)
        do i2=1,nbpDf
          del2=betD1(i2,iclegy,iclpro)
c          alp2=betDp1(i2,iclegy,iclpro)-alppar
	  rh2=delD1(i2,iclegy,iclpro)
	  rh12=rh1*rh2/(rh1+rh2)
	  ftij3=psftij(x*delx**3,sngl(del1+del2+del3+del4-dels))
     *    /x**(del1+del2+del3+del4)
          
          ftist=ftist+
     *    alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *    *alpD1(i3,iclegy,iclpro)*alpD1(i4,iclegy,iclpro)
     *    *alpD2(i5,iclegy)*alpD2(i6,iclegy)
     *    *coefu4(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)
     *    +nbpDf*nbpDf*nbpDf*(i4-1),iclpro)
     *    *((ddelx**(del6-del1-del2-del3)*ftij3
     *    -ddelx**(2.d0*(del1+del2+del3-del6))*ftij1)
     *    /(del1+del2+del3-del6)*ddelx**(del5-del1-del2)
     *    -(ddelx**(del6-del3-del5)*ftij2
     *    -ddelx**(2.d0*(del3+del5-del6))*ftij1)
     *    /(del3+del5-del6)*ddelx**(del1+del2-del5))/(del1+del2-del5)
     *    /(rh3*(rh5+rh12)+(rh4+rh6)*(rh3+rh5+rh12))/(rh1+rh2)
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        psftist=psftist-ftist
     *  *2.*pi*rr*(r3pom*pi/.0389)**3*glusea
     *  *gamdp(icdp,iclpro)**3*ccproj(icdp,iclpro)
c      write(*,*)'3',psftist
      endif
c      goto 1000
     
      if(x.lt.delx**(-20.))then!!!!!!!!!!!!
        ftist=0.d0
        do i5=1,nbpDf
          del5=betD2(i5,iclegy)
	  rh5=delD2(i5,iclegy)
        do i6=1,nbpDf
          del6=betD2(i6,iclegy)
	  rh6=delD2(i6,iclegy)
	  ftij1=psftij(x*delx**2,sngl(del5+del6-dels))
     *    /x**(del5+del6)
        do i1=1,nbpDf
          del1=betD1(i1,iclegy,iclpro)
c          alp1=betDp1(i1,iclegy,iclpro)-alppar
	  rh1=delD1(i1,iclegy,iclpro)
        do i2=1,nbpDf
          del2=betD1(i2,iclegy,iclpro)
c          alp2=betDp1(i2,iclegy,iclpro)-alppar
	  rh2=delD1(i2,iclegy,iclpro)
	  rh12=rh1*rh2/(rh1+rh2)
	  ftij2=psftij(x*delx**2,sngl(del1+del2+del6-dels))
     *    /x**(del1+del2+del6)
        do i3=1,nbpDf
          del3=betD1(i3,iclegy,iclpro)
c          alp3=betDp1(i3,iclegy,iclpro)-alppar
	  rh3=delD1(i3,iclegy,iclpro)
        do i4=1,nbpDf
          del4=betD1(i4,iclegy,iclpro)
c          alp4=betDp1(i4,iclegy,iclpro)-alppar
	  rh4=delD1(i4,iclegy,iclpro)
	  rh34=rh3*rh4/(rh3+rh4)
	  ftij3=psftij(x*delx**2,sngl(del3+del4+del5-dels))
     *    /x**(del3+del4+del5)
	  ftij4=psftij(x*delx**2,sngl(del1+del2+del3+del4-dels))
     *    /x**(del1+del2+del3+del4)
          
          ftist=ftist
     *    +alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *    *alpD1(i3,iclegy,iclpro)*alpD1(i4,iclegy,iclpro)
     *    *alpD2(i5,iclegy)*alpD2(i6,iclegy)
     *    *coefu4(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)
     *    +nbpDf*nbpDf*nbpDf*(i4-1),iclpro)
     *    *(ddelx**(del5-del1-del2-del3-del4)*ftij4
     *    -ddelx**(del1+del2+del6-del3-del4-del5)*ftij3
     *    -ddelx**(del3+del4+del5-del1-del2-del6)*ftij2
     *    +ddelx**(del1+del2+del3+del4-del5-del6)*ftij1)
     *    /(del1+del2-del5)/(del3+del4-del6)
     *    /(rh5+rh6+rh12+rh34)/(rh1+rh2)/(rh3+rh4)
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        psftist=psftist-ftist
     *  *.5*pi*rr*(r3pom*pi/.0389)**3*glusea
     *  *gamdp(icdp,iclpro)**4*ccproj(icdp,iclpro)
      write(*,*)'4',psftist
      endif
      
      if(x.lt.delx**(-2.))then
        ftist=0.d0
        do i1=1,nbpDf
          del1=betD1(i1,iclegy,iclpro)
c          alp1=betDp1(i1,iclegy,iclpro)-alppar
	  rh1=delD1(i1,iclegy,iclpro)
	  ftij1=psftij(x*delx**2,sngl(del1-dels))
     *    /x**del1
        do i2=1,nbpDf
          del2=betD2(i2,iclegy)
	  rh2=delD2(i2,iclegy)
        do i3=1,nbpDf
          del3=betD2(i3,iclegy)
	  rh3=delD2(i3,iclegy)
	  ftij2=psftij(x*delx**2,sngl(del2+del3-dels))
     *    /x**(del2+del3)
          
          ftist=ftist
     *    +alpD1(i1,iclegy,iclpro)*alpD2(i2,iclegy)*alpD2(i3,iclegy)
     *    *coefu1(i1,iclpro)
     *    *(ddelx**(del1-del2-del3)*ftij2
     *    -ddelx**(del2+del3-del1)*ftij1)/(del2+del3-del1)
     *    /(rh2+rh3)
        enddo
        enddo
        enddo
        psftist=psftist-ftist
     *  *2.*pi*rr*(r3pom*pi/.0389)**2*glusea
     *  *gamdp(icdp,iclpro)*ccproj(icdp,iclpro)
c      write(*,*)'5',psftist
      endif
      
      if(x.lt.delx**(-3.))then
        ftist=0.d0
        do i1=1,nbpDf
          del1=betD1(i1,iclegy,iclpro)
c          alp1=betDp1(i1,iclegy,iclpro)-alppar
	  rh1=delD1(i1,iclegy,iclpro)
        do i2=1,nbpDf
          del2=betD1(i2,iclegy,iclpro)
c          alp2=betDp1(i2,iclegy,iclpro)-alppar
	  rh2=delD1(i2,iclegy,iclpro)
	  ftij1=psftij(x*delx**3,sngl(del1+del2-dels))
     *    /x**(del1+del2)
        do i4=1,nbpDf
          del4=betD2(i4,iclegy)
	  rh4=delD2(i4,iclegy)
        do i5=1,nbpDf
          del5=betD2(i5,iclegy)
	  rh5=delD2(i5,iclegy)
	  ftij2=psftij(x*delx**3,sngl(del4+del5-dels))
     *    /x**(del4+del5)
        do i3=1,nbpDf
          del3=betD2(i3,iclegy)
	  rh3=delD2(i3,iclegy)
	  ftij3=psftij(x*delx**3,sngl(del2+del3+del4-dels))
     *    /x**(del2+del3+del4)
          
          ftist=ftist
     *    +alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *    *alpD2(i3,iclegy)*alpD2(i4,iclegy)*alpD2(i5,iclegy)
     *    *coefu2(i1+nbpDf*(i2-1),iclpro)
     *    *((ddelx**(del5-del2-del3)*ftij3
     *    -ddelx**(2.d0*(del2+del3-del5))*ftij2)
     *    /(del2+del3-del5)*ddelx**(del1-del3-del4)
     *    -(ddelx**(del4+del5-del1-del2)*ftij1
     *    -ddelx**(2.d0*(del1+del2-del4-del5))*ftij2)
     *    /(del1+del2-del4-del5)*ddelx**(del3+del4-del1))
     *    /(del3+del4-del1)
     *    /((rh1+rh2)*(rh3+rh4+rh5)+rh3*(rh4+rh5))
        enddo
        enddo
        enddo
        enddo
        enddo
        psftist=psftist+ftist
     *  *4.*pi*rr*(r3pom*pi/.0389)**3*glusea
     *  *gamdp(icdp,iclpro)**2*ccproj(icdp,iclpro)
c      write(*,*)'6',psftist
      endif
         
      if(x.lt.delx**(-3.))then
        ftist=0.d0
        do i1=1,nbpDf
          del1=betD1(i1,iclegy,iclpro)
c          alp1=betDp1(i1,iclegy,iclpro)-alppar
	  rh1=delD1(i1,iclegy,iclpro)
        do i2=1,nbpDf
          del2=betD1(i2,iclegy,iclpro)
c          alp2=betDp1(i2,iclegy,iclpro)-alppar
	  rh2=delD1(i2,iclegy,iclpro)
	  ftij1=psftij(x*delx**3,sngl(del1+del2-dels))
     *    /x**(del1+del2)
        do i5=1,nbpDf
          del5=betD2(i5,iclegy)
	  rh5=delD2(i5,iclegy)
	  ftij2=psftij(x*delx**3,sngl(del2+del5-dels))
     *    /x**(del2+del5)
        do i3=1,nbpDf
          del3=betD2(i3,iclegy)
	  rh3=delD2(i3,iclegy)
        do i4=1,nbpDf
          del4=betD2(i4,iclegy)
	  rh4=delD2(i4,iclegy)
	  rh34=rh3*rh4/(rh3+rh4)
	  ftij3=psftij(x*delx**3,sngl(del2+del3+del4-dels))
     *    /x**(del2+del3+del4)
          
          ftist=ftist
     *    +alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *    *alpD2(i3,iclegy)*alpD2(i4,iclegy)*alpD2(i5,iclegy)
     *    *coefu2(i1+nbpDf*(i2-1),iclpro)
     *    *((ddelx**(del5-del3-del4)*ftij3
     *    -ddelx**(2.d0*(del3+del4-del5))*ftij2)
     *    /(del3+del4-del5)*ddelx**(del1-del3-del4)
     *    -(ddelx**(del5-del1)*ftij1-ddelx**(2.d0*(del1-del5))*ftij2)
     *    /(del1-del5)*ddelx**(del3+del4-del1))/(del3+del4-del1)
     *    /(rh1+rh2+rh34+rh5)/(rh3+rh4)
        enddo
        enddo
        enddo
        enddo
        enddo
        psftist=psftist+ftist
     *  *2.*pi*rr*(r3pom*pi/.0389)**3*glusea
     *  *gamdp(icdp,iclpro)**2*ccproj(icdp,iclpro)
c      write(*,*)'7',psftist
       endif
c1000       continue
       enddo
      icdp=icdps
      icdt=icdts
      iclpro=iclpros
      iclegy=iclegys
       return
       end
                  
c------------------------------------------------------------------------
      function psftig1(x,xpomr,jj)
c-----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      double precision del1,del2,del3,del4,del5,dxpomr
     *,dps2,dps3,dps4,dps5
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar6/  coefu1(nbpDf,nclha)
     *,coefu2(nbpDf*nbpDf,nclha)
     *,coefu3(nbpDf*nbpDf*nbpDf,nclha)
     *,coefu4(nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefu5(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefu6(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefc2(nbpDf*nbpDf,nclha)
     *,coefc3(nbpDf*nbpDf*nbpDf,nclha)
     *,coefc4(nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefc5(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
      common /psar7/  delx,alam3p,gam3p
      common /ar3/    x1(7),a1(7)

      icdps=icdp
      iclegys=iclegy

      dxpomr=dble(xpomr)
      psftig1=0.
      iclegy=1+max(0,int((.5*log(1./xpomr)-log(egylow))
     */log(egyfac)))
      iclegy=min(iclegy,iclegy2)
     
      
      do icdp=icdp1,icdp2
      
      if(jj.eq.1)then
       if(xpomr.lt.1./delx)then
        dps2=0.d0
        dps3=0.d0
        dps4=0.d0
        dps5=0.d0
        do i1=1,nbpDf
         del1=betD1(i1,iclegy,iclpro)
c         alp1=betDp1(i1,iclegy,iclpro)-alppar
	 rh1=delD1(i1,iclegy,iclpro)

        do i2=1,nbpDf
         del2=betD1(i2,iclegy,iclpro)
c         alp2=betDp1(i2,iclegy,iclpro)-alppar
	 rh2=delD1(i2,iclegy,iclpro)
	 
         dps2=dps2+alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *   *coefu2(i1+nbpDf*(i2-1),iclpro)
     *   *dxpomr**(dels-del1-del2)/(rh1+rh2)

        do i3=1,nbpDf
         del3=betD1(i3,iclegy,iclpro)
c         alp3=betDp1(i3,iclegy,iclpro)-alppar
	 rh3=delD1(i3,iclegy,iclpro)
	 rh=1./(1./rh1+1./rh2+1./rh3)
	
         dps3=dps3+alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *   *alpD1(i3,iclegy,iclpro)
     *   *coefu3(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1),iclpro)
     *   *dxpomr**(dels-del1-del2-del3) 
     *   /rh1/rh2/rh3*rh
	 
        do i4=1,nbpDf
         del4=betD1(i4,iclegy,iclpro)
c         alp4=betDp1(i4,iclegy,iclpro)-alppar
	 rh4=delD1(i4,iclegy,iclpro)
	 rh=1./(1./rh1+1./rh2+1./rh3+1./rh4)
	
         dps4=dps4+alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *   *alpD1(i3,iclegy,iclpro)*alpD1(i4,iclegy,iclpro)
     *   *coefu4(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)
     *   +nbpDf*nbpDf*nbpDf*(i4-1),iclpro)
     *   *dxpomr**(dels-del1-del2-del3-del4) 
     *   /rh1/rh2/rh3/rh4*rh

        do i5=1,nbpDf
         del5=betD1(i5,iclegy,iclpro)
c         alp5=betDp1(i5,iclegy,iclpro)-alppar
	 rh5=delD1(i5,iclegy,iclpro)
	 rh=1./(1./rh1+1./rh2+1./rh3+1./rh4+1./rh5)
	
         dps5=dps5+alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *   *alpD1(i3,iclegy,iclpro)*alpD1(i4,iclegy,iclpro)
     *   *alpD1(i5,iclegy,iclpro)
     *   *coefu5(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)+nbpDf*nbpDf
     *   *nbpDf*(i4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(i5-1),iclpro)
     *   *dxpomr**(dels-del1-del2-del3-del4-del5) 
     *   /rh1/rh2/rh3/rh4/rh5*rh
        enddo
        enddo
        enddo
        enddo
        enddo
     
        psftig1=psftig1
     *  +(dps2/2.d0*gamdp(icdp,iclpro)**2
     *  -dps3*gam3p/2.d0*gamdp(icdp,iclpro)**3
     *  +dps4*gam3p**2*7.d0/24.d0*gamdp(icdp,iclpro)**4
     *  -dps5*gam3p**3/8.d0*gamdp(icdp,iclpro)**5)
     *  *(1.-x/dxpomr)**betpom/x**dels
     *  *4.*pi*rr*(r3pom*pi/.0389)*(1.-glusea)
     *  *ccproj(icdp,iclpro)
       endif
      endif
      enddo     
      icdp=icdps
      iclegy=iclegys
      return
      end
           
c------------------------------------------------------------------------
      function psftis1(x,xpomr,jj)
c-----------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      double precision del1,del2,del3,del4,del5,dxpomr
     *,dps2,dps3,dps4,dps5
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar6/  coefu1(nbpDf,nclha)
     *,coefu2(nbpDf*nbpDf,nclha)
     *,coefu3(nbpDf*nbpDf*nbpDf,nclha)
     *,coefu4(nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefu5(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefu6(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefc2(nbpDf*nbpDf,nclha)
     *,coefc3(nbpDf*nbpDf*nbpDf,nclha)
     *,coefc4(nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefc5(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
      common /psar7/ delx,alam3p,gam3p
      
      icdps=icdp
      iclegys=iclegy
      dxpomr=dble(xpomr)
      psftis1=0.
      
      do icdp=icdp1,icdp2
      
      if(jj.eq.1)then
       if(xpomr.lt.1./delx)then
        iclegy=1+max(0,int((.5*log(1./xpomr)-log(egylow))
     *  /log(egyfac)))
        iclegy=min(iclegy,iclegy2)
     
        dps2=0.d0
        dps3=0.d0
        dps4=0.d0
        dps5=0.d0
        do i1=1,nbpDf
         del1=betD1(i1,iclegy,iclpro)
c         alp1=betDp1(i1,iclegy,iclpro)-alppar
	 rh1=delD1(i1,iclegy,iclpro)

        do i2=1,nbpDf
         del2=betD1(i2,iclegy,iclpro)
c         alp2=betDp1(i2,iclegy,iclpro)-alppar
	 rh2=delD1(i2,iclegy,iclpro)
	 
         dps2=dps2+alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *   *coefu2(i1+nbpDf*(i2-1),iclpro)
     *   *dxpomr**(dels-del1-del2)/(rh1+rh2)

        do i3=1,nbpDf
         del3=betD1(i3,iclegy,iclpro)
c         alp3=betDp1(i3,iclegy,iclpro)-alppar
	 rh3=delD1(i3,iclegy,iclpro)
	 rh=1./(1./rh1+1./rh2+1./rh3)
	
         dps3=dps3+alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *   *alpD1(i3,iclegy,iclpro)
     *   *coefu3(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1),iclpro)
     *   *dxpomr**(dels-del1-del2-del3) 
     *   /rh1/rh2/rh3*rh
	 
        do i4=1,nbpDf
         del4=betD1(i4,iclegy,iclpro)
c         alp4=betDp1(i4,iclegy,iclpro)-alppar
	 rh4=delD1(i4,iclegy,iclpro)
	 rh=1./(1./rh1+1./rh2+1./rh3+1./rh4)
	
         dps4=dps4+alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *   *alpD1(i3,iclegy,iclpro)*alpD1(i4,iclegy,iclpro)
     *   *coefu4(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)
     *   +nbpDf*nbpDf*nbpDf*(i4-1),iclpro)
     *   *dxpomr**(dels-del1-del2-del3-del4) 
     *   /rh1/rh2/rh3/rh4*rh

        do i5=1,nbpDf
         del5=betD1(i5,iclegy,iclpro)
c         alp5=betDp1(i5,iclegy,iclpro)-alppar
	 rh5=delD1(i5,iclegy,iclpro)
	 rh=1./(1./rh1+1./rh2+1./rh3+1./rh4+1./rh5)
	
         dps5=dps5+alpD1(i1,iclegy,iclpro)*alpD1(i2,iclegy,iclpro)
     *   *alpD1(i3,iclegy,iclpro)*alpD1(i4,iclegy,iclpro)
     *   *alpD1(i5,iclegy,iclpro)
     *   *coefu5(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)+nbpDf*nbpDf
     *   *nbpDf*(i4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(i5-1),iclpro)
     *   *dxpomr**(dels-del1-del2-del3-del4-del5) 
     *   /rh1/rh2/rh3/rh4/rh5*rh
        enddo
        enddo
        enddo
        enddo
        enddo
     
        psftis1=psftis1
     *  +(dps2/2.d0*gamdp(icdp,iclpro)**2
     *  -dps3*gam3p/2.d0*gamdp(icdp,iclpro)**3
     *  +dps4*gam3p**2*7.d0/24.d0*gamdp(icdp,iclpro)**4
     *  -dps5*gam3p**3/8.d0*gamdp(icdp,iclpro)**5)
     *  *psftilf(x/xpomr)/x**dels*4.*pi*rr*(r3pom*pi/.0389)*glusea
     *  *ccproj(icdp,iclpro)
       endif
      endif
      enddo
      icdp=icdps
      iclegy=iclegys
      return
      end

c------------------------------------------------------------------------
      function psd3p1(xd,xpomr,qq,jj)
c-----------------------------------------------------------------------
c psd3p1 - df2difr/dx_pomr
c xd - bjorken x,
c xpomr - pomeron x,
c qq - photon virtuality
c jj=1 - 1st order
c-----------------------------------------------------------------------
      double precision xx
      common /ar3/    x1(7),a1(7)
      include 'nexus.inc'
      include 'nexus.incsem'

      s=qq/xd
      dqsh=psftis1(xd,xpomr,jj)/4.5
     **psuds(qq,1)/psuds(q2min,1)

      s2min=qq/(1.-q2ini/qq)
      xmin=s2min/s
      xmin=xmin**(delh-dels)
      xmax=min(1.,xpomr)**(delh-dels)
      dsh=0.
      if(xmin.lt.xmax)then
c numerical integration over z1
        do i=1,7
        do m=1,2
          z1=(.5*(xmax+xmin-(2*m-3)*x1(i)*(xmax-xmin)))**
     *    (1./(delh-dels))
          xx=xd/z1
          sdtg=psevi(q2min,qq,xx,1,2)*xx
          sdtq=psevi(q2min,qq,xx,2,2)*xx
          dsh=dsh+a1(i)*(sdtg*psftig1(z1,xpomr,jj)
     *    +sdtq*psftis1(z1,xpomr,jj))*z1**(dels-delh)
        enddo
        enddo
        dsh=dsh*(xmax-xmin)/(delh-dels)/2.
      endif
      psd3p1=dqsh+dsh/4.5
c      write (*,*)'dqsh',dqsh,dsh/4.5
      return
      end
      
c------------------------------------------------------------------------
      function psv3p(sy,xpp,xpm,zb)
c-----------------------------------------------------------------------
c psv3p - 3p-contributions to the interaction eikonal
c sy  - energy squared for the hard interaction,
c xpp - lc+ for the sh pomeron,
c xpm - lc- for the sh pomeron,
c z   - impact parameter factor, z=exp(-b**2/4*rp),
c------------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      double precision dsy,ddelx,dxpp,dxpm
     *,delp1,delp2,delp3,delp4,delp5,delt1,delt2,delt3,delt4,delt5
     *,deli1,deli2
     *,dps,dpx1,dpx2,dpx3,dps1,dps2,dps3
     *,dps12,dps13,dps14,dps15,dps22,dps23,dps24,dps25
     *,dps32,dps33,dps34,dps35,dps42,dps43,dps44,dps45
     *,dps52,dps53,dps54,dps55,dps21,dps31,dps41,dps51
     *,dps3120,dps4120,dps5120,dps4220,dps5220,dps5320
     *,dps3130,dps4130,dps5130,dps4230,dps5230,dps5330
     *,dps3140,dps4140,dps5140,dps4240,dps5240,dps5340
     *,dps3150,dps4150,dps5150,dps4250,dps5250,dps5350
     *,dps2031,dps3031,dps4031,dps5031,dps3131,dps4131,dps5131
     *,dps4231,dps5231,dps5331
     *,dps2041,dps3041,dps4041,dps5041,dps3141,dps4141,dps5141
     *,dps4241,dps5241,dps5341
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar6/  coefu1(nbpDf,nclha)
     *,coefu2(nbpDf*nbpDf,nclha)
     *,coefu3(nbpDf*nbpDf*nbpDf,nclha)
     *,coefu4(nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefu5(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefu6(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefc2(nbpDf*nbpDf,nclha)
     *,coefc3(nbpDf*nbpDf*nbpDf,nclha)
     *,coefc4(nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefc5(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
      common /psar7/ delx,alam3p,gam3p
      
      dsy=dble(sy)/xpp/xpm
      ddelx=dble(delx)
      psv3p=0.      
      iclegys=iclegy
      if(dsy.le.ddelx**2)return

      dxpp=dble(xpp)
      dxpm=dble(xpm)      
      rp=(r2had(iclpro)+r2had(icltar)+slopom*log(max(1.,sy)))*4.*.0389

c      iclegy=1+max(0,int((log(dsy)/6.-log(egylow))/log(egyfac)))
c      iclegy=min(iclegy,iclegy2)
      iclegy=iclegy2

      dps12=0.d0
      dps13=0.d0
      dps14=0.d0
      dps15=0.d0
      do ip1=1,nbpDf
        delp1=betD1(ip1,iclegy,iclpro)
        alpp1=betDp1(ip1,iclegy,iclpro)-alppar
	rhp1=delD1(ip1,iclegy,iclpro)
      do it1=1,nbpDf
        delt1=betD1(it1,iclegy,icltar)
        alpt1=betDp1(it1,iclegy,icltar)-alppar
	rht1=delD1(it1,iclegy,icltar)
      do it2=1,nbpDf
        delt2=betD1(it2,iclegy,icltar)
        alpt2=betDp1(it2,iclegy,icltar)-alppar
	rht2=delD1(it2,iclegy,icltar)
	rh=rhp1+rht1*rht2/(rht1+rht2)

        dps12=dps12+((dsy/ddelx)**(delt1+delt2-delp1)
     *  -ddelx**(delt1+delt2-delp1))/(delt1+delt2-delp1)*dsy**delp1
     *  *dxpm**(2.d0+alpt1+alpt2+delt1+delt2)*dxpp**(1.d0+alpp1+delp1)
     *  *coefu2(it1+nbpDf*(it2-1),icltar)*coefu1(ip1,iclpro)
     *  *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *  *alpD1(ip1,iclegy,iclpro)
     *  /(rht1+rht2)/rh*zb**(rp/rh)

      do it3=1,nbpDf
        delt3=betD1(it3,iclegy,icltar)
        alpt3=betDp1(it3,iclegy,icltar)-alppar
	rht3=delD1(it3,iclegy,icltar)
	rh3=1./(1./rht1+1./rht2+1./rht3)
	rh=rhp1+rh3

        dps13=dps13+((dsy/ddelx)**(delt1+delt2+delt3-delp1)
     *  -ddelx**(delt1+delt2+delt3-delp1))/(delt1+delt2+delt3-delp1)
     *  *dsy**delp1*dxpp**(1.d0+alpp1+delp1)
     *  *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *  *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *  *coefu1(ip1,iclpro)
     *  *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *  *alpD1(it3,iclegy,icltar)*alpD1(ip1,iclegy,iclpro)
     *  *rh3/rht1/rht2/rht3/rh*zb**(rp/rh)

      do it4=1,nbpDf
        delt4=betD1(it4,iclegy,icltar)
        alpt4=betDp1(it4,iclegy,icltar)-alppar
	rht4=delD1(it4,iclegy,icltar)
	rh4=1./(1./rht1+1./rht2+1./rht3+1./rht4)
	rh=rhp1+rh4

        dps14=dps14+((dsy/ddelx)**(delt1+delt2+delt3+delt4-delp1)
     *  -ddelx**(delt1+delt2+delt3+delt4-delp1))
     *  /(delt1+delt2+delt3+delt4-delp1)
     *  *dsy**delp1*dxpp**(1.d0+alpp1+delp1)
     *  *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *  *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *  +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *  *coefu1(ip1,iclpro)
     *  *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *  *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *  *alpD1(ip1,iclegy,iclpro)
     *  *rh4/rht1/rht2/rht3/rht4/rh*zb**(rp/rh)

      do it5=1,nbpDf
        delt5=betD1(it5,iclegy,icltar)
        alpt5=betDp1(it5,iclegy,icltar)-alppar
	rht5=delD1(it5,iclegy,icltar)
	rh5=1./(1./rht1+1./rht2+1./rht3+1./rht4+1./rht5)
	rh=rhp1+rh5

        dps15=dps15+((dsy/ddelx)**(delt1+delt2+delt3+delt4+delt5-delp1)
     *  -ddelx**(delt1+delt2+delt3+delt4+delt5-delp1))
     *  /(delt1+delt2+delt3+delt4+delt5-delp1)
     *  *dsy**delp1*dxpp**(1.d0+alpp1+delp1)
     *  *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *  +delt1+delt2+delt3+delt4+delt5)
     *  *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *  *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *  *coefu1(ip1,iclpro)
     *  *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *  *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *  *alpD1(it5,iclegy,icltar)*alpD1(ip1,iclegy,iclpro)
     *  *rh5/rht1/rht2/rht3/rht4/rht5/rh*zb**(rp/rh)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      dps12=-dps12*(r3pom*pi/.0389)/2.
     **gamdp(icdp,iclpro)*gamdt(icdt,icltar)**2
      dps13=dps13*(r3pom*pi/.0389)/6.*gam3p
     **gamdp(icdp,iclpro)*gamdt(icdt,icltar)**3
      dps14=-dps14*(r3pom*pi/.0389)/24.*gam3p**2
     **gamdp(icdp,iclpro)*gamdt(icdt,icltar)**4
      dps15=dps15*(r3pom*pi/.0389)/120.*gam3p**3
     **gamdp(icdp,iclpro)*gamdt(icdt,icltar)**5

      dps22=0.d0
      dps23=0.d0
      dps24=0.d0
      dps25=0.d0
      do ip1=1,nbpDf
        delp1=betD1(ip1,iclegy,iclpro)
        alpp1=betDp1(ip1,iclegy,iclpro)-alppar
	rhp1=delD1(ip1,iclegy,iclpro)
      do ip2=1,nbpDf
        delp2=betD1(ip2,iclegy,iclpro)
        alpp2=betDp1(ip2,iclegy,iclpro)-alppar
	rhp2=delD1(ip2,iclegy,iclpro)
	rhp=rhp1*rhp2/(rhp1+rhp2)
      do it1=1,nbpDf
        delt1=betD1(it1,iclegy,icltar)
        alpt1=betDp1(it1,iclegy,icltar)-alppar
	rht1=delD1(it1,iclegy,icltar)
      do it2=1,nbpDf
        delt2=betD1(it2,iclegy,icltar)
        alpt2=betDp1(it2,iclegy,icltar)-alppar
	rht2=delD1(it2,iclegy,icltar)
	rh=rhp+rht1*rht2/(rht1+rht2)

        if(abs(delt1+delt2-delp1-delp2).lt.1.e-5)then
          dps=log(max(1.d0,dsy/ddelx**2))
        else
          dps=((dsy/ddelx)**(delt1+delt2-delp1-delp2)
     *    -ddelx**(delt1+delt2-delp1-delp2))
     *    /(delt1+delt2-delp1-delp2)
        endif 
        
        dps22=dps22+dps*dsy**(delp1+delp2)
     *  *dxpm**(2.d0+alpt1+alpt2+delt1+delt2)
     *  *dxpp**(2.d0+alpp1+alpp2+delp1+delp2)
     *  *coefu2(it1+nbpDf*(it2-1),icltar)
     *  *coefu2(ip1+nbpDf*(ip2-1),iclpro)
     *  *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *  *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *  /(rht1+rht2)/(rhp1+rhp2)/rh*zb**(rp/rh)
 
      do it3=1,nbpDf
        delt3=betD1(it3,iclegy,icltar)
        alpt3=betDp1(it3,iclegy,icltar)-alppar
	rht3=delD1(it3,iclegy,icltar)
	rh3=1./(1./rht1+1./rht2+1./rht3)
	rh=rhp+rh3

        dps23=dps23+((dsy/ddelx)**(delt1+delt2+delt3-delp1-delp2)
     *  -ddelx**(delt1+delt2+delt3-delp1-delp2))
     *  /(delt1+delt2+delt3-delp1-delp2)
     *  *dsy**(delp1+delp2)*dxpp**(2.d0+alpp1+alpp2+delp1+delp2)
     *  *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *  *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *  *coefu2(ip1+nbpDf*(ip2-1),iclpro)
     *  *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *  *alpD1(it3,iclegy,icltar)*alpD1(ip1,iclegy,iclpro)
     *  *alpD1(ip2,iclegy,iclpro)
     *  *rh3/rht1/rht2/rht3/(rhp1+rhp2)/rh*zb**(rp/rh)

      do it4=1,nbpDf
        delt4=betD1(it4,iclegy,icltar)
        alpt4=betDp1(it4,iclegy,icltar)-alppar
	rht4=delD1(it4,iclegy,icltar)
	rh4=1./(1./rht1+1./rht2+1./rht3+1./rht4)
	rh=rhp+rh4

        dps24=dps24+((dsy/ddelx)**(delt1+delt2+delt3+delt4-delp1-delp2)
     *  -ddelx**(delt1+delt2+delt3+delt4-delp1-delp2))
     *  /(delt1+delt2+delt3+delt4-delp1-delp2)
     *  *dsy**(delp1+delp2)*dxpp**(2.d0+alpp1+alpp2+delp1+delp2)
     *  *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *  *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *  +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *  *coefu2(ip1+nbpDf*(ip2-1),iclpro)
     *  *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *  *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *  *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *  *rh4/rht1/rht2/rht3/rht4/(rhp1+rhp2)/rh*zb**(rp/rh)

      do it5=1,nbpDf
        delt5=betD1(it5,iclegy,icltar)
        alpt5=betDp1(it5,iclegy,icltar)-alppar
	rht5=delD1(it5,iclegy,icltar)
	rh5=1./(1./rht1+1./rht2+1./rht3+1./rht4+1./rht5)
	rh=rhp+rh5

        dps25=dps25
     *  +((dsy/ddelx)**(delt1+delt2+delt3+delt4+delt5-delp1-delp2)
     *  -ddelx**(delt1+delt2+delt3+delt4+delt5-delp1-delp2))
     *  /(delt1+delt2+delt3+delt4+delt5-delp1-delp2)
     *  *dsy**(delp1+delp2)*dxpp**(2.d0+alpp1+alpp2+delp1+delp2)
     *  *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *  +delt1+delt2+delt3+delt4+delt5)
     *  *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *  *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *  *coefu2(ip1+nbpDf*(ip2-1),iclpro)
     *  *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *  *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *  *alpD1(it5,iclegy,icltar)*alpD1(ip1,iclegy,iclpro)
     *  *alpD1(ip2,iclegy,iclpro)
     *  *rh5/rht1/rht2/rht3/rht4/rht5/(rhp1+rhp2)/rh*zb**(rp/rh)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      dps22=dps22*(r3pom*pi/.0389)/4.*gam3p
     **gamdp(icdp,iclpro)**2*gamdt(icdt,icltar)**2
      dps23=-dps23*(r3pom*pi/.0389)/12.*gam3p**2
     **gamdp(icdp,iclpro)**2*gamdt(icdt,icltar)**3
      dps24=dps24*(r3pom*pi/.0389)/48.*gam3p**3
     **gamdp(icdp,iclpro)**2*gamdt(icdt,icltar)**4
      dps25=-dps25*(r3pom*pi/.0389)/240.*gam3p**4
     **gamdp(icdp,iclpro)**2*gamdt(icdt,icltar)**5

      dps32=0.d0
      dps33=0.d0
      dps34=0.d0
      dps35=0.d0
      do ip1=1,nbpDf
        delp1=betD1(ip1,iclegy,iclpro)
        alpp1=betDp1(ip1,iclegy,iclpro)-alppar
	rhp1=delD1(ip1,iclegy,iclpro)
      do ip2=1,nbpDf
        delp2=betD1(ip2,iclegy,iclpro)
        alpp2=betDp1(ip2,iclegy,iclpro)-alppar
	rhp2=delD1(ip2,iclegy,iclpro)
      do ip3=1,nbpDf
        delp3=betD1(ip3,iclegy,iclpro)
        alpp3=betDp1(ip3,iclegy,iclpro)-alppar
	rhp3=delD1(ip3,iclegy,iclpro)
	rhp=1./(1./rhp1+1./rhp2+1./rhp3)
      do it1=1,nbpDf
        delt1=betD1(it1,iclegy,icltar)
        alpt1=betDp1(it1,iclegy,icltar)-alppar
	rht1=delD1(it1,iclegy,icltar)
      do it2=1,nbpDf
        delt2=betD1(it2,iclegy,icltar)
        alpt2=betDp1(it2,iclegy,icltar)-alppar
	rht2=delD1(it2,iclegy,icltar)
	rh=rhp+rht1*rht2/(rht1+rht2)

        
        dps32=dps32+((dsy/ddelx)**(delt1+delt2-delp1-delp2-delp3)
     *  -ddelx**(delt1+delt2-delp1-delp2-delp3))
     *  /(delt1+delt2-delp1-delp2-delp3)*dsy**(delp1+delp2+delp3)
     *  *dxpm**(2.d0+alpt1+alpt2+delt1+delt2)
     *  *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *  *coefu2(it1+nbpDf*(it2-1),icltar)
     *  *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *  *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *  *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *  *alpD1(ip3,iclegy,iclpro)
     *  /(rht1+rht2)*rhp/rhp1/rhp2/rhp3/rh*zb**(rp/rh)
 
      do it3=1,nbpDf
        delt3=betD1(it3,iclegy,icltar)
        alpt3=betDp1(it3,iclegy,icltar)-alppar
	rht3=delD1(it3,iclegy,icltar)
	rh3=1./(1./rht1+1./rht2+1./rht3)
	rh=rhp+rh3

        if(abs(delt1+delt2+delt3-delp1-delp2-delp3).lt.1.e-5)then
          dps=log(max(1.d0,dsy/ddelx**2))
        else
          dps=((dsy/ddelx)**(delt1+delt2+delt3-delp1-delp2-delp3)
     *    -ddelx**(delt1+delt2+delt3-delp1-delp2-delp3))
     *    /(delt1+delt2+delt3-delp1-delp2-delp3)
        endif 
        dps33=dps33+dps*dsy**(delp1+delp2+delp3)
     *  *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *  *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *  *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *  *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *  *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *  *alpD1(it3,iclegy,icltar)*alpD1(ip1,iclegy,iclpro)
     *  *alpD1(ip2,iclegy,iclpro)*alpD1(ip3,iclegy,iclpro)
     *  *rh3/rht1/rht2/rht3*rhp/rhp1/rhp2/rhp3/rh*zb**(rp/rh)

      do it4=1,nbpDf
        delt4=betD1(it4,iclegy,icltar)
        alpt4=betDp1(it4,iclegy,icltar)-alppar
	rht4=delD1(it4,iclegy,icltar)
	rh4=1./(1./rht1+1./rht2+1./rht3+1./rht4)
	rh=rhp+rh4

        dps34=dps34
     *  +((dsy/ddelx)**(delt1+delt2+delt3+delt4-delp1-delp2-delp3)
     *  -ddelx**(delt1+delt2+delt3+delt4-delp1-delp2-delp3))
     *  /(delt1+delt2+delt3+delt4-delp1-delp2-delp3)
     *  *dsy**(delp1+delp2+delp3)
     *  *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *  *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *  *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *  +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *  *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *  *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *  *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *  *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *  *alpD1(ip3,iclegy,iclpro)
     *  *rh4/rht1/rht2/rht3/rht4*rhp/rhp1/rhp2/rhp3/rh*zb**(rp/rh)

      do it5=1,nbpDf
        delt5=betD1(it5,iclegy,icltar)
        alpt5=betDp1(it5,iclegy,icltar)-alppar
	rht5=delD1(it5,iclegy,icltar)
	rh5=1./(1./rht1+1./rht2+1./rht3+1./rht4+1./rht5)
	rh=rhp+rh5

        dps35=dps35
     *  +((dsy/ddelx)**(delt1+delt2+delt3+delt4+delt5-delp1-delp2-delp3)
     *  -ddelx**(delt1+delt2+delt3+delt4+delt5-delp1-delp2-delp3))
     *  /(delt1+delt2+delt3+delt4+delt5-delp1-delp2-delp3)
     *  *dsy**(delp1+delp2+delp3)
     *  *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *  *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *  +delt1+delt2+delt3+delt4+delt5)
     *  *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *  *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *  *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *  *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *  *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *  *alpD1(it5,iclegy,icltar)*alpD1(ip1,iclegy,iclpro)
     *  *alpD1(ip2,iclegy,iclpro)*alpD1(ip3,iclegy,iclpro)
     *  *rh5/rht1/rht2/rht3/rht4/rht5*rhp/rhp1/rhp2/rhp3/rh*zb**(rp/rh)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      dps32=-dps32*(r3pom*pi/.0389)/12.*gam3p**2
     **gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**2
      dps33=dps33*(r3pom*pi/.0389)/36.*gam3p**3
     **gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**3
      dps34=-dps34*(r3pom*pi/.0389)/144.*gam3p**4
     **gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**4
      dps35=dps35*(r3pom*pi/.0389)/720.*gam3p**5
     **gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**5

      dps42=0.d0
      dps43=0.d0
      dps44=0.d0
      dps45=0.d0
      do ip1=1,nbpDf
        delp1=betD1(ip1,iclegy,iclpro)
        alpp1=betDp1(ip1,iclegy,iclpro)-alppar
	rhp1=delD1(ip1,iclegy,iclpro)
      do ip2=1,nbpDf
        delp2=betD1(ip2,iclegy,iclpro)
        alpp2=betDp1(ip2,iclegy,iclpro)-alppar
	rhp2=delD1(ip2,iclegy,iclpro)
      do ip3=1,nbpDf
        delp3=betD1(ip3,iclegy,iclpro)
        alpp3=betDp1(ip3,iclegy,iclpro)-alppar
	rhp3=delD1(ip3,iclegy,iclpro)
      do ip4=1,nbpDf
        delp4=betD1(ip4,iclegy,iclpro)
        alpp4=betDp1(ip4,iclegy,iclpro)-alppar
	rhp4=delD1(ip4,iclegy,iclpro)
	rhp=1./(1./rhp1+1./rhp2+1./rhp3+1./rhp4)
      do it1=1,nbpDf
        delt1=betD1(it1,iclegy,icltar)
        alpt1=betDp1(it1,iclegy,icltar)-alppar
	rht1=delD1(it1,iclegy,icltar)
      do it2=1,nbpDf
        delt2=betD1(it2,iclegy,icltar)
        alpt2=betDp1(it2,iclegy,icltar)-alppar
	rht2=delD1(it2,iclegy,icltar)
	rh=rhp+rht1*rht2/(rht1+rht2)

        
        dps42=dps42+((dsy/ddelx)**(delt1+delt2-delp1-delp2-delp3-delp4)
     *  -ddelx**(delt1+delt2-delp1-delp2-delp3-delp4))
     *  /(delt1+delt2-delp1-delp2-delp3-delp4)
     *  *dsy**(delp1+delp2+delp3+delp4)
     *  *dxpm**(2.d0+alpt1+alpt2+delt1+delt2)
     *  *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *  *coefu2(it1+nbpDf*(it2-1),icltar)
     *  *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *  +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *  *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *  *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *  *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *  /(rht1+rht2)*rhp/rhp1/rhp2/rhp3/rhp4/rh*zb**(rp/rh)
 
      do it3=1,nbpDf
        delt3=betD1(it3,iclegy,icltar)
        alpt3=betDp1(it3,iclegy,icltar)-alppar
	rht3=delD1(it3,iclegy,icltar)
	rh3=1./(1./rht1+1./rht2+1./rht3)
	rh=rhp+rh3

        dps43=dps43
     *  +((dsy/ddelx)**(delt1+delt2+delt3-delp1-delp2-delp3-delp4)
     *  -ddelx**(delt1+delt2+delt3-delp1-delp2-delp3-delp4))
     *  /(delt1+delt2+delt3-delp1-delp2-delp3-delp4)
     *  *dsy**(delp1+delp2+delp3+delp4)
     *  *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *  *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *  *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *  *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *  +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *  *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *  *alpD1(it3,iclegy,icltar)*alpD1(ip1,iclegy,iclpro)
     *  *alpD1(ip2,iclegy,iclpro)*alpD1(ip3,iclegy,iclpro)
     *  *alpD1(ip4,iclegy,iclpro)
     *  *rh3/rht1/rht2/rht3*rhp/rhp1/rhp2/rhp3/rhp4/rh*zb**(rp/rh)

      do it4=1,nbpDf
        delt4=betD1(it4,iclegy,icltar)
        alpt4=betDp1(it4,iclegy,icltar)-alppar
	rht4=delD1(it4,iclegy,icltar)
	rh4=1./(1./rht1+1./rht2+1./rht3+1./rht4)
	rh=rhp+rh4

        if(abs(delt1+delt2+delt3+delt4-delp1-delp2-delp3-delp4)
     *  .lt.1.e-5)then
          dps=log(max(1.d0,dsy/ddelx**2))
        else
          dps=((dsy/ddelx)**(delt1+delt2+delt3+delt4
     *    -delp1-delp2-delp3-delp4)
     *    -ddelx**(delt1+delt2+delt3+delt4-delp1-delp2-delp3-delp4))
     *    /(delt1+delt2+delt3+delt4-delp1-delp2-delp3-delp4)
        endif 
        dps44=dps44+dps*dsy**(delp1+delp2+delp3+delp4)
     *  *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *  *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *  *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *  +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *  *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *  +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *  *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *  *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *  *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *  *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *  *rh4/rht1/rht2/rht3/rht4*rhp/rhp1/rhp2/rhp3/rhp4/rh*zb**(rp/rh)

      do it5=1,nbpDf
        delt5=betD1(it5,iclegy,icltar)
        alpt5=betDp1(it5,iclegy,icltar)-alppar
	rht5=delD1(it5,iclegy,icltar)
	rh5=1./(1./rht1+1./rht2+1./rht3+1./rht4+1./rht5)
	rh=rhp+rh5

        dps45=dps45
     *  +((dsy/ddelx)**(delt1+delt2+delt3+delt4+delt5
     *  -delp1-delp2-delp3-delp4)-ddelx**(delt1+delt2
     *  +delt3+delt4+delt5-delp1-delp2-delp3-delp4))
     *  /(delt1+delt2+delt3+delt4+delt5-delp1-delp2-delp3-delp4)
     *  *dsy**(delp1+delp2+delp3+delp4)
     *  *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *  *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *  +delt1+delt2+delt3+delt4+delt5)
     *  *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *  *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *  *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *  +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *  *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *  *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *  *alpD1(it5,iclegy,icltar)*alpD1(ip1,iclegy,iclpro)
     *  *alpD1(ip2,iclegy,iclpro)*alpD1(ip3,iclegy,iclpro)
     *  *alpD1(ip4,iclegy,iclpro)
     *  *rh5/rht1/rht2/rht3/rht4/rht5
     *  *rhp/rhp1/rhp2/rhp3/rhp4/rh*zb**(rp/rh)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      dps42=dps42*(r3pom*pi/.0389)/48.*gam3p**3
     **gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**2
      dps43=-dps43*(r3pom*pi/.0389)/144.*gam3p**4
     **gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**3
      dps44=dps44*(r3pom*pi/.0389)/576.*gam3p**5
     **gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**4
      dps45=-dps45*(r3pom*pi/.0389)/2880.*gam3p**6
     **gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**5

      dps52=0.d0
      dps53=0.d0
      dps54=0.d0
      dps55=0.d0
      do ip1=1,nbpDf
        delp1=betD1(ip1,iclegy,iclpro)
        alpp1=betDp1(ip1,iclegy,iclpro)-alppar
	rhp1=delD1(ip1,iclegy,iclpro)
      do ip2=1,nbpDf
        delp2=betD1(ip2,iclegy,iclpro)
        alpp2=betDp1(ip2,iclegy,iclpro)-alppar
	rhp2=delD1(ip2,iclegy,iclpro)
      do ip3=1,nbpDf
        delp3=betD1(ip3,iclegy,iclpro)
        alpp3=betDp1(ip3,iclegy,iclpro)-alppar
	rhp3=delD1(ip3,iclegy,iclpro)
      do ip4=1,nbpDf
        delp4=betD1(ip4,iclegy,iclpro)
        alpp4=betDp1(ip4,iclegy,iclpro)-alppar
	rhp4=delD1(ip4,iclegy,iclpro)
      do ip5=1,nbpDf
        delp5=betD1(ip5,iclegy,iclpro)
        alpp5=betDp1(ip5,iclegy,iclpro)-alppar
	rhp5=delD1(ip5,iclegy,iclpro)
	rhp=1./(1./rhp1+1./rhp2+1./rhp3+1./rhp4+1./rhp5)
      do it1=1,nbpDf
        delt1=betD1(it1,iclegy,icltar)
        alpt1=betDp1(it1,iclegy,icltar)-alppar
	rht1=delD1(it1,iclegy,icltar)
      do it2=1,nbpDf
        delt2=betD1(it2,iclegy,icltar)
        alpt2=betDp1(it2,iclegy,icltar)-alppar
	rht2=delD1(it2,iclegy,icltar)
	rh=rhp+rht1*rht2/(rht1+rht2)

        
        dps52=dps52
     *  +((dsy/ddelx)**(delt1+delt2-delp1-delp2-delp3-delp4-delp5)
     *  -ddelx**(delt1+delt2-delp1-delp2-delp3-delp4-delp5))
     *  /(delt1+delt2-delp1-delp2-delp3-delp4-delp5)
     *  *dsy**(delp1+delp2+delp3+delp4+delp5)
     *  *dxpm**(2.d0+alpt1+alpt2+delt1+delt2)
     *  *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *  +delp1+delp2+delp3+delp4+delp5)
     *  *coefu2(it1+nbpDf*(it2-1),icltar)
     *  *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *  *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *  *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *  *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *  *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *  *alpD1(ip5,iclegy,iclpro)
     *  /(rht1+rht2)*rhp/rhp1/rhp2/rhp3/rhp4/rhp5/rh*zb**(rp/rh)
 
      do it3=1,nbpDf
        delt3=betD1(it3,iclegy,icltar)
        alpt3=betDp1(it3,iclegy,icltar)-alppar
	rht3=delD1(it3,iclegy,icltar)
	rh3=1./(1./rht1+1./rht2+1./rht3)
	rh=rhp+rh3

        dps53=dps53+((dsy/ddelx)**(delt1+delt2+delt3
     *  -delp1-delp2-delp3-delp4-delp5)
     *  -ddelx**(delt1+delt2+delt3-delp1-delp2-delp3-delp4-delp5))
     *  /(delt1+delt2+delt3-delp1-delp2-delp3-delp4-delp5)
     *  *dsy**(delp1+delp2+delp3+delp4+delp5)
     *  *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *  +delp1+delp2+delp3+delp4+delp5)
     *  *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *  *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *  *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *  *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *  *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *  *alpD1(it3,iclegy,icltar)*alpD1(ip1,iclegy,iclpro)
     *  *alpD1(ip2,iclegy,iclpro)*alpD1(ip3,iclegy,iclpro)
     *  *alpD1(ip4,iclegy,iclpro)*alpD1(ip5,iclegy,iclpro)
     *  *rh3/rht1/rht2/rht3*rhp/rhp1/rhp2/rhp3/rhp4/rhp5/rh*zb**(rp/rh)

      do it4=1,nbpDf
        delt4=betD1(it4,iclegy,icltar)
        alpt4=betDp1(it4,iclegy,icltar)-alppar
	rht4=delD1(it4,iclegy,icltar)
	rh4=1./(1./rht1+1./rht2+1./rht3+1./rht4)
	rh=rhp+rh4

        dps=((dsy/ddelx)**(delt1+delt2+delt3+delt4
     *  -delp1-delp2-delp3-delp4-delp5)-ddelx**(delt1+delt2
     *  +delt3+delt4-delp1-delp2-delp3-delp4-delp5))
     *  /(delt1+delt2+delt3+delt4-delp1-delp2-delp3-delp4-delp5)
        dps54=dps54+dps*dsy**(delp1+delp2+delp3+delp4+delp5)
     *  *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *  +delp1+delp2+delp3+delp4+delp5)
     *  *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *  *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *  +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *  *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *  *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *  *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *  *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *  *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *  *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *  *alpD1(ip5,iclegy,iclpro)
     *  *rh4/rht1/rht2/rht3/rht4*rhp/rhp1/rhp2/rhp3/rhp4/rhp5
     *  /rh*zb**(rp/rh)

      do it5=1,nbpDf
        delt5=betD1(it5,iclegy,icltar)
        alpt5=betDp1(it5,iclegy,icltar)-alppar
	rht5=delD1(it5,iclegy,icltar)
	rh5=1./(1./rht1+1./rht2+1./rht3+1./rht4+1./rht5)
	rh=rhp+rh5

        if(abs(delt1+delt2+delt3+delt4+delt5
     *  -delp1-delp2-delp3-delp4-delp5).lt.1.e-5)then
          dps=log(max(1.d0,dsy/ddelx**2))
        else
          dps=((dsy/ddelx)**(delt1+delt2+delt3+delt4+delt5
     *    -delp1-delp2-delp3-delp4-delp5)
     *    -ddelx**(delt1+delt2+delt3+delt4+delt5
     *    -delp1-delp2-delp3-delp4-delp5))
     *    /(delt1+delt2+delt3+delt4+delt5
     *    -delp1-delp2-delp3-delp4-delp5)
        endif 
        dps55=dps55+dps*dsy**(delp1+delp2+delp3+delp4+delp5)
     *  *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *  +delp1+delp2+delp3+delp4+delp5)
     *  *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *  +delt1+delt2+delt3+delt4+delt5)
     *  *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *  *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *  *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *  *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *  *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *  *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *  *alpD1(it5,iclegy,icltar)*alpD1(ip1,iclegy,iclpro)
     *  *alpD1(ip2,iclegy,iclpro)*alpD1(ip3,iclegy,iclpro)
     *  *alpD1(ip4,iclegy,iclpro)*alpD1(ip5,iclegy,iclpro)
     *  *rh5/rht1/rht2/rht3/rht4/rht5
     *  *rhp/rhp1/rhp2/rhp3/rhp4/rhp5/rh*zb**(rp/rh)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      dps52=-dps52*(r3pom*pi/.0389)/240.*gam3p**4
     **gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**2
      dps53=dps53*(r3pom*pi/.0389)/720.*gam3p**5
     **gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**3
      dps54=-dps54*(r3pom*pi/.0389)/2880.*gam3p**6
     **gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**4
      dps55=dps55*(r3pom*pi/.0389)/14400.*gam3p**7
     **gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**5

      dps21=0.d0
      dps31=0.d0
      dps41=0.d0
      dps51=0.d0
      do it1=1,nbpDf
        delt1=betD1(it1,iclegy,icltar)
        alpt1=betDp1(it1,iclegy,icltar)-alppar
	rht1=delD1(it1,iclegy,icltar)
      do ip1=1,nbpDf
        delp1=betD1(ip1,iclegy,iclpro)
        alpp1=betDp1(ip1,iclegy,iclpro)-alppar
	rhp1=delD1(ip1,iclegy,iclpro)
      do ip2=1,nbpDf
        delp2=betD1(ip2,iclegy,iclpro)
        alpp2=betDp1(ip2,iclegy,iclpro)-alppar
	rhp2=delD1(ip2,iclegy,iclpro)
	rh=rht1+rhp1*rhp2/(rhp1+rhp2)

        dps21=dps21+((dsy/ddelx)**(delp1+delp2-delt1)
     *  -ddelx**(delp1+delp2-delt1))/(delp1+delp2-delt1)*dsy**delt1
     *  *dxpp**(2.d0+alpp1+alpp2+delp1+delp2)*dxpm**(1.d0+alpt1+delt1)
     *  *coefu2(ip1+nbpDf*(ip2-1),iclpro)*coefu1(it1,icltar)
     *  *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *  *alpD1(it1,iclegy,icltar)
     *  /(rhp1+rhp2)/rh*zb**(rp/rh)

      do ip3=1,nbpDf
        delp3=betD1(ip3,iclegy,iclpro)
        alpp3=betDp1(ip3,iclegy,iclpro)-alppar
	rhp3=delD1(ip3,iclegy,iclpro)
	rh3=1./(1./rhp1+1./rhp2+1./rhp3)
	rh=rht1+rh3

        dps31=dps31+((dsy/ddelx)**(delp1+delp2+delp3-delt1)
     *  -ddelx**(delp1+delp2+delp3-delt1))/(delp1+delp2+delp3-delt1)
     *  *dsy**delt1*dxpm**(1.d0+alpt1+delt1)
     *  *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *  *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *  *coefu1(it1,icltar)
     *  *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *  *alpD1(ip3,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *  *rh3/rhp1/rhp2/rhp3/rh*zb**(rp/rh)

      do ip4=1,nbpDf
        delp4=betD1(ip4,iclegy,iclpro)
        alpp4=betDp1(ip4,iclegy,iclpro)-alppar
	rhp4=delD1(ip4,iclegy,iclpro)
	rh4=1./(1./rhp1+1./rhp2+1./rhp3+1./rhp4)
	rh=rht1+rh4

        dps41=dps41+((dsy/ddelx)**(delp1+delp2+delp3+delp4-delt1)
     *  -ddelx**(delp1+delp2+delp3+delp4-delt1))
     *  /(delp1+delp2+delp3+delp4-delt1)
     *  *dsy**delt1*dxpm**(1.d0+alpt1+delt1)
     *  *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *  *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *  +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)*coefu1(it1,icltar)
     *  *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *  *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *  *alpD1(it1,iclegy,icltar)
     *  *rh4/rhp1/rhp2/rhp3/rhp4/rh*zb**(rp/rh)

      do ip5=1,nbpDf
        delp5=betD1(ip5,iclegy,iclpro)
        alpp5=betDp1(ip5,iclegy,iclpro)-alppar
	rhp5=delD1(ip5,iclegy,iclpro)
	rh5=1./(1./rhp1+1./rhp2+1./rhp3+1./rhp4+1./rhp5)
	rh=rht1+rh5

        dps51=dps51+((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5-delt1)
     *  -ddelx**(delp1+delp2+delp3+delp4+delp5-delt1))
     *  /(delp1+delp2+delp3+delp4+delp5-delt1)
     *  *dsy**delt1*dxpm**(1.d0+alpt1+delt1)
     *  *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *  +delp1+delp2+delp3+delp4+delp5)
     *  *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *  *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *  *coefu1(it1,icltar)
     *  *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *  *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *  *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *  *rh5/rhp1/rhp2/rhp3/rhp4/rhp5/rh*zb**(rp/rh)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      dps21=-dps21*(r3pom*pi/.0389)/2.
     **gamdp(icdp,iclpro)**2*gamdt(icdt,icltar)
      dps31=dps31*(r3pom*pi/.0389)/6.*gam3p
     **gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)
      dps41=-dps41*(r3pom*pi/.0389)/24.*gam3p**2
     **gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)
      dps51=dps51*(r3pom*pi/.0389)/120.*gam3p**3
     **gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)
     
      dps1=dps12+dps13+dps14+dps15+dps22+dps23+dps24+dps25
     *+dps32+dps33+dps34+dps35+dps42+dps43+dps44+dps45
     *+dps21+dps31+dps41+dps51+dps52+dps53+dps54+dps55

c      write(*,*)'1st',dps1,dps12,dps21,dps13,dps31,dps14,dps41,dps15
c     *,dps51,dps22,dps23,dps32,dps24,dps42,dps25,dps52,dps33,dps34
c     *,dps43,dps35,dps53,dps44,dps45,dps54,dps55
     
      dps2=0.d0
      if(dsy.gt.ddelx**3)then
        dps22=0.d0
        dps32=0.d0
        dps42=0.d0
        dps52=0.d0
        do ii1=1,nbpDf
          deli1=betD2(ii1,iclegy)
	  rhi1=delD2(ii1,iclegy)
        do it1=1,nbpDf
          delt1=betD1(it1,iclegy,icltar)
          alpt1=betDp1(it1,iclegy,icltar)-alppar
	  rht1=delD1(it1,iclegy,icltar)
        do it2=1,nbpDf
          delt2=betD1(it2,iclegy,icltar)
          alpt2=betDp1(it2,iclegy,icltar)-alppar
	  rht2=delD1(it2,iclegy,icltar)
	  rht=rht2
        do ip1=1,nbpDf
          delp1=betD1(ip1,iclegy,iclpro)
          alpp1=betDp1(ip1,iclegy,iclpro)-alppar
	  rhp1=delD1(ip1,iclegy,iclpro)
        do ip2=1,nbpDf
          delp2=betD1(ip2,iclegy,iclpro)
          alpp2=betDp1(ip2,iclegy,iclpro)-alppar
	  rhp2=delD1(ip2,iclegy,iclpro)
	  rhp=rhp2
	  rhpt=rhp*rht1+rhp*rhi1+rht1*rhi1
	  rh=1./(rhi1/rhpt+1./(1./(1./rht+rhp/rhpt)
     *    +1./(1./rhp1+rht1/rhpt)))
	  
          if(abs(delp1+delp2-delt1-delt2).lt.1.e-5)then
            dpx1=-log(max(1.d0,dsy/ddelx**3))
     *      *ddelx**(delt2+deli1-delp1)
          else
            dpx1=-((dsy/ddelx)**(delp1+delp2-delt1-delt2)
     *      -ddelx**(2.d0*(delp1+delp2-delt1-delt2)))
     *      /(delp1+delp2-delt1-delt2)
     *      *ddelx**(delt2+deli1-delp1)
          endif 
          dpx2=((dsy/ddelx)**(delp2+deli1-delt1)
     *    -(ddelx**(2.d0*(delp2+deli1-delt1))))
     *    /(delp2+deli1-delt1)
     *    *ddelx**(delp1-delt2-deli1)
          dps=(dpx1+dpx2)/(delt2+deli1-delp1)
	
          dps22=dps22+dps*dsy**(delt1+delt2)
     *    *dxpp**(2.d0+alpp1+alpp2+delp1+delp2)
     *    *dxpm**(2.d0+alpt1+alpt2+delt1+delt2)
     *    *coefu2(ip1+nbpDf*(ip2-1),iclpro)
     *    *coefu2(it1+nbpDf*(it2-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD2(ii1,iclegy)
     *    *rhp*rht/rhp2/rht2/(rhpt*(rhp1+rht)+rhp1*rht*(rht1+rhp))
     *    *zb**(rp/rh)

        do ip3=1,nbpDf
          delp3=betD1(ip3,iclegy,iclpro)
          alpp3=betDp1(ip3,iclegy,iclpro)-alppar
	  rhp3=delD1(ip3,iclegy,iclpro)
	  rhp=1./(1./rhp2+1./rhp3)
	  rhpt=rhp*rht1+rhp*rhi1+rht1*rhi1
	  rh=1./(rhi1/rhpt+1./(1./(1./rht+rhp/rhpt)
     *    +1./(1./rhp1+rht1/rhpt)))
	  
          dpx1=-((dsy/ddelx)**(delp1+delp2+delp3-delt1-delt2)
     *    -ddelx**(2.d0*(delp1+delp2+delp3-delt1-delt2)))
     *    /(delp1+delp2+delp3-delt1-delt2)
     *    *ddelx**(delt2+deli1-delp1)
          dpx2=((dsy/ddelx)**(delp2+delp3+deli1-delt1)
     *    -(ddelx**(2.d0*(delp2+delp3+deli1-delt1))))
     *    /(delp2+delp3+deli1-delt1)
     *    *ddelx**(delp1-delt2-deli1)
          dps=(dpx1+dpx2)/(delt2+deli1-delp1)
	
          dps32=dps32+dps*dsy**(delt1+delt2)
     *    *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *    *dxpm**(2.d0+alpt1+alpt2+delt1+delt2)
     *    *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *    *coefu2(it1+nbpDf*(it2-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD2(ii1,iclegy)
     *    *rhp*rht/rhp2/rhp3/rht2/(rhpt*(rhp1+rht)+rhp1*rht*(rht1+rhp))
     *    *zb**(rp/rh)

        do ip4=1,nbpDf
          delp4=betD1(ip4,iclegy,iclpro)
          alpp4=betDp1(ip4,iclegy,iclpro)-alppar
	  rhp4=delD1(ip4,iclegy,iclpro)
	  rhp=1./(1./rhp2+1./rhp3+1./rhp4)
	  rhpt=rhp*rht1+rhp*rhi1+rht1*rhi1
	  rh=1./(rhi1/rhpt+1./(1./(1./rht+rhp/rhpt)
     *    +1./(1./rhp1+rht1/rhpt)))
	  
          dpx1=-((dsy/ddelx)**(delp1+delp2+delp3+delp4-delt1-delt2)
     *    -ddelx**(2.d0*(delp1+delp2+delp3+delp4-delt1-delt2)))
     *    /(delp1+delp2+delp3+delp4-delt1-delt2)
     *    *ddelx**(delt2+deli1-delp1)
          dpx2=((dsy/ddelx)**(delp2+delp3+delp4+deli1-delt1)
     *    -(ddelx**(2.d0*(delp2+delp3+delp4+deli1-delt1))))
     *    /(delp2+delp3+delp4+deli1-delt1)
     *    *ddelx**(delp1-delt2-deli1)
          dps=(dpx1+dpx2)/(delt2+deli1-delp1)
	
          dps42=dps42+dps*dsy**(delt1+delt2)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(2.d0+alpt1+alpt2+delt1+delt2)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu2(it1+nbpDf*(it2-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD2(ii1,iclegy)
     *    *rhp*rht/rhp2/rhp3/rhp4/rht2/(rhpt*(rhp1+rht)
     *    +rhp1*rht*(rht1+rhp))*zb**(rp/rh)

        do ip5=1,nbpDf
          delp5=betD1(ip5,iclegy,iclpro)
          alpp5=betDp1(ip5,iclegy,iclpro)-alppar
	  rhp5=delD1(ip5,iclegy,iclpro)
	  rhp=1./(1./rhp2+1./rhp3+1./rhp4+1./rhp5)
	  rhpt=rhp*rht1+rhp*rhi1+rht1*rhi1
	  rh=1./(rhi1/rhpt+1./(1./(1./rht+rhp/rhpt)
     *    +1./(1./rhp1+rht1/rhpt)))
	  
          dpx1=-((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5
     *    -delt1-delt2)
     *    -ddelx**(2.d0*(delp1+delp2+delp3+delp4+delp5-delt1-delt2)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2)
     *    *ddelx**(delt2+deli1-delp1)
          dpx2=((dsy/ddelx)**(delp2+delp3+delp4+delp5+deli1-delt1)
     *    -(ddelx**(2.d0*(delp2+delp3+delp4+delp5+deli1-delt1))))
     *    /(delp2+delp3+delp4+delp5+deli1-delt1)
     *    *ddelx**(delp1-delt2-deli1)
          dps=(dpx1+dpx2)/(delt2+deli1-delp1)
	
          dps52=dps52+dps*dsy**(delt1+delt2)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(2.d0+alpt1+alpt2+delt1+delt2)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu2(it1+nbpDf*(it2-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD2(ii1,iclegy)
     *    *rhp*rht/rhp2/rhp3/rhp4/rhp5/rht2/(rhpt*(rhp1+rht)
     *    +rhp1*rht*(rht1+rhp))*zb**(rp/rh)
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        dps22=dps22*(r3pom*pi/.0389)**2
     *  *gamdp(icdp,iclpro)**2*gamdt(icdt,icltar)**2
        dps32=-dps32*(r3pom*pi/.0389)**2/2.*gam3p
     *  *gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**2
        dps42=dps42*(r3pom*pi/.0389)**2/6.*gam3p**2
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**2
        dps52=-dps52*(r3pom*pi/.0389)**2/24.*gam3p**3
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**2

        dps23=0.d0
        dps33=0.d0
        dps43=0.d0
        dps53=0.d0
        do ii1=1,nbpDf
          deli1=betD2(ii1,iclegy)
	  rhi1=delD2(ii1,iclegy)
        do it1=1,nbpDf
          delt1=betD1(it1,iclegy,icltar)
          alpt1=betDp1(it1,iclegy,icltar)-alppar
	  rht1=delD1(it1,iclegy,icltar)
        do it2=1,nbpDf
          delt2=betD1(it2,iclegy,icltar)
          alpt2=betDp1(it2,iclegy,icltar)-alppar
	  rht2=delD1(it2,iclegy,icltar)
        do it3=1,nbpDf
          delt3=betD1(it3,iclegy,icltar)
          alpt3=betDp1(it3,iclegy,icltar)-alppar
	  rht3=delD1(it3,iclegy,icltar)
	  rht=1./(1./rht2+1./rht3)
        do ip1=1,nbpDf
          delp1=betD1(ip1,iclegy,iclpro)
          alpp1=betDp1(ip1,iclegy,iclpro)-alppar
	  rhp1=delD1(ip1,iclegy,iclpro)
        do ip2=1,nbpDf
          delp2=betD1(ip2,iclegy,iclpro)
          alpp2=betDp1(ip2,iclegy,iclpro)-alppar
	  rhp2=delD1(ip2,iclegy,iclpro)
	  rhp=rhp2
	  rhpt=rhp*rht1+rhp*rhi1+rht1*rhi1
	  rh=1./(rhi1/rhpt+1./(1./(1./rht+rhp/rhpt)
     *    +1./(1./rhp1+rht1/rhpt)))
	  
          dpx1=-((dsy/ddelx)**(delp1+delp2-delt1-delt2-delt3)
     *    -ddelx**(2.d0*(delp1+delp2-delt1-delt2-delt3)))
     *    /(delp1+delp2-delt1-delt2-delt3)
     *    *ddelx**(delt2+delt3+deli1-delp1)
          dpx2=((dsy/ddelx)**(delp2+deli1-delt1)
     *    -(ddelx**(2.d0*(delp2+deli1-delt1))))
     *    /(delp2+deli1-delt1)
     *    *ddelx**(delp1-delt2-delt3-deli1)
          dps=(dpx1+dpx2)/(delt2+delt3+deli1-delp1)
	
          dps23=dps23+dps*dsy**(delt1+delt2+delt3)
     *    *dxpp**(2.d0+alpp1+alpp2+delp1+delp2)
     *    *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *    *coefu2(ip1+nbpDf*(ip2-1),iclpro)
     *    *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD2(ii1,iclegy)
     *    *rhp*rht/rhp2/rht2/rht3/(rhpt*(rhp1+rht)+rhp1*rht*(rht1+rhp))
     *    *zb**(rp/rh)

        do ip3=1,nbpDf
          delp3=betD1(ip3,iclegy,iclpro)
          alpp3=betDp1(ip3,iclegy,iclpro)-alppar
	  rhp3=delD1(ip3,iclegy,iclpro)
	  rhp=1./(1./rhp2+1./rhp3)
	  rhpt=rhp*rht1+rhp*rhi1+rht1*rhi1
	  rh=1./(rhi1/rhpt+1./(1./(1./rht+rhp/rhpt)
     *    +1./(1./rhp1+rht1/rhpt)))
	  
          if(abs(delp1+delp2+delp3-delt1-delt2-delt3).lt.1.e-5)then
            dpx1=-log(max(1.d0,dsy/ddelx**3))
     *      *ddelx**(delt2+delt3+deli1-delp1)
          else
            dpx1=-((dsy/ddelx)**(delp1+delp2+delp3-delt1-delt2-delt3)
     *      -ddelx**(2.d0*(delp1+delp2+delp3-delt1-delt2-delt3)))
     *      /(delp1+delp2+delp3-delt1-delt2-delt3)
     *      *ddelx**(delt2+delt3+deli1-delp1)
          endif 
          dpx2=((dsy/ddelx)**(delp2+delp3+deli1-delt1)
     *    -(ddelx**(2.d0*(delp2+delp3+deli1-delt1))))
     *    /(delp2+delp3+deli1-delt1)
     *    *ddelx**(delp1-delt2-delt3-deli1)
          dps=(dpx1+dpx2)/(delt2+delt3+deli1-delp1)
	
          dps33=dps33+dps*dsy**(delt1+delt2+delt3)
     *    *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *    *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *    *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *    *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD2(ii1,iclegy)
     *    *rhp*rht/rhp2/rhp3/rht2/rht3/(rhpt*(rhp1+rht)
     *    +rhp1*rht*(rht1+rhp))*zb**(rp/rh)

        do ip4=1,nbpDf
          delp4=betD1(ip4,iclegy,iclpro)
          alpp4=betDp1(ip4,iclegy,iclpro)-alppar
	  rhp4=delD1(ip4,iclegy,iclpro)
	  rhp=1./(1./rhp2+1./rhp3+1./rhp4)
	  rhpt=rhp*rht1+rhp*rhi1+rht1*rhi1
	  rh=1./(rhi1/rhpt+1./(1./(1./rht+rhp/rhpt)
     *    +1./(1./rhp1+rht1/rhpt)))
	  
          dpx1=-((dsy/ddelx)**(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3)
     *    -ddelx**(2.d0*(delp1+delp2+delp3+delp4-delt1-delt2-delt3)))
     *    /(delp1+delp2+delp3+delp4-delt1-delt2-delt3)
     *    *ddelx**(delt2+delt3+deli1-delp1)
          dpx2=((dsy/ddelx)**(delp2+delp3+delp4+deli1-delt1)
     *    -(ddelx**(2.d0*(delp2+delp3+delp4+deli1-delt1))))
     *    /(delp2+delp3+delp4+deli1-delt1)
     *    *ddelx**(delp1-delt2-delt3-deli1)
          dps=(dpx1+dpx2)/(delt2+delt3+deli1-delp1)
	
          dps43=dps43+dps*dsy**(delt1+delt2+delt3)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD2(ii1,iclegy)
     *    *rhp*rht/rhp2/rhp3/rhp4/rht2/rht3/(rhpt*(rhp1+rht)
     *    +rhp1*rht*(rht1+rhp))*zb**(rp/rh)

        do ip5=1,nbpDf
          delp5=betD1(ip5,iclegy,iclpro)
          alpp5=betDp1(ip5,iclegy,iclpro)-alppar
	  rhp5=delD1(ip5,iclegy,iclpro)
	  rhp=1./(1./rhp2+1./rhp3+1./rhp4+1./rhp5)
	  rhpt=rhp*rht1+rhp*rhi1+rht1*rhi1
	  rh=1./(rhi1/rhpt+1./(1./(1./rht+rhp/rhpt)
     *    +1./(1./rhp1+rht1/rhpt)))
	  
          dpx1=-((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5
     *    -delt1-delt2-delt3)-ddelx**(2.d0*(delp1+delp2
     *    +delp3+delp4+delp5-delt1-delt2-delt3)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2-delt3)
     *    *ddelx**(delt2+delt3+deli1-delp1)
          dpx2=((dsy/ddelx)**(delp2+delp3+delp4+delp5+deli1-delt1)
     *    -(ddelx**(2.d0*(delp2+delp3+delp4+delp5+deli1-delt1))))
     *    /(delp2+delp3+delp4+delp5+deli1-delt1)
     *    *ddelx**(delp1-delt2-delt3-deli1)
          dps=(dpx1+dpx2)/(delt2+delt3+deli1-delp1)
	
          dps53=dps53+dps*dsy**(delt1+delt2+delt3)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD2(ii1,iclegy)
     *    *rhp*rht/rhp2/rhp3/rhp4/rhp5/rht2/rht3/(rhpt*(rhp1+rht)
     *    +rhp1*rht*(rht1+rhp))*zb**(rp/rh)
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        dps23=-dps23*(r3pom*pi/.0389)**2/2.*gam3p
     *  *gamdp(icdp,iclpro)**2*gamdt(icdt,icltar)**3
        dps33=dps33*(r3pom*pi/.0389)**2/4.*gam3p**2
     *  *gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**3
        dps43=-dps43*(r3pom*pi/.0389)**2/12.*gam3p**3
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**3
        dps53=dps53*(r3pom*pi/.0389)**2/48.*gam3p**4
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**3

        dps24=0.d0
        dps34=0.d0
        dps44=0.d0
        dps54=0.d0
        do ii1=1,nbpDf
          deli1=betD2(ii1,iclegy)
	  rhi1=delD2(ii1,iclegy)
        do it1=1,nbpDf
          delt1=betD1(it1,iclegy,icltar)
          alpt1=betDp1(it1,iclegy,icltar)-alppar
	  rht1=delD1(it1,iclegy,icltar)
        do it2=1,nbpDf
          delt2=betD1(it2,iclegy,icltar)
          alpt2=betDp1(it2,iclegy,icltar)-alppar
	  rht2=delD1(it2,iclegy,icltar)
        do it3=1,nbpDf
          delt3=betD1(it3,iclegy,icltar)
          alpt3=betDp1(it3,iclegy,icltar)-alppar
	  rht3=delD1(it3,iclegy,icltar)
        do it4=1,nbpDf
          delt4=betD1(it4,iclegy,icltar)
          alpt4=betDp1(it4,iclegy,icltar)-alppar
	  rht4=delD1(it4,iclegy,icltar)
	  rht=1./(1./rht2+1./rht3+1./rht4)
        do ip1=1,nbpDf
          delp1=betD1(ip1,iclegy,iclpro)
          alpp1=betDp1(ip1,iclegy,iclpro)-alppar
	  rhp1=delD1(ip1,iclegy,iclpro)
        do ip2=1,nbpDf
          delp2=betD1(ip2,iclegy,iclpro)
          alpp2=betDp1(ip2,iclegy,iclpro)-alppar
	  rhp2=delD1(ip2,iclegy,iclpro)
	  rhp=rhp2
	  rhpt=rhp*rht1+rhp*rhi1+rht1*rhi1
	  rh=1./(rhi1/rhpt+1./(1./(1./rht+rhp/rhpt)
     *    +1./(1./rhp1+rht1/rhpt)))
	  
          dpx1=-((dsy/ddelx)**(delp1+delp2-delt1-delt2-delt3-delt4)
     *    -ddelx**(2.d0*(delp1+delp2-delt1-delt2-delt3-delt4)))
     *    /(delp1+delp2-delt1-delt2-delt3-delt4)
     *    *ddelx**(delt2+delt3+delt4+deli1-delp1)
          dpx2=((dsy/ddelx)**(delp2+deli1-delt1)
     *    -(ddelx**(2.d0*(delp2+deli1-delt1))))
     *    /(delp2+deli1-delt1)
     *    *ddelx**(delp1-delt2-delt3-delt4-deli1)
          dps=(dpx1+dpx2)/(delt2+delt3+delt4+deli1-delp1)
	
          dps24=dps24+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(2.d0+alpp1+alpp2+delp1+delp2)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu2(ip1+nbpDf*(ip2-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD2(ii1,iclegy)
     *    *rhp*rht/rhp2/rht2/rht3/rht4/(rhpt*(rhp1+rht)
     *    +rhp1*rht*(rht1+rhp))*zb**(rp/rh)

        do ip3=1,nbpDf
          delp3=betD1(ip3,iclegy,iclpro)
          alpp3=betDp1(ip3,iclegy,iclpro)-alppar
	  rhp3=delD1(ip3,iclegy,iclpro)
	  rhp=1./(1./rhp2+1./rhp3)
	  rhpt=rhp*rht1+rhp*rhi1+rht1*rhi1
	  rh=1./(rhi1/rhpt+1./(1./(1./rht+rhp/rhpt)
     *    +1./(1./rhp1+rht1/rhpt)))
	  
          dpx1=-((dsy/ddelx)**(delp1+delp2+delp3
     *    -delt1-delt2-delt3-delt4)
     *    -ddelx**(2.d0*(delp1+delp2+delp3-delt1-delt2-delt3-delt4)))
     *    /(delp1+delp2+delp3-delt1-delt2-delt3-delt4)
     *    *ddelx**(delt2+delt3+delt4+deli1-delp1)
          dpx2=((dsy/ddelx)**(delp2+delp3+deli1-delt1)
     *    -(ddelx**(2.d0*(delp2+delp3+deli1-delt1))))
     *    /(delp2+delp3+deli1-delt1)
     *    *ddelx**(delp1-delt2-delt3-delt4-deli1)
          dps=(dpx1+dpx2)/(delt2+delt3+delt4+deli1-delp1)
	
          dps34=dps34+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)*alpD2(ii1,iclegy)
     *    *rhp*rht/rhp2/rhp3/rht2/rht3/rht4/(rhpt*(rhp1+rht)
     *    +rhp1*rht*(rht1+rhp))*zb**(rp/rh)

        do ip4=1,nbpDf
          delp4=betD1(ip4,iclegy,iclpro)
          alpp4=betDp1(ip4,iclegy,iclpro)-alppar
	  rhp4=delD1(ip4,iclegy,iclpro)
	  rhp=1./(1./rhp2+1./rhp3+1./rhp4)
	  rhpt=rhp*rht1+rhp*rhi1+rht1*rhi1
	  rh=1./(rhi1/rhpt+1./(1./(1./rht+rhp/rhpt)
     *    +1./(1./rhp1+rht1/rhpt)))
	  
          if(abs(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4)
     *    .lt.1.e-5)then
            dpx1=-log(max(1.d0,dsy/ddelx**3))
     *      *ddelx**(delt2+delt3+delt4+deli1-delp1)
          else
            dpx1=-((dsy/ddelx)**(delp1+delp2+delp3+delp4
     *      -delt1-delt2-delt3-delt4)
     *      -ddelx**(2.d0*(delp1+delp2+delp3+delp4
     *      -delt1-delt2-delt3-delt4)))
     *      /(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4)
     *      *ddelx**(delt2+delt3+delt4+deli1-delp1)
          endif 
          dpx2=((dsy/ddelx)**(delp2+delp3+delp4+deli1-delt1)
     *    -(ddelx**(2.d0*(delp2+delp3+delp4+deli1-delt1))))
     *    /(delp2+delp3+delp4+deli1-delt1)
     *    *ddelx**(delp1-delt2-delt3-delt4-deli1)
          dps=(dpx1+dpx2)/(delt2+delt3+delt4+deli1-delp1)
	
          dps44=dps44+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD2(ii1,iclegy)
     *    *rhp*rht/rhp2/rhp3/rhp4/rht2/rht3/rht4/(rhpt*(rhp1+rht)
     *    +rhp1*rht*(rht1+rhp))*zb**(rp/rh)

        do ip5=1,nbpDf
          delp5=betD1(ip5,iclegy,iclpro)
          alpp5=betDp1(ip5,iclegy,iclpro)-alppar
	  rhp5=delD1(ip5,iclegy,iclpro)
	  rhp=1./(1./rhp2+1./rhp3+1./rhp4+1./rhp5)
	  rhpt=rhp*rht1+rhp*rhi1+rht1*rhi1
	  rh=1./(rhi1/rhpt+1./(1./(1./rht+rhp/rhpt)
     *    +1./(1./rhp1+rht1/rhpt)))
	  
          dpx1=-((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5
     *    -delt1-delt2-delt3-delt4)-ddelx**(2.d0*(delp1+delp2
     *    +delp3+delp4+delp5-delt1-delt2-delt3-delt4)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2-delt3-delt4)
     *    *ddelx**(delt2+delt3+delt4+deli1-delp1)
          dpx2=((dsy/ddelx)**(delp2+delp3+delp4+delp5+deli1-delt1)
     *    -(ddelx**(2.d0*(delp2+delp3+delp4+delp5+deli1-delt1))))
     *    /(delp2+delp3+delp4+delp5+deli1-delt1)
     *    *ddelx**(delp1-delt2-delt3-delt4-deli1)
          dps=(dpx1+dpx2)/(delt2+delt3+delt4+deli1-delp1)
	
          dps54=dps54+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)*alpD2(ii1,iclegy)
     *    *rhp*rht/rhp2/rhp3/rhp4/rhp5/rht2/rht3/rht4/(rhpt*(rhp1+rht)
     *    +rhp1*rht*(rht1+rhp))*zb**(rp/rh)
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        dps24=dps24*(r3pom*pi/.0389)**2/6.*gam3p**2
     *  *gamdp(icdp,iclpro)**2*gamdt(icdt,icltar)**4
        dps34=-dps34*(r3pom*pi/.0389)**2/12.*gam3p**3
     *  *gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**4
        dps44=dps44*(r3pom*pi/.0389)**2/36.*gam3p**4
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**4
        dps54=-dps54*(r3pom*pi/.0389)**2/144.*gam3p**5
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**4

        dps25=0.d0
        dps35=0.d0
        dps45=0.d0
        dps55=0.d0
        do ii1=1,nbpDf
          deli1=betD2(ii1,iclegy)
	  rhi1=delD2(ii1,iclegy)
        do it1=1,nbpDf
          delt1=betD1(it1,iclegy,icltar)
          alpt1=betDp1(it1,iclegy,icltar)-alppar
	  rht1=delD1(it1,iclegy,icltar)
        do it2=1,nbpDf
          delt2=betD1(it2,iclegy,icltar)
          alpt2=betDp1(it2,iclegy,icltar)-alppar
	  rht2=delD1(it2,iclegy,icltar)
        do it3=1,nbpDf
          delt3=betD1(it3,iclegy,icltar)
          alpt3=betDp1(it3,iclegy,icltar)-alppar
	  rht3=delD1(it3,iclegy,icltar)
        do it4=1,nbpDf
          delt4=betD1(it4,iclegy,icltar)
          alpt4=betDp1(it4,iclegy,icltar)-alppar
	  rht4=delD1(it4,iclegy,icltar)
        do it5=1,nbpDf
          delt5=betD1(it5,iclegy,icltar)
          alpt5=betDp1(it5,iclegy,icltar)-alppar
	  rht5=delD1(it5,iclegy,icltar)
	  rht=1./(1./rht2+1./rht3+1./rht4+1./rht5)
        do ip1=1,nbpDf
          delp1=betD1(ip1,iclegy,iclpro)
          alpp1=betDp1(ip1,iclegy,iclpro)-alppar
	  rhp1=delD1(ip1,iclegy,iclpro)
        do ip2=1,nbpDf
          delp2=betD1(ip2,iclegy,iclpro)
          alpp2=betDp1(ip2,iclegy,iclpro)-alppar
	  rhp2=delD1(ip2,iclegy,iclpro)
	  rhp=rhp2
	  rhpt=rhp*rht1+rhp*rhi1+rht1*rhi1
	  rh=1./(rhi1/rhpt+1./(1./(1./rht+rhp/rhpt)
     *    +1./(1./rhp1+rht1/rhpt)))
	  
          dpx1=-((dsy/ddelx)**(delp1+delp2
     *    -delt1-delt2-delt3-delt4-delt5)
     *    -ddelx**(2.d0*(delp1+delp2-delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2-delt1-delt2-delt3-delt4-delt5)
     *    *ddelx**(delt2+delt3+delt4+delt5+deli1-delp1)
          dpx2=((dsy/ddelx)**(delp2+deli1-delt1)
     *    -(ddelx**(2.d0*(delp2+deli1-delt1))))
     *    /(delp2+deli1-delt1)
     *    *ddelx**(delp1-delt2-delt3-delt4-delt5-deli1)
          dps=(dpx1+dpx2)/(delt2+delt3+delt4+delt5+deli1-delp1)
	
          dps25=dps25+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(2.d0+alpp1+alpp2+delp1+delp2)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu2(ip1+nbpDf*(ip2-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD1(it5,iclegy,icltar)*alpD2(ii1,iclegy)
     *    *rhp*rht/rhp2/rht2/rht3/rht4/rht5/(rhpt*(rhp1+rht)
     *    +rhp1*rht*(rht1+rhp))*zb**(rp/rh)

        do ip3=1,nbpDf
          delp3=betD1(ip3,iclegy,iclpro)
          alpp3=betDp1(ip3,iclegy,iclpro)-alppar
	  rhp3=delD1(ip3,iclegy,iclpro)
	  rhp=1./(1./rhp2+1./rhp3)
	  rhpt=rhp*rht1+rhp*rhi1+rht1*rhi1
	  rh=1./(rhi1/rhpt+1./(1./(1./rht+rhp/rhpt)
     *    +1./(1./rhp1+rht1/rhpt)))
	  
          dpx1=-((dsy/ddelx)**(delp1+delp2+delp3
     *    -delt1-delt2-delt3-delt4-delt5)-ddelx**(2.d0*
     *    (delp1+delp2+delp3-delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2+delp3-delt1-delt2-delt3-delt4-delt5)
     *    *ddelx**(delt2+delt3+delt4+delt5+deli1-delp1)
          dpx2=((dsy/ddelx)**(delp2+delp3+deli1-delt1)
     *    -(ddelx**(2.d0*(delp2+delp3+deli1-delt1))))
     *    /(delp2+delp3+deli1-delt1)
     *    *ddelx**(delp1-delt2-delt3-delt4-delt5-deli1)
          dps=(dpx1+dpx2)/(delt2+delt3+delt4+delt5+deli1-delp1)
	
          dps35=dps35+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)*alpD1(it5,iclegy,icltar)
     *    *alpD2(ii1,iclegy)
     *    *rhp*rht/rhp2/rhp3/rht2/rht3/rht4/rht5/(rhpt*(rhp1+rht)
     *    +rhp1*rht*(rht1+rhp))*zb**(rp/rh)

        do ip4=1,nbpDf
          delp4=betD1(ip4,iclegy,iclpro)
          alpp4=betDp1(ip4,iclegy,iclpro)-alppar
	  rhp4=delD1(ip4,iclegy,iclpro)
	  rhp=1./(1./rhp2+1./rhp3+1./rhp4)
	  rhpt=rhp*rht1+rhp*rhi1+rht1*rhi1
	  rh=1./(rhi1/rhpt+1./(1./(1./rht+rhp/rhpt)
     *    +1./(1./rhp1+rht1/rhpt)))
	  
          dpx1=-((dsy/ddelx)**(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)
     *    -ddelx**(2.d0*(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4-delt5)
     *    *ddelx**(delt2+delt3+delt4+delt5+deli1-delp1)
          dpx2=((dsy/ddelx)**(delp2+delp3+delp4+deli1-delt1)
     *    -(ddelx**(2.d0*(delp2+delp3+delp4+deli1-delt1))))
     *    /(delp2+delp3+delp4+deli1-delt1)
     *    *ddelx**(delp1-delt2-delt3-delt4-delt5-deli1)
          dps=(dpx1+dpx2)/(delt2+delt3+delt4+delt5+deli1-delp1)
	
          dps45=dps45+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD1(it5,iclegy,icltar)*alpD2(ii1,iclegy)
     *    *rhp*rht/rhp2/rhp3/rhp4/rht2/rht3/rht4/rht5/(rhpt*(rhp1+rht)
     *    +rhp1*rht*(rht1+rhp))*zb**(rp/rh)

        do ip5=1,nbpDf
          delp5=betD1(ip5,iclegy,iclpro)
          alpp5=betDp1(ip5,iclegy,iclpro)-alppar
	  rhp5=delD1(ip5,iclegy,iclpro)
	  rhp=1./(1./rhp2+1./rhp3+1./rhp4+1./rhp5)
	  rhpt=rhp*rht1+rhp*rhi1+rht1*rhi1
	  rh=1./(rhi1/rhpt+1./(1./(1./rht+rhp/rhpt)
     *    +1./(1./rhp1+rht1/rhpt)))
	  
          if(abs(delp1+delp2+delp3+delp4+delp5
     *    -delt1-delt2-delt3-delt4-delt5).lt.1.e-5)then
            dpx1=-log(max(1.d0,dsy/ddelx**3))
     *      *ddelx**(delt2+delt3+delt4+delt5+deli1-delp1)
          else
            dpx1=-((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5
     *      -delt1-delt2-delt3-delt4-delt5)
     *      -ddelx**(2.d0*(delp1+delp2+delp3+delp4+delp5
     *      -delt1-delt2-delt3-delt4-delt5)))
     *      /(delp1+delp2+delp3+delp4+delp5
     *      -delt1-delt2-delt3-delt4-delt5)
     *      *ddelx**(delt2+delt3+delt4+delt5+deli1-delp1)
          endif 
          dpx2=((dsy/ddelx)**(delp2+delp3+delp4+delp5+deli1-delt1)
     *    -(ddelx**(2.d0*(delp2+delp3+delp4+delp5+deli1-delt1))))
     *    /(delp2+delp3+delp4+delp5+deli1-delt1)
     *    *ddelx**(delp1-delt2-delt3-delt4-delt5-deli1)
          dps=(dpx1+dpx2)/(delt2+delt3+delt4+delt5+deli1-delp1)
	
          dps55=dps55+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)*alpD1(it5,iclegy,icltar)
     *    *alpD2(ii1,iclegy)
     *    *rhp*rht/rhp2/rhp3/rhp4/rhp5/rht2/rht3/rht4/rht5
     *    /(rhpt*(rhp1+rht)+rhp1*rht*(rht1+rhp))*zb**(rp/rh)
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        dps25=-dps25*(r3pom*pi/.0389)**2/24.*gam3p**3
     *  *gamdp(icdp,iclpro)**2*gamdt(icdt,icltar)**5
        dps35=dps35*(r3pom*pi/.0389)**2/48.*gam3p**4
     *  *gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**5
        dps45=-dps45*(r3pom*pi/.0389)**2/144.*gam3p**5
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**5
        dps55=dps55*(r3pom*pi/.0389)**2/576.*gam3p**6
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**5

        dps2=dps22+dps32+dps42+dps52+dps23+dps33+dps43+dps53
     *  +dps24+dps34+dps44+dps54+dps25+dps35+dps45+dps55
	
c        write(*,*)'2nd',dps2,dps22,dps32,dps23,dps42,dps24,dps33
c     *  ,dps43,dps34,dps52,dps25,dps53,dps35,dps44,dps54,dps45,dps55
      endif

      dps3=0.d0
      if(dsy.gt.ddelx**4)then
        dps3120=0.d0
        dps4120=0.d0
        dps5120=0.d0
        dps4220=0.d0
        dps5220=0.d0
        dps5320=0.d0
        do ii1=1,nbpDf
          deli1=betD2(ii1,iclegy)
	  rhi1=delD2(ii1,iclegy)
        do ii2=1,nbpDf
          deli2=betD2(ii2,iclegy)
	  rhi2=delD2(ii2,iclegy)
        do it1=1,nbpDf
          delt1=betD1(it1,iclegy,icltar)
          alpt1=betDp1(it1,iclegy,icltar)-alppar
	  rht1=delD1(it1,iclegy,icltar)
        do it2=1,nbpDf
          delt2=betD1(it2,iclegy,icltar)
          alpt2=betDp1(it2,iclegy,icltar)-alppar
	  rht2=delD1(it2,iclegy,icltar)
        do ip1=1,nbpDf
          delp1=betD1(ip1,iclegy,iclpro)
          alpp1=betDp1(ip1,iclegy,iclpro)-alppar
	  rhp1=delD1(ip1,iclegy,iclpro)
        do ip2=1,nbpDf
          delp2=betD1(ip2,iclegy,iclpro)
          alpp2=betDp1(ip2,iclegy,iclpro)-alppar
	  rhp2=delD1(ip2,iclegy,iclpro)
        do ip3=1,nbpDf
          delp3=betD1(ip3,iclegy,iclpro)
          alpp3=betDp1(ip3,iclegy,iclpro)-alppar
	  rhp3=delD1(ip3,iclegy,iclpro)
	  
	  rhtn=rht2
	  rhpn=rhp3
	  rhpm=rhp2
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3-delt1-delt2)
     *    -ddelx**(3.d0*(delp1+delp2+delp3-delt1-delt2)))
     *    /(delp1+delp2+delp3-delt1-delt2)
          dpx2=((dsy/ddelx)**(deli1+delp3-delt1)
     *    -(ddelx**(3.d0*(deli1+delp3-delt1))))
     *    /(deli1+delp3-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp2-deli1)
     *    -(ddelx**(2.d0*(deli2+delp2-deli1))))
     *    /(deli2+delp2-deli1)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp3-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp2-deli1)))
     *    /(deli2+delp2+delp3-delt1)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2-delp1-delp2)
     *    -dpx2*ddelx**(2.d0*(delp1+delp2-deli1-delt2)))
     *    /(delp1+delp2-deli1-delt2)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	
          dps3120=dps3120+dps*dsy**(delt1+delt2)
     *    *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *    *dxpm**(2.d0+alpt1+alpt2+delt1+delt2)
     *    *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *    *coefu2(it1+nbpDf*(it2-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rht2/rhpn1/rhtn1/(1./rhpr+1./rhtg)
     *    *zb**(rp/rh)

        do ip4=1,nbpDf
          delp4=betD1(ip4,iclegy,iclpro)
          alpp4=betDp1(ip4,iclegy,iclpro)-alppar
	  rhp4=delD1(ip4,iclegy,iclpro)
	  
	  rhtn=rht2
	  rhpn=1./(1./rhp3+1./rhp4)
	  rhpm=rhp2
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4-delt1-delt2)
     *    -ddelx**(3.d0*(delp1+delp2+delp3+delp4-delt1-delt2)))
     *    /(delp1+delp2+delp3+delp4-delt1-delt2)
          dpx2=((dsy/ddelx)**(deli1+delp3+delp4-delt1)
     *    -(ddelx**(3.d0*(deli1+delp3+delp4-delt1))))
     *    /(deli1+delp3+delp4-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp2-deli1)
     *    -(ddelx**(2.d0*(deli2+delp2-deli1))))
     *    /(deli2+delp2-deli1)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp3+delp4-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp2-deli1)))
     *    /(deli2+delp2+delp3+delp4-delt1)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2-delp1-delp2)
     *    -dpx2*ddelx**(2.d0*(delp1+delp2-deli1-delt2)))
     *    /(delp1+delp2-deli1-delt2)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	
          dps4120=dps4120+dps*dsy**(delt1+delt2)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(2.d0+alpt1+alpt2+delt1+delt2)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu2(it1+nbpDf*(it2-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rhpn1/rhtn1/(1./rhpr+1./rhtg)
     *    *zb**(rp/rh)
	  
	  rhtn=rht2
	  rhpn=rhp3
	  rhpm=1./(1./rhp2+1./rhp4)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4-delt1-delt2)
     *    -ddelx**(3.d0*(delp1+delp2+delp3+delp4-delt1-delt2)))
     *    /(delp1+delp2+delp3+delp4-delt1-delt2)
          dpx2=((dsy/ddelx)**(deli1+delp3-delt1)
     *    -(ddelx**(3.d0*(deli1+delp3-delt1))))
     *    /(deli1+delp3-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp2+delp4-deli1)
     *    -(ddelx**(2.d0*(deli2+delp2+delp4-deli1))))
     *    /(deli2+delp2+delp4-deli1)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp3-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp2+delp4-deli1)))
     *    /(deli2+delp2+delp3+delp4-delt1)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2-delp1-delp2-delp4)
     *    -dpx2*ddelx**(2.d0*(delp1+delp2+delp4-deli1-delt2)))
     *    /(delp1+delp2+delp4-deli1-delt2)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	
          dps4220=dps4220+dps*dsy**(delt1+delt2)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(2.d0+alpt1+alpt2+delt1+delt2)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu2(it1+nbpDf*(it2-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rhpn1/rhtn1/(1./rhpr+1./rhtg)
     *    *zb**(rp/rh)

        do ip5=1,nbpDf
          delp5=betD1(ip5,iclegy,iclpro)
          alpp5=betDp1(ip5,iclegy,iclpro)-alppar
	  rhp5=delD1(ip5,iclegy,iclpro)
	  
	  rhtn=rht2
	  rhpn=1./(1./rhp3+1./rhp4+1./rhp5)
	  rhpm=rhp2
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5-delt1-delt2)
     *    -ddelx**(3.d0*(delp1+delp2+delp3+delp4+delp5-delt1-delt2)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2)
          dpx2=((dsy/ddelx)**(deli1+delp3+delp4+delp5-delt1)
     *    -(ddelx**(3.d0*(deli1+delp3+delp4+delp5-delt1))))
     *    /(deli1+delp3+delp4+delp5-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp2-deli1)
     *    -(ddelx**(2.d0*(deli2+delp2-deli1))))
     *    /(deli2+delp2-deli1)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp3+delp4+delp5-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp2-deli1)))
     *    /(deli2+delp2+delp3+delp4+delp5-delt1)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2-delp1-delp2)
     *    -dpx2*ddelx**(2.d0*(delp1+delp2-deli1-delt2)))
     *    /(delp1+delp2-deli1-delt2)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	
          dps5120=dps5120+dps*dsy**(delt1+delt2)
     *    *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(2.d0+alpt1+alpt2+delt1+delt2)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu2(it1+nbpDf*(it2-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rhp5/rht2/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=rht2
	  rhpn=rhp3
	  rhpm=1./(1./rhp2+1./rhp4+1./rhp5)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5-delt1-delt2)
     *    -ddelx**(3.d0*(delp1+delp2+delp3+delp4+delp5-delt1-delt2)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2)
          dpx2=((dsy/ddelx)**(deli1+delp3-delt1)
     *    -(ddelx**(3.d0*(deli1+delp3-delt1))))
     *    /(deli1+delp3-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp2+delp4+delp5-deli1)
     *    -(ddelx**(2.d0*(deli2+delp2+delp4+delp5-deli1))))
     *    /(deli2+delp2+delp4+delp5-deli1)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp3-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp2+delp4+delp5-deli1)))
     *    /(deli2+delp2+delp3+delp4+delp5-delt1)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2-delp1-delp2-delp4-delp5)
     *    -dpx2*ddelx**(2.d0*(delp1+delp2+delp4+delp5-deli1-delt2)))
     *    /(delp1+delp2+delp4+delp5-deli1-delt2)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	
          dps5320=dps5320+dps*dsy**(delt1+delt2)
     *    *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(2.d0+alpt1+alpt2+delt1+delt2)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu2(it1+nbpDf*(it2-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rhp5/rht2/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=rht2
	  rhpn=1./(1./rhp3+1./rhp5)
	  rhpm=1./(1./rhp2+1./rhp4)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5-delt1-delt2)
     *    -ddelx**(3.d0*(delp1+delp2+delp3+delp4+delp5-delt1-delt2)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2)
          dpx2=((dsy/ddelx)**(deli1+delp3+delp5-delt1)
     *    -(ddelx**(3.d0*(deli1+delp3+delp5-delt1))))
     *    /(deli1+delp3+delp5-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp2+delp4-deli1)
     *    -(ddelx**(2.d0*(deli2+delp2+delp4-deli1))))
     *    /(deli2+delp2+delp4-deli1)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp3+delp5-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp2+delp4-deli1)))
     *    /(deli2+delp2+delp3+delp4+delp5-delt1)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2-delp1-delp2-delp4)
     *    -dpx2*ddelx**(2.d0*(delp1+delp2+delp4-deli1-delt2)))
     *    /(delp1+delp2+delp4-deli1-delt2)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	
          dps5220=dps5220+dps*dsy**(delt1+delt2)
     *    *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(2.d0+alpt1+alpt2+delt1+delt2)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu2(it1+nbpDf*(it2-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rhp5/rht2/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        dps3120=-dps3120*(r3pom*pi/.0389)**3
     *  *gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**2
        dps4120=dps4120*(r3pom*pi/.0389)**3*gam3p/2.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**2
        dps4220=dps4220*(r3pom*pi/.0389)**3*gam3p/2.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**2
        dps5120=-dps5120*(r3pom*pi/.0389)**3*gam3p**2/6.
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**2
        dps5320=-dps5320*(r3pom*pi/.0389)**3*gam3p**2/6.
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**2
        dps5220=-dps5220*(r3pom*pi/.0389)**3*gam3p**2/4.
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**2

        dps3130=0.d0
        dps4130=0.d0
        dps5130=0.d0
        dps4230=0.d0
        dps5230=0.d0
        dps5330=0.d0
        dps2031=0.d0
        dps3031=0.d0
        dps4031=0.d0
        dps5031=0.d0
        dps3131=0.d0
        dps4131=0.d0
        dps5131=0.d0
        dps4231=0.d0
        dps5231=0.d0
        dps5331=0.d0
        do ii1=1,nbpDf
          deli1=betD2(ii1,iclegy)
	  rhi1=delD2(ii1,iclegy)
        do ii2=1,nbpDf
          deli2=betD2(ii2,iclegy)
	  rhi2=delD2(ii2,iclegy)
        do it1=1,nbpDf
          delt1=betD1(it1,iclegy,icltar)
          alpt1=betDp1(it1,iclegy,icltar)-alppar
	  rht1=delD1(it1,iclegy,icltar)
        do it2=1,nbpDf
          delt2=betD1(it2,iclegy,icltar)
          alpt2=betDp1(it2,iclegy,icltar)-alppar
	  rht2=delD1(it2,iclegy,icltar)
        do it3=1,nbpDf
          delt3=betD1(it3,iclegy,icltar)
          alpt3=betDp1(it3,iclegy,icltar)-alppar
	  rht3=delD1(it3,iclegy,icltar)
        do ip1=1,nbpDf
          delp1=betD1(ip1,iclegy,iclpro)
          alpp1=betDp1(ip1,iclegy,iclpro)-alppar
	  rhp1=delD1(ip1,iclegy,iclpro)
        do ip2=1,nbpDf
          delp2=betD1(ip2,iclegy,iclpro)
          alpp2=betDp1(ip2,iclegy,iclpro)-alppar
	  rhp2=delD1(ip2,iclegy,iclpro)
	  
	  rhtn=rht2
	  rhtm=rht3
	  rhpn=rhp2
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2-delt1-delt2-delt3)
     *    -ddelx**(3.d0*(delp1+delp2-delt1-delt2-delt3)))
     *    /(delp1+delp2-delt1-delt2-delt3)
          dpx2=((dsy/ddelx)**(deli1+delp2-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2-delt1))))
     *    /(deli1+delp2-delt1)
          dpx3=((dsy/ddelx**2)**(deli2-deli1-delt3)
     *    -(ddelx**(2.d0*(deli2-deli1-delt3))))
     *    /(deli2-deli1-delt3)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2-deli1-delt3)))
     *    /(deli2+delp2-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3-delp1)
     *    -dpx2*ddelx**(2.d0*(delp1-deli1-delt2-delt3)))
     *    /(delp1-deli1-delt2-delt3)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	
          dps2031=dps2031+dps*dsy**(delt1+delt2+delt3)
     *    *dxpp**(2.d0+alpp1+alpp2+delp1+delp2)
     *    *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *    *coefu2(ip1+nbpDf*(ip2-1),iclpro)
     *    *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rht2/rht3/rhpn1/rhtn1/(1./rhpr+1./rhtg)
     *    *zb**(rp/rh)

        do ip3=1,nbpDf
          delp3=betD1(ip3,iclegy,iclpro)
          alpp3=betDp1(ip3,iclegy,iclpro)-alppar
	  rhp3=delD1(ip3,iclegy,iclpro)
	  
	  rhtn=1./(1./rht2+1./rht3)
	  rhpn=rhp3
	  rhpm=rhp2
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          if(abs(delp1+delp2+delp3-delt1-delt2-delt3).lt.1.e-5)then
            dpx1=log(max(1.d0,dsy/ddelx**4.d0))
          else
            dpx1=((dsy/ddelx)**(delp1+delp2+delp3-delt1-delt2-delt3)
     *      -ddelx**(3.d0*(delp1+delp2+delp3-delt1-delt2-delt3)))
     *      /(delp1+delp2+delp3-delt1-delt2-delt3)
          endif 
          dpx2=((dsy/ddelx)**(deli1+delp3-delt1)
     *    -(ddelx**(3.d0*(deli1+delp3-delt1))))
     *    /(deli1+delp3-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp2-deli1)
     *    -(ddelx**(2.d0*(deli2+delp2-deli1))))
     *    /(deli2+delp2-deli1)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp3-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp2-deli1)))
     *    /(deli2+delp2+delp3-delt1)
     *    *ddelx**(delp1-deli2-delt2-delt3)
     *    -(dpx1*ddelx**(deli1+delt2+delt3-delp1-delp2)
     *    -dpx2*ddelx**(2.d0*(delp1+delp2-deli1-delt2-delt3)))
     *    /(delp1+delp2-deli1-delt2-delt3)
     *    *ddelx**(deli2+delt2+delt3-delp1))/(deli2+delt2+delt3-delp1)
	
          dps3130=dps3130+dps*dsy**(delt1+delt2+delt3)
     *    *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *    *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *    *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *    *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rht2/rht3/rhpn1/rhtn1/(1./rhpr+1./rhtg)
     *    *zb**(rp/rh)
	  
	  rhtn=rht2
	  rhtm=rht3
	  rhpn=rhp2
	  rhpm=rhp3
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          if(abs(delp1+delp2+delp3-delt1-delt2-delt3).lt.1.e-5)then
            dpx1=log(max(1.d0,dsy/ddelx**4.d0))
          else
            dpx1=((dsy/ddelx)**(delp1+delp2+delp3-delt1-delt2-delt3)
     *      -ddelx**(3.d0*(delp1+delp2+delp3-delt1-delt2-delt3)))
     *      /(delp1+delp2+delp3-delt1-delt2-delt3)
          endif 
          dpx2=((dsy/ddelx)**(deli1+delp2-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2-delt1))))
     *    /(deli1+delp2-delt1)
          if(abs(deli2+delp3-deli1-delt3).lt.1.e-5)then
            dpx3=log(max(1.d0,dsy/ddelx**4.d0))
          else
            dpx3=((dsy/ddelx**2)**(deli2+delp3-deli1-delt3)
     *      -(ddelx**(2.d0*(deli2+delp3-deli1-delt3))))
     *      /(deli2+delp3-deli1-delt3)
          endif 
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3-deli1-delt3)))
     *    /(deli2+delp2+delp3-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3-delp1-delp3)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3-deli1-delt2-delt3)))
     *    /(delp1+delp3-deli1-delt2-delt3)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	  
          dps3131=dps3131+dps*dsy**(delt1+delt2+delt3)
     *    *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *    *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *    *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *    *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rht2/rht3/rhpn1/rhtn1/(1./rhpr+1./rhtg)
     *    *zb**(rp/rh)
	  
	  rhtn=rht2
	  rhtm=rht3
	  rhpn=1./(1./rhp2+1./rhp3)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          if(abs(delp1+delp2+delp3-delt1-delt2-delt3).lt.1.e-5)then
            dpx1=log(max(1.d0,dsy/ddelx**4.d0))
          else
            dpx1=((dsy/ddelx)**(delp1+delp2+delp3-delt1-delt2-delt3)
     *      -ddelx**(3.d0*(delp1+delp2+delp3-delt1-delt2-delt3)))
     *      /(delp1+delp2+delp3-delt1-delt2-delt3)
          endif 
          dpx2=((dsy/ddelx)**(deli1+delp2+delp3-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp3-delt1))))
     *    /(deli1+delp2+delp3-delt1)
          dpx3=((dsy/ddelx**2)**(deli2-deli1-delt3)
     *    -(ddelx**(2.d0*(deli2-deli1-delt3))))
     *    /(deli2-deli1-delt3)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp3-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2-deli1-delt3)))
     *    /(deli2+delp2+delp3-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3-delp1)
     *    -dpx2*ddelx**(2.d0*(delp1-deli1-delt2-delt3)))
     *    /(delp1-deli1-delt2-delt3)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	
          dps3031=dps3031+dps*dsy**(delt1+delt2+delt3)
     *    *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *    *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *    *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *    *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rht2/rht3/rhpn1/rhtn1/(1./rhpr+1./rhtg)
     *    *zb**(rp/rh)

        do ip4=1,nbpDf
          delp4=betD1(ip4,iclegy,iclpro)
          alpp4=betDp1(ip4,iclegy,iclpro)-alppar
	  rhp4=delD1(ip4,iclegy,iclpro)
	  
	  rhtn=1./(1./rht2+1./rht3)
	  rhpn=1./(1./rhp3+1./rhp4)
	  rhpm=rhp2
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4-delt1-delt2-delt3)
     *    -ddelx**(3.d0*(delp1+delp2+delp3+delp4-delt1-delt2-delt3)))
     *    /(delp1+delp2+delp3+delp4-delt1-delt2-delt3)
          dpx2=((dsy/ddelx)**(deli1+delp3+delp4-delt1)
     *    -(ddelx**(3.d0*(deli1+delp3+delp4-delt1))))
     *    /(deli1+delp3+delp4-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp2-deli1)
     *    -(ddelx**(2.d0*(deli2+delp2-deli1))))
     *    /(deli2+delp2-deli1)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp3+delp4-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp2-deli1)))
     *    /(deli2+delp2+delp3+delp4-delt1)
     *    *ddelx**(delp1-deli2-delt2-delt3)
     *    -(dpx1*ddelx**(deli1+delt2+delt3-delp1-delp2)
     *    -dpx2*ddelx**(2.d0*(delp1+delp2-deli1-delt2-delt3)))
     *    /(delp1+delp2-deli1-delt2-delt3)
     *    *ddelx**(deli2+delt2+delt3-delp1))/(deli2+delt2+delt3-delp1)
	
          dps4130=dps4130+dps*dsy**(delt1+delt2+delt3)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  	  
	  rhtn=rht2
	  rhtm=rht3
	  rhpn=1./(1./rhp2+1./rhp4)
	  rhpm=rhp3
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4-delt1-delt2-delt3)
     *    -ddelx**(3.d0*(delp1+delp2+delp3+delp4-delt1-delt2-delt3)))
     *    /(delp1+delp2+delp3+delp4-delt1-delt2-delt3)
          dpx2=((dsy/ddelx)**(deli1+delp2+delp4-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp4-delt1))))
     *    /(deli1+delp2+delp4-delt1)
          if(abs(deli2+delp3-deli1-delt3).lt.1.e-5)then
            dpx3=log(max(1.d0,dsy/ddelx**4.d0))
          else
            dpx3=((dsy/ddelx**2)**(deli2+delp3-deli1-delt3)
     *      -(ddelx**(2.d0*(deli2+delp3-deli1-delt3))))
     *      /(deli2+delp3-deli1-delt3)
          endif 
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp4-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3-deli1-delt3)))
     *    /(deli2+delp2+delp3+delp4-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3-delp1-delp3)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3-deli1-delt2-delt3)))
     *    /(delp1+delp3-deli1-delt2-delt3)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	  
          dps4131=dps4131+dps*dsy**(delt1+delt2+delt3)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)

	  rhtn=1./(1./rht2+1./rht3)
	  rhpn=rhp3
	  rhpm=1./(1./rhp2+1./rhp4)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4-delt1-delt2-delt3)
     *    -ddelx**(3.d0*(delp1+delp2+delp3+delp4-delt1-delt2-delt3)))
     *    /(delp1+delp2+delp3+delp4-delt1-delt2-delt3)
          dpx2=((dsy/ddelx)**(deli1+delp3-delt1)
     *    -(ddelx**(3.d0*(deli1+delp3-delt1))))
     *    /(deli1+delp3-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp2+delp4-deli1)
     *    -(ddelx**(2.d0*(deli2+delp2+delp4-deli1))))
     *    /(deli2+delp2+delp4-deli1)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp3-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp2+delp4-deli1)))
     *    /(deli2+delp2+delp3+delp4-delt1)
     *    *ddelx**(delp1-deli2-delt2-delt3)
     *    -(dpx1*ddelx**(deli1+delt2+delt3-delp1-delp2-delp4)
     *    -dpx2*ddelx**(2.d0*(delp1+delp2+delp4-deli1-delt2-delt3)))
     *    /(delp1+delp2+delp4-deli1-delt2-delt3)
     *    *ddelx**(deli2+delt2+delt3-delp1))/(deli2+delt2+delt3-delp1)
	
          dps4230=dps4230+dps*dsy**(delt1+delt2+delt3)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=rht2
	  rhtm=rht3
	  rhpn=rhp2
	  rhpm=1./(1./rhp3+1./rhp4)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4-delt1-delt2-delt3)
     *    -ddelx**(3.d0*(delp1+delp2+delp3+delp4-delt1-delt2-delt3)))
     *    /(delp1+delp2+delp3+delp4-delt1-delt2-delt3)
          dpx2=((dsy/ddelx)**(deli1+delp2-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2-delt1))))
     *    /(deli1+delp2-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp3+delp4-deli1-delt3)
     *    -(ddelx**(2.d0*(deli2+delp3+delp4-deli1-delt3))))
     *    /(deli2+delp3+delp4-deli1-delt3)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3+delp4-deli1-delt3)))
     *    /(deli2+delp2+delp3+delp4-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3-delp1-delp3-delp4)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3+delp4-deli1-delt2-delt3)))
     *    /(delp1+delp3+delp4-deli1-delt2-delt3)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	  
          dps4231=dps4231+dps*dsy**(delt1+delt2+delt3)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  	  
	  rhtn=rht2
	  rhtm=rht3
	  rhpn=1./(1./rhp2+1./rhp3+1./rhp4)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4-delt1-delt2-delt3)
     *    -ddelx**(3.d0*(delp1+delp2+delp3+delp4-delt1-delt2-delt3)))
     *    /(delp1+delp2+delp3+delp4-delt1-delt2-delt3)
          dpx2=((dsy/ddelx)**(deli1+delp2+delp3+delp4-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp3+delp4-delt1))))
     *    /(deli1+delp2+delp3+delp4-delt1)
          dpx3=((dsy/ddelx**2)**(deli2-deli1-delt3)
     *    -(ddelx**(2.d0*(deli2-deli1-delt3))))
     *    /(deli2-deli1-delt3)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp3+delp4-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2-deli1-delt3)))
     *    /(deli2+delp2+delp3+delp4-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3-delp1)
     *    -dpx2*ddelx**(2.d0*(delp1-deli1-delt2-delt3)))
     *    /(delp1-deli1-delt2-delt3)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	
          dps4031=dps4031+dps*dsy**(delt1+delt2+delt3)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)

        do ip5=1,nbpDf
          delp5=betD1(ip5,iclegy,iclpro)
          alpp5=betDp1(ip5,iclegy,iclpro)-alppar
	  rhp5=delD1(ip5,iclegy,iclpro)
	  
	  rhtn=1./(1./rht2+1./rht3)
	  rhpn=1./(1./rhp3+1./rhp4+1./rhp5)
	  rhpm=rhp2
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5
     *    -delt1-delt2-delt3)-ddelx**(3.d0*(delp1+delp2+delp3
     *    +delp4+delp5-delt1-delt2-delt3)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2-delt3)
          dpx2=((dsy/ddelx)**(deli1+delp3+delp4+delp5-delt1)
     *    -(ddelx**(3.d0*(deli1+delp3+delp4+delp5-delt1))))
     *    /(deli1+delp3+delp4+delp5-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp2-deli1)
     *    -(ddelx**(2.d0*(deli2+delp2-deli1))))
     *    /(deli2+delp2-deli1)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp3+delp4+delp5-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp2-deli1)))
     *    /(deli2+delp2+delp3+delp4+delp5-delt1)
     *    *ddelx**(delp1-deli2-delt2-delt3)
     *    -(dpx1*ddelx**(deli1+delt2+delt3-delp1-delp2)
     *    -dpx2*ddelx**(2.d0*(delp1+delp2-deli1-delt2-delt3)))
     *    /(delp1+delp2-deli1-delt2-delt3)
     *    *ddelx**(deli2+delt2+delt3-delp1))/(deli2+delt2+delt3-delp1)
	
          dps5130=dps5130+dps*dsy**(delt1+delt2+delt3)
     *    *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rhp5/rht2/rht3/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  	  
	  rhtn=rht2
	  rhtm=rht3
	  rhpn=1./(1./rhp2+1./rhp4+1./rhp5)
	  rhpm=rhp3
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5
     *    -delt1-delt2-delt3)-ddelx**(3.d0*(delp1+delp2+delp3
     *    +delp4+delp5-delt1-delt2-delt3)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2-delt3)
          dpx2=((dsy/ddelx)**(deli1+delp2+delp4+delp5-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp4+delp5-delt1))))
     *    /(deli1+delp2+delp4+delp5-delt1)
          if(abs(deli2+delp3-deli1-delt3).lt.1.e-5)then
            dpx3=log(max(1.d0,dsy/ddelx**4.d0))
          else
            dpx3=((dsy/ddelx**2)**(deli2+delp3-deli1-delt3)
     *      -(ddelx**(2.d0*(deli2+delp3-deli1-delt3))))
     *      /(deli2+delp3-deli1-delt3)
          endif 
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp4+delp5-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3-deli1-delt3)))
     *    /(deli2+delp2+delp3+delp4+delp5-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3-delp1-delp3)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3-deli1-delt2-delt3)))
     *    /(delp1+delp3-deli1-delt2-delt3)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	  
          dps5131=dps5131+dps*dsy**(delt1+delt2+delt3)
     *    *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rhp5/rht2/rht3/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  	  
	  rhtn=1./(1./rht2+1./rht3)
	  rhpn=rhp3
	  rhpm=1./(1./rhp2+1./rhp4+1./rhp5)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5
     *    -delt1-delt2-delt3)-ddelx**(3.d0*(delp1+delp2+delp3
     *    +delp4+delp5-delt1-delt2-delt3)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2-delt3)
          dpx2=((dsy/ddelx)**(deli1+delp3-delt1)
     *    -(ddelx**(3.d0*(deli1+delp3-delt1))))
     *    /(deli1+delp3-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp2+delp4+delp5-deli1)
     *    -(ddelx**(2.d0*(deli2+delp2+delp4+delp5-deli1))))
     *    /(deli2+delp2+delp4+delp5-deli1)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp3-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp2+delp4+delp5-deli1)))
     *    /(deli2+delp2+delp3+delp4+delp5-delt1)
     *    *ddelx**(delp1-deli2-delt2-delt3)
     *    -(dpx1*ddelx**(deli1+delt2+delt3-delp1-delp2-delp4-delp5)
     *    -dpx2*ddelx**(2.d0*(delp1+delp2+delp4+delp5
     *    -deli1-delt2-delt3)))
     *    /(delp1+delp2+delp4+delp5-deli1-delt2-delt3)
     *    *ddelx**(deli2+delt2+delt3-delp1))/(deli2+delt2+delt3-delp1)
	
          dps5330=dps5330+dps*dsy**(delt1+delt2+delt3)
     *    *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rhp5/rht2/rht3/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=1./(1./rht2+1./rht3)
	  rhpn=1./(1./rhp3+1./rhp5)
	  rhpm=1./(1./rhp2+1./rhp4)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5
     *    -delt1-delt2-delt3)-ddelx**(3.d0*(delp1+delp2+delp3
     *    +delp4+delp5-delt1-delt2-delt3)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2-delt3)
          dpx2=((dsy/ddelx)**(deli1+delp3+delp5-delt1)
     *    -(ddelx**(3.d0*(deli1+delp3+delp5-delt1))))
     *    /(deli1+delp3+delp5-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp2+delp4-deli1)
     *    -(ddelx**(2.d0*(deli2+delp2+delp4-deli1))))
     *    /(deli2+delp2+delp4-deli1)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp3+delp5-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp2+delp4-deli1)))
     *    /(deli2+delp2+delp3+delp4+delp5-delt1)
     *    *ddelx**(delp1-deli2-delt2-delt3)
     *    -(dpx1*ddelx**(deli1+delt2+delt3-delp1-delp2-delp4)
     *    -dpx2*ddelx**(2.d0*(delp1+delp2+delp4-deli1-delt2-delt3)))
     *    /(delp1+delp2+delp4-deli1-delt2-delt3)
     *    *ddelx**(deli2+delt2+delt3-delp1))/(deli2+delt2+delt3-delp1)
	
          dps5230=dps5230+dps*dsy**(delt1+delt2+delt3)
     *    *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rhp5/rht2/rht3/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=rht2
	  rhtm=rht3
	  rhpn=1./(1./rhp2+1./rhp5)
	  rhpm=1./(1./rhp3+1./rhp4)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5
     *    -delt1-delt2-delt3)-ddelx**(3.d0*(delp1+delp2+delp3
     *    +delp4+delp5-delt1-delt2-delt3)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2-delt3)
          dpx2=((dsy/ddelx)**(deli1+delp2+delp5-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp5-delt1))))
     *    /(deli1+delp2+delp5-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp3+delp4-deli1-delt3)
     *    -(ddelx**(2.d0*(deli2+delp3+delp4-deli1-delt3))))
     *    /(deli2+delp3+delp4-deli1-delt3)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp5-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3+delp4-deli1-delt3)))
     *    /(deli2+delp2+delp3+delp4+delp5-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3-delp1-delp3-delp4)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3+delp4-deli1-delt2-delt3)))
     *    /(delp1+delp3+delp4-deli1-delt2-delt3)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	  
          dps5231=dps5231+dps*dsy**(delt1+delt2+delt3)
     *    *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rhp5/rht2/rht3/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  	  
	  rhtn=rht2
	  rhtm=rht3
	  rhpn=rhp2
	  rhpm=1./(1./rhp3+1./rhp4+1./rhp5)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))

          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5
     *    -delt1-delt2-delt3)-ddelx**(3.d0*(delp1+delp2+delp3
     *    +delp4+delp5-delt1-delt2-delt3)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2-delt3)
          dpx2=((dsy/ddelx)**(deli1+delp2-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2-delt1))))
     *    /(deli1+delp2-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp3+delp4+delp5-deli1-delt3)
     *    -(ddelx**(2.d0*(deli2+delp3+delp4+delp5-deli1-delt3))))
     *    /(deli2+delp3+delp4+delp5-deli1-delt3)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3+delp4+delp5-deli1-delt3)))
     *    /(deli2+delp2+delp3+delp4+delp5-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3-delp1-delp3-delp4-delp5)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3+delp4+delp5
     *    -deli1-delt2-delt3)))
     *    /(delp1+delp3+delp4+delp5-deli1-delt2-delt3)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	  
          dps5331=dps5331+dps*dsy**(delt1+delt2+delt3)
     *    *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rhp5/rht2/rht3/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)

	  rhtn=rht2
	  rhtm=rht3
	  rhpn=1./(1./rhp2+1./rhp3+1./rhp4+1./rhp5)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5
     *    -delt1-delt2-delt3)-ddelx**(3.d0*(delp1+delp2+delp3
     *    +delp4+delp5-delt1-delt2-delt3)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2-delt3)
          dpx2=((dsy/ddelx)**(deli1+delp2+delp3+delp4+delp5-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp3+delp4+delp5-delt1))))
     *    /(deli1+delp2+delp3+delp4+delp5-delt1)
          dpx3=((dsy/ddelx**2)**(deli2-deli1-delt3)
     *    -(ddelx**(2.d0*(deli2-deli1-delt3))))
     *    /(deli2-deli1-delt3)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp3+delp4+delp5-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2-deli1-delt3)))
     *    /(deli2+delp2+delp3+delp4+delp5-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3-delp1)
     *    -dpx2*ddelx**(2.d0*(delp1-deli1-delt2-delt3)))
     *    /(delp1-deli1-delt2-delt3)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	
          dps5031=dps5031+dps*dsy**(delt1+delt2+delt3)
     *    *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(3.d0+alpt1+alpt2+alpt3+delt1+delt2+delt3)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu3(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rhp5/rht2/rht3/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        dps3130=dps3130*(r3pom*pi/.0389)**3*gam3p/2.
     *  *gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**3
        dps4130=-dps4130*(r3pom*pi/.0389)**3*gam3p**2/4.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**3
        dps4230=-dps4230*(r3pom*pi/.0389)**3*gam3p**2/4.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**3
        dps5130=dps5130*(r3pom*pi/.0389)**3*gam3p**3/12.
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**3
        dps5330=dps5330*(r3pom*pi/.0389)**3*gam3p**3/12.
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**3
        dps5230=dps5230*(r3pom*pi/.0389)**3*gam3p**3/8.
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**3
        dps2031=-dps2031*(r3pom*pi/.0389)**3
     *  *gamdp(icdp,iclpro)**2*gamdt(icdt,icltar)**3
        dps3031=dps3031*(r3pom*pi/.0389)**3*gam3p/2.
     *  *gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**3
        dps4031=-dps4031*(r3pom*pi/.0389)**3*gam3p**2/6.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**3
        dps5031=dps5031*(r3pom*pi/.0389)**3*gam3p**3/24.
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**3
        dps3131=dps3131*(r3pom*pi/.0389)**3*gam3p
     *  *gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**3
        dps4131=-dps4131*(r3pom*pi/.0389)**3*gam3p**2/2.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**3
        dps4231=-dps4231*(r3pom*pi/.0389)**3*gam3p**2/2.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**3
        dps5131=dps5131*(r3pom*pi/.0389)**3*gam3p**3/6.
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**3
        dps5331=dps5331*(r3pom*pi/.0389)**3*gam3p**3/6.
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**3
        dps5231=dps5231*(r3pom*pi/.0389)**3*gam3p**3/4.
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**3

        dps3140=0.d0
        dps4140=0.d0
        dps5140=0.d0
        dps4240=0.d0
        dps5240=0.d0
        dps5340=0.d0
        dps2041=0.d0
        dps3041=0.d0
        dps4041=0.d0
        dps5041=0.d0
        dps3141=0.d0
        dps4141=0.d0
        dps5141=0.d0
        dps4241=0.d0
        dps5241=0.d0
        dps5341=0.d0
        dps2042=0.d0
        dps3042=0.d0
        dps4042=0.d0
        dps5042=0.d0
        dps3142=0.d0
        dps4142=0.d0
        dps5142=0.d0
        dps4242=0.d0
        dps5242=0.d0
        dps5342=0.d0
        do ii1=1,nbpDf
          deli1=betD2(ii1,iclegy)
	  rhi1=delD2(ii1,iclegy)
        do ii2=1,nbpDf
          deli2=betD2(ii2,iclegy)
	  rhi2=delD2(ii2,iclegy)
        do it1=1,nbpDf
          delt1=betD1(it1,iclegy,icltar)
          alpt1=betDp1(it1,iclegy,icltar)-alppar
	  rht1=delD1(it1,iclegy,icltar)
        do it2=1,nbpDf
          delt2=betD1(it2,iclegy,icltar)
          alpt2=betDp1(it2,iclegy,icltar)-alppar
	  rht2=delD1(it2,iclegy,icltar)
        do it3=1,nbpDf
          delt3=betD1(it3,iclegy,icltar)
          alpt3=betDp1(it3,iclegy,icltar)-alppar
	  rht3=delD1(it3,iclegy,icltar)
        do it4=1,nbpDf
          delt4=betD1(it4,iclegy,icltar)
          alpt4=betDp1(it4,iclegy,icltar)-alppar
	  rht4=delD1(it4,iclegy,icltar)
        do ip1=1,nbpDf
          delp1=betD1(ip1,iclegy,iclpro)
          alpp1=betDp1(ip1,iclegy,iclpro)-alppar
	  rhp1=delD1(ip1,iclegy,iclpro)
        do ip2=1,nbpDf
          delp2=betD1(ip2,iclegy,iclpro)
          alpp2=betDp1(ip2,iclegy,iclpro)-alppar
	  rhp2=delD1(ip2,iclegy,iclpro)
	  
	  rhtn=1./(1./rht2+1./rht4)
	  rhtm=rht3
	  rhpn=rhp2
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2-delt1-delt2-delt3-delt4)
     *    -ddelx**(3.d0*(delp1+delp2-delt1-delt2-delt3-delt4)))
     *    /(delp1+delp2-delt1-delt2-delt3-delt4)
          dpx2=((dsy/ddelx)**(deli1+delp2-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2-delt1))))
     *    /(deli1+delp2-delt1)
          dpx3=((dsy/ddelx**2)**(deli2-deli1-delt3)
     *    -(ddelx**(2.d0*(deli2-deli1-delt3))))
     *    /(deli2-deli1-delt3)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2-deli1-delt3)))
     *    /(deli2+delp2-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2-delt4)
     *    -(dpx1*ddelx**(deli1+delt2+delt4+delt3-delp1)
     *    -dpx2*ddelx**(2.d0*(delp1-deli1-delt2-delt3-delt4)))
     *    /(delp1-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2+delt4-delp1))/(deli2+delt2+delt4-delp1)
	
          dps2041=dps2041+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(2.d0+alpp1+alpp2+delp1+delp2)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu2(ip1+nbpDf*(ip2-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rht2/rht3/rht4/rhpn1/rhtn1/(1./rhpr+1./rhtg)
     *    *zb**(rp/rh)
	  
	  rhtn=rht2
	  rhtm=1./(1./rht3+1./rht4)
	  rhpn=rhp2
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2-delt1-delt2-delt3-delt4)
     *    -ddelx**(3.d0*(delp1+delp2-delt1-delt2-delt3-delt4)))
     *    /(delp1+delp2-delt1-delt2-delt3-delt4)
          dpx2=((dsy/ddelx)**(deli1+delp2-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2-delt1))))
     *    /(deli1+delp2-delt1)
          dpx3=((dsy/ddelx**2)**(deli2-deli1-delt3-delt4)
     *    -(ddelx**(2.d0*(deli2-deli1-delt3-delt4))))
     *    /(deli2-deli1-delt3-delt4)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2-deli1-delt3-delt4)))
     *    /(deli2+delp2-delt1-delt3-delt4)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4-delp1)
     *    -dpx2*ddelx**(2.d0*(delp1-deli1-delt2-delt3-delt4)))
     *    /(delp1-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	
          dps2042=dps2042+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(2.d0+alpp1+alpp2+delp1+delp2)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu2(ip1+nbpDf*(ip2-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rht2/rht3/rht4/rhpn1/rhtn1/(1./rhpr+1./rhtg)
     *    *zb**(rp/rh)

        do ip3=1,nbpDf
          delp3=betD1(ip3,iclegy,iclpro)
          alpp3=betDp1(ip3,iclegy,iclpro)-alppar
	  rhp3=delD1(ip3,iclegy,iclpro)
	  
	  rhtn=1./(1./rht2+1./rht3+1./rht4)
	  rhpn=rhp3
	  rhpm=rhp2
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3-delt1-delt2-delt3-delt4)
     *    -ddelx**(3.d0*(delp1+delp2+delp3-delt1-delt2-delt3-delt4)))
     *    /(delp1+delp2+delp3-delt1-delt2-delt3-delt4)
          dpx2=((dsy/ddelx)**(deli1+delp3-delt1)
     *    -(ddelx**(3.d0*(deli1+delp3-delt1))))
     *    /(deli1+delp3-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp2-deli1)
     *    -(ddelx**(2.d0*(deli2+delp2-deli1))))
     *    /(deli2+delp2-deli1)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp3-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp2-deli1)))
     *    /(deli2+delp2+delp3-delt1)
     *    *ddelx**(delp1-deli2-delt2-delt3-delt4)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4-delp1-delp2)
     *    -dpx2*ddelx**(2.d0*(delp1+delp2-deli1-delt2-delt3-delt4)))
     *    /(delp1+delp2-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2+delt3+delt4-delp1))
     *    /(deli2+delt2+delt3+delt4-delp1)
	
          dps3140=dps3140+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=1./(1./rht2+1./rht4)
	  rhtm=rht3
	  rhpn=rhp2
	  rhpm=rhp3
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3-delt1-delt2-delt3-delt4)
     *    -ddelx**(3.d0*(delp1+delp2+delp3-delt1-delt2-delt3-delt4)))
     *    /(delp1+delp2+delp3-delt1-delt2-delt3-delt4)
          dpx2=((dsy/ddelx)**(deli1+delp2-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2-delt1))))
     *    /(deli1+delp2-delt1)
          if(abs(deli2+delp3-deli1-delt3).lt.1.e-5)then
            dpx3=log(max(1.d0,dsy/ddelx**4.d0))
          else
            dpx3=((dsy/ddelx**2)**(deli2+delp3-deli1-delt3)
     *      -(ddelx**(2.d0*(deli2+delp3-deli1-delt3))))
     *      /(deli2+delp3-deli1-delt3)
          endif 
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3-deli1-delt3)))
     *    /(deli2+delp2+delp3-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2-delt4)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4-delp1-delp3)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3-deli1-delt2-delt3-delt4)))
     *    /(delp1+delp3-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2+delt4-delp1))/(deli2+delt2+delt4-delp1)
	  
          dps3141=dps3141+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=rht2
	  rhtm=1./(1./rht3+1./rht4)
	  rhpn=rhp2
	  rhpm=rhp3
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3-delt1-delt2-delt3-delt4)
     *    -ddelx**(3.d0*(delp1+delp2+delp3-delt1-delt2-delt3-delt4)))
     *    /(delp1+delp2+delp3-delt1-delt2-delt3-delt4)
          dpx2=((dsy/ddelx)**(deli1+delp2-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2-delt1))))
     *    /(deli1+delp2-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp3-deli1-delt3-delt4)
     *    -(ddelx**(2.d0*(deli2+delp3-deli1-delt3-delt4))))
     *    /(deli2+delp3-deli1-delt3-delt4)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3-deli1-delt3-delt4)))
     *    /(deli2+delp2+delp3-delt1-delt3-delt4)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4-delp1-delp3)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3-deli1-delt2-delt3-delt4)))
     *    /(delp1+delp3-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	
          dps3142=dps3142+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=1./(1./rht2+1./rht4)
	  rhtm=rht3
	  rhpn=1./(1./rhp2+1./rhp3)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3-delt1-delt2-delt3-delt4)
     *    -ddelx**(3.d0*(delp1+delp2+delp3-delt1-delt2-delt3-delt4)))
     *    /(delp1+delp2+delp3-delt1-delt2-delt3-delt4)
          dpx2=((dsy/ddelx)**(deli1+delp2+delp3-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp3-delt1))))
     *    /(deli1+delp2+delp3-delt1)
          dpx3=((dsy/ddelx**2)**(deli2-deli1-delt3)
     *    -(ddelx**(2.d0*(deli2-deli1-delt3))))
     *    /(deli2-deli1-delt3)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp3-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2-deli1-delt3)))
     *    /(deli2+delp2+delp3-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2-delt4)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4-delp1)
     *    -dpx2*ddelx**(2.d0*(delp1-deli1-delt2-delt3-delt4)))
     *    /(delp1-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2+delt4-delp1))/(deli2+delt2+delt4-delp1)
	
          dps3041=dps3041+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=rht2
	  rhtm=1./(1./rht3+1./rht4)
	  rhpn=1./(1./rhp2+1./rhp3)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3-delt1-delt2-delt3-delt4)
     *    -ddelx**(3.d0*(delp1+delp2+delp3-delt1-delt2-delt3-delt4)))
     *    /(delp1+delp2+delp3-delt1-delt2-delt3-delt4)
          dpx2=((dsy/ddelx)**(deli1+delp2+delp3-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp3-delt1))))
     *    /(deli1+delp2+delp3-delt1)
          dpx3=((dsy/ddelx**2)**(deli2-deli1-delt3-delt4)
     *    -(ddelx**(2.d0*(deli2-deli1-delt3-delt4))))
     *    /(deli2-deli1-delt3-delt4)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp3-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2-deli1-delt3-delt4)))
     *    /(deli2+delp2+delp3-delt1-delt3-delt4)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4-delp1)
     *    -dpx2*ddelx**(2.d0*(delp1-deli1-delt2-delt3-delt4)))
     *    /(delp1-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	
          dps3042=dps3042+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)

        do ip4=1,nbpDf
          delp4=betD1(ip4,iclegy,iclpro)
          alpp4=betDp1(ip4,iclegy,iclpro)-alppar
	  rhp4=delD1(ip4,iclegy,iclpro)
	  
	  rhtn=1./(1./rht2+1./rht3+1./rht4)
	  rhpn=1./(1./rhp3+1./rhp4)
	  rhpm=rhp2
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          if(abs(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4)
     *    .lt.1.e-5)then
            dpx1=log(max(1.d0,dsy/ddelx**4.d0))
          else
            dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4
     *      -delt1-delt2-delt3-delt4)
     *      -ddelx**(3.d0*(delp1+delp2+delp3+delp4
     *      -delt1-delt2-delt3-delt4)))
     *      /(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4)
          endif 
          dpx2=((dsy/ddelx)**(deli1+delp3+delp4-delt1)
     *    -(ddelx**(3.d0*(deli1+delp3+delp4-delt1))))
     *    /(deli1+delp3+delp4-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp2-deli1)
     *    -(ddelx**(2.d0*(deli2+delp2-deli1))))
     *    /(deli2+delp2-deli1)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp3+delp4-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp2-deli1)))
     *    /(deli2+delp2+delp3+delp4-delt1)
     *    *ddelx**(delp1-deli2-delt2-delt3-delt4)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4-delp1-delp2)
     *    -dpx2*ddelx**(2.d0*(delp1+delp2-deli1-delt2-delt3-delt4)))
     *    /(delp1+delp2-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2+delt3+delt4-delp1))
     *    /(deli2+delt2+delt3+delt4-delp1)
	
          dps4140=dps4140+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  	  
	  rhtn=1./(1./rht2+1./rht4)
	  rhtm=rht3
	  rhpn=1./(1./rhp2+1./rhp4)
	  rhpm=rhp3
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          if(abs(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4)
     *    .lt.1.e-5)then
            dpx1=log(max(1.d0,dsy/ddelx**4.d0))
          else
            dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4
     *      -delt1-delt2-delt3-delt4)
     *      -ddelx**(3.d0*(delp1+delp2+delp3+delp4
     *      -delt1-delt2-delt3-delt4)))
     *      /(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4)
          endif 
          dpx2=((dsy/ddelx)**(deli1+delp2+delp4-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp4-delt1))))
     *    /(deli1+delp2+delp4-delt1)
          if(abs(deli2+delp3-deli1-delt3).lt.1.e-5)then
            dpx3=log(max(1.d0,dsy/ddelx**4.d0))
          else
            dpx3=((dsy/ddelx**2)**(deli2+delp3-deli1-delt3)
     *      -(ddelx**(2.d0*(deli2+delp3-deli1-delt3))))
     *      /(deli2+delp3-deli1-delt3)
          endif 
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp4-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3-deli1-delt3)))
     *    /(deli2+delp2+delp3+delp4-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2-delt4)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4-delp1-delp3)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3-deli1-delt2-delt3-delt4)))
     *    /(delp1+delp3-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2+delt4-delp1))/(deli2+delt2+delt4-delp1)
	  
          dps4141=dps4141+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)

	  rhtn=1./(1./rht2+1./rht3+1./rht4)
	  rhpn=rhp3
	  rhpm=1./(1./rhp2+1./rhp4)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          if(abs(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4)
     *    .lt.1.e-5)then
            dpx1=log(max(1.d0,dsy/ddelx**4.d0))
          else
            dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4
     *      -delt1-delt2-delt3-delt4)
     *      -ddelx**(3.d0*(delp1+delp2+delp3+delp4
     *      -delt1-delt2-delt3-delt4)))
     *      /(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4)
          endif 
          dpx2=((dsy/ddelx)**(deli1+delp3-delt1)
     *    -(ddelx**(3.d0*(deli1+delp3-delt1))))
     *    /(deli1+delp3-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp2+delp4-deli1)
     *    -(ddelx**(2.d0*(deli2+delp2+delp4-deli1))))
     *    /(deli2+delp2+delp4-deli1)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp3-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp2+delp4-deli1)))
     *    /(deli2+delp2+delp3+delp4-delt1)
     *    *ddelx**(delp1-deli2-delt2-delt3-delt4)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4-delp1-delp2-delp4)
     *    -dpx2*ddelx**(2.d0*(delp1+delp2+delp4
     *    -deli1-delt2-delt3-delt4)))
     *    /(delp1+delp2+delp4-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2+delt3+delt4-delp1))
     *    /(deli2+delt2+delt3+delt4-delp1)
	
          dps4240=dps4240+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=1./(1./rht2+1./rht4)
	  rhtm=rht3
	  rhpn=rhp2
	  rhpm=1./(1./rhp3+1./rhp4)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          if(abs(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4)
     *    .lt.1.e-5)then
            dpx1=log(max(1.d0,dsy/ddelx**4.d0))
          else
            dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4
     *      -delt1-delt2-delt3-delt4)
     *      -ddelx**(3.d0*(delp1+delp2+delp3+delp4
     *      -delt1-delt2-delt3-delt4)))
     *      /(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4)
          endif 
          dpx2=((dsy/ddelx)**(deli1+delp2-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2-delt1))))
     *    /(deli1+delp2-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp3+delp4-deli1-delt3)
     *    -(ddelx**(2.d0*(deli2+delp3+delp4-deli1-delt3))))
     *    /(deli2+delp3+delp4-deli1-delt3)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3+delp4-deli1-delt3)))
     *    /(deli2+delp2+delp3+delp4-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2-delt4)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4-delp1-delp3-delp4)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3+delp4
     *    -deli1-delt2-delt3-delt4)))
     *    /(delp1+delp3+delp4-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2+delt4-delp1))/(deli2+delt2+delt4-delp1)
	  
          dps4241=dps4241+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  	  
	  rhtn=1./(1./rht2+1./rht4)
	  rhtm=rht3
	  rhpn=1./(1./rhp2+1./rhp3+1./rhp4)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          if(abs(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4)
     *    .lt.1.e-5)then
            dpx1=log(max(1.d0,dsy/ddelx**4.d0))
          else
            dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4
     *      -delt1-delt2-delt3-delt4)
     *      -ddelx**(3.d0*(delp1+delp2+delp3+delp4
     *      -delt1-delt2-delt3-delt4)))
     *      /(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4)
          endif 
          dpx2=((dsy/ddelx)**(deli1+delp2+delp3+delp4-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp3+delp4-delt1))))
     *    /(deli1+delp2+delp3+delp4-delt1)
          dpx3=((dsy/ddelx**2)**(deli2-deli1-delt3)
     *    -(ddelx**(2.d0*(deli2-deli1-delt3))))
     *    /(deli2-deli1-delt3)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp3+delp4-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2-deli1-delt3)))
     *    /(deli2+delp2+delp3+delp4-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2-delt4)
     *    -(dpx1*ddelx**(deli1+delt2+delt4+delt3-delp1)
     *    -dpx2*ddelx**(2.d0*(delp1-deli1-delt2-delt3-delt4)))
     *    /(delp1-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2+delt4-delp1))/(deli2+delt2+delt4-delp1)
	
          dps4041=dps4041+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  	  
	  rhtn=rht2
	  rhtm=1./(1./rht3+1./rht4)
	  rhpn=1./(1./rhp2+1./rhp3+1./rhp4)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          if(abs(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4)
     *    .lt.1.e-5)then
            dpx1=log(max(1.d0,dsy/ddelx**4.d0))
          else
            dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4
     *      -delt1-delt2-delt3-delt4)
     *      -ddelx**(3.d0*(delp1+delp2+delp3+delp4
     *      -delt1-delt2-delt3-delt4)))
     *      /(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4)
          endif 
          dpx2=((dsy/ddelx)**(deli1+delp2+delp3+delp4-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp3+delp4-delt1))))
     *    /(deli1+delp2+delp3+delp4-delt1)
          dpx3=((dsy/ddelx**2)**(deli2-deli1-delt3-delt4)
     *    -(ddelx**(2.d0*(deli2-deli1-delt3-delt4))))
     *    /(deli2-deli1-delt3-delt4)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp3+delp4-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2-deli1-delt3-delt4)))
     *    /(deli2+delp2+delp3+delp4-delt1-delt3-delt4)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4-delp1)
     *    -dpx2*ddelx**(2.d0*(delp1-deli1-delt2-delt3-delt4)))
     *    /(delp1-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	
          dps4042=dps4042+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  	  
	  rhtn=rht2
	  rhtm=1./(1./rht3+1./rht4)
	  rhpn=1./(1./rhp2+1./rhp4)
	  rhpm=rhp3
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          if(abs(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4)
     *    .lt.1.e-5)then
            dpx1=log(max(1.d0,dsy/ddelx**4.d0))
          else
            dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4
     *      -delt1-delt2-delt3-delt4)
     *      -ddelx**(3.d0*(delp1+delp2+delp3+delp4
     *      -delt1-delt2-delt3-delt4)))
     *      /(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4)
          endif 
          dpx2=((dsy/ddelx)**(deli1+delp2+delp4-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp4-delt1))))
     *    /(deli1+delp2+delp4-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp3-deli1-delt3-delt4)
     *    -(ddelx**(2.d0*(deli2+delp3-deli1-delt3-delt4))))
     *    /(deli2+delp3-deli1-delt3-delt4)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp4-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3-deli1-delt3-delt4)))
     *    /(deli2+delp2+delp3+delp4-delt1-delt3-delt4)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4-delp1-delp3)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3-deli1-delt2-delt3-delt4)))
     *    /(delp1+delp3-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	  
          dps4142=dps4142+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=rht2
	  rhtm=1./(1./rht3+1./rht4)
	  rhpn=rhp2
	  rhpm=1./(1./rhp3+1./rhp4)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          if(abs(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4)
     *    .lt.1.e-5)then
            dpx1=log(max(1.d0,dsy/ddelx**4.d0))
          else
            dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4
     *      -delt1-delt2-delt3-delt4)
     *      -ddelx**(3.d0*(delp1+delp2+delp3+delp4
     *      -delt1-delt2-delt3-delt4)))
     *      /(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4)
          endif 
          dpx2=((dsy/ddelx)**(deli1+delp2-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2-delt1))))
     *    /(deli1+delp2-delt1)
          if(abs(deli2+delp3+delp4-deli1-delt3-delt4).lt.1.e-5)then
            dpx3=log(max(1.d0,dsy/ddelx**4.d0))
          else
            dpx3=((dsy/ddelx**2)**(deli2+delp3+delp4-deli1-delt3-delt4)
     *      -(ddelx**(2.d0*(deli2+delp3+delp4-deli1-delt3-delt4))))
     *      /(deli2+delp3+delp4-deli1-delt3-delt4)
          endif
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3+delp4-deli1-delt3-delt4)))
     *    /(deli2+delp2+delp3+delp4-delt1-delt3-delt4)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4-delp1-delp3-delp4)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3+delp4
     *    -deli1-delt2-delt3-delt4)))
     *    /(delp1+delp3+delp4-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	  
          dps4242=dps4242+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)

        do ip5=1,nbpDf
          delp5=betD1(ip5,iclegy,iclpro)
          alpp5=betDp1(ip5,iclegy,iclpro)-alppar
	  rhp5=delD1(ip5,iclegy,iclpro)
	  
	  rhtn=1./(1./rht2+1./rht3+1./rht4)
	  rhpn=1./(1./rhp3+1./rhp4+1./rhp5)
	  rhpm=rhp2
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5
     *    -delt1-delt2-delt3-delt4)-ddelx**(3.d0*(delp1+delp2+delp3
     *    +delp4+delp5-delt1-delt2-delt3-delt4)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2-delt3-delt4)
          dpx2=((dsy/ddelx)**(deli1+delp3+delp4+delp5-delt1)
     *    -(ddelx**(3.d0*(deli1+delp3+delp4+delp5-delt1))))
     *    /(deli1+delp3+delp4+delp5-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp2-deli1)
     *    -(ddelx**(2.d0*(deli2+delp2-deli1))))
     *    /(deli2+delp2-deli1)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp3+delp4+delp5-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp2-deli1)))
     *    /(deli2+delp2+delp3+delp4+delp5-delt1)
     *    *ddelx**(delp1-deli2-delt2-delt3-delt4)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4-delp1-delp2)
     *    -dpx2*ddelx**(2.d0*(delp1+delp2-deli1-delt2-delt3-delt4)))
     *    /(delp1+delp2-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2+delt3+delt4-delp1))
     *    /(deli2+delt2+delt3+delt4-delp1)
	
          dps5140=dps5140+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)*alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rhp5/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  	  
	  rhtn=1./(1./rht2+1./rht4)
	  rhtm=rht3
	  rhpn=1./(1./rhp2+1./rhp4+1./rhp5)
	  rhpm=rhp3
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5
     *    -delt1-delt2-delt3-delt4)-ddelx**(3.d0*(delp1+delp2+delp3
     *    +delp4+delp5-delt1-delt2-delt3-delt4)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2-delt3-delt4)
          dpx2=((dsy/ddelx)**(deli1+delp2+delp4+delp5-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp4+delp5-delt1))))
     *    /(deli1+delp2+delp4+delp5-delt1)
          if(abs(deli2+delp3-deli1-delt3).lt.1.e-5)then
            dpx3=log(max(1.d0,dsy/ddelx**4.d0))
          else
            dpx3=((dsy/ddelx**2)**(deli2+delp3-deli1-delt3)
     *      -(ddelx**(2.d0*(deli2+delp3-deli1-delt3))))
     *      /(deli2+delp3-deli1-delt3)
          endif 
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp4+delp5-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3-deli1-delt3)))
     *    /(deli2+delp2+delp3+delp4+delp5-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2-delt4)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4-delp1-delp3)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3-deli1-delt2-delt3-delt4)))
     *    /(delp1+delp3-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2+delt4-delp1))/(deli2+delt2+delt4-delp1)
	  
          dps5141=dps5141+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)*alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rhp5/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  	  
	  rhtn=1./(1./rht2+1./rht3+1./rht4)
	  rhpn=rhp3
	  rhpm=1./(1./rhp2+1./rhp4+1./rhp5)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5
     *    -delt1-delt2-delt3-delt4)-ddelx**(3.d0*(delp1+delp2+delp3
     *    +delp4+delp5-delt1-delt2-delt3-delt4)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2-delt3-delt4)
          dpx2=((dsy/ddelx)**(deli1+delp3-delt1)
     *    -(ddelx**(3.d0*(deli1+delp3-delt1))))
     *    /(deli1+delp3-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp2+delp4+delp5-deli1)
     *    -(ddelx**(2.d0*(deli2+delp2+delp4+delp5-deli1))))
     *    /(deli2+delp2+delp4+delp5-deli1)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp3-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp2+delp4+delp5-deli1)))
     *    /(deli2+delp2+delp3+delp4+delp5-delt1)
     *    *ddelx**(delp1-deli2-delt2-delt3-delt4)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4
     *    -delp1-delp2-delp4-delp5)
     *    -dpx2*ddelx**(2.d0*(delp1+delp2+delp4+delp5
     *    -deli1-delt2-delt3-delt4)))
     *    /(delp1+delp2+delp4+delp5-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2+delt3+delt4-delp1))
     *    /(deli2+delt2+delt3+delt4-delp1)
	
          dps5340=dps5340+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)*alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rhp5/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=1./(1./rht2+1./rht3+1./rht4)
	  rhpn=1./(1./rhp3+1./rhp5)
	  rhpm=1./(1./rhp2+1./rhp4)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5
     *    -delt1-delt2-delt3-delt4)-ddelx**(3.d0*(delp1+delp2+delp3
     *    +delp4+delp5-delt1-delt2-delt3-delt4)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2-delt3-delt4)
          dpx2=((dsy/ddelx)**(deli1+delp3+delp5-delt1)
     *    -(ddelx**(3.d0*(deli1+delp3+delp5-delt1))))
     *    /(deli1+delp3+delp5-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp2+delp4-deli1)
     *    -(ddelx**(2.d0*(deli2+delp2+delp4-deli1))))
     *    /(deli2+delp2+delp4-deli1)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp3+delp5-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp2+delp4-deli1)))
     *    /(deli2+delp2+delp3+delp4+delp5-delt1)
     *    *ddelx**(delp1-deli2-delt2-delt3-delt4)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4-delp1-delp2-delp4)
     *    -dpx2*ddelx**(2.d0*(delp1+delp2+delp4
     *    -deli1-delt2-delt3-delt4)))
     *    /(delp1+delp2+delp4-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2+delt3+delt4-delp1))
     *    /(deli2+delt2+delt3+delt4-delp1)
	
          dps5240=dps5240+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)*alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rhp5/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=1./(1./rht2+1./rht4)
	  rhtm=rht3
	  rhpn=1./(1./rhp2+1./rhp5)
	  rhpm=1./(1./rhp3+1./rhp4)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5
     *    -delt1-delt2-delt3-delt4)-ddelx**(3.d0*(delp1+delp2+delp3
     *    +delp4+delp5-delt1-delt2-delt3-delt4)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2-delt3-delt4)
          dpx2=((dsy/ddelx)**(deli1+delp2+delp5-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp5-delt1))))
     *    /(deli1+delp2+delp5-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp3+delp4-deli1-delt3)
     *    -(ddelx**(2.d0*(deli2+delp3+delp4-deli1-delt3))))
     *    /(deli2+delp3+delp4-deli1-delt3)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp5-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3+delp4-deli1-delt3)))
     *    /(deli2+delp2+delp3+delp4+delp5-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2-delt4)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4-delp1-delp3-delp4)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3+delp4
     *    -deli1-delt2-delt3-delt4)))
     *    /(delp1+delp3+delp4-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2+delt4-delp1))/(deli2+delt2+delt4-delp1)
	  
          dps5241=dps5241+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)*alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rhp5/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  	  
	  rhtn=1./(1./rht2+1./rht4)
	  rhtm=rht3
	  rhpn=rhp2
	  rhpm=1./(1./rhp3+1./rhp4+1./rhp5)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))

          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5
     *    -delt1-delt2-delt3-delt4)-ddelx**(3.d0*(delp1+delp2+delp3
     *    +delp4+delp5-delt1-delt2-delt3-delt4)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2-delt3-delt4)
          dpx2=((dsy/ddelx)**(deli1+delp2-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2-delt1))))
     *    /(deli1+delp2-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp3+delp4+delp5-deli1-delt3)
     *    -(ddelx**(2.d0*(deli2+delp3+delp4+delp5-deli1-delt3))))
     *    /(deli2+delp3+delp4+delp5-deli1-delt3)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3+delp4+delp5-deli1-delt3)))
     *    /(deli2+delp2+delp3+delp4+delp5-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2-delt4)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4
     *    -delp1-delp3-delp4-delp5)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3+delp4+delp5
     *    -deli1-delt2-delt3-delt4)))
     *    /(delp1+delp3+delp4+delp5-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2+delt4-delp1))/(deli2+delt2+delt4-delp1)
	  
          dps5341=dps5341+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)*alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rhp5/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)

	  rhtn=1./(1./rht2+1./rht4)
	  rhtm=rht3
	  rhpn=1./(1./rhp2+1./rhp3+1./rhp4+1./rhp5)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5
     *    -delt1-delt2-delt3-delt4)-ddelx**(3.d0*(delp1+delp2+delp3
     *    +delp4+delp5-delt1-delt2-delt3-delt4)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2-delt3-delt4)
          dpx2=((dsy/ddelx)**(deli1+delp2+delp3+delp4+delp5-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp3+delp4+delp5-delt1))))
     *    /(deli1+delp2+delp3+delp4+delp5-delt1)
          dpx3=((dsy/ddelx**2)**(deli2-deli1-delt3)
     *    -(ddelx**(2.d0*(deli2-deli1-delt3))))
     *    /(deli2-deli1-delt3)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp3+delp4+delp5-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2-deli1-delt3)))
     *    /(deli2+delp2+delp3+delp4+delp5-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2-delt4)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4-delp1)
     *    -dpx2*ddelx**(2.d0*(delp1-deli1-delt2-delt3-delt4)))
     *    /(delp1-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2+delt4-delp1))/(deli2+delt2+delt4-delp1)
	
          dps5041=dps5041+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)*alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rhp5/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)

	  rhtn=rht2
	  rhtm=1./(1./rht3+1./rht4)
	  rhpn=1./(1./rhp2+1./rhp3+1./rhp4+1./rhp5)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5
     *    -delt1-delt2-delt3-delt4)-ddelx**(3.d0*(delp1+delp2+delp3
     *    +delp4+delp5-delt1-delt2-delt3-delt4)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2-delt3-delt4)
          dpx2=((dsy/ddelx)**(deli1+delp2+delp3+delp4+delp5-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp3+delp4+delp5-delt1))))
     *    /(deli1+delp2+delp3+delp4+delp5-delt1)
          dpx3=((dsy/ddelx**2)**(deli2-deli1-delt3-delt4)
     *    -(ddelx**(2.d0*(deli2-deli1-delt3-delt4))))
     *    /(deli2-deli1-delt3-delt4)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp3+delp4+delp5-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2-deli1-delt3-delt4)))
     *    /(deli2+delp2+delp3+delp4+delp5-delt1-delt3-delt4)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4-delp1)
     *    -dpx2*ddelx**(2.d0*(delp1-deli1-delt2-delt3-delt4)))
     *    /(delp1-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	
          dps5042=dps5042+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)*alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rhp5/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  	  
	  rhtn=rht2
	  rhtm=1./(1./rht3+1./rht4)
	  rhpn=1./(1./rhp2+1./rhp4+1./rhp5)
	  rhpm=rhp3
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5
     *    -delt1-delt2-delt3-delt4)-ddelx**(3.d0*(delp1+delp2+delp3
     *    +delp4+delp5-delt1-delt2-delt3-delt4)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2-delt3-delt4)
          dpx2=((dsy/ddelx)**(deli1+delp2+delp4+delp5-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp4+delp5-delt1))))
     *    /(deli1+delp2+delp4+delp5-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp3-deli1-delt3-delt4)
     *    -(ddelx**(2.d0*(deli2+delp3-deli1-delt3-delt4))))
     *    /(deli2+delp3-deli1-delt3-delt4)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp4+delp5-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3-deli1-delt3-delt4)))
     *    /(deli2+delp2+delp3+delp4+delp5-delt1-delt3-delt4)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4-delp1-delp3)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3-deli1-delt2-delt3-delt4)))
     *    /(delp1+delp3-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	  
          dps5142=dps5142+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)*alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rhp5/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=rht2
	  rhtm=1./(1./rht3+1./rht4)
	  rhpn=1./(1./rhp2+1./rhp5)
	  rhpm=1./(1./rhp3+1./rhp4)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5
     *    -delt1-delt2-delt3-delt4)-ddelx**(3.d0*(delp1+delp2+delp3
     *    +delp4+delp5-delt1-delt2-delt3-delt4)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2-delt3-delt4)
          dpx2=((dsy/ddelx)**(deli1+delp2+delp5-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp5-delt1))))
     *    /(deli1+delp2+delp5-delt1)
          if(abs(deli2+delp3+delp4-deli1-delt3-delt4).lt.1.e-5)then
            dpx3=log(max(1.d0,dsy/ddelx**4.d0))
          else
            dpx3=((dsy/ddelx**2)**(deli2+delp3+delp4-deli1-delt3-delt4)
     *      -(ddelx**(2.d0*(deli2+delp3+delp4-deli1-delt3-delt4))))
     *      /(deli2+delp3+delp4-deli1-delt3-delt4)
          endif
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp5-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3+delp4-deli1-delt3-delt4)))
     *    /(deli2+delp2+delp3+delp4+delp5-delt1-delt3-delt4)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4-delp1-delp3-delp4)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3+delp4
     *    -deli1-delt2-delt3-delt4)))
     *    /(delp1+delp3+delp4-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	  
          dps5242=dps5242+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)*alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rhp5/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  	  
	  rhtn=rht2
	  rhtm=1./(1./rht3+1./rht4)
	  rhpn=rhp2
	  rhpm=1./(1./rhp3+1./rhp4+1./rhp5)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))

          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4+delp5
     *    -delt1-delt2-delt3-delt4)-ddelx**(3.d0*(delp1+delp2+delp3
     *    +delp4+delp5-delt1-delt2-delt3-delt4)))
     *    /(delp1+delp2+delp3+delp4+delp5-delt1-delt2-delt3-delt4)
          dpx2=((dsy/ddelx)**(deli1+delp2-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2-delt1))))
     *    /(deli1+delp2-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp3+delp4+delp5
     *    -deli1-delt3-delt4)
     *    -(ddelx**(2.d0*(deli2+delp3+delp4+delp5-deli1-delt3-delt4))))
     *    /(deli2+delp3+delp4+delp5-deli1-delt3-delt4)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3+delp4+delp5
     *    -deli1-delt3-delt4)))
     *    /(deli2+delp2+delp3+delp4+delp5-delt1-delt3-delt4)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4
     *    -delp1-delp3-delp4-delp5)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3+delp4+delp5
     *    -deli1-delt2-delt3-delt4)))
     *    /(delp1+delp3+delp4+delp5-deli1-delt2-delt3-delt4)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	  
          dps5342=dps5342+dps*dsy**(delt1+delt2+delt3+delt4)
     *    *dxpp**(5.d0+alpp1+alpp2+alpp3+alpp4+alpp5
     *    +delp1+delp2+delp3+delp4+delp5)
     *    *dxpm**(4.d0+alpt1+alpt2+alpt3+alpt4+delt1+delt2+delt3+delt4)
     *    *coefu5(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)+nbpDf*nbpDf
     *    *nbpDf*(ip4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(ip5-1),iclpro)
     *    *coefu4(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)
     *    +nbpDf*nbpDf*nbpDf*(it4-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(ip5,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)*alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rhp5/rht2/rht3/rht4/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        dps3140=-dps3140*(r3pom*pi/.0389)**3*gam3p**2/6.
     *  *gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**4
        dps4140=dps4140*(r3pom*pi/.0389)**3*gam3p**3/12.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**4
        dps4240=dps4240*(r3pom*pi/.0389)**3*gam3p**3/12.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**4
        dps5140=-dps5140*(r3pom*pi/.0389)**3*gam3p**4/36.
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**4
        dps5340=-dps5340*(r3pom*pi/.0389)**3*gam3p**4/36.
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**4
        dps5240=-dps5240*(r3pom*pi/.0389)**3*gam3p**4/24.
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**4
        dps2041=dps2041*(r3pom*pi/.0389)**3*gam3p/2.
     *  *gamdp(icdp,iclpro)**2*gamdt(icdt,icltar)**4
        dps3041=-dps3041*(r3pom*pi/.0389)**3*gam3p**2/4.
     *  *gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**4
        dps4041=dps4041*(r3pom*pi/.0389)**3*gam3p**3/12.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**4
        dps5041=-dps5041*(r3pom*pi/.0389)**3*gam3p**4/48.
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**4
        dps3141=-dps3141*(r3pom*pi/.0389)**3*gam3p**2/2.
     *  *gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**4
        dps4141=dps4141*(r3pom*pi/.0389)**3*gam3p**3/4.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**4
        dps4241=dps4241*(r3pom*pi/.0389)**3*gam3p**3/4.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**4
        dps5141=-dps5141*(r3pom*pi/.0389)**3*gam3p**4/12.
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**4
        dps5341=-dps5341*(r3pom*pi/.0389)**3*gam3p**4/12.
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**4
        dps5241=-dps5241*(r3pom*pi/.0389)**3*gam3p**4/8.
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**4
        dps2042=dps2042*(r3pom*pi/.0389)**3*gam3p/2.
     *  *gamdp(icdp,iclpro)**2*gamdt(icdt,icltar)**4
        dps3042=-dps3042*(r3pom*pi/.0389)**3*gam3p**2/4.
     *  *gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**4
        dps3142=-dps3142*(r3pom*pi/.0389)**3*gam3p**2/2.
     *  *gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**4
        dps4042=dps4042*(r3pom*pi/.0389)**3*gam3p**3/12.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**4
        dps4142=dps4142*(r3pom*pi/.0389)**3*gam3p**3/4.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**4
        dps4242=dps4242*(r3pom*pi/.0389)**3*gam3p**3/4.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**4
        dps5042=-dps5042*(r3pom*pi/.0389)**3*gam3p**4/48.
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**4
        dps5142=-dps5142*(r3pom*pi/.0389)**3*gam3p**4/12.
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**4
        dps5242=-dps5242*(r3pom*pi/.0389)**3*gam3p**4/8.
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**4
        dps5342=-dps5342*(r3pom*pi/.0389)**3*gam3p**4/12.
     *  *gamdp(icdp,iclpro)**5*gamdt(icdt,icltar)**4

        dps2051=0.d0
        dps2052=0.d0
        dps2053=0.d0
        dps3150=0.d0
        dps3051=0.d0
        dps3151=0.d0
        dps3052=0.d0
        dps3152=0.d0
        dps3053=0.d0
        dps3153=0.d0
        dps4150=0.d0
        dps4250=0.d0
        dps4051=0.d0
        dps4151=0.d0
        dps4251=0.d0
        dps4052=0.d0
        dps4152=0.d0
        dps4252=0.d0
        dps4053=0.d0
        dps4153=0.d0
        dps4253=0.d0
        dps5150=0.d0
        dps5250=0.d0
        dps5350=0.d0
        dps5051=0.d0
        dps5151=0.d0
        dps5251=0.d0
        dps5351=0.d0
        dps5052=0.d0
        dps5152=0.d0
        dps5252=0.d0
        dps5352=0.d0
        do ii1=1,nbpDf
          deli1=betD2(ii1,iclegy)
	  rhi1=delD2(ii1,iclegy)
        do ii2=1,nbpDf
          deli2=betD2(ii2,iclegy)
	  rhi2=delD2(ii2,iclegy)
        do it1=1,nbpDf
          delt1=betD1(it1,iclegy,icltar)
          alpt1=betDp1(it1,iclegy,icltar)-alppar
	  rht1=delD1(it1,iclegy,icltar)
        do it2=1,nbpDf
          delt2=betD1(it2,iclegy,icltar)
          alpt2=betDp1(it2,iclegy,icltar)-alppar
	  rht2=delD1(it2,iclegy,icltar)
        do it3=1,nbpDf
          delt3=betD1(it3,iclegy,icltar)
          alpt3=betDp1(it3,iclegy,icltar)-alppar
	  rht3=delD1(it3,iclegy,icltar)
        do it4=1,nbpDf
          delt4=betD1(it4,iclegy,icltar)
          alpt4=betDp1(it4,iclegy,icltar)-alppar
	  rht4=delD1(it4,iclegy,icltar)
        do it5=1,nbpDf
          delt5=betD1(it5,iclegy,icltar)
          alpt5=betDp1(it5,iclegy,icltar)-alppar
	  rht5=delD1(it5,iclegy,icltar)
        do ip1=1,nbpDf
          delp1=betD1(ip1,iclegy,iclpro)
          alpp1=betDp1(ip1,iclegy,iclpro)-alppar
	  rhp1=delD1(ip1,iclegy,iclpro)
        do ip2=1,nbpDf
          delp2=betD1(ip2,iclegy,iclpro)
          alpp2=betDp1(ip2,iclegy,iclpro)-alppar
	  rhp2=delD1(ip2,iclegy,iclpro)
	  
	  rhtn=1./(1./rht2+1./rht4+1./rht5)
	  rhtm=rht3
	  rhpn=rhp2
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2
     *    -delt1-delt2-delt3-delt4-delt5)
     *    -ddelx**(3.d0*(delp1+delp2-delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2-delt1-delt2-delt3-delt4-delt5)
          dpx2=((dsy/ddelx)**(deli1+delp2-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2-delt1))))
     *    /(deli1+delp2-delt1)
          dpx3=((dsy/ddelx**2)**(deli2-deli1-delt3)
     *    -(ddelx**(2.d0*(deli2-deli1-delt3))))
     *    /(deli2-deli1-delt3)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2-deli1-delt3)))
     *    /(deli2+delp2-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2-delt4-delt5)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4+delt5-delp1)
     *    -dpx2*ddelx**(2.d0*(delp1-deli1-delt2-delt3-delt4-delt5)))
     *    /(delp1-deli1-delt2-delt3-delt4-delt5)
     *    *ddelx**(deli2+delt2+delt4+delt5-delp1))
     *    /(deli2+delt2+delt4+delt5-delp1)
	
          dps2051=dps2051+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(2.d0+alpp1+alpp2+delp1+delp2)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu2(ip1+nbpDf*(ip2-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD1(it5,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rht2/rht3/rht4/rht5/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=1./(1./rht2+1./rht5)
	  rhtm=1./(1./rht3+1./rht4)
	  rhpn=rhp2
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2
     *    -delt1-delt2-delt3-delt4-delt5)
     *    -ddelx**(3.d0*(delp1+delp2-delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2-delt1-delt2-delt3-delt4-delt5)
          dpx2=((dsy/ddelx)**(deli1+delp2-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2-delt1))))
     *    /(deli1+delp2-delt1)
          dpx3=((dsy/ddelx**2)**(deli2-deli1-delt3-delt4)
     *    -(ddelx**(2.d0*(deli2-deli1-delt3-delt4))))
     *    /(deli2-deli1-delt3-delt4)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2-deli1-delt3-delt4)))
     *    /(deli2+delp2-delt1-delt3-delt4)
     *    *ddelx**(delp1-deli2-delt2-delt5)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4+delt5-delp1)
     *    -dpx2*ddelx**(2.d0*(delp1-deli1-delt2-delt3-delt4-delt5)))
     *    /(delp1-deli1-delt2-delt3-delt4-delt5)
     *    *ddelx**(deli2+delt2+delt5-delp1))
     *    /(deli2+delt2+delt5-delp1)
	
          dps2052=dps2052+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(2.d0+alpp1+alpp2+delp1+delp2)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu2(ip1+nbpDf*(ip2-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD1(it5,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rht2/rht3/rht4/rht5/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=rht2
	  rhtm=1./(1./rht3+1./rht4+1./rht5)
	  rhpn=rhp2
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2
     *    -delt1-delt2-delt3-delt4-delt5)
     *    -ddelx**(3.d0*(delp1+delp2-delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2-delt1-delt2-delt3-delt4-delt5)
          dpx2=((dsy/ddelx)**(deli1+delp2-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2-delt1))))
     *    /(deli1+delp2-delt1)
          dpx3=((dsy/ddelx**2)**(deli2-deli1-delt3-delt4-delt5)
     *    -(ddelx**(2.d0*(deli2-deli1-delt3-delt4-delt5))))
     *    /(deli2-deli1-delt3-delt4-delt5)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2-deli1-delt3-delt4-delt5)))
     *    /(deli2+delp2-delt1-delt3-delt4-delt5)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4+delt5-delp1)
     *    -dpx2*ddelx**(2.d0*(delp1-deli1-delt2-delt3-delt4-delt5)))
     *    /(delp1-deli1-delt2-delt3-delt4-delt5)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	
          dps2053=dps2053+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(2.d0+alpp1+alpp2+delp1+delp2)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu2(ip1+nbpDf*(ip2-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD1(it5,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rht2/rht3/rht4/rht5/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)

        do ip3=1,nbpDf
          delp3=betD1(ip3,iclegy,iclpro)
          alpp3=betDp1(ip3,iclegy,iclpro)-alppar
	  rhp3=delD1(ip3,iclegy,iclpro)
	  
	  rhtn=1./(1./rht2+1./rht3+1./rht4+1./rht5)
	  rhpn=rhp3
	  rhpm=rhp2
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3
     *    -delt1-delt2-delt3-delt4-delt5)-ddelx**(3.d0*(delp1
     *    +delp2+delp3-delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2+delp3-delt1-delt2-delt3-delt4-delt5)
          dpx2=((dsy/ddelx)**(deli1+delp3-delt1)
     *    -(ddelx**(3.d0*(deli1+delp3-delt1))))
     *    /(deli1+delp3-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp2-deli1)
     *    -(ddelx**(2.d0*(deli2+delp2-deli1))))
     *    /(deli2+delp2-deli1)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp3-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp2-deli1)))
     *    /(deli2+delp2+delp3-delt1)
     *    *ddelx**(delp1-deli2-delt2-delt3-delt4-delt5)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4+delt5-delp1-delp2)
     *    -dpx2*ddelx**(2.d0*(delp1+delp2
     *    -deli1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2-deli1-delt2-delt3-delt4-delt5)
     *    *ddelx**(deli2+delt2+delt3+delt4+delt5-delp1))
     *    /(deli2+delt2+delt3+delt4+delt5-delp1)
	
          dps3150=dps3150+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)*alpD1(it5,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rht2/rht3/rht4/rht5/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=1./(1./rht2+1./rht4+1./rht5)
	  rhtm=rht3
	  rhpn=rhp2
	  rhpm=rhp3
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3
     *    -delt1-delt2-delt3-delt4-delt5)-ddelx**(3.d0*(delp1
     *    +delp2+delp3-delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2+delp3-delt1-delt2-delt3-delt4-delt5)
          dpx2=((dsy/ddelx)**(deli1+delp2-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2-delt1))))
     *    /(deli1+delp2-delt1)
          if(abs(deli2+delp3-deli1-delt3).lt.1.e-5)then
            dpx3=log(max(1.d0,dsy/ddelx**4.d0))
          else
            dpx3=((dsy/ddelx**2)**(deli2+delp3-deli1-delt3)
     *      -(ddelx**(2.d0*(deli2+delp3-deli1-delt3))))
     *      /(deli2+delp3-deli1-delt3)
          endif 
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3-deli1-delt3)))
     *    /(deli2+delp2+delp3-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2-delt4-delt5)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4+delt5-delp1-delp3)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3
     *    -deli1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp3-deli1-delt2-delt3-delt4-delt5)
     *    *ddelx**(deli2+delt2+delt4+delt5-delp1))
     *    /(deli2+delt2+delt4+delt5-delp1)
	  
          dps3151=dps3151+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)*alpD1(it5,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rht2/rht3/rht4/rht5/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=1./(1./rht2+1./rht5)
	  rhtm=1./(1./rht3+1./rht4)
	  rhpn=rhp2
	  rhpm=rhp3
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3
     *    -delt1-delt2-delt3-delt4-delt5)-ddelx**(3.d0*(delp1
     *    +delp2+delp3-delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2+delp3-delt1-delt2-delt3-delt4-delt5)
          dpx2=((dsy/ddelx)**(deli1+delp2-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2-delt1))))
     *    /(deli1+delp2-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp3-deli1-delt3-delt4)
     *    -(ddelx**(2.d0*(deli2+delp3-deli1-delt3-delt4))))
     *    /(deli2+delp3-deli1-delt3-delt4)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3-deli1-delt3-delt4)))
     *    /(deli2+delp2+delp3-delt1-delt3-delt4)
     *    *ddelx**(delp1-deli2-delt2-delt5)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4+delt5-delp1-delp3)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3
     *    -deli1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp3-deli1-delt2-delt3-delt4-delt5)
     *    *ddelx**(deli2+delt2+delt5-delp1))/(deli2+delt2+delt5-delp1)
	
          dps3152=dps3152+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)*alpD1(it5,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rht2/rht3/rht4/rht5/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=rht2
	  rhtm=1./(1./rht3+1./rht4+1./rht5)
	  rhpn=rhp2
	  rhpm=rhp3
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3
     *    -delt1-delt2-delt3-delt4-delt5)-ddelx**(3.d0*(delp1
     *    +delp2+delp3-delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2+delp3-delt1-delt2-delt3-delt4-delt5)
          dpx2=((dsy/ddelx)**(deli1+delp2-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2-delt1))))
     *    /(deli1+delp2-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp3-deli1-delt3-delt4-delt5)
     *    -(ddelx**(2.d0*(deli2+delp3-deli1-delt3-delt4-delt5))))
     *    /(deli2+delp3-deli1-delt3-delt4-delt5)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3-deli1-delt3-delt4-delt5)))
     *    /(deli2+delp2+delp3-delt1-delt3-delt4-delt5)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4+delt5-delp1-delp3)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3
     *    -deli1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp3-deli1-delt2-delt3-delt4-delt5)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	
          dps3153=dps3153+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)*alpD1(it5,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rht2/rht3/rht4/rht5/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=1./(1./rht2+1./rht4+1./rht5)
	  rhtm=rht3
	  rhpn=1./(1./rhp2+1./rhp3)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3
     *    -delt1-delt2-delt3-delt4-delt5)-ddelx**(3.d0*(delp1
     *    +delp2+delp3-delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2+delp3-delt1-delt2-delt3-delt4-delt5)
          dpx2=((dsy/ddelx)**(deli1+delp2+delp3-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp3-delt1))))
     *    /(deli1+delp2+delp3-delt1)
          dpx3=((dsy/ddelx**2)**(deli2-deli1-delt3)
     *    -(ddelx**(2.d0*(deli2-deli1-delt3))))
     *    /(deli2-deli1-delt3)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp3-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2-deli1-delt3)))
     *    /(deli2+delp2+delp3-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2-delt4-delt5)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4+delt5-delp1)
     *    -dpx2*ddelx**(2.d0*(delp1-deli1-delt2-delt3-delt4-delt5)))
     *    /(delp1-deli1-delt2-delt3-delt4-delt5)
     *    *ddelx**(deli2+delt2+delt4+delt5-delp1))
     *    /(deli2+delt2+delt4+delt5-delp1)
	
          dps3051=dps3051+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)*alpD1(it5,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rht2/rht3/rht4/rht5/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=1./(1./rht2+1./rht5)
	  rhtm=1./(1./rht3+1./rht4)
	  rhpn=1./(1./rhp2+1./rhp3)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3
     *    -delt1-delt2-delt3-delt4-delt5)-ddelx**(3.d0*(delp1
     *    +delp2+delp3-delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2+delp3-delt1-delt2-delt3-delt4-delt5)
          dpx2=((dsy/ddelx)**(deli1+delp2+delp3-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp3-delt1))))
     *    /(deli1+delp2+delp3-delt1)
          dpx3=((dsy/ddelx**2)**(deli2-deli1-delt3-delt4)
     *    -(ddelx**(2.d0*(deli2-deli1-delt3-delt4))))
     *    /(deli2-deli1-delt3-delt4)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp3-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2-deli1-delt3-delt4)))
     *    /(deli2+delp2+delp3-delt1-delt3-delt4)
     *    *ddelx**(delp1-deli2-delt2-delt5)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4+delt5-delp1)
     *    -dpx2*ddelx**(2.d0*(delp1-deli1-delt2-delt3-delt4-delt5)))
     *    /(delp1-deli1-delt2-delt3-delt4-delt5)
     *    *ddelx**(deli2+delt2+delt5-delp1))/(deli2+delt2+delt5-delp1)
	
          dps3052=dps3052+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)*alpD1(it5,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rht2/rht3/rht4/rht5/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=rht2
	  rhtm=1./(1./rht3+1./rht4+1./rht5)
	  rhpn=1./(1./rhp2+1./rhp3)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3
     *    -delt1-delt2-delt3-delt4-delt5)-ddelx**(3.d0*(delp1
     *    +delp2+delp3-delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2+delp3-delt1-delt2-delt3-delt4-delt5)
          dpx2=((dsy/ddelx)**(deli1+delp2+delp3-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp3-delt1))))
     *    /(deli1+delp2+delp3-delt1)
          dpx3=((dsy/ddelx**2)**(deli2-deli1-delt3-delt4-delt5)
     *    -(ddelx**(2.d0*(deli2-deli1-delt3-delt4-delt5))))
     *    /(deli2-deli1-delt3-delt4-delt5)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp3-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2-deli1-delt3-delt4-delt5)))
     *    /(deli2+delp2+delp3-delt1-delt3-delt4-delt5)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4+delt5-delp1)
     *    -dpx2*ddelx**(2.d0*(delp1-deli1-delt2-delt3-delt4-delt5)))
     *    /(delp1-deli1-delt2-delt3-delt4-delt5)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	
          dps3053=dps3053+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(3.d0+alpp1+alpp2+alpp3+delp1+delp2+delp3)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu3(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(it1,iclegy,icltar)
     *    *alpD1(it2,iclegy,icltar)*alpD1(it3,iclegy,icltar)
     *    *alpD1(it4,iclegy,icltar)*alpD1(it5,iclegy,icltar)
     *    *alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rht2/rht3/rht4/rht5/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)

        do ip4=1,nbpDf
          delp4=betD1(ip4,iclegy,iclpro)
          alpp4=betDp1(ip4,iclegy,iclpro)-alppar
	  rhp4=delD1(ip4,iclegy,iclpro)
	  
	  rhtn=1./(1./rht2+1./rht3+1./rht4+1./rht5)
	  rhpn=1./(1./rhp3+1./rhp4)
	  rhpm=rhp2
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)
     *    -ddelx**(3.d0*(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4-delt5)
          dpx2=((dsy/ddelx)**(deli1+delp3+delp4-delt1)
     *    -(ddelx**(3.d0*(deli1+delp3+delp4-delt1))))
     *    /(deli1+delp3+delp4-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp2-deli1)
     *    -(ddelx**(2.d0*(deli2+delp2-deli1))))
     *    /(deli2+delp2-deli1)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp3+delp4-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp2-deli1)))
     *    /(deli2+delp2+delp3+delp4-delt1)
     *    *ddelx**(delp1-deli2-delt2-delt3-delt4-delt5)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4+delt5-delp1-delp2)
     *    -dpx2*ddelx**(2.d0*(delp1+delp2
     *    -deli1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2-deli1-delt2-delt3-delt4-delt5)
     *    *ddelx**(deli2+delt2+delt3+delt4+delt5-delp1))
     *    /(deli2+delt2+delt3+delt4+delt5-delp1)
	
          dps4150=dps4150+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD1(it5,iclegy,icltar)*alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rht4/rht5/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)

	  rhtn=1./(1./rht2+1./rht3+1./rht4+1./rht5)
	  rhpn=rhp3
	  rhpm=1./(1./rhp2+1./rhp4)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)
     *    -ddelx**(3.d0*(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4-delt5)
          dpx2=((dsy/ddelx)**(deli1+delp3-delt1)
     *    -(ddelx**(3.d0*(deli1+delp3-delt1))))
     *    /(deli1+delp3-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp2+delp4-deli1)
     *    -(ddelx**(2.d0*(deli2+delp2+delp4-deli1))))
     *    /(deli2+delp2+delp4-deli1)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp3-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp2+delp4-deli1)))
     *    /(deli2+delp2+delp3+delp4-delt1)
     *    *ddelx**(delp1-deli2-delt2-delt3-delt4-delt5)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4+delt5
     *    -delp1-delp2-delp4)
     *    -dpx2*ddelx**(2.d0*(delp1+delp2+delp4
     *    -deli1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2+delp4-deli1-delt2-delt3-delt4-delt5)
     *    *ddelx**(deli2+delt2+delt3+delt4+delt5-delp1))
     *    /(deli2+delt2+delt3+delt4+delt5-delp1)
	
          dps4250=dps4250+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD1(it5,iclegy,icltar)*alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rht4/rht5/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  	  
	  rhtn=1./(1./rht2+1./rht4+1./rht5)
	  rhtm=rht3
	  rhpn=1./(1./rhp2+1./rhp4)
	  rhpm=rhp3
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)
     *    -ddelx**(3.d0*(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4-delt5)
          dpx2=((dsy/ddelx)**(deli1+delp2+delp4-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp4-delt1))))
     *    /(deli1+delp2+delp4-delt1)
          if(abs(deli2+delp3-deli1-delt3).lt.1.e-5)then
            dpx3=log(max(1.d0,dsy/ddelx**4.d0))
          else
            dpx3=((dsy/ddelx**2)**(deli2+delp3-deli1-delt3)
     *      -(ddelx**(2.d0*(deli2+delp3-deli1-delt3))))
     *      /(deli2+delp3-deli1-delt3)
          endif 
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp4-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3-deli1-delt3)))
     *    /(deli2+delp2+delp3+delp4-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2-delt4-delt5)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4+delt5-delp1-delp3)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3
     *    -deli1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp3-deli1-delt2-delt3-delt4-delt5)
     *    *ddelx**(deli2+delt2+delt4+delt5-delp1))
     *    /(deli2+delt2+delt4+delt5-delp1)
	  
          dps4151=dps4151+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD1(it5,iclegy,icltar)*alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rht4/rht5/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=1./(1./rht2+1./rht4+1./rht5)
	  rhtm=rht3
	  rhpn=rhp2
	  rhpm=1./(1./rhp3+1./rhp4)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)
     *    -ddelx**(3.d0*(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4-delt5)
          dpx2=((dsy/ddelx)**(deli1+delp2-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2-delt1))))
     *    /(deli1+delp2-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp3+delp4-deli1-delt3)
     *    -(ddelx**(2.d0*(deli2+delp3+delp4-deli1-delt3))))
     *    /(deli2+delp3+delp4-deli1-delt3)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3+delp4-deli1-delt3)))
     *    /(deli2+delp2+delp3+delp4-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2-delt4-delt5)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4+delt5
     *    -delp1-delp3-delp4)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3+delp4
     *    -deli1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp3+delp4-deli1-delt2-delt3-delt4-delt5)
     *    *ddelx**(deli2+delt2+delt4+delt5-delp1))
     *    /(deli2+delt2+delt4+delt5-delp1)
	  
          dps4251=dps4251+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD1(it5,iclegy,icltar)*alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rht4/rht5/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=1./(1./rht2+1./rht4+1./rht5)
	  rhtm=rht3
	  rhpn=1./(1./rhp2+1./rhp3+1./rhp4)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)
     *    -ddelx**(3.d0*(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4-delt5)
          dpx2=((dsy/ddelx)**(deli1+delp2+delp3+delp4-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp3+delp4-delt1))))
     *    /(deli1+delp2+delp3+delp4-delt1)
          dpx3=((dsy/ddelx**2)**(deli2-deli1-delt3)
     *    -(ddelx**(2.d0*(deli2-deli1-delt3))))
     *    /(deli2-deli1-delt3)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp3+delp4-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2-deli1-delt3)))
     *    /(deli2+delp2+delp3+delp4-delt1-delt3)
     *    *ddelx**(delp1-deli2-delt2-delt4-delt5)
     *    -(dpx1*ddelx**(deli1+delt2+delt4+delt5+delt3-delp1)
     *    -dpx2*ddelx**(2.d0*(delp1-deli1-delt2-delt3-delt4-delt5)))
     *    /(delp1-deli1-delt2-delt3-delt4-delt5)
     *    *ddelx**(deli2+delt2+delt4+delt5-delp1))
     *    /(deli2+delt2+delt4+delt5-delp1)
	
          dps4051=dps4051+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD1(it5,iclegy,icltar)*alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rht4/rht5/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  	  
	  rhtn=1./(1./rht2+1./rht5)
	  rhtm=1./(1./rht3+1./rht4)
	  rhpn=1./(1./rhp2+1./rhp3+1./rhp4)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)
     *    -ddelx**(3.d0*(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4-delt5)
          dpx2=((dsy/ddelx)**(deli1+delp2+delp3+delp4-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp3+delp4-delt1))))
     *    /(deli1+delp2+delp3+delp4-delt1)
          dpx3=((dsy/ddelx**2)**(deli2-deli1-delt3-delt4)
     *    -(ddelx**(2.d0*(deli2-deli1-delt3-delt4))))
     *    /(deli2-deli1-delt3-delt4)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp3+delp4-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2-deli1-delt3-delt4)))
     *    /(deli2+delp2+delp3+delp4-delt1-delt3-delt4)
     *    *ddelx**(delp1-deli2-delt2-delt5)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4+delt5-delp1)
     *    -dpx2*ddelx**(2.d0*(delp1-deli1-delt2-delt3-delt4-delt5)))
     *    /(delp1-deli1-delt2-delt3-delt4-delt5)
     *    *ddelx**(deli2+delt2+delt5-delp1))/(deli2+delt2+delt5-delp1)
	
          dps4052=dps4052+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD1(it5,iclegy,icltar)*alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rht4/rht5/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  	  
	  rhtn=1./(1./rht2+1./rht5)
	  rhtm=1./(1./rht3+1./rht4)
	  rhpn=1./(1./rhp2+1./rhp4)
	  rhpm=rhp3
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)
     *    -ddelx**(3.d0*(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4-delt5)
          dpx2=((dsy/ddelx)**(deli1+delp2+delp4-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp4-delt1))))
     *    /(deli1+delp2+delp4-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp3-deli1-delt3-delt4)
     *    -(ddelx**(2.d0*(deli2+delp3-deli1-delt3-delt4))))
     *    /(deli2+delp3-deli1-delt3-delt4)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp4-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3-deli1-delt3-delt4)))
     *    /(deli2+delp2+delp3+delp4-delt1-delt3-delt4)
     *    *ddelx**(delp1-deli2-delt2-delt5)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4+delt5-delp1-delp3)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3
     *    -deli1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp3-deli1-delt2-delt3-delt4-delt5)
     *    *ddelx**(deli2+delt2+delt5-delp1))/(deli2+delt2+delt5-delp1)
	
          dps4152=dps4152+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD1(it5,iclegy,icltar)*alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rht4/rht5/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=1./(1./rht2+1./rht5)
	  rhtm=1./(1./rht3+1./rht4)
	  rhpn=rhp2
	  rhpm=1./(1./rhp3+1./rhp4)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)
     *    -ddelx**(3.d0*(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4-delt5)
          dpx2=((dsy/ddelx)**(deli1+delp2-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2-delt1))))
     *    /(deli1+delp2-delt1)
          if(abs(deli2+delp3+delp4-deli1-delt3-delt4).lt.1.e-5)then
            dpx3=log(max(1.d0,dsy/ddelx**4.d0))
          else
            dpx3=((dsy/ddelx**2)**(deli2+delp3+delp4-deli1-delt3-delt4)
     *      -(ddelx**(2.d0*(deli2+delp3+delp4-deli1-delt3-delt4))))
     *      /(deli2+delp3+delp4-deli1-delt3-delt4)
          endif
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3+delp4-deli1-delt3-delt4)))
     *    /(deli2+delp2+delp3+delp4-delt1-delt3-delt4)
     *    *ddelx**(delp1-deli2-delt2-delt5)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4+delt5
     *    -delp1-delp3-delp4)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3+delp4
     *    -deli1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp3+delp4-deli1-delt2-delt3-delt4-delt5)
     *    *ddelx**(deli2+delt2+delt5-delp1))/(deli2+delt2+delt5-delp1)
	  
          dps4252=dps4252+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD1(it5,iclegy,icltar)*alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rht4/rht5/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  	  
	  rhtn=rht2
	  rhtm=1./(1./rht3+1./rht4+1./rht5)
	  rhpn=1./(1./rhp2+1./rhp3+1./rhp4)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)
     *    -ddelx**(3.d0*(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4-delt5)
          dpx2=((dsy/ddelx)**(deli1+delp2+delp3+delp4-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp3+delp4-delt1))))
     *    /(deli1+delp2+delp3+delp4-delt1)
          dpx3=((dsy/ddelx**2)**(deli2-deli1-delt3-delt4-delt5)
     *    -(ddelx**(2.d0*(deli2-deli1-delt3-delt4-delt5))))
     *    /(deli2-deli1-delt3-delt4-delt5)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp3+delp4-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2-deli1-delt3-delt4-delt5)))
     *    /(deli2+delp2+delp3+delp4-delt1-delt3-delt4-delt5)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4+delt5-delp1)
     *    -dpx2*ddelx**(2.d0*(delp1-deli1-delt2-delt3-delt4-delt5)))
     *    /(delp1-deli1-delt2-delt3-delt4-delt5)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	
          dps4053=dps4053+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD1(it5,iclegy,icltar)*alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rht4/rht5/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  	  
	  rhtn=rht2
	  rhtm=1./(1./rht3+1./rht4+1./rht5)
	  rhpn=1./(1./rhp2+1./rhp4)
	  rhpm=rhp3
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)
     *    -ddelx**(3.d0*(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4-delt5)
          dpx2=((dsy/ddelx)**(deli1+delp2+delp4-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2+delp4-delt1))))
     *    /(deli1+delp2+delp4-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp3-deli1-delt3-delt4-delt5)
     *    -(ddelx**(2.d0*(deli2+delp3-deli1-delt3-delt4-delt5))))
     *    /(deli2+delp3-deli1-delt3-delt4-delt5)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2+delp4-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3-deli1-delt3-delt4-delt5)))
     *    /(deli2+delp2+delp3+delp4-delt1-delt3-delt4-delt5)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4+delt5-delp1-delp3)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3
     *    -deli1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp3-deli1-delt2-delt3-delt4-delt5)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	
          dps4153=dps4153+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD1(it5,iclegy,icltar)*alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rht4/rht5/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)
	  
	  rhtn=rht2
	  rhtm=1./(1./rht3+1./rht4+1./rht5)
	  rhpn=rhp2
	  rhpm=1./(1./rhp3+1./rhp4)
	  rhtn1=rhtn*rhp1+rhtn*rhi2+rhp1*rhi2
	  rhpn1=rhpn*rht1+rhpn*rhi1+rht1*rhi1
	  rhpr=1./(1./rhpm+rht1/rhpn1+rhtn/rhtn1)
	  rhtg=1./(1./rhtm+rhpn/rhpn1+rhp1/rhtn1)
	  rh=1./(rhi1/rhpn1+rhi2/rhtn1+1./(rhpr+rhtg))
	  
          dpx1=((dsy/ddelx)**(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)
     *    -ddelx**(3.d0*(delp1+delp2+delp3+delp4
     *    -delt1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp2+delp3+delp4-delt1-delt2-delt3-delt4-delt5)
          dpx2=((dsy/ddelx)**(deli1+delp2-delt1)
     *    -(ddelx**(3.d0*(deli1+delp2-delt1))))
     *    /(deli1+delp2-delt1)
          dpx3=((dsy/ddelx**2)**(deli2+delp3+delp4
     *    -deli1-delt3-delt4-delt5)
     *    -(ddelx**(2.d0*(deli2+delp3+delp4-deli1-delt3-delt4-delt5))))
     *    /(deli2+delp3+delp4-deli1-delt3-delt4-delt5)
          dps=((dpx3*(dsy/ddelx)**(deli1+delp2-delt1)
     *    -dpx2*ddelx**(2.d0*(deli2+delp3+delp4
     *    -deli1-delt3-delt4-delt5)))
     *    /(deli2+delp2+delp3+delp4-delt1-delt3-delt4-delt5)
     *    *ddelx**(delp1-deli2-delt2)
     *    -(dpx1*ddelx**(deli1+delt2+delt3+delt4+delt5
     *    -delp1-delp3-delp4)
     *    -dpx2*ddelx**(2.d0*(delp1+delp3+delp4
     *    -deli1-delt2-delt3-delt4-delt5)))
     *    /(delp1+delp3+delp4-deli1-delt2-delt3-delt4-delt5)
     *    *ddelx**(deli2+delt2-delp1))/(deli2+delt2-delp1)
	  
          dps4253=dps4253+dps*dsy**(delt1+delt2+delt3+delt4+delt5)
     *    *dxpp**(4.d0+alpp1+alpp2+alpp3+alpp4+delp1+delp2+delp3+delp4)
     *    *dxpm**(5.d0+alpt1+alpt2+alpt3+alpt4+alpt5
     *    +delt1+delt2+delt3+delt4+delt5)
     *    *coefu4(ip1+nbpDf*(ip2-1)+nbpDf*nbpDf*(ip3-1)
     *    +nbpDf*nbpDf*nbpDf*(ip4-1),iclpro)
     *    *coefu5(it1+nbpDf*(it2-1)+nbpDf*nbpDf*(it3-1)+nbpDf*nbpDf
     *    *nbpDf*(it4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(it5-1),icltar)
     *    *alpD1(ip1,iclegy,iclpro)*alpD1(ip2,iclegy,iclpro)
     *    *alpD1(ip3,iclegy,iclpro)*alpD1(ip4,iclegy,iclpro)
     *    *alpD1(it1,iclegy,icltar)*alpD1(it2,iclegy,icltar)
     *    *alpD1(it3,iclegy,icltar)*alpD1(it4,iclegy,icltar)
     *    *alpD1(it5,iclegy,icltar)*alpD2(ii1,iclegy)*alpD2(ii2,iclegy)
     *    *rhpn*rhtn/rhp2/rhp3/rhp4/rht2/rht3/rht4/rht5/rhpn1/rhtn1
     *    /(1./rhpr+1./rhtg)*zb**(rp/rh)

        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        enddo
        dps2051=-dps2051*(r3pom*pi/.0389)**3*gam3p**2/6.
     *  *gamdp(icdp,iclpro)**2*gamdt(icdt,icltar)**5
        dps2052=-dps2052*(r3pom*pi/.0389)**3*gam3p**2/4.
     *  *gamdp(icdp,iclpro)**2*gamdt(icdt,icltar)**5
        dps2053=-dps2053*(r3pom*pi/.0389)**3*gam3p**2/6.
     *  *gamdp(icdp,iclpro)**2*gamdt(icdt,icltar)**5
        dps3051=dps3051*(r3pom*pi/.0389)**3*gam3p**3/12.
     *  *gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**5
        dps3052=dps3052*(r3pom*pi/.0389)**3*gam3p**3/8.
     *  *gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**5
        dps3053=dps3053*(r3pom*pi/.0389)**3*gam3p**3/12.
     *  *gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**5
        dps3150=dps3150*(r3pom*pi/.0389)**3*gam3p**3/24.
     *  *gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**5
        dps3151=dps3151*(r3pom*pi/.0389)**3*gam3p**3/6.
     *  *gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**5
        dps3152=dps3152*(r3pom*pi/.0389)**3*gam3p**3/4.
     *  *gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**5
        dps3153=dps3153*(r3pom*pi/.0389)**3*gam3p**3/6.
     *  *gamdp(icdp,iclpro)**3*gamdt(icdt,icltar)**5
        dps4051=-dps4051*(r3pom*pi/.0389)**3*gam3p**4/36.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**5
        dps4052=-dps4052*(r3pom*pi/.0389)**3*gam3p**4/24.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**5
        dps4053=-dps4053*(r3pom*pi/.0389)**3*gam3p**4/36.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**5
        dps4150=-dps4150*(r3pom*pi/.0389)**3*gam3p**4/48.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**5
        dps4151=-dps4151*(r3pom*pi/.0389)**3*gam3p**4/12.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**5
        dps4152=-dps4152*(r3pom*pi/.0389)**3*gam3p**4/8.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**5
        dps4153=-dps4153*(r3pom*pi/.0389)**3*gam3p**4/12.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**5
        dps4250=-dps4250*(r3pom*pi/.0389)**3*gam3p**4/48.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**5
        dps4251=-dps4251*(r3pom*pi/.0389)**3*gam3p**4/12.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**5
        dps4252=-dps4252*(r3pom*pi/.0389)**3*gam3p**4/8.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**5
        dps4253=-dps4253*(r3pom*pi/.0389)**3*gam3p**4/12.
     *  *gamdp(icdp,iclpro)**4*gamdt(icdt,icltar)**5

        dps3=dps3120+dps4120+dps4220+dps5120+dps5320+dps5220
     *  +dps3130+dps4130+dps4230+dps5130+dps5330+dps5230
     *  +dps2031+dps3031+dps4031+dps5031
     *  +dps3131+dps4131+dps4231+dps5131+dps5331+dps5231
     *  +dps3140+dps4140+dps4240+dps5140+dps5340+dps5240
     *  +dps2041+dps3041+dps4041+dps5041
     *  +dps3141+dps4141+dps4241+dps5141+dps5341+dps5241
     *  +dps2042+dps3042+dps3142+dps4042+dps5042
     *  +dps4142+dps4242+dps5142+dps5342+dps5242
     *  +dps2051+dps2052+dps2053+dps3051+dps3052+dps3053
     *  +dps3150+dps3151+dps3152+dps3153+dps4051+dps4052+dps4053
     *  +dps4150+dps4151+dps4152+dps4153
     *  +dps4250+dps4251+dps4252+dps4253
	
c        write(*,*)'3rd',dps3,dps3120,dps2031,dps4120,dps2041
c     *  ,dps4220,dps2042,dps3130,dps3031,dps3131
c        write(*,*)'4-3',dps4130,dps4230,dps4031,dps4131,dps4231
c        write(*,*)'3-4',dps3041,dps3042,dps3140,dps3141,dps3142
c        write(*,*)'5-2,3',dps5120,dps2051,dps5220,dps2052,dps5320
c     *  ,dps2053,dps5130,dps3051,dps5230,dps3052,dps5330,dps3053
c     *  ,dps5031,dps3150,dps5131,dps3151,dps5231,dps3152,dps5331,dps3153
c        write(*,*)'4-4',dps4140,dps4041,dps4240,dps4042,dps4241,dps4142
c     *  ,dps4141,dps4242
c        write(*,*)'5-4',dps5140,dps5240,dps5340,dps5041,dps5141
c     *  ,dps5241,dps5341,dps5042,dps5142,dps5242,dps5342
c        write(*,*)'4-5',dps4051,dps4052,dps4053,dps4150,dps4151
c     *  ,dps4152,dps4153,dps4250,dps4251,dps4252,dps4253
      endif

      psv3p=dps1+dps2+dps3
      write(*,*)'psv3p',psv3p,dps1,dps2,dps3
      iclegy=iclegys

      return 
      end
                  
c------------------------------------------------------------------------
      function psfro(xpomr,zb,iclp,icdpro)
c-----------------------------------------------------------------------
c psfro - generalized froissaron between proj. and 3p-vertex
c xpp   - lc+ for the proj. side,
c xpomr - lc+ for the vertex,
c zb    - impact parameter factor, z=exp(-b**2/4*rp),
c------------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      double precision ddelx,dxpomr,fan0,fan1,fan2
     *,dps1,dps2,dps3,dps4,dps5,dps6,dps7,dps8,dps9,dps10,dps11
     *,del1,del2,del3,del4,del5,del6,del7,del8,del9
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar6/  coefu1(nbpDf,nclha)
     *,coefu2(nbpDf*nbpDf,nclha)
     *,coefu3(nbpDf*nbpDf*nbpDf,nclha)
     *,coefu4(nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefu5(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefu6(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefc2(nbpDf*nbpDf,nclha)
     *,coefc3(nbpDf*nbpDf*nbpDf,nclha)
     *,coefc4(nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefc5(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
      common /psar7/ delx,alam3p,gam3p
      
      iclegys=iclegy
      psfro=0.
      if(1./xpomr.lt..999*delx)return
      
      rp=(r2had(iclp)+.5*alam3p-slopom*log(xpomr))*4.*.0389
      dxpomr=dble(xpomr)
      ddelx=dble(delx)

      dps2=0.d0
      dps3=0.d0
      dps4=0.d0
      dps5=0.d0
      dps6=0.d0
      iclegy=iclegy2
      do i1=1,nbpDf
         del1=betD1(i1,iclegy,iclp)
c         alp1=betDp1(i1,iclegy,iclp)-alppar
	 rh1=delD1(i1,iclegy,iclp)

      do i2=1,nbpDf
         del2=betD1(i2,iclegy,iclp)
c         alp2=betDp1(i2,iclegy,iclp)-alppar
	 rh2=delD1(i2,iclegy,iclp)
	 rh=rh1*rh2/(rh1+rh2)
	 
	 dps2=dps2+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   /dxpomr**(del1+del2) 
     *   *coefu2(i1+nbpDf*(i2-1),iclp)
     *   /rh1/rh2*zb**(rp/rh)

      do i3=1,nbpDf
         del3=betD1(i3,iclegy,iclp)
c         alp3=betDp1(i3,iclegy,iclp)-alppar
	 rh3=delD1(i3,iclegy,iclp)
	 rh=1./(1./rh1+1./rh2+1./rh3)
	
         dps3=dps3+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   *alpD1(i3,iclegy,iclp)/xpomr**(del1+del2+del3) 
     *   *coefu3(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1),iclp)
     *   /rh1/rh2/rh3*zb**(rp/rh)
	 
      do i4=1,nbpDf
         del4=betD1(i4,iclegy,iclp)
c         alp4=betDp1(i4,iclegy,iclp)-alppar
	 rh4=delD1(i4,iclegy,iclp)
	 rh=1./(1./rh1+1./rh2+1./rh3+1./rh4)
	
         dps4=dps4+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   *alpD1(i3,iclegy,iclp)*alpD1(i4,iclegy,iclp)
     *   /xpomr**(del1+del2+del3+del4) 
     *   *coefu4(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)
     *   +nbpDf*nbpDf*nbpDf*(i4-1),iclp)
     *   /rh1/rh2/rh3/rh4*zb**(rp/rh)

      do i5=1,nbpDf
         del5=betD1(i5,iclegy,iclp)
c         alp5=betDp1(i5,iclegy,iclp)-alppar
	 rh5=delD1(i5,iclegy,iclp)
	 rh=1./(1./rh1+1./rh2+1./rh3+1./rh4+1./rh5)
	
         dps5=dps5+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   *alpD1(i3,iclegy,iclp)*alpD1(i4,iclegy,iclp)
     *   *alpD1(i5,iclegy,iclp)/xpomr**(del1+del2+del3+del4+del5)
     *   *coefu5(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)+nbpDf*nbpDf
     *   *nbpDf*(i4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(i5-1),iclp)
     *   /rh1/rh2/rh3/rh4/rh5*zb**(rp/rh)

      do i6=1,nbpDf
         del6=betD1(i6,iclegy,iclp)
c         alp6=betDp1(i6,iclegy,iclp)-alppar
	 rh6=delD1(i6,iclegy,iclp)
	 rh=1./(1./rh1+1./rh2+1./rh3+1./rh4+1./rh5+1./rh6)
	
         dps6=dps6+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   *alpD1(i3,iclegy,iclp)*alpD1(i4,iclegy,iclp)
     *   *alpD1(i5,iclegy,iclp)*alpD1(i6,iclegy,iclp)
     *   /xpomr**(del1+del2+del3+del4+del5+del6) 
     *   *coefu6(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)
     *   +nbpDf*nbpDf*nbpDf*(i4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(i5-1)
     *   +nbpDf*nbpDf*nbpDf*nbpDf*nbpDf*(i6-1),iclp)
     *   /rh1/rh2/rh3/rh4/rh5/rh6*zb**(rp/rh)
      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
      
      fan0=(-dps2/2.d0*gamdp(icdpro,iclp)**2
     *+dps3*gam3p/6.d0*gamdp(icdpro,iclp)**3
     *-dps4*gam3p**2/24.d0*gamdp(icdpro,iclp)**4
     *+dps5*gam3p**3/120.d0*gamdp(icdpro,iclp)**5
     *-dps6*gam3p**4/720.d0*gamdp(icdpro,iclp)**6)*(r3pom*pi/.0389)

c      if((zb.eq.1..or.zb.eq..02).and.icdpro.eq.1)
c     *write(*,*)'fan0',fan0
c     *,-dps2/2.d0*gamdp(icdpro,iclp)**2*(r3pom*pi/.0389)
c     *,+dps3*gam3p/6.d0*gamdp(icdpro,iclp)**3*(r3pom*pi/.0389)
c     *,-dps4*gam3p**2/24.d0*gamdp(icdpro,iclp)**4*(r3pom*pi/.0389)
c     *,+dps5*gam3p**3/120.d0*gamdp(icdpro,iclp)**5*(r3pom*pi/.0389)
c     *,-dps6*gam3p**4/720.d0*gamdp(icdpro,iclp)**6*(r3pom*pi/.0389)
	
      fan1=0.d0
      if(1./xpomr.gt.delx**2)then
       dps1=0.d0
       dps2=0.d0
       dps3=0.d0
       dps4=0.d0
       dps5=0.d0
       dps6=0.d0
       dps7=0.d0
       dps8=0.d0
       dps9=0.d0
       dps10=0.d0
       dps11=0.d0
       do i6=1,nbpDf
         del6=betD2(i6,iclegy)
	 rh6=delD2(i6,iclegy)
       do i4=1,nbpDf
         del4=betD1(i4,iclegy,iclp)
c         alp4=betDp1(i4,iclegy,iclp)-alppar
	 rh4=delD1(i4,iclegy,iclp)
       do i5=1,nbpDf
         del5=betD1(i5,iclegy,iclp)
c         alp5=betDp1(i5,iclegy,iclp)-alppar
	 rh5=delD1(i5,iclegy,iclp)
	 rh45=rh6+rh4*rh5/(rh4+rh5)

       do i1=1,nbpDf
         del1=betD1(i1,iclegy,iclp)
c         alp1=betDp1(i1,iclegy,iclp)-alppar
	 rh1=delD1(i1,iclegy,iclp)
	 rh=1./(1./rh1+1./rh45)
	
	 dps2=dps2+alpD1(i4,iclegy,iclp)*alpD1(i5,iclegy,iclp)
     *   *alpD1(i1,iclegy,iclp)*alpD2(i6,iclegy)
     *   *coefu3(i1+nbpDf*(i4-1)+nbpDf*nbpDf*(i5-1),iclp)
     *   *((dxpomr*ddelx)**(del6-del4-del5)
     *   -ddelx**(del4+del5-del6))/(del4+del5-del6)
     *   /dxpomr**(del1+del6)
     *   /(rh4+rh5)/rh1/rh45*zb**(rp/rh)
     
       do i2=1,nbpDf
         del2=betD1(i2,iclegy,iclp)
c         alp2=betDp1(i2,iclegy,iclp)-alppar
	 rh2=delD1(i2,iclegy,iclp)
	 rh=1./(1./rh1+1./rh2+1./rh45)

	 dps3=dps3+alpD1(i4,iclegy,iclp)*alpD1(i5,iclegy,iclp)
     *   *alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   *alpD2(i6,iclegy)
     *   *coefu4(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i4-1)
     *   +nbpDf*nbpDf*nbpDf*(i5-1),iclp)
     *   *((dxpomr*ddelx)**(del6-del4-del5)
     *   -ddelx**(del4+del5-del6))/(del4+del5-del6)
     *   /dxpomr**(del1+del2+del6)
     *   /(rh4+rh5)/rh1/rh2/rh45*zb**(rp/rh)

         rh145=1./(1./rh1+1./rh4+1./rh5)
	 rh1456=rh6+rh145
         rh=1./(1./rh2+1./rh1456)

	 dps6=dps6+alpD1(i4,iclegy,iclp)*alpD1(i5,iclegy,iclp)
     *   *alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   *alpD2(i6,iclegy)
     *   *coefu4(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i4-1)
     *   +nbpDf*nbpDf*nbpDf*(i5-1),iclp)
     *   *((dxpomr*ddelx)**(del6-del1-del4-del5)
     *   -ddelx**(del1+del4+del5-del6))/(del1+del4+del5-del6)
     *   /dxpomr**(del2+del6)
     *   *rh145/rh1/rh4/rh5/rh1456/rh2*zb**(rp/rh)
            
       do i3=1,nbpDf
         del3=betD1(i3,iclegy,iclp)
c         alp3=betDp1(i3,iclegy,iclp)-alppar
	 rh3=delD1(i3,iclegy,iclp)
	 rh=1./(1./rh1+1./rh2+1./rh3+1./rh45)

	 dps4=dps4+alpD1(i4,iclegy,iclp)*alpD1(i5,iclegy,iclp)
     *   *alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   *alpD1(i3,iclegy,iclp)*alpD2(i6,iclegy)
     *   *coefu5(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)+nbpDf*nbpDf
     *   *nbpDf*(i4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(i5-1),iclp)
     *   *((dxpomr*ddelx)**(del6-del4-del5)
     *   -ddelx**(del4+del5-del6))/(del4+del5-del6)
     *   /dxpomr**(del1+del2+del3+del6)
     *   /(rh4+rh5)/rh1/rh2/rh3/rh45*zb**(rp/rh)

         rh=1./(1./rh2+1./rh3+1./rh1456)

	 dps7=dps7+alpD1(i4,iclegy,iclp)*alpD1(i5,iclegy,iclp)
     *   *alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   *alpD1(i3,iclegy,iclp)*alpD2(i6,iclegy)
     *   *coefu5(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)+nbpDf*nbpDf
     *   *nbpDf*(i4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(i5-1),iclp)
     *   *((dxpomr*ddelx)**(del6-del1-del4-del5)
     *   -ddelx**(del1+del4+del5-del6))/(del1+del4+del5-del6)
     *   /dxpomr**(del2+del3+del6)
     *   *rh145/rh1/rh4/rh5/rh1456/rh2/rh3*zb**(rp/rh)

         rh1245=1./(1./rh1+1./rh2+1./rh4+1./rh5)
	 rh12456=rh6+rh1245
         rh=1./(1./rh3+1./rh12456)

	 dps9=dps9+alpD1(i4,iclegy,iclp)*alpD1(i5,iclegy,iclp)
     *   *alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   *alpD1(i3,iclegy,iclp)*alpD2(i6,iclegy)
     *   *coefu5(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)+nbpDf*nbpDf
     *   *nbpDf*(i4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(i5-1),iclp)
     *   *((dxpomr*ddelx)**(del6-del1-del2-del4-del5)
     *   -ddelx**(del1+del2+del4+del5-del6))
     *   /(del1+del2+del4+del5-del6)
     *   /dxpomr**(del3+del6)
     *   *rh1245/rh1/rh2/rh4/rh5/rh12456/rh3*zb**(rp/rh)
            
       do i8=1,nbpDf
         del8=betD1(i8,iclegy,iclp)
c         alp8=betDp1(i8,iclegy,iclp)-alppar
	 rh8=delD1(i8,iclegy,iclp)
	 rh=1./(1./rh1+1./rh2+1./rh3+1./rh8+1./rh45)

	 dps5=dps5+alpD1(i4,iclegy,iclp)*alpD1(i5,iclegy,iclp)
     *   *alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   *alpD1(i3,iclegy,iclp)*alpD1(i8,iclegy,iclp)
     *   *alpD2(i6,iclegy)
     *   *coefu6(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)
     *   +nbpDf*nbpDf*nbpDf*(i4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(i5-1)
     *   +nbpDf*nbpDf*nbpDf*nbpDf*nbpDf*(i8-1),iclp)
     *   *((dxpomr*ddelx)**(del6-del4-del5)
     *   -ddelx**(del4+del5-del6))/(del4+del5-del6)
     *   /dxpomr**(del1+del2+del3+del8+del6)
     *   /(rh4+rh5)/rh1/rh2/rh3/rh8/rh45*zb**(rp/rh)

         rh=1./(1./rh2+1./rh3+1./rh8+1./rh1456)

	 dps8=dps8+alpD1(i4,iclegy,iclp)*alpD1(i5,iclegy,iclp)
     *   *alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   *alpD1(i3,iclegy,iclp)*alpD1(i8,iclegy,iclp)
     *   *alpD2(i6,iclegy)
     *   *coefu6(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)
     *   +nbpDf*nbpDf*nbpDf*(i4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(i5-1)
     *   +nbpDf*nbpDf*nbpDf*nbpDf*nbpDf*(i8-1),iclp)
     *   *((dxpomr*ddelx)**(del6-del1-del4-del5)
     *   -ddelx**(del1+del4+del5-del6))/(del1+del4+del5-del6)
     *   /dxpomr**(del2+del3+del8+del6)
     *   *rh145/rh1/rh4/rh5/rh1456/rh2/rh3/rh8*zb**(rp/rh)

         rh=1./(1./rh3+1./rh8+1./rh12456)

	 dps10=dps10+alpD1(i4,iclegy,iclp)*alpD1(i5,iclegy,iclp)
     *   *alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   *alpD1(i3,iclegy,iclp)*alpD1(i8,iclegy,iclp)
     *   *alpD2(i6,iclegy)
     *   *coefu6(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)
     *   +nbpDf*nbpDf*nbpDf*(i4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(i5-1)
     *   +nbpDf*nbpDf*nbpDf*nbpDf*nbpDf*(i8-1),iclp)
     *   *((dxpomr*ddelx)**(del6-del1-del2-del4-del5)
     *   -ddelx**(del1+del2+del4+del5-del6))
     *   /(del1+del2+del4+del5-del6)
     *   /dxpomr**(del3+del6+del8)
     *   *rh1245/rh1/rh2/rh4/rh5/rh12456/rh3/rh8*zb**(rp/rh)

         rh12458=1./(1./rh1+1./rh2+1./rh4+1./rh5+1./rh8)
	 rh124568=rh6+rh12458
         rh=1./(1./rh3+1./rh124568)

	 dps11=dps11+alpD1(i4,iclegy,iclp)*alpD1(i5,iclegy,iclp)
     *   *alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   *alpD1(i3,iclegy,iclp)*alpD1(i8,iclegy,iclp)
     *   *alpD2(i6,iclegy)
     *   *coefu6(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)
     *   +nbpDf*nbpDf*nbpDf*(i4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(i5-1)
     *   +nbpDf*nbpDf*nbpDf*nbpDf*nbpDf*(i8-1),iclp)
     *   *((dxpomr*ddelx)**(del6-del1-del2-del4-del5-del8)
     *   -ddelx**(del1+del2+del4+del5+del8-del6))
     *   /(del1+del2+del4+del5+del8-del6)
     *   /dxpomr**(del3+del6)
     *   *rh12458/rh1/rh2/rh4/rh5/rh8/rh124568/rh3*zb**(rp/rh)
       enddo
       enddo
       enddo
       enddo
       enddo
       enddo
       enddo

       fan1=(dps2/2.d0*gamdp(icdpro,iclp)**3
     * -dps3*gam3p/4.d0*gamdp(icdpro,iclp)**4
     * +dps4*gam3p**2/12.d0*gamdp(icdpro,iclp)**5
     * -dps5*gam3p**3/48.d0*gamdp(icdpro,iclp)**6
     * -dps6*gam3p/6.d0*gamdp(icdpro,iclp)**4
     * +dps7*gam3p**2/12.d0*gamdp(icdpro,iclp)**5
     * -dps8*gam3p**3/36.d0*gamdp(icdpro,iclp)**6
     * +dps9*gam3p**2/24.d0*gamdp(icdpro,iclp)**5
     * -dps10*gam3p**3/48.d0*gamdp(icdpro,iclp)**6
     * -dps11*gam3p**3/120.d0*gamdp(icdpro,iclp)**6)*(r3pom*pi/.0389)**2

c       if((zb.eq.1..or.zb.eq..02).and.icdpro.eq.1)
c     * write(*,*)'fan1',fan1
c     * ,+dps2/2.d0*(r3pom*pi/.0389)**2*gamdp(icdpro,iclp)**3
c     * ,-dps3*gam3p/4.d0*(r3pom*pi/.0389)**2*gamdp(icdpro,iclp)**4
c     * ,dps4*gam3p**2/12.d0*(r3pom*pi/.0389)**2*gamdp(icdpro,iclp)**5
c     * ,-dps5*gam3p**3/48.d0*(r3pom*pi/.0389)**2*gamdp(icdpro,iclp)**6
c     * ,-dps6*gam3p/6.d0*(r3pom*pi/.0389)**2*gamdp(icdpro,iclp)**4
c     * ,dps7*gam3p**2/12.d0*(r3pom*pi/.0389)**2*gamdp(icdpro,iclp)**5
c     * ,-dps8*gam3p**3/36.d0*(r3pom*pi/.0389)**2*gamdp(icdpro,iclp)**6
c     * ,dps9*gam3p**2/24.d0*(r3pom*pi/.0389)**2*gamdp(icdpro,iclp)**5
c     * ,-dps10*gam3p**3/48.d0*(r3pom*pi/.0389)**2*gamdp(icdpro,iclp)**6
c     * ,-dps11*gam3p**3/120.d0*(r3pom*pi/.0389)**2*gamdp(icdpro,iclp)**6
      endif
      	
      fan2=0.d0
      if(1./xpomr.gt.delx**3)then
       dps1=0.d0
       dps2=0.d0
       dps3=0.d0
       dps4=0.d0
       dps5=0.d0
       dps6=0.d0
       dps7=0.d0
       dps8=0.d0
       dps9=0.d0
       dps10=0.d0
       do i6=1,nbpDf
         del6=betD2(i6,iclegy)
	 rh6=delD2(i6,iclegy)
       do i7=1,nbpDf
         del7=betD2(i7,iclegy)
	 rh7=delD2(i7,iclegy)
       do i1=1,nbpDf
         del1=betD1(i1,iclegy,iclp)
c         alp1=betDp1(i1,iclegy,iclp)-alppar
	 rh1=delD1(i1,iclegy,iclp)
       do i2=1,nbpDf
         del2=betD1(i2,iclegy,iclp)
c         alp2=betDp1(i2,iclegy,iclp)-alppar
	 rh2=delD1(i2,iclegy,iclp)
       do i3=1,nbpDf
         del3=betD1(i3,iclegy,iclp)
c         alp3=betDp1(i3,iclegy,iclp)-alppar
	 rh3=delD1(i3,iclegy,iclp)
       do i4=1,nbpDf
         del4=betD1(i4,iclegy,iclp)
c         alp4=betDp1(i4,iclegy,iclp)-alppar
	 rh4=delD1(i4,iclegy,iclp)

	 rh126=rh6+rh1*rh2/(rh1+rh2)
	 rh1236=1./(1./rh126+1./rh3)
	 rh=1./(1./(rh7+rh1236)+1./rh4)
	
         dps1=dps1+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   *alpD1(i3,iclegy,iclp)*alpD1(i4,iclegy,iclp)
     *   *alpD2(i6,iclegy)*alpD2(i7,iclegy)
     *   *coefu4(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)
     *   +nbpDf*nbpDf*nbpDf*(i4-1),iclp)
     *   *(((dxpomr*ddelx)**(del7-del1-del2-del3)
     *   -ddelx**(2.d0*(del1+del2+del3-del7)))
     *   /(del1+del2+del3-del7)*ddelx**(del6-del1-del2)
     *   -((dxpomr*ddelx)**(del7-del3-del6)
     *   -ddelx**(2.d0*(del3+del6-del7)))/(del3+del6-del7)
     *   *ddelx**(del1+del2-del6))/(del1+del2-del6)
     *   /dxpomr**(del4+del7)
     *   /(rh1+rh2)/rh4/(rh3+rh126)/(rh7+rh1236)*zb**(rp/rh)

       do i5=1,nbpDf
         del5=betD1(i5,iclegy,iclp)
c         alp5=betDp1(i5,iclegy,iclp)-alppar
	 rh5=delD1(i5,iclegy,iclp)     
	 rh=1./(1./(rh7+rh1236)+1./rh4+1./rh5)
	
         dps2=dps2+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   *alpD1(i3,iclegy,iclp)*alpD1(i4,iclegy,iclp)
     *   *alpD1(i5,iclegy,iclp)*alpD2(i6,iclegy)*alpD2(i7,iclegy)
     *   *coefu5(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)+nbpDf*nbpDf
     *   *nbpDf*(i4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(i5-1),iclp)
     *   *(((dxpomr*ddelx)**(del7-del1-del2-del3)
     *   -ddelx**(2.d0*(del1+del2+del3-del7)))
     *   /(del1+del2+del3-del7)*ddelx**(del6-del1-del2)
     *   -((dxpomr*ddelx)**(del7-del3-del6)
     *   -ddelx**(2.d0*(del3+del6-del7)))/(del3+del6-del7)
     *   *ddelx**(del1+del2-del6))/(del1+del2-del6)
     *   /dxpomr**(del4+del5+del7)
     *   /(rh1+rh2)/rh4/rh5/(rh3+rh126)/(rh7+rh1236)*zb**(rp/rh)

	 rh123=1./(1./rh1+1./rh2+1./rh3)
	 rh1234=1./(1./(rh6+rh123)+1./rh4)
	 rh=1./(1./(rh7+rh1234)+1./rh5)
	
         dps4=dps4+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   *alpD1(i3,iclegy,iclp)*alpD1(i4,iclegy,iclp)
     *   *alpD1(i5,iclegy,iclp)*alpD2(i6,iclegy)*alpD2(i7,iclegy)
     *   *coefu5(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)+nbpDf*nbpDf
     *   *nbpDf*(i4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(i5-1),iclp)
     *   *(((dxpomr*ddelx)**(del7-del1-del2-del3-del4)
     *   -ddelx**(2.d0*(del1+del2+del3+del4-del7)))
     *   /(del1+del2+del3+del4-del7)*ddelx**(del6-del1-del2-del3)
     *   -((dxpomr*ddelx)**(del7-del4-del6)
     *   -ddelx**(2.d0*(del4+del6-del7)))/(del4+del6-del7)
     *   *ddelx**(del1+del2+del3-del6))/(del1+del2+del3-del6)
     *   /dxpomr**(del5+del7)
     *   *rh123/rh1/rh2/rh3/rh5/(rh4+rh6+rh123)/(rh7+rh1234)
     *   *zb**(rp/rh)

	 rh12346=1./(1./rh126+1./rh3+1./rh4)
	 rh=1./(1./(rh7+rh12346)+1./rh5)
	
         dps6=dps6+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   *alpD1(i3,iclegy,iclp)*alpD1(i4,iclegy,iclp)
     *   *alpD1(i5,iclegy,iclp)*alpD2(i6,iclegy)*alpD2(i7,iclegy)
     *   *coefu5(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)+nbpDf*nbpDf
     *   *nbpDf*(i4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(i5-1),iclp)
     *   *(((dxpomr*ddelx)**(del7-del1-del2-del3-del4)
     *   -ddelx**(2.d0*(del1+del2+del3+del4-del7)))
     *   /(del1+del2+del3+del4-del7)*ddelx**(del6-del1-del2)
     *   -((dxpomr*ddelx)**(del7-del3-del4-del6)
     *   -ddelx**(2.d0*(del3+del4+del6-del7)))/(del3+del4+del6-del7)
     *   *ddelx**(del1+del2-del6))/(del1+del2-del6)
     *   /dxpomr**(del5+del7)
     *   /(rh1+rh2)/rh3/rh4/rh126*rh12346/(rh7+rh12346)/rh5
     *   *zb**(rp/rh)

       do i9=1,nbpDf
         del9=betD1(i9,iclegy,iclp)
c         alp9=betDp1(i9,iclegy,iclp)-alppar
	 rh9=delD1(i9,iclegy,iclp)
	 rh=1./(1./(rh7+rh1236)+1./rh4+1./rh5+1./rh9)
	
         dps3=dps3+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   *alpD1(i3,iclegy,iclp)*alpD1(i4,iclegy,iclp)
     *   *alpD1(i5,iclegy,iclp)*alpD1(i9,iclegy,iclp)
     *   *alpD2(i6,iclegy)*alpD2(i7,iclegy)
     *   *coefu6(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)
     *   +nbpDf*nbpDf*nbpDf*(i4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(i5-1)
     *   +nbpDf*nbpDf*nbpDf*nbpDf*nbpDf*(i9-1),iclp)
     *   *(((dxpomr*ddelx)**(del7-del1-del2-del3)
     *   -ddelx**(2.d0*(del1+del2+del3-del7)))
     *   /(del1+del2+del3-del7)*ddelx**(del6-del1-del2)
     *   -((dxpomr*ddelx)**(del7-del3-del6)
     *   -ddelx**(2.d0*(del3+del6-del7)))/(del3+del6-del7)
     *   *ddelx**(del1+del2-del6))/(del1+del2-del6)
     *   /dxpomr**(del4+del5+del7+del9)
     *   /(rh1+rh2)/rh4/rh5/rh9/(rh3+rh126)/(rh7+rh1236)*zb**(rp/rh)

	 rh=1./(1./(rh7+rh1234)+1./rh5+1./rh9)
	
         dps5=dps5+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   *alpD1(i3,iclegy,iclp)*alpD1(i4,iclegy,iclp)
     *   *alpD1(i5,iclegy,iclp)*alpD1(i9,iclegy,iclp)
     *   *alpD2(i6,iclegy)*alpD2(i7,iclegy)
     *   *coefu6(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)
     *   +nbpDf*nbpDf*nbpDf*(i4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(i5-1)
     *   +nbpDf*nbpDf*nbpDf*nbpDf*nbpDf*(i9-1),iclp)
     *   *(((dxpomr*ddelx)**(del7-del1-del2-del3-del4)
     *   -ddelx**(2.d0*(del1+del2+del3+del4-del7)))
     *   /(del1+del2+del3+del4-del7)*ddelx**(del6-del1-del2-del3)
     *   -((dxpomr*ddelx)**(del7-del4-del6)
     *   -ddelx**(2.d0*(del4+del6-del7)))/(del4+del6-del7)
     *   *ddelx**(del1+del2+del3-del6))/(del1+del2+del3-del6)
     *   /dxpomr**(del5+del7+del9)
     *   *rh123/rh1/rh2/rh3/rh5/rh9/(rh4+rh6+rh123)/(rh7+rh1234)
     *   *zb**(rp/rh)

	 rh=1./(1./(rh7+rh12346)+1./rh5+1./rh9)
	
         dps7=dps7+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   *alpD1(i3,iclegy,iclp)*alpD1(i4,iclegy,iclp)
     *   *alpD1(i5,iclegy,iclp)*alpD1(i9,iclegy,iclp)
     *   *alpD2(i6,iclegy)*alpD2(i7,iclegy)
     *   *coefu6(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)
     *   +nbpDf*nbpDf*nbpDf*(i4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(i5-1)
     *   +nbpDf*nbpDf*nbpDf*nbpDf*nbpDf*(i9-1),iclp)
     *   *(((dxpomr*ddelx)**(del7-del1-del2-del3-del4)
     *   -ddelx**(2.d0*(del1+del2+del3+del4-del7)))
     *   /(del1+del2+del3+del4-del7)*ddelx**(del6-del1-del2)
     *   -((dxpomr*ddelx)**(del7-del3-del4-del6)
     *   -ddelx**(2.d0*(del3+del4+del6-del7)))/(del3+del4+del6-del7)
     *   *ddelx**(del1+del2-del6))/(del1+del2-del6)
     *   /dxpomr**(del5+del7+del9)
     *   /(rh1+rh2)/rh3/rh4/rh5/rh9/rh126*rh12346/(rh7+rh12346)
     *   *zb**(rp/rh)

	 rh1239=1./(1./rh1+1./rh2+1./rh3+1./rh9)
	 rh12349=1./(1./(rh6+rh1239)+1./rh4)
	 rh=1./(1./(rh7+rh12349)+1./rh5)
	
         dps8=dps8+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   *alpD1(i3,iclegy,iclp)*alpD1(i4,iclegy,iclp)
     *   *alpD1(i5,iclegy,iclp)*alpD1(i9,iclegy,iclp)
     *   *alpD2(i6,iclegy)*alpD2(i7,iclegy)
     *   *coefu6(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)
     *   +nbpDf*nbpDf*nbpDf*(i4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(i5-1)
     *   +nbpDf*nbpDf*nbpDf*nbpDf*nbpDf*(i9-1),iclp)
     *   *(((dxpomr*ddelx)**(del7-del1-del2-del3-del4-del9)
     *   -ddelx**(2.d0*(del1+del2+del3+del4+del9-del7)))
     *   /(del1+del2+del3+del4+del9-del7)
     *   *ddelx**(del6-del1-del2-del3-del9)
     *   -((dxpomr*ddelx)**(del7-del4-del6)
     *   -ddelx**(2.d0*(del4+del6-del7)))/(del4+del6-del7)
     *   *ddelx**(del1+del2+del3+del9-del6))
     *   /(del1+del2+del3+del9-del6)
     *   /dxpomr**(del5+del7)
     *   *rh1239/rh1/rh2/rh3/rh9/rh5/(rh4+rh6+rh1239)/(rh7+rh12349)
     *   *zb**(rp/rh)

	 rh123469=1./(1./(rh6+rh123)+1./rh4+1./rh9)
	 rh=1./(1./(rh7+rh123469)+1./rh5)
	
         dps9=dps9+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   *alpD1(i3,iclegy,iclp)*alpD1(i4,iclegy,iclp)
     *   *alpD1(i5,iclegy,iclp)*alpD1(i9,iclegy,iclp)
     *   *alpD2(i6,iclegy)*alpD2(i7,iclegy)
     *   *coefu6(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)
     *   +nbpDf*nbpDf*nbpDf*(i4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(i5-1)
     *   +nbpDf*nbpDf*nbpDf*nbpDf*nbpDf*(i9-1),iclp)
     *   *(((dxpomr*ddelx)**(del7-del1-del2-del3-del4-del9)
     *   -ddelx**(2.d0*(del1+del2+del3+del4+del9-del7)))
     *   /(del1+del2+del3+del4+del9-del7)*ddelx**(del6-del1-del2-del3)
     *   -((dxpomr*ddelx)**(del7-del4-del6-del9)
     *   -ddelx**(2.d0*(del4+del6+del9-del7)))/(del4+del6+del9-del7)
     *   *ddelx**(del1+del2+del3-del6))/(del1+del2+del3-del6)
     *   /dxpomr**(del5+del7)
     *   *rh123/rh1/rh2/rh3/rh4/rh9/(rh6+rh123)*rh123469/rh5
     *   /(rh7+rh123469)*zb**(rp/rh)

	 rh1234690=1./(1./rh126+1./rh3+1./rh4+1./rh9)
	 rh=1./(1./(rh7+rh1234690)+1./rh5)
	
         dps10=dps10+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *   *alpD1(i3,iclegy,iclp)*alpD1(i4,iclegy,iclp)
     *   *alpD1(i5,iclegy,iclp)*alpD1(i9,iclegy,iclp)
     *   *alpD2(i6,iclegy)*alpD2(i7,iclegy)
     *   *coefu6(i1+nbpDf*(i2-1)+nbpDf*nbpDf*(i3-1)
     *   +nbpDf*nbpDf*nbpDf*(i4-1)+nbpDf*nbpDf*nbpDf*nbpDf*(i5-1)
     *   +nbpDf*nbpDf*nbpDf*nbpDf*nbpDf*(i9-1),iclp)
     *   *(((dxpomr*ddelx)**(del7-del1-del2-del3-del4-del9)
     *   -ddelx**(2.d0*(del1+del2+del3+del4+del9-del7)))
     *   /(del1+del2+del3+del4+del9-del7)*ddelx**(del6-del1-del2)
     *   -((dxpomr*ddelx)**(del7-del3-del4-del6-del9)
     *   -ddelx**(2.d0*(del3+del4+del6+del9-del7)))
     *   /(del3+del4+del6+del9-del7)
     *   *ddelx**(del1+del2-del6))/(del1+del2-del6)
     *   /dxpomr**(del5+del7)
     *   /(rh1+rh2)/rh3/rh4/rh9/rh126*rh1234690/(rh7+rh1234690)/rh5
     *   *zb**(rp/rh)
       enddo
       enddo
       enddo
       enddo
       enddo
       enddo
       enddo
       enddo

       fan2=(-dps1/2.d0*gamdp(icdpro,iclp)**4
     * +dps2*gam3p/4.d0*gamdp(icdpro,iclp)**5
     * -dps3*gam3p**2/12.d0*gamdp(icdpro,iclp)**6
     * +dps4*gam3p/6.d0*gamdp(icdpro,iclp)**5
     * -dps5*gam3p**2/12.d0*gamdp(icdpro,iclp)**6
     * +dps6*gam3p/4.d0*gamdp(icdpro,iclp)**5
     * -dps7*gam3p**2/8.d0*gamdp(icdpro,iclp)**6
     * -dps8*gam3p**2/24.d0*gamdp(icdpro,iclp)**6
     * -dps9*gam3p**2/12.d0*gamdp(icdpro,iclp)**6
     * -dps10*gam3p**2/12.d0*gamdp(icdpro,iclp)**6)*(r3pom*pi/.0389)**3

c       if((zb.eq.1..or.zb.eq..02).and.icdpro.eq.1)
c     * write(*,*)'fan2',fan2
c     * ,-dps1/2.d0*(r3pom*pi/.0389)**3*gamdp(icdpro,iclp)**4
c     * ,dps2*gam3p/4.d0*(r3pom*pi/.0389)**3*gamdp(icdpro,iclp)**5
c     * ,-dps3*gam3p**2/12.d0*(r3pom*pi/.0389)**3*gamdp(icdpro,iclp)**6
c     * ,dps4*gam3p/6.d0*(r3pom*pi/.0389)**3*gamdp(icdpro,iclp)**5
c     * ,-dps5*gam3p**2/12.d0*(r3pom*pi/.0389)**3*gamdp(icdpro,iclp)**6
c     * ,dps6*gam3p/4.d0*(r3pom*pi/.0389)**3*gamdp(icdpro,iclp)**5
c     * ,-dps7*gam3p**2/8.d0*(r3pom*pi/.0389)**3*gamdp(icdpro,iclp)**6
c     * ,-dps8*gam3p**2/24.d0*(r3pom*pi/.0389)**3*gamdp(icdpro,iclp)**6
c     * ,-dps9*gam3p**2/12.d0*(r3pom*pi/.0389)**3*gamdp(icdpro,iclp)**6
c     * ,-dps10*gam3p**2/12.d0*(r3pom*pi/.0389)**3*gamdp(icdpro,iclp)**6
      endif
      
      psfro=fan0+fan1+fan2
      iclegy=iclegys
      return
      end
                       
c------------------------------------------------------------------------
      function psv2(xpomr,zb,iclp,iqq)
c-----------------------------------------------------------------------
c psv2 - 2-pom contribution to the froissaron 
c xpomr - lc+ for the vertex,
c zb    - impact parameter factor, z=exp(-b**2/4*rp),
c------------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      double precision dxpomr,del1,del2,dps
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar7/ delx,alam3p,gam3p
ctp060202 to avoid warnings with gfortran compilation
      logical ctp060202
      ctp060202=.false.
      if(ctp060202)write(*,*)iqq
ctp060202 end
      
      psv2=0.
      iclegys=iclegy
      if(1./xpomr.lt..999*delx)return
      
      rp=(r2had(iclp)+.5*alam3p-slopom*log(xpomr))*4.*.0389
      dxpomr=dble(xpomr)
      iclegy=iclegy2

      dps=0.d0
      do i1=1,nbpDf
        del1=betD1(i1,iclegy,iclp)
c        alp1=betDp1(i1,iclegy,iclp)-alppar
        rh1=delD1(i1,iclegy,iclp)
      do i2=1,nbpDf
        del2=betD1(i2,iclegy,iclp)
c        alp2=betDp1(i2,iclegy,iclp)-alppar
        rh2=delD1(i2,iclegy,iclp)
        rh=rh1*rh2/(rh1+rh2)
	
        dps=dps+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *  *pscoefi(xpomr,i1,i2,iclp,2)
     *  /dxpomr**(del1+del2)/rh1/rh2*zb**(rp/rh)
      enddo
      enddo
      psv2=-dps/2.
      iclegy=iclegys
      return
      end
           
c------------------------------------------------------------------------
      function psvfro(xpp,xpr,xpomr,zb,iclp,icdpro,iqq)
c-----------------------------------------------------------------------
c psvfro - effective froissaron contributions
c xpomr - lc+ for the vertex,
c zb    - impact parameter factor, z=exp(-b**2/4*rp),
c iqq=0 - total uncut
c iqq=1 - total 1-cut
c iqq=2 - total 2-cut
c iqq=3 - soft 1-cut
c iqq=4 - gg 1-cut
c iqq=5 - qg 1-cut
c iqq=6 - difr
c------------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      double precision dxpp,dxpr,dxpomr,del1,del2,dps
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar7/ delx,alam3p,gam3p
      
      psvfro=0.
      iclegys=iclegy
      if(1./xpomr.lt..999*delx)return
      
      rp=(r2had(iclp)+.5*alam3p-slopom*log(xpomr))*4.*.0389
      dxpp=dble(xpp)
      dxpr=dble(xpr)
      dxpomr=dble(xpomr)
      iclegy=iclegy2
      
      dps=0.d0
      if(iqq.eq.0)then
       if(xpr.le.2.*xpomr)return
       do i1=1,nbpDf
        del1=betD1(i1,iclegy,iclp)
        alp1=betDp1(i1,iclegy,iclp)-alppar
        rh1=delD1(i1,iclegy,iclp)
       do i2=1,nbpDf
        del2=betD1(i2,iclegy,iclp)
        alp2=betDp1(i2,iclegy,iclp)-alppar
        rh2=delD1(i2,iclegy,iclp)
	rh=rh1*rh2/(rh1+rh2)
	
	dps=dps+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *  *pscoefi(xpomr/xpr,i1,i2,iclp,2)
     *  /dxpomr**(del1+del2)*dxpr**(2.d0+del1+del2+alp1+alp2) 
     *  /rh1/rh2*zb**(rp/rh)
       enddo
       enddo
       dps=-dps/2.d0
             
      elseif(iqq.eq.6)then
       if((xpr+xpomr).le.2.*xpomr)return
       do i1=1,nbpDf
        del1=betD1(i1,iclegy,iclp)
        alp1=betDp1(i1,iclegy,iclp)-alppar
        rh1=delD1(i1,iclegy,iclp)
       do i2=1,nbpDf
        del2=betD1(i2,iclegy,iclp)
        alp2=betDp1(i2,iclegy,iclp)-alppar
        rh2=delD1(i2,iclegy,iclp)
	rh=rh1*rh2/(rh1+rh2)
	
	dps=dps+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *  /dxpomr**(del1+del2)*(dxpr+dxpomr)**(2.d0+del1+del2+alp1+alp2) 
     *  *pscoefi(xpomr/(xpr+xpomr),i1,i2,iclp,2)
     *  /rh1/rh2*zb**(rp/rh)	
       enddo
       enddo
       dps=dps*(1.+dxpomr/dxpr)**alplea(iclp) /8.d0  !/2.d0
       
      elseif(iqq.eq.1)then
       if(min(xpp,xpr).le.xpomr)return
       do i2=1,nbpDf
        del2=betD1(i2,iclegy,iclp)
        alp2=betDp1(i2,iclegy,iclp)-alppar
        rh2=delD1(i2,iclegy,iclp)
	coef=pscoefi(xpomr/xpr,i2,0,iclp,1)
       do i1=1,nbpDf
        del1=betD1(i1,iclegy,iclp)
        alp1=betDp1(i1,iclegy,iclp)-alppar
        rh1=delD1(i1,iclegy,iclp)
	rh=rh1*rh2/(rh1+rh2)
	
	dps=dps+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)*coef
     *  /dxpomr**(del1+del2)*dxpp**(del1+alp1)*dxpr**(1.d0+del2+alp2)
     *  /rh1/rh2*zb**(rp/rh)		
       enddo
       enddo
       dps=-dps *1.25d0  !*2.d0
       
      elseif(iqq.eq.2)then
       if(xpp.le.2.*xpomr)return
       do i1=1,nbpDf
        del1=betD1(i1,iclegy,iclp)
        alp1=betDp1(i1,iclegy,iclp)-alppar
        rh1=delD1(i1,iclegy,iclp)
       do i2=1,nbpDf
        del2=betD1(i2,iclegy,iclp)
        alp2=betDp1(i2,iclegy,iclp)-alppar
        rh2=delD1(i2,iclegy,iclp)
	rh=rh1*rh2/(rh1+rh2)
	
	dps=dps+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *  *pscoefi(xpomr/xpp,i1,i2,iclp,0)
     *  /dxpomr**(del1+del2)*dxpp**(1.d0+del1+del2+alp1+alp2)
     *  /rh1/rh2*zb**(rp/rh)
       enddo
       enddo
       dps=dps *.625d0   !
       
      elseif(iqq.le.5)then
       if(min(xpp,xpr).le.xpomr)return
       do i2=1,nbpDf
        del2=betD1(i2,iclegy,iclp)
        alp2=betDp1(i2,iclegy,iclp)-alppar
        rh2=delD1(i2,iclegy,iclp)
	
	dps=dps+alpD1(i2,iclegy,iclp)
     *  /dxpomr**del2*dxpr**(1.d0+del2+alp2)
     *  *pscoefi(xpomr/xpr,i2,0,iclp,1)
     *  /rh2*zb**(rp/rh2)	
       enddo
       dps=-dps  *1.25d0  !*2.d0
       
       sy=xpp/xpomr
       if(iqq.eq.3)then
        rh=r2had(iclp)+.5*alam3p+slopom*log(max(1.,sy))
        dps=dps*chad(iclp)*gamhad(iclp)*sy**dels
     *  *dxpp**(-alppar)*zb**(rp/rh/4./.0389)/rh
       else
        rh=(r2had(iclp)+r2had(icltar)+slopom*log(max(1.,sy)))*4.*.0389
        z=zb**(rp/rh)
	iclps=iclpro
	iclpro=iclp
        if(iqq.eq.4)then
         dps=dps*psvin(sy,xpp,1.,z,16)
        elseif(iqq.eq.5)then
         dps=dps*psvin(sy,xpp,1.,z,18)
        endif      
	iclpro=iclps
       endif      
      else
       stop'psvfro-wrong iqq!!!'
      endif
      psvfro=dps*psfroin(xpomr,zb,iclp,icdpro)
      iclegy=iclegys
      return
      end
          
c------------------------------------------------------------------------
      function psfroin(xpomr,z,iclp,icdpro)
c-----------------------------------------------------------------------
c psfroin - interpolation of effective froissaron corrections
c xpomr - lc+ for the 3p-vertex,
c z   - impact parameter factor, z=exp(-b**2/4*rp),
c-----------------------------------------------------------------------
      dimension wk(3),wz(3)
      common /psar7/  delx,alam3p,gam3p
      common /psar38/ vfro(11,14,3,2)
      
      psfroin=0.
      if(xpomr*delx.gt.1.)return
 
      if(z.gt..1)then
	zz=10.*z+4
      else
	zz=50.*z
      endif
      jz=min(12,int(zz))
      if(jz.eq.0)jz=1
      if(jz.eq.4)jz=3
      wz(2)=zz-jz
      wz(3)=wz(2)*(wz(2)-1.)*.5
      wz(1)=1.-wz(2)+wz(3)
      wz(2)=wz(2)-2.*wz(3)

      yl=log(xpomr*delx)/log(1.e-6*delx)*10.+1
      k=max(1,int(yl))
      k=min(k,9)    
      wk(2)=yl-k
      wk(3)=wk(2)*(wk(2)-1.)*.5
      wk(1)=1.-wk(2)+wk(3)
      wk(2)=wk(2)-2.*wk(3)
      do l1=1,3
      do k1=1,3
        k2=k+k1-1
        l2=jz+l1-1
        psfroin=psfroin+vfro(k2,l2,iclp,icdpro)*wk(k1)*wz(l1)
      enddo
      enddo
      psfroin=exp(psfroin)
      return 
      end
          
c------------------------------------------------------------------------
      function psvnorm(b)
c-----------------------------------------------------------------------
c psvnorm - X-contribution normalization
c b   - impact parameter
c-----------------------------------------------------------------------
      dimension wk(3),wz(3)
      common /psar7/  delx,alam3p,gam3p
      common /psar39/ vnorm(11,14,3,2,2)
      include 'nexus.inc'
      include 'nexus.incsem'
      
      psvnorm=0.
      if(engy.le.delx)return
 
      rp=r2had(iclpro)+r2had(icltar)+slopom*log(max(1.,engy**2))
      z=exp(-b**2/(4.*.0389*rp))
      if(z.gt..1)then
	zz=10.*z+4
      else
	zz=50.*z
      endif
      jz=min(12,int(zz))
      if(jz.eq.0)jz=1
      if(jz.eq.4)jz=3
      wz(2)=zz-jz
      wz(3)=wz(2)*(wz(2)-1.)*.5
      wz(1)=1.-wz(2)+wz(3)
      wz(2)=wz(2)-2.*wz(3)

      yl=log(engy/delx/2.)/log(5.e3/delx)*10.+1
      k=max(1,int(yl))
      k=min(k,9)    
      wk(2)=yl-k
      wk(3)=wk(2)*(wk(2)-1.)*.5
      wk(1)=1.-wk(2)+wk(3)
      wk(2)=wk(2)-2.*wk(3)
      do l1=1,3
      do k1=1,3
        k2=k+k1-1
        l2=jz+l1-1
        psvnorm=psvnorm+vnorm(k2,l2,iclpro,icdp,icdt)*wk(k1)*wz(l1)
      enddo
      enddo
      psvnorm=exp(psvnorm)
      return 
      end
                    
c------------------------------------------------------------------------
      function psvy(xpp0,xpr0,xpm0,xmr0,b,iqq)
c-----------------------------------------------------------------------
c psvy - 3p-contributions to the interaction eikonal
c xpp - lc+ for the pomeron,
c xpr - lc+ for the remnant,
c xpm - lc- for the pomeron,
c xpr - lc- for the remnant,
c b   - impact parameter,
c iqq=1  - Y-proj-uncut
c iqq=2  - Y-proj-1-cut
c iqq=3  - Y-proj-2-cut
c iqq=4  - Y-proj-soft-cut
c iqq=5  - Y-proj-gss-cut
c iqq=6  - Y-proj-qss-cut
c iqq=7  - Y-proj-ssg-cut
c iqq=8  - Y-proj-ssq-cut
c iqq=9  - Y-proj-difr
c iqq=-1 - Y-targ-uncut
c iqq=-2 - Y-targ-1-cut
c iqq=-3 - Y-targ-2-cut
c iqq=-4 - Y-targ-soft-cut
c iqq=-5 - Y-targ-gss-cut
c iqq=-6 - Y-targ-qss-cut
c iqq=-7 - Y-targ-ssg-cut
c iqq=-8 - Y-targ-ssq-cut
c iqq=-9 - Y-targ-difr
c------------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      double precision v3p1,dps
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar7/ delx,alam3p,gam3p
      common /ar9/   x9(3),a9(3)
      common /ar4/   x4(2),a4(2)
      
      psvy=0. 
      iclegys=iclegy
      if(engy.lt.delx)return
      
      iclegy=iclegy2      
      if(iqq.gt.0)then
        xpp=xpp0
        xpr=xpr0
        xpm=xpm0
        xmr=xmr0
	iclp=iclpro
	iclt=icltar
	icdpro=icdp
	icdtar=icdt
        iqqa=iqq
      else
        xpm=xpp0
        xmr=xpr0
        xpp=xpm0
        xpr=xmr0
	iclt=iclpro
	iclp=icltar
	icdtar=icdp
	icdpro=icdt
        iqqa=-iqq
      endif

      v3p1=0.d0
      if(iqqa.eq.1)then
       if(xpr*xmr*engy**2.le.2..or.xpr.le.2.*delx/engy**2
     * .or.xmr.le.delx/engy**2)return
       xpmin=max(1./xmr,delx)/engy**2
       xpmax=min(xpr/2.,1./delx)
       
       rp=(r2had(iclpro)+r2had(icltar)+slopom
     * *log(max(1.,engy**2*xpr*xmr)))*4.*.0389
       do ix1=1,2
       do mx1=1,2
        xpomr=(xpmin/xpmax)**(.5+x4(ix1)*(mx1-1.5))*xpmax
	
       do ib1=1,2
       do mb1=1,2
        z=.5+x4(ib1)*(mb1-1.5)
        b1=sqrt(-rp/4.*log(z))
        dbb=b1**2+.25*b**2
       do ib2=1,2
       do mb2=1,2
        phi=pi*(.5+x4(ib2)*(mb2-1.5))
	bb1=dbb+b*b1*cos(phi)
	bb2=2.*dbb-bb1
	
        rp1=(r2had(iclp)+.5*alam3p-slopom*log(xpomr))*4.*.0389
        zb1=exp(-bb1/rp1)
	    
	dps=0.d0
        do i1=1,nbpDf
          del1=betD1(i1,iclegy,iclt)
          alp1=betDp1(i1,iclegy,iclt)-alppar
          rh1=delD1(i1,iclegy,iclt)

          dps=dps+alpD1(i1,iclegy,iclt)
     *    *pscoefi(1./xpomr/xmr/engy**2,i1,0,iclt,1)
     *    *(xpomr*engy**2)**del1*xmr**(1.+del1+alp1)
     *    /rh1*exp(-bb2/rh1)
        enddo
      
	v3p1=v3p1+a4(ib1)*a4(ib2)*a4(ix1)/z
     *  *psvfro(xpp,xpr,xpomr,zb1,iclp,icdpro,0)*dps
       enddo
       enddo
       enddo
       enddo
       enddo
       enddo
       psvy=v3p1*rp/32.d0*log(xpmax/xpmin)

      elseif(iqqa.le.3)then
       if(iqqa.eq.2.and.(min(xpp,xpr)*xpm*engy**2.le.1.
     * .or.min(xpp,xpr).le.delx/engy**2)
     * .or.iqqa.eq.3.and.(xpp*xpm*engy**2.le.2.
     * .or.xpp.le.2.*delx/engy**2).or.xpm.le.delx/engy**2)return
       xpmin=max(1./xpm,delx)/engy**2
       if(iqqa.eq.2)then
         xpmax=min(min(xpp,xpr),1./delx)
       else
         xpmax=min(xpp/2.,1./delx)
       endif
       
       rp=(r2had(iclpro)+r2had(icltar)+slopom
     * *log(max(1.,engy**2*xpp*xpm)))*4.*.0389

       do ix1=1,2
       do mx1=1,2
        xpomr=(xpmin/xpmax)**(.5+x4(ix1)*(mx1-1.5))*xpmax
	
       do ib1=1,2
       do mb1=1,2
        z=.5+x4(ib1)*(mb1-1.5)
        b1=sqrt(-rp/4.*log(z))
        dbb=b1**2+.25*b**2
       do ib2=1,2
       do mb2=1,2
        phi=pi*(.5+x4(ib2)*(mb2-1.5))
	bb1=dbb+b*b1*cos(phi)
	bb2=2.*dbb-bb1
	
        rp1=(r2had(iclp)+.5*alam3p-slopom*log(xpomr))*4.*.0389
        zb1=exp(-bb1/rp1)
	    
	dps=0.d0
        do i1=1,nbpDf
          del1=betD1(i1,iclegy,iclt)
          alp1=betDp1(i1,iclegy,iclt)-alppar
          rh1=delD1(i1,iclegy,iclt)

          dps=dps+alpD1(i1,iclegy,iclt)
     *    *(xpomr*engy**2)**del1*xpm**(del1+alp1)
     *    /rh1*exp(-bb2/rh1)
        enddo
      
	v3p1=v3p1+a4(ib1)*a4(ib2)*a4(ix1)/z
     *  *psvfro(xpp,xpr,xpomr,zb1,iclp,icdpro,iqqa-1)*dps
       enddo
       enddo
       enddo
       enddo
       enddo
       enddo
       psvy=v3p1*rp/32.d0*log(xpmax/xpmin)

      elseif(iqqa.le.6)then
       if(min(xpp,xpr)*xpm*engy**2.le.1.
     * .or.min(xpp,xpr).le.delx/engy**2
     * .or.xpm.le.delx/engy**2)return
       xpmin=max(1./xpm,delx)/engy**2
       xpmax=min(min(xpp,xpr),1./delx)
       
       rp=(r2had(iclpro)+r2had(icltar)+slopom
     * *log(max(1.,engy**2*xpp*xpm)))*4.*.0389
       do ix1=1,2
       do mx1=1,2
        xpomr=(xpmin/xpmax)**(.5+x4(ix1)*(mx1-1.5))*xpmax
	
       do ib1=1,2
       do mb1=1,2
        z=.5+x4(ib1)*(mb1-1.5)
        b1=sqrt(-rp/4.*log(z))
        dbb=b1**2+.25*b**2
       do ib2=1,2
       do mb2=1,2
        phi=pi*(.5+x4(ib2)*(mb2-1.5))
	bb1=dbb+b*b1*cos(phi)
	bb2=2.*dbb-bb1
	
        rp1=(r2had(iclp)+.5*alam3p-slopom*log(xpomr))*4.*.0389
        zb1=exp(-bb1/rp1)
	    
        rh=r2had(iclt)+.5*alam3p+slopom*log(max(1.,xpomr*xpm*engy**2))
        dps=chad(iclt)*gamhad(iclt)*(xpomr*xpm*engy**2)**dels
     *  *xpm**(-alppar)*exp(-bb2/rh/4./.0389)/rh

	v3p1=v3p1+a4(ib1)*a4(ib2)*a4(ix1)/z
     *  *psvfro(xpp,xpr,xpomr,zb1,iclp,icdpro,iqqa-1)*dps
       enddo
       enddo
       enddo
       enddo
       enddo
       enddo
       psvy=v3p1*rp/32.d0*log(xpmax/xpmin)

      elseif(iqqa.le.8)then
       if(min(xpp,xpr)*xpm*engy**2.le.1.
     * .or.min(xpp,xpr).le.delx/engy**2
     * .or.xpm.le.delx/engy**2)return
       xpmin=max(1./xpm,delx)/engy**2
       xpmax=min(min(xpp,xpr),1./delx)
       
       rp=(r2had(iclpro)+r2had(icltar)+slopom
     * *log(max(1.,engy**2*xpp*xpm)))*4.*.0389
       do ix1=1,2
       do mx1=1,2
        xpomr=(xpmin/xpmax)**(.5+x4(ix1)*(mx1-1.5))*xpmax
	
       do ib1=1,2
       do mb1=1,2
        z=.5+x4(ib1)*(mb1-1.5)
        b1=sqrt(-rp/4.*log(z))
        dbb=b1**2+.25*b**2
       do ib2=1,2
       do mb2=1,2
        phi=pi*(.5+x4(ib2)*(mb2-1.5))
	bb1=dbb+b*b1*cos(phi)
	bb2=2.*dbb-bb1
	
        rp1=(r2had(iclp)+.5*alam3p-slopom*log(xpomr))*4.*.0389
        zb1=exp(-bb1/rp1)
	    
	sy=xpomr*xpm*engy**2
        rp2=(r2had(iclt)+r2had(icltar)+slopom*log(max(1.,sy)))*4.*.0389
        zb2=exp(-bb2/rp2)
	iclps=iclpro
	iclpro=iclt
        if(iqqa.eq.7)then
          dps=psvin(sy,xpm,1.,zb2,16)
        elseif(iqqa.eq.8)then
          dps=psvin(sy,xpm,1.,zb2,18)
        endif      
	iclpro=iclps

	v3p1=v3p1+a4(ib1)*a4(ib2)*a4(ix1)/z
     *  *psvfro(xpp,xpr,xpomr,zb1,iclp,icdpro,3)*dps
       enddo
       enddo
       enddo
       enddo
       enddo
       enddo
       psvy=v3p1*rp/32.d0*log(xpmax/xpmin)

      elseif(iqqa.eq.9)then
       if(xpp.ge.min((xpr+xpp)/2.,1./delx)
     * .or.xpp.le.max(1./xpm,delx)/engy**2)return

       rp=(r2had(iclpro)+r2had(icltar)+slopom
     * *log(max(1.,engy**2*(xpr+xpp)*xpm)))*4.*.0389

       do ib1=1,2
       do mb1=1,2
        z=.5+x4(ib1)*(mb1-1.5)
        b1=sqrt(-rp/4.*log(z))
        dbb=b1**2+.25*b**2
       do ib2=1,2
       do mb2=1,2
        phi=pi*(.5+x4(ib2)*(mb2-1.5))
	bb1=dbb+b*b1*cos(phi)
	bb2=2.*dbb-bb1
	
        rp1=(r2had(iclp)+.5*alam3p-slopom*log(xpp))*4.*.0389
        zb1=exp(-bb1/rp1)
	    
	dps=0.d0
        do i1=1,nbpDf
          del1=betD1(i1,iclegy,iclt)
          alp1=betDp1(i1,iclegy,iclt)-alppar
          rh1=delD1(i1,iclegy,iclt)

          dps=dps+alpD1(i1,iclegy,iclt)
     *    *(xpp*engy**2)**del1*xpm**(del1+alp1)
     *    /rh1*exp(-bb2/rh1)
        enddo
      
	v3p1=v3p1+a4(ib1)*a4(ib2)/z
     *  *psvfro(xpp,xpr,xpp,zb1,iclp,icdpro,6)*dps
       enddo
       enddo
       enddo
       enddo
       psvy=v3p1/xpp*rp/16.d0
      else
       stop'psvy-wrong iqq!!!'
      endif
      psvy=psvy*gamdt(icdtar,iclt)
      iclegy=iclegys
      return 
      end
             
c------------------------------------------------------------------------
      function psvx(xpp,xpr,xpm,xmr,b,iqq)
c-----------------------------------------------------------------------
c psvx - 4p-contributions to the interaction eikonal
c xpp - lc+ for the pomeron,
c xpr - lc+ for the remnant,
c xpm - lc- for the pomeron,
c xpr - lc- for the remnant,
c b   - impact parameter,
c iqq=0  - X-uncut
c iqq=1  - X-1-cut
c iqq=2  - X-Y+cut
c iqq=-2 - X-Y-cut
c iqq=3  - X-1-cut-soft
c iqq=4  - X-1-cut-gss
c iqq=-4 - X-1-cut-gss
c iqq=5  - X-1-cut-qss
c iqq=-5 - X-1-cut-qss
c iqq=6  - X-difr+
c iqq=-6 - X-difr-
c------------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      double precision dsy,dxpp,dxpr,dxpm,dxmr,ddelx,v3p1,dxpomr
     *,xpmin,xpmax
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar6/  coefu1(nbpDf,nclha)
     *,coefu2(nbpDf*nbpDf,nclha)
     *,coefu3(nbpDf*nbpDf*nbpDf,nclha)
     *,coefu4(nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefu5(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefu6(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefc2(nbpDf*nbpDf,nclha)
     *,coefc3(nbpDf*nbpDf*nbpDf,nclha)
     *,coefc4(nbpDf*nbpDf*nbpDf*nbpDf,nclha)
     *,coefc5(nbpDf*nbpDf*nbpDf*nbpDf*nbpDf,nclha)
      common /psar7/ delx,alam3p,gam3p
      common /ar9/   x9(3),a9(3)
      common /ar4/   x4(2),a4(2)
      
      psvx=0. 
      if(engy.lt.delx)return
      
      iclegy=iclegy2  
      dsy=dble(engy)**2    
      ddelx=dble(delx)
      if(iqq.ge.0)then
        dxpp=dble(xpp)
        dxpr=dble(xpr)
        dxpm=dble(xpm)
        dxmr=dble(xmr)
	iclp=iclpro
	iclt=icltar
	icdpro=icdp
	icdtar=icdt
        iqqa=iqq
      else
        dxpm=dble(xpp)
        dxmr=dble(xpr)
        dxpp=dble(xpm)
        dxpr=dble(xmr)
	iclt=iclpro
	iclp=icltar
	icdtar=icdp
	icdpro=icdt
        iqqa=-iqq
      endif

      v3p1=0.d0
      if(iqqa.lt.6)then
       if(iqqa.eq.0)then
        if(dxpr*dxmr*dsy.le.4.d0.or.dxpr.le.2.d0*ddelx/dsy
     *  .or.dxmr.le.2.d0*ddelx/dsy)return
        xpmin=max(2.d0/dxmr,ddelx)/dsy
        xpmax=min(dxpr/2.d0,1.d0/ddelx)
        rp=(.5*(r2had(iclpro)+r2had(icltar))+slopom
     *  *log(max(1.,engy**2*xpr*xmr)))*4.*.0389
       elseif(iqqa.eq.2)then
        if(dxpp*min(dxpm,dxmr)*dsy.le.2.d0.or.dxpp.le.2.d0*ddelx/dsy
     *  .or.min(dxpm,dxmr).le.ddelx/dsy)return
        xpmin=max(1.d0/min(dxpm,dxmr),ddelx)/dsy
        xpmax=min(dxpp/2.d0,1.d0/ddelx)
        rp=(.5*(r2had(iclpro)+r2had(icltar))+slopom
     *  *log(max(1.,engy**2*xpp*xpm)))*4.*.0389
       else
        if(min(dxpp,dxpr)*min(dxpm,dxmr)*dsy.le.1.d0
     *  .or.min(dxpp,dxpr).le.ddelx/dsy
     *  .or.min(dxpm,dxmr).le.ddelx/dsy)return
        xpmin=max(1.d0/min(dxpm,dxmr),dble(delx))/dsy
        xpmax=min(min(dxpp,dxpr),1.d0/ddelx)
        rp=(.5*(r2had(iclpro)+r2had(icltar))+slopom
     *  *log(max(1.,engy**2*xpp*xpm)))*4.*.0389
       endif
       
       do ix1=1,2
       do mx1=1,2
        dxpomr=(xpmin/xpmax)**(.5d0+x4(ix1)*(mx1-1.5d0))*xpmax
	
       do ib1=1,2
       do mb1=1,2
        z=.5+x4(ib1)*(mb1-1.5)
        b1=sqrt(-rp/4.*log(z))
        dbb=b1**2+.25*b**2
       do ib2=1,2
       do mb2=1,2
        phi=pi*(.5+x4(ib2)*(mb2-1.5))
	bb1=dbb+b*b1*cos(phi)
	bb2=2.*dbb-bb1
	
	v3p1=v3p1+a4(ib1)*a4(ib2)*a4(ix1)/z
     *  *psvxb(dxpp,dxpr,dxpm,dxmr,dxpomr,bb1,bb2
     *  ,iclp,iclt,icdpro,icdtar,iqqa)
       enddo
       enddo
       enddo
       enddo
       enddo
       enddo
       psvx=v3p1*rp/32.d0*log(xpmax/xpmin)

      elseif(iqqa.eq.6)then
       if(dxpp.ge.min((dxpr+dxpp)/2.d0,1.d0/ddelx)
     * .or.dxpp.le.max(1.d0/min(dxpm,dxmr),ddelx)/dsy)return

       rp=(.5*(r2had(iclpro)+r2had(icltar))+slopom
     * *log(max(1.d0,engy**2*(dxpr+dxpp)*dxpm)))*4.*.0389

       do ib1=1,2
       do mb1=1,2
        z=.5+x4(ib1)*(mb1-1.5)
        b1=sqrt(-rp/4.*log(z))
        dbb=b1**2+.25*b**2
       do ib2=1,2
       do mb2=1,2
        phi=pi*(.5+x4(ib2)*(mb2-1.5))
	bb1=dbb+b*b1*cos(phi)
	bb2=2.*dbb-bb1
	
	v3p1=v3p1+a4(ib1)*a4(ib2)/z
     *  *psvxb(dxpp,dxpr,dxpm,dxmr,dxpp,bb1,bb2
     *  ,iclp,iclt,icdpro,icdtar,iqqa)
       enddo
       enddo
       enddo
       enddo
       psvx=v3p1/dxpp*rp/16.d0

      else
       stop'psvx-wrong iqq!!!'
      endif
      psvx=psvx*psvnorm(b)
      return
      end
           
c------------------------------------------------------------------------
      function psvxb(dxpp,dxpr,dxpm,dxmr,dxpomr,bb1,bb2
     *,iclp,iclt,icdpro,icdtar,iqq)
c-----------------------------------------------------------------------
c psvxb   - integrand for X-contributions
c dxpomr  - lc+ for the vertex,
c bb1,bb2 - impact parameters to proj(targ),
c iqq=0   - uncut
c iqq=1   - 1-cut
c iqq=2   - Y-cut
c iqq=3   - soft 1-cut
c iqq=4   - gg 1-cut
c iqq=5   - qg 1-cut
c iqq=6   - difr
c------------------------------------------------------------------------
      include 'nexus.inc'
      include 'nexus.incsem'
      double precision ddelx,dxpp,dxpr,dxpm,dxmr,dxpomr
     *,del1,del2,dps,dps1
      common /Dparam1/ alpD1(nbpDf,nclegy,nclha),delD2(nbpDf,nclegy),
     &betD1(nbpDf,nclegy,nclha),betDp1(nbpDf,nclegy,nclha),
     &alpD2(nbpDf,nclegy),betD2(nbpDf,nclegy),delD1(nbpDf,nclegy,nclha)
      common /psar7/ delx,alam3p,gam3p
ctp060202 to avoid warnings with gfortran compilation
      logical ctp060202
      ctp060202=.false.
      if(ctp060202)write(*,*)icdpro,icdtar
ctp060202 end
      
      psvxb=0.
      iclegys=iclegy
      ddelx=dble(delx)
      dsy=dble(engy)**2
      iclegy=iclegy2
      if(1.d0/dxpomr.lt.ddelx.or.dxpomr.lt.ddelx/dsy)return
c     *write(*,*)'psvxb-dxpomr:',1.d0/dxpomr,ddelx,dxpomr,ddelx/dsy
            
      dps=0.d0
      dps1=0.d0
      if(iqq.eq.0)then
       if(dxpomr.ge.dxpr/2.d0.or.dxpomr.le.2.d0/dxmr/dsy)return
       do i1=1,nbpDf
        del1=betD1(i1,iclegy,iclp)
        alp1=betDp1(i1,iclegy,iclp)-alppar
        rh1=delD1(i1,iclegy,iclp)
       do i2=1,nbpDf
        del2=betD1(i2,iclegy,iclp)
        alp2=betDp1(i2,iclegy,iclp)-alppar
        rh2=delD1(i2,iclegy,iclp)
	rh=rh1*rh2/(rh1+rh2)
	
	dps=dps+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *  /dxpomr**(del1+del2)
     *  *dxpr**(2.d0+alp1+alp2+del1+del2)
     *  *pscoefi(sngl(dxpomr/dxpr),i1,i2,iclp,2)
     *  /rh1/rh2*exp(-bb1/rh)
       enddo
       enddo
             
       do i1=1,nbpDf
        del1=betD1(i1,iclegy,iclt)
        alp1=betDp1(i1,iclegy,iclt)-alppar
        rh1=delD1(i1,iclegy,iclt)
       do i2=1,nbpDf
        del2=betD1(i2,iclegy,iclt)
        alp2=betDp1(i2,iclegy,iclt)-alppar
        rh2=delD1(i2,iclegy,iclt)
	rh=rh1*rh2/(rh1+rh2)
	
	dps1=dps1+alpD1(i1,iclegy,iclt)*alpD1(i2,iclegy,iclt)
     *  *(dxpomr*dsy)**(del1+del2)
     *  *dxmr**(2.d0+alp1+alp2+del1+del2)
     *  *pscoefi(sngl(1.d0/dxpomr/dxmr/dsy),i1,i2,iclt,2)
     *  /rh1/rh2*exp(-bb2/rh)
       enddo
       enddo
       dps1=dps1  /2.d0
       
      elseif(iqq.eq.1)then
       if(dxpomr.ge.min(dxpp,dxpr)
     * .or.dxpomr.le.1.d0/min(dxpm,dxmr)/dsy)return
       do i1=1,nbpDf
        del1=betD1(i1,iclegy,iclp)
        alp1=betDp1(i1,iclegy,iclp)-alppar
        rh1=delD1(i1,iclegy,iclp)
       do i2=1,nbpDf
        del2=betD1(i2,iclegy,iclp)
        alp2=betDp1(i2,iclegy,iclp)-alppar
        rh2=delD1(i2,iclegy,iclp)
	rh=rh1*rh2/(rh1+rh2)
	
	dps=dps+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *  /dxpomr**(del1+del2)
     *  *dxpp**(alp1+del1)*dxpr**(1.d0+alp2+del2)
     *  *pscoefi(sngl(dxpomr/dxpr),i2,0,iclp,1)
     *  /rh1/rh2*exp(-bb1/rh)
       enddo
       enddo
             
       do i1=1,nbpDf
        del1=betD1(i1,iclegy,iclt)
        alp1=betDp1(i1,iclegy,iclt)-alppar
        rh1=delD1(i1,iclegy,iclt)
       do i2=1,nbpDf
        del2=betD1(i2,iclegy,iclt)
        alp2=betDp1(i2,iclegy,iclt)-alppar
        rh2=delD1(i2,iclegy,iclt)
	rh=rh1*rh2/(rh1+rh2)
	
	dps1=dps1+alpD1(i1,iclegy,iclt)*alpD1(i2,iclegy,iclt)
     *  *(dxpomr*dsy)**(del1+del2)
     *  *dxpm**(alp1+del1)*dxmr**(1.d0+alp2+del2)
     *  *pscoefi(sngl(1.d0/dxpomr/dxmr/dsy),i2,0,iclt,1)
     *  /rh1/rh2*exp(-bb2/rh)
       enddo
       enddo
       dps1=dps1  *2.d0
       
      elseif(iqq.eq.2)then
       if(dxpomr.ge.dxpp/2.d0.or.dxpomr
     * .le.1.d0/min(dxpm,dxmr)/dsy)return
       do i1=1,nbpDf
        del1=betD1(i1,iclegy,iclp)
        alp1=betDp1(i1,iclegy,iclp)-alppar
        rh1=delD1(i1,iclegy,iclp)
       do i2=1,nbpDf
        del2=betD1(i2,iclegy,iclp)
        alp2=betDp1(i2,iclegy,iclp)-alppar
        rh2=delD1(i2,iclegy,iclp)
	rh=rh1*rh2/(rh1+rh2)
	
	dps=dps+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *  /dxpomr**(del1+del2)
     *  *dxpp**(1.d0+alp1+alp2+del1+del2)
     *  *pscoefi(sngl(dxpomr/dxpp),i1,i2,iclp,0)
     *  /rh1/rh2*exp(-bb1/rh)
       enddo
       enddo
             
       do i1=1,nbpDf
        del1=betD1(i1,iclegy,iclt)
        alp1=betDp1(i1,iclegy,iclt)-alppar
        rh1=delD1(i1,iclegy,iclt)
       do i2=1,nbpDf
        del2=betD1(i2,iclegy,iclt)
        alp2=betDp1(i2,iclegy,iclt)-alppar
        rh2=delD1(i2,iclegy,iclt)
	rh=rh1*rh2/(rh1+rh2)
	
	dps1=dps1+alpD1(i1,iclegy,iclt)*alpD1(i2,iclegy,iclt)
     *  *(dxpomr*dsy)**(del1+del2)
     *  *dxpm**(alp1+del1)*dxmr**(1.d0+alp2+del2)
     *  *pscoefi(sngl(1.d0/dxpomr/dxmr/dsy),i2,0,iclt,1)
     *  /rh1/rh2*exp(-bb2/rh)
       enddo
       enddo
       dps1=-dps1  *.625  !
       
      elseif(iqq.eq.6)then
       if(dxpp.ge.min((dxpr+dxpp)/2.d0,1.d0/ddelx)
     * .or.dxpp.le.max(ddelx,1.d0/min(dxpm,dxmr))/dsy)return
       do i1=1,nbpDf
        del1=betD1(i1,iclegy,iclp)
        alp1=betDp1(i1,iclegy,iclp)-alppar
        rh1=delD1(i1,iclegy,iclp)
       do i2=1,nbpDf
        del2=betD1(i2,iclegy,iclp)
        alp2=betDp1(i2,iclegy,iclp)-alppar
        rh2=delD1(i2,iclegy,iclp)
	rh=rh1*rh2/(rh1+rh2)
	
	dps=dps+alpD1(i1,iclegy,iclp)*alpD1(i2,iclegy,iclp)
     *  /dxpp**(del1+del2)
     *  *(dxpr+dxpp)**(2.d0+alp1+alp2+del1+del2)
     *  *pscoefi(sngl(dxpp/(dxpr+dxpp)),i1,i2,iclp,2)
     *  /rh1/rh2*exp(-bb1/rh)
       enddo
       enddo
       dps=dps/8.d0   
       
       do i1=1,nbpDf
        del1=betD1(i1,iclegy,iclt)
        alp1=betDp1(i1,iclegy,iclt)-alppar
        rh1=delD1(i1,iclegy,iclt)
       do i2=1,nbpDf
        del2=betD1(i2,iclegy,iclt)
        alp2=betDp1(i2,iclegy,iclt)-alppar
        rh2=delD1(i2,iclegy,iclt)
	rh=rh1*rh2/(rh1+rh2)
	
        dps1=dps1+alpD1(i1,iclegy,iclt)*alpD1(i2,iclegy,iclt)
     *  *(dxpp*dsy)**(del1+del2)
     *  *dxpm**(alp1+del1)*dxmr**(1.d0+alp2+del2)
     *  *pscoefi(sngl(1.d0/dxpp/dxmr/dsy),i2,0,iclt,1)
     *  /rh1/rh2*exp(-bb2/rh)
       enddo
       enddo
       dps1=-dps1
       
      elseif(iqq.eq.3)then
       if(dxpomr.ge.min(dxpp,dxpr)
     * .or.dxpomr.le.1.d0/min(dxpm,dxmr)/dsy)return
       do i2=1,nbpDf
        del2=betD1(i2,iclegy,iclp)
        alp2=betDp1(i2,iclegy,iclp)-alppar
        rh2=delD1(i2,iclegy,iclp)
	
	dps=dps+alpD1(i2,iclegy,iclp)
     *  /dxpomr**del2*dxpr**(1.d0+alp2+del2)
     *  *pscoefi(sngl(dxpomr/dxpr),i2,0,iclp,1)
     *  /rh2*exp(-bb1/rh2)
       enddo

       sy=sngl(dxpp/dxpomr)
       rh=r2had(iclp)+.5*alam3p+slopom*log(max(1.,sy))
       dps=dps*chad(iclp)*gamhad(iclp)*sy**dels
     * *dxpp**(-alppar)*exp(-bb1/rh/4./.0389)/rh

       dps=dps *2.d0 

       do i2=1,nbpDf
        del2=betD1(i2,iclegy,iclt)
        alp2=betDp1(i2,iclegy,iclt)-alppar
        rh2=delD1(i2,iclegy,iclt)
	
	dps1=dps1+alpD1(i2,iclegy,iclt)
     *  *(dxpomr*dsy)**del2*dxmr**(1.d0+alp2+del2)
     *  *pscoefi(sngl(1.d0/dxpomr/dxmr/dsy),i2,0,iclt,1)
     *  /rh2*exp(-bb2/rh2)
       enddo
       
       rh=r2had(iclt)+.5*alam3p+slopom*log(max(1.d0,dxpomr*dxpm*dsy))
       dps1=dps1*chad(iclt)*gamhad(iclt)*(dxpomr*dsy)**dels
     * *dxpm**(dels-alppar)*exp(-bb2/rh/4./.0389)/rh
       
      elseif(iqq.le.5)then
       if(dxpomr.ge.min(dxpp,dxpr)
     * .or.dxpomr.le.1.d0/min(dxpm,dxmr)/dsy)return
       do i2=1,nbpDf
        del2=betD1(i2,iclegy,iclp)
        alp2=betDp1(i2,iclegy,iclp)-alppar
        rh2=delD1(i2,iclegy,iclp)
	
	dps=dps+alpD1(i2,iclegy,iclp)
     *  /dxpomr**del2*dxpr**(1.d0+alp2+del2)
     *  *pscoefi(sngl(dxpomr/dxpr),i2,0,iclp,1)
     *  /rh2*exp(-bb1/rh2)
       enddo

       sy=sngl(dxpp/dxpomr)
       rh=(r2had(iclp)+r2had(icltar)+slopom*log(max(1.,sy)))*4.*.0389
       z=exp(-bb1/rh)
       iclps=iclpro
       iclpro=iclp
       if(iqq.eq.4)then
        dps=dps*psvin(sy,sngl(dxpp),1.,z,16)
       elseif(iqq.eq.5)then
        dps=dps*psvin(sy,sngl(dxpp),1.,z,18)
       endif      
       iclpro=iclps
       dps=dps *2.d0 

       do i2=1,nbpDf
        del2=betD1(i2,iclegy,iclt)
        alp2=betDp1(i2,iclegy,iclt)-alppar
        rh2=delD1(i2,iclegy,iclt)
	
	dps1=dps1+alpD1(i2,iclegy,iclt)
     *  *(dxpomr*dsy)**del2*dxmr**(1.d0+alp2+del2)
     *  *pscoefi(sngl(1.d0/dxpomr/dxmr/dsy),i2,0,iclt,1)
     *  /rh2*exp(-bb2/rh2)
       enddo
       
       rh=r2had(iclt)+.5*alam3p+slopom*log(max(1.d0,dxpomr*dxpm*dsy))
       dps1=dps1*chad(iclt)*gamhad(iclt)*(dxpomr*dsy)**dels
     * *dxpm**(dels-alppar)*exp(-bb2/rh/4./.0389)/rh
      else
       stop'psvxb-wrong iqq!!!'
      endif
      psvxb=dps*dps1
c      *gamdp(icdpro,iclp)**2*gamdt(icdtar,iclt)**2*gam3p
c     **(r3pom*pi/.0389)*psvnorm(b)
      iclegy=iclegys
      return
      end
      
c------------------------------------------------------------------------
      function pscoef(zz,alp1,alp2,iclp,iqq)
c-----------------------------------------------------------------------
c pscoef - integrated vertexes
c zz=xpomr/xpr(xpp)
c iqq=0 - 2-cut
c iqq=1 - 1-uncut
c iqq=2 - 2-uncut
c------------------------------------------------------------------------
      common /ar3/ x1(7),a1(7)
      include 'nexus.inc'
      
      pscoef=0.
      dps=0.
      if(iqq.eq.0)then
       xmax=.5**(1.+alp1)
       xmin=zz**(1.+alp1)
       do i1=1,7
       do m1=1,2
        xx=(.5*(xmin+xmax+(2*m1-3)*x1(i1)*(xmin-xmax)))**(1./(1.+alp1))
	dps=dps+a1(i1)*(1.-xx)**alp2
       enddo
       enddo
       pscoef=pscoef+dps*(xmax-xmin)/2./(1.+alp1)
       dps=0.
       xmax=.5**(1.+alp2)
       xmin=zz**(1.+alp2)
       do i1=1,7
       do m1=1,2
        xx=(.5*(xmin+xmax+(2*m1-3)*x1(i1)*(xmin-xmax)))**(1./(1.+alp2))
	dps=dps+a1(i1)*(1.-xx)**alp1
       enddo
       enddo
       pscoef=pscoef+dps*(xmax-xmin)/2./(1.+alp2)

      elseif(iqq.eq.1)then
       xmax=1.
       xmin=zz**(1.+alp1)
       do i1=1,7
       do m1=1,2
        xx=(.5*(xmin+xmax+(2*m1-3)*x1(i1)*(xmin-xmax)))**(1./(1.+alp1))
	dps=dps+a1(i1)*(1.-xx)**alplea(iclp)
       enddo
       enddo
       pscoef=pscoef+dps*(xmax-xmin)/2./(1.+alp1)

      elseif(iqq.eq.2)then
       xmax=(1.-zz)**(1.+alp1)
       xmin=zz**(1.+alp1)
       do i1=1,7
       do m1=1,2
        xx=(.5*(xmin+xmax+(2*m1-3)*x1(i1)*(xmin-xmax)))**(1./(1.+alp1))
	
        xmax1=1.
        xmin1=(zz/(1.-xx))**(1.+alp2)
        do i2=1,7
        do m2=1,2
         xx1=(.5*(xmin1+xmax1+(2*m2-3)*x1(i2)*(xmin1-xmax1)))
     *   **(1./(1.+alp2))
	 dps=dps+a1(i1)*a1(i2)*(1.-xx)**(1.+alp2+alplea(iclp))
     *   *(1.-xx1)**alplea(iclp)*(xmax1-xmin1)
        enddo
        enddo
       enddo
       enddo
       pscoef=pscoef+dps*(xmax-xmin)/4./(1.+alp1)/(1.+alp2)
      endif
      return
      end
      
c------------------------------------------------------------------------
      function pscoefi(z,i1,i2,iclp,iqq)
c-----------------------------------------------------------------------
c pscoefi - interpolation of integrated vertexes
c z=xpomr/xpr(xpp)
c iqq=0 - 2-cut
c iqq=1 - 1-uncut
c iqq=2 - 2-uncut
c------------------------------------------------------------------------
      include 'nexus.inc'
      dimension wz(3)
      common /psar40/ coefxu1(nbpDf,nclha,10)
     *,coefxu2(nbpDf,nbpDf,nclha,10),coefxc2(nbpDf,nbpDf,nclha,10)

      pscoefi=0.
      if(z.ge.1..or.iqq.ne.1.and.z.ge..5)return

      if(iqq.eq.1)then
       if(z.ge..2)then
	zz=5.*z+5
       else
	zz=25.*z+1
       endif
      else
       if(z.ge..1)then
	zz=10.*z+5
       else
	zz=50.*z+1
       endif
      endif
      
      jz=min(8,int(zz))
      if(jz.eq.5)jz=4
      wz(2)=zz-jz
      wz(3)=wz(2)*(wz(2)-1.)*.5
      wz(1)=1.-wz(2)+wz(3)
      wz(2)=wz(2)-2.*wz(3)

      if(iqq.eq.0)then
       do l1=1,3
        l2=jz+l1-1
        pscoefi=pscoefi+coefxc2(i1,i2,iclp,l2)*wz(l1)
       enddo
      elseif(iqq.eq.1)then
       do l1=1,3
        l2=jz+l1-1
        pscoefi=pscoefi+coefxu1(i1,iclp,l2)*wz(l1)
       enddo
      elseif(iqq.eq.2)then
       do l1=1,3
        l2=jz+l1-1
        pscoefi=pscoefi+coefxu2(i1,i2,iclp,l2)*wz(l1)
       enddo
      endif
      pscoefi=max(0.,pscoefi)
      return 
      end
                    
